(set-logic QF_NIA)
(set-info
  :source |
SMT script generated by Ultimate LassoRanker [1].
Ultimate LassoRanker is a tool that analyzes termination and nontermination of 
lasso-shaped programs. This script contains the SMT commands that Ultimate 
LassoRanker used while checking if a lasso-shaped program has a geometric 
nontermination argument [2].

This SMT script belongs to a set of SMT scripts that was generated by applying
Ultimate Buchi Automizer [3,4] to the benchmarks from the SV-COMP 2015 [5,6] 
which are available at [7]. Ultimate Buchi Automizer takes omega-traces
(lasso-shaped programs) and uses LassoRanker in order to check if the 
lasso-shaped program is terminating.

2015-04-30, Matthias Heizmann (heizmann@informatik.uni-freiburg.de)


[1] https://ultimate.informatik.uni-freiburg.de/LassoRanker/
[2] Jan Leike, Matthias Heizmann:
Geometric Series as Nontermination Arguments for Linear Lasso Programs. 
CoRR abs/1405.4413 (2014)
http://arxiv.org/abs/1405.4413
[3] http://ultimate.informatik.uni-freiburg.de/BuchiAutomizer/
[4] Matthias Heizmann, Jochen Hoenicke, Andreas Podelski: Software Model 
Checking for People Who Love Automata. CAV 2013:36-52
[5] http://sv-comp.sosy-lab.org/2015/
[6] Dirk Beyer: Software Verification and Verifiable Witnesses - (Report on 
SV-COMP 2015). TACAS 2015: 401-416
[7] https://svn.sosy-lab.org/software/sv-benchmarks/tags/svcomp15/
|)
(set-info :smt-lib-version 2.0)
(set-info :category "industrial")
(set-info :status unsat)
(declare-fun init_cstpncpy_~s~3.base () Int)
(declare-fun honda_cstpncpy_~s~3.base () Int)
(declare-fun ray_cstpncpy_~s~3.base () Int)
(declare-fun |init_(ite (select #valid cstpncpy_~d~3.base) 1 0)| () Int)
(declare-fun |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| () Int)
(declare-fun |ray_(ite (select #valid cstpncpy_~d~3.base) 1 0)| () Int)
(declare-fun |init_(select #length cstpncpy_~s~3.base)| () Int)
(declare-fun |honda_(select #length cstpncpy_~s~3.base)| () Int)
(declare-fun |ray_(select #length cstpncpy_~s~3.base)| () Int)
(declare-fun |init_cstpncpy_#t~mem0.offset| () Int)
(declare-fun |honda_cstpncpy_#t~mem0.offset| () Int)
(declare-fun |ray_cstpncpy_#t~mem0.offset| () Int)
(declare-fun |init_cstpncpy_#t~post4.offset| () Int)
(declare-fun |honda_cstpncpy_#t~post4.offset| () Int)
(declare-fun |ray_cstpncpy_#t~post4.offset| () Int)
(declare-fun |init_(select #length cstpncpy_~d~3.base)| () Int)
(declare-fun |honda_(select #length cstpncpy_~d~3.base)| () Int)
(declare-fun |ray_(select #length cstpncpy_~d~3.base)| () Int)
(declare-fun init_cstpncpy_~s~3.offset () Int)
(declare-fun honda_cstpncpy_~s~3.offset () Int)
(declare-fun ray_cstpncpy_~s~3.offset () Int)
(declare-fun init_cstpncpy_~n () Int)
(declare-fun honda_cstpncpy_~n () Int)
(declare-fun ray_cstpncpy_~n () Int)
(declare-fun |init_cstpncpy_#in~dst.base| () Int)
(declare-fun |honda_cstpncpy_#in~dst.base| () Int)
(declare-fun |ray_cstpncpy_#in~dst.base| () Int)
(declare-fun |init_cstpncpy_#t~post4.base| () Int)
(declare-fun |honda_cstpncpy_#t~post4.base| () Int)
(declare-fun |ray_cstpncpy_#t~post4.base| () Int)
(declare-fun |init_cstpncpy_~#dst.offset| () Int)
(declare-fun |honda_cstpncpy_~#dst.offset| () Int)
(declare-fun |ray_cstpncpy_~#dst.offset| () Int)
(declare-fun
  |init_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
  () Int)
(declare-fun
  |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
  () Int)
(declare-fun
  |ray_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
  () Int)
(declare-fun |init_cstpncpy_#t~mem7| () Int)
(declare-fun |honda_cstpncpy_#t~mem7| () Int)
(declare-fun |ray_cstpncpy_#t~mem7| () Int)
(declare-fun |init_cstpncpy_#t~post5.offset| () Int)
(declare-fun |honda_cstpncpy_#t~post5.offset| () Int)
(declare-fun |ray_cstpncpy_#t~post5.offset| () Int)
(declare-fun init_cstpncpy_~d~3.base () Int)
(declare-fun honda_cstpncpy_~d~3.base () Int)
(declare-fun ray_cstpncpy_~d~3.base () Int)
(declare-fun |init_cstpncpy_#in~src.offset| () Int)
(declare-fun |honda_cstpncpy_#in~src.offset| () Int)
(declare-fun |ray_cstpncpy_#in~src.offset| () Int)
(declare-fun |init_cstpncpy_#in~dst.offset| () Int)
(declare-fun |honda_cstpncpy_#in~dst.offset| () Int)
(declare-fun |ray_cstpncpy_#in~dst.offset| () Int)
(declare-fun |init_(ite (select #valid 0) 1 0)| () Int)
(declare-fun |honda_(ite (select #valid 0) 1 0)| () Int)
(declare-fun |ray_(ite (select #valid 0) 1 0)| () Int)
(declare-fun |init_(ite (select #valid cstpncpy_~s~3.base) 1 0)| () Int)
(declare-fun |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| () Int)
(declare-fun |ray_(ite (select #valid cstpncpy_~s~3.base) 1 0)| () Int)
(declare-fun |init_cstpncpy_#t~mem1.offset| () Int)
(declare-fun |honda_cstpncpy_#t~mem1.offset| () Int)
(declare-fun |ray_cstpncpy_#t~mem1.offset| () Int)
(declare-fun init_cstpncpy_~src.base () Int)
(declare-fun honda_cstpncpy_~src.base () Int)
(declare-fun ray_cstpncpy_~src.base () Int)
(declare-fun |init_cstpncpy_#t~mem0.base| () Int)
(declare-fun |honda_cstpncpy_#t~mem0.base| () Int)
(declare-fun |ray_cstpncpy_#t~mem0.base| () Int)
(declare-fun |init_#NULL.offset| () Int)
(declare-fun |honda_#NULL.offset| () Int)
(declare-fun |ray_#NULL.offset| () Int)
(declare-fun init_cstpncpy_~d~3.offset () Int)
(declare-fun honda_cstpncpy_~d~3.offset () Int)
(declare-fun ray_cstpncpy_~d~3.offset () Int)
(declare-fun |init_cstpncpy_#t~post3| () Int)
(declare-fun |honda_cstpncpy_#t~post3| () Int)
(declare-fun |ray_cstpncpy_#t~post3| () Int)
(declare-fun init_cstpncpy_~src.offset () Int)
(declare-fun honda_cstpncpy_~src.offset () Int)
(declare-fun ray_cstpncpy_~src.offset () Int)
(declare-fun |init_cstpncpy_#in~n| () Int)
(declare-fun |honda_cstpncpy_#in~n| () Int)
(declare-fun |ray_cstpncpy_#in~n| () Int)
(declare-fun |init_cstpncpy_~#dst.base| () Int)
(declare-fun |honda_cstpncpy_~#dst.base| () Int)
(declare-fun |ray_cstpncpy_~#dst.base| () Int)
(declare-fun |init_cstpncpy_#t~mem1.base| () Int)
(declare-fun |honda_cstpncpy_#t~mem1.base| () Int)
(declare-fun |ray_cstpncpy_#t~mem1.base| () Int)
(declare-fun |init_cstpncpy_#t~post5.base| () Int)
(declare-fun |honda_cstpncpy_#t~post5.base| () Int)
(declare-fun |ray_cstpncpy_#t~post5.base| () Int)
(declare-fun |init_cstpncpy_#in~src.base| () Int)
(declare-fun |honda_cstpncpy_#in~src.base| () Int)
(declare-fun |ray_cstpncpy_#in~src.base| () Int)
(declare-fun |init_#NULL.base| () Int)
(declare-fun |honda_#NULL.base| () Int)
(declare-fun |ray_#NULL.base| () Int)
(declare-fun
  |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
  () Int)
(declare-fun
  |ray_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
  () Int)
(declare-fun |honda_(select old(#length) cstpncpy_#in~src.base)| () Int)
(declare-fun |ray_(select old(#length) cstpncpy_#in~src.base)| () Int)
(declare-fun
  |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
  () Int)
(declare-fun
  |ray_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
  () Int)
(declare-fun
  |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
  () Int)
(declare-fun
  |ray_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
  () Int)
(declare-fun |honda_(select #length cstpncpy_#in~src.base)| () Int)
(declare-fun |ray_(select #length cstpncpy_#in~src.base)| () Int)
(declare-fun |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| ()
  Int)
(declare-fun |ray_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| () Int)
(declare-fun |honda_(select #length cstpncpy_#in~dst.base)| () Int)
(declare-fun |ray_(select #length cstpncpy_#in~dst.base)| () Int)
(declare-fun
  |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
  () Int)
(declare-fun
  |ray_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
  () Int)
(declare-fun |honda_(select old(#length) cstpncpy_~#dst.base)| () Int)
(declare-fun |ray_(select old(#length) cstpncpy_~#dst.base)| () Int)
(declare-fun
  |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
  () Int)
(declare-fun
  |ray_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
  () Int)
(declare-fun |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| () Int)
(declare-fun |ray_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| () Int)
(declare-fun |honda_(select #length cstpncpy_~#dst.base)| () Int)
(declare-fun |ray_(select #length cstpncpy_~#dst.base)| () Int)
(declare-fun |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| () Int)
(declare-fun |ray_(ite (select #valid cstpncpy_~#dst.base) 1 0)| () Int)
(declare-fun |honda_(select old(#length) cstpncpy_#in~dst.base)| () Int)
(declare-fun |ray_(select old(#length) cstpncpy_#in~dst.base)| () Int)
(declare-fun |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| ()
  Int)
(declare-fun |ray_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| ()
  Int)
(declare-fun |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| () Int)
(declare-fun |ray_(ite (select #valid cstpncpy_#in~src.base) 1 0)| () Int)
(declare-fun |honda_(ite (select old(#valid) 0) 1 0)| () Int)
(declare-fun |ray_(ite (select old(#valid) 0) 1 0)| () Int)
(declare-fun
  |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
  () Int)
(declare-fun
  |ray_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
  () Int)
(declare-fun |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| ()
  Int)
(declare-fun |ray_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| ()
  Int)
(declare-fun lambda () Int)
(declare-fun aux_3314 () Int)
(declare-fun aux_3316 () Int)
(declare-fun aux_3319 () Int)
(declare-fun aux_3321 () Int)
(declare-fun aux_3323 () Int)
(declare-fun aux_3329 () Int)
(declare-fun aux_3331 () Int)
(declare-fun aux_3334 () Int)
(declare-fun aux_3336 () Int)
(declare-fun aux_3338 () Int)
(declare-fun aux_3344 () Int)
(declare-fun aux_3346 () Int)
(declare-fun aux_3349 () Int)
(declare-fun aux_3351 () Int)
(declare-fun aux_3353 () Int)
(declare-fun aux_3359 () Int)
(declare-fun aux_3361 () Int)
(declare-fun aux_3364 () Int)
(declare-fun aux_3366 () Int)
(declare-fun aux_3368 () Int)
(declare-fun aux_3374 () Int)
(declare-fun aux_3376 () Int)
(declare-fun aux_3379 () Int)
(declare-fun aux_3381 () Int)
(declare-fun aux_3383 () Int)
(declare-fun aux_3389 () Int)
(declare-fun aux_3391 () Int)
(declare-fun aux_3394 () Int)
(declare-fun aux_3396 () Int)
(declare-fun aux_3398 () Int)
(declare-fun aux_3404 () Int)
(declare-fun aux_3406 () Int)
(declare-fun aux_3409 () Int)
(declare-fun aux_3411 () Int)
(declare-fun aux_3413 () Int)
(declare-fun aux_3419 () Int)
(declare-fun aux_3421 () Int)
(declare-fun aux_3424 () Int)
(declare-fun aux_3426 () Int)
(declare-fun aux_3428 () Int)
(declare-fun aux_3434 () Int)
(declare-fun aux_3436 () Int)
(declare-fun aux_3439 () Int)
(declare-fun aux_3441 () Int)
(declare-fun aux_3443 () Int)
(declare-fun aux_3449 () Int)
(declare-fun aux_3451 () Int)
(declare-fun aux_3454 () Int)
(declare-fun aux_3456 () Int)
(declare-fun aux_3458 () Int)
(declare-fun aux_3464 () Int)
(declare-fun aux_3466 () Int)
(declare-fun aux_3469 () Int)
(declare-fun aux_3471 () Int)
(declare-fun aux_3473 () Int)
(declare-fun aux_3479 () Int)
(declare-fun aux_3481 () Int)
(declare-fun aux_3484 () Int)
(declare-fun aux_3486 () Int)
(declare-fun aux_3488 () Int)
(declare-fun aux_3494 () Int)
(declare-fun aux_3496 () Int)
(declare-fun aux_3499 () Int)
(declare-fun aux_3501 () Int)
(declare-fun aux_3503 () Int)
(declare-fun aux_3509 () Int)
(declare-fun aux_3511 () Int)
(declare-fun aux_3514 () Int)
(declare-fun aux_3516 () Int)
(declare-fun aux_3518 () Int)
(declare-fun aux_3524 () Int)
(declare-fun aux_3526 () Int)
(declare-fun aux_3529 () Int)
(declare-fun aux_3531 () Int)
(declare-fun aux_3533 () Int)
(declare-fun aux_3539 () Int)
(declare-fun aux_3541 () Int)
(declare-fun aux_3544 () Int)
(declare-fun aux_3546 () Int)
(declare-fun aux_3548 () Int)
(declare-fun aux_3554 () Int)
(declare-fun aux_3556 () Int)
(declare-fun aux_3559 () Int)
(declare-fun aux_3561 () Int)
(declare-fun aux_3563 () Int)
(declare-fun aux_3569 () Int)
(declare-fun aux_3571 () Int)
(declare-fun aux_3574 () Int)
(declare-fun aux_3576 () Int)
(declare-fun aux_3578 () Int)
(declare-fun aux_3584 () Int)
(declare-fun aux_3586 () Int)
(declare-fun aux_3589 () Int)
(declare-fun aux_3591 () Int)
(declare-fun aux_3593 () Int)
(declare-fun aux_3599 () Int)
(declare-fun aux_3601 () Int)
(declare-fun aux_3604 () Int)
(declare-fun aux_3606 () Int)
(declare-fun aux_3608 () Int)
(declare-fun aux_3614 () Int)
(declare-fun aux_3616 () Int)
(declare-fun aux_3619 () Int)
(declare-fun aux_3621 () Int)
(declare-fun aux_3623 () Int)
(declare-fun aux_3629 () Int)
(declare-fun aux_3631 () Int)
(declare-fun aux_3634 () Int)
(declare-fun aux_3636 () Int)
(declare-fun aux_3638 () Int)
(declare-fun aux_3644 () Int)
(declare-fun aux_3646 () Int)
(declare-fun aux_3649 () Int)
(declare-fun aux_3651 () Int)
(declare-fun aux_3653 () Int)
(declare-fun aux_3659 () Int)
(declare-fun aux_3661 () Int)
(declare-fun aux_3664 () Int)
(declare-fun aux_3666 () Int)
(declare-fun aux_3668 () Int)
(declare-fun aux_3674 () Int)
(declare-fun aux_3675 () Int)
(declare-fun aux_3679 () Int)
(declare-fun aux_3680 () Int)
(declare-fun aux_3686 () Int)
(declare-fun aux_3687 () Int)
(declare-fun aux_3691 () Int)
(declare-fun aux_3692 () Int)
(declare-fun aux_3698 () Int)
(declare-fun aux_3699 () Int)
(declare-fun aux_3703 () Int)
(declare-fun aux_3704 () Int)
(declare-fun aux_3710 () Int)
(declare-fun aux_3711 () Int)
(declare-fun aux_3715 () Int)
(declare-fun aux_3716 () Int)
(declare-fun aux_3722 () Int)
(declare-fun aux_3723 () Int)
(declare-fun aux_3727 () Int)
(declare-fun aux_3728 () Int)
(declare-fun aux_3734 () Int)
(declare-fun aux_3735 () Int)
(declare-fun aux_3739 () Int)
(declare-fun aux_3740 () Int)
(declare-fun aux_3746 () Int)
(declare-fun aux_3747 () Int)
(declare-fun aux_3751 () Int)
(declare-fun aux_3752 () Int)
(declare-fun aux_3758 () Int)
(declare-fun aux_3759 () Int)
(declare-fun aux_3763 () Int)
(declare-fun aux_3764 () Int)
(assert
 (and
 (or
 (and
 (= |init_(ite (select #valid cstpncpy_~d~3.base) 1 0)|
 |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)|)
 (= |init_(select #length cstpncpy_~s~3.base)|
 |honda_(select #length cstpncpy_~s~3.base)|)
 (= |init_cstpncpy_#t~post4.offset| |honda_cstpncpy_#t~post4.offset|)
 (= |init_(select #length cstpncpy_~d~3.base)|
 |honda_(select #length cstpncpy_~d~3.base)|)
 (= |init_cstpncpy_#t~post4.base| |honda_cstpncpy_#t~post4.base|)
 (=
 |init_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|)
 (= |init_cstpncpy_#t~mem7| |honda_cstpncpy_#t~mem7|)
 (= |init_cstpncpy_#t~post5.offset| |honda_cstpncpy_#t~post5.offset|)
 (= |init_(ite (select #valid cstpncpy_~s~3.base) 1 0)|
 |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)|)
 (= |init_cstpncpy_#t~post3| |honda_cstpncpy_#t~post3|)
 (= |init_cstpncpy_#t~post5.base| |honda_cstpncpy_#t~post5.base|)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| (- 1))
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 1)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 1)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base (- 1))
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 1)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| (- 1)) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 1) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| (- 1))
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| (- 1))
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 1)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| (- 1)) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 1) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0)
 (* honda_cstpncpy_~n (- 1)) 
 (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base (- 1))
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 1) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) (* aux_3314 (- 1)) 4294967295) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 1) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) (* aux_3314 (- 1)) 
 (* aux_3316 (- 4294967296)) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0)
 (* honda_cstpncpy_~n (- 1)) 
 (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) (* aux_3314 1) 
 (* aux_3316 4294967296) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| (- 1))
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 1)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| (- 1))
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 1) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| (- 1))
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 1)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| (- 1))
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 1)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0)
 (* honda_cstpncpy_~s~3.offset (- 1))
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 1) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 1)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 1)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset (- 1)) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 1)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| (- 1))
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) (* aux_3319 1) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 1)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 (- 1)) (* |honda_(select #length cstpncpy_~s~3.base)| 0)
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base (- 1))
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 1)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| (- 1))
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| (- 1))
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 1)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| (- 1))
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 1)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| (- 1))
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) (* aux_3314 1) 
 (* aux_3321 (- 1)) (- 1)) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 1)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset (- 1)) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 1) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 1) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 (- 1)) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| (- 1)) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 1) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base (- 1))
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 1)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 1)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0)
 (* honda_cstpncpy_~n (- 1)) 
 (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset (- 1)) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 1) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 1)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| (- 1))
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| (- 1))
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 1)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) (* aux_3321 (- 1)) 
 (* aux_3323 (- 4294967296)) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) (* aux_3321 1) 
 (* aux_3323 4294967296) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) (* aux_3321 1) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 1)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base (- 1))
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 1)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| (- 1)) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 1) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) (* aux_3319 1) 
 (- 1)) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 1)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) (- 4)) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 1)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset (- 1)) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| (- 1))
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 1) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 1)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) (* aux_3319 (- 1)) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 1)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| (- 1))
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 1)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| (- 1))
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| (- 1))
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 1)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 1)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| (- 1))
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 1) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0))
 (and
 (= |init_(ite (select #valid cstpncpy_~d~3.base) 1 0)|
 |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)|)
 (= |init_(select #length cstpncpy_~s~3.base)|
 |honda_(select #length cstpncpy_~s~3.base)|)
 (= |init_cstpncpy_#t~post4.offset| |honda_cstpncpy_#t~post4.offset|)
 (= |init_(select #length cstpncpy_~d~3.base)|
 |honda_(select #length cstpncpy_~d~3.base)|)
 (= |init_cstpncpy_#t~post4.base| |honda_cstpncpy_#t~post4.base|)
 (=
 |init_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|)
 (= |init_cstpncpy_#t~mem7| |honda_cstpncpy_#t~mem7|)
 (= |init_cstpncpy_#t~post5.offset| |honda_cstpncpy_#t~post5.offset|)
 (= |init_(ite (select #valid cstpncpy_~s~3.base) 1 0)|
 |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)|)
 (= |init_cstpncpy_#t~post3| |honda_cstpncpy_#t~post3|)
 (= |init_cstpncpy_#t~post5.base| |honda_cstpncpy_#t~post5.base|)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 1) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| (- 1))
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 1)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 1)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base (- 1))
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 1)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| (- 1)) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 1) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| (- 1))
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| (- 1))
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 1) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0)
 (* honda_cstpncpy_~n (- 1)) 
 (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base (- 1))
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 1) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) (* aux_3329 (- 1)) 4294967295) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 1) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) (* aux_3329 (- 1)) 
 (* aux_3331 (- 4294967296)) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0)
 (* honda_cstpncpy_~n (- 1)) 
 (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) (* aux_3329 1) 
 (* aux_3331 4294967296) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| (- 1))
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 1)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| (- 1))
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 1)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| (- 1))
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 1) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| (- 1))
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 1)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0)
 (* honda_cstpncpy_~s~3.offset (- 1))
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 1) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 1)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 1)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset (- 1)) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 1)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| (- 1))
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) (* aux_3334 1) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 1)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 (- 1)) (* |honda_(select #length cstpncpy_~s~3.base)| 0)
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| (- 1)) 
 (* |honda_cstpncpy_#in~src.base| 1)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base (- 1))
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 1)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| (- 1))
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| (- 1))
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 1)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| (- 1))
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 1)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| (- 1))
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) (* aux_3329 1) 
 (* aux_3336 (- 1)) (- 1)) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 1)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset (- 1)) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 1) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 1) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 (- 1)) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| (- 1)) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 1) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base (- 1))
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 1)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 1)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0)
 (* honda_cstpncpy_~n (- 1)) 
 (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset (- 1)) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 1) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 1)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| (- 1))
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| (- 1))
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 1)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) (* aux_3336 (- 1)) 
 (* aux_3338 (- 4294967296)) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) (* aux_3336 1) 
 (* aux_3338 4294967296) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) (* aux_3336 1) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 1)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base (- 1))
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 1)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| (- 1)) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 1) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) (* aux_3334 1) 
 (- 1)) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 1)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) (- 4)) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 1)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset (- 1)) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| (- 1))
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 1) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 1)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) (* aux_3334 (- 1)) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 1)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| (- 1))
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 1)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| (- 1))
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| (- 1))
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 1)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 1)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| (- 1))
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 1) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0))
 (and
 (= |init_(ite (select #valid cstpncpy_~d~3.base) 1 0)|
 |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)|)
 (= |init_(select #length cstpncpy_~s~3.base)|
 |honda_(select #length cstpncpy_~s~3.base)|)
 (= |init_cstpncpy_#t~post4.offset| |honda_cstpncpy_#t~post4.offset|)
 (= |init_(select #length cstpncpy_~d~3.base)|
 |honda_(select #length cstpncpy_~d~3.base)|)
 (= |init_cstpncpy_#t~post4.base| |honda_cstpncpy_#t~post4.base|)
 (=
 |init_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|)
 (= |init_cstpncpy_#t~mem7| |honda_cstpncpy_#t~mem7|)
 (= |init_cstpncpy_#t~post5.offset| |honda_cstpncpy_#t~post5.offset|)
 (= |init_(ite (select #valid cstpncpy_~s~3.base) 1 0)|
 |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)|)
 (= |init_cstpncpy_#t~post3| |honda_cstpncpy_#t~post3|)
 (= |init_cstpncpy_#t~post5.base| |honda_cstpncpy_#t~post5.base|)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| (- 1))
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 1)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 1)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base (- 1))
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 1)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| (- 1)) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 1) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| (- 1))
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| (- 1))
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 1) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0)
 (* honda_cstpncpy_~n (- 1)) 
 (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base (- 1))
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 1) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) (* aux_3344 (- 1)) 4294967295) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 1) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) (* aux_3344 (- 1)) 
 (* aux_3346 (- 4294967296)) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0)
 (* honda_cstpncpy_~n (- 1)) 
 (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) (* aux_3344 1) 
 (* aux_3346 4294967296) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| (- 1))
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 1)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| (- 1))
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 1) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| (- 1))
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 1)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0)
 (* honda_cstpncpy_~s~3.offset (- 1))
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 1) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 1)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 1)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset (- 1)) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 1)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| (- 1))
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) (* aux_3349 1) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 1)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 (- 1)) (* |honda_(select #length cstpncpy_~s~3.base)| 0)
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| (- 1))
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 1) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| (- 1)) 
 (* |honda_cstpncpy_#in~src.base| 1)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base (- 1))
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 1)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| (- 1))
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| (- 1))
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 1)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| (- 1))
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 1)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| (- 1))
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) (* aux_3344 1) 
 (* aux_3351 (- 1)) (- 1)) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 1)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset (- 1)) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 1) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 1) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 (- 1)) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 1)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| (- 1)) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 1) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base (- 1))
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 1)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 1)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0)
 (* honda_cstpncpy_~n (- 1)) 
 (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset (- 1)) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 1) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 1)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| (- 1))
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| (- 1))
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 1)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) (* aux_3351 (- 1)) 
 (* aux_3353 (- 4294967296)) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) (* aux_3351 1) 
 (* aux_3353 4294967296) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) (* aux_3351 1) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 1)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base (- 1))
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 1)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| (- 1)) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 1) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) (* aux_3349 1) 
 (- 1)) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 1)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) (- 4)) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 1)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset (- 1)) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| (- 1))
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 1) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 1)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) (* aux_3349 (- 1)) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 1)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| (- 1))
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 1)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| (- 1))
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| (- 1))
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 1)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 1)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| (- 1))
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 1) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0))
 (and
 (= |init_(ite (select #valid cstpncpy_~d~3.base) 1 0)|
 |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)|)
 (= |init_(select #length cstpncpy_~s~3.base)|
 |honda_(select #length cstpncpy_~s~3.base)|)
 (= |init_cstpncpy_#t~post4.offset| |honda_cstpncpy_#t~post4.offset|)
 (= |init_(select #length cstpncpy_~d~3.base)|
 |honda_(select #length cstpncpy_~d~3.base)|)
 (= |init_cstpncpy_#t~post4.base| |honda_cstpncpy_#t~post4.base|)
 (=
 |init_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|)
 (= |init_cstpncpy_#t~mem7| |honda_cstpncpy_#t~mem7|)
 (= |init_cstpncpy_#t~post5.offset| |honda_cstpncpy_#t~post5.offset|)
 (= |init_(ite (select #valid cstpncpy_~s~3.base) 1 0)|
 |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)|)
 (= |init_cstpncpy_#t~post3| |honda_cstpncpy_#t~post3|)
 (= |init_cstpncpy_#t~post5.base| |honda_cstpncpy_#t~post5.base|)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| (- 1))
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 1)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 1)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base (- 1))
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 1)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| (- 1)) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 1) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| (- 1))
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| (- 1))
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 1) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0)
 (* honda_cstpncpy_~n (- 1)) 
 (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 1) 
 (* |honda_cstpncpy_#in~src.base| (- 1))
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base (- 1))
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 1) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) (* aux_3359 (- 1)) 4294967295) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 1) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) (* aux_3359 (- 1)) 
 (* aux_3361 (- 4294967296)) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0)
 (* honda_cstpncpy_~n (- 1)) 
 (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) (* aux_3359 1) 
 (* aux_3361 4294967296) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| (- 1))
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 1)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| (- 1))
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 1) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| (- 1))
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 1)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0)
 (* honda_cstpncpy_~s~3.offset (- 1))
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 1) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 1)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 1)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset (- 1)) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 1)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| (- 1))
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) (* aux_3364 1) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 1)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 (- 1)) (* |honda_(select #length cstpncpy_~s~3.base)| 0)
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base (- 1))
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 1)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| (- 1))
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| (- 1))
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 1)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| (- 1))
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 1)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| (- 1))
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) (* aux_3359 1) 
 (* aux_3366 (- 1)) (- 1)) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 1)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset (- 1)) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 1) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 1) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 (- 1)) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| (- 1)) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 1) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base (- 1))
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 1)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 1)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0)
 (* honda_cstpncpy_~n (- 1)) 
 (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset (- 1)) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 1) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 1)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| (- 1))
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| (- 1))
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 1)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| (- 1))
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 1)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) (* aux_3366 (- 1)) 
 (* aux_3368 (- 4294967296)) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) (* aux_3366 1) 
 (* aux_3368 4294967296) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) (* aux_3366 1) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 1)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base (- 1))
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 1)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| (- 1)) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 1) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) (* aux_3364 1) 
 (- 1)) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 1)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) (- 4)) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 1)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset (- 1)) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| (- 1))
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 1) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 1)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) (* aux_3364 (- 1)) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 1)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| (- 1))
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| (- 1)) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 1)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| (- 1))
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| (- 1))
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 1)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 1)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| (- 1))
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 1) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0))
 (and
 (= |init_(ite (select #valid cstpncpy_~d~3.base) 1 0)|
 |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)|)
 (= |init_(select #length cstpncpy_~s~3.base)|
 |honda_(select #length cstpncpy_~s~3.base)|)
 (= |init_cstpncpy_#t~post4.offset| |honda_cstpncpy_#t~post4.offset|)
 (= |init_(select #length cstpncpy_~d~3.base)|
 |honda_(select #length cstpncpy_~d~3.base)|)
 (= |init_cstpncpy_#t~post4.base| |honda_cstpncpy_#t~post4.base|)
 (=
 |init_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|)
 (= |init_cstpncpy_#t~mem7| |honda_cstpncpy_#t~mem7|)
 (= |init_cstpncpy_#t~post5.offset| |honda_cstpncpy_#t~post5.offset|)
 (= |init_(ite (select #valid cstpncpy_~s~3.base) 1 0)|
 |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)|)
 (= |init_cstpncpy_#t~post3| |honda_cstpncpy_#t~post3|)
 (= |init_cstpncpy_#t~post5.base| |honda_cstpncpy_#t~post5.base|)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 1) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| (- 1))
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 1)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 1)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base (- 1))
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 1)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| (- 1)) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 1) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| (- 1))
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| (- 1))
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 1)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| (- 1)) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 1) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0)
 (* honda_cstpncpy_~n (- 1)) 
 (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base (- 1))
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 1) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) (* aux_3374 (- 1)) 4294967295) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 1) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) (* aux_3374 (- 1)) 
 (* aux_3376 (- 4294967296)) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0)
 (* honda_cstpncpy_~n (- 1)) 
 (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) (* aux_3374 1) 
 (* aux_3376 4294967296) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| (- 1))
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 1)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| (- 1))
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 1) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| (- 1))
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 1)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0)
 (* honda_cstpncpy_~s~3.offset (- 1))
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 1) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 1)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 1)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset (- 1)) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 1)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| (- 1))
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) (* aux_3379 1) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 1)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 (- 1)) (* |honda_(select #length cstpncpy_~s~3.base)| 0)
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base (- 1))
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 1)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| (- 1))
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| (- 1))
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 1)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| (- 1))
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 1)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| (- 1))
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) (* aux_3374 1) 
 (* aux_3381 (- 1)) (- 1)) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 1)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset (- 1)) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 1) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 1) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 (- 1)) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| (- 1)) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 1) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base (- 1))
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 1)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 1)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0)
 (* honda_cstpncpy_~n (- 1)) 
 (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset (- 1)) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 1) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 1)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| (- 1))
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| (- 1))
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 1)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| (- 1))
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 1)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) (* aux_3381 (- 1)) 
 (* aux_3383 (- 4294967296)) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) (* aux_3381 1) 
 (* aux_3383 4294967296) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) (* aux_3381 1) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 1)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base (- 1))
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 1)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| (- 1)) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 1) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) (* aux_3379 1) 
 (- 1)) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 1)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) (- 4)) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 1)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset (- 1)) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| (- 1))
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 1) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 1)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) (* aux_3379 (- 1)) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 1)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| (- 1))
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 1)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| (- 1))
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| (- 1))
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 1)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 1)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| (- 1))
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 1) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0))
 (and
 (= |init_(ite (select #valid cstpncpy_~d~3.base) 1 0)|
 |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)|)
 (= |init_(select #length cstpncpy_~s~3.base)|
 |honda_(select #length cstpncpy_~s~3.base)|)
 (= |init_cstpncpy_#t~post4.offset| |honda_cstpncpy_#t~post4.offset|)
 (= |init_(select #length cstpncpy_~d~3.base)|
 |honda_(select #length cstpncpy_~d~3.base)|)
 (= |init_cstpncpy_#t~post4.base| |honda_cstpncpy_#t~post4.base|)
 (=
 |init_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|)
 (= |init_cstpncpy_#t~mem7| |honda_cstpncpy_#t~mem7|)
 (= |init_cstpncpy_#t~post5.offset| |honda_cstpncpy_#t~post5.offset|)
 (= |init_(ite (select #valid cstpncpy_~s~3.base) 1 0)|
 |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)|)
 (= |init_cstpncpy_#t~post3| |honda_cstpncpy_#t~post3|)
 (= |init_cstpncpy_#t~post5.base| |honda_cstpncpy_#t~post5.base|)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| (- 1))
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 1)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 1)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base (- 1))
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 1)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| (- 1)) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 1) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| (- 1))
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| (- 1))
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 1)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| (- 1)) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 1) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0)
 (* honda_cstpncpy_~n (- 1)) 
 (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 1) 
 (* |honda_cstpncpy_#in~src.base| (- 1))
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base (- 1))
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 1) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) (* aux_3389 (- 1)) 4294967295) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 1) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) (* aux_3389 (- 1)) 
 (* aux_3391 (- 4294967296)) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0)
 (* honda_cstpncpy_~n (- 1)) 
 (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) (* aux_3389 1) 
 (* aux_3391 4294967296) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| (- 1))
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 1)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| (- 1))
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 1) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| (- 1))
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 1)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| (- 1))
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0)
 (* honda_cstpncpy_~s~3.offset (- 1))
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 1) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 1)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 1)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset (- 1)) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 1)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| (- 1))
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) (* aux_3394 1) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 1)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 (- 1)) (* |honda_(select #length cstpncpy_~s~3.base)| 0)
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base (- 1))
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 1)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| (- 1))
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| (- 1))
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 1)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| (- 1))
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 1)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| (- 1))
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) (* aux_3389 1) 
 (* aux_3396 (- 1)) (- 1)) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 1)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset (- 1)) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 1) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 1) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 (- 1)) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| (- 1)) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 1) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base (- 1))
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 1)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 1)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0)
 (* honda_cstpncpy_~n (- 1)) 
 (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset (- 1)) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 1) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 1)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| (- 1))
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| (- 1))
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 1)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) (* aux_3396 (- 1)) 
 (* aux_3398 (- 4294967296)) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) (* aux_3396 1) 
 (* aux_3398 4294967296) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) (* aux_3396 1) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 1)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base (- 1))
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 1)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| (- 1)) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 1) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) (* aux_3394 1) 
 (- 1)) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 1)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) (- 4)) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 1)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset (- 1)) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| (- 1))
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 1) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 1)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) (* aux_3394 (- 1)) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 1)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| (- 1))
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 1)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| (- 1))
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| (- 1))
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 1)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 1)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| (- 1))
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 1) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0))
 (and
 (= |init_(ite (select #valid cstpncpy_~d~3.base) 1 0)|
 |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)|)
 (= |init_(select #length cstpncpy_~s~3.base)|
 |honda_(select #length cstpncpy_~s~3.base)|)
 (= |init_cstpncpy_#t~post4.offset| |honda_cstpncpy_#t~post4.offset|)
 (= |init_(select #length cstpncpy_~d~3.base)|
 |honda_(select #length cstpncpy_~d~3.base)|)
 (= |init_cstpncpy_#t~post4.base| |honda_cstpncpy_#t~post4.base|)
 (=
 |init_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|)
 (= |init_cstpncpy_#t~mem7| |honda_cstpncpy_#t~mem7|)
 (= |init_cstpncpy_#t~post5.offset| |honda_cstpncpy_#t~post5.offset|)
 (= |init_(ite (select #valid cstpncpy_~s~3.base) 1 0)|
 |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)|)
 (= |init_cstpncpy_#t~post3| |honda_cstpncpy_#t~post3|)
 (= |init_cstpncpy_#t~post5.base| |honda_cstpncpy_#t~post5.base|)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| (- 1))
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 1)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 1)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base (- 1))
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 1)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| (- 1)) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 1) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| (- 1))
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| (- 1))
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 1) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0)
 (* honda_cstpncpy_~n (- 1)) 
 (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base (- 1))
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 1) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) (* aux_3404 (- 1)) 4294967295) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 1) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) (* aux_3404 (- 1)) 
 (* aux_3406 (- 4294967296)) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0)
 (* honda_cstpncpy_~n (- 1)) 
 (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) (* aux_3404 1) 
 (* aux_3406 4294967296) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| (- 1))
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 1)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| (- 1))
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 1) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| (- 1))
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 1)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0)
 (* honda_cstpncpy_~s~3.offset (- 1))
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 1) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 1)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 1)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset (- 1)) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 1)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| (- 1))
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) (* aux_3409 1) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 1)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 (- 1)) (* |honda_(select #length cstpncpy_~s~3.base)| 0)
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| (- 1))
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 1) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| (- 1)) 
 (* |honda_cstpncpy_#in~src.base| 1)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| (- 1))
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base (- 1))
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 1)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| (- 1))
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| (- 1))
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 1)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| (- 1))
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 1)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| (- 1))
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) (* aux_3404 1) 
 (* aux_3411 (- 1)) (- 1)) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 1)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset (- 1)) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 1) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 1) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 (- 1)) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| (- 1)) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 1) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base (- 1))
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 1)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 1)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0)
 (* honda_cstpncpy_~n (- 1)) 
 (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset (- 1)) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 1) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 1)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| (- 1))
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| (- 1))
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 1)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) (* aux_3411 (- 1)) 
 (* aux_3413 (- 4294967296)) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) (* aux_3411 1) 
 (* aux_3413 4294967296) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) (* aux_3411 1) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 1)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base (- 1))
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 1)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| (- 1)) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 1) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) (* aux_3409 1) 
 (- 1)) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 1)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) (- 4)) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 1)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset (- 1)) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| (- 1))
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 1) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 1)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) (* aux_3409 (- 1)) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 1)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| (- 1))
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 1)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| (- 1))
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| (- 1))
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 1)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 1)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| (- 1))
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 1) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0))
 (and
 (= |init_(ite (select #valid cstpncpy_~d~3.base) 1 0)|
 |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)|)
 (= |init_(select #length cstpncpy_~s~3.base)|
 |honda_(select #length cstpncpy_~s~3.base)|)
 (= |init_cstpncpy_#t~post4.offset| |honda_cstpncpy_#t~post4.offset|)
 (= |init_(select #length cstpncpy_~d~3.base)|
 |honda_(select #length cstpncpy_~d~3.base)|)
 (= |init_cstpncpy_#t~post4.base| |honda_cstpncpy_#t~post4.base|)
 (=
 |init_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|)
 (= |init_cstpncpy_#t~mem7| |honda_cstpncpy_#t~mem7|)
 (= |init_cstpncpy_#t~post5.offset| |honda_cstpncpy_#t~post5.offset|)
 (= |init_(ite (select #valid cstpncpy_~s~3.base) 1 0)|
 |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)|)
 (= |init_cstpncpy_#t~post3| |honda_cstpncpy_#t~post3|)
 (= |init_cstpncpy_#t~post5.base| |honda_cstpncpy_#t~post5.base|)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| (- 1))
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 1)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 1)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base (- 1))
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 1)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| (- 1)) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 1) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| (- 1))
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| (- 1))
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 1) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0)
 (* honda_cstpncpy_~n (- 1)) 
 (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base (- 1))
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 1) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) (* aux_3419 (- 1)) 4294967295) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 1) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) (* aux_3419 (- 1)) 
 (* aux_3421 (- 4294967296)) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0)
 (* honda_cstpncpy_~n (- 1)) 
 (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) (* aux_3419 1) 
 (* aux_3421 4294967296) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| (- 1))
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 1)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| (- 1))
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 1) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| (- 1))
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 1)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0)
 (* honda_cstpncpy_~s~3.offset (- 1))
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 1) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 1)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 1)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset (- 1)) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 1)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| (- 1))
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) (* aux_3424 1) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 1)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 (- 1)) (* |honda_(select #length cstpncpy_~s~3.base)| 0)
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base (- 1))
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 1)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| (- 1))
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| (- 1))
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 1)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| (- 1))
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 1)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| (- 1))
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) (* aux_3419 1) 
 (* aux_3426 (- 1)) (- 1)) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 1)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset (- 1)) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 1) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 1) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 (- 1)) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 1)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| (- 1)) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 1) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base (- 1))
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 1)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 1)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0)
 (* honda_cstpncpy_~n (- 1)) 
 (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset (- 1)) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 1) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 1)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| (- 1))
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| (- 1))
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 1)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| (- 1))
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 1)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) (* aux_3426 (- 1)) 
 (* aux_3428 (- 4294967296)) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) (* aux_3426 1) 
 (* aux_3428 4294967296) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) (* aux_3426 1) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 1)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base (- 1))
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 1)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| (- 1)) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 1) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) (* aux_3424 1) 
 (- 1)) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 1)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) (- 4)) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 1)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset (- 1)) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| (- 1))
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 1) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 1)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) (* aux_3424 (- 1)) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 1)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| (- 1))
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| (- 1)) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 1)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| (- 1))
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| (- 1))
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 1)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 1)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| (- 1))
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 1) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0))
 (and
 (= |init_(ite (select #valid cstpncpy_~d~3.base) 1 0)|
 |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)|)
 (= |init_(select #length cstpncpy_~s~3.base)|
 |honda_(select #length cstpncpy_~s~3.base)|)
 (= |init_cstpncpy_#t~post4.offset| |honda_cstpncpy_#t~post4.offset|)
 (= |init_(select #length cstpncpy_~d~3.base)|
 |honda_(select #length cstpncpy_~d~3.base)|)
 (= |init_cstpncpy_#t~post4.base| |honda_cstpncpy_#t~post4.base|)
 (=
 |init_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|)
 (= |init_cstpncpy_#t~mem7| |honda_cstpncpy_#t~mem7|)
 (= |init_cstpncpy_#t~post5.offset| |honda_cstpncpy_#t~post5.offset|)
 (= |init_(ite (select #valid cstpncpy_~s~3.base) 1 0)|
 |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)|)
 (= |init_cstpncpy_#t~post3| |honda_cstpncpy_#t~post3|)
 (= |init_cstpncpy_#t~post5.base| |honda_cstpncpy_#t~post5.base|)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| (- 1))
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 1)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 1)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base (- 1))
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 1)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| (- 1)) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 1) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| (- 1))
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| (- 1))
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 1)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| (- 1)) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 1) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0)
 (* honda_cstpncpy_~n (- 1)) 
 (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 1) 
 (* |honda_cstpncpy_#in~src.base| (- 1))
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base (- 1))
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 1) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) (* aux_3434 (- 1)) 4294967295) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 1) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) (* aux_3434 (- 1)) 
 (* aux_3436 (- 4294967296)) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0)
 (* honda_cstpncpy_~n (- 1)) 
 (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) (* aux_3434 1) 
 (* aux_3436 4294967296) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| (- 1))
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 1)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| (- 1))
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 1) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| (- 1))
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 1)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 1)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0)
 (* honda_cstpncpy_~s~3.offset (- 1))
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 1) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 1)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 1)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset (- 1)) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 1)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| (- 1))
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) (* aux_3439 1) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 1)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 (- 1)) (* |honda_(select #length cstpncpy_~s~3.base)| 0)
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base (- 1))
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 1)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| (- 1))
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| (- 1))
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 1)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| (- 1))
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 1)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| (- 1))
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) (* aux_3434 1) 
 (* aux_3441 (- 1)) (- 1)) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 1)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset (- 1)) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 1) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 1) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 (- 1)) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| (- 1)) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 1) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base (- 1))
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 1)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 1)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0)
 (* honda_cstpncpy_~n (- 1)) 
 (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset (- 1)) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 1) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 1)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| (- 1))
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| (- 1))
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 1)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) (* aux_3441 (- 1)) 
 (* aux_3443 (- 4294967296)) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) (* aux_3441 1) 
 (* aux_3443 4294967296) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) (* aux_3441 1) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 1)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base (- 1))
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 1)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| (- 1)) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 1) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) (* aux_3439 1) 
 (- 1)) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 1)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) (- 4)) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 1)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset (- 1)) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| (- 1))
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 1) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 1)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) (* aux_3439 (- 1)) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 1)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| (- 1))
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 1)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| (- 1))
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| (- 1))
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 1)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 1)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| (- 1))
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 1) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0))
 (and
 (= |init_(ite (select #valid cstpncpy_~d~3.base) 1 0)|
 |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)|)
 (= |init_(select #length cstpncpy_~s~3.base)|
 |honda_(select #length cstpncpy_~s~3.base)|)
 (= |init_cstpncpy_#t~post4.offset| |honda_cstpncpy_#t~post4.offset|)
 (= |init_(select #length cstpncpy_~d~3.base)|
 |honda_(select #length cstpncpy_~d~3.base)|)
 (= |init_cstpncpy_#t~post4.base| |honda_cstpncpy_#t~post4.base|)
 (=
 |init_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|)
 (= |init_cstpncpy_#t~mem7| |honda_cstpncpy_#t~mem7|)
 (= |init_cstpncpy_#t~post5.offset| |honda_cstpncpy_#t~post5.offset|)
 (= |init_(ite (select #valid cstpncpy_~s~3.base) 1 0)|
 |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)|)
 (= |init_cstpncpy_#t~post3| |honda_cstpncpy_#t~post3|)
 (= |init_cstpncpy_#t~post5.base| |honda_cstpncpy_#t~post5.base|)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 1) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| (- 1))
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 1)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 1)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base (- 1))
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 1)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| (- 1)) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 1) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| (- 1))
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| (- 1))
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 1) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0)
 (* honda_cstpncpy_~n (- 1)) 
 (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base (- 1))
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 1) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) (* aux_3449 (- 1)) 4294967295) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 1) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) (* aux_3449 (- 1)) 
 (* aux_3451 (- 4294967296)) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0)
 (* honda_cstpncpy_~n (- 1)) 
 (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) (* aux_3449 1) 
 (* aux_3451 4294967296) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| (- 1))
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 1)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| (- 1))
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 1) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| (- 1))
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 1)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| (- 1))
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0)
 (* honda_cstpncpy_~s~3.offset (- 1))
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 1) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 1)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 1)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset (- 1)) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 1)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| (- 1))
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) (* aux_3454 1) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 1)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 (- 1)) (* |honda_(select #length cstpncpy_~s~3.base)| 0)
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| (- 1)) 
 (* |honda_cstpncpy_#in~src.base| 1)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base (- 1))
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 1)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| (- 1))
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| (- 1))
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 1)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| (- 1))
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 1)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| (- 1))
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) (* aux_3449 1) 
 (* aux_3456 (- 1)) (- 1)) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 1)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset (- 1)) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 1) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 1) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 (- 1)) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| (- 1)) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 1) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base (- 1))
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 1)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 1)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0)
 (* honda_cstpncpy_~n (- 1)) 
 (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset (- 1)) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 1) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 1)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| (- 1))
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| (- 1))
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 1)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) (* aux_3456 (- 1)) 
 (* aux_3458 (- 4294967296)) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) (* aux_3456 1) 
 (* aux_3458 4294967296) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) (* aux_3456 1) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 1)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base (- 1))
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 1)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| (- 1)) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 1) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) (* aux_3454 1) 
 (- 1)) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 1)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) (- 4)) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 1)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset (- 1)) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| (- 1))
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 1) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 1)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) (* aux_3454 (- 1)) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 1)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| (- 1))
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 1)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| (- 1))
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| (- 1))
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 1)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 1)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| (- 1))
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 1) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0))
 (and
 (= |init_(ite (select #valid cstpncpy_~d~3.base) 1 0)|
 |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)|)
 (= |init_(select #length cstpncpy_~s~3.base)|
 |honda_(select #length cstpncpy_~s~3.base)|)
 (= |init_cstpncpy_#t~post4.offset| |honda_cstpncpy_#t~post4.offset|)
 (= |init_(select #length cstpncpy_~d~3.base)|
 |honda_(select #length cstpncpy_~d~3.base)|)
 (= |init_cstpncpy_#t~post4.base| |honda_cstpncpy_#t~post4.base|)
 (=
 |init_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|)
 (= |init_cstpncpy_#t~mem7| |honda_cstpncpy_#t~mem7|)
 (= |init_cstpncpy_#t~post5.offset| |honda_cstpncpy_#t~post5.offset|)
 (= |init_(ite (select #valid cstpncpy_~s~3.base) 1 0)|
 |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)|)
 (= |init_cstpncpy_#t~post3| |honda_cstpncpy_#t~post3|)
 (= |init_cstpncpy_#t~post5.base| |honda_cstpncpy_#t~post5.base|)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 1) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| (- 1))
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 1)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 1)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base (- 1))
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 1)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| (- 1)) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 1) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| (- 1))
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| (- 1))
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 1)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| (- 1)) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 1) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0)
 (* honda_cstpncpy_~n (- 1)) 
 (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base (- 1))
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 1) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) (* aux_3464 (- 1)) 4294967295) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 1) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) (* aux_3464 (- 1)) 
 (* aux_3466 (- 4294967296)) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0)
 (* honda_cstpncpy_~n (- 1)) 
 (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) (* aux_3464 1) 
 (* aux_3466 4294967296) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| (- 1))
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 1)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| (- 1))
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 1) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| (- 1))
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 1)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0)
 (* honda_cstpncpy_~s~3.offset (- 1))
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 1) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 1)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 1)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset (- 1)) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 1)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| (- 1))
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) (* aux_3469 1) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 1)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 (- 1)) (* |honda_(select #length cstpncpy_~s~3.base)| 0)
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| (- 1))
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base (- 1))
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 1)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| (- 1))
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| (- 1))
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 1)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| (- 1))
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 1)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| (- 1))
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) (* aux_3464 1) 
 (* aux_3471 (- 1)) (- 1)) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 1)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset (- 1)) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 1) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 1) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 (- 1)) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| (- 1)) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 1) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base (- 1))
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 1)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 1)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0)
 (* honda_cstpncpy_~n (- 1)) 
 (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset (- 1)) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 1) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 1)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| (- 1))
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| (- 1))
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 1)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) (* aux_3471 (- 1)) 
 (* aux_3473 (- 4294967296)) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) (* aux_3471 1) 
 (* aux_3473 4294967296) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) (* aux_3471 1) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 1)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base (- 1))
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 1)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| (- 1)) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 1) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) (* aux_3469 1) 
 (- 1)) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 1)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) (- 4)) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 1)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset (- 1)) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| (- 1))
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 1) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 1)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) (* aux_3469 (- 1)) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 1)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| (- 1))
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 1)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| (- 1))
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| (- 1))
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 1)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 1)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| (- 1))
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 1) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0))
 (and
 (= |init_(ite (select #valid cstpncpy_~d~3.base) 1 0)|
 |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)|)
 (= |init_(select #length cstpncpy_~s~3.base)|
 |honda_(select #length cstpncpy_~s~3.base)|)
 (= |init_cstpncpy_#t~post4.offset| |honda_cstpncpy_#t~post4.offset|)
 (= |init_(select #length cstpncpy_~d~3.base)|
 |honda_(select #length cstpncpy_~d~3.base)|)
 (= |init_cstpncpy_#t~post4.base| |honda_cstpncpy_#t~post4.base|)
 (=
 |init_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|)
 (= |init_cstpncpy_#t~mem7| |honda_cstpncpy_#t~mem7|)
 (= |init_cstpncpy_#t~post5.offset| |honda_cstpncpy_#t~post5.offset|)
 (= |init_(ite (select #valid cstpncpy_~s~3.base) 1 0)|
 |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)|)
 (= |init_cstpncpy_#t~post3| |honda_cstpncpy_#t~post3|)
 (= |init_cstpncpy_#t~post5.base| |honda_cstpncpy_#t~post5.base|)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 1) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| (- 1))
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 1)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 1)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base (- 1))
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 1)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| (- 1)) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 1) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| (- 1))
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| (- 1))
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 1) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0)
 (* honda_cstpncpy_~n (- 1)) 
 (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base (- 1))
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 1) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) (* aux_3479 (- 1)) 4294967295) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 1) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) (* aux_3479 (- 1)) 
 (* aux_3481 (- 4294967296)) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0)
 (* honda_cstpncpy_~n (- 1)) 
 (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) (* aux_3479 1) 
 (* aux_3481 4294967296) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| (- 1))
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 1)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| (- 1))
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 1) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| (- 1))
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 1)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0)
 (* honda_cstpncpy_~s~3.offset (- 1))
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 1) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 1)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 1)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset (- 1)) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 1)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| (- 1))
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) (* aux_3484 1) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 1)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 (- 1)) (* |honda_(select #length cstpncpy_~s~3.base)| 0)
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| (- 1))
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base (- 1))
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 1)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| (- 1))
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| (- 1))
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 1)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| (- 1))
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 1)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| (- 1))
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) (* aux_3479 1) 
 (* aux_3486 (- 1)) (- 1)) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 1)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset (- 1)) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 1) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 1) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 (- 1)) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| (- 1)) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 1) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base (- 1))
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 1)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 1)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0)
 (* honda_cstpncpy_~n (- 1)) 
 (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset (- 1)) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 1) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 1)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| (- 1))
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| (- 1))
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 1)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| (- 1))
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 1)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) (* aux_3486 (- 1)) 
 (* aux_3488 (- 4294967296)) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) (* aux_3486 1) 
 (* aux_3488 4294967296) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) (* aux_3486 1) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 1)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base (- 1))
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 1)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| (- 1)) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 1) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) (* aux_3484 1) 
 (- 1)) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 1)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) (- 4)) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 1)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset (- 1)) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| (- 1))
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 1) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 1)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) (* aux_3484 (- 1)) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 1)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| (- 1))
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 1)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| (- 1))
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| (- 1))
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 1)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 1)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| (- 1))
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 1) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0))
 (and
 (= |init_(ite (select #valid cstpncpy_~d~3.base) 1 0)|
 |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)|)
 (= |init_(select #length cstpncpy_~s~3.base)|
 |honda_(select #length cstpncpy_~s~3.base)|)
 (= |init_cstpncpy_#t~post4.offset| |honda_cstpncpy_#t~post4.offset|)
 (= |init_(select #length cstpncpy_~d~3.base)|
 |honda_(select #length cstpncpy_~d~3.base)|)
 (= |init_cstpncpy_#t~post4.base| |honda_cstpncpy_#t~post4.base|)
 (=
 |init_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|)
 (= |init_cstpncpy_#t~mem7| |honda_cstpncpy_#t~mem7|)
 (= |init_cstpncpy_#t~post5.offset| |honda_cstpncpy_#t~post5.offset|)
 (= |init_(ite (select #valid cstpncpy_~s~3.base) 1 0)|
 |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)|)
 (= |init_cstpncpy_#t~post3| |honda_cstpncpy_#t~post3|)
 (= |init_cstpncpy_#t~post5.base| |honda_cstpncpy_#t~post5.base|)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| (- 1))
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 1)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 1)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base (- 1))
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 1)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| (- 1)) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 1) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| (- 1))
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| (- 1))
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 1)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| (- 1)) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 1) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0)
 (* honda_cstpncpy_~n (- 1)) 
 (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base (- 1))
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 1) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) (* aux_3494 (- 1)) 4294967295) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 1) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) (* aux_3494 (- 1)) 
 (* aux_3496 (- 4294967296)) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0)
 (* honda_cstpncpy_~n (- 1)) 
 (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) (* aux_3494 1) 
 (* aux_3496 4294967296) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| (- 1))
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 1)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| (- 1))
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 1) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| (- 1))
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 1)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0)
 (* honda_cstpncpy_~s~3.offset (- 1))
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 1) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 1)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 1)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset (- 1)) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 1)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| (- 1))
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) (* aux_3499 1) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 1)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 (- 1)) (* |honda_(select #length cstpncpy_~s~3.base)| 0)
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| (- 1))
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base (- 1))
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 1)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| (- 1))
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| (- 1))
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 1)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| (- 1))
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 1)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| (- 1))
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) (* aux_3494 1) 
 (* aux_3501 (- 1)) (- 1)) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 1)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset (- 1)) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 1) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 1) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 (- 1)) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| (- 1)) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 1) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base (- 1))
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 1)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 1)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0)
 (* honda_cstpncpy_~n (- 1)) 
 (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset (- 1)) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 1) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 1)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| (- 1))
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| (- 1))
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 1)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| (- 1))
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 1)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) (* aux_3501 (- 1)) 
 (* aux_3503 (- 4294967296)) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) (* aux_3501 1) 
 (* aux_3503 4294967296) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) (* aux_3501 1) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 1)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base (- 1))
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 1)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| (- 1)) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 1) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) (* aux_3499 1) 
 (- 1)) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 1)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) (- 4)) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 1)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset (- 1)) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| (- 1))
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 1) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 1)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) (* aux_3499 (- 1)) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 1)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| (- 1))
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 1)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| (- 1))
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| (- 1))
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 1)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 1)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| (- 1))
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 1) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0))
 (and
 (= |init_(ite (select #valid cstpncpy_~d~3.base) 1 0)|
 |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)|)
 (= |init_(select #length cstpncpy_~s~3.base)|
 |honda_(select #length cstpncpy_~s~3.base)|)
 (= |init_cstpncpy_#t~post4.offset| |honda_cstpncpy_#t~post4.offset|)
 (= |init_(select #length cstpncpy_~d~3.base)|
 |honda_(select #length cstpncpy_~d~3.base)|)
 (= |init_cstpncpy_#t~post4.base| |honda_cstpncpy_#t~post4.base|)
 (=
 |init_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|)
 (= |init_cstpncpy_#t~mem7| |honda_cstpncpy_#t~mem7|)
 (= |init_cstpncpy_#t~post5.offset| |honda_cstpncpy_#t~post5.offset|)
 (= |init_(ite (select #valid cstpncpy_~s~3.base) 1 0)|
 |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)|)
 (= |init_cstpncpy_#t~post3| |honda_cstpncpy_#t~post3|)
 (= |init_cstpncpy_#t~post5.base| |honda_cstpncpy_#t~post5.base|)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| (- 1))
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 1)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 1)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base (- 1))
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 1)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| (- 1)) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 1) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| (- 1))
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| (- 1))
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 1) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0)
 (* honda_cstpncpy_~n (- 1)) 
 (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 1) 
 (* |honda_cstpncpy_#in~src.base| (- 1))
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base (- 1))
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 1) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) (* aux_3509 (- 1)) 4294967295) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 1) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) (* aux_3509 (- 1)) 
 (* aux_3511 (- 4294967296)) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0)
 (* honda_cstpncpy_~n (- 1)) 
 (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) (* aux_3509 1) 
 (* aux_3511 4294967296) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| (- 1))
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 1)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| (- 1))
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 1) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| (- 1))
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 1)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| (- 1))
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 1)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0)
 (* honda_cstpncpy_~s~3.offset (- 1))
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 1) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 1)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 1)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset (- 1)) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 1)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| (- 1))
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) (* aux_3514 1) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 1)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 (- 1)) (* |honda_(select #length cstpncpy_~s~3.base)| 0)
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base (- 1))
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 1)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| (- 1))
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| (- 1))
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 1)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| (- 1))
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 1)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| (- 1))
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) (* aux_3509 1) 
 (* aux_3516 (- 1)) (- 1)) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 1)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset (- 1)) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 1) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 1) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 (- 1)) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| (- 1)) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 1) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base (- 1))
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 1)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 1)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0)
 (* honda_cstpncpy_~n (- 1)) 
 (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset (- 1)) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 1) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 1)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| (- 1))
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| (- 1))
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 1)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) (* aux_3516 (- 1)) 
 (* aux_3518 (- 4294967296)) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) (* aux_3516 1) 
 (* aux_3518 4294967296) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) (* aux_3516 1) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 1)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base (- 1))
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 1)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| (- 1)) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 1) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) (* aux_3514 1) 
 (- 1)) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 1)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) (- 4)) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 1)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset (- 1)) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| (- 1))
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 1) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 1)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) (* aux_3514 (- 1)) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 1)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| (- 1))
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 1)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| (- 1))
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| (- 1))
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 1)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 1)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| (- 1))
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 1) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0))
 (and
 (= |init_(ite (select #valid cstpncpy_~d~3.base) 1 0)|
 |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)|)
 (= |init_(select #length cstpncpy_~s~3.base)|
 |honda_(select #length cstpncpy_~s~3.base)|)
 (= |init_cstpncpy_#t~post4.offset| |honda_cstpncpy_#t~post4.offset|)
 (= |init_(select #length cstpncpy_~d~3.base)|
 |honda_(select #length cstpncpy_~d~3.base)|)
 (= |init_cstpncpy_#t~post4.base| |honda_cstpncpy_#t~post4.base|)
 (=
 |init_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|)
 (= |init_cstpncpy_#t~mem7| |honda_cstpncpy_#t~mem7|)
 (= |init_cstpncpy_#t~post5.offset| |honda_cstpncpy_#t~post5.offset|)
 (= |init_(ite (select #valid cstpncpy_~s~3.base) 1 0)|
 |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)|)
 (= |init_cstpncpy_#t~post3| |honda_cstpncpy_#t~post3|)
 (= |init_cstpncpy_#t~post5.base| |honda_cstpncpy_#t~post5.base|)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| (- 1))
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 1)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 1)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base (- 1))
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 1)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| (- 1)) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 1) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| (- 1))
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| (- 1))
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 1) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0)
 (* honda_cstpncpy_~n (- 1)) 
 (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base (- 1))
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 1) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) (* aux_3524 (- 1)) 4294967295) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 1) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) (* aux_3524 (- 1)) 
 (* aux_3526 (- 4294967296)) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0)
 (* honda_cstpncpy_~n (- 1)) 
 (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) (* aux_3524 1) 
 (* aux_3526 4294967296) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| (- 1))
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 1)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| (- 1))
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 1)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| (- 1))
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 1) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| (- 1))
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 1)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| (- 1))
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0)
 (* honda_cstpncpy_~s~3.offset (- 1))
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 1) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 1)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 1)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset (- 1)) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 1)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| (- 1))
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) (* aux_3529 1) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 1)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 (- 1)) (* |honda_(select #length cstpncpy_~s~3.base)| 0)
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| (- 1)) 
 (* |honda_cstpncpy_#in~src.base| 1)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base (- 1))
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 1)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| (- 1))
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| (- 1))
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 1)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| (- 1))
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 1)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| (- 1))
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) (* aux_3524 1) 
 (* aux_3531 (- 1)) (- 1)) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 1)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset (- 1)) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 1) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 1) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 (- 1)) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| (- 1)) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 1) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base (- 1))
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 1)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 1)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0)
 (* honda_cstpncpy_~n (- 1)) 
 (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset (- 1)) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 1) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 1)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| (- 1))
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| (- 1))
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 1)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) (* aux_3531 (- 1)) 
 (* aux_3533 (- 4294967296)) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) (* aux_3531 1) 
 (* aux_3533 4294967296) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) (* aux_3531 1) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 1)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base (- 1))
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 1)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| (- 1)) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 1) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) (* aux_3529 1) 
 (- 1)) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 1)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) (- 4)) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 1)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset (- 1)) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| (- 1))
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 1) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 1)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) (* aux_3529 (- 1)) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 1)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| (- 1))
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 1)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| (- 1))
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| (- 1))
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 1)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 1)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| (- 1))
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 1) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0))
 (and
 (= |init_(ite (select #valid cstpncpy_~d~3.base) 1 0)|
 |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)|)
 (= |init_(select #length cstpncpy_~s~3.base)|
 |honda_(select #length cstpncpy_~s~3.base)|)
 (= |init_cstpncpy_#t~post4.offset| |honda_cstpncpy_#t~post4.offset|)
 (= |init_(select #length cstpncpy_~d~3.base)|
 |honda_(select #length cstpncpy_~d~3.base)|)
 (= |init_cstpncpy_#t~post4.base| |honda_cstpncpy_#t~post4.base|)
 (=
 |init_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|)
 (= |init_cstpncpy_#t~mem7| |honda_cstpncpy_#t~mem7|)
 (= |init_cstpncpy_#t~post5.offset| |honda_cstpncpy_#t~post5.offset|)
 (= |init_(ite (select #valid cstpncpy_~s~3.base) 1 0)|
 |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)|)
 (= |init_cstpncpy_#t~post3| |honda_cstpncpy_#t~post3|)
 (= |init_cstpncpy_#t~post5.base| |honda_cstpncpy_#t~post5.base|)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| (- 1))
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 1)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 1)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base (- 1))
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 1)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| (- 1)) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 1) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| (- 1))
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| (- 1))
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 1) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0)
 (* honda_cstpncpy_~n (- 1)) 
 (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base (- 1))
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 1) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) (* aux_3539 (- 1)) 4294967295) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 1) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) (* aux_3539 (- 1)) 
 (* aux_3541 (- 4294967296)) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0)
 (* honda_cstpncpy_~n (- 1)) 
 (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) (* aux_3539 1) 
 (* aux_3541 4294967296) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| (- 1))
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 1)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| (- 1))
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 1) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| (- 1))
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 1)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0)
 (* honda_cstpncpy_~s~3.offset (- 1))
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 1) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 1)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 1)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset (- 1)) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 1)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| (- 1))
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) (* aux_3544 1) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 1)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 (- 1)) (* |honda_(select #length cstpncpy_~s~3.base)| 0)
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| (- 1))
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 1) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| (- 1))
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base (- 1))
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 1)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| (- 1))
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| (- 1))
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 1)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| (- 1))
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 1)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| (- 1))
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) (* aux_3539 1) 
 (* aux_3546 (- 1)) (- 1)) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 1)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset (- 1)) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 1) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 1) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 (- 1)) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 1)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| (- 1)) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 1) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base (- 1))
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 1)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 1)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0)
 (* honda_cstpncpy_~n (- 1)) 
 (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset (- 1)) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 1) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 1)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| (- 1))
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| (- 1))
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 1)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) (* aux_3546 (- 1)) 
 (* aux_3548 (- 4294967296)) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) (* aux_3546 1) 
 (* aux_3548 4294967296) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) (* aux_3546 1) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 1)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base (- 1))
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 1)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| (- 1)) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 1) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) (* aux_3544 1) 
 (- 1)) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 1)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) (- 4)) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 1)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset (- 1)) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| (- 1))
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 1) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 1)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) (* aux_3544 (- 1)) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 1)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| (- 1))
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 1)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| (- 1))
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| (- 1))
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 1)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 1)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| (- 1))
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 1) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0))
 (and
 (= |init_(ite (select #valid cstpncpy_~d~3.base) 1 0)|
 |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)|)
 (= |init_(select #length cstpncpy_~s~3.base)|
 |honda_(select #length cstpncpy_~s~3.base)|)
 (= |init_cstpncpy_#t~post4.offset| |honda_cstpncpy_#t~post4.offset|)
 (= |init_(select #length cstpncpy_~d~3.base)|
 |honda_(select #length cstpncpy_~d~3.base)|)
 (= |init_cstpncpy_#t~post4.base| |honda_cstpncpy_#t~post4.base|)
 (=
 |init_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|)
 (= |init_cstpncpy_#t~mem7| |honda_cstpncpy_#t~mem7|)
 (= |init_cstpncpy_#t~post5.offset| |honda_cstpncpy_#t~post5.offset|)
 (= |init_(ite (select #valid cstpncpy_~s~3.base) 1 0)|
 |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)|)
 (= |init_cstpncpy_#t~post3| |honda_cstpncpy_#t~post3|)
 (= |init_cstpncpy_#t~post5.base| |honda_cstpncpy_#t~post5.base|)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 1) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| (- 1))
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 1)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 1)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base (- 1))
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 1)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| (- 1)) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 1) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| (- 1))
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| (- 1))
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 1) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0)
 (* honda_cstpncpy_~n (- 1)) 
 (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base (- 1))
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 1) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) (* aux_3554 (- 1)) 4294967295) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 1) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) (* aux_3554 (- 1)) 
 (* aux_3556 (- 4294967296)) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0)
 (* honda_cstpncpy_~n (- 1)) 
 (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) (* aux_3554 1) 
 (* aux_3556 4294967296) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| (- 1))
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 1)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| (- 1))
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 1)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| (- 1))
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 1) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| (- 1))
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 1)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| (- 1))
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0)
 (* honda_cstpncpy_~s~3.offset (- 1))
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 1) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 1)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 1)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset (- 1)) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 1)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| (- 1))
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) (* aux_3559 1) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 1)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 (- 1)) (* |honda_(select #length cstpncpy_~s~3.base)| 0)
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base (- 1))
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 1)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| (- 1))
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| (- 1))
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 1)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| (- 1))
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 1)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| (- 1))
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) (* aux_3554 1) 
 (* aux_3561 (- 1)) (- 1)) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 1)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset (- 1)) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 1) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 1) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 (- 1)) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| (- 1)) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 1) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base (- 1))
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 1)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 1)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0)
 (* honda_cstpncpy_~n (- 1)) 
 (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset (- 1)) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 1) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 1)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| (- 1))
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| (- 1))
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 1)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) (* aux_3561 (- 1)) 
 (* aux_3563 (- 4294967296)) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) (* aux_3561 1) 
 (* aux_3563 4294967296) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) (* aux_3561 1) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 1)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base (- 1))
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 1)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| (- 1)) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 1) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) (* aux_3559 1) 
 (- 1)) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 1)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) (- 4)) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 1)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset (- 1)) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| (- 1))
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 1) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 1)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) (* aux_3559 (- 1)) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 1)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| (- 1))
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 1)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| (- 1))
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| (- 1))
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 1)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 1)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| (- 1))
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 1) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0))
 (and
 (= |init_(ite (select #valid cstpncpy_~d~3.base) 1 0)|
 |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)|)
 (= |init_(select #length cstpncpy_~s~3.base)|
 |honda_(select #length cstpncpy_~s~3.base)|)
 (= |init_cstpncpy_#t~post4.offset| |honda_cstpncpy_#t~post4.offset|)
 (= |init_(select #length cstpncpy_~d~3.base)|
 |honda_(select #length cstpncpy_~d~3.base)|)
 (= |init_cstpncpy_#t~post4.base| |honda_cstpncpy_#t~post4.base|)
 (=
 |init_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|)
 (= |init_cstpncpy_#t~mem7| |honda_cstpncpy_#t~mem7|)
 (= |init_cstpncpy_#t~post5.offset| |honda_cstpncpy_#t~post5.offset|)
 (= |init_(ite (select #valid cstpncpy_~s~3.base) 1 0)|
 |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)|)
 (= |init_cstpncpy_#t~post3| |honda_cstpncpy_#t~post3|)
 (= |init_cstpncpy_#t~post5.base| |honda_cstpncpy_#t~post5.base|)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| (- 1))
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 1)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 1)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base (- 1))
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 1)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| (- 1)) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 1) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| (- 1))
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| (- 1))
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 1) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0)
 (* honda_cstpncpy_~n (- 1)) 
 (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base (- 1))
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 1) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) (* aux_3569 (- 1)) 4294967295) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 1) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) (* aux_3569 (- 1)) 
 (* aux_3571 (- 4294967296)) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0)
 (* honda_cstpncpy_~n (- 1)) 
 (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) (* aux_3569 1) 
 (* aux_3571 4294967296) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| (- 1))
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 1)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| (- 1))
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 1)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| (- 1))
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 1) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| (- 1))
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 1)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0)
 (* honda_cstpncpy_~s~3.offset (- 1))
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 1) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 1)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 1)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset (- 1)) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 1)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| (- 1))
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) (* aux_3574 1) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 1)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 (- 1)) (* |honda_(select #length cstpncpy_~s~3.base)| 0)
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| (- 1))
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 1) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base (- 1))
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 1)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| (- 1))
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| (- 1))
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 1)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| (- 1))
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 1)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| (- 1))
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) (* aux_3569 1) 
 (* aux_3576 (- 1)) (- 1)) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 1)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset (- 1)) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 1) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 1) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 (- 1)) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| (- 1)) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 1) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base (- 1))
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 1)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 1)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0)
 (* honda_cstpncpy_~n (- 1)) 
 (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset (- 1)) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 1) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 1)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| (- 1))
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| (- 1))
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 1)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) (* aux_3576 (- 1)) 
 (* aux_3578 (- 4294967296)) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) (* aux_3576 1) 
 (* aux_3578 4294967296) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) (* aux_3576 1) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 1)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base (- 1))
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 1)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| (- 1)) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 1) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) (* aux_3574 1) 
 (- 1)) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 1)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) (- 4)) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 1)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset (- 1)) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| (- 1))
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 1) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 1)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) (* aux_3574 (- 1)) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 1)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| (- 1))
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| (- 1)) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 1)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| (- 1))
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| (- 1))
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 1)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 1)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| (- 1))
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 1) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0))
 (and
 (= |init_(ite (select #valid cstpncpy_~d~3.base) 1 0)|
 |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)|)
 (= |init_(select #length cstpncpy_~s~3.base)|
 |honda_(select #length cstpncpy_~s~3.base)|)
 (= |init_cstpncpy_#t~post4.offset| |honda_cstpncpy_#t~post4.offset|)
 (= |init_(select #length cstpncpy_~d~3.base)|
 |honda_(select #length cstpncpy_~d~3.base)|)
 (= |init_cstpncpy_#t~post4.base| |honda_cstpncpy_#t~post4.base|)
 (=
 |init_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|)
 (= |init_cstpncpy_#t~mem7| |honda_cstpncpy_#t~mem7|)
 (= |init_cstpncpy_#t~post5.offset| |honda_cstpncpy_#t~post5.offset|)
 (= |init_(ite (select #valid cstpncpy_~s~3.base) 1 0)|
 |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)|)
 (= |init_cstpncpy_#t~post3| |honda_cstpncpy_#t~post3|)
 (= |init_cstpncpy_#t~post5.base| |honda_cstpncpy_#t~post5.base|)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| (- 1))
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 1)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 1)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base (- 1))
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 1)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| (- 1)) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 1) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| (- 1))
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| (- 1))
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 1) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0)
 (* honda_cstpncpy_~n (- 1)) 
 (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base (- 1))
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 1) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) (* aux_3584 (- 1)) 4294967295) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 1) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) (* aux_3584 (- 1)) 
 (* aux_3586 (- 4294967296)) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0)
 (* honda_cstpncpy_~n (- 1)) 
 (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) (* aux_3584 1) 
 (* aux_3586 4294967296) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| (- 1))
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 1)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| (- 1))
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 1)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| (- 1))
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 1) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| (- 1))
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 1)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 1)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0)
 (* honda_cstpncpy_~s~3.offset (- 1))
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 1) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 1)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 1)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset (- 1)) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 1)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| (- 1))
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) (* aux_3589 1) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 1)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 (- 1)) (* |honda_(select #length cstpncpy_~s~3.base)| 0)
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base (- 1))
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 1)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| (- 1))
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| (- 1))
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 1)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| (- 1))
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 1)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| (- 1))
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) (* aux_3584 1) 
 (* aux_3591 (- 1)) (- 1)) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 1)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset (- 1)) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 1) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 1) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 (- 1)) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| (- 1)) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 1) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base (- 1))
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 1)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 1)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0)
 (* honda_cstpncpy_~n (- 1)) 
 (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset (- 1)) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 1) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 1)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| (- 1))
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| (- 1))
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 1)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) (* aux_3591 (- 1)) 
 (* aux_3593 (- 4294967296)) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) (* aux_3591 1) 
 (* aux_3593 4294967296) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) (* aux_3591 1) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 1)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base (- 1))
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 1)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| (- 1)) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 1) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) (* aux_3589 1) 
 (- 1)) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 1)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) (- 4)) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 1)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset (- 1)) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| (- 1))
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 1) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 1)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) (* aux_3589 (- 1)) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 1)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| (- 1))
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| (- 1)) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 1)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| (- 1))
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| (- 1))
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 1)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 1)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| (- 1))
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 1) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0))
 (and
 (= |init_(ite (select #valid cstpncpy_~d~3.base) 1 0)|
 |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)|)
 (= |init_(select #length cstpncpy_~s~3.base)|
 |honda_(select #length cstpncpy_~s~3.base)|)
 (= |init_cstpncpy_#t~post4.offset| |honda_cstpncpy_#t~post4.offset|)
 (= |init_(select #length cstpncpy_~d~3.base)|
 |honda_(select #length cstpncpy_~d~3.base)|)
 (= |init_cstpncpy_#t~post4.base| |honda_cstpncpy_#t~post4.base|)
 (=
 |init_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|)
 (= |init_cstpncpy_#t~mem7| |honda_cstpncpy_#t~mem7|)
 (= |init_cstpncpy_#t~post5.offset| |honda_cstpncpy_#t~post5.offset|)
 (= |init_(ite (select #valid cstpncpy_~s~3.base) 1 0)|
 |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)|)
 (= |init_cstpncpy_#t~post3| |honda_cstpncpy_#t~post3|)
 (= |init_cstpncpy_#t~post5.base| |honda_cstpncpy_#t~post5.base|)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| (- 1))
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 1)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 1)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base (- 1))
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 1)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| (- 1)) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 1) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| (- 1))
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| (- 1))
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 1) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0)
 (* honda_cstpncpy_~n (- 1)) 
 (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base (- 1))
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 1) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) (* aux_3599 (- 1)) 4294967295) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 1) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) (* aux_3599 (- 1)) 
 (* aux_3601 (- 4294967296)) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0)
 (* honda_cstpncpy_~n (- 1)) 
 (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) (* aux_3599 1) 
 (* aux_3601 4294967296) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| (- 1))
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 1)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| (- 1))
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 1) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| (- 1))
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 1)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0)
 (* honda_cstpncpy_~s~3.offset (- 1))
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 1) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 1)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 1)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset (- 1)) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 1)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| (- 1))
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) (* aux_3604 1) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 1)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 (- 1)) (* |honda_(select #length cstpncpy_~s~3.base)| 0)
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| (- 1)) 
 (* |honda_cstpncpy_#in~src.base| 1)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| (- 1))
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base (- 1))
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 1)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| (- 1))
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| (- 1))
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 1)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| (- 1))
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 1)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| (- 1))
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) (* aux_3599 1) 
 (* aux_3606 (- 1)) (- 1)) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 1)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset (- 1)) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 1) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 1) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 (- 1)) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 1)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| (- 1)) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 1) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base (- 1))
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 1)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 1)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0)
 (* honda_cstpncpy_~n (- 1)) 
 (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset (- 1)) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 1) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 1)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| (- 1))
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| (- 1))
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 1)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) (* aux_3606 (- 1)) 
 (* aux_3608 (- 4294967296)) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) (* aux_3606 1) 
 (* aux_3608 4294967296) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) (* aux_3606 1) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 1)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base (- 1))
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 1)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| (- 1)) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 1) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) (* aux_3604 1) 
 (- 1)) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 1)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) (- 4)) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 1)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset (- 1)) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| (- 1))
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 1) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 1)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) (* aux_3604 (- 1)) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 1)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| (- 1))
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 1)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| (- 1))
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| (- 1))
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 1)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 1)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| (- 1))
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 1) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0))
 (and
 (= |init_(ite (select #valid cstpncpy_~d~3.base) 1 0)|
 |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)|)
 (= |init_(select #length cstpncpy_~s~3.base)|
 |honda_(select #length cstpncpy_~s~3.base)|)
 (= |init_cstpncpy_#t~post4.offset| |honda_cstpncpy_#t~post4.offset|)
 (= |init_(select #length cstpncpy_~d~3.base)|
 |honda_(select #length cstpncpy_~d~3.base)|)
 (= |init_cstpncpy_#t~post4.base| |honda_cstpncpy_#t~post4.base|)
 (=
 |init_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|)
 (= |init_cstpncpy_#t~mem7| |honda_cstpncpy_#t~mem7|)
 (= |init_cstpncpy_#t~post5.offset| |honda_cstpncpy_#t~post5.offset|)
 (= |init_(ite (select #valid cstpncpy_~s~3.base) 1 0)|
 |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)|)
 (= |init_cstpncpy_#t~post3| |honda_cstpncpy_#t~post3|)
 (= |init_cstpncpy_#t~post5.base| |honda_cstpncpy_#t~post5.base|)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| (- 1))
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 1)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 1)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base (- 1))
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 1)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| (- 1)) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 1) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| (- 1))
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| (- 1))
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 1) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0)
 (* honda_cstpncpy_~n (- 1)) 
 (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 1) 
 (* |honda_cstpncpy_#in~src.base| (- 1))
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base (- 1))
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 1) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) (* aux_3614 (- 1)) 4294967295) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 1) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) (* aux_3614 (- 1)) 
 (* aux_3616 (- 4294967296)) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0)
 (* honda_cstpncpy_~n (- 1)) 
 (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) (* aux_3614 1) 
 (* aux_3616 4294967296) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| (- 1))
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 1)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| (- 1))
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 1) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| (- 1))
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 1)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0)
 (* honda_cstpncpy_~s~3.offset (- 1))
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 1) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 1)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 1)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset (- 1)) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 1)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| (- 1))
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) (* aux_3619 1) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 1)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 (- 1)) (* |honda_(select #length cstpncpy_~s~3.base)| 0)
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base (- 1))
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 1)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| (- 1))
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| (- 1))
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 1)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| (- 1))
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 1)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| (- 1))
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) (* aux_3614 1) 
 (* aux_3621 (- 1)) (- 1)) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 1)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset (- 1)) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 1) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 1) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 (- 1)) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 1)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| (- 1)) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 1) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base (- 1))
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 1)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 1)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0)
 (* honda_cstpncpy_~n (- 1)) 
 (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset (- 1)) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 1) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 1)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| (- 1))
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| (- 1))
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 1)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| (- 1))
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 1)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) (* aux_3621 (- 1)) 
 (* aux_3623 (- 4294967296)) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) (* aux_3621 1) 
 (* aux_3623 4294967296) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) (* aux_3621 1) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 1)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base (- 1))
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 1)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| (- 1)) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 1) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) (* aux_3619 1) 
 (- 1)) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 1)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) (- 4)) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 1)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset (- 1)) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| (- 1))
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 1) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 1)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) (* aux_3619 (- 1)) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 1)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| (- 1))
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 1)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| (- 1))
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| (- 1))
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 1)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 1)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| (- 1))
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 1) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0))
 (and
 (= |init_(ite (select #valid cstpncpy_~d~3.base) 1 0)|
 |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)|)
 (= |init_(select #length cstpncpy_~s~3.base)|
 |honda_(select #length cstpncpy_~s~3.base)|)
 (= |init_cstpncpy_#t~post4.offset| |honda_cstpncpy_#t~post4.offset|)
 (= |init_(select #length cstpncpy_~d~3.base)|
 |honda_(select #length cstpncpy_~d~3.base)|)
 (= |init_cstpncpy_#t~post4.base| |honda_cstpncpy_#t~post4.base|)
 (=
 |init_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|)
 (= |init_cstpncpy_#t~mem7| |honda_cstpncpy_#t~mem7|)
 (= |init_cstpncpy_#t~post5.offset| |honda_cstpncpy_#t~post5.offset|)
 (= |init_(ite (select #valid cstpncpy_~s~3.base) 1 0)|
 |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)|)
 (= |init_cstpncpy_#t~post3| |honda_cstpncpy_#t~post3|)
 (= |init_cstpncpy_#t~post5.base| |honda_cstpncpy_#t~post5.base|)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| (- 1))
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 1)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 1)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base (- 1))
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 1)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| (- 1)) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 1) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| (- 1))
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| (- 1))
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 1) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0)
 (* honda_cstpncpy_~n (- 1)) 
 (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base (- 1))
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 1) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) (* aux_3629 (- 1)) 4294967295) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 1) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) (* aux_3629 (- 1)) 
 (* aux_3631 (- 4294967296)) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0)
 (* honda_cstpncpy_~n (- 1)) 
 (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) (* aux_3629 1) 
 (* aux_3631 4294967296) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| (- 1))
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 1)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| (- 1))
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 1)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| (- 1))
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 1) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| (- 1))
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 1)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 1)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0)
 (* honda_cstpncpy_~s~3.offset (- 1))
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 1) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 1)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 1)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset (- 1)) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 1)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| (- 1))
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) (* aux_3634 1) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 1)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 (- 1)) (* |honda_(select #length cstpncpy_~s~3.base)| 0)
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| (- 1))
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 1) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base (- 1))
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 1)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| (- 1))
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| (- 1))
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 1)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| (- 1))
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 1)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| (- 1))
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) (* aux_3629 1) 
 (* aux_3636 (- 1)) (- 1)) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 1)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset (- 1)) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 1) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 1) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 (- 1)) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| (- 1)) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 1) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base (- 1))
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 1)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 1)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0)
 (* honda_cstpncpy_~n (- 1)) 
 (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset (- 1)) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 1) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 1)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| (- 1))
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| (- 1))
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 1)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) (* aux_3636 (- 1)) 
 (* aux_3638 (- 4294967296)) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) (* aux_3636 1) 
 (* aux_3638 4294967296) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) (* aux_3636 1) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 1)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base (- 1))
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 1)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| (- 1)) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 1) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) (* aux_3634 1) 
 (- 1)) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 1)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) (- 4)) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 1)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset (- 1)) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| (- 1))
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 1) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 1)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) (* aux_3634 (- 1)) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 1)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| (- 1))
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 1)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| (- 1))
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| (- 1))
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 1)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 1)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| (- 1))
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 1) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0))
 (and
 (= |init_(ite (select #valid cstpncpy_~d~3.base) 1 0)|
 |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)|)
 (= |init_(select #length cstpncpy_~s~3.base)|
 |honda_(select #length cstpncpy_~s~3.base)|)
 (= |init_cstpncpy_#t~post4.offset| |honda_cstpncpy_#t~post4.offset|)
 (= |init_(select #length cstpncpy_~d~3.base)|
 |honda_(select #length cstpncpy_~d~3.base)|)
 (= |init_cstpncpy_#t~post4.base| |honda_cstpncpy_#t~post4.base|)
 (=
 |init_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|)
 (= |init_cstpncpy_#t~mem7| |honda_cstpncpy_#t~mem7|)
 (= |init_cstpncpy_#t~post5.offset| |honda_cstpncpy_#t~post5.offset|)
 (= |init_(ite (select #valid cstpncpy_~s~3.base) 1 0)|
 |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)|)
 (= |init_cstpncpy_#t~post3| |honda_cstpncpy_#t~post3|)
 (= |init_cstpncpy_#t~post5.base| |honda_cstpncpy_#t~post5.base|)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| (- 1))
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 1)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 1)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base (- 1))
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 1)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| (- 1)) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 1) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| (- 1))
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| (- 1))
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 1) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0)
 (* honda_cstpncpy_~n (- 1)) 
 (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 1) 
 (* |honda_cstpncpy_#in~src.base| (- 1))
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base (- 1))
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 1) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) (* aux_3644 (- 1)) 4294967295) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 1) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) (* aux_3644 (- 1)) 
 (* aux_3646 (- 4294967296)) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0)
 (* honda_cstpncpy_~n (- 1)) 
 (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) (* aux_3644 1) 
 (* aux_3646 4294967296) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| (- 1))
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 1)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| (- 1))
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 1) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| (- 1))
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 1)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0)
 (* honda_cstpncpy_~s~3.offset (- 1))
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 1) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 1)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 1)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset (- 1)) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 1)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| (- 1))
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) (* aux_3649 1) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 1)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 (- 1)) (* |honda_(select #length cstpncpy_~s~3.base)| 0)
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base (- 1))
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 1)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| (- 1))
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| (- 1))
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 1)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| (- 1))
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 1)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| (- 1))
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) (* aux_3644 1) 
 (* aux_3651 (- 1)) (- 1)) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 1)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset (- 1)) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 1) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 1) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 (- 1)) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 1)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| (- 1)) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 1) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base (- 1))
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 1)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 1)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0)
 (* honda_cstpncpy_~n (- 1)) 
 (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset (- 1)) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 1) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 1)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| (- 1))
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| (- 1))
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 1)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) (* aux_3651 (- 1)) 
 (* aux_3653 (- 4294967296)) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) (* aux_3651 1) 
 (* aux_3653 4294967296) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) (* aux_3651 1) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 1)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base (- 1))
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 1)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| (- 1)) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 1) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) (* aux_3649 1) 
 (- 1)) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 1)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) (- 4)) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 1)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset (- 1)) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| (- 1))
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 1) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 1)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) (* aux_3649 (- 1)) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 1)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| (- 1))
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| (- 1)) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 1)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| (- 1))
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| (- 1))
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 1)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 1)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| (- 1))
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 1) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0))
 (and
 (= |init_(ite (select #valid cstpncpy_~d~3.base) 1 0)|
 |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)|)
 (= |init_(select #length cstpncpy_~s~3.base)|
 |honda_(select #length cstpncpy_~s~3.base)|)
 (= |init_cstpncpy_#t~post4.offset| |honda_cstpncpy_#t~post4.offset|)
 (= |init_(select #length cstpncpy_~d~3.base)|
 |honda_(select #length cstpncpy_~d~3.base)|)
 (= |init_cstpncpy_#t~post4.base| |honda_cstpncpy_#t~post4.base|)
 (=
 |init_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|)
 (= |init_cstpncpy_#t~mem7| |honda_cstpncpy_#t~mem7|)
 (= |init_cstpncpy_#t~post5.offset| |honda_cstpncpy_#t~post5.offset|)
 (= |init_(ite (select #valid cstpncpy_~s~3.base) 1 0)|
 |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)|)
 (= |init_cstpncpy_#t~post3| |honda_cstpncpy_#t~post3|)
 (= |init_cstpncpy_#t~post5.base| |honda_cstpncpy_#t~post5.base|)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| (- 1))
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 1)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 1)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base (- 1))
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 1)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| (- 1)) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 1) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| (- 1))
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| (- 1))
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 1) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0)
 (* honda_cstpncpy_~n (- 1)) 
 (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base (- 1))
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 1) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) (* aux_3659 (- 1)) 4294967295) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 1) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) (* aux_3659 (- 1)) 
 (* aux_3661 (- 4294967296)) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0)
 (* honda_cstpncpy_~n (- 1)) 
 (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) (* aux_3659 1) 
 (* aux_3661 4294967296) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| (- 1))
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 1)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| (- 1))
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 1) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| (- 1))
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 1)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 1)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0)
 (* honda_cstpncpy_~s~3.offset (- 1))
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 1) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 1)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 1)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset (- 1)) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 1)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| (- 1))
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) (* aux_3664 1) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 1)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 (- 1)) (* |honda_(select #length cstpncpy_~s~3.base)| 0)
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| (- 1))
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 1) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base (- 1))
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 1)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| (- 1))
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| (- 1))
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 1)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| (- 1))
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 1)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| (- 1))
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) (* aux_3659 1) 
 (* aux_3666 (- 1)) (- 1)) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 1)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset (- 1)) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 1) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 1) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 (- 1)) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| (- 1)) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 1) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base (- 1))
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 1)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 1)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0)
 (* honda_cstpncpy_~n (- 1)) 
 (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset (- 1)) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 1) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 1)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| (- 1))
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| (- 1))
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 1)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) (* aux_3666 (- 1)) 
 (* aux_3668 (- 4294967296)) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) (* aux_3666 1) 
 (* aux_3668 4294967296) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) (* aux_3666 1) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 1)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base (- 1))
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 1)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| (- 1)) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 1) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) (* aux_3664 1) 
 (- 1)) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 1)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) (- 4)) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 1)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset (- 1)) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| (- 1))
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 1) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 1)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) (* aux_3664 (- 1)) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 1)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| (- 1))
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| (- 1)) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 1)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| (- 1))
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| (- 1))
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 1)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 1)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_cstpncpy_#t~mem0.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select old(#length) cstpncpy_#in~src.base)| 0)
 (* |honda_cstpncpy_~#dst.offset| 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* honda_cstpncpy_~d~3.base 0)
 (*
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_cstpncpy_#in~src.offset| 0)
 (* |honda_(select #length cstpncpy_#in~src.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~mem1.offset| 0) 
 (* |honda_cstpncpy_#t~mem0.base| 0)
 (* |honda_(select #length cstpncpy_#in~dst.base)| 0)
 (*
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_#NULL.offset| 0) 
 (* |honda_cstpncpy_#in~n| 0) 
 (* |honda_cstpncpy_#t~mem1.base| 0) 
 (* |honda_cstpncpy_#t~post5.base| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select old(#length) cstpncpy_~#dst.base)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#in~dst.base| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_(select #length cstpncpy_~#dst.base)| 0)
 (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)| 0)
 (* |honda_(select old(#length) cstpncpy_#in~dst.base)| 0)
 (* |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)| 0)
 (* |honda_cstpncpy_#in~dst.offset| (- 1))
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~src.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 1) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* honda_cstpncpy_~src.offset 0) 
 (* |honda_cstpncpy_~#dst.base| 0) 
 (* |honda_cstpncpy_#in~src.base| 0)
 (*
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 0) (* |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| 0)
 (* init_cstpncpy_~s~3.base 0) 
 (* |init_cstpncpy_#t~mem0.offset| 0) 
 (* init_cstpncpy_~s~3.offset 0) 
 (* init_cstpncpy_~n 0) (* |init_cstpncpy_#in~dst.base| 0)
 (* |init_cstpncpy_~#dst.offset| 0) 
 (* init_cstpncpy_~d~3.base 0) 
 (* |init_cstpncpy_#in~src.offset| 0) 
 (* |init_cstpncpy_#in~dst.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_cstpncpy_#t~mem1.offset| 0) 
 (* init_cstpncpy_~src.base 0) 
 (* |init_cstpncpy_#t~mem0.base| 0) 
 (* |init_#NULL.offset| 0) 
 (* init_cstpncpy_~d~3.offset 0) 
 (* init_cstpncpy_~src.offset 0) 
 (* |init_cstpncpy_#in~n| 0) 
 (* |init_cstpncpy_~#dst.base| 0) 
 (* |init_cstpncpy_#t~mem1.base| 0) 
 (* |init_cstpncpy_#in~src.base| 0) 
 (* |init_#NULL.base| 0) 0) 0)))
 (or
 (and
 (= |honda_cstpncpy_#t~mem0.offset|
 (+ |honda_cstpncpy_#t~mem0.offset| |ray_cstpncpy_#t~mem0.offset|))
 (=
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 (+
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 |ray_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|))
 (= |honda_(select old(#length) cstpncpy_#in~src.base)|
 (+ |honda_(select old(#length) cstpncpy_#in~src.base)|
 |ray_(select old(#length) cstpncpy_#in~src.base)|))
 (= |honda_cstpncpy_~#dst.offset|
 (+ |honda_cstpncpy_~#dst.offset| |ray_cstpncpy_~#dst.offset|))
 (=
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 (+
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 |ray_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|))
 (=
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 (+
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 |ray_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|))
 (= |honda_(select #length cstpncpy_#in~src.base)|
 (+ |honda_(select #length cstpncpy_#in~src.base)|
 |ray_(select #length cstpncpy_#in~src.base)|))
 (= |honda_cstpncpy_#in~src.offset|
 (+ |honda_cstpncpy_#in~src.offset| |ray_cstpncpy_#in~src.offset|))
 (= |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)|
 (+ |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)|
 |ray_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)|))
 (= |honda_cstpncpy_#t~mem1.offset|
 (+ |honda_cstpncpy_#t~mem1.offset| |ray_cstpncpy_#t~mem1.offset|))
 (= |honda_(select #length cstpncpy_#in~dst.base)|
 (+ |honda_(select #length cstpncpy_#in~dst.base)|
 |ray_(select #length cstpncpy_#in~dst.base)|))
 (= |honda_cstpncpy_#t~mem0.base|
 (+ |honda_cstpncpy_#t~mem0.base| |ray_cstpncpy_#t~mem0.base|))
 (=
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 (+
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 |ray_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|))
 (= |honda_#NULL.offset| (+ |honda_#NULL.offset| |ray_#NULL.offset|))
 (= |honda_cstpncpy_#in~n| (+ |honda_cstpncpy_#in~n| |ray_cstpncpy_#in~n|))
 (= |honda_cstpncpy_#t~mem1.base|
 (+ |honda_cstpncpy_#t~mem1.base| |ray_cstpncpy_#t~mem1.base|))
 (= |honda_#NULL.base| (+ |honda_#NULL.base| |ray_#NULL.base|))
 (= |honda_(select old(#length) cstpncpy_~#dst.base)|
 (+ |honda_(select old(#length) cstpncpy_~#dst.base)|
 |ray_(select old(#length) cstpncpy_~#dst.base)|))
 (=
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 (+
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 |ray_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|))
 (= |honda_cstpncpy_#in~dst.base|
 (+ |honda_cstpncpy_#in~dst.base| |ray_cstpncpy_#in~dst.base|))
 (= |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)|
 (+ |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)|
 |ray_(ite (select #valid cstpncpy_#in~dst.base) 1 0)|))
 (= |honda_(select #length cstpncpy_~#dst.base)|
 (+ |honda_(select #length cstpncpy_~#dst.base)|
 |ray_(select #length cstpncpy_~#dst.base)|))
 (= |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)|
 (+ |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)|
 |ray_(ite (select #valid cstpncpy_~#dst.base) 1 0)|))
 (= |honda_(select old(#length) cstpncpy_#in~dst.base)|
 (+ |honda_(select old(#length) cstpncpy_#in~dst.base)|
 |ray_(select old(#length) cstpncpy_#in~dst.base)|))
 (= |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)|
 (+ |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)|
 |ray_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)|))
 (= |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)|
 (+ |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)|
 |ray_(ite (select #valid cstpncpy_#in~src.base) 1 0)|))
 (= |honda_cstpncpy_#in~dst.offset|
 (+ |honda_cstpncpy_#in~dst.offset| |ray_cstpncpy_#in~dst.offset|))
 (= |honda_(ite (select #valid 0) 1 0)|
 (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|))
 (= honda_cstpncpy_~src.base
 (+ honda_cstpncpy_~src.base ray_cstpncpy_~src.base))
 (= |honda_(ite (select old(#valid) 0) 1 0)|
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|))
 (= |honda_cstpncpy_~#dst.base|
 (+ |honda_cstpncpy_~#dst.base| |ray_cstpncpy_~#dst.base|))
 (= honda_cstpncpy_~src.offset
 (+ honda_cstpncpy_~src.offset ray_cstpncpy_~src.offset))
 (= |honda_cstpncpy_#in~src.base|
 (+ |honda_cstpncpy_#in~src.base| |ray_cstpncpy_#in~src.base|))
 (=
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 (+
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 |ray_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|))
 (= |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)|
 (+ |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)|
 |ray_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)|))
 (>=
 (+ (* (+ |honda_cstpncpy_#t~mem0.offset| |ray_cstpncpy_#t~mem0.offset|) 0)
 (*
 (+ |honda_(select #length cstpncpy_~d~3.base)|
 |ray_(select #length cstpncpy_~d~3.base)|) 0)
 (* (+ |honda_cstpncpy_#t~post4.offset| |ray_cstpncpy_#t~post4.offset|) 0)
 (* (+ honda_cstpncpy_~s~3.offset ray_cstpncpy_~s~3.offset) 0)
 (*
 (+
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 |ray_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|)
 0)
 (*
 (+ |honda_(select old(#length) cstpncpy_#in~src.base)|
 |ray_(select old(#length) cstpncpy_#in~src.base)|) 0)
 (* (+ |honda_cstpncpy_~#dst.offset| |ray_cstpncpy_~#dst.offset|) 0)
 (*
 (+
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 |ray_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|)
 0) (* (+ |honda_cstpncpy_#t~mem7| |ray_cstpncpy_#t~mem7|) 0)
 (*
 (+
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 |ray_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|)
 0) (* (+ honda_cstpncpy_~d~3.base ray_cstpncpy_~d~3.base) 0)
 (*
 (+
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 |ray_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|)
 0)
 (*
 (+ |honda_(select #length cstpncpy_#in~src.base)|
 |ray_(select #length cstpncpy_#in~src.base)|) 0)
 (* (+ |honda_cstpncpy_#in~src.offset| |ray_cstpncpy_#in~src.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)|
 |ray_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)|) 0)
 (* (+ |honda_cstpncpy_#t~mem1.offset| |ray_cstpncpy_#t~mem1.offset|) 0)
 (*
 (+ |honda_(select #length cstpncpy_#in~dst.base)|
 |ray_(select #length cstpncpy_#in~dst.base)|) 0)
 (* (+ |honda_cstpncpy_#t~mem0.base| |ray_cstpncpy_#t~mem0.base|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 |ray_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|)
 0) (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_cstpncpy_#in~n| |ray_cstpncpy_#in~n|) 0)
 (* (+ |honda_cstpncpy_#t~mem1.base| |ray_cstpncpy_#t~mem1.base|) 0)
 (* (+ |honda_cstpncpy_#t~post5.base| |ray_cstpncpy_#t~post5.base|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(select old(#length) cstpncpy_~#dst.base)|
 |ray_(select old(#length) cstpncpy_~#dst.base)|) 0)
 (*
 (+ |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)|
 |ray_(ite (select #valid cstpncpy_~d~3.base) 1 0)|) 0)
 (* (+ honda_cstpncpy_~s~3.base ray_cstpncpy_~s~3.base) 0)
 (*
 (+
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 |ray_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|)
 0)
 (*
 (+ |honda_(select #length cstpncpy_~s~3.base)|
 |ray_(select #length cstpncpy_~s~3.base)|) 
 (- 1)) (* (+ honda_cstpncpy_~n ray_cstpncpy_~n) 0)
 (* (+ |honda_cstpncpy_#in~dst.base| |ray_cstpncpy_#in~dst.base|) 0)
 (*
 (+ |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)|
 |ray_(ite (select #valid cstpncpy_#in~dst.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length cstpncpy_~#dst.base)|
 |ray_(select #length cstpncpy_~#dst.base)|) 0)
 (* (+ |honda_cstpncpy_#t~post4.base| |ray_cstpncpy_#t~post4.base|) 0)
 (*
 (+ |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)|
 |ray_(ite (select #valid cstpncpy_~#dst.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) cstpncpy_#in~dst.base)|
 |ray_(select old(#length) cstpncpy_#in~dst.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)|
 |ray_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)|) 0)
 (* (+ |honda_cstpncpy_#t~post5.offset| |ray_cstpncpy_#t~post5.offset|) 0)
 (*
 (+ |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)|
 |ray_(ite (select #valid cstpncpy_#in~src.base) 1 0)|) 0)
 (* (+ |honda_cstpncpy_#in~dst.offset| |ray_cstpncpy_#in~dst.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)|
 |ray_(ite (select #valid cstpncpy_~s~3.base) 1 0)|) 0)
 (* (+ honda_cstpncpy_~src.base ray_cstpncpy_~src.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ honda_cstpncpy_~d~3.offset ray_cstpncpy_~d~3.offset) 0)
 (* (+ |honda_cstpncpy_#t~post3| |ray_cstpncpy_#t~post3|) 0)
 (* (+ |honda_cstpncpy_~#dst.base| |ray_cstpncpy_~#dst.base|) 0)
 (* (+ honda_cstpncpy_~src.offset ray_cstpncpy_~src.offset) 0)
 (* (+ |honda_cstpncpy_#in~src.base| |ray_cstpncpy_#in~src.base|) 0)
 (*
 (+
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 |ray_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)|
 |ray_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)|) 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0) 
 (* honda_cstpncpy_~d~3.base 0) 
 (* |honda_cstpncpy_#t~post5.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(select #length cstpncpy_~s~3.base)| 1) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 0) 0)
 (>=
 (+ (* (+ |honda_cstpncpy_#t~mem0.offset| |ray_cstpncpy_#t~mem0.offset|) 0)
 (*
 (+ |honda_(select #length cstpncpy_~d~3.base)|
 |ray_(select #length cstpncpy_~d~3.base)|) 0)
 (* (+ |honda_cstpncpy_#t~post4.offset| |ray_cstpncpy_#t~post4.offset|) 0)
 (* (+ honda_cstpncpy_~s~3.offset ray_cstpncpy_~s~3.offset) 0)
 (*
 (+
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 |ray_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|)
 0)
 (*
 (+ |honda_(select old(#length) cstpncpy_#in~src.base)|
 |ray_(select old(#length) cstpncpy_#in~src.base)|) 0)
 (* (+ |honda_cstpncpy_~#dst.offset| |ray_cstpncpy_~#dst.offset|) 0)
 (*
 (+
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 |ray_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|)
 0) (* (+ |honda_cstpncpy_#t~mem7| |ray_cstpncpy_#t~mem7|) 0)
 (*
 (+
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 |ray_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|)
 0) (* (+ honda_cstpncpy_~d~3.base ray_cstpncpy_~d~3.base) (- 1))
 (*
 (+
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 |ray_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|)
 0)
 (*
 (+ |honda_(select #length cstpncpy_#in~src.base)|
 |ray_(select #length cstpncpy_#in~src.base)|) 0)
 (* (+ |honda_cstpncpy_#in~src.offset| |ray_cstpncpy_#in~src.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)|
 |ray_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)|) 0)
 (* (+ |honda_cstpncpy_#t~mem1.offset| |ray_cstpncpy_#t~mem1.offset|) 0)
 (*
 (+ |honda_(select #length cstpncpy_#in~dst.base)|
 |ray_(select #length cstpncpy_#in~dst.base)|) 0)
 (* (+ |honda_cstpncpy_#t~mem0.base| |ray_cstpncpy_#t~mem0.base|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 |ray_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|)
 0) (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_cstpncpy_#in~n| |ray_cstpncpy_#in~n|) 0)
 (* (+ |honda_cstpncpy_#t~mem1.base| |ray_cstpncpy_#t~mem1.base|) 0)
 (* (+ |honda_cstpncpy_#t~post5.base| |ray_cstpncpy_#t~post5.base|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(select old(#length) cstpncpy_~#dst.base)|
 |ray_(select old(#length) cstpncpy_~#dst.base)|) 0)
 (*
 (+ |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)|
 |ray_(ite (select #valid cstpncpy_~d~3.base) 1 0)|) 0)
 (* (+ honda_cstpncpy_~s~3.base ray_cstpncpy_~s~3.base) 0)
 (*
 (+
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 |ray_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|)
 0)
 (*
 (+ |honda_(select #length cstpncpy_~s~3.base)|
 |ray_(select #length cstpncpy_~s~3.base)|) 0)
 (* (+ honda_cstpncpy_~n ray_cstpncpy_~n) 0)
 (* (+ |honda_cstpncpy_#in~dst.base| |ray_cstpncpy_#in~dst.base|) 0)
 (*
 (+ |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)|
 |ray_(ite (select #valid cstpncpy_#in~dst.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length cstpncpy_~#dst.base)|
 |ray_(select #length cstpncpy_~#dst.base)|) 0)
 (* (+ |honda_cstpncpy_#t~post4.base| |ray_cstpncpy_#t~post4.base|) 0)
 (*
 (+ |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)|
 |ray_(ite (select #valid cstpncpy_~#dst.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) cstpncpy_#in~dst.base)|
 |ray_(select old(#length) cstpncpy_#in~dst.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)|
 |ray_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)|) 0)
 (* (+ |honda_cstpncpy_#t~post5.offset| |ray_cstpncpy_#t~post5.offset|) 0)
 (*
 (+ |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)|
 |ray_(ite (select #valid cstpncpy_#in~src.base) 1 0)|) 0)
 (* (+ |honda_cstpncpy_#in~dst.offset| |ray_cstpncpy_#in~dst.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)|
 |ray_(ite (select #valid cstpncpy_~s~3.base) 1 0)|) 0)
 (* (+ honda_cstpncpy_~src.base ray_cstpncpy_~src.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ honda_cstpncpy_~d~3.offset ray_cstpncpy_~d~3.offset) 0)
 (* (+ |honda_cstpncpy_#t~post3| |ray_cstpncpy_#t~post3|) 0)
 (* (+ |honda_cstpncpy_~#dst.base| |ray_cstpncpy_~#dst.base|) 0)
 (* (+ honda_cstpncpy_~src.offset ray_cstpncpy_~src.offset) 0)
 (* (+ |honda_cstpncpy_#in~src.base| |ray_cstpncpy_#in~src.base|) 0)
 (*
 (+
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 |ray_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)|
 |ray_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)|) 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0) 
 (* honda_cstpncpy_~d~3.base 1) 
 (* |honda_cstpncpy_#t~post5.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 0) 0)
 (>=
 (+ (* (+ |honda_cstpncpy_#t~mem0.offset| |ray_cstpncpy_#t~mem0.offset|) 0)
 (*
 (+ |honda_(select #length cstpncpy_~d~3.base)|
 |ray_(select #length cstpncpy_~d~3.base)|) 0)
 (* (+ |honda_cstpncpy_#t~post4.offset| |ray_cstpncpy_#t~post4.offset|) 0)
 (* (+ honda_cstpncpy_~s~3.offset ray_cstpncpy_~s~3.offset) 0)
 (*
 (+
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 |ray_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|)
 0)
 (*
 (+ |honda_(select old(#length) cstpncpy_#in~src.base)|
 |ray_(select old(#length) cstpncpy_#in~src.base)|) 0)
 (* (+ |honda_cstpncpy_~#dst.offset| |ray_cstpncpy_~#dst.offset|) 0)
 (*
 (+
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 |ray_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|)
 0) (* (+ |honda_cstpncpy_#t~mem7| |ray_cstpncpy_#t~mem7|) 0)
 (*
 (+
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 |ray_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|)
 0) (* (+ honda_cstpncpy_~d~3.base ray_cstpncpy_~d~3.base) 0)
 (*
 (+
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 |ray_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|)
 0)
 (*
 (+ |honda_(select #length cstpncpy_#in~src.base)|
 |ray_(select #length cstpncpy_#in~src.base)|) 0)
 (* (+ |honda_cstpncpy_#in~src.offset| |ray_cstpncpy_#in~src.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)|
 |ray_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)|) 0)
 (* (+ |honda_cstpncpy_#t~mem1.offset| |ray_cstpncpy_#t~mem1.offset|) 0)
 (*
 (+ |honda_(select #length cstpncpy_#in~dst.base)|
 |ray_(select #length cstpncpy_#in~dst.base)|) 0)
 (* (+ |honda_cstpncpy_#t~mem0.base| |ray_cstpncpy_#t~mem0.base|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 |ray_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|)
 0) (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_cstpncpy_#in~n| |ray_cstpncpy_#in~n|) 0)
 (* (+ |honda_cstpncpy_#t~mem1.base| |ray_cstpncpy_#t~mem1.base|) 0)
 (* (+ |honda_cstpncpy_#t~post5.base| |ray_cstpncpy_#t~post5.base|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(select old(#length) cstpncpy_~#dst.base)|
 |ray_(select old(#length) cstpncpy_~#dst.base)|) 0)
 (*
 (+ |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)|
 |ray_(ite (select #valid cstpncpy_~d~3.base) 1 0)|) 0)
 (* (+ honda_cstpncpy_~s~3.base ray_cstpncpy_~s~3.base) 0)
 (*
 (+
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 |ray_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|)
 0)
 (*
 (+ |honda_(select #length cstpncpy_~s~3.base)|
 |ray_(select #length cstpncpy_~s~3.base)|) 0)
 (* (+ honda_cstpncpy_~n ray_cstpncpy_~n) 0)
 (* (+ |honda_cstpncpy_#in~dst.base| |ray_cstpncpy_#in~dst.base|) 0)
 (*
 (+ |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)|
 |ray_(ite (select #valid cstpncpy_#in~dst.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length cstpncpy_~#dst.base)|
 |ray_(select #length cstpncpy_~#dst.base)|) 0)
 (* (+ |honda_cstpncpy_#t~post4.base| |ray_cstpncpy_#t~post4.base|) 0)
 (*
 (+ |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)|
 |ray_(ite (select #valid cstpncpy_~#dst.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) cstpncpy_#in~dst.base)|
 |ray_(select old(#length) cstpncpy_#in~dst.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)|
 |ray_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)|) 0)
 (* (+ |honda_cstpncpy_#t~post5.offset| |ray_cstpncpy_#t~post5.offset|) 0)
 (*
 (+ |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)|
 |ray_(ite (select #valid cstpncpy_#in~src.base) 1 0)|) 0)
 (* (+ |honda_cstpncpy_#in~dst.offset| |ray_cstpncpy_#in~dst.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)|
 |ray_(ite (select #valid cstpncpy_~s~3.base) 1 0)|) 0)
 (* (+ honda_cstpncpy_~src.base ray_cstpncpy_~src.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ honda_cstpncpy_~d~3.offset ray_cstpncpy_~d~3.offset) (- 1))
 (* (+ |honda_cstpncpy_#t~post3| |ray_cstpncpy_#t~post3|) 0)
 (* (+ |honda_cstpncpy_~#dst.base| |ray_cstpncpy_~#dst.base|) 0)
 (* (+ honda_cstpncpy_~src.offset ray_cstpncpy_~src.offset) 0)
 (* (+ |honda_cstpncpy_#in~src.base| |ray_cstpncpy_#in~src.base|) 0)
 (*
 (+
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 |ray_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)|
 |ray_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)|) 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0) 
 (* honda_cstpncpy_~d~3.base 0) 
 (* |honda_cstpncpy_#t~post5.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 1) 
 (* |honda_cstpncpy_#t~post3| 0) 1) 0)
 (>=
 (+ (* (+ |honda_cstpncpy_#t~mem0.offset| |ray_cstpncpy_#t~mem0.offset|) 0)
 (*
 (+ |honda_(select #length cstpncpy_~d~3.base)|
 |ray_(select #length cstpncpy_~d~3.base)|) 0)
 (* (+ |honda_cstpncpy_#t~post4.offset| |ray_cstpncpy_#t~post4.offset|) 0)
 (* (+ honda_cstpncpy_~s~3.offset ray_cstpncpy_~s~3.offset) 0)
 (*
 (+
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 |ray_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|)
 0)
 (*
 (+ |honda_(select old(#length) cstpncpy_#in~src.base)|
 |ray_(select old(#length) cstpncpy_#in~src.base)|) 0)
 (* (+ |honda_cstpncpy_~#dst.offset| |ray_cstpncpy_~#dst.offset|) 0)
 (*
 (+
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 |ray_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|)
 0) (* (+ |honda_cstpncpy_#t~mem7| |ray_cstpncpy_#t~mem7|) 0)
 (*
 (+
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 |ray_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|)
 0) (* (+ honda_cstpncpy_~d~3.base ray_cstpncpy_~d~3.base) 0)
 (*
 (+
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 |ray_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|)
 0)
 (*
 (+ |honda_(select #length cstpncpy_#in~src.base)|
 |ray_(select #length cstpncpy_#in~src.base)|) 0)
 (* (+ |honda_cstpncpy_#in~src.offset| |ray_cstpncpy_#in~src.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)|
 |ray_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)|) 0)
 (* (+ |honda_cstpncpy_#t~mem1.offset| |ray_cstpncpy_#t~mem1.offset|) 0)
 (*
 (+ |honda_(select #length cstpncpy_#in~dst.base)|
 |ray_(select #length cstpncpy_#in~dst.base)|) 0)
 (* (+ |honda_cstpncpy_#t~mem0.base| |ray_cstpncpy_#t~mem0.base|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 |ray_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|)
 0) (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_cstpncpy_#in~n| |ray_cstpncpy_#in~n|) 0)
 (* (+ |honda_cstpncpy_#t~mem1.base| |ray_cstpncpy_#t~mem1.base|) 0)
 (* (+ |honda_cstpncpy_#t~post5.base| |ray_cstpncpy_#t~post5.base|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(select old(#length) cstpncpy_~#dst.base)|
 |ray_(select old(#length) cstpncpy_~#dst.base)|) 0)
 (*
 (+ |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)|
 |ray_(ite (select #valid cstpncpy_~d~3.base) 1 0)|) 0)
 (* (+ honda_cstpncpy_~s~3.base ray_cstpncpy_~s~3.base) (- 1))
 (*
 (+
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 |ray_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|)
 0)
 (*
 (+ |honda_(select #length cstpncpy_~s~3.base)|
 |ray_(select #length cstpncpy_~s~3.base)|) 0)
 (* (+ honda_cstpncpy_~n ray_cstpncpy_~n) 0)
 (* (+ |honda_cstpncpy_#in~dst.base| |ray_cstpncpy_#in~dst.base|) 0)
 (*
 (+ |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)|
 |ray_(ite (select #valid cstpncpy_#in~dst.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length cstpncpy_~#dst.base)|
 |ray_(select #length cstpncpy_~#dst.base)|) 0)
 (* (+ |honda_cstpncpy_#t~post4.base| |ray_cstpncpy_#t~post4.base|) 0)
 (*
 (+ |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)|
 |ray_(ite (select #valid cstpncpy_~#dst.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) cstpncpy_#in~dst.base)|
 |ray_(select old(#length) cstpncpy_#in~dst.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)|
 |ray_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)|) 0)
 (* (+ |honda_cstpncpy_#t~post5.offset| |ray_cstpncpy_#t~post5.offset|) 0)
 (*
 (+ |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)|
 |ray_(ite (select #valid cstpncpy_#in~src.base) 1 0)|) 0)
 (* (+ |honda_cstpncpy_#in~dst.offset| |ray_cstpncpy_#in~dst.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)|
 |ray_(ite (select #valid cstpncpy_~s~3.base) 1 0)|) 0)
 (* (+ honda_cstpncpy_~src.base ray_cstpncpy_~src.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ honda_cstpncpy_~d~3.offset ray_cstpncpy_~d~3.offset) 0)
 (* (+ |honda_cstpncpy_#t~post3| |ray_cstpncpy_#t~post3|) 0)
 (* (+ |honda_cstpncpy_~#dst.base| |ray_cstpncpy_~#dst.base|) 0)
 (* (+ honda_cstpncpy_~src.offset ray_cstpncpy_~src.offset) 0)
 (* (+ |honda_cstpncpy_#in~src.base| |ray_cstpncpy_#in~src.base|) 0)
 (*
 (+
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 |ray_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)|
 |ray_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)|) 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0) 
 (* honda_cstpncpy_~d~3.base 1) 
 (* |honda_cstpncpy_#t~post5.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (- 1)) 0)
 (>=
 (+ (* (+ |honda_cstpncpy_#t~mem0.offset| |ray_cstpncpy_#t~mem0.offset|) 0)
 (*
 (+ |honda_(select #length cstpncpy_~d~3.base)|
 |ray_(select #length cstpncpy_~d~3.base)|) 0)
 (* (+ |honda_cstpncpy_#t~post4.offset| |ray_cstpncpy_#t~post4.offset|) 0)
 (* (+ honda_cstpncpy_~s~3.offset ray_cstpncpy_~s~3.offset) 0)
 (*
 (+
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 |ray_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|)
 0)
 (*
 (+ |honda_(select old(#length) cstpncpy_#in~src.base)|
 |ray_(select old(#length) cstpncpy_#in~src.base)|) 0)
 (* (+ |honda_cstpncpy_~#dst.offset| |ray_cstpncpy_~#dst.offset|) 0)
 (*
 (+
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 |ray_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|)
 0) (* (+ |honda_cstpncpy_#t~mem7| |ray_cstpncpy_#t~mem7|) 0)
 (*
 (+
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 |ray_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|)
 0) (* (+ honda_cstpncpy_~d~3.base ray_cstpncpy_~d~3.base) 0)
 (*
 (+
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 |ray_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|)
 0)
 (*
 (+ |honda_(select #length cstpncpy_#in~src.base)|
 |ray_(select #length cstpncpy_#in~src.base)|) 0)
 (* (+ |honda_cstpncpy_#in~src.offset| |ray_cstpncpy_#in~src.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)|
 |ray_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)|) 0)
 (* (+ |honda_cstpncpy_#t~mem1.offset| |ray_cstpncpy_#t~mem1.offset|) 0)
 (*
 (+ |honda_(select #length cstpncpy_#in~dst.base)|
 |ray_(select #length cstpncpy_#in~dst.base)|) 0)
 (* (+ |honda_cstpncpy_#t~mem0.base| |ray_cstpncpy_#t~mem0.base|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 |ray_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|)
 0) (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_cstpncpy_#in~n| |ray_cstpncpy_#in~n|) 0)
 (* (+ |honda_cstpncpy_#t~mem1.base| |ray_cstpncpy_#t~mem1.base|) 0)
 (* (+ |honda_cstpncpy_#t~post5.base| |ray_cstpncpy_#t~post5.base|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(select old(#length) cstpncpy_~#dst.base)|
 |ray_(select old(#length) cstpncpy_~#dst.base)|) 0)
 (*
 (+ |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)|
 |ray_(ite (select #valid cstpncpy_~d~3.base) 1 0)|) 1)
 (* (+ honda_cstpncpy_~s~3.base ray_cstpncpy_~s~3.base) 0)
 (*
 (+
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 |ray_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|)
 0)
 (*
 (+ |honda_(select #length cstpncpy_~s~3.base)|
 |ray_(select #length cstpncpy_~s~3.base)|) 0)
 (* (+ honda_cstpncpy_~n ray_cstpncpy_~n) 0)
 (* (+ |honda_cstpncpy_#in~dst.base| |ray_cstpncpy_#in~dst.base|) 0)
 (*
 (+ |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)|
 |ray_(ite (select #valid cstpncpy_#in~dst.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length cstpncpy_~#dst.base)|
 |ray_(select #length cstpncpy_~#dst.base)|) 0)
 (* (+ |honda_cstpncpy_#t~post4.base| |ray_cstpncpy_#t~post4.base|) 0)
 (*
 (+ |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)|
 |ray_(ite (select #valid cstpncpy_~#dst.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) cstpncpy_#in~dst.base)|
 |ray_(select old(#length) cstpncpy_#in~dst.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)|
 |ray_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)|) 0)
 (* (+ |honda_cstpncpy_#t~post5.offset| |ray_cstpncpy_#t~post5.offset|) 0)
 (*
 (+ |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)|
 |ray_(ite (select #valid cstpncpy_#in~src.base) 1 0)|) 0)
 (* (+ |honda_cstpncpy_#in~dst.offset| |ray_cstpncpy_#in~dst.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)|
 |ray_(ite (select #valid cstpncpy_~s~3.base) 1 0)|) 0)
 (* (+ honda_cstpncpy_~src.base ray_cstpncpy_~src.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ honda_cstpncpy_~d~3.offset ray_cstpncpy_~d~3.offset) 0)
 (* (+ |honda_cstpncpy_#t~post3| |ray_cstpncpy_#t~post3|) 0)
 (* (+ |honda_cstpncpy_~#dst.base| |ray_cstpncpy_~#dst.base|) 0)
 (* (+ honda_cstpncpy_~src.offset ray_cstpncpy_~src.offset) 0)
 (* (+ |honda_cstpncpy_#in~src.base| |ray_cstpncpy_#in~src.base|) 0)
 (*
 (+
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 |ray_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)|
 |ray_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)|) 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0) 
 (* honda_cstpncpy_~d~3.base 0) 
 (* |honda_cstpncpy_#t~post5.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (- 1)) 0)
 (>=
 (+ (* (+ |honda_cstpncpy_#t~mem0.offset| |ray_cstpncpy_#t~mem0.offset|) 0)
 (*
 (+ |honda_(select #length cstpncpy_~d~3.base)|
 |ray_(select #length cstpncpy_~d~3.base)|) 
 (- 1))
 (* (+ |honda_cstpncpy_#t~post4.offset| |ray_cstpncpy_#t~post4.offset|) 0)
 (* (+ honda_cstpncpy_~s~3.offset ray_cstpncpy_~s~3.offset) 0)
 (*
 (+
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 |ray_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|)
 0)
 (*
 (+ |honda_(select old(#length) cstpncpy_#in~src.base)|
 |ray_(select old(#length) cstpncpy_#in~src.base)|) 0)
 (* (+ |honda_cstpncpy_~#dst.offset| |ray_cstpncpy_~#dst.offset|) 0)
 (*
 (+
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 |ray_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|)
 0) (* (+ |honda_cstpncpy_#t~mem7| |ray_cstpncpy_#t~mem7|) 0)
 (*
 (+
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 |ray_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|)
 0) (* (+ honda_cstpncpy_~d~3.base ray_cstpncpy_~d~3.base) 0)
 (*
 (+
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 |ray_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|)
 0)
 (*
 (+ |honda_(select #length cstpncpy_#in~src.base)|
 |ray_(select #length cstpncpy_#in~src.base)|) 0)
 (* (+ |honda_cstpncpy_#in~src.offset| |ray_cstpncpy_#in~src.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)|
 |ray_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)|) 0)
 (* (+ |honda_cstpncpy_#t~mem1.offset| |ray_cstpncpy_#t~mem1.offset|) 0)
 (*
 (+ |honda_(select #length cstpncpy_#in~dst.base)|
 |ray_(select #length cstpncpy_#in~dst.base)|) 0)
 (* (+ |honda_cstpncpy_#t~mem0.base| |ray_cstpncpy_#t~mem0.base|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 |ray_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|)
 0) (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_cstpncpy_#in~n| |ray_cstpncpy_#in~n|) 0)
 (* (+ |honda_cstpncpy_#t~mem1.base| |ray_cstpncpy_#t~mem1.base|) 0)
 (* (+ |honda_cstpncpy_#t~post5.base| |ray_cstpncpy_#t~post5.base|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(select old(#length) cstpncpy_~#dst.base)|
 |ray_(select old(#length) cstpncpy_~#dst.base)|) 0)
 (*
 (+ |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)|
 |ray_(ite (select #valid cstpncpy_~d~3.base) 1 0)|) 0)
 (* (+ honda_cstpncpy_~s~3.base ray_cstpncpy_~s~3.base) 0)
 (*
 (+
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 |ray_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|)
 0)
 (*
 (+ |honda_(select #length cstpncpy_~s~3.base)|
 |ray_(select #length cstpncpy_~s~3.base)|) 0)
 (* (+ honda_cstpncpy_~n ray_cstpncpy_~n) 0)
 (* (+ |honda_cstpncpy_#in~dst.base| |ray_cstpncpy_#in~dst.base|) 0)
 (*
 (+ |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)|
 |ray_(ite (select #valid cstpncpy_#in~dst.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length cstpncpy_~#dst.base)|
 |ray_(select #length cstpncpy_~#dst.base)|) 0)
 (* (+ |honda_cstpncpy_#t~post4.base| |ray_cstpncpy_#t~post4.base|) 0)
 (*
 (+ |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)|
 |ray_(ite (select #valid cstpncpy_~#dst.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) cstpncpy_#in~dst.base)|
 |ray_(select old(#length) cstpncpy_#in~dst.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)|
 |ray_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)|) 0)
 (* (+ |honda_cstpncpy_#t~post5.offset| |ray_cstpncpy_#t~post5.offset|) 0)
 (*
 (+ |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)|
 |ray_(ite (select #valid cstpncpy_#in~src.base) 1 0)|) 0)
 (* (+ |honda_cstpncpy_#in~dst.offset| |ray_cstpncpy_#in~dst.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)|
 |ray_(ite (select #valid cstpncpy_~s~3.base) 1 0)|) 0)
 (* (+ honda_cstpncpy_~src.base ray_cstpncpy_~src.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ honda_cstpncpy_~d~3.offset ray_cstpncpy_~d~3.offset) 0)
 (* (+ |honda_cstpncpy_#t~post3| |ray_cstpncpy_#t~post3|) 0)
 (* (+ |honda_cstpncpy_~#dst.base| |ray_cstpncpy_~#dst.base|) 0)
 (* (+ honda_cstpncpy_~src.offset ray_cstpncpy_~src.offset) 0)
 (* (+ |honda_cstpncpy_#in~src.base| |ray_cstpncpy_#in~src.base|) 0)
 (*
 (+
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 |ray_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)|
 |ray_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)|) 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 1)
 (* |honda_cstpncpy_#t~post4.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0) 
 (* honda_cstpncpy_~d~3.base 0) 
 (* |honda_cstpncpy_#t~post5.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 0) 0)
 (>=
 (+ (* (+ |honda_cstpncpy_#t~mem0.offset| |ray_cstpncpy_#t~mem0.offset|) 0)
 (*
 (+ |honda_(select #length cstpncpy_~d~3.base)|
 |ray_(select #length cstpncpy_~d~3.base)|) 0)
 (* (+ |honda_cstpncpy_#t~post4.offset| |ray_cstpncpy_#t~post4.offset|) 0)
 (* (+ honda_cstpncpy_~s~3.offset ray_cstpncpy_~s~3.offset) 0)
 (*
 (+
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 |ray_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|)
 0)
 (*
 (+ |honda_(select old(#length) cstpncpy_#in~src.base)|
 |ray_(select old(#length) cstpncpy_#in~src.base)|) 0)
 (* (+ |honda_cstpncpy_~#dst.offset| |ray_cstpncpy_~#dst.offset|) 0)
 (*
 (+
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 |ray_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|)
 0) (* (+ |honda_cstpncpy_#t~mem7| |ray_cstpncpy_#t~mem7|) 0)
 (*
 (+
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 |ray_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|)
 0) (* (+ honda_cstpncpy_~d~3.base ray_cstpncpy_~d~3.base) 1)
 (*
 (+
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 |ray_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|)
 0)
 (*
 (+ |honda_(select #length cstpncpy_#in~src.base)|
 |ray_(select #length cstpncpy_#in~src.base)|) 0)
 (* (+ |honda_cstpncpy_#in~src.offset| |ray_cstpncpy_#in~src.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)|
 |ray_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)|) 0)
 (* (+ |honda_cstpncpy_#t~mem1.offset| |ray_cstpncpy_#t~mem1.offset|) 0)
 (*
 (+ |honda_(select #length cstpncpy_#in~dst.base)|
 |ray_(select #length cstpncpy_#in~dst.base)|) 0)
 (* (+ |honda_cstpncpy_#t~mem0.base| |ray_cstpncpy_#t~mem0.base|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 |ray_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|)
 0) (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_cstpncpy_#in~n| |ray_cstpncpy_#in~n|) 0)
 (* (+ |honda_cstpncpy_#t~mem1.base| |ray_cstpncpy_#t~mem1.base|) 0)
 (* (+ |honda_cstpncpy_#t~post5.base| |ray_cstpncpy_#t~post5.base|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(select old(#length) cstpncpy_~#dst.base)|
 |ray_(select old(#length) cstpncpy_~#dst.base)|) 0)
 (*
 (+ |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)|
 |ray_(ite (select #valid cstpncpy_~d~3.base) 1 0)|) 0)
 (* (+ honda_cstpncpy_~s~3.base ray_cstpncpy_~s~3.base) 0)
 (*
 (+
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 |ray_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|)
 0)
 (*
 (+ |honda_(select #length cstpncpy_~s~3.base)|
 |ray_(select #length cstpncpy_~s~3.base)|) 0)
 (* (+ honda_cstpncpy_~n ray_cstpncpy_~n) 0)
 (* (+ |honda_cstpncpy_#in~dst.base| |ray_cstpncpy_#in~dst.base|) 0)
 (*
 (+ |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)|
 |ray_(ite (select #valid cstpncpy_#in~dst.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length cstpncpy_~#dst.base)|
 |ray_(select #length cstpncpy_~#dst.base)|) 0)
 (* (+ |honda_cstpncpy_#t~post4.base| |ray_cstpncpy_#t~post4.base|) 0)
 (*
 (+ |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)|
 |ray_(ite (select #valid cstpncpy_~#dst.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) cstpncpy_#in~dst.base)|
 |ray_(select old(#length) cstpncpy_#in~dst.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)|
 |ray_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)|) 0)
 (* (+ |honda_cstpncpy_#t~post5.offset| |ray_cstpncpy_#t~post5.offset|) 0)
 (*
 (+ |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)|
 |ray_(ite (select #valid cstpncpy_#in~src.base) 1 0)|) 0)
 (* (+ |honda_cstpncpy_#in~dst.offset| |ray_cstpncpy_#in~dst.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)|
 |ray_(ite (select #valid cstpncpy_~s~3.base) 1 0)|) 0)
 (* (+ honda_cstpncpy_~src.base ray_cstpncpy_~src.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ honda_cstpncpy_~d~3.offset ray_cstpncpy_~d~3.offset) 0)
 (* (+ |honda_cstpncpy_#t~post3| |ray_cstpncpy_#t~post3|) 0)
 (* (+ |honda_cstpncpy_~#dst.base| |ray_cstpncpy_~#dst.base|) 0)
 (* (+ honda_cstpncpy_~src.offset ray_cstpncpy_~src.offset) 0)
 (* (+ |honda_cstpncpy_#in~src.base| |ray_cstpncpy_#in~src.base|) 0)
 (*
 (+
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 |ray_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)|
 |ray_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)|) 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0) 
 (* honda_cstpncpy_~d~3.base (- 1)) 
 (* |honda_cstpncpy_#t~post5.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 0) 0)
 (>=
 (+ (* (+ |honda_cstpncpy_#t~mem0.offset| |ray_cstpncpy_#t~mem0.offset|) 0)
 (*
 (+ |honda_(select #length cstpncpy_~d~3.base)|
 |ray_(select #length cstpncpy_~d~3.base)|) 0)
 (* (+ |honda_cstpncpy_#t~post4.offset| |ray_cstpncpy_#t~post4.offset|) 0)
 (* (+ honda_cstpncpy_~s~3.offset ray_cstpncpy_~s~3.offset) 0)
 (*
 (+
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 |ray_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|)
 0)
 (*
 (+ |honda_(select old(#length) cstpncpy_#in~src.base)|
 |ray_(select old(#length) cstpncpy_#in~src.base)|) 0)
 (* (+ |honda_cstpncpy_~#dst.offset| |ray_cstpncpy_~#dst.offset|) 0)
 (*
 (+
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 |ray_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|)
 0) (* (+ |honda_cstpncpy_#t~mem7| |ray_cstpncpy_#t~mem7|) 0)
 (*
 (+
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 |ray_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|)
 0) (* (+ honda_cstpncpy_~d~3.base ray_cstpncpy_~d~3.base) 0)
 (*
 (+
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 |ray_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|)
 0)
 (*
 (+ |honda_(select #length cstpncpy_#in~src.base)|
 |ray_(select #length cstpncpy_#in~src.base)|) 0)
 (* (+ |honda_cstpncpy_#in~src.offset| |ray_cstpncpy_#in~src.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)|
 |ray_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)|) 0)
 (* (+ |honda_cstpncpy_#t~mem1.offset| |ray_cstpncpy_#t~mem1.offset|) 0)
 (*
 (+ |honda_(select #length cstpncpy_#in~dst.base)|
 |ray_(select #length cstpncpy_#in~dst.base)|) 0)
 (* (+ |honda_cstpncpy_#t~mem0.base| |ray_cstpncpy_#t~mem0.base|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 |ray_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|)
 0) (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_cstpncpy_#in~n| |ray_cstpncpy_#in~n|) 0)
 (* (+ |honda_cstpncpy_#t~mem1.base| |ray_cstpncpy_#t~mem1.base|) 0)
 (* (+ |honda_cstpncpy_#t~post5.base| |ray_cstpncpy_#t~post5.base|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(select old(#length) cstpncpy_~#dst.base)|
 |ray_(select old(#length) cstpncpy_~#dst.base)|) 0)
 (*
 (+ |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)|
 |ray_(ite (select #valid cstpncpy_~d~3.base) 1 0)|) 0)
 (* (+ honda_cstpncpy_~s~3.base ray_cstpncpy_~s~3.base) 0)
 (*
 (+
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 |ray_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|)
 0)
 (*
 (+ |honda_(select #length cstpncpy_~s~3.base)|
 |ray_(select #length cstpncpy_~s~3.base)|) 0)
 (* (+ honda_cstpncpy_~n ray_cstpncpy_~n) 0)
 (* (+ |honda_cstpncpy_#in~dst.base| |ray_cstpncpy_#in~dst.base|) 0)
 (*
 (+ |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)|
 |ray_(ite (select #valid cstpncpy_#in~dst.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length cstpncpy_~#dst.base)|
 |ray_(select #length cstpncpy_~#dst.base)|) 0)
 (* (+ |honda_cstpncpy_#t~post4.base| |ray_cstpncpy_#t~post4.base|) 0)
 (*
 (+ |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)|
 |ray_(ite (select #valid cstpncpy_~#dst.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) cstpncpy_#in~dst.base)|
 |ray_(select old(#length) cstpncpy_#in~dst.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)|
 |ray_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)|) 0)
 (* (+ |honda_cstpncpy_#t~post5.offset| |ray_cstpncpy_#t~post5.offset|) 0)
 (*
 (+ |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)|
 |ray_(ite (select #valid cstpncpy_#in~src.base) 1 0)|) 0)
 (* (+ |honda_cstpncpy_#in~dst.offset| |ray_cstpncpy_#in~dst.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)|
 |ray_(ite (select #valid cstpncpy_~s~3.base) 1 0)|) 0)
 (* (+ honda_cstpncpy_~src.base ray_cstpncpy_~src.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ honda_cstpncpy_~d~3.offset ray_cstpncpy_~d~3.offset) 0)
 (* (+ |honda_cstpncpy_#t~post3| |ray_cstpncpy_#t~post3|) 0)
 (* (+ |honda_cstpncpy_~#dst.base| |ray_cstpncpy_~#dst.base|) 0)
 (* (+ honda_cstpncpy_~src.offset ray_cstpncpy_~src.offset) 0)
 (* (+ |honda_cstpncpy_#in~src.base| |ray_cstpncpy_#in~src.base|) 0)
 (*
 (+
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 |ray_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)|
 |ray_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)|) 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0) 
 (* honda_cstpncpy_~s~3.offset (- 1))
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0) 
 (* honda_cstpncpy_~d~3.base 0) 
 (* |honda_cstpncpy_#t~post5.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(select #length cstpncpy_~s~3.base)| 1) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (- 1)) 0)
 (>=
 (+ (* (+ |honda_cstpncpy_#t~mem0.offset| |ray_cstpncpy_#t~mem0.offset|) 0)
 (*
 (+ |honda_(select #length cstpncpy_~d~3.base)|
 |ray_(select #length cstpncpy_~d~3.base)|) 0)
 (* (+ |honda_cstpncpy_#t~post4.offset| |ray_cstpncpy_#t~post4.offset|) 0)
 (* (+ honda_cstpncpy_~s~3.offset ray_cstpncpy_~s~3.offset) (- 1))
 (*
 (+
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 |ray_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|)
 0)
 (*
 (+ |honda_(select old(#length) cstpncpy_#in~src.base)|
 |ray_(select old(#length) cstpncpy_#in~src.base)|) 0)
 (* (+ |honda_cstpncpy_~#dst.offset| |ray_cstpncpy_~#dst.offset|) 0)
 (*
 (+
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 |ray_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|)
 0) (* (+ |honda_cstpncpy_#t~mem7| |ray_cstpncpy_#t~mem7|) 0)
 (*
 (+
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 |ray_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|)
 0) (* (+ honda_cstpncpy_~d~3.base ray_cstpncpy_~d~3.base) 0)
 (*
 (+
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 |ray_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|)
 0)
 (*
 (+ |honda_(select #length cstpncpy_#in~src.base)|
 |ray_(select #length cstpncpy_#in~src.base)|) 0)
 (* (+ |honda_cstpncpy_#in~src.offset| |ray_cstpncpy_#in~src.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)|
 |ray_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)|) 0)
 (* (+ |honda_cstpncpy_#t~mem1.offset| |ray_cstpncpy_#t~mem1.offset|) 0)
 (*
 (+ |honda_(select #length cstpncpy_#in~dst.base)|
 |ray_(select #length cstpncpy_#in~dst.base)|) 0)
 (* (+ |honda_cstpncpy_#t~mem0.base| |ray_cstpncpy_#t~mem0.base|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 |ray_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|)
 0) (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_cstpncpy_#in~n| |ray_cstpncpy_#in~n|) 0)
 (* (+ |honda_cstpncpy_#t~mem1.base| |ray_cstpncpy_#t~mem1.base|) 0)
 (* (+ |honda_cstpncpy_#t~post5.base| |ray_cstpncpy_#t~post5.base|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(select old(#length) cstpncpy_~#dst.base)|
 |ray_(select old(#length) cstpncpy_~#dst.base)|) 0)
 (*
 (+ |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)|
 |ray_(ite (select #valid cstpncpy_~d~3.base) 1 0)|) 0)
 (* (+ honda_cstpncpy_~s~3.base ray_cstpncpy_~s~3.base) 0)
 (*
 (+
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 |ray_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|)
 0)
 (*
 (+ |honda_(select #length cstpncpy_~s~3.base)|
 |ray_(select #length cstpncpy_~s~3.base)|) 0)
 (* (+ honda_cstpncpy_~n ray_cstpncpy_~n) 0)
 (* (+ |honda_cstpncpy_#in~dst.base| |ray_cstpncpy_#in~dst.base|) 0)
 (*
 (+ |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)|
 |ray_(ite (select #valid cstpncpy_#in~dst.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length cstpncpy_~#dst.base)|
 |ray_(select #length cstpncpy_~#dst.base)|) 0)
 (* (+ |honda_cstpncpy_#t~post4.base| |ray_cstpncpy_#t~post4.base|) 0)
 (*
 (+ |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)|
 |ray_(ite (select #valid cstpncpy_~#dst.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) cstpncpy_#in~dst.base)|
 |ray_(select old(#length) cstpncpy_#in~dst.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)|
 |ray_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)|) 0)
 (* (+ |honda_cstpncpy_#t~post5.offset| |ray_cstpncpy_#t~post5.offset|) 0)
 (*
 (+ |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)|
 |ray_(ite (select #valid cstpncpy_#in~src.base) 1 0)|) 0)
 (* (+ |honda_cstpncpy_#in~dst.offset| |ray_cstpncpy_#in~dst.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)|
 |ray_(ite (select #valid cstpncpy_~s~3.base) 1 0)|) 0)
 (* (+ honda_cstpncpy_~src.base ray_cstpncpy_~src.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ honda_cstpncpy_~d~3.offset ray_cstpncpy_~d~3.offset) 0)
 (* (+ |honda_cstpncpy_#t~post3| |ray_cstpncpy_#t~post3|) 0)
 (* (+ |honda_cstpncpy_~#dst.base| |ray_cstpncpy_~#dst.base|) 0)
 (* (+ honda_cstpncpy_~src.offset ray_cstpncpy_~src.offset) 0)
 (* (+ |honda_cstpncpy_#in~src.base| |ray_cstpncpy_#in~src.base|) 0)
 (*
 (+
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 |ray_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)|
 |ray_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)|) 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 1)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0) 
 (* honda_cstpncpy_~d~3.base 0) 
 (* |honda_cstpncpy_#t~post5.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 1) 0)
 (>=
 (+ (* (+ |honda_cstpncpy_#t~mem0.offset| |ray_cstpncpy_#t~mem0.offset|) 0)
 (*
 (+ |honda_(select #length cstpncpy_~d~3.base)|
 |ray_(select #length cstpncpy_~d~3.base)|) 0)
 (* (+ |honda_cstpncpy_#t~post4.offset| |ray_cstpncpy_#t~post4.offset|) 0)
 (* (+ honda_cstpncpy_~s~3.offset ray_cstpncpy_~s~3.offset) 0)
 (*
 (+
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 |ray_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|)
 0)
 (*
 (+ |honda_(select old(#length) cstpncpy_#in~src.base)|
 |ray_(select old(#length) cstpncpy_#in~src.base)|) 0)
 (* (+ |honda_cstpncpy_~#dst.offset| |ray_cstpncpy_~#dst.offset|) 0)
 (*
 (+
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 |ray_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|)
 0) (* (+ |honda_cstpncpy_#t~mem7| |ray_cstpncpy_#t~mem7|) 0)
 (*
 (+
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 |ray_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|)
 0) (* (+ honda_cstpncpy_~d~3.base ray_cstpncpy_~d~3.base) 0)
 (*
 (+
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 |ray_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|)
 0)
 (*
 (+ |honda_(select #length cstpncpy_#in~src.base)|
 |ray_(select #length cstpncpy_#in~src.base)|) 0)
 (* (+ |honda_cstpncpy_#in~src.offset| |ray_cstpncpy_#in~src.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)|
 |ray_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)|) 0)
 (* (+ |honda_cstpncpy_#t~mem1.offset| |ray_cstpncpy_#t~mem1.offset|) 0)
 (*
 (+ |honda_(select #length cstpncpy_#in~dst.base)|
 |ray_(select #length cstpncpy_#in~dst.base)|) 0)
 (* (+ |honda_cstpncpy_#t~mem0.base| |ray_cstpncpy_#t~mem0.base|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 |ray_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|)
 0) (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_cstpncpy_#in~n| |ray_cstpncpy_#in~n|) 0)
 (* (+ |honda_cstpncpy_#t~mem1.base| |ray_cstpncpy_#t~mem1.base|) 0)
 (* (+ |honda_cstpncpy_#t~post5.base| |ray_cstpncpy_#t~post5.base|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(select old(#length) cstpncpy_~#dst.base)|
 |ray_(select old(#length) cstpncpy_~#dst.base)|) 0)
 (*
 (+ |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)|
 |ray_(ite (select #valid cstpncpy_~d~3.base) 1 0)|) 0)
 (* (+ honda_cstpncpy_~s~3.base ray_cstpncpy_~s~3.base) 0)
 (*
 (+
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 |ray_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|)
 0)
 (*
 (+ |honda_(select #length cstpncpy_~s~3.base)|
 |ray_(select #length cstpncpy_~s~3.base)|) 0)
 (* (+ honda_cstpncpy_~n ray_cstpncpy_~n) (- 1))
 (* (+ |honda_cstpncpy_#in~dst.base| |ray_cstpncpy_#in~dst.base|) 0)
 (*
 (+ |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)|
 |ray_(ite (select #valid cstpncpy_#in~dst.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length cstpncpy_~#dst.base)|
 |ray_(select #length cstpncpy_~#dst.base)|) 0)
 (* (+ |honda_cstpncpy_#t~post4.base| |ray_cstpncpy_#t~post4.base|) 0)
 (*
 (+ |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)|
 |ray_(ite (select #valid cstpncpy_~#dst.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) cstpncpy_#in~dst.base)|
 |ray_(select old(#length) cstpncpy_#in~dst.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)|
 |ray_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)|) 0)
 (* (+ |honda_cstpncpy_#t~post5.offset| |ray_cstpncpy_#t~post5.offset|) 0)
 (*
 (+ |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)|
 |ray_(ite (select #valid cstpncpy_#in~src.base) 1 0)|) 0)
 (* (+ |honda_cstpncpy_#in~dst.offset| |ray_cstpncpy_#in~dst.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)|
 |ray_(ite (select #valid cstpncpy_~s~3.base) 1 0)|) 0)
 (* (+ honda_cstpncpy_~src.base ray_cstpncpy_~src.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ honda_cstpncpy_~d~3.offset ray_cstpncpy_~d~3.offset) 0)
 (* (+ |honda_cstpncpy_#t~post3| |ray_cstpncpy_#t~post3|) 0)
 (* (+ |honda_cstpncpy_~#dst.base| |ray_cstpncpy_~#dst.base|) 0)
 (* (+ honda_cstpncpy_~src.offset ray_cstpncpy_~src.offset) 0)
 (* (+ |honda_cstpncpy_#in~src.base| |ray_cstpncpy_#in~src.base|) 0)
 (*
 (+
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 |ray_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)|
 |ray_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)|) 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0) 
 (* honda_cstpncpy_~d~3.base 0) 
 (* |honda_cstpncpy_#t~post5.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 1) (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (- 1)) 0)
 (>=
 (+ (* (+ |honda_cstpncpy_#t~mem0.offset| |ray_cstpncpy_#t~mem0.offset|) 0)
 (*
 (+ |honda_(select #length cstpncpy_~d~3.base)|
 |ray_(select #length cstpncpy_~d~3.base)|) 0)
 (* (+ |honda_cstpncpy_#t~post4.offset| |ray_cstpncpy_#t~post4.offset|) 0)
 (* (+ honda_cstpncpy_~s~3.offset ray_cstpncpy_~s~3.offset) 0)
 (*
 (+
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 |ray_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|)
 0)
 (*
 (+ |honda_(select old(#length) cstpncpy_#in~src.base)|
 |ray_(select old(#length) cstpncpy_#in~src.base)|) 0)
 (* (+ |honda_cstpncpy_~#dst.offset| |ray_cstpncpy_~#dst.offset|) 0)
 (*
 (+
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 |ray_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|)
 0) (* (+ |honda_cstpncpy_#t~mem7| |ray_cstpncpy_#t~mem7|) 0)
 (*
 (+
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 |ray_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|)
 0) (* (+ honda_cstpncpy_~d~3.base ray_cstpncpy_~d~3.base) 0)
 (*
 (+
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 |ray_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|)
 0)
 (*
 (+ |honda_(select #length cstpncpy_#in~src.base)|
 |ray_(select #length cstpncpy_#in~src.base)|) 0)
 (* (+ |honda_cstpncpy_#in~src.offset| |ray_cstpncpy_#in~src.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)|
 |ray_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)|) 0)
 (* (+ |honda_cstpncpy_#t~mem1.offset| |ray_cstpncpy_#t~mem1.offset|) 0)
 (*
 (+ |honda_(select #length cstpncpy_#in~dst.base)|
 |ray_(select #length cstpncpy_#in~dst.base)|) 0)
 (* (+ |honda_cstpncpy_#t~mem0.base| |ray_cstpncpy_#t~mem0.base|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 |ray_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|)
 0) (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_cstpncpy_#in~n| |ray_cstpncpy_#in~n|) 0)
 (* (+ |honda_cstpncpy_#t~mem1.base| |ray_cstpncpy_#t~mem1.base|) 0)
 (* (+ |honda_cstpncpy_#t~post5.base| |ray_cstpncpy_#t~post5.base|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(select old(#length) cstpncpy_~#dst.base)|
 |ray_(select old(#length) cstpncpy_~#dst.base)|) 0)
 (*
 (+ |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)|
 |ray_(ite (select #valid cstpncpy_~d~3.base) 1 0)|) 0)
 (* (+ honda_cstpncpy_~s~3.base ray_cstpncpy_~s~3.base) 0)
 (*
 (+
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 |ray_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|)
 0)
 (*
 (+ |honda_(select #length cstpncpy_~s~3.base)|
 |ray_(select #length cstpncpy_~s~3.base)|) 0)
 (* (+ honda_cstpncpy_~n ray_cstpncpy_~n) 0)
 (* (+ |honda_cstpncpy_#in~dst.base| |ray_cstpncpy_#in~dst.base|) 0)
 (*
 (+ |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)|
 |ray_(ite (select #valid cstpncpy_#in~dst.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length cstpncpy_~#dst.base)|
 |ray_(select #length cstpncpy_~#dst.base)|) 0)
 (* (+ |honda_cstpncpy_#t~post4.base| |ray_cstpncpy_#t~post4.base|) 0)
 (*
 (+ |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)|
 |ray_(ite (select #valid cstpncpy_~#dst.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) cstpncpy_#in~dst.base)|
 |ray_(select old(#length) cstpncpy_#in~dst.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)|
 |ray_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)|) 0)
 (* (+ |honda_cstpncpy_#t~post5.offset| |ray_cstpncpy_#t~post5.offset|) 0)
 (*
 (+ |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)|
 |ray_(ite (select #valid cstpncpy_#in~src.base) 1 0)|) 0)
 (* (+ |honda_cstpncpy_#in~dst.offset| |ray_cstpncpy_#in~dst.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)|
 |ray_(ite (select #valid cstpncpy_~s~3.base) 1 0)|) 0)
 (* (+ honda_cstpncpy_~src.base ray_cstpncpy_~src.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ honda_cstpncpy_~d~3.offset ray_cstpncpy_~d~3.offset) 1)
 (* (+ |honda_cstpncpy_#t~post3| |ray_cstpncpy_#t~post3|) 0)
 (* (+ |honda_cstpncpy_~#dst.base| |ray_cstpncpy_~#dst.base|) 0)
 (* (+ honda_cstpncpy_~src.offset ray_cstpncpy_~src.offset) 0)
 (* (+ |honda_cstpncpy_#in~src.base| |ray_cstpncpy_#in~src.base|) 0)
 (*
 (+
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 |ray_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)|
 |ray_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)|) 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0) 
 (* honda_cstpncpy_~d~3.base 0) 
 (* |honda_cstpncpy_#t~post5.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset (- 1)) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (- 1)) 0)
 (>=
 (+ (* (+ |honda_cstpncpy_#t~mem0.offset| |ray_cstpncpy_#t~mem0.offset|) 0)
 (*
 (+ |honda_(select #length cstpncpy_~d~3.base)|
 |ray_(select #length cstpncpy_~d~3.base)|) 0)
 (* (+ |honda_cstpncpy_#t~post4.offset| |ray_cstpncpy_#t~post4.offset|) 0)
 (* (+ honda_cstpncpy_~s~3.offset ray_cstpncpy_~s~3.offset) 0)
 (*
 (+
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 |ray_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|)
 0)
 (*
 (+ |honda_(select old(#length) cstpncpy_#in~src.base)|
 |ray_(select old(#length) cstpncpy_#in~src.base)|) 0)
 (* (+ |honda_cstpncpy_~#dst.offset| |ray_cstpncpy_~#dst.offset|) 0)
 (*
 (+
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 |ray_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|)
 0) (* (+ |honda_cstpncpy_#t~mem7| |ray_cstpncpy_#t~mem7|) 0)
 (*
 (+
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 |ray_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|)
 0) (* (+ honda_cstpncpy_~d~3.base ray_cstpncpy_~d~3.base) 0)
 (*
 (+
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 |ray_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|)
 0)
 (*
 (+ |honda_(select #length cstpncpy_#in~src.base)|
 |ray_(select #length cstpncpy_#in~src.base)|) 0)
 (* (+ |honda_cstpncpy_#in~src.offset| |ray_cstpncpy_#in~src.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)|
 |ray_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)|) 0)
 (* (+ |honda_cstpncpy_#t~mem1.offset| |ray_cstpncpy_#t~mem1.offset|) 0)
 (*
 (+ |honda_(select #length cstpncpy_#in~dst.base)|
 |ray_(select #length cstpncpy_#in~dst.base)|) 0)
 (* (+ |honda_cstpncpy_#t~mem0.base| |ray_cstpncpy_#t~mem0.base|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 |ray_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|)
 0) (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_cstpncpy_#in~n| |ray_cstpncpy_#in~n|) 0)
 (* (+ |honda_cstpncpy_#t~mem1.base| |ray_cstpncpy_#t~mem1.base|) 0)
 (* (+ |honda_cstpncpy_#t~post5.base| |ray_cstpncpy_#t~post5.base|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(select old(#length) cstpncpy_~#dst.base)|
 |ray_(select old(#length) cstpncpy_~#dst.base)|) 0)
 (*
 (+ |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)|
 |ray_(ite (select #valid cstpncpy_~d~3.base) 1 0)|) 0)
 (* (+ honda_cstpncpy_~s~3.base ray_cstpncpy_~s~3.base) 0)
 (*
 (+
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 |ray_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|)
 0)
 (*
 (+ |honda_(select #length cstpncpy_~s~3.base)|
 |ray_(select #length cstpncpy_~s~3.base)|) 0)
 (* (+ honda_cstpncpy_~n ray_cstpncpy_~n) 0)
 (* (+ |honda_cstpncpy_#in~dst.base| |ray_cstpncpy_#in~dst.base|) 0)
 (*
 (+ |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)|
 |ray_(ite (select #valid cstpncpy_#in~dst.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length cstpncpy_~#dst.base)|
 |ray_(select #length cstpncpy_~#dst.base)|) 0)
 (* (+ |honda_cstpncpy_#t~post4.base| |ray_cstpncpy_#t~post4.base|) 0)
 (*
 (+ |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)|
 |ray_(ite (select #valid cstpncpy_~#dst.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) cstpncpy_#in~dst.base)|
 |ray_(select old(#length) cstpncpy_#in~dst.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)|
 |ray_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)|) 0)
 (* (+ |honda_cstpncpy_#t~post5.offset| |ray_cstpncpy_#t~post5.offset|) 0)
 (*
 (+ |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)|
 |ray_(ite (select #valid cstpncpy_#in~src.base) 1 0)|) 0)
 (* (+ |honda_cstpncpy_#in~dst.offset| |ray_cstpncpy_#in~dst.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)|
 |ray_(ite (select #valid cstpncpy_~s~3.base) 1 0)|) 1)
 (* (+ honda_cstpncpy_~src.base ray_cstpncpy_~src.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ honda_cstpncpy_~d~3.offset ray_cstpncpy_~d~3.offset) 0)
 (* (+ |honda_cstpncpy_#t~post3| |ray_cstpncpy_#t~post3|) 0)
 (* (+ |honda_cstpncpy_~#dst.base| |ray_cstpncpy_~#dst.base|) 0)
 (* (+ honda_cstpncpy_~src.offset ray_cstpncpy_~src.offset) 0)
 (* (+ |honda_cstpncpy_#in~src.base| |ray_cstpncpy_#in~src.base|) 0)
 (*
 (+
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 |ray_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)|
 |ray_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)|) 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0) 
 (* honda_cstpncpy_~d~3.base 0) 
 (* |honda_cstpncpy_#t~post5.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (- 1)) 0)
 (>=
 (+ (* (+ |honda_cstpncpy_#t~mem0.offset| |ray_cstpncpy_#t~mem0.offset|) 0)
 (*
 (+ |honda_(select #length cstpncpy_~d~3.base)|
 |ray_(select #length cstpncpy_~d~3.base)|) 0)
 (* (+ |honda_cstpncpy_#t~post4.offset| |ray_cstpncpy_#t~post4.offset|) 0)
 (* (+ honda_cstpncpy_~s~3.offset ray_cstpncpy_~s~3.offset) 0)
 (*
 (+
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 |ray_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|)
 0)
 (*
 (+ |honda_(select old(#length) cstpncpy_#in~src.base)|
 |ray_(select old(#length) cstpncpy_#in~src.base)|) 0)
 (* (+ |honda_cstpncpy_~#dst.offset| |ray_cstpncpy_~#dst.offset|) 0)
 (*
 (+
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 |ray_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|)
 0) (* (+ |honda_cstpncpy_#t~mem7| |ray_cstpncpy_#t~mem7|) 0)
 (*
 (+
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 |ray_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|)
 0) (* (+ honda_cstpncpy_~d~3.base ray_cstpncpy_~d~3.base) 0)
 (*
 (+
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 |ray_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|)
 0)
 (*
 (+ |honda_(select #length cstpncpy_#in~src.base)|
 |ray_(select #length cstpncpy_#in~src.base)|) 0)
 (* (+ |honda_cstpncpy_#in~src.offset| |ray_cstpncpy_#in~src.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)|
 |ray_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)|) 0)
 (* (+ |honda_cstpncpy_#t~mem1.offset| |ray_cstpncpy_#t~mem1.offset|) 0)
 (*
 (+ |honda_(select #length cstpncpy_#in~dst.base)|
 |ray_(select #length cstpncpy_#in~dst.base)|) 0)
 (* (+ |honda_cstpncpy_#t~mem0.base| |ray_cstpncpy_#t~mem0.base|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 |ray_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|)
 0) (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_cstpncpy_#in~n| |ray_cstpncpy_#in~n|) 0)
 (* (+ |honda_cstpncpy_#t~mem1.base| |ray_cstpncpy_#t~mem1.base|) 0)
 (* (+ |honda_cstpncpy_#t~post5.base| |ray_cstpncpy_#t~post5.base|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(select old(#length) cstpncpy_~#dst.base)|
 |ray_(select old(#length) cstpncpy_~#dst.base)|) 0)
 (*
 (+ |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)|
 |ray_(ite (select #valid cstpncpy_~d~3.base) 1 0)|) 0)
 (* (+ honda_cstpncpy_~s~3.base ray_cstpncpy_~s~3.base) 0)
 (*
 (+
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 |ray_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|)
 0)
 (*
 (+ |honda_(select #length cstpncpy_~s~3.base)|
 |ray_(select #length cstpncpy_~s~3.base)|) 0)
 (* (+ honda_cstpncpy_~n ray_cstpncpy_~n) 0)
 (* (+ |honda_cstpncpy_#in~dst.base| |ray_cstpncpy_#in~dst.base|) 0)
 (*
 (+ |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)|
 |ray_(ite (select #valid cstpncpy_#in~dst.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length cstpncpy_~#dst.base)|
 |ray_(select #length cstpncpy_~#dst.base)|) 0)
 (* (+ |honda_cstpncpy_#t~post4.base| |ray_cstpncpy_#t~post4.base|) 0)
 (*
 (+ |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)|
 |ray_(ite (select #valid cstpncpy_~#dst.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) cstpncpy_#in~dst.base)|
 |ray_(select old(#length) cstpncpy_#in~dst.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)|
 |ray_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)|) 0)
 (* (+ |honda_cstpncpy_#t~post5.offset| |ray_cstpncpy_#t~post5.offset|) 0)
 (*
 (+ |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)|
 |ray_(ite (select #valid cstpncpy_#in~src.base) 1 0)|) 0)
 (* (+ |honda_cstpncpy_#in~dst.offset| |ray_cstpncpy_#in~dst.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)|
 |ray_(ite (select #valid cstpncpy_~s~3.base) 1 0)|) 0)
 (* (+ honda_cstpncpy_~src.base ray_cstpncpy_~src.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ honda_cstpncpy_~d~3.offset ray_cstpncpy_~d~3.offset) 0)
 (* (+ |honda_cstpncpy_#t~post3| |ray_cstpncpy_#t~post3|) 0)
 (* (+ |honda_cstpncpy_~#dst.base| |ray_cstpncpy_~#dst.base|) 0)
 (* (+ honda_cstpncpy_~src.offset ray_cstpncpy_~src.offset) 0)
 (* (+ |honda_cstpncpy_#in~src.base| |ray_cstpncpy_#in~src.base|) 0)
 (*
 (+
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 |ray_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)|
 |ray_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)|) 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0) 
 (* honda_cstpncpy_~d~3.base 0) 
 (* |honda_cstpncpy_#t~post5.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(select #length cstpncpy_~s~3.base)| 0)
 (* honda_cstpncpy_~n (- 1)) 
 (* |honda_cstpncpy_#t~post4.base| 0) 
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* aux_3674 1) (* aux_3675 4294967296) 1) 0)
 (>=
 (+ (* (+ |honda_cstpncpy_#t~mem0.offset| |ray_cstpncpy_#t~mem0.offset|) 0)
 (*
 (+ |honda_(select #length cstpncpy_~d~3.base)|
 |ray_(select #length cstpncpy_~d~3.base)|) 0)
 (* (+ |honda_cstpncpy_#t~post4.offset| |ray_cstpncpy_#t~post4.offset|) 0)
 (* (+ honda_cstpncpy_~s~3.offset ray_cstpncpy_~s~3.offset) 0)
 (*
 (+
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 |ray_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|)
 0)
 (*
 (+ |honda_(select old(#length) cstpncpy_#in~src.base)|
 |ray_(select old(#length) cstpncpy_#in~src.base)|) 0)
 (* (+ |honda_cstpncpy_~#dst.offset| |ray_cstpncpy_~#dst.offset|) 0)
 (*
 (+
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 |ray_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|)
 0) (* (+ |honda_cstpncpy_#t~mem7| |ray_cstpncpy_#t~mem7|) 0)
 (*
 (+
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 |ray_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|)
 0) (* (+ honda_cstpncpy_~d~3.base ray_cstpncpy_~d~3.base) 0)
 (*
 (+
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 |ray_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|)
 0)
 (*
 (+ |honda_(select #length cstpncpy_#in~src.base)|
 |ray_(select #length cstpncpy_#in~src.base)|) 0)
 (* (+ |honda_cstpncpy_#in~src.offset| |ray_cstpncpy_#in~src.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)|
 |ray_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)|) 0)
 (* (+ |honda_cstpncpy_#t~mem1.offset| |ray_cstpncpy_#t~mem1.offset|) 0)
 (*
 (+ |honda_(select #length cstpncpy_#in~dst.base)|
 |ray_(select #length cstpncpy_#in~dst.base)|) 0)
 (* (+ |honda_cstpncpy_#t~mem0.base| |ray_cstpncpy_#t~mem0.base|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 |ray_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|)
 0) (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_cstpncpy_#in~n| |ray_cstpncpy_#in~n|) 0)
 (* (+ |honda_cstpncpy_#t~mem1.base| |ray_cstpncpy_#t~mem1.base|) 0)
 (* (+ |honda_cstpncpy_#t~post5.base| |ray_cstpncpy_#t~post5.base|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(select old(#length) cstpncpy_~#dst.base)|
 |ray_(select old(#length) cstpncpy_~#dst.base)|) 0)
 (*
 (+ |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)|
 |ray_(ite (select #valid cstpncpy_~d~3.base) 1 0)|) 0)
 (* (+ honda_cstpncpy_~s~3.base ray_cstpncpy_~s~3.base) 0)
 (*
 (+
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 |ray_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|)
 0)
 (*
 (+ |honda_(select #length cstpncpy_~s~3.base)|
 |ray_(select #length cstpncpy_~s~3.base)|) 0)
 (* (+ honda_cstpncpy_~n ray_cstpncpy_~n) 0)
 (* (+ |honda_cstpncpy_#in~dst.base| |ray_cstpncpy_#in~dst.base|) 0)
 (*
 (+ |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)|
 |ray_(ite (select #valid cstpncpy_#in~dst.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length cstpncpy_~#dst.base)|
 |ray_(select #length cstpncpy_~#dst.base)|) 0)
 (* (+ |honda_cstpncpy_#t~post4.base| |ray_cstpncpy_#t~post4.base|) 0)
 (*
 (+ |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)|
 |ray_(ite (select #valid cstpncpy_~#dst.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) cstpncpy_#in~dst.base)|
 |ray_(select old(#length) cstpncpy_#in~dst.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)|
 |ray_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)|) 0)
 (* (+ |honda_cstpncpy_#t~post5.offset| |ray_cstpncpy_#t~post5.offset|) 0)
 (*
 (+ |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)|
 |ray_(ite (select #valid cstpncpy_#in~src.base) 1 0)|) 0)
 (* (+ |honda_cstpncpy_#in~dst.offset| |ray_cstpncpy_#in~dst.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)|
 |ray_(ite (select #valid cstpncpy_~s~3.base) 1 0)|) 0)
 (* (+ honda_cstpncpy_~src.base ray_cstpncpy_~src.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ honda_cstpncpy_~d~3.offset ray_cstpncpy_~d~3.offset) 0)
 (* (+ |honda_cstpncpy_#t~post3| |ray_cstpncpy_#t~post3|) 0)
 (* (+ |honda_cstpncpy_~#dst.base| |ray_cstpncpy_~#dst.base|) 0)
 (* (+ honda_cstpncpy_~src.offset ray_cstpncpy_~src.offset) 0)
 (* (+ |honda_cstpncpy_#in~src.base| |ray_cstpncpy_#in~src.base|) 0)
 (*
 (+
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 |ray_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)|
 |ray_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)|) 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0) 
 (* honda_cstpncpy_~d~3.base 0) 
 (* |honda_cstpncpy_#t~post5.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* aux_3674 (- 1)) 4294967295) 0)
 (>=
 (+ (* (+ |honda_cstpncpy_#t~mem0.offset| |ray_cstpncpy_#t~mem0.offset|) 0)
 (*
 (+ |honda_(select #length cstpncpy_~d~3.base)|
 |ray_(select #length cstpncpy_~d~3.base)|) 0)
 (* (+ |honda_cstpncpy_#t~post4.offset| |ray_cstpncpy_#t~post4.offset|) 0)
 (* (+ honda_cstpncpy_~s~3.offset ray_cstpncpy_~s~3.offset) 0)
 (*
 (+
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 |ray_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|)
 0)
 (*
 (+ |honda_(select old(#length) cstpncpy_#in~src.base)|
 |ray_(select old(#length) cstpncpy_#in~src.base)|) 0)
 (* (+ |honda_cstpncpy_~#dst.offset| |ray_cstpncpy_~#dst.offset|) 0)
 (*
 (+
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 |ray_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|)
 0) (* (+ |honda_cstpncpy_#t~mem7| |ray_cstpncpy_#t~mem7|) 0)
 (*
 (+
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 |ray_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|)
 0) (* (+ honda_cstpncpy_~d~3.base ray_cstpncpy_~d~3.base) 0)
 (*
 (+
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 |ray_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|)
 0)
 (*
 (+ |honda_(select #length cstpncpy_#in~src.base)|
 |ray_(select #length cstpncpy_#in~src.base)|) 0)
 (* (+ |honda_cstpncpy_#in~src.offset| |ray_cstpncpy_#in~src.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)|
 |ray_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)|) 0)
 (* (+ |honda_cstpncpy_#t~mem1.offset| |ray_cstpncpy_#t~mem1.offset|) 0)
 (*
 (+ |honda_(select #length cstpncpy_#in~dst.base)|
 |ray_(select #length cstpncpy_#in~dst.base)|) 0)
 (* (+ |honda_cstpncpy_#t~mem0.base| |ray_cstpncpy_#t~mem0.base|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 |ray_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|)
 0) (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_cstpncpy_#in~n| |ray_cstpncpy_#in~n|) 0)
 (* (+ |honda_cstpncpy_#t~mem1.base| |ray_cstpncpy_#t~mem1.base|) 0)
 (* (+ |honda_cstpncpy_#t~post5.base| |ray_cstpncpy_#t~post5.base|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(select old(#length) cstpncpy_~#dst.base)|
 |ray_(select old(#length) cstpncpy_~#dst.base)|) 0)
 (*
 (+ |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)|
 |ray_(ite (select #valid cstpncpy_~d~3.base) 1 0)|) 0)
 (* (+ honda_cstpncpy_~s~3.base ray_cstpncpy_~s~3.base) 0)
 (*
 (+
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 |ray_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|)
 0)
 (*
 (+ |honda_(select #length cstpncpy_~s~3.base)|
 |ray_(select #length cstpncpy_~s~3.base)|) 0)
 (* (+ honda_cstpncpy_~n ray_cstpncpy_~n) 0)
 (* (+ |honda_cstpncpy_#in~dst.base| |ray_cstpncpy_#in~dst.base|) 0)
 (*
 (+ |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)|
 |ray_(ite (select #valid cstpncpy_#in~dst.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length cstpncpy_~#dst.base)|
 |ray_(select #length cstpncpy_~#dst.base)|) 0)
 (* (+ |honda_cstpncpy_#t~post4.base| |ray_cstpncpy_#t~post4.base|) 0)
 (*
 (+ |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)|
 |ray_(ite (select #valid cstpncpy_~#dst.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) cstpncpy_#in~dst.base)|
 |ray_(select old(#length) cstpncpy_#in~dst.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)|
 |ray_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)|) 0)
 (* (+ |honda_cstpncpy_#t~post5.offset| |ray_cstpncpy_#t~post5.offset|) 0)
 (*
 (+ |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)|
 |ray_(ite (select #valid cstpncpy_#in~src.base) 1 0)|) 0)
 (* (+ |honda_cstpncpy_#in~dst.offset| |ray_cstpncpy_#in~dst.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)|
 |ray_(ite (select #valid cstpncpy_~s~3.base) 1 0)|) 0)
 (* (+ honda_cstpncpy_~src.base ray_cstpncpy_~src.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ honda_cstpncpy_~d~3.offset ray_cstpncpy_~d~3.offset) 0)
 (* (+ |honda_cstpncpy_#t~post3| |ray_cstpncpy_#t~post3|) 0)
 (* (+ |honda_cstpncpy_~#dst.base| |ray_cstpncpy_~#dst.base|) 0)
 (* (+ honda_cstpncpy_~src.offset ray_cstpncpy_~src.offset) 0)
 (* (+ |honda_cstpncpy_#in~src.base| |ray_cstpncpy_#in~src.base|) 0)
 (*
 (+
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 |ray_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)|
 |ray_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)|) 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0) 
 (* honda_cstpncpy_~d~3.base 0) 
 (* |honda_cstpncpy_#t~post5.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 1) (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* aux_3674 (- 1)) (* aux_3675 (- 4294967296)) 
 (- 1)) 0)
 (>=
 (+ (* (+ |honda_cstpncpy_#t~mem0.offset| |ray_cstpncpy_#t~mem0.offset|) 0)
 (*
 (+ |honda_(select #length cstpncpy_~d~3.base)|
 |ray_(select #length cstpncpy_~d~3.base)|) 0)
 (* (+ |honda_cstpncpy_#t~post4.offset| |ray_cstpncpy_#t~post4.offset|) 0)
 (* (+ honda_cstpncpy_~s~3.offset ray_cstpncpy_~s~3.offset) 0)
 (*
 (+
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 |ray_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|)
 0)
 (*
 (+ |honda_(select old(#length) cstpncpy_#in~src.base)|
 |ray_(select old(#length) cstpncpy_#in~src.base)|) 0)
 (* (+ |honda_cstpncpy_~#dst.offset| |ray_cstpncpy_~#dst.offset|) 0)
 (*
 (+
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 |ray_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|)
 0) (* (+ |honda_cstpncpy_#t~mem7| |ray_cstpncpy_#t~mem7|) 0)
 (*
 (+
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 |ray_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|)
 0) (* (+ honda_cstpncpy_~d~3.base ray_cstpncpy_~d~3.base) 0)
 (*
 (+
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 |ray_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|)
 0)
 (*
 (+ |honda_(select #length cstpncpy_#in~src.base)|
 |ray_(select #length cstpncpy_#in~src.base)|) 0)
 (* (+ |honda_cstpncpy_#in~src.offset| |ray_cstpncpy_#in~src.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)|
 |ray_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)|) 0)
 (* (+ |honda_cstpncpy_#t~mem1.offset| |ray_cstpncpy_#t~mem1.offset|) 0)
 (*
 (+ |honda_(select #length cstpncpy_#in~dst.base)|
 |ray_(select #length cstpncpy_#in~dst.base)|) 0)
 (* (+ |honda_cstpncpy_#t~mem0.base| |ray_cstpncpy_#t~mem0.base|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 |ray_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|)
 0) (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_cstpncpy_#in~n| |ray_cstpncpy_#in~n|) 0)
 (* (+ |honda_cstpncpy_#t~mem1.base| |ray_cstpncpy_#t~mem1.base|) 0)
 (* (+ |honda_cstpncpy_#t~post5.base| |ray_cstpncpy_#t~post5.base|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(select old(#length) cstpncpy_~#dst.base)|
 |ray_(select old(#length) cstpncpy_~#dst.base)|) 0)
 (*
 (+ |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)|
 |ray_(ite (select #valid cstpncpy_~d~3.base) 1 0)|) 0)
 (* (+ honda_cstpncpy_~s~3.base ray_cstpncpy_~s~3.base) 0)
 (*
 (+
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 |ray_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|)
 0)
 (*
 (+ |honda_(select #length cstpncpy_~s~3.base)|
 |ray_(select #length cstpncpy_~s~3.base)|) 0)
 (* (+ honda_cstpncpy_~n ray_cstpncpy_~n) 0)
 (* (+ |honda_cstpncpy_#in~dst.base| |ray_cstpncpy_#in~dst.base|) 0)
 (*
 (+ |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)|
 |ray_(ite (select #valid cstpncpy_#in~dst.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length cstpncpy_~#dst.base)|
 |ray_(select #length cstpncpy_~#dst.base)|) 0)
 (* (+ |honda_cstpncpy_#t~post4.base| |ray_cstpncpy_#t~post4.base|) 0)
 (*
 (+ |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)|
 |ray_(ite (select #valid cstpncpy_~#dst.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) cstpncpy_#in~dst.base)|
 |ray_(select old(#length) cstpncpy_#in~dst.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)|
 |ray_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)|) 0)
 (* (+ |honda_cstpncpy_#t~post5.offset| |ray_cstpncpy_#t~post5.offset|) 0)
 (*
 (+ |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)|
 |ray_(ite (select #valid cstpncpy_#in~src.base) 1 0)|) 0)
 (* (+ |honda_cstpncpy_#in~dst.offset| |ray_cstpncpy_#in~dst.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)|
 |ray_(ite (select #valid cstpncpy_~s~3.base) 1 0)|) 0)
 (* (+ honda_cstpncpy_~src.base ray_cstpncpy_~src.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ honda_cstpncpy_~d~3.offset ray_cstpncpy_~d~3.offset) 0)
 (* (+ |honda_cstpncpy_#t~post3| |ray_cstpncpy_#t~post3|) 0)
 (* (+ |honda_cstpncpy_~#dst.base| |ray_cstpncpy_~#dst.base|) 0)
 (* (+ honda_cstpncpy_~src.offset ray_cstpncpy_~src.offset) 0)
 (* (+ |honda_cstpncpy_#in~src.base| |ray_cstpncpy_#in~src.base|) 0)
 (*
 (+
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 |ray_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)|
 |ray_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)|) 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0) 
 (* honda_cstpncpy_~d~3.base 0) 
 (* |honda_cstpncpy_#t~post5.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* aux_3679 (- 1)) (* aux_3680 (- 4294967296)) 0) 0)
 (>=
 (+ (* (+ |honda_cstpncpy_#t~mem0.offset| |ray_cstpncpy_#t~mem0.offset|) 0)
 (*
 (+ |honda_(select #length cstpncpy_~d~3.base)|
 |ray_(select #length cstpncpy_~d~3.base)|) 0)
 (* (+ |honda_cstpncpy_#t~post4.offset| |ray_cstpncpy_#t~post4.offset|) 0)
 (* (+ honda_cstpncpy_~s~3.offset ray_cstpncpy_~s~3.offset) 0)
 (*
 (+
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 |ray_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|)
 0)
 (*
 (+ |honda_(select old(#length) cstpncpy_#in~src.base)|
 |ray_(select old(#length) cstpncpy_#in~src.base)|) 0)
 (* (+ |honda_cstpncpy_~#dst.offset| |ray_cstpncpy_~#dst.offset|) 0)
 (*
 (+
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 |ray_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|)
 0) (* (+ |honda_cstpncpy_#t~mem7| |ray_cstpncpy_#t~mem7|) 0)
 (*
 (+
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 |ray_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|)
 0) (* (+ honda_cstpncpy_~d~3.base ray_cstpncpy_~d~3.base) 0)
 (*
 (+
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 |ray_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|)
 0)
 (*
 (+ |honda_(select #length cstpncpy_#in~src.base)|
 |ray_(select #length cstpncpy_#in~src.base)|) 0)
 (* (+ |honda_cstpncpy_#in~src.offset| |ray_cstpncpy_#in~src.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)|
 |ray_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)|) 0)
 (* (+ |honda_cstpncpy_#t~mem1.offset| |ray_cstpncpy_#t~mem1.offset|) 0)
 (*
 (+ |honda_(select #length cstpncpy_#in~dst.base)|
 |ray_(select #length cstpncpy_#in~dst.base)|) 0)
 (* (+ |honda_cstpncpy_#t~mem0.base| |ray_cstpncpy_#t~mem0.base|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 |ray_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|)
 0) (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_cstpncpy_#in~n| |ray_cstpncpy_#in~n|) 0)
 (* (+ |honda_cstpncpy_#t~mem1.base| |ray_cstpncpy_#t~mem1.base|) 0)
 (* (+ |honda_cstpncpy_#t~post5.base| |ray_cstpncpy_#t~post5.base|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(select old(#length) cstpncpy_~#dst.base)|
 |ray_(select old(#length) cstpncpy_~#dst.base)|) 0)
 (*
 (+ |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)|
 |ray_(ite (select #valid cstpncpy_~d~3.base) 1 0)|) 0)
 (* (+ honda_cstpncpy_~s~3.base ray_cstpncpy_~s~3.base) 0)
 (*
 (+
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 |ray_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|)
 0)
 (*
 (+ |honda_(select #length cstpncpy_~s~3.base)|
 |ray_(select #length cstpncpy_~s~3.base)|) 0)
 (* (+ honda_cstpncpy_~n ray_cstpncpy_~n) 0)
 (* (+ |honda_cstpncpy_#in~dst.base| |ray_cstpncpy_#in~dst.base|) 0)
 (*
 (+ |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)|
 |ray_(ite (select #valid cstpncpy_#in~dst.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length cstpncpy_~#dst.base)|
 |ray_(select #length cstpncpy_~#dst.base)|) 0)
 (* (+ |honda_cstpncpy_#t~post4.base| |ray_cstpncpy_#t~post4.base|) 0)
 (*
 (+ |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)|
 |ray_(ite (select #valid cstpncpy_~#dst.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) cstpncpy_#in~dst.base)|
 |ray_(select old(#length) cstpncpy_#in~dst.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)|
 |ray_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)|) 0)
 (* (+ |honda_cstpncpy_#t~post5.offset| |ray_cstpncpy_#t~post5.offset|) 0)
 (*
 (+ |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)|
 |ray_(ite (select #valid cstpncpy_#in~src.base) 1 0)|) 0)
 (* (+ |honda_cstpncpy_#in~dst.offset| |ray_cstpncpy_#in~dst.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)|
 |ray_(ite (select #valid cstpncpy_~s~3.base) 1 0)|) 0)
 (* (+ honda_cstpncpy_~src.base ray_cstpncpy_~src.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ honda_cstpncpy_~d~3.offset ray_cstpncpy_~d~3.offset) 0)
 (* (+ |honda_cstpncpy_#t~post3| |ray_cstpncpy_#t~post3|) 0)
 (* (+ |honda_cstpncpy_~#dst.base| |ray_cstpncpy_~#dst.base|) 0)
 (* (+ honda_cstpncpy_~src.offset ray_cstpncpy_~src.offset) 0)
 (* (+ |honda_cstpncpy_#in~src.base| |ray_cstpncpy_#in~src.base|) 0)
 (*
 (+
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 |ray_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)|
 |ray_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)|) 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0) 
 (* honda_cstpncpy_~d~3.base 0) 
 (* |honda_cstpncpy_#t~post5.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* aux_3679 1) (* aux_3680 4294967296) 0) 0)
 (>=
 (+ (* (+ |honda_cstpncpy_#t~mem0.offset| |ray_cstpncpy_#t~mem0.offset|) 0)
 (*
 (+ |honda_(select #length cstpncpy_~d~3.base)|
 |ray_(select #length cstpncpy_~d~3.base)|) 0)
 (* (+ |honda_cstpncpy_#t~post4.offset| |ray_cstpncpy_#t~post4.offset|) 0)
 (* (+ honda_cstpncpy_~s~3.offset ray_cstpncpy_~s~3.offset) 0)
 (*
 (+
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 |ray_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|)
 0)
 (*
 (+ |honda_(select old(#length) cstpncpy_#in~src.base)|
 |ray_(select old(#length) cstpncpy_#in~src.base)|) 0)
 (* (+ |honda_cstpncpy_~#dst.offset| |ray_cstpncpy_~#dst.offset|) 0)
 (*
 (+
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 |ray_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|)
 0) (* (+ |honda_cstpncpy_#t~mem7| |ray_cstpncpy_#t~mem7|) 0)
 (*
 (+
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 |ray_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|)
 0) (* (+ honda_cstpncpy_~d~3.base ray_cstpncpy_~d~3.base) 0)
 (*
 (+
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 |ray_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|)
 0)
 (*
 (+ |honda_(select #length cstpncpy_#in~src.base)|
 |ray_(select #length cstpncpy_#in~src.base)|) 0)
 (* (+ |honda_cstpncpy_#in~src.offset| |ray_cstpncpy_#in~src.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)|
 |ray_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)|) 0)
 (* (+ |honda_cstpncpy_#t~mem1.offset| |ray_cstpncpy_#t~mem1.offset|) 0)
 (*
 (+ |honda_(select #length cstpncpy_#in~dst.base)|
 |ray_(select #length cstpncpy_#in~dst.base)|) 0)
 (* (+ |honda_cstpncpy_#t~mem0.base| |ray_cstpncpy_#t~mem0.base|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 |ray_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|)
 0) (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_cstpncpy_#in~n| |ray_cstpncpy_#in~n|) 0)
 (* (+ |honda_cstpncpy_#t~mem1.base| |ray_cstpncpy_#t~mem1.base|) 0)
 (* (+ |honda_cstpncpy_#t~post5.base| |ray_cstpncpy_#t~post5.base|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(select old(#length) cstpncpy_~#dst.base)|
 |ray_(select old(#length) cstpncpy_~#dst.base)|) 0)
 (*
 (+ |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)|
 |ray_(ite (select #valid cstpncpy_~d~3.base) 1 0)|) 0)
 (* (+ honda_cstpncpy_~s~3.base ray_cstpncpy_~s~3.base) 0)
 (*
 (+
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 |ray_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|)
 0)
 (*
 (+ |honda_(select #length cstpncpy_~s~3.base)|
 |ray_(select #length cstpncpy_~s~3.base)|) 0)
 (* (+ honda_cstpncpy_~n ray_cstpncpy_~n) 0)
 (* (+ |honda_cstpncpy_#in~dst.base| |ray_cstpncpy_#in~dst.base|) 0)
 (*
 (+ |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)|
 |ray_(ite (select #valid cstpncpy_#in~dst.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length cstpncpy_~#dst.base)|
 |ray_(select #length cstpncpy_~#dst.base)|) 0)
 (* (+ |honda_cstpncpy_#t~post4.base| |ray_cstpncpy_#t~post4.base|) 0)
 (*
 (+ |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)|
 |ray_(ite (select #valid cstpncpy_~#dst.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) cstpncpy_#in~dst.base)|
 |ray_(select old(#length) cstpncpy_#in~dst.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)|
 |ray_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)|) 0)
 (* (+ |honda_cstpncpy_#t~post5.offset| |ray_cstpncpy_#t~post5.offset|) 0)
 (*
 (+ |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)|
 |ray_(ite (select #valid cstpncpy_#in~src.base) 1 0)|) 0)
 (* (+ |honda_cstpncpy_#in~dst.offset| |ray_cstpncpy_#in~dst.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)|
 |ray_(ite (select #valid cstpncpy_~s~3.base) 1 0)|) 0)
 (* (+ honda_cstpncpy_~src.base ray_cstpncpy_~src.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ honda_cstpncpy_~d~3.offset ray_cstpncpy_~d~3.offset) 0)
 (* (+ |honda_cstpncpy_#t~post3| |ray_cstpncpy_#t~post3|) 0)
 (* (+ |honda_cstpncpy_~#dst.base| |ray_cstpncpy_~#dst.base|) 0)
 (* (+ honda_cstpncpy_~src.offset ray_cstpncpy_~src.offset) 0)
 (* (+ |honda_cstpncpy_#in~src.base| |ray_cstpncpy_#in~src.base|) 0)
 (*
 (+
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 |ray_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)|
 |ray_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)|) 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0) 
 (* honda_cstpncpy_~d~3.base 0) 
 (* |honda_cstpncpy_#t~post5.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* aux_3679 1) 0) 0)
 (>=
 (+ (* (+ |honda_cstpncpy_#t~mem0.offset| |ray_cstpncpy_#t~mem0.offset|) 0)
 (*
 (+ |honda_(select #length cstpncpy_~d~3.base)|
 |ray_(select #length cstpncpy_~d~3.base)|) 1)
 (* (+ |honda_cstpncpy_#t~post4.offset| |ray_cstpncpy_#t~post4.offset|) 0)
 (* (+ honda_cstpncpy_~s~3.offset ray_cstpncpy_~s~3.offset) 0)
 (*
 (+
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 |ray_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|)
 0)
 (*
 (+ |honda_(select old(#length) cstpncpy_#in~src.base)|
 |ray_(select old(#length) cstpncpy_#in~src.base)|) 0)
 (* (+ |honda_cstpncpy_~#dst.offset| |ray_cstpncpy_~#dst.offset|) 0)
 (*
 (+
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 |ray_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|)
 0) (* (+ |honda_cstpncpy_#t~mem7| |ray_cstpncpy_#t~mem7|) 0)
 (*
 (+
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 |ray_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|)
 0) (* (+ honda_cstpncpy_~d~3.base ray_cstpncpy_~d~3.base) 0)
 (*
 (+
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 |ray_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|)
 0)
 (*
 (+ |honda_(select #length cstpncpy_#in~src.base)|
 |ray_(select #length cstpncpy_#in~src.base)|) 0)
 (* (+ |honda_cstpncpy_#in~src.offset| |ray_cstpncpy_#in~src.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)|
 |ray_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)|) 0)
 (* (+ |honda_cstpncpy_#t~mem1.offset| |ray_cstpncpy_#t~mem1.offset|) 0)
 (*
 (+ |honda_(select #length cstpncpy_#in~dst.base)|
 |ray_(select #length cstpncpy_#in~dst.base)|) 0)
 (* (+ |honda_cstpncpy_#t~mem0.base| |ray_cstpncpy_#t~mem0.base|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 |ray_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|)
 0) (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_cstpncpy_#in~n| |ray_cstpncpy_#in~n|) 0)
 (* (+ |honda_cstpncpy_#t~mem1.base| |ray_cstpncpy_#t~mem1.base|) 0)
 (* (+ |honda_cstpncpy_#t~post5.base| |ray_cstpncpy_#t~post5.base|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(select old(#length) cstpncpy_~#dst.base)|
 |ray_(select old(#length) cstpncpy_~#dst.base)|) 0)
 (*
 (+ |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)|
 |ray_(ite (select #valid cstpncpy_~d~3.base) 1 0)|) 0)
 (* (+ honda_cstpncpy_~s~3.base ray_cstpncpy_~s~3.base) 0)
 (*
 (+
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 |ray_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|)
 0)
 (*
 (+ |honda_(select #length cstpncpy_~s~3.base)|
 |ray_(select #length cstpncpy_~s~3.base)|) 0)
 (* (+ honda_cstpncpy_~n ray_cstpncpy_~n) 0)
 (* (+ |honda_cstpncpy_#in~dst.base| |ray_cstpncpy_#in~dst.base|) 0)
 (*
 (+ |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)|
 |ray_(ite (select #valid cstpncpy_#in~dst.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length cstpncpy_~#dst.base)|
 |ray_(select #length cstpncpy_~#dst.base)|) 0)
 (* (+ |honda_cstpncpy_#t~post4.base| |ray_cstpncpy_#t~post4.base|) 0)
 (*
 (+ |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)|
 |ray_(ite (select #valid cstpncpy_~#dst.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) cstpncpy_#in~dst.base)|
 |ray_(select old(#length) cstpncpy_#in~dst.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)|
 |ray_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)|) 0)
 (* (+ |honda_cstpncpy_#t~post5.offset| |ray_cstpncpy_#t~post5.offset|) 0)
 (*
 (+ |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)|
 |ray_(ite (select #valid cstpncpy_#in~src.base) 1 0)|) 0)
 (* (+ |honda_cstpncpy_#in~dst.offset| |ray_cstpncpy_#in~dst.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)|
 |ray_(ite (select #valid cstpncpy_~s~3.base) 1 0)|) 0)
 (* (+ honda_cstpncpy_~src.base ray_cstpncpy_~src.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ honda_cstpncpy_~d~3.offset ray_cstpncpy_~d~3.offset) 0)
 (* (+ |honda_cstpncpy_#t~post3| |ray_cstpncpy_#t~post3|) 0)
 (* (+ |honda_cstpncpy_~#dst.base| |ray_cstpncpy_~#dst.base|) 0)
 (* (+ honda_cstpncpy_~src.offset ray_cstpncpy_~src.offset) 0)
 (* (+ |honda_cstpncpy_#in~src.base| |ray_cstpncpy_#in~src.base|) 0)
 (*
 (+
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 |ray_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)|
 |ray_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)|) 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| (- 1))
 (* |honda_cstpncpy_#t~post4.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0) 
 (* honda_cstpncpy_~d~3.base 0) 
 (* |honda_cstpncpy_#t~post5.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 0) 0)
 (>=
 (+ (* (+ |honda_cstpncpy_#t~mem0.offset| |ray_cstpncpy_#t~mem0.offset|) 0)
 (*
 (+ |honda_(select #length cstpncpy_~d~3.base)|
 |ray_(select #length cstpncpy_~d~3.base)|) 0)
 (* (+ |honda_cstpncpy_#t~post4.offset| |ray_cstpncpy_#t~post4.offset|) 0)
 (* (+ honda_cstpncpy_~s~3.offset ray_cstpncpy_~s~3.offset) 0)
 (*
 (+
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 |ray_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|)
 0)
 (*
 (+ |honda_(select old(#length) cstpncpy_#in~src.base)|
 |ray_(select old(#length) cstpncpy_#in~src.base)|) 0)
 (* (+ |honda_cstpncpy_~#dst.offset| |ray_cstpncpy_~#dst.offset|) 0)
 (*
 (+
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 |ray_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|)
 0) (* (+ |honda_cstpncpy_#t~mem7| |ray_cstpncpy_#t~mem7|) 0)
 (*
 (+
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 |ray_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|)
 0) (* (+ honda_cstpncpy_~d~3.base ray_cstpncpy_~d~3.base) 0)
 (*
 (+
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 |ray_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|)
 0)
 (*
 (+ |honda_(select #length cstpncpy_#in~src.base)|
 |ray_(select #length cstpncpy_#in~src.base)|) 0)
 (* (+ |honda_cstpncpy_#in~src.offset| |ray_cstpncpy_#in~src.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)|
 |ray_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)|) 0)
 (* (+ |honda_cstpncpy_#t~mem1.offset| |ray_cstpncpy_#t~mem1.offset|) 0)
 (*
 (+ |honda_(select #length cstpncpy_#in~dst.base)|
 |ray_(select #length cstpncpy_#in~dst.base)|) 0)
 (* (+ |honda_cstpncpy_#t~mem0.base| |ray_cstpncpy_#t~mem0.base|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 |ray_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|)
 0) (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_cstpncpy_#in~n| |ray_cstpncpy_#in~n|) 0)
 (* (+ |honda_cstpncpy_#t~mem1.base| |ray_cstpncpy_#t~mem1.base|) 0)
 (* (+ |honda_cstpncpy_#t~post5.base| |ray_cstpncpy_#t~post5.base|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(select old(#length) cstpncpy_~#dst.base)|
 |ray_(select old(#length) cstpncpy_~#dst.base)|) 0)
 (*
 (+ |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)|
 |ray_(ite (select #valid cstpncpy_~d~3.base) 1 0)|) 0)
 (* (+ honda_cstpncpy_~s~3.base ray_cstpncpy_~s~3.base) (- 1))
 (*
 (+
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 |ray_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|)
 0)
 (*
 (+ |honda_(select #length cstpncpy_~s~3.base)|
 |ray_(select #length cstpncpy_~s~3.base)|) 0)
 (* (+ honda_cstpncpy_~n ray_cstpncpy_~n) 0)
 (* (+ |honda_cstpncpy_#in~dst.base| |ray_cstpncpy_#in~dst.base|) 0)
 (*
 (+ |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)|
 |ray_(ite (select #valid cstpncpy_#in~dst.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length cstpncpy_~#dst.base)|
 |ray_(select #length cstpncpy_~#dst.base)|) 0)
 (* (+ |honda_cstpncpy_#t~post4.base| |ray_cstpncpy_#t~post4.base|) 0)
 (*
 (+ |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)|
 |ray_(ite (select #valid cstpncpy_~#dst.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) cstpncpy_#in~dst.base)|
 |ray_(select old(#length) cstpncpy_#in~dst.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)|
 |ray_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)|) 0)
 (* (+ |honda_cstpncpy_#t~post5.offset| |ray_cstpncpy_#t~post5.offset|) 0)
 (*
 (+ |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)|
 |ray_(ite (select #valid cstpncpy_#in~src.base) 1 0)|) 0)
 (* (+ |honda_cstpncpy_#in~dst.offset| |ray_cstpncpy_#in~dst.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)|
 |ray_(ite (select #valid cstpncpy_~s~3.base) 1 0)|) 0)
 (* (+ honda_cstpncpy_~src.base ray_cstpncpy_~src.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ honda_cstpncpy_~d~3.offset ray_cstpncpy_~d~3.offset) 0)
 (* (+ |honda_cstpncpy_#t~post3| |ray_cstpncpy_#t~post3|) 0)
 (* (+ |honda_cstpncpy_~#dst.base| |ray_cstpncpy_~#dst.base|) 0)
 (* (+ honda_cstpncpy_~src.offset ray_cstpncpy_~src.offset) 0)
 (* (+ |honda_cstpncpy_#in~src.base| |ray_cstpncpy_#in~src.base|) 0)
 (*
 (+
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 |ray_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)|
 |ray_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)|) 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0) 
 (* honda_cstpncpy_~d~3.base 0) 
 (* |honda_cstpncpy_#t~post5.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (* honda_cstpncpy_~s~3.base 1)
 (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 0) 0)
 (>=
 (+ (* (+ |honda_cstpncpy_#t~mem0.offset| |ray_cstpncpy_#t~mem0.offset|) 0)
 (*
 (+ |honda_(select #length cstpncpy_~d~3.base)|
 |ray_(select #length cstpncpy_~d~3.base)|) 0)
 (* (+ |honda_cstpncpy_#t~post4.offset| |ray_cstpncpy_#t~post4.offset|) 0)
 (* (+ honda_cstpncpy_~s~3.offset ray_cstpncpy_~s~3.offset) 1)
 (*
 (+
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 |ray_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|)
 0)
 (*
 (+ |honda_(select old(#length) cstpncpy_#in~src.base)|
 |ray_(select old(#length) cstpncpy_#in~src.base)|) 0)
 (* (+ |honda_cstpncpy_~#dst.offset| |ray_cstpncpy_~#dst.offset|) 0)
 (*
 (+
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 |ray_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|)
 0) (* (+ |honda_cstpncpy_#t~mem7| |ray_cstpncpy_#t~mem7|) 0)
 (*
 (+
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 |ray_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|)
 0) (* (+ honda_cstpncpy_~d~3.base ray_cstpncpy_~d~3.base) 0)
 (*
 (+
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 |ray_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|)
 0)
 (*
 (+ |honda_(select #length cstpncpy_#in~src.base)|
 |ray_(select #length cstpncpy_#in~src.base)|) 0)
 (* (+ |honda_cstpncpy_#in~src.offset| |ray_cstpncpy_#in~src.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)|
 |ray_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)|) 0)
 (* (+ |honda_cstpncpy_#t~mem1.offset| |ray_cstpncpy_#t~mem1.offset|) 0)
 (*
 (+ |honda_(select #length cstpncpy_#in~dst.base)|
 |ray_(select #length cstpncpy_#in~dst.base)|) 0)
 (* (+ |honda_cstpncpy_#t~mem0.base| |ray_cstpncpy_#t~mem0.base|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 |ray_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|)
 0) (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_cstpncpy_#in~n| |ray_cstpncpy_#in~n|) 0)
 (* (+ |honda_cstpncpy_#t~mem1.base| |ray_cstpncpy_#t~mem1.base|) 0)
 (* (+ |honda_cstpncpy_#t~post5.base| |ray_cstpncpy_#t~post5.base|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(select old(#length) cstpncpy_~#dst.base)|
 |ray_(select old(#length) cstpncpy_~#dst.base)|) 0)
 (*
 (+ |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)|
 |ray_(ite (select #valid cstpncpy_~d~3.base) 1 0)|) 0)
 (* (+ honda_cstpncpy_~s~3.base ray_cstpncpy_~s~3.base) 0)
 (*
 (+
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 |ray_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|)
 0)
 (*
 (+ |honda_(select #length cstpncpy_~s~3.base)|
 |ray_(select #length cstpncpy_~s~3.base)|) 0)
 (* (+ honda_cstpncpy_~n ray_cstpncpy_~n) 0)
 (* (+ |honda_cstpncpy_#in~dst.base| |ray_cstpncpy_#in~dst.base|) 0)
 (*
 (+ |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)|
 |ray_(ite (select #valid cstpncpy_#in~dst.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length cstpncpy_~#dst.base)|
 |ray_(select #length cstpncpy_~#dst.base)|) 0)
 (* (+ |honda_cstpncpy_#t~post4.base| |ray_cstpncpy_#t~post4.base|) 0)
 (*
 (+ |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)|
 |ray_(ite (select #valid cstpncpy_~#dst.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) cstpncpy_#in~dst.base)|
 |ray_(select old(#length) cstpncpy_#in~dst.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)|
 |ray_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)|) 0)
 (* (+ |honda_cstpncpy_#t~post5.offset| |ray_cstpncpy_#t~post5.offset|) 0)
 (*
 (+ |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)|
 |ray_(ite (select #valid cstpncpy_#in~src.base) 1 0)|) 0)
 (* (+ |honda_cstpncpy_#in~dst.offset| |ray_cstpncpy_#in~dst.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)|
 |ray_(ite (select #valid cstpncpy_~s~3.base) 1 0)|) 0)
 (* (+ honda_cstpncpy_~src.base ray_cstpncpy_~src.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ honda_cstpncpy_~d~3.offset ray_cstpncpy_~d~3.offset) 0)
 (* (+ |honda_cstpncpy_#t~post3| |ray_cstpncpy_#t~post3|) 0)
 (* (+ |honda_cstpncpy_~#dst.base| |ray_cstpncpy_~#dst.base|) 0)
 (* (+ honda_cstpncpy_~src.offset ray_cstpncpy_~src.offset) 0)
 (* (+ |honda_cstpncpy_#in~src.base| |ray_cstpncpy_#in~src.base|) 0)
 (*
 (+
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 |ray_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)|
 |ray_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)|) 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0) 
 (* honda_cstpncpy_~s~3.offset (- 1))
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0) 
 (* honda_cstpncpy_~d~3.base 0) 
 (* |honda_cstpncpy_#t~post5.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (- 1)) 0)
 (>=
 (+ (* (+ |honda_cstpncpy_#t~mem0.offset| |ray_cstpncpy_#t~mem0.offset|) 0)
 (*
 (+ |honda_(select #length cstpncpy_~d~3.base)|
 |ray_(select #length cstpncpy_~d~3.base)|) 0)
 (* (+ |honda_cstpncpy_#t~post4.offset| |ray_cstpncpy_#t~post4.offset|) 0)
 (* (+ honda_cstpncpy_~s~3.offset ray_cstpncpy_~s~3.offset) 0)
 (*
 (+
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 |ray_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|)
 0)
 (*
 (+ |honda_(select old(#length) cstpncpy_#in~src.base)|
 |ray_(select old(#length) cstpncpy_#in~src.base)|) 0)
 (* (+ |honda_cstpncpy_~#dst.offset| |ray_cstpncpy_~#dst.offset|) 0)
 (*
 (+
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 |ray_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|)
 0) (* (+ |honda_cstpncpy_#t~mem7| |ray_cstpncpy_#t~mem7|) 0)
 (*
 (+
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 |ray_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|)
 0) (* (+ honda_cstpncpy_~d~3.base ray_cstpncpy_~d~3.base) 0)
 (*
 (+
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 |ray_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|)
 0)
 (*
 (+ |honda_(select #length cstpncpy_#in~src.base)|
 |ray_(select #length cstpncpy_#in~src.base)|) 0)
 (* (+ |honda_cstpncpy_#in~src.offset| |ray_cstpncpy_#in~src.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)|
 |ray_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)|) 0)
 (* (+ |honda_cstpncpy_#t~mem1.offset| |ray_cstpncpy_#t~mem1.offset|) 0)
 (*
 (+ |honda_(select #length cstpncpy_#in~dst.base)|
 |ray_(select #length cstpncpy_#in~dst.base)|) 0)
 (* (+ |honda_cstpncpy_#t~mem0.base| |ray_cstpncpy_#t~mem0.base|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 |ray_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|)
 0) (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_cstpncpy_#in~n| |ray_cstpncpy_#in~n|) 0)
 (* (+ |honda_cstpncpy_#t~mem1.base| |ray_cstpncpy_#t~mem1.base|) 0)
 (* (+ |honda_cstpncpy_#t~post5.base| |ray_cstpncpy_#t~post5.base|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(select old(#length) cstpncpy_~#dst.base)|
 |ray_(select old(#length) cstpncpy_~#dst.base)|) 0)
 (*
 (+ |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)|
 |ray_(ite (select #valid cstpncpy_~d~3.base) 1 0)|) 0)
 (* (+ honda_cstpncpy_~s~3.base ray_cstpncpy_~s~3.base) 0)
 (*
 (+
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 |ray_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|)
 0)
 (*
 (+ |honda_(select #length cstpncpy_~s~3.base)|
 |ray_(select #length cstpncpy_~s~3.base)|) 0)
 (* (+ honda_cstpncpy_~n ray_cstpncpy_~n) 0)
 (* (+ |honda_cstpncpy_#in~dst.base| |ray_cstpncpy_#in~dst.base|) 0)
 (*
 (+ |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)|
 |ray_(ite (select #valid cstpncpy_#in~dst.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length cstpncpy_~#dst.base)|
 |ray_(select #length cstpncpy_~#dst.base)|) 0)
 (* (+ |honda_cstpncpy_#t~post4.base| |ray_cstpncpy_#t~post4.base|) 0)
 (*
 (+ |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)|
 |ray_(ite (select #valid cstpncpy_~#dst.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) cstpncpy_#in~dst.base)|
 |ray_(select old(#length) cstpncpy_#in~dst.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)|
 |ray_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)|) 0)
 (* (+ |honda_cstpncpy_#t~post5.offset| |ray_cstpncpy_#t~post5.offset|) 0)
 (*
 (+ |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)|
 |ray_(ite (select #valid cstpncpy_#in~src.base) 1 0)|) 0)
 (* (+ |honda_cstpncpy_#in~dst.offset| |ray_cstpncpy_#in~dst.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)|
 |ray_(ite (select #valid cstpncpy_~s~3.base) 1 0)|) 0)
 (* (+ honda_cstpncpy_~src.base ray_cstpncpy_~src.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ honda_cstpncpy_~d~3.offset ray_cstpncpy_~d~3.offset) 0)
 (* (+ |honda_cstpncpy_#t~post3| |ray_cstpncpy_#t~post3|) 0)
 (* (+ |honda_cstpncpy_~#dst.base| |ray_cstpncpy_~#dst.base|) 0)
 (* (+ honda_cstpncpy_~src.offset ray_cstpncpy_~src.offset) 0)
 (* (+ |honda_cstpncpy_#in~src.base| |ray_cstpncpy_#in~src.base|) 0)
 (*
 (+
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 |ray_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)|
 |ray_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)|) 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0) 
 (* honda_cstpncpy_~d~3.base 0) 
 (* |honda_cstpncpy_#t~post5.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 1)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (- 1)) 0)
 (>=
 (+ (* (+ |honda_cstpncpy_#t~mem0.offset| |ray_cstpncpy_#t~mem0.offset|) 0)
 (*
 (+ |honda_(select #length cstpncpy_~d~3.base)|
 |ray_(select #length cstpncpy_~d~3.base)|) 0)
 (* (+ |honda_cstpncpy_#t~post4.offset| |ray_cstpncpy_#t~post4.offset|) 0)
 (* (+ honda_cstpncpy_~s~3.offset ray_cstpncpy_~s~3.offset) 0)
 (*
 (+
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 |ray_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|)
 0)
 (*
 (+ |honda_(select old(#length) cstpncpy_#in~src.base)|
 |ray_(select old(#length) cstpncpy_#in~src.base)|) 0)
 (* (+ |honda_cstpncpy_~#dst.offset| |ray_cstpncpy_~#dst.offset|) 0)
 (*
 (+
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 |ray_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|)
 0) (* (+ |honda_cstpncpy_#t~mem7| |ray_cstpncpy_#t~mem7|) 0)
 (*
 (+
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 |ray_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|)
 0) (* (+ honda_cstpncpy_~d~3.base ray_cstpncpy_~d~3.base) 0)
 (*
 (+
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 |ray_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|)
 0)
 (*
 (+ |honda_(select #length cstpncpy_#in~src.base)|
 |ray_(select #length cstpncpy_#in~src.base)|) 0)
 (* (+ |honda_cstpncpy_#in~src.offset| |ray_cstpncpy_#in~src.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)|
 |ray_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)|) 0)
 (* (+ |honda_cstpncpy_#t~mem1.offset| |ray_cstpncpy_#t~mem1.offset|) 0)
 (*
 (+ |honda_(select #length cstpncpy_#in~dst.base)|
 |ray_(select #length cstpncpy_#in~dst.base)|) 0)
 (* (+ |honda_cstpncpy_#t~mem0.base| |ray_cstpncpy_#t~mem0.base|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 |ray_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|)
 0) (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_cstpncpy_#in~n| |ray_cstpncpy_#in~n|) 0)
 (* (+ |honda_cstpncpy_#t~mem1.base| |ray_cstpncpy_#t~mem1.base|) 0)
 (* (+ |honda_cstpncpy_#t~post5.base| |ray_cstpncpy_#t~post5.base|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(select old(#length) cstpncpy_~#dst.base)|
 |ray_(select old(#length) cstpncpy_~#dst.base)|) 0)
 (*
 (+ |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)|
 |ray_(ite (select #valid cstpncpy_~d~3.base) 1 0)|) 0)
 (* (+ honda_cstpncpy_~s~3.base ray_cstpncpy_~s~3.base) 0)
 (*
 (+
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 |ray_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|)
 0)
 (*
 (+ |honda_(select #length cstpncpy_~s~3.base)|
 |ray_(select #length cstpncpy_~s~3.base)|) 0)
 (* (+ honda_cstpncpy_~n ray_cstpncpy_~n) 1)
 (* (+ |honda_cstpncpy_#in~dst.base| |ray_cstpncpy_#in~dst.base|) 0)
 (*
 (+ |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)|
 |ray_(ite (select #valid cstpncpy_#in~dst.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length cstpncpy_~#dst.base)|
 |ray_(select #length cstpncpy_~#dst.base)|) 0)
 (* (+ |honda_cstpncpy_#t~post4.base| |ray_cstpncpy_#t~post4.base|) 0)
 (*
 (+ |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)|
 |ray_(ite (select #valid cstpncpy_~#dst.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) cstpncpy_#in~dst.base)|
 |ray_(select old(#length) cstpncpy_#in~dst.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)|
 |ray_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)|) 0)
 (* (+ |honda_cstpncpy_#t~post5.offset| |ray_cstpncpy_#t~post5.offset|) 0)
 (*
 (+ |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)|
 |ray_(ite (select #valid cstpncpy_#in~src.base) 1 0)|) 0)
 (* (+ |honda_cstpncpy_#in~dst.offset| |ray_cstpncpy_#in~dst.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)|
 |ray_(ite (select #valid cstpncpy_~s~3.base) 1 0)|) 0)
 (* (+ honda_cstpncpy_~src.base ray_cstpncpy_~src.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ honda_cstpncpy_~d~3.offset ray_cstpncpy_~d~3.offset) 0)
 (* (+ |honda_cstpncpy_#t~post3| |ray_cstpncpy_#t~post3|) 0)
 (* (+ |honda_cstpncpy_~#dst.base| |ray_cstpncpy_~#dst.base|) 0)
 (* (+ honda_cstpncpy_~src.offset ray_cstpncpy_~src.offset) 0)
 (* (+ |honda_cstpncpy_#in~src.base| |ray_cstpncpy_#in~src.base|) 0)
 (*
 (+
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 |ray_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)|
 |ray_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)|) 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0) 
 (* honda_cstpncpy_~d~3.base 0) 
 (* |honda_cstpncpy_#t~post5.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(select #length cstpncpy_~s~3.base)| 0)
 (* honda_cstpncpy_~n (- 1)) 
 (* |honda_cstpncpy_#t~post4.base| 0) 
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 1) 0)
 (>=
 (+ (* (+ |honda_cstpncpy_#t~mem0.offset| |ray_cstpncpy_#t~mem0.offset|) 0)
 (*
 (+ |honda_(select #length cstpncpy_~d~3.base)|
 |ray_(select #length cstpncpy_~d~3.base)|) 0)
 (* (+ |honda_cstpncpy_#t~post4.offset| |ray_cstpncpy_#t~post4.offset|) 0)
 (* (+ honda_cstpncpy_~s~3.offset ray_cstpncpy_~s~3.offset) 0)
 (*
 (+
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 |ray_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|)
 0)
 (*
 (+ |honda_(select old(#length) cstpncpy_#in~src.base)|
 |ray_(select old(#length) cstpncpy_#in~src.base)|) 0)
 (* (+ |honda_cstpncpy_~#dst.offset| |ray_cstpncpy_~#dst.offset|) 0)
 (*
 (+
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 |ray_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|)
 0) (* (+ |honda_cstpncpy_#t~mem7| |ray_cstpncpy_#t~mem7|) 0)
 (*
 (+
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 |ray_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|)
 0) (* (+ honda_cstpncpy_~d~3.base ray_cstpncpy_~d~3.base) 0)
 (*
 (+
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 |ray_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|)
 0)
 (*
 (+ |honda_(select #length cstpncpy_#in~src.base)|
 |ray_(select #length cstpncpy_#in~src.base)|) 0)
 (* (+ |honda_cstpncpy_#in~src.offset| |ray_cstpncpy_#in~src.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)|
 |ray_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)|) 0)
 (* (+ |honda_cstpncpy_#t~mem1.offset| |ray_cstpncpy_#t~mem1.offset|) 0)
 (*
 (+ |honda_(select #length cstpncpy_#in~dst.base)|
 |ray_(select #length cstpncpy_#in~dst.base)|) 0)
 (* (+ |honda_cstpncpy_#t~mem0.base| |ray_cstpncpy_#t~mem0.base|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 |ray_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|)
 0) (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_cstpncpy_#in~n| |ray_cstpncpy_#in~n|) 0)
 (* (+ |honda_cstpncpy_#t~mem1.base| |ray_cstpncpy_#t~mem1.base|) 0)
 (* (+ |honda_cstpncpy_#t~post5.base| |ray_cstpncpy_#t~post5.base|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(select old(#length) cstpncpy_~#dst.base)|
 |ray_(select old(#length) cstpncpy_~#dst.base)|) 0)
 (*
 (+ |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)|
 |ray_(ite (select #valid cstpncpy_~d~3.base) 1 0)|) 0)
 (* (+ honda_cstpncpy_~s~3.base ray_cstpncpy_~s~3.base) 0)
 (*
 (+
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 |ray_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|)
 0)
 (*
 (+ |honda_(select #length cstpncpy_~s~3.base)|
 |ray_(select #length cstpncpy_~s~3.base)|) 1)
 (* (+ honda_cstpncpy_~n ray_cstpncpy_~n) 0)
 (* (+ |honda_cstpncpy_#in~dst.base| |ray_cstpncpy_#in~dst.base|) 0)
 (*
 (+ |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)|
 |ray_(ite (select #valid cstpncpy_#in~dst.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length cstpncpy_~#dst.base)|
 |ray_(select #length cstpncpy_~#dst.base)|) 0)
 (* (+ |honda_cstpncpy_#t~post4.base| |ray_cstpncpy_#t~post4.base|) 0)
 (*
 (+ |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)|
 |ray_(ite (select #valid cstpncpy_~#dst.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) cstpncpy_#in~dst.base)|
 |ray_(select old(#length) cstpncpy_#in~dst.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)|
 |ray_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)|) 0)
 (* (+ |honda_cstpncpy_#t~post5.offset| |ray_cstpncpy_#t~post5.offset|) 0)
 (*
 (+ |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)|
 |ray_(ite (select #valid cstpncpy_#in~src.base) 1 0)|) 0)
 (* (+ |honda_cstpncpy_#in~dst.offset| |ray_cstpncpy_#in~dst.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)|
 |ray_(ite (select #valid cstpncpy_~s~3.base) 1 0)|) 0)
 (* (+ honda_cstpncpy_~src.base ray_cstpncpy_~src.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ honda_cstpncpy_~d~3.offset ray_cstpncpy_~d~3.offset) 0)
 (* (+ |honda_cstpncpy_#t~post3| |ray_cstpncpy_#t~post3|) 0)
 (* (+ |honda_cstpncpy_~#dst.base| |ray_cstpncpy_~#dst.base|) 0)
 (* (+ honda_cstpncpy_~src.offset ray_cstpncpy_~src.offset) 0)
 (* (+ |honda_cstpncpy_#in~src.base| |ray_cstpncpy_#in~src.base|) 0)
 (*
 (+
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 |ray_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)|
 |ray_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)|) 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0) 
 (* honda_cstpncpy_~d~3.base 0) 
 (* |honda_cstpncpy_#t~post5.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(select #length cstpncpy_~s~3.base)| (- 1))
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 0) 0)
 (>=
 (+ (* (+ |honda_cstpncpy_#t~mem0.offset| |ray_cstpncpy_#t~mem0.offset|) 0)
 (*
 (+ |honda_(select #length cstpncpy_~d~3.base)|
 |ray_(select #length cstpncpy_~d~3.base)|) 0)
 (* (+ |honda_cstpncpy_#t~post4.offset| |ray_cstpncpy_#t~post4.offset|) 0)
 (* (+ honda_cstpncpy_~s~3.offset ray_cstpncpy_~s~3.offset) 0)
 (*
 (+
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 |ray_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|)
 0)
 (*
 (+ |honda_(select old(#length) cstpncpy_#in~src.base)|
 |ray_(select old(#length) cstpncpy_#in~src.base)|) 0)
 (* (+ |honda_cstpncpy_~#dst.offset| |ray_cstpncpy_~#dst.offset|) 0)
 (*
 (+
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 |ray_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|)
 0) (* (+ |honda_cstpncpy_#t~mem7| |ray_cstpncpy_#t~mem7|) 0)
 (*
 (+
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 |ray_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|)
 0) (* (+ honda_cstpncpy_~d~3.base ray_cstpncpy_~d~3.base) 0)
 (*
 (+
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 |ray_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|)
 0)
 (*
 (+ |honda_(select #length cstpncpy_#in~src.base)|
 |ray_(select #length cstpncpy_#in~src.base)|) 0)
 (* (+ |honda_cstpncpy_#in~src.offset| |ray_cstpncpy_#in~src.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)|
 |ray_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)|) 0)
 (* (+ |honda_cstpncpy_#t~mem1.offset| |ray_cstpncpy_#t~mem1.offset|) 0)
 (*
 (+ |honda_(select #length cstpncpy_#in~dst.base)|
 |ray_(select #length cstpncpy_#in~dst.base)|) 0)
 (* (+ |honda_cstpncpy_#t~mem0.base| |ray_cstpncpy_#t~mem0.base|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 |ray_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|)
 0) (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_cstpncpy_#in~n| |ray_cstpncpy_#in~n|) 0)
 (* (+ |honda_cstpncpy_#t~mem1.base| |ray_cstpncpy_#t~mem1.base|) 0)
 (* (+ |honda_cstpncpy_#t~post5.base| |ray_cstpncpy_#t~post5.base|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(select old(#length) cstpncpy_~#dst.base)|
 |ray_(select old(#length) cstpncpy_~#dst.base)|) 0)
 (*
 (+ |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)|
 |ray_(ite (select #valid cstpncpy_~d~3.base) 1 0)|) 0)
 (* (+ honda_cstpncpy_~s~3.base ray_cstpncpy_~s~3.base) 0)
 (*
 (+
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 |ray_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|)
 0)
 (*
 (+ |honda_(select #length cstpncpy_~s~3.base)|
 |ray_(select #length cstpncpy_~s~3.base)|) 0)
 (* (+ honda_cstpncpy_~n ray_cstpncpy_~n) 0)
 (* (+ |honda_cstpncpy_#in~dst.base| |ray_cstpncpy_#in~dst.base|) 0)
 (*
 (+ |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)|
 |ray_(ite (select #valid cstpncpy_#in~dst.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length cstpncpy_~#dst.base)|
 |ray_(select #length cstpncpy_~#dst.base)|) 0)
 (* (+ |honda_cstpncpy_#t~post4.base| |ray_cstpncpy_#t~post4.base|) 0)
 (*
 (+ |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)|
 |ray_(ite (select #valid cstpncpy_~#dst.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) cstpncpy_#in~dst.base)|
 |ray_(select old(#length) cstpncpy_#in~dst.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)|
 |ray_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)|) 0)
 (* (+ |honda_cstpncpy_#t~post5.offset| |ray_cstpncpy_#t~post5.offset|) 0)
 (*
 (+ |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)|
 |ray_(ite (select #valid cstpncpy_#in~src.base) 1 0)|) 0)
 (* (+ |honda_cstpncpy_#in~dst.offset| |ray_cstpncpy_#in~dst.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)|
 |ray_(ite (select #valid cstpncpy_~s~3.base) 1 0)|) 0)
 (* (+ honda_cstpncpy_~src.base ray_cstpncpy_~src.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ honda_cstpncpy_~d~3.offset ray_cstpncpy_~d~3.offset) 0)
 (* (+ |honda_cstpncpy_#t~post3| |ray_cstpncpy_#t~post3|) 0)
 (* (+ |honda_cstpncpy_~#dst.base| |ray_cstpncpy_~#dst.base|) 0)
 (* (+ honda_cstpncpy_~src.offset ray_cstpncpy_~src.offset) 0)
 (* (+ |honda_cstpncpy_#in~src.base| |ray_cstpncpy_#in~src.base|) 0)
 (*
 (+
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 |ray_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)|
 |ray_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)|) 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 1) (* |honda_cstpncpy_#t~mem7| 0) 
 (* honda_cstpncpy_~d~3.base 0) 
 (* |honda_cstpncpy_#t~post5.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (- 1)) 0)
 (>=
 (+ (* (+ |honda_cstpncpy_#t~mem0.offset| |ray_cstpncpy_#t~mem0.offset|) 0)
 (*
 (+ |honda_(select #length cstpncpy_~d~3.base)|
 |ray_(select #length cstpncpy_~d~3.base)|) 0)
 (* (+ |honda_cstpncpy_#t~post4.offset| |ray_cstpncpy_#t~post4.offset|) 0)
 (* (+ honda_cstpncpy_~s~3.offset ray_cstpncpy_~s~3.offset) 0)
 (*
 (+
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 |ray_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|)
 0)
 (*
 (+ |honda_(select old(#length) cstpncpy_#in~src.base)|
 |ray_(select old(#length) cstpncpy_#in~src.base)|) 0)
 (* (+ |honda_cstpncpy_~#dst.offset| |ray_cstpncpy_~#dst.offset|) 0)
 (*
 (+
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 |ray_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|)
 0) (* (+ |honda_cstpncpy_#t~mem7| |ray_cstpncpy_#t~mem7|) 0)
 (*
 (+
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 |ray_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|)
 0) (* (+ honda_cstpncpy_~d~3.base ray_cstpncpy_~d~3.base) 0)
 (*
 (+
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 |ray_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|)
 0)
 (*
 (+ |honda_(select #length cstpncpy_#in~src.base)|
 |ray_(select #length cstpncpy_#in~src.base)|) 0)
 (* (+ |honda_cstpncpy_#in~src.offset| |ray_cstpncpy_#in~src.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)|
 |ray_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)|) 0)
 (* (+ |honda_cstpncpy_#t~mem1.offset| |ray_cstpncpy_#t~mem1.offset|) 0)
 (*
 (+ |honda_(select #length cstpncpy_#in~dst.base)|
 |ray_(select #length cstpncpy_#in~dst.base)|) 0)
 (* (+ |honda_cstpncpy_#t~mem0.base| |ray_cstpncpy_#t~mem0.base|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 |ray_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|)
 0) (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_cstpncpy_#in~n| |ray_cstpncpy_#in~n|) 0)
 (* (+ |honda_cstpncpy_#t~mem1.base| |ray_cstpncpy_#t~mem1.base|) 0)
 (* (+ |honda_cstpncpy_#t~post5.base| |ray_cstpncpy_#t~post5.base|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(select old(#length) cstpncpy_~#dst.base)|
 |ray_(select old(#length) cstpncpy_~#dst.base)|) 0)
 (*
 (+ |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)|
 |ray_(ite (select #valid cstpncpy_~d~3.base) 1 0)|) 0)
 (* (+ honda_cstpncpy_~s~3.base ray_cstpncpy_~s~3.base) 1)
 (*
 (+
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 |ray_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|)
 0)
 (*
 (+ |honda_(select #length cstpncpy_~s~3.base)|
 |ray_(select #length cstpncpy_~s~3.base)|) 0)
 (* (+ honda_cstpncpy_~n ray_cstpncpy_~n) 0)
 (* (+ |honda_cstpncpy_#in~dst.base| |ray_cstpncpy_#in~dst.base|) 0)
 (*
 (+ |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)|
 |ray_(ite (select #valid cstpncpy_#in~dst.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length cstpncpy_~#dst.base)|
 |ray_(select #length cstpncpy_~#dst.base)|) 0)
 (* (+ |honda_cstpncpy_#t~post4.base| |ray_cstpncpy_#t~post4.base|) 0)
 (*
 (+ |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)|
 |ray_(ite (select #valid cstpncpy_~#dst.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) cstpncpy_#in~dst.base)|
 |ray_(select old(#length) cstpncpy_#in~dst.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)|
 |ray_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)|) 0)
 (* (+ |honda_cstpncpy_#t~post5.offset| |ray_cstpncpy_#t~post5.offset|) 0)
 (*
 (+ |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)|
 |ray_(ite (select #valid cstpncpy_#in~src.base) 1 0)|) 0)
 (* (+ |honda_cstpncpy_#in~dst.offset| |ray_cstpncpy_#in~dst.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)|
 |ray_(ite (select #valid cstpncpy_~s~3.base) 1 0)|) 0)
 (* (+ honda_cstpncpy_~src.base ray_cstpncpy_~src.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ honda_cstpncpy_~d~3.offset ray_cstpncpy_~d~3.offset) 0)
 (* (+ |honda_cstpncpy_#t~post3| |ray_cstpncpy_#t~post3|) 0)
 (* (+ |honda_cstpncpy_~#dst.base| |ray_cstpncpy_~#dst.base|) 0)
 (* (+ honda_cstpncpy_~src.offset ray_cstpncpy_~src.offset) 0)
 (* (+ |honda_cstpncpy_#in~src.base| |ray_cstpncpy_#in~src.base|) 0)
 (*
 (+
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 |ray_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)|
 |ray_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)|) 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0) 
 (* honda_cstpncpy_~d~3.base 0) 
 (* |honda_cstpncpy_#t~post5.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (* honda_cstpncpy_~s~3.base (- 1))
 (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 0) 0)
 (>=
 (+ (* (+ |honda_cstpncpy_#t~mem0.offset| |ray_cstpncpy_#t~mem0.offset|) 0)
 (*
 (+ |honda_(select #length cstpncpy_~d~3.base)|
 |ray_(select #length cstpncpy_~d~3.base)|) 0)
 (* (+ |honda_cstpncpy_#t~post4.offset| |ray_cstpncpy_#t~post4.offset|) 0)
 (* (+ honda_cstpncpy_~s~3.offset ray_cstpncpy_~s~3.offset) 0)
 (*
 (+
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 |ray_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|)
 0)
 (*
 (+ |honda_(select old(#length) cstpncpy_#in~src.base)|
 |ray_(select old(#length) cstpncpy_#in~src.base)|) 0)
 (* (+ |honda_cstpncpy_~#dst.offset| |ray_cstpncpy_~#dst.offset|) 0)
 (*
 (+
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 |ray_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|)
 0) (* (+ |honda_cstpncpy_#t~mem7| |ray_cstpncpy_#t~mem7|) 0)
 (*
 (+
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 |ray_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|)
 0) (* (+ honda_cstpncpy_~d~3.base ray_cstpncpy_~d~3.base) 0)
 (*
 (+
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 |ray_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|)
 0)
 (*
 (+ |honda_(select #length cstpncpy_#in~src.base)|
 |ray_(select #length cstpncpy_#in~src.base)|) 0)
 (* (+ |honda_cstpncpy_#in~src.offset| |ray_cstpncpy_#in~src.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)|
 |ray_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)|) 0)
 (* (+ |honda_cstpncpy_#t~mem1.offset| |ray_cstpncpy_#t~mem1.offset|) 0)
 (*
 (+ |honda_(select #length cstpncpy_#in~dst.base)|
 |ray_(select #length cstpncpy_#in~dst.base)|) 0)
 (* (+ |honda_cstpncpy_#t~mem0.base| |ray_cstpncpy_#t~mem0.base|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 |ray_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|)
 0) (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_cstpncpy_#in~n| |ray_cstpncpy_#in~n|) 0)
 (* (+ |honda_cstpncpy_#t~mem1.base| |ray_cstpncpy_#t~mem1.base|) 0)
 (* (+ |honda_cstpncpy_#t~post5.base| |ray_cstpncpy_#t~post5.base|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(select old(#length) cstpncpy_~#dst.base)|
 |ray_(select old(#length) cstpncpy_~#dst.base)|) 0)
 (*
 (+ |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)|
 |ray_(ite (select #valid cstpncpy_~d~3.base) 1 0)|) 0)
 (* (+ honda_cstpncpy_~s~3.base ray_cstpncpy_~s~3.base) 0)
 (*
 (+
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 |ray_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|)
 0)
 (*
 (+ |honda_(select #length cstpncpy_~s~3.base)|
 |ray_(select #length cstpncpy_~s~3.base)|) 0)
 (* (+ honda_cstpncpy_~n ray_cstpncpy_~n) 0)
 (* (+ |honda_cstpncpy_#in~dst.base| |ray_cstpncpy_#in~dst.base|) 0)
 (*
 (+ |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)|
 |ray_(ite (select #valid cstpncpy_#in~dst.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length cstpncpy_~#dst.base)|
 |ray_(select #length cstpncpy_~#dst.base)|) 0)
 (* (+ |honda_cstpncpy_#t~post4.base| |ray_cstpncpy_#t~post4.base|) 0)
 (*
 (+ |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)|
 |ray_(ite (select #valid cstpncpy_~#dst.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) cstpncpy_#in~dst.base)|
 |ray_(select old(#length) cstpncpy_#in~dst.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)|
 |ray_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)|) 0)
 (* (+ |honda_cstpncpy_#t~post5.offset| |ray_cstpncpy_#t~post5.offset|) 0)
 (*
 (+ |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)|
 |ray_(ite (select #valid cstpncpy_#in~src.base) 1 0)|) 0)
 (* (+ |honda_cstpncpy_#in~dst.offset| |ray_cstpncpy_#in~dst.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)|
 |ray_(ite (select #valid cstpncpy_~s~3.base) 1 0)|) 0)
 (* (+ honda_cstpncpy_~src.base ray_cstpncpy_~src.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ honda_cstpncpy_~d~3.offset ray_cstpncpy_~d~3.offset) 0)
 (* (+ |honda_cstpncpy_#t~post3| |ray_cstpncpy_#t~post3|) 0)
 (* (+ |honda_cstpncpy_~#dst.base| |ray_cstpncpy_~#dst.base|) 0)
 (* (+ honda_cstpncpy_~src.offset ray_cstpncpy_~src.offset) 0)
 (* (+ |honda_cstpncpy_#in~src.base| |ray_cstpncpy_#in~src.base|) 0)
 (*
 (+
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 |ray_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)|
 |ray_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)|) 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 1)
 (* |honda_cstpncpy_#t~post4.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0) 
 (* honda_cstpncpy_~d~3.base 0) 
 (* |honda_cstpncpy_#t~post5.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset (- 1)) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (- 1)) 0)
 (>=
 (+ (* (+ |honda_cstpncpy_#t~mem0.offset| |ray_cstpncpy_#t~mem0.offset|) 0)
 (*
 (+ |honda_(select #length cstpncpy_~d~3.base)|
 |ray_(select #length cstpncpy_~d~3.base)|) 0)
 (* (+ |honda_cstpncpy_#t~post4.offset| |ray_cstpncpy_#t~post4.offset|) 0)
 (* (+ honda_cstpncpy_~s~3.offset ray_cstpncpy_~s~3.offset) 0)
 (*
 (+
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 |ray_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|)
 0)
 (*
 (+ |honda_(select old(#length) cstpncpy_#in~src.base)|
 |ray_(select old(#length) cstpncpy_#in~src.base)|) 0)
 (* (+ |honda_cstpncpy_~#dst.offset| |ray_cstpncpy_~#dst.offset|) 0)
 (*
 (+
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 |ray_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|)
 0) (* (+ |honda_cstpncpy_#t~mem7| |ray_cstpncpy_#t~mem7|) 0)
 (*
 (+
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 |ray_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|)
 0) (* (+ honda_cstpncpy_~d~3.base ray_cstpncpy_~d~3.base) 0)
 (*
 (+
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 |ray_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|)
 0)
 (*
 (+ |honda_(select #length cstpncpy_#in~src.base)|
 |ray_(select #length cstpncpy_#in~src.base)|) 0)
 (* (+ |honda_cstpncpy_#in~src.offset| |ray_cstpncpy_#in~src.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)|
 |ray_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)|) 0)
 (* (+ |honda_cstpncpy_#t~mem1.offset| |ray_cstpncpy_#t~mem1.offset|) 0)
 (*
 (+ |honda_(select #length cstpncpy_#in~dst.base)|
 |ray_(select #length cstpncpy_#in~dst.base)|) 0)
 (* (+ |honda_cstpncpy_#t~mem0.base| |ray_cstpncpy_#t~mem0.base|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 |ray_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|)
 0) (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_cstpncpy_#in~n| |ray_cstpncpy_#in~n|) 0)
 (* (+ |honda_cstpncpy_#t~mem1.base| |ray_cstpncpy_#t~mem1.base|) 0)
 (* (+ |honda_cstpncpy_#t~post5.base| |ray_cstpncpy_#t~post5.base|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(select old(#length) cstpncpy_~#dst.base)|
 |ray_(select old(#length) cstpncpy_~#dst.base)|) 0)
 (*
 (+ |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)|
 |ray_(ite (select #valid cstpncpy_~d~3.base) 1 0)|) 0)
 (* (+ honda_cstpncpy_~s~3.base ray_cstpncpy_~s~3.base) 0)
 (*
 (+
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 |ray_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|)
 0)
 (*
 (+ |honda_(select #length cstpncpy_~s~3.base)|
 |ray_(select #length cstpncpy_~s~3.base)|) 0)
 (* (+ honda_cstpncpy_~n ray_cstpncpy_~n) 0)
 (* (+ |honda_cstpncpy_#in~dst.base| |ray_cstpncpy_#in~dst.base|) 0)
 (*
 (+ |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)|
 |ray_(ite (select #valid cstpncpy_#in~dst.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length cstpncpy_~#dst.base)|
 |ray_(select #length cstpncpy_~#dst.base)|) 0)
 (* (+ |honda_cstpncpy_#t~post4.base| |ray_cstpncpy_#t~post4.base|) 0)
 (*
 (+ |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)|
 |ray_(ite (select #valid cstpncpy_~#dst.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) cstpncpy_#in~dst.base)|
 |ray_(select old(#length) cstpncpy_#in~dst.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)|
 |ray_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)|) 0)
 (* (+ |honda_cstpncpy_#t~post5.offset| |ray_cstpncpy_#t~post5.offset|) 0)
 (*
 (+ |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)|
 |ray_(ite (select #valid cstpncpy_#in~src.base) 1 0)|) 0)
 (* (+ |honda_cstpncpy_#in~dst.offset| |ray_cstpncpy_#in~dst.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)|
 |ray_(ite (select #valid cstpncpy_~s~3.base) 1 0)|) 0)
 (* (+ honda_cstpncpy_~src.base ray_cstpncpy_~src.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ honda_cstpncpy_~d~3.offset ray_cstpncpy_~d~3.offset) 0)
 (* (+ |honda_cstpncpy_#t~post3| |ray_cstpncpy_#t~post3|) 0)
 (* (+ |honda_cstpncpy_~#dst.base| |ray_cstpncpy_~#dst.base|) 0)
 (* (+ honda_cstpncpy_~src.offset ray_cstpncpy_~src.offset) 0)
 (* (+ |honda_cstpncpy_#in~src.base| |ray_cstpncpy_#in~src.base|) 0)
 (*
 (+
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 |ray_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)|
 |ray_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)|) 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0) 
 (* honda_cstpncpy_~d~3.base 0) 
 (* |honda_cstpncpy_#t~post5.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 1)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (- 1)) 0)
 (>=
 (+ (* (+ |honda_cstpncpy_#t~mem0.offset| |ray_cstpncpy_#t~mem0.offset|) 0)
 (*
 (+ |honda_(select #length cstpncpy_~d~3.base)|
 |ray_(select #length cstpncpy_~d~3.base)|) 0)
 (* (+ |honda_cstpncpy_#t~post4.offset| |ray_cstpncpy_#t~post4.offset|) 0)
 (* (+ honda_cstpncpy_~s~3.offset ray_cstpncpy_~s~3.offset) 0)
 (*
 (+
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 |ray_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|)
 0)
 (*
 (+ |honda_(select old(#length) cstpncpy_#in~src.base)|
 |ray_(select old(#length) cstpncpy_#in~src.base)|) 0)
 (* (+ |honda_cstpncpy_~#dst.offset| |ray_cstpncpy_~#dst.offset|) 0)
 (*
 (+
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 |ray_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|)
 0) (* (+ |honda_cstpncpy_#t~mem7| |ray_cstpncpy_#t~mem7|) 0)
 (*
 (+
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 |ray_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|)
 0) (* (+ honda_cstpncpy_~d~3.base ray_cstpncpy_~d~3.base) 0)
 (*
 (+
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 |ray_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|)
 0)
 (*
 (+ |honda_(select #length cstpncpy_#in~src.base)|
 |ray_(select #length cstpncpy_#in~src.base)|) 0)
 (* (+ |honda_cstpncpy_#in~src.offset| |ray_cstpncpy_#in~src.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)|
 |ray_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)|) 0)
 (* (+ |honda_cstpncpy_#t~mem1.offset| |ray_cstpncpy_#t~mem1.offset|) 0)
 (*
 (+ |honda_(select #length cstpncpy_#in~dst.base)|
 |ray_(select #length cstpncpy_#in~dst.base)|) 0)
 (* (+ |honda_cstpncpy_#t~mem0.base| |ray_cstpncpy_#t~mem0.base|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 |ray_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|)
 0) (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_cstpncpy_#in~n| |ray_cstpncpy_#in~n|) 0)
 (* (+ |honda_cstpncpy_#t~mem1.base| |ray_cstpncpy_#t~mem1.base|) 0)
 (* (+ |honda_cstpncpy_#t~post5.base| |ray_cstpncpy_#t~post5.base|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(select old(#length) cstpncpy_~#dst.base)|
 |ray_(select old(#length) cstpncpy_~#dst.base)|) 0)
 (*
 (+ |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)|
 |ray_(ite (select #valid cstpncpy_~d~3.base) 1 0)|) 0)
 (* (+ honda_cstpncpy_~s~3.base ray_cstpncpy_~s~3.base) 0)
 (*
 (+
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 |ray_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|)
 0)
 (*
 (+ |honda_(select #length cstpncpy_~s~3.base)|
 |ray_(select #length cstpncpy_~s~3.base)|) 0)
 (* (+ honda_cstpncpy_~n ray_cstpncpy_~n) 0)
 (* (+ |honda_cstpncpy_#in~dst.base| |ray_cstpncpy_#in~dst.base|) 0)
 (*
 (+ |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)|
 |ray_(ite (select #valid cstpncpy_#in~dst.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length cstpncpy_~#dst.base)|
 |ray_(select #length cstpncpy_~#dst.base)|) 0)
 (* (+ |honda_cstpncpy_#t~post4.base| |ray_cstpncpy_#t~post4.base|) 0)
 (*
 (+ |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)|
 |ray_(ite (select #valid cstpncpy_~#dst.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) cstpncpy_#in~dst.base)|
 |ray_(select old(#length) cstpncpy_#in~dst.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)|
 |ray_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)|) 0)
 (* (+ |honda_cstpncpy_#t~post5.offset| |ray_cstpncpy_#t~post5.offset|) 0)
 (*
 (+ |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)|
 |ray_(ite (select #valid cstpncpy_#in~src.base) 1 0)|) 0)
 (* (+ |honda_cstpncpy_#in~dst.offset| |ray_cstpncpy_#in~dst.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)|
 |ray_(ite (select #valid cstpncpy_~s~3.base) 1 0)|) 0)
 (* (+ honda_cstpncpy_~src.base ray_cstpncpy_~src.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ honda_cstpncpy_~d~3.offset ray_cstpncpy_~d~3.offset) 0)
 (* (+ |honda_cstpncpy_#t~post3| |ray_cstpncpy_#t~post3|) 0)
 (* (+ |honda_cstpncpy_~#dst.base| |ray_cstpncpy_~#dst.base|) 0)
 (* (+ honda_cstpncpy_~src.offset ray_cstpncpy_~src.offset) 0)
 (* (+ |honda_cstpncpy_#in~src.base| |ray_cstpncpy_#in~src.base|) 0)
 (*
 (+
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 |ray_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)|
 |ray_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)|) 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0) 
 (* honda_cstpncpy_~d~3.base 0) 
 (* |honda_cstpncpy_#t~post5.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* aux_3679 (- 1)) (* aux_3674 1) 
 (- 1)) 0)
 (= |ray_cstpncpy_#t~mem0.offset| (* |ray_cstpncpy_#t~mem0.offset| lambda))
 (=
 |ray_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 (*
 |ray_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 lambda))
 (= |ray_(select old(#length) cstpncpy_#in~src.base)|
 (* |ray_(select old(#length) cstpncpy_#in~src.base)| lambda))
 (= |ray_cstpncpy_~#dst.offset| (* |ray_cstpncpy_~#dst.offset| lambda))
 (=
 |ray_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 (*
 |ray_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 lambda))
 (=
 |ray_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 (*
 |ray_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 lambda))
 (= |ray_(select #length cstpncpy_#in~src.base)|
 (* |ray_(select #length cstpncpy_#in~src.base)| lambda))
 (= |ray_cstpncpy_#in~src.offset| (* |ray_cstpncpy_#in~src.offset| lambda))
 (= |ray_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)|
 (* |ray_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| lambda))
 (= |ray_cstpncpy_#t~mem1.offset| (* |ray_cstpncpy_#t~mem1.offset| lambda))
 (= |ray_(select #length cstpncpy_#in~dst.base)|
 (* |ray_(select #length cstpncpy_#in~dst.base)| lambda))
 (= |ray_cstpncpy_#t~mem0.base| (* |ray_cstpncpy_#t~mem0.base| lambda))
 (=
 |ray_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 (*
 |ray_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 lambda)) (= |ray_#NULL.offset| (* |ray_#NULL.offset| lambda))
 (= |ray_cstpncpy_#in~n| (* |ray_cstpncpy_#in~n| lambda))
 (= |ray_cstpncpy_#t~mem1.base| (* |ray_cstpncpy_#t~mem1.base| lambda))
 (= |ray_#NULL.base| (* |ray_#NULL.base| lambda))
 (= |ray_(select old(#length) cstpncpy_~#dst.base)|
 (* |ray_(select old(#length) cstpncpy_~#dst.base)| lambda))
 (=
 |ray_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 (*
 |ray_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 lambda))
 (= |ray_cstpncpy_#in~dst.base| (* |ray_cstpncpy_#in~dst.base| lambda))
 (= |ray_(ite (select #valid cstpncpy_#in~dst.base) 1 0)|
 (* |ray_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| lambda))
 (= |ray_(select #length cstpncpy_~#dst.base)|
 (* |ray_(select #length cstpncpy_~#dst.base)| lambda))
 (= |ray_(ite (select #valid cstpncpy_~#dst.base) 1 0)|
 (* |ray_(ite (select #valid cstpncpy_~#dst.base) 1 0)| lambda))
 (= |ray_(select old(#length) cstpncpy_#in~dst.base)|
 (* |ray_(select old(#length) cstpncpy_#in~dst.base)| lambda))
 (= |ray_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)|
 (* |ray_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| lambda))
 (= |ray_(ite (select #valid cstpncpy_#in~src.base) 1 0)|
 (* |ray_(ite (select #valid cstpncpy_#in~src.base) 1 0)| lambda))
 (= |ray_cstpncpy_#in~dst.offset| (* |ray_cstpncpy_#in~dst.offset| lambda))
 (= |ray_(ite (select #valid 0) 1 0)|
 (* |ray_(ite (select #valid 0) 1 0)| lambda))
 (= ray_cstpncpy_~src.base (* ray_cstpncpy_~src.base lambda))
 (= |ray_(ite (select old(#valid) 0) 1 0)|
 (* |ray_(ite (select old(#valid) 0) 1 0)| lambda))
 (= |ray_cstpncpy_~#dst.base| (* |ray_cstpncpy_~#dst.base| lambda))
 (= ray_cstpncpy_~src.offset (* ray_cstpncpy_~src.offset lambda))
 (= |ray_cstpncpy_#in~src.base| (* |ray_cstpncpy_#in~src.base| lambda))
 (=
 |ray_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 (*
 |ray_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 lambda))
 (= |ray_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)|
 (* |ray_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| lambda))
 (>=
 (+ (* (* |ray_cstpncpy_#t~mem0.offset| lambda) 0)
 (* (* |ray_(select #length cstpncpy_~d~3.base)| lambda) 0)
 (* (* |ray_cstpncpy_#t~post4.offset| lambda) 0)
 (* (* ray_cstpncpy_~s~3.offset lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 lambda) 0)
 (* (* |ray_(select old(#length) cstpncpy_#in~src.base)| lambda) 0)
 (* (* |ray_cstpncpy_~#dst.offset| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 lambda) 0) (* (* |ray_cstpncpy_#t~mem7| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 lambda) 0) (* (* ray_cstpncpy_~d~3.base lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 lambda) 0) (* (* |ray_(select #length cstpncpy_#in~src.base)| lambda) 0)
 (* (* |ray_cstpncpy_#in~src.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| lambda) 0)
 (* (* |ray_cstpncpy_#t~mem1.offset| lambda) 0)
 (* (* |ray_(select #length cstpncpy_#in~dst.base)| lambda) 0)
 (* (* |ray_cstpncpy_#t~mem0.base| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_cstpncpy_#in~n| lambda) 0)
 (* (* |ray_cstpncpy_#t~mem1.base| lambda) 0)
 (* (* |ray_cstpncpy_#t~post5.base| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(select old(#length) cstpncpy_~#dst.base)| lambda) 0)
 (* (* |ray_(ite (select #valid cstpncpy_~d~3.base) 1 0)| lambda) 0)
 (* (* ray_cstpncpy_~s~3.base lambda) 0)
 (*
 (*
 |ray_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 lambda) 0) (* (* |ray_(select #length cstpncpy_~s~3.base)| lambda) (- 1))
 (* (* ray_cstpncpy_~n lambda) 0)
 (* (* |ray_cstpncpy_#in~dst.base| lambda) 0)
 (* (* |ray_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length cstpncpy_~#dst.base)| lambda) 0)
 (* (* |ray_cstpncpy_#t~post4.base| lambda) 0)
 (* (* |ray_(ite (select #valid cstpncpy_~#dst.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) cstpncpy_#in~dst.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| lambda) 0)
 (* (* |ray_cstpncpy_#t~post5.offset| lambda) 0)
 (* (* |ray_(ite (select #valid cstpncpy_#in~src.base) 1 0)| lambda) 0)
 (* (* |ray_cstpncpy_#in~dst.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid cstpncpy_~s~3.base) 1 0)| lambda) 0)
 (* (* ray_cstpncpy_~src.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* ray_cstpncpy_~d~3.offset lambda) 0)
 (* (* |ray_cstpncpy_#t~post3| lambda) 0)
 (* (* |ray_cstpncpy_~#dst.base| lambda) 0)
 (* (* ray_cstpncpy_~src.offset lambda) 0)
 (* (* |ray_cstpncpy_#in~src.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| lambda) 0)
 (* |ray_(select #length cstpncpy_~d~3.base)| 0)
 (* |ray_cstpncpy_#t~post4.offset| 0) 
 (* ray_cstpncpy_~s~3.offset 0)
 (*
 |ray_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |ray_cstpncpy_#t~mem7| 0) 
 (* ray_cstpncpy_~d~3.base 0) 
 (* |ray_cstpncpy_#t~post5.base| 0)
 (* |ray_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (* ray_cstpncpy_~s~3.base 0) 
 (* |ray_(select #length cstpncpy_~s~3.base)| 1) 
 (* ray_cstpncpy_~n 0) (* |ray_cstpncpy_#t~post4.base| 0)
 (* |ray_cstpncpy_#t~post5.offset| 0)
 (* |ray_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* ray_cstpncpy_~d~3.offset 0) 
 (* |ray_cstpncpy_#t~post3| 0)) 0)
 (>=
 (+ (* (* |ray_cstpncpy_#t~mem0.offset| lambda) 0)
 (* (* |ray_(select #length cstpncpy_~d~3.base)| lambda) 0)
 (* (* |ray_cstpncpy_#t~post4.offset| lambda) 0)
 (* (* ray_cstpncpy_~s~3.offset lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 lambda) 0)
 (* (* |ray_(select old(#length) cstpncpy_#in~src.base)| lambda) 0)
 (* (* |ray_cstpncpy_~#dst.offset| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 lambda) 0) (* (* |ray_cstpncpy_#t~mem7| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 lambda) 0) (* (* ray_cstpncpy_~d~3.base lambda) (- 1))
 (*
 (*
 |ray_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 lambda) 0) (* (* |ray_(select #length cstpncpy_#in~src.base)| lambda) 0)
 (* (* |ray_cstpncpy_#in~src.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| lambda) 0)
 (* (* |ray_cstpncpy_#t~mem1.offset| lambda) 0)
 (* (* |ray_(select #length cstpncpy_#in~dst.base)| lambda) 0)
 (* (* |ray_cstpncpy_#t~mem0.base| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_cstpncpy_#in~n| lambda) 0)
 (* (* |ray_cstpncpy_#t~mem1.base| lambda) 0)
 (* (* |ray_cstpncpy_#t~post5.base| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(select old(#length) cstpncpy_~#dst.base)| lambda) 0)
 (* (* |ray_(ite (select #valid cstpncpy_~d~3.base) 1 0)| lambda) 0)
 (* (* ray_cstpncpy_~s~3.base lambda) 0)
 (*
 (*
 |ray_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 lambda) 0) (* (* |ray_(select #length cstpncpy_~s~3.base)| lambda) 0)
 (* (* ray_cstpncpy_~n lambda) 0)
 (* (* |ray_cstpncpy_#in~dst.base| lambda) 0)
 (* (* |ray_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length cstpncpy_~#dst.base)| lambda) 0)
 (* (* |ray_cstpncpy_#t~post4.base| lambda) 0)
 (* (* |ray_(ite (select #valid cstpncpy_~#dst.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) cstpncpy_#in~dst.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| lambda) 0)
 (* (* |ray_cstpncpy_#t~post5.offset| lambda) 0)
 (* (* |ray_(ite (select #valid cstpncpy_#in~src.base) 1 0)| lambda) 0)
 (* (* |ray_cstpncpy_#in~dst.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid cstpncpy_~s~3.base) 1 0)| lambda) 0)
 (* (* ray_cstpncpy_~src.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* ray_cstpncpy_~d~3.offset lambda) 0)
 (* (* |ray_cstpncpy_#t~post3| lambda) 0)
 (* (* |ray_cstpncpy_~#dst.base| lambda) 0)
 (* (* ray_cstpncpy_~src.offset lambda) 0)
 (* (* |ray_cstpncpy_#in~src.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| lambda) 0)
 (* |ray_(select #length cstpncpy_~d~3.base)| 0)
 (* |ray_cstpncpy_#t~post4.offset| 0) 
 (* ray_cstpncpy_~s~3.offset 0)
 (*
 |ray_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |ray_cstpncpy_#t~mem7| 0) 
 (* ray_cstpncpy_~d~3.base 1) 
 (* |ray_cstpncpy_#t~post5.base| 0)
 (* |ray_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (* ray_cstpncpy_~s~3.base 0) 
 (* |ray_(select #length cstpncpy_~s~3.base)| 0) 
 (* ray_cstpncpy_~n 0) (* |ray_cstpncpy_#t~post4.base| 0)
 (* |ray_cstpncpy_#t~post5.offset| 0)
 (* |ray_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* ray_cstpncpy_~d~3.offset 0) 
 (* |ray_cstpncpy_#t~post3| 0)) 0)
 (>=
 (+ (* (* |ray_cstpncpy_#t~mem0.offset| lambda) 0)
 (* (* |ray_(select #length cstpncpy_~d~3.base)| lambda) 0)
 (* (* |ray_cstpncpy_#t~post4.offset| lambda) 0)
 (* (* ray_cstpncpy_~s~3.offset lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 lambda) 0)
 (* (* |ray_(select old(#length) cstpncpy_#in~src.base)| lambda) 0)
 (* (* |ray_cstpncpy_~#dst.offset| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 lambda) 0) (* (* |ray_cstpncpy_#t~mem7| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 lambda) 0) (* (* ray_cstpncpy_~d~3.base lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 lambda) 0) (* (* |ray_(select #length cstpncpy_#in~src.base)| lambda) 0)
 (* (* |ray_cstpncpy_#in~src.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| lambda) 0)
 (* (* |ray_cstpncpy_#t~mem1.offset| lambda) 0)
 (* (* |ray_(select #length cstpncpy_#in~dst.base)| lambda) 0)
 (* (* |ray_cstpncpy_#t~mem0.base| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_cstpncpy_#in~n| lambda) 0)
 (* (* |ray_cstpncpy_#t~mem1.base| lambda) 0)
 (* (* |ray_cstpncpy_#t~post5.base| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(select old(#length) cstpncpy_~#dst.base)| lambda) 0)
 (* (* |ray_(ite (select #valid cstpncpy_~d~3.base) 1 0)| lambda) 0)
 (* (* ray_cstpncpy_~s~3.base lambda) 0)
 (*
 (*
 |ray_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 lambda) 0) (* (* |ray_(select #length cstpncpy_~s~3.base)| lambda) 0)
 (* (* ray_cstpncpy_~n lambda) 0)
 (* (* |ray_cstpncpy_#in~dst.base| lambda) 0)
 (* (* |ray_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length cstpncpy_~#dst.base)| lambda) 0)
 (* (* |ray_cstpncpy_#t~post4.base| lambda) 0)
 (* (* |ray_(ite (select #valid cstpncpy_~#dst.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) cstpncpy_#in~dst.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| lambda) 0)
 (* (* |ray_cstpncpy_#t~post5.offset| lambda) 0)
 (* (* |ray_(ite (select #valid cstpncpy_#in~src.base) 1 0)| lambda) 0)
 (* (* |ray_cstpncpy_#in~dst.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid cstpncpy_~s~3.base) 1 0)| lambda) 0)
 (* (* ray_cstpncpy_~src.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* ray_cstpncpy_~d~3.offset lambda) (- 1))
 (* (* |ray_cstpncpy_#t~post3| lambda) 0)
 (* (* |ray_cstpncpy_~#dst.base| lambda) 0)
 (* (* ray_cstpncpy_~src.offset lambda) 0)
 (* (* |ray_cstpncpy_#in~src.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| lambda) 0)
 (* |ray_(select #length cstpncpy_~d~3.base)| 0)
 (* |ray_cstpncpy_#t~post4.offset| 0) 
 (* ray_cstpncpy_~s~3.offset 0)
 (*
 |ray_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |ray_cstpncpy_#t~mem7| 0) 
 (* ray_cstpncpy_~d~3.base 0) 
 (* |ray_cstpncpy_#t~post5.base| 0)
 (* |ray_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (* ray_cstpncpy_~s~3.base 0) 
 (* |ray_(select #length cstpncpy_~s~3.base)| 0) 
 (* ray_cstpncpy_~n 0) (* |ray_cstpncpy_#t~post4.base| 0)
 (* |ray_cstpncpy_#t~post5.offset| 0)
 (* |ray_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* ray_cstpncpy_~d~3.offset 1) 
 (* |ray_cstpncpy_#t~post3| 0)) 0)
 (>=
 (+ (* (* |ray_cstpncpy_#t~mem0.offset| lambda) 0)
 (* (* |ray_(select #length cstpncpy_~d~3.base)| lambda) 0)
 (* (* |ray_cstpncpy_#t~post4.offset| lambda) 0)
 (* (* ray_cstpncpy_~s~3.offset lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 lambda) 0)
 (* (* |ray_(select old(#length) cstpncpy_#in~src.base)| lambda) 0)
 (* (* |ray_cstpncpy_~#dst.offset| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 lambda) 0) (* (* |ray_cstpncpy_#t~mem7| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 lambda) 0) (* (* ray_cstpncpy_~d~3.base lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 lambda) 0) (* (* |ray_(select #length cstpncpy_#in~src.base)| lambda) 0)
 (* (* |ray_cstpncpy_#in~src.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| lambda) 0)
 (* (* |ray_cstpncpy_#t~mem1.offset| lambda) 0)
 (* (* |ray_(select #length cstpncpy_#in~dst.base)| lambda) 0)
 (* (* |ray_cstpncpy_#t~mem0.base| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_cstpncpy_#in~n| lambda) 0)
 (* (* |ray_cstpncpy_#t~mem1.base| lambda) 0)
 (* (* |ray_cstpncpy_#t~post5.base| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(select old(#length) cstpncpy_~#dst.base)| lambda) 0)
 (* (* |ray_(ite (select #valid cstpncpy_~d~3.base) 1 0)| lambda) 0)
 (* (* ray_cstpncpy_~s~3.base lambda) (- 1))
 (*
 (*
 |ray_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 lambda) 0) (* (* |ray_(select #length cstpncpy_~s~3.base)| lambda) 0)
 (* (* ray_cstpncpy_~n lambda) 0)
 (* (* |ray_cstpncpy_#in~dst.base| lambda) 0)
 (* (* |ray_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length cstpncpy_~#dst.base)| lambda) 0)
 (* (* |ray_cstpncpy_#t~post4.base| lambda) 0)
 (* (* |ray_(ite (select #valid cstpncpy_~#dst.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) cstpncpy_#in~dst.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| lambda) 0)
 (* (* |ray_cstpncpy_#t~post5.offset| lambda) 0)
 (* (* |ray_(ite (select #valid cstpncpy_#in~src.base) 1 0)| lambda) 0)
 (* (* |ray_cstpncpy_#in~dst.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid cstpncpy_~s~3.base) 1 0)| lambda) 0)
 (* (* ray_cstpncpy_~src.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* ray_cstpncpy_~d~3.offset lambda) 0)
 (* (* |ray_cstpncpy_#t~post3| lambda) 0)
 (* (* |ray_cstpncpy_~#dst.base| lambda) 0)
 (* (* ray_cstpncpy_~src.offset lambda) 0)
 (* (* |ray_cstpncpy_#in~src.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| lambda) 0)
 (* |ray_(select #length cstpncpy_~d~3.base)| 0)
 (* |ray_cstpncpy_#t~post4.offset| 0) 
 (* ray_cstpncpy_~s~3.offset 0)
 (*
 |ray_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |ray_cstpncpy_#t~mem7| 0) 
 (* ray_cstpncpy_~d~3.base 1) 
 (* |ray_cstpncpy_#t~post5.base| 0)
 (* |ray_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (* ray_cstpncpy_~s~3.base 0) 
 (* |ray_(select #length cstpncpy_~s~3.base)| 0) 
 (* ray_cstpncpy_~n 0) (* |ray_cstpncpy_#t~post4.base| 0)
 (* |ray_cstpncpy_#t~post5.offset| 0)
 (* |ray_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* ray_cstpncpy_~d~3.offset 0) 
 (* |ray_cstpncpy_#t~post3| 0)) 0)
 (>=
 (+ (* (* |ray_cstpncpy_#t~mem0.offset| lambda) 0)
 (* (* |ray_(select #length cstpncpy_~d~3.base)| lambda) 0)
 (* (* |ray_cstpncpy_#t~post4.offset| lambda) 0)
 (* (* ray_cstpncpy_~s~3.offset lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 lambda) 0)
 (* (* |ray_(select old(#length) cstpncpy_#in~src.base)| lambda) 0)
 (* (* |ray_cstpncpy_~#dst.offset| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 lambda) 0) (* (* |ray_cstpncpy_#t~mem7| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 lambda) 0) (* (* ray_cstpncpy_~d~3.base lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 lambda) 0) (* (* |ray_(select #length cstpncpy_#in~src.base)| lambda) 0)
 (* (* |ray_cstpncpy_#in~src.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| lambda) 0)
 (* (* |ray_cstpncpy_#t~mem1.offset| lambda) 0)
 (* (* |ray_(select #length cstpncpy_#in~dst.base)| lambda) 0)
 (* (* |ray_cstpncpy_#t~mem0.base| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_cstpncpy_#in~n| lambda) 0)
 (* (* |ray_cstpncpy_#t~mem1.base| lambda) 0)
 (* (* |ray_cstpncpy_#t~post5.base| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(select old(#length) cstpncpy_~#dst.base)| lambda) 0)
 (* (* |ray_(ite (select #valid cstpncpy_~d~3.base) 1 0)| lambda) 1)
 (* (* ray_cstpncpy_~s~3.base lambda) 0)
 (*
 (*
 |ray_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 lambda) 0) (* (* |ray_(select #length cstpncpy_~s~3.base)| lambda) 0)
 (* (* ray_cstpncpy_~n lambda) 0)
 (* (* |ray_cstpncpy_#in~dst.base| lambda) 0)
 (* (* |ray_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length cstpncpy_~#dst.base)| lambda) 0)
 (* (* |ray_cstpncpy_#t~post4.base| lambda) 0)
 (* (* |ray_(ite (select #valid cstpncpy_~#dst.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) cstpncpy_#in~dst.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| lambda) 0)
 (* (* |ray_cstpncpy_#t~post5.offset| lambda) 0)
 (* (* |ray_(ite (select #valid cstpncpy_#in~src.base) 1 0)| lambda) 0)
 (* (* |ray_cstpncpy_#in~dst.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid cstpncpy_~s~3.base) 1 0)| lambda) 0)
 (* (* ray_cstpncpy_~src.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* ray_cstpncpy_~d~3.offset lambda) 0)
 (* (* |ray_cstpncpy_#t~post3| lambda) 0)
 (* (* |ray_cstpncpy_~#dst.base| lambda) 0)
 (* (* ray_cstpncpy_~src.offset lambda) 0)
 (* (* |ray_cstpncpy_#in~src.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| lambda) 0)
 (* |ray_(select #length cstpncpy_~d~3.base)| 0)
 (* |ray_cstpncpy_#t~post4.offset| 0) 
 (* ray_cstpncpy_~s~3.offset 0)
 (*
 |ray_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |ray_cstpncpy_#t~mem7| 0) 
 (* ray_cstpncpy_~d~3.base 0) 
 (* |ray_cstpncpy_#t~post5.base| 0)
 (* |ray_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (* ray_cstpncpy_~s~3.base 0) 
 (* |ray_(select #length cstpncpy_~s~3.base)| 0) 
 (* ray_cstpncpy_~n 0) (* |ray_cstpncpy_#t~post4.base| 0)
 (* |ray_cstpncpy_#t~post5.offset| 0)
 (* |ray_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* ray_cstpncpy_~d~3.offset 0) 
 (* |ray_cstpncpy_#t~post3| 0)) 0)
 (>=
 (+ (* (* |ray_cstpncpy_#t~mem0.offset| lambda) 0)
 (* (* |ray_(select #length cstpncpy_~d~3.base)| lambda) (- 1))
 (* (* |ray_cstpncpy_#t~post4.offset| lambda) 0)
 (* (* ray_cstpncpy_~s~3.offset lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 lambda) 0)
 (* (* |ray_(select old(#length) cstpncpy_#in~src.base)| lambda) 0)
 (* (* |ray_cstpncpy_~#dst.offset| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 lambda) 0) (* (* |ray_cstpncpy_#t~mem7| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 lambda) 0) (* (* ray_cstpncpy_~d~3.base lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 lambda) 0) (* (* |ray_(select #length cstpncpy_#in~src.base)| lambda) 0)
 (* (* |ray_cstpncpy_#in~src.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| lambda) 0)
 (* (* |ray_cstpncpy_#t~mem1.offset| lambda) 0)
 (* (* |ray_(select #length cstpncpy_#in~dst.base)| lambda) 0)
 (* (* |ray_cstpncpy_#t~mem0.base| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_cstpncpy_#in~n| lambda) 0)
 (* (* |ray_cstpncpy_#t~mem1.base| lambda) 0)
 (* (* |ray_cstpncpy_#t~post5.base| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(select old(#length) cstpncpy_~#dst.base)| lambda) 0)
 (* (* |ray_(ite (select #valid cstpncpy_~d~3.base) 1 0)| lambda) 0)
 (* (* ray_cstpncpy_~s~3.base lambda) 0)
 (*
 (*
 |ray_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 lambda) 0) (* (* |ray_(select #length cstpncpy_~s~3.base)| lambda) 0)
 (* (* ray_cstpncpy_~n lambda) 0)
 (* (* |ray_cstpncpy_#in~dst.base| lambda) 0)
 (* (* |ray_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length cstpncpy_~#dst.base)| lambda) 0)
 (* (* |ray_cstpncpy_#t~post4.base| lambda) 0)
 (* (* |ray_(ite (select #valid cstpncpy_~#dst.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) cstpncpy_#in~dst.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| lambda) 0)
 (* (* |ray_cstpncpy_#t~post5.offset| lambda) 0)
 (* (* |ray_(ite (select #valid cstpncpy_#in~src.base) 1 0)| lambda) 0)
 (* (* |ray_cstpncpy_#in~dst.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid cstpncpy_~s~3.base) 1 0)| lambda) 0)
 (* (* ray_cstpncpy_~src.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* ray_cstpncpy_~d~3.offset lambda) 0)
 (* (* |ray_cstpncpy_#t~post3| lambda) 0)
 (* (* |ray_cstpncpy_~#dst.base| lambda) 0)
 (* (* ray_cstpncpy_~src.offset lambda) 0)
 (* (* |ray_cstpncpy_#in~src.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| lambda) 0)
 (* |ray_(select #length cstpncpy_~d~3.base)| 1)
 (* |ray_cstpncpy_#t~post4.offset| 0) 
 (* ray_cstpncpy_~s~3.offset 0)
 (*
 |ray_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |ray_cstpncpy_#t~mem7| 0) 
 (* ray_cstpncpy_~d~3.base 0) 
 (* |ray_cstpncpy_#t~post5.base| 0)
 (* |ray_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (* ray_cstpncpy_~s~3.base 0) 
 (* |ray_(select #length cstpncpy_~s~3.base)| 0) 
 (* ray_cstpncpy_~n 0) (* |ray_cstpncpy_#t~post4.base| 0)
 (* |ray_cstpncpy_#t~post5.offset| 0)
 (* |ray_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* ray_cstpncpy_~d~3.offset 0) 
 (* |ray_cstpncpy_#t~post3| 0)) 0)
 (>=
 (+ (* (* |ray_cstpncpy_#t~mem0.offset| lambda) 0)
 (* (* |ray_(select #length cstpncpy_~d~3.base)| lambda) 0)
 (* (* |ray_cstpncpy_#t~post4.offset| lambda) 0)
 (* (* ray_cstpncpy_~s~3.offset lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 lambda) 0)
 (* (* |ray_(select old(#length) cstpncpy_#in~src.base)| lambda) 0)
 (* (* |ray_cstpncpy_~#dst.offset| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 lambda) 0) (* (* |ray_cstpncpy_#t~mem7| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 lambda) 0) (* (* ray_cstpncpy_~d~3.base lambda) 1)
 (*
 (*
 |ray_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 lambda) 0) (* (* |ray_(select #length cstpncpy_#in~src.base)| lambda) 0)
 (* (* |ray_cstpncpy_#in~src.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| lambda) 0)
 (* (* |ray_cstpncpy_#t~mem1.offset| lambda) 0)
 (* (* |ray_(select #length cstpncpy_#in~dst.base)| lambda) 0)
 (* (* |ray_cstpncpy_#t~mem0.base| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_cstpncpy_#in~n| lambda) 0)
 (* (* |ray_cstpncpy_#t~mem1.base| lambda) 0)
 (* (* |ray_cstpncpy_#t~post5.base| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(select old(#length) cstpncpy_~#dst.base)| lambda) 0)
 (* (* |ray_(ite (select #valid cstpncpy_~d~3.base) 1 0)| lambda) 0)
 (* (* ray_cstpncpy_~s~3.base lambda) 0)
 (*
 (*
 |ray_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 lambda) 0) (* (* |ray_(select #length cstpncpy_~s~3.base)| lambda) 0)
 (* (* ray_cstpncpy_~n lambda) 0)
 (* (* |ray_cstpncpy_#in~dst.base| lambda) 0)
 (* (* |ray_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length cstpncpy_~#dst.base)| lambda) 0)
 (* (* |ray_cstpncpy_#t~post4.base| lambda) 0)
 (* (* |ray_(ite (select #valid cstpncpy_~#dst.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) cstpncpy_#in~dst.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| lambda) 0)
 (* (* |ray_cstpncpy_#t~post5.offset| lambda) 0)
 (* (* |ray_(ite (select #valid cstpncpy_#in~src.base) 1 0)| lambda) 0)
 (* (* |ray_cstpncpy_#in~dst.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid cstpncpy_~s~3.base) 1 0)| lambda) 0)
 (* (* ray_cstpncpy_~src.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* ray_cstpncpy_~d~3.offset lambda) 0)
 (* (* |ray_cstpncpy_#t~post3| lambda) 0)
 (* (* |ray_cstpncpy_~#dst.base| lambda) 0)
 (* (* ray_cstpncpy_~src.offset lambda) 0)
 (* (* |ray_cstpncpy_#in~src.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| lambda) 0)
 (* |ray_(select #length cstpncpy_~d~3.base)| 0)
 (* |ray_cstpncpy_#t~post4.offset| 0) 
 (* ray_cstpncpy_~s~3.offset 0)
 (*
 |ray_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |ray_cstpncpy_#t~mem7| 0) 
 (* ray_cstpncpy_~d~3.base (- 1)) 
 (* |ray_cstpncpy_#t~post5.base| 0)
 (* |ray_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (* ray_cstpncpy_~s~3.base 0) 
 (* |ray_(select #length cstpncpy_~s~3.base)| 0) 
 (* ray_cstpncpy_~n 0) (* |ray_cstpncpy_#t~post4.base| 0)
 (* |ray_cstpncpy_#t~post5.offset| 0)
 (* |ray_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* ray_cstpncpy_~d~3.offset 0) 
 (* |ray_cstpncpy_#t~post3| 0)) 0)
 (>=
 (+ (* (* |ray_cstpncpy_#t~mem0.offset| lambda) 0)
 (* (* |ray_(select #length cstpncpy_~d~3.base)| lambda) 0)
 (* (* |ray_cstpncpy_#t~post4.offset| lambda) 0)
 (* (* ray_cstpncpy_~s~3.offset lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 lambda) 0)
 (* (* |ray_(select old(#length) cstpncpy_#in~src.base)| lambda) 0)
 (* (* |ray_cstpncpy_~#dst.offset| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 lambda) 0) (* (* |ray_cstpncpy_#t~mem7| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 lambda) 0) (* (* ray_cstpncpy_~d~3.base lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 lambda) 0) (* (* |ray_(select #length cstpncpy_#in~src.base)| lambda) 0)
 (* (* |ray_cstpncpy_#in~src.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| lambda) 0)
 (* (* |ray_cstpncpy_#t~mem1.offset| lambda) 0)
 (* (* |ray_(select #length cstpncpy_#in~dst.base)| lambda) 0)
 (* (* |ray_cstpncpy_#t~mem0.base| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_cstpncpy_#in~n| lambda) 0)
 (* (* |ray_cstpncpy_#t~mem1.base| lambda) 0)
 (* (* |ray_cstpncpy_#t~post5.base| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(select old(#length) cstpncpy_~#dst.base)| lambda) 0)
 (* (* |ray_(ite (select #valid cstpncpy_~d~3.base) 1 0)| lambda) 0)
 (* (* ray_cstpncpy_~s~3.base lambda) 0)
 (*
 (*
 |ray_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 lambda) 0) (* (* |ray_(select #length cstpncpy_~s~3.base)| lambda) 0)
 (* (* ray_cstpncpy_~n lambda) 0)
 (* (* |ray_cstpncpy_#in~dst.base| lambda) 0)
 (* (* |ray_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length cstpncpy_~#dst.base)| lambda) 0)
 (* (* |ray_cstpncpy_#t~post4.base| lambda) 0)
 (* (* |ray_(ite (select #valid cstpncpy_~#dst.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) cstpncpy_#in~dst.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| lambda) 0)
 (* (* |ray_cstpncpy_#t~post5.offset| lambda) 0)
 (* (* |ray_(ite (select #valid cstpncpy_#in~src.base) 1 0)| lambda) 0)
 (* (* |ray_cstpncpy_#in~dst.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid cstpncpy_~s~3.base) 1 0)| lambda) 0)
 (* (* ray_cstpncpy_~src.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* ray_cstpncpy_~d~3.offset lambda) 0)
 (* (* |ray_cstpncpy_#t~post3| lambda) 0)
 (* (* |ray_cstpncpy_~#dst.base| lambda) 0)
 (* (* ray_cstpncpy_~src.offset lambda) 0)
 (* (* |ray_cstpncpy_#in~src.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| lambda) 0)
 (* |ray_(select #length cstpncpy_~d~3.base)| 0)
 (* |ray_cstpncpy_#t~post4.offset| 0) 
 (* ray_cstpncpy_~s~3.offset (- 1))
 (*
 |ray_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |ray_cstpncpy_#t~mem7| 0) 
 (* ray_cstpncpy_~d~3.base 0) 
 (* |ray_cstpncpy_#t~post5.base| 0)
 (* |ray_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (* ray_cstpncpy_~s~3.base 0) 
 (* |ray_(select #length cstpncpy_~s~3.base)| 1) 
 (* ray_cstpncpy_~n 0) (* |ray_cstpncpy_#t~post4.base| 0)
 (* |ray_cstpncpy_#t~post5.offset| 0)
 (* |ray_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* ray_cstpncpy_~d~3.offset 0) 
 (* |ray_cstpncpy_#t~post3| 0)) 0)
 (>=
 (+ (* (* |ray_cstpncpy_#t~mem0.offset| lambda) 0)
 (* (* |ray_(select #length cstpncpy_~d~3.base)| lambda) 0)
 (* (* |ray_cstpncpy_#t~post4.offset| lambda) 0)
 (* (* ray_cstpncpy_~s~3.offset lambda) (- 1))
 (*
 (*
 |ray_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 lambda) 0)
 (* (* |ray_(select old(#length) cstpncpy_#in~src.base)| lambda) 0)
 (* (* |ray_cstpncpy_~#dst.offset| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 lambda) 0) (* (* |ray_cstpncpy_#t~mem7| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 lambda) 0) (* (* ray_cstpncpy_~d~3.base lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 lambda) 0) (* (* |ray_(select #length cstpncpy_#in~src.base)| lambda) 0)
 (* (* |ray_cstpncpy_#in~src.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| lambda) 0)
 (* (* |ray_cstpncpy_#t~mem1.offset| lambda) 0)
 (* (* |ray_(select #length cstpncpy_#in~dst.base)| lambda) 0)
 (* (* |ray_cstpncpy_#t~mem0.base| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_cstpncpy_#in~n| lambda) 0)
 (* (* |ray_cstpncpy_#t~mem1.base| lambda) 0)
 (* (* |ray_cstpncpy_#t~post5.base| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(select old(#length) cstpncpy_~#dst.base)| lambda) 0)
 (* (* |ray_(ite (select #valid cstpncpy_~d~3.base) 1 0)| lambda) 0)
 (* (* ray_cstpncpy_~s~3.base lambda) 0)
 (*
 (*
 |ray_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 lambda) 0) (* (* |ray_(select #length cstpncpy_~s~3.base)| lambda) 0)
 (* (* ray_cstpncpy_~n lambda) 0)
 (* (* |ray_cstpncpy_#in~dst.base| lambda) 0)
 (* (* |ray_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length cstpncpy_~#dst.base)| lambda) 0)
 (* (* |ray_cstpncpy_#t~post4.base| lambda) 0)
 (* (* |ray_(ite (select #valid cstpncpy_~#dst.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) cstpncpy_#in~dst.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| lambda) 0)
 (* (* |ray_cstpncpy_#t~post5.offset| lambda) 0)
 (* (* |ray_(ite (select #valid cstpncpy_#in~src.base) 1 0)| lambda) 0)
 (* (* |ray_cstpncpy_#in~dst.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid cstpncpy_~s~3.base) 1 0)| lambda) 0)
 (* (* ray_cstpncpy_~src.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* ray_cstpncpy_~d~3.offset lambda) 0)
 (* (* |ray_cstpncpy_#t~post3| lambda) 0)
 (* (* |ray_cstpncpy_~#dst.base| lambda) 0)
 (* (* ray_cstpncpy_~src.offset lambda) 0)
 (* (* |ray_cstpncpy_#in~src.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| lambda) 0)
 (* |ray_(select #length cstpncpy_~d~3.base)| 0)
 (* |ray_cstpncpy_#t~post4.offset| 0) 
 (* ray_cstpncpy_~s~3.offset 1)
 (*
 |ray_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |ray_cstpncpy_#t~mem7| 0) 
 (* ray_cstpncpy_~d~3.base 0) 
 (* |ray_cstpncpy_#t~post5.base| 0)
 (* |ray_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (* ray_cstpncpy_~s~3.base 0) 
 (* |ray_(select #length cstpncpy_~s~3.base)| 0) 
 (* ray_cstpncpy_~n 0) (* |ray_cstpncpy_#t~post4.base| 0)
 (* |ray_cstpncpy_#t~post5.offset| 0)
 (* |ray_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* ray_cstpncpy_~d~3.offset 0) 
 (* |ray_cstpncpy_#t~post3| 0)) 0)
 (>=
 (+ (* (* |ray_cstpncpy_#t~mem0.offset| lambda) 0)
 (* (* |ray_(select #length cstpncpy_~d~3.base)| lambda) 0)
 (* (* |ray_cstpncpy_#t~post4.offset| lambda) 0)
 (* (* ray_cstpncpy_~s~3.offset lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 lambda) 0)
 (* (* |ray_(select old(#length) cstpncpy_#in~src.base)| lambda) 0)
 (* (* |ray_cstpncpy_~#dst.offset| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 lambda) 0) (* (* |ray_cstpncpy_#t~mem7| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 lambda) 0) (* (* ray_cstpncpy_~d~3.base lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 lambda) 0) (* (* |ray_(select #length cstpncpy_#in~src.base)| lambda) 0)
 (* (* |ray_cstpncpy_#in~src.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| lambda) 0)
 (* (* |ray_cstpncpy_#t~mem1.offset| lambda) 0)
 (* (* |ray_(select #length cstpncpy_#in~dst.base)| lambda) 0)
 (* (* |ray_cstpncpy_#t~mem0.base| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_cstpncpy_#in~n| lambda) 0)
 (* (* |ray_cstpncpy_#t~mem1.base| lambda) 0)
 (* (* |ray_cstpncpy_#t~post5.base| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(select old(#length) cstpncpy_~#dst.base)| lambda) 0)
 (* (* |ray_(ite (select #valid cstpncpy_~d~3.base) 1 0)| lambda) 0)
 (* (* ray_cstpncpy_~s~3.base lambda) 0)
 (*
 (*
 |ray_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 lambda) 0) (* (* |ray_(select #length cstpncpy_~s~3.base)| lambda) 0)
 (* (* ray_cstpncpy_~n lambda) (- 1))
 (* (* |ray_cstpncpy_#in~dst.base| lambda) 0)
 (* (* |ray_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length cstpncpy_~#dst.base)| lambda) 0)
 (* (* |ray_cstpncpy_#t~post4.base| lambda) 0)
 (* (* |ray_(ite (select #valid cstpncpy_~#dst.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) cstpncpy_#in~dst.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| lambda) 0)
 (* (* |ray_cstpncpy_#t~post5.offset| lambda) 0)
 (* (* |ray_(ite (select #valid cstpncpy_#in~src.base) 1 0)| lambda) 0)
 (* (* |ray_cstpncpy_#in~dst.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid cstpncpy_~s~3.base) 1 0)| lambda) 0)
 (* (* ray_cstpncpy_~src.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* ray_cstpncpy_~d~3.offset lambda) 0)
 (* (* |ray_cstpncpy_#t~post3| lambda) 0)
 (* (* |ray_cstpncpy_~#dst.base| lambda) 0)
 (* (* ray_cstpncpy_~src.offset lambda) 0)
 (* (* |ray_cstpncpy_#in~src.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| lambda) 0)
 (* |ray_(select #length cstpncpy_~d~3.base)| 0)
 (* |ray_cstpncpy_#t~post4.offset| 0) 
 (* ray_cstpncpy_~s~3.offset 0)
 (*
 |ray_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |ray_cstpncpy_#t~mem7| 0) 
 (* ray_cstpncpy_~d~3.base 0) 
 (* |ray_cstpncpy_#t~post5.base| 0)
 (* |ray_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (* ray_cstpncpy_~s~3.base 0) 
 (* |ray_(select #length cstpncpy_~s~3.base)| 0) 
 (* ray_cstpncpy_~n 1) (* |ray_cstpncpy_#t~post4.base| 0)
 (* |ray_cstpncpy_#t~post5.offset| 0)
 (* |ray_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* ray_cstpncpy_~d~3.offset 0) 
 (* |ray_cstpncpy_#t~post3| 0)) 0)
 (>=
 (+ (* (* |ray_cstpncpy_#t~mem0.offset| lambda) 0)
 (* (* |ray_(select #length cstpncpy_~d~3.base)| lambda) 0)
 (* (* |ray_cstpncpy_#t~post4.offset| lambda) 0)
 (* (* ray_cstpncpy_~s~3.offset lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 lambda) 0)
 (* (* |ray_(select old(#length) cstpncpy_#in~src.base)| lambda) 0)
 (* (* |ray_cstpncpy_~#dst.offset| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 lambda) 0) (* (* |ray_cstpncpy_#t~mem7| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 lambda) 0) (* (* ray_cstpncpy_~d~3.base lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 lambda) 0) (* (* |ray_(select #length cstpncpy_#in~src.base)| lambda) 0)
 (* (* |ray_cstpncpy_#in~src.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| lambda) 0)
 (* (* |ray_cstpncpy_#t~mem1.offset| lambda) 0)
 (* (* |ray_(select #length cstpncpy_#in~dst.base)| lambda) 0)
 (* (* |ray_cstpncpy_#t~mem0.base| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_cstpncpy_#in~n| lambda) 0)
 (* (* |ray_cstpncpy_#t~mem1.base| lambda) 0)
 (* (* |ray_cstpncpy_#t~post5.base| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(select old(#length) cstpncpy_~#dst.base)| lambda) 0)
 (* (* |ray_(ite (select #valid cstpncpy_~d~3.base) 1 0)| lambda) 0)
 (* (* ray_cstpncpy_~s~3.base lambda) 0)
 (*
 (*
 |ray_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 lambda) 0) (* (* |ray_(select #length cstpncpy_~s~3.base)| lambda) 0)
 (* (* ray_cstpncpy_~n lambda) 0)
 (* (* |ray_cstpncpy_#in~dst.base| lambda) 0)
 (* (* |ray_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length cstpncpy_~#dst.base)| lambda) 0)
 (* (* |ray_cstpncpy_#t~post4.base| lambda) 0)
 (* (* |ray_(ite (select #valid cstpncpy_~#dst.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) cstpncpy_#in~dst.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| lambda) 0)
 (* (* |ray_cstpncpy_#t~post5.offset| lambda) 0)
 (* (* |ray_(ite (select #valid cstpncpy_#in~src.base) 1 0)| lambda) 0)
 (* (* |ray_cstpncpy_#in~dst.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid cstpncpy_~s~3.base) 1 0)| lambda) 0)
 (* (* ray_cstpncpy_~src.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* ray_cstpncpy_~d~3.offset lambda) 1)
 (* (* |ray_cstpncpy_#t~post3| lambda) 0)
 (* (* |ray_cstpncpy_~#dst.base| lambda) 0)
 (* (* ray_cstpncpy_~src.offset lambda) 0)
 (* (* |ray_cstpncpy_#in~src.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| lambda) 0)
 (* |ray_(select #length cstpncpy_~d~3.base)| 0)
 (* |ray_cstpncpy_#t~post4.offset| 0) 
 (* ray_cstpncpy_~s~3.offset 0)
 (*
 |ray_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |ray_cstpncpy_#t~mem7| 0) 
 (* ray_cstpncpy_~d~3.base 0) 
 (* |ray_cstpncpy_#t~post5.base| 0)
 (* |ray_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (* ray_cstpncpy_~s~3.base 0) 
 (* |ray_(select #length cstpncpy_~s~3.base)| 0) 
 (* ray_cstpncpy_~n 0) (* |ray_cstpncpy_#t~post4.base| 0)
 (* |ray_cstpncpy_#t~post5.offset| 0)
 (* |ray_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* ray_cstpncpy_~d~3.offset (- 1)) 
 (* |ray_cstpncpy_#t~post3| 0)) 0)
 (>=
 (+ (* (* |ray_cstpncpy_#t~mem0.offset| lambda) 0)
 (* (* |ray_(select #length cstpncpy_~d~3.base)| lambda) 0)
 (* (* |ray_cstpncpy_#t~post4.offset| lambda) 0)
 (* (* ray_cstpncpy_~s~3.offset lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 lambda) 0)
 (* (* |ray_(select old(#length) cstpncpy_#in~src.base)| lambda) 0)
 (* (* |ray_cstpncpy_~#dst.offset| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 lambda) 0) (* (* |ray_cstpncpy_#t~mem7| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 lambda) 0) (* (* ray_cstpncpy_~d~3.base lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 lambda) 0) (* (* |ray_(select #length cstpncpy_#in~src.base)| lambda) 0)
 (* (* |ray_cstpncpy_#in~src.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| lambda) 0)
 (* (* |ray_cstpncpy_#t~mem1.offset| lambda) 0)
 (* (* |ray_(select #length cstpncpy_#in~dst.base)| lambda) 0)
 (* (* |ray_cstpncpy_#t~mem0.base| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_cstpncpy_#in~n| lambda) 0)
 (* (* |ray_cstpncpy_#t~mem1.base| lambda) 0)
 (* (* |ray_cstpncpy_#t~post5.base| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(select old(#length) cstpncpy_~#dst.base)| lambda) 0)
 (* (* |ray_(ite (select #valid cstpncpy_~d~3.base) 1 0)| lambda) 0)
 (* (* ray_cstpncpy_~s~3.base lambda) 0)
 (*
 (*
 |ray_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 lambda) 0) (* (* |ray_(select #length cstpncpy_~s~3.base)| lambda) 0)
 (* (* ray_cstpncpy_~n lambda) 0)
 (* (* |ray_cstpncpy_#in~dst.base| lambda) 0)
 (* (* |ray_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length cstpncpy_~#dst.base)| lambda) 0)
 (* (* |ray_cstpncpy_#t~post4.base| lambda) 0)
 (* (* |ray_(ite (select #valid cstpncpy_~#dst.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) cstpncpy_#in~dst.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| lambda) 0)
 (* (* |ray_cstpncpy_#t~post5.offset| lambda) 0)
 (* (* |ray_(ite (select #valid cstpncpy_#in~src.base) 1 0)| lambda) 0)
 (* (* |ray_cstpncpy_#in~dst.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid cstpncpy_~s~3.base) 1 0)| lambda) 1)
 (* (* ray_cstpncpy_~src.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* ray_cstpncpy_~d~3.offset lambda) 0)
 (* (* |ray_cstpncpy_#t~post3| lambda) 0)
 (* (* |ray_cstpncpy_~#dst.base| lambda) 0)
 (* (* ray_cstpncpy_~src.offset lambda) 0)
 (* (* |ray_cstpncpy_#in~src.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| lambda) 0)
 (* |ray_(select #length cstpncpy_~d~3.base)| 0)
 (* |ray_cstpncpy_#t~post4.offset| 0) 
 (* ray_cstpncpy_~s~3.offset 0)
 (*
 |ray_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |ray_cstpncpy_#t~mem7| 0) 
 (* ray_cstpncpy_~d~3.base 0) 
 (* |ray_cstpncpy_#t~post5.base| 0)
 (* |ray_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (* ray_cstpncpy_~s~3.base 0) 
 (* |ray_(select #length cstpncpy_~s~3.base)| 0) 
 (* ray_cstpncpy_~n 0) (* |ray_cstpncpy_#t~post4.base| 0)
 (* |ray_cstpncpy_#t~post5.offset| 0)
 (* |ray_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* ray_cstpncpy_~d~3.offset 0) 
 (* |ray_cstpncpy_#t~post3| 0)) 0)
 (>=
 (+ (* (* |ray_cstpncpy_#t~mem0.offset| lambda) 0)
 (* (* |ray_(select #length cstpncpy_~d~3.base)| lambda) 0)
 (* (* |ray_cstpncpy_#t~post4.offset| lambda) 0)
 (* (* ray_cstpncpy_~s~3.offset lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 lambda) 0)
 (* (* |ray_(select old(#length) cstpncpy_#in~src.base)| lambda) 0)
 (* (* |ray_cstpncpy_~#dst.offset| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 lambda) 0) (* (* |ray_cstpncpy_#t~mem7| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 lambda) 0) (* (* ray_cstpncpy_~d~3.base lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 lambda) 0) (* (* |ray_(select #length cstpncpy_#in~src.base)| lambda) 0)
 (* (* |ray_cstpncpy_#in~src.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| lambda) 0)
 (* (* |ray_cstpncpy_#t~mem1.offset| lambda) 0)
 (* (* |ray_(select #length cstpncpy_#in~dst.base)| lambda) 0)
 (* (* |ray_cstpncpy_#t~mem0.base| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_cstpncpy_#in~n| lambda) 0)
 (* (* |ray_cstpncpy_#t~mem1.base| lambda) 0)
 (* (* |ray_cstpncpy_#t~post5.base| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(select old(#length) cstpncpy_~#dst.base)| lambda) 0)
 (* (* |ray_(ite (select #valid cstpncpy_~d~3.base) 1 0)| lambda) 0)
 (* (* ray_cstpncpy_~s~3.base lambda) 0)
 (*
 (*
 |ray_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 lambda) 0) (* (* |ray_(select #length cstpncpy_~s~3.base)| lambda) 0)
 (* (* ray_cstpncpy_~n lambda) 0)
 (* (* |ray_cstpncpy_#in~dst.base| lambda) 0)
 (* (* |ray_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length cstpncpy_~#dst.base)| lambda) 0)
 (* (* |ray_cstpncpy_#t~post4.base| lambda) 0)
 (* (* |ray_(ite (select #valid cstpncpy_~#dst.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) cstpncpy_#in~dst.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| lambda) 0)
 (* (* |ray_cstpncpy_#t~post5.offset| lambda) 0)
 (* (* |ray_(ite (select #valid cstpncpy_#in~src.base) 1 0)| lambda) 0)
 (* (* |ray_cstpncpy_#in~dst.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid cstpncpy_~s~3.base) 1 0)| lambda) 0)
 (* (* ray_cstpncpy_~src.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* ray_cstpncpy_~d~3.offset lambda) 0)
 (* (* |ray_cstpncpy_#t~post3| lambda) 0)
 (* (* |ray_cstpncpy_~#dst.base| lambda) 0)
 (* (* ray_cstpncpy_~src.offset lambda) 0)
 (* (* |ray_cstpncpy_#in~src.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| lambda) 0)
 (* |ray_(select #length cstpncpy_~d~3.base)| 0)
 (* |ray_cstpncpy_#t~post4.offset| 0) 
 (* ray_cstpncpy_~s~3.offset 0)
 (*
 |ray_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |ray_cstpncpy_#t~mem7| 0) 
 (* ray_cstpncpy_~d~3.base 0) 
 (* |ray_cstpncpy_#t~post5.base| 0)
 (* |ray_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (* ray_cstpncpy_~s~3.base 0) 
 (* |ray_(select #length cstpncpy_~s~3.base)| 0) 
 (* ray_cstpncpy_~n (- 1)) 
 (* |ray_cstpncpy_#t~post4.base| 0) 
 (* |ray_cstpncpy_#t~post5.offset| 0)
 (* |ray_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* ray_cstpncpy_~d~3.offset 0) 
 (* |ray_cstpncpy_#t~post3| 0) 
 (* aux_3686 1) (* aux_3687 4294967296)) 0)
 (>=
 (+ (* (* |ray_cstpncpy_#t~mem0.offset| lambda) 0)
 (* (* |ray_(select #length cstpncpy_~d~3.base)| lambda) 0)
 (* (* |ray_cstpncpy_#t~post4.offset| lambda) 0)
 (* (* ray_cstpncpy_~s~3.offset lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 lambda) 0)
 (* (* |ray_(select old(#length) cstpncpy_#in~src.base)| lambda) 0)
 (* (* |ray_cstpncpy_~#dst.offset| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 lambda) 0) (* (* |ray_cstpncpy_#t~mem7| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 lambda) 0) (* (* ray_cstpncpy_~d~3.base lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 lambda) 0) (* (* |ray_(select #length cstpncpy_#in~src.base)| lambda) 0)
 (* (* |ray_cstpncpy_#in~src.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| lambda) 0)
 (* (* |ray_cstpncpy_#t~mem1.offset| lambda) 0)
 (* (* |ray_(select #length cstpncpy_#in~dst.base)| lambda) 0)
 (* (* |ray_cstpncpy_#t~mem0.base| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_cstpncpy_#in~n| lambda) 0)
 (* (* |ray_cstpncpy_#t~mem1.base| lambda) 0)
 (* (* |ray_cstpncpy_#t~post5.base| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(select old(#length) cstpncpy_~#dst.base)| lambda) 0)
 (* (* |ray_(ite (select #valid cstpncpy_~d~3.base) 1 0)| lambda) 0)
 (* (* ray_cstpncpy_~s~3.base lambda) 0)
 (*
 (*
 |ray_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 lambda) 0) (* (* |ray_(select #length cstpncpy_~s~3.base)| lambda) 0)
 (* (* ray_cstpncpy_~n lambda) 0)
 (* (* |ray_cstpncpy_#in~dst.base| lambda) 0)
 (* (* |ray_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length cstpncpy_~#dst.base)| lambda) 0)
 (* (* |ray_cstpncpy_#t~post4.base| lambda) 0)
 (* (* |ray_(ite (select #valid cstpncpy_~#dst.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) cstpncpy_#in~dst.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| lambda) 0)
 (* (* |ray_cstpncpy_#t~post5.offset| lambda) 0)
 (* (* |ray_(ite (select #valid cstpncpy_#in~src.base) 1 0)| lambda) 0)
 (* (* |ray_cstpncpy_#in~dst.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid cstpncpy_~s~3.base) 1 0)| lambda) 0)
 (* (* ray_cstpncpy_~src.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* ray_cstpncpy_~d~3.offset lambda) 0)
 (* (* |ray_cstpncpy_#t~post3| lambda) 0)
 (* (* |ray_cstpncpy_~#dst.base| lambda) 0)
 (* (* ray_cstpncpy_~src.offset lambda) 0)
 (* (* |ray_cstpncpy_#in~src.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| lambda) 0)
 (* |ray_(select #length cstpncpy_~d~3.base)| 0)
 (* |ray_cstpncpy_#t~post4.offset| 0) 
 (* ray_cstpncpy_~s~3.offset 0)
 (*
 |ray_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |ray_cstpncpy_#t~mem7| 0) 
 (* ray_cstpncpy_~d~3.base 0) 
 (* |ray_cstpncpy_#t~post5.base| 0)
 (* |ray_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (* ray_cstpncpy_~s~3.base 0) 
 (* |ray_(select #length cstpncpy_~s~3.base)| 0) 
 (* ray_cstpncpy_~n 0) (* |ray_cstpncpy_#t~post4.base| 0)
 (* |ray_cstpncpy_#t~post5.offset| 0)
 (* |ray_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* ray_cstpncpy_~d~3.offset 0) 
 (* |ray_cstpncpy_#t~post3| 0) 
 (* aux_3686 (- 1))) 0)
 (>=
 (+ (* (* |ray_cstpncpy_#t~mem0.offset| lambda) 0)
 (* (* |ray_(select #length cstpncpy_~d~3.base)| lambda) 0)
 (* (* |ray_cstpncpy_#t~post4.offset| lambda) 0)
 (* (* ray_cstpncpy_~s~3.offset lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 lambda) 0)
 (* (* |ray_(select old(#length) cstpncpy_#in~src.base)| lambda) 0)
 (* (* |ray_cstpncpy_~#dst.offset| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 lambda) 0) (* (* |ray_cstpncpy_#t~mem7| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 lambda) 0) (* (* ray_cstpncpy_~d~3.base lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 lambda) 0) (* (* |ray_(select #length cstpncpy_#in~src.base)| lambda) 0)
 (* (* |ray_cstpncpy_#in~src.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| lambda) 0)
 (* (* |ray_cstpncpy_#t~mem1.offset| lambda) 0)
 (* (* |ray_(select #length cstpncpy_#in~dst.base)| lambda) 0)
 (* (* |ray_cstpncpy_#t~mem0.base| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_cstpncpy_#in~n| lambda) 0)
 (* (* |ray_cstpncpy_#t~mem1.base| lambda) 0)
 (* (* |ray_cstpncpy_#t~post5.base| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(select old(#length) cstpncpy_~#dst.base)| lambda) 0)
 (* (* |ray_(ite (select #valid cstpncpy_~d~3.base) 1 0)| lambda) 0)
 (* (* ray_cstpncpy_~s~3.base lambda) 0)
 (*
 (*
 |ray_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 lambda) 0) (* (* |ray_(select #length cstpncpy_~s~3.base)| lambda) 0)
 (* (* ray_cstpncpy_~n lambda) 0)
 (* (* |ray_cstpncpy_#in~dst.base| lambda) 0)
 (* (* |ray_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length cstpncpy_~#dst.base)| lambda) 0)
 (* (* |ray_cstpncpy_#t~post4.base| lambda) 0)
 (* (* |ray_(ite (select #valid cstpncpy_~#dst.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) cstpncpy_#in~dst.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| lambda) 0)
 (* (* |ray_cstpncpy_#t~post5.offset| lambda) 0)
 (* (* |ray_(ite (select #valid cstpncpy_#in~src.base) 1 0)| lambda) 0)
 (* (* |ray_cstpncpy_#in~dst.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid cstpncpy_~s~3.base) 1 0)| lambda) 0)
 (* (* ray_cstpncpy_~src.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* ray_cstpncpy_~d~3.offset lambda) 0)
 (* (* |ray_cstpncpy_#t~post3| lambda) 0)
 (* (* |ray_cstpncpy_~#dst.base| lambda) 0)
 (* (* ray_cstpncpy_~src.offset lambda) 0)
 (* (* |ray_cstpncpy_#in~src.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| lambda) 0)
 (* |ray_(select #length cstpncpy_~d~3.base)| 0)
 (* |ray_cstpncpy_#t~post4.offset| 0) 
 (* ray_cstpncpy_~s~3.offset 0)
 (*
 |ray_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |ray_cstpncpy_#t~mem7| 0) 
 (* ray_cstpncpy_~d~3.base 0) 
 (* |ray_cstpncpy_#t~post5.base| 0)
 (* |ray_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (* ray_cstpncpy_~s~3.base 0) 
 (* |ray_(select #length cstpncpy_~s~3.base)| 0) 
 (* ray_cstpncpy_~n 1) (* |ray_cstpncpy_#t~post4.base| 0)
 (* |ray_cstpncpy_#t~post5.offset| 0)
 (* |ray_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* ray_cstpncpy_~d~3.offset 0) 
 (* |ray_cstpncpy_#t~post3| 0) 
 (* aux_3686 (- 1)) (* aux_3687 (- 4294967296))) 0)
 (>=
 (+ (* (* |ray_cstpncpy_#t~mem0.offset| lambda) 0)
 (* (* |ray_(select #length cstpncpy_~d~3.base)| lambda) 0)
 (* (* |ray_cstpncpy_#t~post4.offset| lambda) 0)
 (* (* ray_cstpncpy_~s~3.offset lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 lambda) 0)
 (* (* |ray_(select old(#length) cstpncpy_#in~src.base)| lambda) 0)
 (* (* |ray_cstpncpy_~#dst.offset| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 lambda) 0) (* (* |ray_cstpncpy_#t~mem7| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 lambda) 0) (* (* ray_cstpncpy_~d~3.base lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 lambda) 0) (* (* |ray_(select #length cstpncpy_#in~src.base)| lambda) 0)
 (* (* |ray_cstpncpy_#in~src.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| lambda) 0)
 (* (* |ray_cstpncpy_#t~mem1.offset| lambda) 0)
 (* (* |ray_(select #length cstpncpy_#in~dst.base)| lambda) 0)
 (* (* |ray_cstpncpy_#t~mem0.base| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_cstpncpy_#in~n| lambda) 0)
 (* (* |ray_cstpncpy_#t~mem1.base| lambda) 0)
 (* (* |ray_cstpncpy_#t~post5.base| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(select old(#length) cstpncpy_~#dst.base)| lambda) 0)
 (* (* |ray_(ite (select #valid cstpncpy_~d~3.base) 1 0)| lambda) 0)
 (* (* ray_cstpncpy_~s~3.base lambda) 0)
 (*
 (*
 |ray_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 lambda) 0) (* (* |ray_(select #length cstpncpy_~s~3.base)| lambda) 0)
 (* (* ray_cstpncpy_~n lambda) 0)
 (* (* |ray_cstpncpy_#in~dst.base| lambda) 0)
 (* (* |ray_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length cstpncpy_~#dst.base)| lambda) 0)
 (* (* |ray_cstpncpy_#t~post4.base| lambda) 0)
 (* (* |ray_(ite (select #valid cstpncpy_~#dst.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) cstpncpy_#in~dst.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| lambda) 0)
 (* (* |ray_cstpncpy_#t~post5.offset| lambda) 0)
 (* (* |ray_(ite (select #valid cstpncpy_#in~src.base) 1 0)| lambda) 0)
 (* (* |ray_cstpncpy_#in~dst.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid cstpncpy_~s~3.base) 1 0)| lambda) 0)
 (* (* ray_cstpncpy_~src.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* ray_cstpncpy_~d~3.offset lambda) 0)
 (* (* |ray_cstpncpy_#t~post3| lambda) 0)
 (* (* |ray_cstpncpy_~#dst.base| lambda) 0)
 (* (* ray_cstpncpy_~src.offset lambda) 0)
 (* (* |ray_cstpncpy_#in~src.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| lambda) 0)
 (* |ray_(select #length cstpncpy_~d~3.base)| 0)
 (* |ray_cstpncpy_#t~post4.offset| 0) 
 (* ray_cstpncpy_~s~3.offset 0)
 (*
 |ray_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |ray_cstpncpy_#t~mem7| 0) 
 (* ray_cstpncpy_~d~3.base 0) 
 (* |ray_cstpncpy_#t~post5.base| 0)
 (* |ray_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (* ray_cstpncpy_~s~3.base 0) 
 (* |ray_(select #length cstpncpy_~s~3.base)| 0) 
 (* ray_cstpncpy_~n 0) (* |ray_cstpncpy_#t~post4.base| 0)
 (* |ray_cstpncpy_#t~post5.offset| 0)
 (* |ray_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* ray_cstpncpy_~d~3.offset 0) 
 (* |ray_cstpncpy_#t~post3| 0) 
 (* aux_3691 (- 1)) (* aux_3692 (- 4294967296))) 0)
 (>=
 (+ (* (* |ray_cstpncpy_#t~mem0.offset| lambda) 0)
 (* (* |ray_(select #length cstpncpy_~d~3.base)| lambda) 0)
 (* (* |ray_cstpncpy_#t~post4.offset| lambda) 0)
 (* (* ray_cstpncpy_~s~3.offset lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 lambda) 0)
 (* (* |ray_(select old(#length) cstpncpy_#in~src.base)| lambda) 0)
 (* (* |ray_cstpncpy_~#dst.offset| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 lambda) 0) (* (* |ray_cstpncpy_#t~mem7| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 lambda) 0) (* (* ray_cstpncpy_~d~3.base lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 lambda) 0) (* (* |ray_(select #length cstpncpy_#in~src.base)| lambda) 0)
 (* (* |ray_cstpncpy_#in~src.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| lambda) 0)
 (* (* |ray_cstpncpy_#t~mem1.offset| lambda) 0)
 (* (* |ray_(select #length cstpncpy_#in~dst.base)| lambda) 0)
 (* (* |ray_cstpncpy_#t~mem0.base| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_cstpncpy_#in~n| lambda) 0)
 (* (* |ray_cstpncpy_#t~mem1.base| lambda) 0)
 (* (* |ray_cstpncpy_#t~post5.base| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(select old(#length) cstpncpy_~#dst.base)| lambda) 0)
 (* (* |ray_(ite (select #valid cstpncpy_~d~3.base) 1 0)| lambda) 0)
 (* (* ray_cstpncpy_~s~3.base lambda) 0)
 (*
 (*
 |ray_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 lambda) 0) (* (* |ray_(select #length cstpncpy_~s~3.base)| lambda) 0)
 (* (* ray_cstpncpy_~n lambda) 0)
 (* (* |ray_cstpncpy_#in~dst.base| lambda) 0)
 (* (* |ray_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length cstpncpy_~#dst.base)| lambda) 0)
 (* (* |ray_cstpncpy_#t~post4.base| lambda) 0)
 (* (* |ray_(ite (select #valid cstpncpy_~#dst.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) cstpncpy_#in~dst.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| lambda) 0)
 (* (* |ray_cstpncpy_#t~post5.offset| lambda) 0)
 (* (* |ray_(ite (select #valid cstpncpy_#in~src.base) 1 0)| lambda) 0)
 (* (* |ray_cstpncpy_#in~dst.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid cstpncpy_~s~3.base) 1 0)| lambda) 0)
 (* (* ray_cstpncpy_~src.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* ray_cstpncpy_~d~3.offset lambda) 0)
 (* (* |ray_cstpncpy_#t~post3| lambda) 0)
 (* (* |ray_cstpncpy_~#dst.base| lambda) 0)
 (* (* ray_cstpncpy_~src.offset lambda) 0)
 (* (* |ray_cstpncpy_#in~src.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| lambda) 0)
 (* |ray_(select #length cstpncpy_~d~3.base)| 0)
 (* |ray_cstpncpy_#t~post4.offset| 0) 
 (* ray_cstpncpy_~s~3.offset 0)
 (*
 |ray_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |ray_cstpncpy_#t~mem7| 0) 
 (* ray_cstpncpy_~d~3.base 0) 
 (* |ray_cstpncpy_#t~post5.base| 0)
 (* |ray_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (* ray_cstpncpy_~s~3.base 0) 
 (* |ray_(select #length cstpncpy_~s~3.base)| 0) 
 (* ray_cstpncpy_~n 0) (* |ray_cstpncpy_#t~post4.base| 0)
 (* |ray_cstpncpy_#t~post5.offset| 0)
 (* |ray_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* ray_cstpncpy_~d~3.offset 0) 
 (* |ray_cstpncpy_#t~post3| 0) 
 (* aux_3691 1) (* aux_3692 4294967296)) 0)
 (>=
 (+ (* (* |ray_cstpncpy_#t~mem0.offset| lambda) 0)
 (* (* |ray_(select #length cstpncpy_~d~3.base)| lambda) 0)
 (* (* |ray_cstpncpy_#t~post4.offset| lambda) 0)
 (* (* ray_cstpncpy_~s~3.offset lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 lambda) 0)
 (* (* |ray_(select old(#length) cstpncpy_#in~src.base)| lambda) 0)
 (* (* |ray_cstpncpy_~#dst.offset| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 lambda) 0) (* (* |ray_cstpncpy_#t~mem7| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 lambda) 0) (* (* ray_cstpncpy_~d~3.base lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 lambda) 0) (* (* |ray_(select #length cstpncpy_#in~src.base)| lambda) 0)
 (* (* |ray_cstpncpy_#in~src.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| lambda) 0)
 (* (* |ray_cstpncpy_#t~mem1.offset| lambda) 0)
 (* (* |ray_(select #length cstpncpy_#in~dst.base)| lambda) 0)
 (* (* |ray_cstpncpy_#t~mem0.base| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_cstpncpy_#in~n| lambda) 0)
 (* (* |ray_cstpncpy_#t~mem1.base| lambda) 0)
 (* (* |ray_cstpncpy_#t~post5.base| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(select old(#length) cstpncpy_~#dst.base)| lambda) 0)
 (* (* |ray_(ite (select #valid cstpncpy_~d~3.base) 1 0)| lambda) 0)
 (* (* ray_cstpncpy_~s~3.base lambda) 0)
 (*
 (*
 |ray_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 lambda) 0) (* (* |ray_(select #length cstpncpy_~s~3.base)| lambda) 0)
 (* (* ray_cstpncpy_~n lambda) 0)
 (* (* |ray_cstpncpy_#in~dst.base| lambda) 0)
 (* (* |ray_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length cstpncpy_~#dst.base)| lambda) 0)
 (* (* |ray_cstpncpy_#t~post4.base| lambda) 0)
 (* (* |ray_(ite (select #valid cstpncpy_~#dst.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) cstpncpy_#in~dst.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| lambda) 0)
 (* (* |ray_cstpncpy_#t~post5.offset| lambda) 0)
 (* (* |ray_(ite (select #valid cstpncpy_#in~src.base) 1 0)| lambda) 0)
 (* (* |ray_cstpncpy_#in~dst.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid cstpncpy_~s~3.base) 1 0)| lambda) 0)
 (* (* ray_cstpncpy_~src.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* ray_cstpncpy_~d~3.offset lambda) 0)
 (* (* |ray_cstpncpy_#t~post3| lambda) 0)
 (* (* |ray_cstpncpy_~#dst.base| lambda) 0)
 (* (* ray_cstpncpy_~src.offset lambda) 0)
 (* (* |ray_cstpncpy_#in~src.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| lambda) 0)
 (* |ray_(select #length cstpncpy_~d~3.base)| 0)
 (* |ray_cstpncpy_#t~post4.offset| 0) 
 (* ray_cstpncpy_~s~3.offset 0)
 (*
 |ray_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |ray_cstpncpy_#t~mem7| 0) 
 (* ray_cstpncpy_~d~3.base 0) 
 (* |ray_cstpncpy_#t~post5.base| 0)
 (* |ray_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (* ray_cstpncpy_~s~3.base 0) 
 (* |ray_(select #length cstpncpy_~s~3.base)| 0) 
 (* ray_cstpncpy_~n 0) (* |ray_cstpncpy_#t~post4.base| 0)
 (* |ray_cstpncpy_#t~post5.offset| 0)
 (* |ray_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* ray_cstpncpy_~d~3.offset 0) 
 (* |ray_cstpncpy_#t~post3| 0) 
 (* aux_3691 1)) 0)
 (>=
 (+ (* (* |ray_cstpncpy_#t~mem0.offset| lambda) 0)
 (* (* |ray_(select #length cstpncpy_~d~3.base)| lambda) 1)
 (* (* |ray_cstpncpy_#t~post4.offset| lambda) 0)
 (* (* ray_cstpncpy_~s~3.offset lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 lambda) 0)
 (* (* |ray_(select old(#length) cstpncpy_#in~src.base)| lambda) 0)
 (* (* |ray_cstpncpy_~#dst.offset| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 lambda) 0) (* (* |ray_cstpncpy_#t~mem7| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 lambda) 0) (* (* ray_cstpncpy_~d~3.base lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 lambda) 0) (* (* |ray_(select #length cstpncpy_#in~src.base)| lambda) 0)
 (* (* |ray_cstpncpy_#in~src.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| lambda) 0)
 (* (* |ray_cstpncpy_#t~mem1.offset| lambda) 0)
 (* (* |ray_(select #length cstpncpy_#in~dst.base)| lambda) 0)
 (* (* |ray_cstpncpy_#t~mem0.base| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_cstpncpy_#in~n| lambda) 0)
 (* (* |ray_cstpncpy_#t~mem1.base| lambda) 0)
 (* (* |ray_cstpncpy_#t~post5.base| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(select old(#length) cstpncpy_~#dst.base)| lambda) 0)
 (* (* |ray_(ite (select #valid cstpncpy_~d~3.base) 1 0)| lambda) 0)
 (* (* ray_cstpncpy_~s~3.base lambda) 0)
 (*
 (*
 |ray_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 lambda) 0) (* (* |ray_(select #length cstpncpy_~s~3.base)| lambda) 0)
 (* (* ray_cstpncpy_~n lambda) 0)
 (* (* |ray_cstpncpy_#in~dst.base| lambda) 0)
 (* (* |ray_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length cstpncpy_~#dst.base)| lambda) 0)
 (* (* |ray_cstpncpy_#t~post4.base| lambda) 0)
 (* (* |ray_(ite (select #valid cstpncpy_~#dst.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) cstpncpy_#in~dst.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| lambda) 0)
 (* (* |ray_cstpncpy_#t~post5.offset| lambda) 0)
 (* (* |ray_(ite (select #valid cstpncpy_#in~src.base) 1 0)| lambda) 0)
 (* (* |ray_cstpncpy_#in~dst.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid cstpncpy_~s~3.base) 1 0)| lambda) 0)
 (* (* ray_cstpncpy_~src.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* ray_cstpncpy_~d~3.offset lambda) 0)
 (* (* |ray_cstpncpy_#t~post3| lambda) 0)
 (* (* |ray_cstpncpy_~#dst.base| lambda) 0)
 (* (* ray_cstpncpy_~src.offset lambda) 0)
 (* (* |ray_cstpncpy_#in~src.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| lambda) 0)
 (* |ray_(select #length cstpncpy_~d~3.base)| (- 1))
 (* |ray_cstpncpy_#t~post4.offset| 0) 
 (* ray_cstpncpy_~s~3.offset 0)
 (*
 |ray_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |ray_cstpncpy_#t~mem7| 0) 
 (* ray_cstpncpy_~d~3.base 0) 
 (* |ray_cstpncpy_#t~post5.base| 0)
 (* |ray_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (* ray_cstpncpy_~s~3.base 0) 
 (* |ray_(select #length cstpncpy_~s~3.base)| 0) 
 (* ray_cstpncpy_~n 0) (* |ray_cstpncpy_#t~post4.base| 0)
 (* |ray_cstpncpy_#t~post5.offset| 0)
 (* |ray_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* ray_cstpncpy_~d~3.offset 0) 
 (* |ray_cstpncpy_#t~post3| 0)) 0)
 (>=
 (+ (* (* |ray_cstpncpy_#t~mem0.offset| lambda) 0)
 (* (* |ray_(select #length cstpncpy_~d~3.base)| lambda) 0)
 (* (* |ray_cstpncpy_#t~post4.offset| lambda) 0)
 (* (* ray_cstpncpy_~s~3.offset lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 lambda) 0)
 (* (* |ray_(select old(#length) cstpncpy_#in~src.base)| lambda) 0)
 (* (* |ray_cstpncpy_~#dst.offset| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 lambda) 0) (* (* |ray_cstpncpy_#t~mem7| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 lambda) 0) (* (* ray_cstpncpy_~d~3.base lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 lambda) 0) (* (* |ray_(select #length cstpncpy_#in~src.base)| lambda) 0)
 (* (* |ray_cstpncpy_#in~src.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| lambda) 0)
 (* (* |ray_cstpncpy_#t~mem1.offset| lambda) 0)
 (* (* |ray_(select #length cstpncpy_#in~dst.base)| lambda) 0)
 (* (* |ray_cstpncpy_#t~mem0.base| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_cstpncpy_#in~n| lambda) 0)
 (* (* |ray_cstpncpy_#t~mem1.base| lambda) 0)
 (* (* |ray_cstpncpy_#t~post5.base| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(select old(#length) cstpncpy_~#dst.base)| lambda) 0)
 (* (* |ray_(ite (select #valid cstpncpy_~d~3.base) 1 0)| lambda) 0)
 (* (* ray_cstpncpy_~s~3.base lambda) (- 1))
 (*
 (*
 |ray_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 lambda) 0) (* (* |ray_(select #length cstpncpy_~s~3.base)| lambda) 0)
 (* (* ray_cstpncpy_~n lambda) 0)
 (* (* |ray_cstpncpy_#in~dst.base| lambda) 0)
 (* (* |ray_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length cstpncpy_~#dst.base)| lambda) 0)
 (* (* |ray_cstpncpy_#t~post4.base| lambda) 0)
 (* (* |ray_(ite (select #valid cstpncpy_~#dst.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) cstpncpy_#in~dst.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| lambda) 0)
 (* (* |ray_cstpncpy_#t~post5.offset| lambda) 0)
 (* (* |ray_(ite (select #valid cstpncpy_#in~src.base) 1 0)| lambda) 0)
 (* (* |ray_cstpncpy_#in~dst.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid cstpncpy_~s~3.base) 1 0)| lambda) 0)
 (* (* ray_cstpncpy_~src.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* ray_cstpncpy_~d~3.offset lambda) 0)
 (* (* |ray_cstpncpy_#t~post3| lambda) 0)
 (* (* |ray_cstpncpy_~#dst.base| lambda) 0)
 (* (* ray_cstpncpy_~src.offset lambda) 0)
 (* (* |ray_cstpncpy_#in~src.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| lambda) 0)
 (* |ray_(select #length cstpncpy_~d~3.base)| 0)
 (* |ray_cstpncpy_#t~post4.offset| 0) 
 (* ray_cstpncpy_~s~3.offset 0)
 (*
 |ray_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |ray_cstpncpy_#t~mem7| 0) 
 (* ray_cstpncpy_~d~3.base 0) 
 (* |ray_cstpncpy_#t~post5.base| 0)
 (* |ray_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (* ray_cstpncpy_~s~3.base 1) 
 (* |ray_(select #length cstpncpy_~s~3.base)| 0) 
 (* ray_cstpncpy_~n 0) (* |ray_cstpncpy_#t~post4.base| 0)
 (* |ray_cstpncpy_#t~post5.offset| 0)
 (* |ray_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* ray_cstpncpy_~d~3.offset 0) 
 (* |ray_cstpncpy_#t~post3| 0)) 0)
 (>=
 (+ (* (* |ray_cstpncpy_#t~mem0.offset| lambda) 0)
 (* (* |ray_(select #length cstpncpy_~d~3.base)| lambda) 0)
 (* (* |ray_cstpncpy_#t~post4.offset| lambda) 0)
 (* (* ray_cstpncpy_~s~3.offset lambda) 1)
 (*
 (*
 |ray_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 lambda) 0)
 (* (* |ray_(select old(#length) cstpncpy_#in~src.base)| lambda) 0)
 (* (* |ray_cstpncpy_~#dst.offset| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 lambda) 0) (* (* |ray_cstpncpy_#t~mem7| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 lambda) 0) (* (* ray_cstpncpy_~d~3.base lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 lambda) 0) (* (* |ray_(select #length cstpncpy_#in~src.base)| lambda) 0)
 (* (* |ray_cstpncpy_#in~src.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| lambda) 0)
 (* (* |ray_cstpncpy_#t~mem1.offset| lambda) 0)
 (* (* |ray_(select #length cstpncpy_#in~dst.base)| lambda) 0)
 (* (* |ray_cstpncpy_#t~mem0.base| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_cstpncpy_#in~n| lambda) 0)
 (* (* |ray_cstpncpy_#t~mem1.base| lambda) 0)
 (* (* |ray_cstpncpy_#t~post5.base| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(select old(#length) cstpncpy_~#dst.base)| lambda) 0)
 (* (* |ray_(ite (select #valid cstpncpy_~d~3.base) 1 0)| lambda) 0)
 (* (* ray_cstpncpy_~s~3.base lambda) 0)
 (*
 (*
 |ray_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 lambda) 0) (* (* |ray_(select #length cstpncpy_~s~3.base)| lambda) 0)
 (* (* ray_cstpncpy_~n lambda) 0)
 (* (* |ray_cstpncpy_#in~dst.base| lambda) 0)
 (* (* |ray_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length cstpncpy_~#dst.base)| lambda) 0)
 (* (* |ray_cstpncpy_#t~post4.base| lambda) 0)
 (* (* |ray_(ite (select #valid cstpncpy_~#dst.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) cstpncpy_#in~dst.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| lambda) 0)
 (* (* |ray_cstpncpy_#t~post5.offset| lambda) 0)
 (* (* |ray_(ite (select #valid cstpncpy_#in~src.base) 1 0)| lambda) 0)
 (* (* |ray_cstpncpy_#in~dst.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid cstpncpy_~s~3.base) 1 0)| lambda) 0)
 (* (* ray_cstpncpy_~src.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* ray_cstpncpy_~d~3.offset lambda) 0)
 (* (* |ray_cstpncpy_#t~post3| lambda) 0)
 (* (* |ray_cstpncpy_~#dst.base| lambda) 0)
 (* (* ray_cstpncpy_~src.offset lambda) 0)
 (* (* |ray_cstpncpy_#in~src.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| lambda) 0)
 (* |ray_(select #length cstpncpy_~d~3.base)| 0)
 (* |ray_cstpncpy_#t~post4.offset| 0) 
 (* ray_cstpncpy_~s~3.offset (- 1))
 (*
 |ray_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |ray_cstpncpy_#t~mem7| 0) 
 (* ray_cstpncpy_~d~3.base 0) 
 (* |ray_cstpncpy_#t~post5.base| 0)
 (* |ray_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (* ray_cstpncpy_~s~3.base 0) 
 (* |ray_(select #length cstpncpy_~s~3.base)| 0) 
 (* ray_cstpncpy_~n 0) (* |ray_cstpncpy_#t~post4.base| 0)
 (* |ray_cstpncpy_#t~post5.offset| 0)
 (* |ray_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* ray_cstpncpy_~d~3.offset 0) 
 (* |ray_cstpncpy_#t~post3| 0)) 0)
 (>=
 (+ (* (* |ray_cstpncpy_#t~mem0.offset| lambda) 0)
 (* (* |ray_(select #length cstpncpy_~d~3.base)| lambda) 0)
 (* (* |ray_cstpncpy_#t~post4.offset| lambda) 0)
 (* (* ray_cstpncpy_~s~3.offset lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 lambda) 0)
 (* (* |ray_(select old(#length) cstpncpy_#in~src.base)| lambda) 0)
 (* (* |ray_cstpncpy_~#dst.offset| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 lambda) 0) (* (* |ray_cstpncpy_#t~mem7| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 lambda) 0) (* (* ray_cstpncpy_~d~3.base lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 lambda) 0) (* (* |ray_(select #length cstpncpy_#in~src.base)| lambda) 0)
 (* (* |ray_cstpncpy_#in~src.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| lambda) 0)
 (* (* |ray_cstpncpy_#t~mem1.offset| lambda) 0)
 (* (* |ray_(select #length cstpncpy_#in~dst.base)| lambda) 0)
 (* (* |ray_cstpncpy_#t~mem0.base| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_cstpncpy_#in~n| lambda) 0)
 (* (* |ray_cstpncpy_#t~mem1.base| lambda) 0)
 (* (* |ray_cstpncpy_#t~post5.base| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(select old(#length) cstpncpy_~#dst.base)| lambda) 0)
 (* (* |ray_(ite (select #valid cstpncpy_~d~3.base) 1 0)| lambda) 0)
 (* (* ray_cstpncpy_~s~3.base lambda) 0)
 (*
 (*
 |ray_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 lambda) 0) (* (* |ray_(select #length cstpncpy_~s~3.base)| lambda) 0)
 (* (* ray_cstpncpy_~n lambda) 0)
 (* (* |ray_cstpncpy_#in~dst.base| lambda) 0)
 (* (* |ray_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length cstpncpy_~#dst.base)| lambda) 0)
 (* (* |ray_cstpncpy_#t~post4.base| lambda) 0)
 (* (* |ray_(ite (select #valid cstpncpy_~#dst.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) cstpncpy_#in~dst.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| lambda) 0)
 (* (* |ray_cstpncpy_#t~post5.offset| lambda) 0)
 (* (* |ray_(ite (select #valid cstpncpy_#in~src.base) 1 0)| lambda) 0)
 (* (* |ray_cstpncpy_#in~dst.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid cstpncpy_~s~3.base) 1 0)| lambda) 0)
 (* (* ray_cstpncpy_~src.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* ray_cstpncpy_~d~3.offset lambda) 0)
 (* (* |ray_cstpncpy_#t~post3| lambda) 0)
 (* (* |ray_cstpncpy_~#dst.base| lambda) 0)
 (* (* ray_cstpncpy_~src.offset lambda) 0)
 (* (* |ray_cstpncpy_#in~src.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| lambda) 0)
 (* |ray_(select #length cstpncpy_~d~3.base)| 0)
 (* |ray_cstpncpy_#t~post4.offset| 0) 
 (* ray_cstpncpy_~s~3.offset 0)
 (*
 |ray_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |ray_cstpncpy_#t~mem7| 0) 
 (* ray_cstpncpy_~d~3.base 0) 
 (* |ray_cstpncpy_#t~post5.base| 0)
 (* |ray_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (* ray_cstpncpy_~s~3.base 0) 
 (* |ray_(select #length cstpncpy_~s~3.base)| 0) 
 (* ray_cstpncpy_~n 0) (* |ray_cstpncpy_#t~post4.base| 0)
 (* |ray_cstpncpy_#t~post5.offset| 0)
 (* |ray_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 1)
 (* ray_cstpncpy_~d~3.offset 0) 
 (* |ray_cstpncpy_#t~post3| 0)) 0)
 (>=
 (+ (* (* |ray_cstpncpy_#t~mem0.offset| lambda) 0)
 (* (* |ray_(select #length cstpncpy_~d~3.base)| lambda) 0)
 (* (* |ray_cstpncpy_#t~post4.offset| lambda) 0)
 (* (* ray_cstpncpy_~s~3.offset lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 lambda) 0)
 (* (* |ray_(select old(#length) cstpncpy_#in~src.base)| lambda) 0)
 (* (* |ray_cstpncpy_~#dst.offset| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 lambda) 0) (* (* |ray_cstpncpy_#t~mem7| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 lambda) 0) (* (* ray_cstpncpy_~d~3.base lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 lambda) 0) (* (* |ray_(select #length cstpncpy_#in~src.base)| lambda) 0)
 (* (* |ray_cstpncpy_#in~src.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| lambda) 0)
 (* (* |ray_cstpncpy_#t~mem1.offset| lambda) 0)
 (* (* |ray_(select #length cstpncpy_#in~dst.base)| lambda) 0)
 (* (* |ray_cstpncpy_#t~mem0.base| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_cstpncpy_#in~n| lambda) 0)
 (* (* |ray_cstpncpy_#t~mem1.base| lambda) 0)
 (* (* |ray_cstpncpy_#t~post5.base| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(select old(#length) cstpncpy_~#dst.base)| lambda) 0)
 (* (* |ray_(ite (select #valid cstpncpy_~d~3.base) 1 0)| lambda) 0)
 (* (* ray_cstpncpy_~s~3.base lambda) 0)
 (*
 (*
 |ray_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 lambda) 0) (* (* |ray_(select #length cstpncpy_~s~3.base)| lambda) 0)
 (* (* ray_cstpncpy_~n lambda) 1)
 (* (* |ray_cstpncpy_#in~dst.base| lambda) 0)
 (* (* |ray_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length cstpncpy_~#dst.base)| lambda) 0)
 (* (* |ray_cstpncpy_#t~post4.base| lambda) 0)
 (* (* |ray_(ite (select #valid cstpncpy_~#dst.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) cstpncpy_#in~dst.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| lambda) 0)
 (* (* |ray_cstpncpy_#t~post5.offset| lambda) 0)
 (* (* |ray_(ite (select #valid cstpncpy_#in~src.base) 1 0)| lambda) 0)
 (* (* |ray_cstpncpy_#in~dst.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid cstpncpy_~s~3.base) 1 0)| lambda) 0)
 (* (* ray_cstpncpy_~src.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* ray_cstpncpy_~d~3.offset lambda) 0)
 (* (* |ray_cstpncpy_#t~post3| lambda) 0)
 (* (* |ray_cstpncpy_~#dst.base| lambda) 0)
 (* (* ray_cstpncpy_~src.offset lambda) 0)
 (* (* |ray_cstpncpy_#in~src.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| lambda) 0)
 (* |ray_(select #length cstpncpy_~d~3.base)| 0)
 (* |ray_cstpncpy_#t~post4.offset| 0) 
 (* ray_cstpncpy_~s~3.offset 0)
 (*
 |ray_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |ray_cstpncpy_#t~mem7| 0) 
 (* ray_cstpncpy_~d~3.base 0) 
 (* |ray_cstpncpy_#t~post5.base| 0)
 (* |ray_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (* ray_cstpncpy_~s~3.base 0) 
 (* |ray_(select #length cstpncpy_~s~3.base)| 0) 
 (* ray_cstpncpy_~n (- 1)) 
 (* |ray_cstpncpy_#t~post4.base| 0) 
 (* |ray_cstpncpy_#t~post5.offset| 0)
 (* |ray_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* ray_cstpncpy_~d~3.offset 0) 
 (* |ray_cstpncpy_#t~post3| 0)) 0)
 (>=
 (+ (* (* |ray_cstpncpy_#t~mem0.offset| lambda) 0)
 (* (* |ray_(select #length cstpncpy_~d~3.base)| lambda) 0)
 (* (* |ray_cstpncpy_#t~post4.offset| lambda) 0)
 (* (* ray_cstpncpy_~s~3.offset lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 lambda) 0)
 (* (* |ray_(select old(#length) cstpncpy_#in~src.base)| lambda) 0)
 (* (* |ray_cstpncpy_~#dst.offset| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 lambda) 0) (* (* |ray_cstpncpy_#t~mem7| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 lambda) 0) (* (* ray_cstpncpy_~d~3.base lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 lambda) 0) (* (* |ray_(select #length cstpncpy_#in~src.base)| lambda) 0)
 (* (* |ray_cstpncpy_#in~src.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| lambda) 0)
 (* (* |ray_cstpncpy_#t~mem1.offset| lambda) 0)
 (* (* |ray_(select #length cstpncpy_#in~dst.base)| lambda) 0)
 (* (* |ray_cstpncpy_#t~mem0.base| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_cstpncpy_#in~n| lambda) 0)
 (* (* |ray_cstpncpy_#t~mem1.base| lambda) 0)
 (* (* |ray_cstpncpy_#t~post5.base| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(select old(#length) cstpncpy_~#dst.base)| lambda) 0)
 (* (* |ray_(ite (select #valid cstpncpy_~d~3.base) 1 0)| lambda) 0)
 (* (* ray_cstpncpy_~s~3.base lambda) 0)
 (*
 (*
 |ray_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 lambda) 0) (* (* |ray_(select #length cstpncpy_~s~3.base)| lambda) 1)
 (* (* ray_cstpncpy_~n lambda) 0)
 (* (* |ray_cstpncpy_#in~dst.base| lambda) 0)
 (* (* |ray_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length cstpncpy_~#dst.base)| lambda) 0)
 (* (* |ray_cstpncpy_#t~post4.base| lambda) 0)
 (* (* |ray_(ite (select #valid cstpncpy_~#dst.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) cstpncpy_#in~dst.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| lambda) 0)
 (* (* |ray_cstpncpy_#t~post5.offset| lambda) 0)
 (* (* |ray_(ite (select #valid cstpncpy_#in~src.base) 1 0)| lambda) 0)
 (* (* |ray_cstpncpy_#in~dst.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid cstpncpy_~s~3.base) 1 0)| lambda) 0)
 (* (* ray_cstpncpy_~src.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* ray_cstpncpy_~d~3.offset lambda) 0)
 (* (* |ray_cstpncpy_#t~post3| lambda) 0)
 (* (* |ray_cstpncpy_~#dst.base| lambda) 0)
 (* (* ray_cstpncpy_~src.offset lambda) 0)
 (* (* |ray_cstpncpy_#in~src.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| lambda) 0)
 (* |ray_(select #length cstpncpy_~d~3.base)| 0)
 (* |ray_cstpncpy_#t~post4.offset| 0) 
 (* ray_cstpncpy_~s~3.offset 0)
 (*
 |ray_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |ray_cstpncpy_#t~mem7| 0) 
 (* ray_cstpncpy_~d~3.base 0) 
 (* |ray_cstpncpy_#t~post5.base| 0)
 (* |ray_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (* ray_cstpncpy_~s~3.base 0)
 (* |ray_(select #length cstpncpy_~s~3.base)| (- 1)) 
 (* ray_cstpncpy_~n 0) (* |ray_cstpncpy_#t~post4.base| 0)
 (* |ray_cstpncpy_#t~post5.offset| 0)
 (* |ray_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* ray_cstpncpy_~d~3.offset 0) 
 (* |ray_cstpncpy_#t~post3| 0)) 0)
 (>=
 (+ (* (* |ray_cstpncpy_#t~mem0.offset| lambda) 0)
 (* (* |ray_(select #length cstpncpy_~d~3.base)| lambda) 0)
 (* (* |ray_cstpncpy_#t~post4.offset| lambda) 0)
 (* (* ray_cstpncpy_~s~3.offset lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 lambda) 0)
 (* (* |ray_(select old(#length) cstpncpy_#in~src.base)| lambda) 0)
 (* (* |ray_cstpncpy_~#dst.offset| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 lambda) 0) (* (* |ray_cstpncpy_#t~mem7| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 lambda) 0) (* (* ray_cstpncpy_~d~3.base lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 lambda) 0) (* (* |ray_(select #length cstpncpy_#in~src.base)| lambda) 0)
 (* (* |ray_cstpncpy_#in~src.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| lambda) 0)
 (* (* |ray_cstpncpy_#t~mem1.offset| lambda) 0)
 (* (* |ray_(select #length cstpncpy_#in~dst.base)| lambda) 0)
 (* (* |ray_cstpncpy_#t~mem0.base| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_cstpncpy_#in~n| lambda) 0)
 (* (* |ray_cstpncpy_#t~mem1.base| lambda) 0)
 (* (* |ray_cstpncpy_#t~post5.base| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(select old(#length) cstpncpy_~#dst.base)| lambda) 0)
 (* (* |ray_(ite (select #valid cstpncpy_~d~3.base) 1 0)| lambda) 0)
 (* (* ray_cstpncpy_~s~3.base lambda) 0)
 (*
 (*
 |ray_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 lambda) 0) (* (* |ray_(select #length cstpncpy_~s~3.base)| lambda) 0)
 (* (* ray_cstpncpy_~n lambda) 0)
 (* (* |ray_cstpncpy_#in~dst.base| lambda) 0)
 (* (* |ray_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length cstpncpy_~#dst.base)| lambda) 0)
 (* (* |ray_cstpncpy_#t~post4.base| lambda) 0)
 (* (* |ray_(ite (select #valid cstpncpy_~#dst.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) cstpncpy_#in~dst.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| lambda) 0)
 (* (* |ray_cstpncpy_#t~post5.offset| lambda) 0)
 (* (* |ray_(ite (select #valid cstpncpy_#in~src.base) 1 0)| lambda) 0)
 (* (* |ray_cstpncpy_#in~dst.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid cstpncpy_~s~3.base) 1 0)| lambda) 0)
 (* (* ray_cstpncpy_~src.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* ray_cstpncpy_~d~3.offset lambda) 0)
 (* (* |ray_cstpncpy_#t~post3| lambda) 0)
 (* (* |ray_cstpncpy_~#dst.base| lambda) 0)
 (* (* ray_cstpncpy_~src.offset lambda) 0)
 (* (* |ray_cstpncpy_#in~src.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| lambda) 0)
 (* |ray_(select #length cstpncpy_~d~3.base)| 0)
 (* |ray_cstpncpy_#t~post4.offset| 0) 
 (* ray_cstpncpy_~s~3.offset 0)
 (*
 |ray_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 1) (* |ray_cstpncpy_#t~mem7| 0) 
 (* ray_cstpncpy_~d~3.base 0) 
 (* |ray_cstpncpy_#t~post5.base| 0)
 (* |ray_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (* ray_cstpncpy_~s~3.base 0) 
 (* |ray_(select #length cstpncpy_~s~3.base)| 0) 
 (* ray_cstpncpy_~n 0) (* |ray_cstpncpy_#t~post4.base| 0)
 (* |ray_cstpncpy_#t~post5.offset| 0)
 (* |ray_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* ray_cstpncpy_~d~3.offset 0) 
 (* |ray_cstpncpy_#t~post3| 0)) 0)
 (>=
 (+ (* (* |ray_cstpncpy_#t~mem0.offset| lambda) 0)
 (* (* |ray_(select #length cstpncpy_~d~3.base)| lambda) 0)
 (* (* |ray_cstpncpy_#t~post4.offset| lambda) 0)
 (* (* ray_cstpncpy_~s~3.offset lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 lambda) 0)
 (* (* |ray_(select old(#length) cstpncpy_#in~src.base)| lambda) 0)
 (* (* |ray_cstpncpy_~#dst.offset| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 lambda) 0) (* (* |ray_cstpncpy_#t~mem7| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 lambda) 0) (* (* ray_cstpncpy_~d~3.base lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 lambda) 0) (* (* |ray_(select #length cstpncpy_#in~src.base)| lambda) 0)
 (* (* |ray_cstpncpy_#in~src.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| lambda) 0)
 (* (* |ray_cstpncpy_#t~mem1.offset| lambda) 0)
 (* (* |ray_(select #length cstpncpy_#in~dst.base)| lambda) 0)
 (* (* |ray_cstpncpy_#t~mem0.base| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_cstpncpy_#in~n| lambda) 0)
 (* (* |ray_cstpncpy_#t~mem1.base| lambda) 0)
 (* (* |ray_cstpncpy_#t~post5.base| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(select old(#length) cstpncpy_~#dst.base)| lambda) 0)
 (* (* |ray_(ite (select #valid cstpncpy_~d~3.base) 1 0)| lambda) 0)
 (* (* ray_cstpncpy_~s~3.base lambda) 1)
 (*
 (*
 |ray_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 lambda) 0) (* (* |ray_(select #length cstpncpy_~s~3.base)| lambda) 0)
 (* (* ray_cstpncpy_~n lambda) 0)
 (* (* |ray_cstpncpy_#in~dst.base| lambda) 0)
 (* (* |ray_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length cstpncpy_~#dst.base)| lambda) 0)
 (* (* |ray_cstpncpy_#t~post4.base| lambda) 0)
 (* (* |ray_(ite (select #valid cstpncpy_~#dst.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) cstpncpy_#in~dst.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| lambda) 0)
 (* (* |ray_cstpncpy_#t~post5.offset| lambda) 0)
 (* (* |ray_(ite (select #valid cstpncpy_#in~src.base) 1 0)| lambda) 0)
 (* (* |ray_cstpncpy_#in~dst.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid cstpncpy_~s~3.base) 1 0)| lambda) 0)
 (* (* ray_cstpncpy_~src.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* ray_cstpncpy_~d~3.offset lambda) 0)
 (* (* |ray_cstpncpy_#t~post3| lambda) 0)
 (* (* |ray_cstpncpy_~#dst.base| lambda) 0)
 (* (* ray_cstpncpy_~src.offset lambda) 0)
 (* (* |ray_cstpncpy_#in~src.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| lambda) 0)
 (* |ray_(select #length cstpncpy_~d~3.base)| 0)
 (* |ray_cstpncpy_#t~post4.offset| 0) 
 (* ray_cstpncpy_~s~3.offset 0)
 (*
 |ray_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |ray_cstpncpy_#t~mem7| 0) 
 (* ray_cstpncpy_~d~3.base 0) 
 (* |ray_cstpncpy_#t~post5.base| 0)
 (* |ray_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (* ray_cstpncpy_~s~3.base (- 1))
 (* |ray_(select #length cstpncpy_~s~3.base)| 0) 
 (* ray_cstpncpy_~n 0) (* |ray_cstpncpy_#t~post4.base| 0)
 (* |ray_cstpncpy_#t~post5.offset| 0)
 (* |ray_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* ray_cstpncpy_~d~3.offset 0) 
 (* |ray_cstpncpy_#t~post3| 0)) 0)
 (>=
 (+ (* (* |ray_cstpncpy_#t~mem0.offset| lambda) 0)
 (* (* |ray_(select #length cstpncpy_~d~3.base)| lambda) 0)
 (* (* |ray_cstpncpy_#t~post4.offset| lambda) 0)
 (* (* ray_cstpncpy_~s~3.offset lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 lambda) 0)
 (* (* |ray_(select old(#length) cstpncpy_#in~src.base)| lambda) 0)
 (* (* |ray_cstpncpy_~#dst.offset| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 lambda) 0) (* (* |ray_cstpncpy_#t~mem7| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 lambda) 0) (* (* ray_cstpncpy_~d~3.base lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 lambda) 0) (* (* |ray_(select #length cstpncpy_#in~src.base)| lambda) 0)
 (* (* |ray_cstpncpy_#in~src.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| lambda) 0)
 (* (* |ray_cstpncpy_#t~mem1.offset| lambda) 0)
 (* (* |ray_(select #length cstpncpy_#in~dst.base)| lambda) 0)
 (* (* |ray_cstpncpy_#t~mem0.base| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_cstpncpy_#in~n| lambda) 0)
 (* (* |ray_cstpncpy_#t~mem1.base| lambda) 0)
 (* (* |ray_cstpncpy_#t~post5.base| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(select old(#length) cstpncpy_~#dst.base)| lambda) 0)
 (* (* |ray_(ite (select #valid cstpncpy_~d~3.base) 1 0)| lambda) 0)
 (* (* ray_cstpncpy_~s~3.base lambda) 0)
 (*
 (*
 |ray_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 lambda) 0) (* (* |ray_(select #length cstpncpy_~s~3.base)| lambda) 0)
 (* (* ray_cstpncpy_~n lambda) 0)
 (* (* |ray_cstpncpy_#in~dst.base| lambda) 0)
 (* (* |ray_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length cstpncpy_~#dst.base)| lambda) 0)
 (* (* |ray_cstpncpy_#t~post4.base| lambda) 0)
 (* (* |ray_(ite (select #valid cstpncpy_~#dst.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) cstpncpy_#in~dst.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| lambda) 0)
 (* (* |ray_cstpncpy_#t~post5.offset| lambda) 0)
 (* (* |ray_(ite (select #valid cstpncpy_#in~src.base) 1 0)| lambda) 0)
 (* (* |ray_cstpncpy_#in~dst.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid cstpncpy_~s~3.base) 1 0)| lambda) 0)
 (* (* ray_cstpncpy_~src.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* ray_cstpncpy_~d~3.offset lambda) 0)
 (* (* |ray_cstpncpy_#t~post3| lambda) 0)
 (* (* |ray_cstpncpy_~#dst.base| lambda) 0)
 (* (* ray_cstpncpy_~src.offset lambda) 0)
 (* (* |ray_cstpncpy_#in~src.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| lambda) 0)
 (* |ray_(select #length cstpncpy_~d~3.base)| 1)
 (* |ray_cstpncpy_#t~post4.offset| 0) 
 (* ray_cstpncpy_~s~3.offset 0)
 (*
 |ray_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |ray_cstpncpy_#t~mem7| 0) 
 (* ray_cstpncpy_~d~3.base 0) 
 (* |ray_cstpncpy_#t~post5.base| 0)
 (* |ray_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (* ray_cstpncpy_~s~3.base 0) 
 (* |ray_(select #length cstpncpy_~s~3.base)| 0) 
 (* ray_cstpncpy_~n 0) (* |ray_cstpncpy_#t~post4.base| 0)
 (* |ray_cstpncpy_#t~post5.offset| 0)
 (* |ray_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* ray_cstpncpy_~d~3.offset (- 1)) 
 (* |ray_cstpncpy_#t~post3| 0)) 0)
 (>=
 (+ (* (* |ray_cstpncpy_#t~mem0.offset| lambda) 0)
 (* (* |ray_(select #length cstpncpy_~d~3.base)| lambda) 0)
 (* (* |ray_cstpncpy_#t~post4.offset| lambda) 0)
 (* (* ray_cstpncpy_~s~3.offset lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 lambda) 0)
 (* (* |ray_(select old(#length) cstpncpy_#in~src.base)| lambda) 0)
 (* (* |ray_cstpncpy_~#dst.offset| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 lambda) 0) (* (* |ray_cstpncpy_#t~mem7| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 lambda) 0) (* (* ray_cstpncpy_~d~3.base lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 lambda) 0) (* (* |ray_(select #length cstpncpy_#in~src.base)| lambda) 0)
 (* (* |ray_cstpncpy_#in~src.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| lambda) 0)
 (* (* |ray_cstpncpy_#t~mem1.offset| lambda) 0)
 (* (* |ray_(select #length cstpncpy_#in~dst.base)| lambda) 0)
 (* (* |ray_cstpncpy_#t~mem0.base| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_cstpncpy_#in~n| lambda) 0)
 (* (* |ray_cstpncpy_#t~mem1.base| lambda) 0)
 (* (* |ray_cstpncpy_#t~post5.base| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(select old(#length) cstpncpy_~#dst.base)| lambda) 0)
 (* (* |ray_(ite (select #valid cstpncpy_~d~3.base) 1 0)| lambda) 0)
 (* (* ray_cstpncpy_~s~3.base lambda) 0)
 (*
 (*
 |ray_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 lambda) 0) (* (* |ray_(select #length cstpncpy_~s~3.base)| lambda) 0)
 (* (* ray_cstpncpy_~n lambda) 0)
 (* (* |ray_cstpncpy_#in~dst.base| lambda) 0)
 (* (* |ray_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length cstpncpy_~#dst.base)| lambda) 0)
 (* (* |ray_cstpncpy_#t~post4.base| lambda) 0)
 (* (* |ray_(ite (select #valid cstpncpy_~#dst.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) cstpncpy_#in~dst.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| lambda) 0)
 (* (* |ray_cstpncpy_#t~post5.offset| lambda) 0)
 (* (* |ray_(ite (select #valid cstpncpy_#in~src.base) 1 0)| lambda) 0)
 (* (* |ray_cstpncpy_#in~dst.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid cstpncpy_~s~3.base) 1 0)| lambda) 0)
 (* (* ray_cstpncpy_~src.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* ray_cstpncpy_~d~3.offset lambda) 0)
 (* (* |ray_cstpncpy_#t~post3| lambda) 0)
 (* (* |ray_cstpncpy_~#dst.base| lambda) 0)
 (* (* ray_cstpncpy_~src.offset lambda) 0)
 (* (* |ray_cstpncpy_#in~src.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| lambda) 0)
 (* |ray_(select #length cstpncpy_~d~3.base)| 0)
 (* |ray_cstpncpy_#t~post4.offset| 0) 
 (* ray_cstpncpy_~s~3.offset 0)
 (*
 |ray_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |ray_cstpncpy_#t~mem7| 0) 
 (* ray_cstpncpy_~d~3.base 0) 
 (* |ray_cstpncpy_#t~post5.base| 0)
 (* |ray_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 1)
 (* ray_cstpncpy_~s~3.base 0) 
 (* |ray_(select #length cstpncpy_~s~3.base)| 0) 
 (* ray_cstpncpy_~n 0) (* |ray_cstpncpy_#t~post4.base| 0)
 (* |ray_cstpncpy_#t~post5.offset| 0)
 (* |ray_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* ray_cstpncpy_~d~3.offset 0) 
 (* |ray_cstpncpy_#t~post3| 0)) 0)
 (>=
 (+ (* (* |ray_cstpncpy_#t~mem0.offset| lambda) 0)
 (* (* |ray_(select #length cstpncpy_~d~3.base)| lambda) 0)
 (* (* |ray_cstpncpy_#t~post4.offset| lambda) 0)
 (* (* ray_cstpncpy_~s~3.offset lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 lambda) 0)
 (* (* |ray_(select old(#length) cstpncpy_#in~src.base)| lambda) 0)
 (* (* |ray_cstpncpy_~#dst.offset| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 lambda) 0) (* (* |ray_cstpncpy_#t~mem7| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 lambda) 0) (* (* ray_cstpncpy_~d~3.base lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 lambda) 0) (* (* |ray_(select #length cstpncpy_#in~src.base)| lambda) 0)
 (* (* |ray_cstpncpy_#in~src.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| lambda) 0)
 (* (* |ray_cstpncpy_#t~mem1.offset| lambda) 0)
 (* (* |ray_(select #length cstpncpy_#in~dst.base)| lambda) 0)
 (* (* |ray_cstpncpy_#t~mem0.base| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_cstpncpy_#in~n| lambda) 0)
 (* (* |ray_cstpncpy_#t~mem1.base| lambda) 0)
 (* (* |ray_cstpncpy_#t~post5.base| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(select old(#length) cstpncpy_~#dst.base)| lambda) 0)
 (* (* |ray_(ite (select #valid cstpncpy_~d~3.base) 1 0)| lambda) 0)
 (* (* ray_cstpncpy_~s~3.base lambda) 0)
 (*
 (*
 |ray_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 lambda) 0) (* (* |ray_(select #length cstpncpy_~s~3.base)| lambda) 0)
 (* (* ray_cstpncpy_~n lambda) 0)
 (* (* |ray_cstpncpy_#in~dst.base| lambda) 0)
 (* (* |ray_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length cstpncpy_~#dst.base)| lambda) 0)
 (* (* |ray_cstpncpy_#t~post4.base| lambda) 0)
 (* (* |ray_(ite (select #valid cstpncpy_~#dst.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) cstpncpy_#in~dst.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| lambda) 0)
 (* (* |ray_cstpncpy_#t~post5.offset| lambda) 0)
 (* (* |ray_(ite (select #valid cstpncpy_#in~src.base) 1 0)| lambda) 0)
 (* (* |ray_cstpncpy_#in~dst.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid cstpncpy_~s~3.base) 1 0)| lambda) 0)
 (* (* ray_cstpncpy_~src.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* ray_cstpncpy_~d~3.offset lambda) 0)
 (* (* |ray_cstpncpy_#t~post3| lambda) 0)
 (* (* |ray_cstpncpy_~#dst.base| lambda) 0)
 (* (* ray_cstpncpy_~src.offset lambda) 0)
 (* (* |ray_cstpncpy_#in~src.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| lambda) 0)
 (* |ray_(select #length cstpncpy_~d~3.base)| 0)
 (* |ray_cstpncpy_#t~post4.offset| 0) 
 (* ray_cstpncpy_~s~3.offset 0)
 (*
 |ray_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |ray_cstpncpy_#t~mem7| 0) 
 (* ray_cstpncpy_~d~3.base 0) 
 (* |ray_cstpncpy_#t~post5.base| 0)
 (* |ray_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (* ray_cstpncpy_~s~3.base 0) 
 (* |ray_(select #length cstpncpy_~s~3.base)| 0) 
 (* ray_cstpncpy_~n 0) (* |ray_cstpncpy_#t~post4.base| 0)
 (* |ray_cstpncpy_#t~post5.offset| 0)
 (* |ray_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* ray_cstpncpy_~d~3.offset 0) 
 (* |ray_cstpncpy_#t~post3| 0) 
 (* aux_3691 (- 1)) (* aux_3686 1)) 0) 
 (= lambda lambda))
 (and
 (= |honda_cstpncpy_#t~mem0.offset|
 (+ |honda_cstpncpy_#t~mem0.offset| |ray_cstpncpy_#t~mem0.offset|))
 (=
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 (+
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 |ray_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|))
 (= |honda_(select old(#length) cstpncpy_#in~src.base)|
 (+ |honda_(select old(#length) cstpncpy_#in~src.base)|
 |ray_(select old(#length) cstpncpy_#in~src.base)|))
 (= |honda_cstpncpy_~#dst.offset|
 (+ |honda_cstpncpy_~#dst.offset| |ray_cstpncpy_~#dst.offset|))
 (=
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 (+
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 |ray_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|))
 (=
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 (+
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 |ray_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|))
 (= |honda_(select #length cstpncpy_#in~src.base)|
 (+ |honda_(select #length cstpncpy_#in~src.base)|
 |ray_(select #length cstpncpy_#in~src.base)|))
 (= |honda_cstpncpy_#in~src.offset|
 (+ |honda_cstpncpy_#in~src.offset| |ray_cstpncpy_#in~src.offset|))
 (= |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)|
 (+ |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)|
 |ray_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)|))
 (= |honda_cstpncpy_#t~mem1.offset|
 (+ |honda_cstpncpy_#t~mem1.offset| |ray_cstpncpy_#t~mem1.offset|))
 (= |honda_(select #length cstpncpy_#in~dst.base)|
 (+ |honda_(select #length cstpncpy_#in~dst.base)|
 |ray_(select #length cstpncpy_#in~dst.base)|))
 (= |honda_cstpncpy_#t~mem0.base|
 (+ |honda_cstpncpy_#t~mem0.base| |ray_cstpncpy_#t~mem0.base|))
 (=
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 (+
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 |ray_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|))
 (= |honda_#NULL.offset| (+ |honda_#NULL.offset| |ray_#NULL.offset|))
 (= |honda_cstpncpy_#in~n| (+ |honda_cstpncpy_#in~n| |ray_cstpncpy_#in~n|))
 (= |honda_cstpncpy_#t~mem1.base|
 (+ |honda_cstpncpy_#t~mem1.base| |ray_cstpncpy_#t~mem1.base|))
 (= |honda_#NULL.base| (+ |honda_#NULL.base| |ray_#NULL.base|))
 (= |honda_(select old(#length) cstpncpy_~#dst.base)|
 (+ |honda_(select old(#length) cstpncpy_~#dst.base)|
 |ray_(select old(#length) cstpncpy_~#dst.base)|))
 (=
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 (+
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 |ray_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|))
 (= |honda_cstpncpy_#in~dst.base|
 (+ |honda_cstpncpy_#in~dst.base| |ray_cstpncpy_#in~dst.base|))
 (= |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)|
 (+ |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)|
 |ray_(ite (select #valid cstpncpy_#in~dst.base) 1 0)|))
 (= |honda_(select #length cstpncpy_~#dst.base)|
 (+ |honda_(select #length cstpncpy_~#dst.base)|
 |ray_(select #length cstpncpy_~#dst.base)|))
 (= |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)|
 (+ |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)|
 |ray_(ite (select #valid cstpncpy_~#dst.base) 1 0)|))
 (= |honda_(select old(#length) cstpncpy_#in~dst.base)|
 (+ |honda_(select old(#length) cstpncpy_#in~dst.base)|
 |ray_(select old(#length) cstpncpy_#in~dst.base)|))
 (= |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)|
 (+ |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)|
 |ray_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)|))
 (= |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)|
 (+ |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)|
 |ray_(ite (select #valid cstpncpy_#in~src.base) 1 0)|))
 (= |honda_cstpncpy_#in~dst.offset|
 (+ |honda_cstpncpy_#in~dst.offset| |ray_cstpncpy_#in~dst.offset|))
 (= |honda_(ite (select #valid 0) 1 0)|
 (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|))
 (= honda_cstpncpy_~src.base
 (+ honda_cstpncpy_~src.base ray_cstpncpy_~src.base))
 (= |honda_(ite (select old(#valid) 0) 1 0)|
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|))
 (= |honda_cstpncpy_~#dst.base|
 (+ |honda_cstpncpy_~#dst.base| |ray_cstpncpy_~#dst.base|))
 (= honda_cstpncpy_~src.offset
 (+ honda_cstpncpy_~src.offset ray_cstpncpy_~src.offset))
 (= |honda_cstpncpy_#in~src.base|
 (+ |honda_cstpncpy_#in~src.base| |ray_cstpncpy_#in~src.base|))
 (=
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 (+
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 |ray_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|))
 (= |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)|
 (+ |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)|
 |ray_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)|))
 (>=
 (+ (* (+ |honda_cstpncpy_#t~mem0.offset| |ray_cstpncpy_#t~mem0.offset|) 0)
 (*
 (+ |honda_(select #length cstpncpy_~d~3.base)|
 |ray_(select #length cstpncpy_~d~3.base)|) 0)
 (* (+ |honda_cstpncpy_#t~post4.offset| |ray_cstpncpy_#t~post4.offset|) 0)
 (* (+ honda_cstpncpy_~s~3.offset ray_cstpncpy_~s~3.offset) 0)
 (*
 (+
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 |ray_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|)
 0)
 (*
 (+ |honda_(select old(#length) cstpncpy_#in~src.base)|
 |ray_(select old(#length) cstpncpy_#in~src.base)|) 0)
 (* (+ |honda_cstpncpy_~#dst.offset| |ray_cstpncpy_~#dst.offset|) 0)
 (*
 (+
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 |ray_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|)
 0) (* (+ |honda_cstpncpy_#t~mem7| |ray_cstpncpy_#t~mem7|) 0)
 (*
 (+
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 |ray_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|)
 0) (* (+ honda_cstpncpy_~d~3.base ray_cstpncpy_~d~3.base) 0)
 (*
 (+
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 |ray_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|)
 0)
 (*
 (+ |honda_(select #length cstpncpy_#in~src.base)|
 |ray_(select #length cstpncpy_#in~src.base)|) 0)
 (* (+ |honda_cstpncpy_#in~src.offset| |ray_cstpncpy_#in~src.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)|
 |ray_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)|) 0)
 (* (+ |honda_cstpncpy_#t~mem1.offset| |ray_cstpncpy_#t~mem1.offset|) 0)
 (*
 (+ |honda_(select #length cstpncpy_#in~dst.base)|
 |ray_(select #length cstpncpy_#in~dst.base)|) 0)
 (* (+ |honda_cstpncpy_#t~mem0.base| |ray_cstpncpy_#t~mem0.base|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 |ray_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|)
 0) (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_cstpncpy_#in~n| |ray_cstpncpy_#in~n|) 0)
 (* (+ |honda_cstpncpy_#t~mem1.base| |ray_cstpncpy_#t~mem1.base|) 0)
 (* (+ |honda_cstpncpy_#t~post5.base| |ray_cstpncpy_#t~post5.base|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(select old(#length) cstpncpy_~#dst.base)|
 |ray_(select old(#length) cstpncpy_~#dst.base)|) 0)
 (*
 (+ |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)|
 |ray_(ite (select #valid cstpncpy_~d~3.base) 1 0)|) 0)
 (* (+ honda_cstpncpy_~s~3.base ray_cstpncpy_~s~3.base) 0)
 (*
 (+
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 |ray_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|)
 0)
 (*
 (+ |honda_(select #length cstpncpy_~s~3.base)|
 |ray_(select #length cstpncpy_~s~3.base)|) 
 (- 1)) (* (+ honda_cstpncpy_~n ray_cstpncpy_~n) 0)
 (* (+ |honda_cstpncpy_#in~dst.base| |ray_cstpncpy_#in~dst.base|) 0)
 (*
 (+ |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)|
 |ray_(ite (select #valid cstpncpy_#in~dst.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length cstpncpy_~#dst.base)|
 |ray_(select #length cstpncpy_~#dst.base)|) 0)
 (* (+ |honda_cstpncpy_#t~post4.base| |ray_cstpncpy_#t~post4.base|) 0)
 (*
 (+ |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)|
 |ray_(ite (select #valid cstpncpy_~#dst.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) cstpncpy_#in~dst.base)|
 |ray_(select old(#length) cstpncpy_#in~dst.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)|
 |ray_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)|) 0)
 (* (+ |honda_cstpncpy_#t~post5.offset| |ray_cstpncpy_#t~post5.offset|) 0)
 (*
 (+ |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)|
 |ray_(ite (select #valid cstpncpy_#in~src.base) 1 0)|) 0)
 (* (+ |honda_cstpncpy_#in~dst.offset| |ray_cstpncpy_#in~dst.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)|
 |ray_(ite (select #valid cstpncpy_~s~3.base) 1 0)|) 0)
 (* (+ honda_cstpncpy_~src.base ray_cstpncpy_~src.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ honda_cstpncpy_~d~3.offset ray_cstpncpy_~d~3.offset) 0)
 (* (+ |honda_cstpncpy_#t~post3| |ray_cstpncpy_#t~post3|) 0)
 (* (+ |honda_cstpncpy_~#dst.base| |ray_cstpncpy_~#dst.base|) 0)
 (* (+ honda_cstpncpy_~src.offset ray_cstpncpy_~src.offset) 0)
 (* (+ |honda_cstpncpy_#in~src.base| |ray_cstpncpy_#in~src.base|) 0)
 (*
 (+
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 |ray_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)|
 |ray_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)|) 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0) 
 (* honda_cstpncpy_~d~3.base 0) 
 (* |honda_cstpncpy_#t~post5.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(select #length cstpncpy_~s~3.base)| 1) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 0) 0)
 (>=
 (+ (* (+ |honda_cstpncpy_#t~mem0.offset| |ray_cstpncpy_#t~mem0.offset|) 0)
 (*
 (+ |honda_(select #length cstpncpy_~d~3.base)|
 |ray_(select #length cstpncpy_~d~3.base)|) 0)
 (* (+ |honda_cstpncpy_#t~post4.offset| |ray_cstpncpy_#t~post4.offset|) 0)
 (* (+ honda_cstpncpy_~s~3.offset ray_cstpncpy_~s~3.offset) 0)
 (*
 (+
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 |ray_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|)
 0)
 (*
 (+ |honda_(select old(#length) cstpncpy_#in~src.base)|
 |ray_(select old(#length) cstpncpy_#in~src.base)|) 0)
 (* (+ |honda_cstpncpy_~#dst.offset| |ray_cstpncpy_~#dst.offset|) 0)
 (*
 (+
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 |ray_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|)
 0) (* (+ |honda_cstpncpy_#t~mem7| |ray_cstpncpy_#t~mem7|) 0)
 (*
 (+
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 |ray_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|)
 0) (* (+ honda_cstpncpy_~d~3.base ray_cstpncpy_~d~3.base) (- 1))
 (*
 (+
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 |ray_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|)
 0)
 (*
 (+ |honda_(select #length cstpncpy_#in~src.base)|
 |ray_(select #length cstpncpy_#in~src.base)|) 0)
 (* (+ |honda_cstpncpy_#in~src.offset| |ray_cstpncpy_#in~src.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)|
 |ray_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)|) 0)
 (* (+ |honda_cstpncpy_#t~mem1.offset| |ray_cstpncpy_#t~mem1.offset|) 0)
 (*
 (+ |honda_(select #length cstpncpy_#in~dst.base)|
 |ray_(select #length cstpncpy_#in~dst.base)|) 0)
 (* (+ |honda_cstpncpy_#t~mem0.base| |ray_cstpncpy_#t~mem0.base|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 |ray_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|)
 0) (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_cstpncpy_#in~n| |ray_cstpncpy_#in~n|) 0)
 (* (+ |honda_cstpncpy_#t~mem1.base| |ray_cstpncpy_#t~mem1.base|) 0)
 (* (+ |honda_cstpncpy_#t~post5.base| |ray_cstpncpy_#t~post5.base|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(select old(#length) cstpncpy_~#dst.base)|
 |ray_(select old(#length) cstpncpy_~#dst.base)|) 0)
 (*
 (+ |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)|
 |ray_(ite (select #valid cstpncpy_~d~3.base) 1 0)|) 0)
 (* (+ honda_cstpncpy_~s~3.base ray_cstpncpy_~s~3.base) 0)
 (*
 (+
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 |ray_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|)
 0)
 (*
 (+ |honda_(select #length cstpncpy_~s~3.base)|
 |ray_(select #length cstpncpy_~s~3.base)|) 0)
 (* (+ honda_cstpncpy_~n ray_cstpncpy_~n) 0)
 (* (+ |honda_cstpncpy_#in~dst.base| |ray_cstpncpy_#in~dst.base|) 0)
 (*
 (+ |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)|
 |ray_(ite (select #valid cstpncpy_#in~dst.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length cstpncpy_~#dst.base)|
 |ray_(select #length cstpncpy_~#dst.base)|) 0)
 (* (+ |honda_cstpncpy_#t~post4.base| |ray_cstpncpy_#t~post4.base|) 0)
 (*
 (+ |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)|
 |ray_(ite (select #valid cstpncpy_~#dst.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) cstpncpy_#in~dst.base)|
 |ray_(select old(#length) cstpncpy_#in~dst.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)|
 |ray_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)|) 0)
 (* (+ |honda_cstpncpy_#t~post5.offset| |ray_cstpncpy_#t~post5.offset|) 0)
 (*
 (+ |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)|
 |ray_(ite (select #valid cstpncpy_#in~src.base) 1 0)|) 0)
 (* (+ |honda_cstpncpy_#in~dst.offset| |ray_cstpncpy_#in~dst.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)|
 |ray_(ite (select #valid cstpncpy_~s~3.base) 1 0)|) 0)
 (* (+ honda_cstpncpy_~src.base ray_cstpncpy_~src.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ honda_cstpncpy_~d~3.offset ray_cstpncpy_~d~3.offset) 0)
 (* (+ |honda_cstpncpy_#t~post3| |ray_cstpncpy_#t~post3|) 0)
 (* (+ |honda_cstpncpy_~#dst.base| |ray_cstpncpy_~#dst.base|) 0)
 (* (+ honda_cstpncpy_~src.offset ray_cstpncpy_~src.offset) 0)
 (* (+ |honda_cstpncpy_#in~src.base| |ray_cstpncpy_#in~src.base|) 0)
 (*
 (+
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 |ray_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)|
 |ray_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)|) 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0) 
 (* honda_cstpncpy_~d~3.base 1) 
 (* |honda_cstpncpy_#t~post5.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 0) 0)
 (>=
 (+ (* (+ |honda_cstpncpy_#t~mem0.offset| |ray_cstpncpy_#t~mem0.offset|) 0)
 (*
 (+ |honda_(select #length cstpncpy_~d~3.base)|
 |ray_(select #length cstpncpy_~d~3.base)|) 0)
 (* (+ |honda_cstpncpy_#t~post4.offset| |ray_cstpncpy_#t~post4.offset|) 0)
 (* (+ honda_cstpncpy_~s~3.offset ray_cstpncpy_~s~3.offset) 0)
 (*
 (+
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 |ray_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|)
 0)
 (*
 (+ |honda_(select old(#length) cstpncpy_#in~src.base)|
 |ray_(select old(#length) cstpncpy_#in~src.base)|) 0)
 (* (+ |honda_cstpncpy_~#dst.offset| |ray_cstpncpy_~#dst.offset|) 0)
 (*
 (+
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 |ray_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|)
 0) (* (+ |honda_cstpncpy_#t~mem7| |ray_cstpncpy_#t~mem7|) 0)
 (*
 (+
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 |ray_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|)
 0) (* (+ honda_cstpncpy_~d~3.base ray_cstpncpy_~d~3.base) 0)
 (*
 (+
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 |ray_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|)
 0)
 (*
 (+ |honda_(select #length cstpncpy_#in~src.base)|
 |ray_(select #length cstpncpy_#in~src.base)|) 0)
 (* (+ |honda_cstpncpy_#in~src.offset| |ray_cstpncpy_#in~src.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)|
 |ray_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)|) 0)
 (* (+ |honda_cstpncpy_#t~mem1.offset| |ray_cstpncpy_#t~mem1.offset|) 0)
 (*
 (+ |honda_(select #length cstpncpy_#in~dst.base)|
 |ray_(select #length cstpncpy_#in~dst.base)|) 0)
 (* (+ |honda_cstpncpy_#t~mem0.base| |ray_cstpncpy_#t~mem0.base|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 |ray_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|)
 0) (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_cstpncpy_#in~n| |ray_cstpncpy_#in~n|) 0)
 (* (+ |honda_cstpncpy_#t~mem1.base| |ray_cstpncpy_#t~mem1.base|) 0)
 (* (+ |honda_cstpncpy_#t~post5.base| |ray_cstpncpy_#t~post5.base|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(select old(#length) cstpncpy_~#dst.base)|
 |ray_(select old(#length) cstpncpy_~#dst.base)|) 0)
 (*
 (+ |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)|
 |ray_(ite (select #valid cstpncpy_~d~3.base) 1 0)|) 0)
 (* (+ honda_cstpncpy_~s~3.base ray_cstpncpy_~s~3.base) 0)
 (*
 (+
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 |ray_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|)
 0)
 (*
 (+ |honda_(select #length cstpncpy_~s~3.base)|
 |ray_(select #length cstpncpy_~s~3.base)|) 0)
 (* (+ honda_cstpncpy_~n ray_cstpncpy_~n) 0)
 (* (+ |honda_cstpncpy_#in~dst.base| |ray_cstpncpy_#in~dst.base|) 0)
 (*
 (+ |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)|
 |ray_(ite (select #valid cstpncpy_#in~dst.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length cstpncpy_~#dst.base)|
 |ray_(select #length cstpncpy_~#dst.base)|) 0)
 (* (+ |honda_cstpncpy_#t~post4.base| |ray_cstpncpy_#t~post4.base|) 0)
 (*
 (+ |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)|
 |ray_(ite (select #valid cstpncpy_~#dst.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) cstpncpy_#in~dst.base)|
 |ray_(select old(#length) cstpncpy_#in~dst.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)|
 |ray_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)|) 0)
 (* (+ |honda_cstpncpy_#t~post5.offset| |ray_cstpncpy_#t~post5.offset|) 0)
 (*
 (+ |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)|
 |ray_(ite (select #valid cstpncpy_#in~src.base) 1 0)|) 0)
 (* (+ |honda_cstpncpy_#in~dst.offset| |ray_cstpncpy_#in~dst.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)|
 |ray_(ite (select #valid cstpncpy_~s~3.base) 1 0)|) 0)
 (* (+ honda_cstpncpy_~src.base ray_cstpncpy_~src.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ honda_cstpncpy_~d~3.offset ray_cstpncpy_~d~3.offset) (- 1))
 (* (+ |honda_cstpncpy_#t~post3| |ray_cstpncpy_#t~post3|) 0)
 (* (+ |honda_cstpncpy_~#dst.base| |ray_cstpncpy_~#dst.base|) 0)
 (* (+ honda_cstpncpy_~src.offset ray_cstpncpy_~src.offset) 0)
 (* (+ |honda_cstpncpy_#in~src.base| |ray_cstpncpy_#in~src.base|) 0)
 (*
 (+
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 |ray_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)|
 |ray_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)|) 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0) 
 (* honda_cstpncpy_~d~3.base 0) 
 (* |honda_cstpncpy_#t~post5.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 1) 
 (* |honda_cstpncpy_#t~post3| 0) 1) 0)
 (>=
 (+ (* (+ |honda_cstpncpy_#t~mem0.offset| |ray_cstpncpy_#t~mem0.offset|) 0)
 (*
 (+ |honda_(select #length cstpncpy_~d~3.base)|
 |ray_(select #length cstpncpy_~d~3.base)|) 0)
 (* (+ |honda_cstpncpy_#t~post4.offset| |ray_cstpncpy_#t~post4.offset|) 0)
 (* (+ honda_cstpncpy_~s~3.offset ray_cstpncpy_~s~3.offset) 0)
 (*
 (+
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 |ray_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|)
 0)
 (*
 (+ |honda_(select old(#length) cstpncpy_#in~src.base)|
 |ray_(select old(#length) cstpncpy_#in~src.base)|) 0)
 (* (+ |honda_cstpncpy_~#dst.offset| |ray_cstpncpy_~#dst.offset|) 0)
 (*
 (+
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 |ray_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|)
 0) (* (+ |honda_cstpncpy_#t~mem7| |ray_cstpncpy_#t~mem7|) 0)
 (*
 (+
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 |ray_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|)
 0) (* (+ honda_cstpncpy_~d~3.base ray_cstpncpy_~d~3.base) 0)
 (*
 (+
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 |ray_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|)
 0)
 (*
 (+ |honda_(select #length cstpncpy_#in~src.base)|
 |ray_(select #length cstpncpy_#in~src.base)|) 0)
 (* (+ |honda_cstpncpy_#in~src.offset| |ray_cstpncpy_#in~src.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)|
 |ray_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)|) 0)
 (* (+ |honda_cstpncpy_#t~mem1.offset| |ray_cstpncpy_#t~mem1.offset|) 0)
 (*
 (+ |honda_(select #length cstpncpy_#in~dst.base)|
 |ray_(select #length cstpncpy_#in~dst.base)|) 0)
 (* (+ |honda_cstpncpy_#t~mem0.base| |ray_cstpncpy_#t~mem0.base|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 |ray_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|)
 0) (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_cstpncpy_#in~n| |ray_cstpncpy_#in~n|) 0)
 (* (+ |honda_cstpncpy_#t~mem1.base| |ray_cstpncpy_#t~mem1.base|) 0)
 (* (+ |honda_cstpncpy_#t~post5.base| |ray_cstpncpy_#t~post5.base|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(select old(#length) cstpncpy_~#dst.base)|
 |ray_(select old(#length) cstpncpy_~#dst.base)|) 0)
 (*
 (+ |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)|
 |ray_(ite (select #valid cstpncpy_~d~3.base) 1 0)|) 1)
 (* (+ honda_cstpncpy_~s~3.base ray_cstpncpy_~s~3.base) 0)
 (*
 (+
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 |ray_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|)
 0)
 (*
 (+ |honda_(select #length cstpncpy_~s~3.base)|
 |ray_(select #length cstpncpy_~s~3.base)|) 0)
 (* (+ honda_cstpncpy_~n ray_cstpncpy_~n) 0)
 (* (+ |honda_cstpncpy_#in~dst.base| |ray_cstpncpy_#in~dst.base|) 0)
 (*
 (+ |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)|
 |ray_(ite (select #valid cstpncpy_#in~dst.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length cstpncpy_~#dst.base)|
 |ray_(select #length cstpncpy_~#dst.base)|) 0)
 (* (+ |honda_cstpncpy_#t~post4.base| |ray_cstpncpy_#t~post4.base|) 0)
 (*
 (+ |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)|
 |ray_(ite (select #valid cstpncpy_~#dst.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) cstpncpy_#in~dst.base)|
 |ray_(select old(#length) cstpncpy_#in~dst.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)|
 |ray_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)|) 0)
 (* (+ |honda_cstpncpy_#t~post5.offset| |ray_cstpncpy_#t~post5.offset|) 0)
 (*
 (+ |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)|
 |ray_(ite (select #valid cstpncpy_#in~src.base) 1 0)|) 0)
 (* (+ |honda_cstpncpy_#in~dst.offset| |ray_cstpncpy_#in~dst.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)|
 |ray_(ite (select #valid cstpncpy_~s~3.base) 1 0)|) 0)
 (* (+ honda_cstpncpy_~src.base ray_cstpncpy_~src.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ honda_cstpncpy_~d~3.offset ray_cstpncpy_~d~3.offset) 0)
 (* (+ |honda_cstpncpy_#t~post3| |ray_cstpncpy_#t~post3|) 0)
 (* (+ |honda_cstpncpy_~#dst.base| |ray_cstpncpy_~#dst.base|) 0)
 (* (+ honda_cstpncpy_~src.offset ray_cstpncpy_~src.offset) 0)
 (* (+ |honda_cstpncpy_#in~src.base| |ray_cstpncpy_#in~src.base|) 0)
 (*
 (+
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 |ray_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)|
 |ray_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)|) 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0) 
 (* honda_cstpncpy_~d~3.base 0) 
 (* |honda_cstpncpy_#t~post5.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (- 1)) 0)
 (>=
 (+ (* (+ |honda_cstpncpy_#t~mem0.offset| |ray_cstpncpy_#t~mem0.offset|) 0)
 (*
 (+ |honda_(select #length cstpncpy_~d~3.base)|
 |ray_(select #length cstpncpy_~d~3.base)|) 
 (- 1))
 (* (+ |honda_cstpncpy_#t~post4.offset| |ray_cstpncpy_#t~post4.offset|) 0)
 (* (+ honda_cstpncpy_~s~3.offset ray_cstpncpy_~s~3.offset) 0)
 (*
 (+
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 |ray_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|)
 0)
 (*
 (+ |honda_(select old(#length) cstpncpy_#in~src.base)|
 |ray_(select old(#length) cstpncpy_#in~src.base)|) 0)
 (* (+ |honda_cstpncpy_~#dst.offset| |ray_cstpncpy_~#dst.offset|) 0)
 (*
 (+
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 |ray_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|)
 0) (* (+ |honda_cstpncpy_#t~mem7| |ray_cstpncpy_#t~mem7|) 0)
 (*
 (+
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 |ray_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|)
 0) (* (+ honda_cstpncpy_~d~3.base ray_cstpncpy_~d~3.base) 0)
 (*
 (+
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 |ray_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|)
 0)
 (*
 (+ |honda_(select #length cstpncpy_#in~src.base)|
 |ray_(select #length cstpncpy_#in~src.base)|) 0)
 (* (+ |honda_cstpncpy_#in~src.offset| |ray_cstpncpy_#in~src.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)|
 |ray_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)|) 0)
 (* (+ |honda_cstpncpy_#t~mem1.offset| |ray_cstpncpy_#t~mem1.offset|) 0)
 (*
 (+ |honda_(select #length cstpncpy_#in~dst.base)|
 |ray_(select #length cstpncpy_#in~dst.base)|) 0)
 (* (+ |honda_cstpncpy_#t~mem0.base| |ray_cstpncpy_#t~mem0.base|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 |ray_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|)
 0) (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_cstpncpy_#in~n| |ray_cstpncpy_#in~n|) 0)
 (* (+ |honda_cstpncpy_#t~mem1.base| |ray_cstpncpy_#t~mem1.base|) 0)
 (* (+ |honda_cstpncpy_#t~post5.base| |ray_cstpncpy_#t~post5.base|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(select old(#length) cstpncpy_~#dst.base)|
 |ray_(select old(#length) cstpncpy_~#dst.base)|) 0)
 (*
 (+ |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)|
 |ray_(ite (select #valid cstpncpy_~d~3.base) 1 0)|) 0)
 (* (+ honda_cstpncpy_~s~3.base ray_cstpncpy_~s~3.base) 0)
 (*
 (+
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 |ray_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|)
 0)
 (*
 (+ |honda_(select #length cstpncpy_~s~3.base)|
 |ray_(select #length cstpncpy_~s~3.base)|) 0)
 (* (+ honda_cstpncpy_~n ray_cstpncpy_~n) 0)
 (* (+ |honda_cstpncpy_#in~dst.base| |ray_cstpncpy_#in~dst.base|) 0)
 (*
 (+ |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)|
 |ray_(ite (select #valid cstpncpy_#in~dst.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length cstpncpy_~#dst.base)|
 |ray_(select #length cstpncpy_~#dst.base)|) 0)
 (* (+ |honda_cstpncpy_#t~post4.base| |ray_cstpncpy_#t~post4.base|) 0)
 (*
 (+ |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)|
 |ray_(ite (select #valid cstpncpy_~#dst.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) cstpncpy_#in~dst.base)|
 |ray_(select old(#length) cstpncpy_#in~dst.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)|
 |ray_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)|) 0)
 (* (+ |honda_cstpncpy_#t~post5.offset| |ray_cstpncpy_#t~post5.offset|) 0)
 (*
 (+ |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)|
 |ray_(ite (select #valid cstpncpy_#in~src.base) 1 0)|) 0)
 (* (+ |honda_cstpncpy_#in~dst.offset| |ray_cstpncpy_#in~dst.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)|
 |ray_(ite (select #valid cstpncpy_~s~3.base) 1 0)|) 0)
 (* (+ honda_cstpncpy_~src.base ray_cstpncpy_~src.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ honda_cstpncpy_~d~3.offset ray_cstpncpy_~d~3.offset) 0)
 (* (+ |honda_cstpncpy_#t~post3| |ray_cstpncpy_#t~post3|) 0)
 (* (+ |honda_cstpncpy_~#dst.base| |ray_cstpncpy_~#dst.base|) 0)
 (* (+ honda_cstpncpy_~src.offset ray_cstpncpy_~src.offset) 0)
 (* (+ |honda_cstpncpy_#in~src.base| |ray_cstpncpy_#in~src.base|) 0)
 (*
 (+
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 |ray_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)|
 |ray_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)|) 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 1)
 (* |honda_cstpncpy_#t~post4.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0) 
 (* honda_cstpncpy_~d~3.base 0) 
 (* |honda_cstpncpy_#t~post5.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 0) 0)
 (>=
 (+ (* (+ |honda_cstpncpy_#t~mem0.offset| |ray_cstpncpy_#t~mem0.offset|) 0)
 (*
 (+ |honda_(select #length cstpncpy_~d~3.base)|
 |ray_(select #length cstpncpy_~d~3.base)|) 0)
 (* (+ |honda_cstpncpy_#t~post4.offset| |ray_cstpncpy_#t~post4.offset|) 0)
 (* (+ honda_cstpncpy_~s~3.offset ray_cstpncpy_~s~3.offset) 0)
 (*
 (+
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 |ray_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|)
 0)
 (*
 (+ |honda_(select old(#length) cstpncpy_#in~src.base)|
 |ray_(select old(#length) cstpncpy_#in~src.base)|) 0)
 (* (+ |honda_cstpncpy_~#dst.offset| |ray_cstpncpy_~#dst.offset|) 0)
 (*
 (+
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 |ray_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|)
 0) (* (+ |honda_cstpncpy_#t~mem7| |ray_cstpncpy_#t~mem7|) 0)
 (*
 (+
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 |ray_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|)
 0) (* (+ honda_cstpncpy_~d~3.base ray_cstpncpy_~d~3.base) 1)
 (*
 (+
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 |ray_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|)
 0)
 (*
 (+ |honda_(select #length cstpncpy_#in~src.base)|
 |ray_(select #length cstpncpy_#in~src.base)|) 0)
 (* (+ |honda_cstpncpy_#in~src.offset| |ray_cstpncpy_#in~src.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)|
 |ray_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)|) 0)
 (* (+ |honda_cstpncpy_#t~mem1.offset| |ray_cstpncpy_#t~mem1.offset|) 0)
 (*
 (+ |honda_(select #length cstpncpy_#in~dst.base)|
 |ray_(select #length cstpncpy_#in~dst.base)|) 0)
 (* (+ |honda_cstpncpy_#t~mem0.base| |ray_cstpncpy_#t~mem0.base|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 |ray_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|)
 0) (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_cstpncpy_#in~n| |ray_cstpncpy_#in~n|) 0)
 (* (+ |honda_cstpncpy_#t~mem1.base| |ray_cstpncpy_#t~mem1.base|) 0)
 (* (+ |honda_cstpncpy_#t~post5.base| |ray_cstpncpy_#t~post5.base|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(select old(#length) cstpncpy_~#dst.base)|
 |ray_(select old(#length) cstpncpy_~#dst.base)|) 0)
 (*
 (+ |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)|
 |ray_(ite (select #valid cstpncpy_~d~3.base) 1 0)|) 0)
 (* (+ honda_cstpncpy_~s~3.base ray_cstpncpy_~s~3.base) 0)
 (*
 (+
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 |ray_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|)
 0)
 (*
 (+ |honda_(select #length cstpncpy_~s~3.base)|
 |ray_(select #length cstpncpy_~s~3.base)|) 0)
 (* (+ honda_cstpncpy_~n ray_cstpncpy_~n) 0)
 (* (+ |honda_cstpncpy_#in~dst.base| |ray_cstpncpy_#in~dst.base|) 0)
 (*
 (+ |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)|
 |ray_(ite (select #valid cstpncpy_#in~dst.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length cstpncpy_~#dst.base)|
 |ray_(select #length cstpncpy_~#dst.base)|) 0)
 (* (+ |honda_cstpncpy_#t~post4.base| |ray_cstpncpy_#t~post4.base|) 0)
 (*
 (+ |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)|
 |ray_(ite (select #valid cstpncpy_~#dst.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) cstpncpy_#in~dst.base)|
 |ray_(select old(#length) cstpncpy_#in~dst.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)|
 |ray_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)|) 0)
 (* (+ |honda_cstpncpy_#t~post5.offset| |ray_cstpncpy_#t~post5.offset|) 0)
 (*
 (+ |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)|
 |ray_(ite (select #valid cstpncpy_#in~src.base) 1 0)|) 0)
 (* (+ |honda_cstpncpy_#in~dst.offset| |ray_cstpncpy_#in~dst.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)|
 |ray_(ite (select #valid cstpncpy_~s~3.base) 1 0)|) 0)
 (* (+ honda_cstpncpy_~src.base ray_cstpncpy_~src.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ honda_cstpncpy_~d~3.offset ray_cstpncpy_~d~3.offset) 0)
 (* (+ |honda_cstpncpy_#t~post3| |ray_cstpncpy_#t~post3|) 0)
 (* (+ |honda_cstpncpy_~#dst.base| |ray_cstpncpy_~#dst.base|) 0)
 (* (+ honda_cstpncpy_~src.offset ray_cstpncpy_~src.offset) 0)
 (* (+ |honda_cstpncpy_#in~src.base| |ray_cstpncpy_#in~src.base|) 0)
 (*
 (+
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 |ray_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)|
 |ray_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)|) 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0) 
 (* honda_cstpncpy_~d~3.base (- 1)) 
 (* |honda_cstpncpy_#t~post5.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 0) 0)
 (>=
 (+ (* (+ |honda_cstpncpy_#t~mem0.offset| |ray_cstpncpy_#t~mem0.offset|) 0)
 (*
 (+ |honda_(select #length cstpncpy_~d~3.base)|
 |ray_(select #length cstpncpy_~d~3.base)|) 0)
 (* (+ |honda_cstpncpy_#t~post4.offset| |ray_cstpncpy_#t~post4.offset|) 0)
 (* (+ honda_cstpncpy_~s~3.offset ray_cstpncpy_~s~3.offset) 0)
 (*
 (+
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 |ray_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|)
 0)
 (*
 (+ |honda_(select old(#length) cstpncpy_#in~src.base)|
 |ray_(select old(#length) cstpncpy_#in~src.base)|) 0)
 (* (+ |honda_cstpncpy_~#dst.offset| |ray_cstpncpy_~#dst.offset|) 0)
 (*
 (+
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 |ray_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|)
 0) (* (+ |honda_cstpncpy_#t~mem7| |ray_cstpncpy_#t~mem7|) 0)
 (*
 (+
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 |ray_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|)
 0) (* (+ honda_cstpncpy_~d~3.base ray_cstpncpy_~d~3.base) 0)
 (*
 (+
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 |ray_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|)
 0)
 (*
 (+ |honda_(select #length cstpncpy_#in~src.base)|
 |ray_(select #length cstpncpy_#in~src.base)|) 0)
 (* (+ |honda_cstpncpy_#in~src.offset| |ray_cstpncpy_#in~src.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)|
 |ray_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)|) 0)
 (* (+ |honda_cstpncpy_#t~mem1.offset| |ray_cstpncpy_#t~mem1.offset|) 0)
 (*
 (+ |honda_(select #length cstpncpy_#in~dst.base)|
 |ray_(select #length cstpncpy_#in~dst.base)|) 0)
 (* (+ |honda_cstpncpy_#t~mem0.base| |ray_cstpncpy_#t~mem0.base|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 |ray_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|)
 0) (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_cstpncpy_#in~n| |ray_cstpncpy_#in~n|) 0)
 (* (+ |honda_cstpncpy_#t~mem1.base| |ray_cstpncpy_#t~mem1.base|) 0)
 (* (+ |honda_cstpncpy_#t~post5.base| |ray_cstpncpy_#t~post5.base|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(select old(#length) cstpncpy_~#dst.base)|
 |ray_(select old(#length) cstpncpy_~#dst.base)|) 0)
 (*
 (+ |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)|
 |ray_(ite (select #valid cstpncpy_~d~3.base) 1 0)|) 0)
 (* (+ honda_cstpncpy_~s~3.base ray_cstpncpy_~s~3.base) 0)
 (*
 (+
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 |ray_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|)
 0)
 (*
 (+ |honda_(select #length cstpncpy_~s~3.base)|
 |ray_(select #length cstpncpy_~s~3.base)|) 0)
 (* (+ honda_cstpncpy_~n ray_cstpncpy_~n) 0)
 (* (+ |honda_cstpncpy_#in~dst.base| |ray_cstpncpy_#in~dst.base|) 0)
 (*
 (+ |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)|
 |ray_(ite (select #valid cstpncpy_#in~dst.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length cstpncpy_~#dst.base)|
 |ray_(select #length cstpncpy_~#dst.base)|) 0)
 (* (+ |honda_cstpncpy_#t~post4.base| |ray_cstpncpy_#t~post4.base|) 0)
 (*
 (+ |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)|
 |ray_(ite (select #valid cstpncpy_~#dst.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) cstpncpy_#in~dst.base)|
 |ray_(select old(#length) cstpncpy_#in~dst.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)|
 |ray_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)|) 0)
 (* (+ |honda_cstpncpy_#t~post5.offset| |ray_cstpncpy_#t~post5.offset|) 0)
 (*
 (+ |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)|
 |ray_(ite (select #valid cstpncpy_#in~src.base) 1 0)|) 0)
 (* (+ |honda_cstpncpy_#in~dst.offset| |ray_cstpncpy_#in~dst.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)|
 |ray_(ite (select #valid cstpncpy_~s~3.base) 1 0)|) 0)
 (* (+ honda_cstpncpy_~src.base ray_cstpncpy_~src.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ honda_cstpncpy_~d~3.offset ray_cstpncpy_~d~3.offset) 0)
 (* (+ |honda_cstpncpy_#t~post3| |ray_cstpncpy_#t~post3|) 0)
 (* (+ |honda_cstpncpy_~#dst.base| |ray_cstpncpy_~#dst.base|) 0)
 (* (+ honda_cstpncpy_~src.offset ray_cstpncpy_~src.offset) 0)
 (* (+ |honda_cstpncpy_#in~src.base| |ray_cstpncpy_#in~src.base|) 0)
 (*
 (+
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 |ray_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)|
 |ray_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)|) 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0) 
 (* honda_cstpncpy_~s~3.offset (- 1))
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0) 
 (* honda_cstpncpy_~d~3.base 0) 
 (* |honda_cstpncpy_#t~post5.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(select #length cstpncpy_~s~3.base)| 1) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (- 1)) 0)
 (>=
 (+ (* (+ |honda_cstpncpy_#t~mem0.offset| |ray_cstpncpy_#t~mem0.offset|) 0)
 (*
 (+ |honda_(select #length cstpncpy_~d~3.base)|
 |ray_(select #length cstpncpy_~d~3.base)|) 0)
 (* (+ |honda_cstpncpy_#t~post4.offset| |ray_cstpncpy_#t~post4.offset|) 0)
 (* (+ honda_cstpncpy_~s~3.offset ray_cstpncpy_~s~3.offset) (- 1))
 (*
 (+
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 |ray_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|)
 0)
 (*
 (+ |honda_(select old(#length) cstpncpy_#in~src.base)|
 |ray_(select old(#length) cstpncpy_#in~src.base)|) 0)
 (* (+ |honda_cstpncpy_~#dst.offset| |ray_cstpncpy_~#dst.offset|) 0)
 (*
 (+
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 |ray_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|)
 0) (* (+ |honda_cstpncpy_#t~mem7| |ray_cstpncpy_#t~mem7|) 0)
 (*
 (+
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 |ray_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|)
 0) (* (+ honda_cstpncpy_~d~3.base ray_cstpncpy_~d~3.base) 0)
 (*
 (+
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 |ray_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|)
 0)
 (*
 (+ |honda_(select #length cstpncpy_#in~src.base)|
 |ray_(select #length cstpncpy_#in~src.base)|) 0)
 (* (+ |honda_cstpncpy_#in~src.offset| |ray_cstpncpy_#in~src.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)|
 |ray_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)|) 0)
 (* (+ |honda_cstpncpy_#t~mem1.offset| |ray_cstpncpy_#t~mem1.offset|) 0)
 (*
 (+ |honda_(select #length cstpncpy_#in~dst.base)|
 |ray_(select #length cstpncpy_#in~dst.base)|) 0)
 (* (+ |honda_cstpncpy_#t~mem0.base| |ray_cstpncpy_#t~mem0.base|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 |ray_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|)
 0) (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_cstpncpy_#in~n| |ray_cstpncpy_#in~n|) 0)
 (* (+ |honda_cstpncpy_#t~mem1.base| |ray_cstpncpy_#t~mem1.base|) 0)
 (* (+ |honda_cstpncpy_#t~post5.base| |ray_cstpncpy_#t~post5.base|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(select old(#length) cstpncpy_~#dst.base)|
 |ray_(select old(#length) cstpncpy_~#dst.base)|) 0)
 (*
 (+ |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)|
 |ray_(ite (select #valid cstpncpy_~d~3.base) 1 0)|) 0)
 (* (+ honda_cstpncpy_~s~3.base ray_cstpncpy_~s~3.base) 0)
 (*
 (+
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 |ray_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|)
 0)
 (*
 (+ |honda_(select #length cstpncpy_~s~3.base)|
 |ray_(select #length cstpncpy_~s~3.base)|) 0)
 (* (+ honda_cstpncpy_~n ray_cstpncpy_~n) 0)
 (* (+ |honda_cstpncpy_#in~dst.base| |ray_cstpncpy_#in~dst.base|) 0)
 (*
 (+ |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)|
 |ray_(ite (select #valid cstpncpy_#in~dst.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length cstpncpy_~#dst.base)|
 |ray_(select #length cstpncpy_~#dst.base)|) 0)
 (* (+ |honda_cstpncpy_#t~post4.base| |ray_cstpncpy_#t~post4.base|) 0)
 (*
 (+ |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)|
 |ray_(ite (select #valid cstpncpy_~#dst.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) cstpncpy_#in~dst.base)|
 |ray_(select old(#length) cstpncpy_#in~dst.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)|
 |ray_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)|) 0)
 (* (+ |honda_cstpncpy_#t~post5.offset| |ray_cstpncpy_#t~post5.offset|) 0)
 (*
 (+ |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)|
 |ray_(ite (select #valid cstpncpy_#in~src.base) 1 0)|) 0)
 (* (+ |honda_cstpncpy_#in~dst.offset| |ray_cstpncpy_#in~dst.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)|
 |ray_(ite (select #valid cstpncpy_~s~3.base) 1 0)|) 0)
 (* (+ honda_cstpncpy_~src.base ray_cstpncpy_~src.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ honda_cstpncpy_~d~3.offset ray_cstpncpy_~d~3.offset) 0)
 (* (+ |honda_cstpncpy_#t~post3| |ray_cstpncpy_#t~post3|) 0)
 (* (+ |honda_cstpncpy_~#dst.base| |ray_cstpncpy_~#dst.base|) 0)
 (* (+ honda_cstpncpy_~src.offset ray_cstpncpy_~src.offset) 0)
 (* (+ |honda_cstpncpy_#in~src.base| |ray_cstpncpy_#in~src.base|) 0)
 (*
 (+
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 |ray_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)|
 |ray_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)|) 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 1)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0) 
 (* honda_cstpncpy_~d~3.base 0) 
 (* |honda_cstpncpy_#t~post5.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 1) 0)
 (>=
 (+ (* (+ |honda_cstpncpy_#t~mem0.offset| |ray_cstpncpy_#t~mem0.offset|) 0)
 (*
 (+ |honda_(select #length cstpncpy_~d~3.base)|
 |ray_(select #length cstpncpy_~d~3.base)|) 0)
 (* (+ |honda_cstpncpy_#t~post4.offset| |ray_cstpncpy_#t~post4.offset|) 0)
 (* (+ honda_cstpncpy_~s~3.offset ray_cstpncpy_~s~3.offset) 0)
 (*
 (+
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 |ray_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|)
 0)
 (*
 (+ |honda_(select old(#length) cstpncpy_#in~src.base)|
 |ray_(select old(#length) cstpncpy_#in~src.base)|) 0)
 (* (+ |honda_cstpncpy_~#dst.offset| |ray_cstpncpy_~#dst.offset|) 0)
 (*
 (+
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 |ray_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|)
 0) (* (+ |honda_cstpncpy_#t~mem7| |ray_cstpncpy_#t~mem7|) 0)
 (*
 (+
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 |ray_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|)
 0) (* (+ honda_cstpncpy_~d~3.base ray_cstpncpy_~d~3.base) 0)
 (*
 (+
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 |ray_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|)
 0)
 (*
 (+ |honda_(select #length cstpncpy_#in~src.base)|
 |ray_(select #length cstpncpy_#in~src.base)|) 0)
 (* (+ |honda_cstpncpy_#in~src.offset| |ray_cstpncpy_#in~src.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)|
 |ray_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)|) 0)
 (* (+ |honda_cstpncpy_#t~mem1.offset| |ray_cstpncpy_#t~mem1.offset|) 0)
 (*
 (+ |honda_(select #length cstpncpy_#in~dst.base)|
 |ray_(select #length cstpncpy_#in~dst.base)|) 0)
 (* (+ |honda_cstpncpy_#t~mem0.base| |ray_cstpncpy_#t~mem0.base|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 |ray_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|)
 0) (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_cstpncpy_#in~n| |ray_cstpncpy_#in~n|) 0)
 (* (+ |honda_cstpncpy_#t~mem1.base| |ray_cstpncpy_#t~mem1.base|) 0)
 (* (+ |honda_cstpncpy_#t~post5.base| |ray_cstpncpy_#t~post5.base|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(select old(#length) cstpncpy_~#dst.base)|
 |ray_(select old(#length) cstpncpy_~#dst.base)|) 0)
 (*
 (+ |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)|
 |ray_(ite (select #valid cstpncpy_~d~3.base) 1 0)|) 0)
 (* (+ honda_cstpncpy_~s~3.base ray_cstpncpy_~s~3.base) 0)
 (*
 (+
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 |ray_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|)
 0)
 (*
 (+ |honda_(select #length cstpncpy_~s~3.base)|
 |ray_(select #length cstpncpy_~s~3.base)|) 0)
 (* (+ honda_cstpncpy_~n ray_cstpncpy_~n) (- 1))
 (* (+ |honda_cstpncpy_#in~dst.base| |ray_cstpncpy_#in~dst.base|) 0)
 (*
 (+ |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)|
 |ray_(ite (select #valid cstpncpy_#in~dst.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length cstpncpy_~#dst.base)|
 |ray_(select #length cstpncpy_~#dst.base)|) 0)
 (* (+ |honda_cstpncpy_#t~post4.base| |ray_cstpncpy_#t~post4.base|) 0)
 (*
 (+ |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)|
 |ray_(ite (select #valid cstpncpy_~#dst.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) cstpncpy_#in~dst.base)|
 |ray_(select old(#length) cstpncpy_#in~dst.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)|
 |ray_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)|) 0)
 (* (+ |honda_cstpncpy_#t~post5.offset| |ray_cstpncpy_#t~post5.offset|) 0)
 (*
 (+ |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)|
 |ray_(ite (select #valid cstpncpy_#in~src.base) 1 0)|) 0)
 (* (+ |honda_cstpncpy_#in~dst.offset| |ray_cstpncpy_#in~dst.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)|
 |ray_(ite (select #valid cstpncpy_~s~3.base) 1 0)|) 0)
 (* (+ honda_cstpncpy_~src.base ray_cstpncpy_~src.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ honda_cstpncpy_~d~3.offset ray_cstpncpy_~d~3.offset) 0)
 (* (+ |honda_cstpncpy_#t~post3| |ray_cstpncpy_#t~post3|) 0)
 (* (+ |honda_cstpncpy_~#dst.base| |ray_cstpncpy_~#dst.base|) 0)
 (* (+ honda_cstpncpy_~src.offset ray_cstpncpy_~src.offset) 0)
 (* (+ |honda_cstpncpy_#in~src.base| |ray_cstpncpy_#in~src.base|) 0)
 (*
 (+
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 |ray_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)|
 |ray_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)|) 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0) 
 (* honda_cstpncpy_~d~3.base 0) 
 (* |honda_cstpncpy_#t~post5.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 1) (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (- 1)) 0)
 (>=
 (+ (* (+ |honda_cstpncpy_#t~mem0.offset| |ray_cstpncpy_#t~mem0.offset|) 0)
 (*
 (+ |honda_(select #length cstpncpy_~d~3.base)|
 |ray_(select #length cstpncpy_~d~3.base)|) 0)
 (* (+ |honda_cstpncpy_#t~post4.offset| |ray_cstpncpy_#t~post4.offset|) 0)
 (* (+ honda_cstpncpy_~s~3.offset ray_cstpncpy_~s~3.offset) 0)
 (*
 (+
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 |ray_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|)
 0)
 (*
 (+ |honda_(select old(#length) cstpncpy_#in~src.base)|
 |ray_(select old(#length) cstpncpy_#in~src.base)|) 0)
 (* (+ |honda_cstpncpy_~#dst.offset| |ray_cstpncpy_~#dst.offset|) 0)
 (*
 (+
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 |ray_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|)
 0) (* (+ |honda_cstpncpy_#t~mem7| |ray_cstpncpy_#t~mem7|) 0)
 (*
 (+
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 |ray_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|)
 0) (* (+ honda_cstpncpy_~d~3.base ray_cstpncpy_~d~3.base) 0)
 (*
 (+
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 |ray_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|)
 0)
 (*
 (+ |honda_(select #length cstpncpy_#in~src.base)|
 |ray_(select #length cstpncpy_#in~src.base)|) 0)
 (* (+ |honda_cstpncpy_#in~src.offset| |ray_cstpncpy_#in~src.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)|
 |ray_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)|) 0)
 (* (+ |honda_cstpncpy_#t~mem1.offset| |ray_cstpncpy_#t~mem1.offset|) 0)
 (*
 (+ |honda_(select #length cstpncpy_#in~dst.base)|
 |ray_(select #length cstpncpy_#in~dst.base)|) 0)
 (* (+ |honda_cstpncpy_#t~mem0.base| |ray_cstpncpy_#t~mem0.base|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 |ray_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|)
 0) (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_cstpncpy_#in~n| |ray_cstpncpy_#in~n|) 0)
 (* (+ |honda_cstpncpy_#t~mem1.base| |ray_cstpncpy_#t~mem1.base|) 0)
 (* (+ |honda_cstpncpy_#t~post5.base| |ray_cstpncpy_#t~post5.base|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(select old(#length) cstpncpy_~#dst.base)|
 |ray_(select old(#length) cstpncpy_~#dst.base)|) 0)
 (*
 (+ |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)|
 |ray_(ite (select #valid cstpncpy_~d~3.base) 1 0)|) 0)
 (* (+ honda_cstpncpy_~s~3.base ray_cstpncpy_~s~3.base) 0)
 (*
 (+
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 |ray_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|)
 0)
 (*
 (+ |honda_(select #length cstpncpy_~s~3.base)|
 |ray_(select #length cstpncpy_~s~3.base)|) 0)
 (* (+ honda_cstpncpy_~n ray_cstpncpy_~n) 0)
 (* (+ |honda_cstpncpy_#in~dst.base| |ray_cstpncpy_#in~dst.base|) 0)
 (*
 (+ |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)|
 |ray_(ite (select #valid cstpncpy_#in~dst.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length cstpncpy_~#dst.base)|
 |ray_(select #length cstpncpy_~#dst.base)|) 0)
 (* (+ |honda_cstpncpy_#t~post4.base| |ray_cstpncpy_#t~post4.base|) 0)
 (*
 (+ |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)|
 |ray_(ite (select #valid cstpncpy_~#dst.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) cstpncpy_#in~dst.base)|
 |ray_(select old(#length) cstpncpy_#in~dst.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)|
 |ray_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)|) 0)
 (* (+ |honda_cstpncpy_#t~post5.offset| |ray_cstpncpy_#t~post5.offset|) 0)
 (*
 (+ |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)|
 |ray_(ite (select #valid cstpncpy_#in~src.base) 1 0)|) 0)
 (* (+ |honda_cstpncpy_#in~dst.offset| |ray_cstpncpy_#in~dst.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)|
 |ray_(ite (select #valid cstpncpy_~s~3.base) 1 0)|) 0)
 (* (+ honda_cstpncpy_~src.base ray_cstpncpy_~src.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ honda_cstpncpy_~d~3.offset ray_cstpncpy_~d~3.offset) 1)
 (* (+ |honda_cstpncpy_#t~post3| |ray_cstpncpy_#t~post3|) 0)
 (* (+ |honda_cstpncpy_~#dst.base| |ray_cstpncpy_~#dst.base|) 0)
 (* (+ honda_cstpncpy_~src.offset ray_cstpncpy_~src.offset) 0)
 (* (+ |honda_cstpncpy_#in~src.base| |ray_cstpncpy_#in~src.base|) 0)
 (*
 (+
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 |ray_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)|
 |ray_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)|) 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0) 
 (* honda_cstpncpy_~d~3.base 0) 
 (* |honda_cstpncpy_#t~post5.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset (- 1)) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (- 1)) 0)
 (>=
 (+ (* (+ |honda_cstpncpy_#t~mem0.offset| |ray_cstpncpy_#t~mem0.offset|) 0)
 (*
 (+ |honda_(select #length cstpncpy_~d~3.base)|
 |ray_(select #length cstpncpy_~d~3.base)|) 0)
 (* (+ |honda_cstpncpy_#t~post4.offset| |ray_cstpncpy_#t~post4.offset|) 0)
 (* (+ honda_cstpncpy_~s~3.offset ray_cstpncpy_~s~3.offset) 0)
 (*
 (+
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 |ray_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|)
 0)
 (*
 (+ |honda_(select old(#length) cstpncpy_#in~src.base)|
 |ray_(select old(#length) cstpncpy_#in~src.base)|) 0)
 (* (+ |honda_cstpncpy_~#dst.offset| |ray_cstpncpy_~#dst.offset|) 0)
 (*
 (+
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 |ray_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|)
 0) (* (+ |honda_cstpncpy_#t~mem7| |ray_cstpncpy_#t~mem7|) 0)
 (*
 (+
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 |ray_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|)
 0) (* (+ honda_cstpncpy_~d~3.base ray_cstpncpy_~d~3.base) 0)
 (*
 (+
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 |ray_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|)
 0)
 (*
 (+ |honda_(select #length cstpncpy_#in~src.base)|
 |ray_(select #length cstpncpy_#in~src.base)|) 0)
 (* (+ |honda_cstpncpy_#in~src.offset| |ray_cstpncpy_#in~src.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)|
 |ray_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)|) 0)
 (* (+ |honda_cstpncpy_#t~mem1.offset| |ray_cstpncpy_#t~mem1.offset|) 0)
 (*
 (+ |honda_(select #length cstpncpy_#in~dst.base)|
 |ray_(select #length cstpncpy_#in~dst.base)|) 0)
 (* (+ |honda_cstpncpy_#t~mem0.base| |ray_cstpncpy_#t~mem0.base|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 |ray_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|)
 0) (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_cstpncpy_#in~n| |ray_cstpncpy_#in~n|) 0)
 (* (+ |honda_cstpncpy_#t~mem1.base| |ray_cstpncpy_#t~mem1.base|) 0)
 (* (+ |honda_cstpncpy_#t~post5.base| |ray_cstpncpy_#t~post5.base|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(select old(#length) cstpncpy_~#dst.base)|
 |ray_(select old(#length) cstpncpy_~#dst.base)|) 0)
 (*
 (+ |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)|
 |ray_(ite (select #valid cstpncpy_~d~3.base) 1 0)|) 0)
 (* (+ honda_cstpncpy_~s~3.base ray_cstpncpy_~s~3.base) 1)
 (*
 (+
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 |ray_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|)
 0)
 (*
 (+ |honda_(select #length cstpncpy_~s~3.base)|
 |ray_(select #length cstpncpy_~s~3.base)|) 0)
 (* (+ honda_cstpncpy_~n ray_cstpncpy_~n) 0)
 (* (+ |honda_cstpncpy_#in~dst.base| |ray_cstpncpy_#in~dst.base|) 0)
 (*
 (+ |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)|
 |ray_(ite (select #valid cstpncpy_#in~dst.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length cstpncpy_~#dst.base)|
 |ray_(select #length cstpncpy_~#dst.base)|) 0)
 (* (+ |honda_cstpncpy_#t~post4.base| |ray_cstpncpy_#t~post4.base|) 0)
 (*
 (+ |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)|
 |ray_(ite (select #valid cstpncpy_~#dst.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) cstpncpy_#in~dst.base)|
 |ray_(select old(#length) cstpncpy_#in~dst.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)|
 |ray_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)|) 0)
 (* (+ |honda_cstpncpy_#t~post5.offset| |ray_cstpncpy_#t~post5.offset|) 0)
 (*
 (+ |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)|
 |ray_(ite (select #valid cstpncpy_#in~src.base) 1 0)|) 0)
 (* (+ |honda_cstpncpy_#in~dst.offset| |ray_cstpncpy_#in~dst.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)|
 |ray_(ite (select #valid cstpncpy_~s~3.base) 1 0)|) 0)
 (* (+ honda_cstpncpy_~src.base ray_cstpncpy_~src.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ honda_cstpncpy_~d~3.offset ray_cstpncpy_~d~3.offset) 0)
 (* (+ |honda_cstpncpy_#t~post3| |ray_cstpncpy_#t~post3|) 0)
 (* (+ |honda_cstpncpy_~#dst.base| |ray_cstpncpy_~#dst.base|) 0)
 (* (+ honda_cstpncpy_~src.offset ray_cstpncpy_~src.offset) 0)
 (* (+ |honda_cstpncpy_#in~src.base| |ray_cstpncpy_#in~src.base|) 0)
 (*
 (+
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 |ray_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)|
 |ray_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)|) 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0) 
 (* honda_cstpncpy_~d~3.base (- 1)) 
 (* |honda_cstpncpy_#t~post5.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (- 1)) 0)
 (>=
 (+ (* (+ |honda_cstpncpy_#t~mem0.offset| |ray_cstpncpy_#t~mem0.offset|) 0)
 (*
 (+ |honda_(select #length cstpncpy_~d~3.base)|
 |ray_(select #length cstpncpy_~d~3.base)|) 0)
 (* (+ |honda_cstpncpy_#t~post4.offset| |ray_cstpncpy_#t~post4.offset|) 0)
 (* (+ honda_cstpncpy_~s~3.offset ray_cstpncpy_~s~3.offset) 0)
 (*
 (+
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 |ray_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|)
 0)
 (*
 (+ |honda_(select old(#length) cstpncpy_#in~src.base)|
 |ray_(select old(#length) cstpncpy_#in~src.base)|) 0)
 (* (+ |honda_cstpncpy_~#dst.offset| |ray_cstpncpy_~#dst.offset|) 0)
 (*
 (+
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 |ray_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|)
 0) (* (+ |honda_cstpncpy_#t~mem7| |ray_cstpncpy_#t~mem7|) 0)
 (*
 (+
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 |ray_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|)
 0) (* (+ honda_cstpncpy_~d~3.base ray_cstpncpy_~d~3.base) 0)
 (*
 (+
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 |ray_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|)
 0)
 (*
 (+ |honda_(select #length cstpncpy_#in~src.base)|
 |ray_(select #length cstpncpy_#in~src.base)|) 0)
 (* (+ |honda_cstpncpy_#in~src.offset| |ray_cstpncpy_#in~src.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)|
 |ray_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)|) 0)
 (* (+ |honda_cstpncpy_#t~mem1.offset| |ray_cstpncpy_#t~mem1.offset|) 0)
 (*
 (+ |honda_(select #length cstpncpy_#in~dst.base)|
 |ray_(select #length cstpncpy_#in~dst.base)|) 0)
 (* (+ |honda_cstpncpy_#t~mem0.base| |ray_cstpncpy_#t~mem0.base|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 |ray_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|)
 0) (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_cstpncpy_#in~n| |ray_cstpncpy_#in~n|) 0)
 (* (+ |honda_cstpncpy_#t~mem1.base| |ray_cstpncpy_#t~mem1.base|) 0)
 (* (+ |honda_cstpncpy_#t~post5.base| |ray_cstpncpy_#t~post5.base|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(select old(#length) cstpncpy_~#dst.base)|
 |ray_(select old(#length) cstpncpy_~#dst.base)|) 0)
 (*
 (+ |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)|
 |ray_(ite (select #valid cstpncpy_~d~3.base) 1 0)|) 0)
 (* (+ honda_cstpncpy_~s~3.base ray_cstpncpy_~s~3.base) 0)
 (*
 (+
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 |ray_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|)
 0)
 (*
 (+ |honda_(select #length cstpncpy_~s~3.base)|
 |ray_(select #length cstpncpy_~s~3.base)|) 0)
 (* (+ honda_cstpncpy_~n ray_cstpncpy_~n) 0)
 (* (+ |honda_cstpncpy_#in~dst.base| |ray_cstpncpy_#in~dst.base|) 0)
 (*
 (+ |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)|
 |ray_(ite (select #valid cstpncpy_#in~dst.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length cstpncpy_~#dst.base)|
 |ray_(select #length cstpncpy_~#dst.base)|) 0)
 (* (+ |honda_cstpncpy_#t~post4.base| |ray_cstpncpy_#t~post4.base|) 0)
 (*
 (+ |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)|
 |ray_(ite (select #valid cstpncpy_~#dst.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) cstpncpy_#in~dst.base)|
 |ray_(select old(#length) cstpncpy_#in~dst.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)|
 |ray_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)|) 0)
 (* (+ |honda_cstpncpy_#t~post5.offset| |ray_cstpncpy_#t~post5.offset|) 0)
 (*
 (+ |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)|
 |ray_(ite (select #valid cstpncpy_#in~src.base) 1 0)|) 0)
 (* (+ |honda_cstpncpy_#in~dst.offset| |ray_cstpncpy_#in~dst.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)|
 |ray_(ite (select #valid cstpncpy_~s~3.base) 1 0)|) 1)
 (* (+ honda_cstpncpy_~src.base ray_cstpncpy_~src.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ honda_cstpncpy_~d~3.offset ray_cstpncpy_~d~3.offset) 0)
 (* (+ |honda_cstpncpy_#t~post3| |ray_cstpncpy_#t~post3|) 0)
 (* (+ |honda_cstpncpy_~#dst.base| |ray_cstpncpy_~#dst.base|) 0)
 (* (+ honda_cstpncpy_~src.offset ray_cstpncpy_~src.offset) 0)
 (* (+ |honda_cstpncpy_#in~src.base| |ray_cstpncpy_#in~src.base|) 0)
 (*
 (+
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 |ray_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)|
 |ray_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)|) 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0) 
 (* honda_cstpncpy_~d~3.base 0) 
 (* |honda_cstpncpy_#t~post5.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (- 1)) 0)
 (>=
 (+ (* (+ |honda_cstpncpy_#t~mem0.offset| |ray_cstpncpy_#t~mem0.offset|) 0)
 (*
 (+ |honda_(select #length cstpncpy_~d~3.base)|
 |ray_(select #length cstpncpy_~d~3.base)|) 0)
 (* (+ |honda_cstpncpy_#t~post4.offset| |ray_cstpncpy_#t~post4.offset|) 0)
 (* (+ honda_cstpncpy_~s~3.offset ray_cstpncpy_~s~3.offset) 0)
 (*
 (+
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 |ray_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|)
 0)
 (*
 (+ |honda_(select old(#length) cstpncpy_#in~src.base)|
 |ray_(select old(#length) cstpncpy_#in~src.base)|) 0)
 (* (+ |honda_cstpncpy_~#dst.offset| |ray_cstpncpy_~#dst.offset|) 0)
 (*
 (+
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 |ray_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|)
 0) (* (+ |honda_cstpncpy_#t~mem7| |ray_cstpncpy_#t~mem7|) 0)
 (*
 (+
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 |ray_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|)
 0) (* (+ honda_cstpncpy_~d~3.base ray_cstpncpy_~d~3.base) 0)
 (*
 (+
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 |ray_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|)
 0)
 (*
 (+ |honda_(select #length cstpncpy_#in~src.base)|
 |ray_(select #length cstpncpy_#in~src.base)|) 0)
 (* (+ |honda_cstpncpy_#in~src.offset| |ray_cstpncpy_#in~src.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)|
 |ray_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)|) 0)
 (* (+ |honda_cstpncpy_#t~mem1.offset| |ray_cstpncpy_#t~mem1.offset|) 0)
 (*
 (+ |honda_(select #length cstpncpy_#in~dst.base)|
 |ray_(select #length cstpncpy_#in~dst.base)|) 0)
 (* (+ |honda_cstpncpy_#t~mem0.base| |ray_cstpncpy_#t~mem0.base|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 |ray_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|)
 0) (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_cstpncpy_#in~n| |ray_cstpncpy_#in~n|) 0)
 (* (+ |honda_cstpncpy_#t~mem1.base| |ray_cstpncpy_#t~mem1.base|) 0)
 (* (+ |honda_cstpncpy_#t~post5.base| |ray_cstpncpy_#t~post5.base|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(select old(#length) cstpncpy_~#dst.base)|
 |ray_(select old(#length) cstpncpy_~#dst.base)|) 0)
 (*
 (+ |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)|
 |ray_(ite (select #valid cstpncpy_~d~3.base) 1 0)|) 0)
 (* (+ honda_cstpncpy_~s~3.base ray_cstpncpy_~s~3.base) 0)
 (*
 (+
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 |ray_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|)
 0)
 (*
 (+ |honda_(select #length cstpncpy_~s~3.base)|
 |ray_(select #length cstpncpy_~s~3.base)|) 0)
 (* (+ honda_cstpncpy_~n ray_cstpncpy_~n) 0)
 (* (+ |honda_cstpncpy_#in~dst.base| |ray_cstpncpy_#in~dst.base|) 0)
 (*
 (+ |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)|
 |ray_(ite (select #valid cstpncpy_#in~dst.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length cstpncpy_~#dst.base)|
 |ray_(select #length cstpncpy_~#dst.base)|) 0)
 (* (+ |honda_cstpncpy_#t~post4.base| |ray_cstpncpy_#t~post4.base|) 0)
 (*
 (+ |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)|
 |ray_(ite (select #valid cstpncpy_~#dst.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) cstpncpy_#in~dst.base)|
 |ray_(select old(#length) cstpncpy_#in~dst.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)|
 |ray_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)|) 0)
 (* (+ |honda_cstpncpy_#t~post5.offset| |ray_cstpncpy_#t~post5.offset|) 0)
 (*
 (+ |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)|
 |ray_(ite (select #valid cstpncpy_#in~src.base) 1 0)|) 0)
 (* (+ |honda_cstpncpy_#in~dst.offset| |ray_cstpncpy_#in~dst.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)|
 |ray_(ite (select #valid cstpncpy_~s~3.base) 1 0)|) 0)
 (* (+ honda_cstpncpy_~src.base ray_cstpncpy_~src.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ honda_cstpncpy_~d~3.offset ray_cstpncpy_~d~3.offset) 0)
 (* (+ |honda_cstpncpy_#t~post3| |ray_cstpncpy_#t~post3|) 0)
 (* (+ |honda_cstpncpy_~#dst.base| |ray_cstpncpy_~#dst.base|) 0)
 (* (+ honda_cstpncpy_~src.offset ray_cstpncpy_~src.offset) 0)
 (* (+ |honda_cstpncpy_#in~src.base| |ray_cstpncpy_#in~src.base|) 0)
 (*
 (+
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 |ray_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)|
 |ray_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)|) 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0) 
 (* honda_cstpncpy_~d~3.base 0) 
 (* |honda_cstpncpy_#t~post5.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(select #length cstpncpy_~s~3.base)| 0)
 (* honda_cstpncpy_~n (- 1)) 
 (* |honda_cstpncpy_#t~post4.base| 0) 
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* aux_3698 1) (* aux_3699 4294967296) 1) 0)
 (>=
 (+ (* (+ |honda_cstpncpy_#t~mem0.offset| |ray_cstpncpy_#t~mem0.offset|) 0)
 (*
 (+ |honda_(select #length cstpncpy_~d~3.base)|
 |ray_(select #length cstpncpy_~d~3.base)|) 0)
 (* (+ |honda_cstpncpy_#t~post4.offset| |ray_cstpncpy_#t~post4.offset|) 0)
 (* (+ honda_cstpncpy_~s~3.offset ray_cstpncpy_~s~3.offset) 0)
 (*
 (+
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 |ray_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|)
 0)
 (*
 (+ |honda_(select old(#length) cstpncpy_#in~src.base)|
 |ray_(select old(#length) cstpncpy_#in~src.base)|) 0)
 (* (+ |honda_cstpncpy_~#dst.offset| |ray_cstpncpy_~#dst.offset|) 0)
 (*
 (+
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 |ray_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|)
 0) (* (+ |honda_cstpncpy_#t~mem7| |ray_cstpncpy_#t~mem7|) 0)
 (*
 (+
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 |ray_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|)
 0) (* (+ honda_cstpncpy_~d~3.base ray_cstpncpy_~d~3.base) 0)
 (*
 (+
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 |ray_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|)
 0)
 (*
 (+ |honda_(select #length cstpncpy_#in~src.base)|
 |ray_(select #length cstpncpy_#in~src.base)|) 0)
 (* (+ |honda_cstpncpy_#in~src.offset| |ray_cstpncpy_#in~src.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)|
 |ray_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)|) 0)
 (* (+ |honda_cstpncpy_#t~mem1.offset| |ray_cstpncpy_#t~mem1.offset|) 0)
 (*
 (+ |honda_(select #length cstpncpy_#in~dst.base)|
 |ray_(select #length cstpncpy_#in~dst.base)|) 0)
 (* (+ |honda_cstpncpy_#t~mem0.base| |ray_cstpncpy_#t~mem0.base|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 |ray_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|)
 0) (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_cstpncpy_#in~n| |ray_cstpncpy_#in~n|) 0)
 (* (+ |honda_cstpncpy_#t~mem1.base| |ray_cstpncpy_#t~mem1.base|) 0)
 (* (+ |honda_cstpncpy_#t~post5.base| |ray_cstpncpy_#t~post5.base|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(select old(#length) cstpncpy_~#dst.base)|
 |ray_(select old(#length) cstpncpy_~#dst.base)|) 0)
 (*
 (+ |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)|
 |ray_(ite (select #valid cstpncpy_~d~3.base) 1 0)|) 0)
 (* (+ honda_cstpncpy_~s~3.base ray_cstpncpy_~s~3.base) 0)
 (*
 (+
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 |ray_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|)
 0)
 (*
 (+ |honda_(select #length cstpncpy_~s~3.base)|
 |ray_(select #length cstpncpy_~s~3.base)|) 0)
 (* (+ honda_cstpncpy_~n ray_cstpncpy_~n) 0)
 (* (+ |honda_cstpncpy_#in~dst.base| |ray_cstpncpy_#in~dst.base|) 0)
 (*
 (+ |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)|
 |ray_(ite (select #valid cstpncpy_#in~dst.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length cstpncpy_~#dst.base)|
 |ray_(select #length cstpncpy_~#dst.base)|) 0)
 (* (+ |honda_cstpncpy_#t~post4.base| |ray_cstpncpy_#t~post4.base|) 0)
 (*
 (+ |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)|
 |ray_(ite (select #valid cstpncpy_~#dst.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) cstpncpy_#in~dst.base)|
 |ray_(select old(#length) cstpncpy_#in~dst.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)|
 |ray_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)|) 0)
 (* (+ |honda_cstpncpy_#t~post5.offset| |ray_cstpncpy_#t~post5.offset|) 0)
 (*
 (+ |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)|
 |ray_(ite (select #valid cstpncpy_#in~src.base) 1 0)|) 0)
 (* (+ |honda_cstpncpy_#in~dst.offset| |ray_cstpncpy_#in~dst.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)|
 |ray_(ite (select #valid cstpncpy_~s~3.base) 1 0)|) 0)
 (* (+ honda_cstpncpy_~src.base ray_cstpncpy_~src.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ honda_cstpncpy_~d~3.offset ray_cstpncpy_~d~3.offset) 0)
 (* (+ |honda_cstpncpy_#t~post3| |ray_cstpncpy_#t~post3|) 0)
 (* (+ |honda_cstpncpy_~#dst.base| |ray_cstpncpy_~#dst.base|) 0)
 (* (+ honda_cstpncpy_~src.offset ray_cstpncpy_~src.offset) 0)
 (* (+ |honda_cstpncpy_#in~src.base| |ray_cstpncpy_#in~src.base|) 0)
 (*
 (+
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 |ray_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)|
 |ray_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)|) 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0) 
 (* honda_cstpncpy_~d~3.base 0) 
 (* |honda_cstpncpy_#t~post5.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* aux_3698 (- 1)) 4294967295) 0)
 (>=
 (+ (* (+ |honda_cstpncpy_#t~mem0.offset| |ray_cstpncpy_#t~mem0.offset|) 0)
 (*
 (+ |honda_(select #length cstpncpy_~d~3.base)|
 |ray_(select #length cstpncpy_~d~3.base)|) 0)
 (* (+ |honda_cstpncpy_#t~post4.offset| |ray_cstpncpy_#t~post4.offset|) 0)
 (* (+ honda_cstpncpy_~s~3.offset ray_cstpncpy_~s~3.offset) 0)
 (*
 (+
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 |ray_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|)
 0)
 (*
 (+ |honda_(select old(#length) cstpncpy_#in~src.base)|
 |ray_(select old(#length) cstpncpy_#in~src.base)|) 0)
 (* (+ |honda_cstpncpy_~#dst.offset| |ray_cstpncpy_~#dst.offset|) 0)
 (*
 (+
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 |ray_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|)
 0) (* (+ |honda_cstpncpy_#t~mem7| |ray_cstpncpy_#t~mem7|) 0)
 (*
 (+
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 |ray_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|)
 0) (* (+ honda_cstpncpy_~d~3.base ray_cstpncpy_~d~3.base) 0)
 (*
 (+
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 |ray_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|)
 0)
 (*
 (+ |honda_(select #length cstpncpy_#in~src.base)|
 |ray_(select #length cstpncpy_#in~src.base)|) 0)
 (* (+ |honda_cstpncpy_#in~src.offset| |ray_cstpncpy_#in~src.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)|
 |ray_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)|) 0)
 (* (+ |honda_cstpncpy_#t~mem1.offset| |ray_cstpncpy_#t~mem1.offset|) 0)
 (*
 (+ |honda_(select #length cstpncpy_#in~dst.base)|
 |ray_(select #length cstpncpy_#in~dst.base)|) 0)
 (* (+ |honda_cstpncpy_#t~mem0.base| |ray_cstpncpy_#t~mem0.base|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 |ray_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|)
 0) (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_cstpncpy_#in~n| |ray_cstpncpy_#in~n|) 0)
 (* (+ |honda_cstpncpy_#t~mem1.base| |ray_cstpncpy_#t~mem1.base|) 0)
 (* (+ |honda_cstpncpy_#t~post5.base| |ray_cstpncpy_#t~post5.base|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(select old(#length) cstpncpy_~#dst.base)|
 |ray_(select old(#length) cstpncpy_~#dst.base)|) 0)
 (*
 (+ |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)|
 |ray_(ite (select #valid cstpncpy_~d~3.base) 1 0)|) 0)
 (* (+ honda_cstpncpy_~s~3.base ray_cstpncpy_~s~3.base) 0)
 (*
 (+
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 |ray_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|)
 0)
 (*
 (+ |honda_(select #length cstpncpy_~s~3.base)|
 |ray_(select #length cstpncpy_~s~3.base)|) 0)
 (* (+ honda_cstpncpy_~n ray_cstpncpy_~n) 0)
 (* (+ |honda_cstpncpy_#in~dst.base| |ray_cstpncpy_#in~dst.base|) 0)
 (*
 (+ |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)|
 |ray_(ite (select #valid cstpncpy_#in~dst.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length cstpncpy_~#dst.base)|
 |ray_(select #length cstpncpy_~#dst.base)|) 0)
 (* (+ |honda_cstpncpy_#t~post4.base| |ray_cstpncpy_#t~post4.base|) 0)
 (*
 (+ |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)|
 |ray_(ite (select #valid cstpncpy_~#dst.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) cstpncpy_#in~dst.base)|
 |ray_(select old(#length) cstpncpy_#in~dst.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)|
 |ray_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)|) 0)
 (* (+ |honda_cstpncpy_#t~post5.offset| |ray_cstpncpy_#t~post5.offset|) 0)
 (*
 (+ |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)|
 |ray_(ite (select #valid cstpncpy_#in~src.base) 1 0)|) 0)
 (* (+ |honda_cstpncpy_#in~dst.offset| |ray_cstpncpy_#in~dst.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)|
 |ray_(ite (select #valid cstpncpy_~s~3.base) 1 0)|) 0)
 (* (+ honda_cstpncpy_~src.base ray_cstpncpy_~src.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ honda_cstpncpy_~d~3.offset ray_cstpncpy_~d~3.offset) 0)
 (* (+ |honda_cstpncpy_#t~post3| |ray_cstpncpy_#t~post3|) 0)
 (* (+ |honda_cstpncpy_~#dst.base| |ray_cstpncpy_~#dst.base|) 0)
 (* (+ honda_cstpncpy_~src.offset ray_cstpncpy_~src.offset) 0)
 (* (+ |honda_cstpncpy_#in~src.base| |ray_cstpncpy_#in~src.base|) 0)
 (*
 (+
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 |ray_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)|
 |ray_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)|) 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0) 
 (* honda_cstpncpy_~d~3.base 0) 
 (* |honda_cstpncpy_#t~post5.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 1) (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* aux_3698 (- 1)) (* aux_3699 (- 4294967296)) 
 (- 1)) 0)
 (>=
 (+ (* (+ |honda_cstpncpy_#t~mem0.offset| |ray_cstpncpy_#t~mem0.offset|) 0)
 (*
 (+ |honda_(select #length cstpncpy_~d~3.base)|
 |ray_(select #length cstpncpy_~d~3.base)|) 0)
 (* (+ |honda_cstpncpy_#t~post4.offset| |ray_cstpncpy_#t~post4.offset|) 0)
 (* (+ honda_cstpncpy_~s~3.offset ray_cstpncpy_~s~3.offset) 0)
 (*
 (+
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 |ray_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|)
 0)
 (*
 (+ |honda_(select old(#length) cstpncpy_#in~src.base)|
 |ray_(select old(#length) cstpncpy_#in~src.base)|) 0)
 (* (+ |honda_cstpncpy_~#dst.offset| |ray_cstpncpy_~#dst.offset|) 0)
 (*
 (+
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 |ray_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|)
 0) (* (+ |honda_cstpncpy_#t~mem7| |ray_cstpncpy_#t~mem7|) 0)
 (*
 (+
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 |ray_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|)
 0) (* (+ honda_cstpncpy_~d~3.base ray_cstpncpy_~d~3.base) 0)
 (*
 (+
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 |ray_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|)
 0)
 (*
 (+ |honda_(select #length cstpncpy_#in~src.base)|
 |ray_(select #length cstpncpy_#in~src.base)|) 0)
 (* (+ |honda_cstpncpy_#in~src.offset| |ray_cstpncpy_#in~src.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)|
 |ray_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)|) 0)
 (* (+ |honda_cstpncpy_#t~mem1.offset| |ray_cstpncpy_#t~mem1.offset|) 0)
 (*
 (+ |honda_(select #length cstpncpy_#in~dst.base)|
 |ray_(select #length cstpncpy_#in~dst.base)|) 0)
 (* (+ |honda_cstpncpy_#t~mem0.base| |ray_cstpncpy_#t~mem0.base|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 |ray_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|)
 0) (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_cstpncpy_#in~n| |ray_cstpncpy_#in~n|) 0)
 (* (+ |honda_cstpncpy_#t~mem1.base| |ray_cstpncpy_#t~mem1.base|) 0)
 (* (+ |honda_cstpncpy_#t~post5.base| |ray_cstpncpy_#t~post5.base|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(select old(#length) cstpncpy_~#dst.base)|
 |ray_(select old(#length) cstpncpy_~#dst.base)|) 0)
 (*
 (+ |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)|
 |ray_(ite (select #valid cstpncpy_~d~3.base) 1 0)|) 0)
 (* (+ honda_cstpncpy_~s~3.base ray_cstpncpy_~s~3.base) 0)
 (*
 (+
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 |ray_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|)
 0)
 (*
 (+ |honda_(select #length cstpncpy_~s~3.base)|
 |ray_(select #length cstpncpy_~s~3.base)|) 0)
 (* (+ honda_cstpncpy_~n ray_cstpncpy_~n) 0)
 (* (+ |honda_cstpncpy_#in~dst.base| |ray_cstpncpy_#in~dst.base|) 0)
 (*
 (+ |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)|
 |ray_(ite (select #valid cstpncpy_#in~dst.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length cstpncpy_~#dst.base)|
 |ray_(select #length cstpncpy_~#dst.base)|) 0)
 (* (+ |honda_cstpncpy_#t~post4.base| |ray_cstpncpy_#t~post4.base|) 0)
 (*
 (+ |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)|
 |ray_(ite (select #valid cstpncpy_~#dst.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) cstpncpy_#in~dst.base)|
 |ray_(select old(#length) cstpncpy_#in~dst.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)|
 |ray_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)|) 0)
 (* (+ |honda_cstpncpy_#t~post5.offset| |ray_cstpncpy_#t~post5.offset|) 0)
 (*
 (+ |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)|
 |ray_(ite (select #valid cstpncpy_#in~src.base) 1 0)|) 0)
 (* (+ |honda_cstpncpy_#in~dst.offset| |ray_cstpncpy_#in~dst.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)|
 |ray_(ite (select #valid cstpncpy_~s~3.base) 1 0)|) 0)
 (* (+ honda_cstpncpy_~src.base ray_cstpncpy_~src.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ honda_cstpncpy_~d~3.offset ray_cstpncpy_~d~3.offset) 0)
 (* (+ |honda_cstpncpy_#t~post3| |ray_cstpncpy_#t~post3|) 0)
 (* (+ |honda_cstpncpy_~#dst.base| |ray_cstpncpy_~#dst.base|) 0)
 (* (+ honda_cstpncpy_~src.offset ray_cstpncpy_~src.offset) 0)
 (* (+ |honda_cstpncpy_#in~src.base| |ray_cstpncpy_#in~src.base|) 0)
 (*
 (+
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 |ray_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)|
 |ray_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)|) 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0) 
 (* honda_cstpncpy_~d~3.base 0) 
 (* |honda_cstpncpy_#t~post5.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* aux_3703 (- 1)) (* aux_3704 (- 4294967296)) 0) 0)
 (>=
 (+ (* (+ |honda_cstpncpy_#t~mem0.offset| |ray_cstpncpy_#t~mem0.offset|) 0)
 (*
 (+ |honda_(select #length cstpncpy_~d~3.base)|
 |ray_(select #length cstpncpy_~d~3.base)|) 0)
 (* (+ |honda_cstpncpy_#t~post4.offset| |ray_cstpncpy_#t~post4.offset|) 0)
 (* (+ honda_cstpncpy_~s~3.offset ray_cstpncpy_~s~3.offset) 0)
 (*
 (+
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 |ray_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|)
 0)
 (*
 (+ |honda_(select old(#length) cstpncpy_#in~src.base)|
 |ray_(select old(#length) cstpncpy_#in~src.base)|) 0)
 (* (+ |honda_cstpncpy_~#dst.offset| |ray_cstpncpy_~#dst.offset|) 0)
 (*
 (+
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 |ray_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|)
 0) (* (+ |honda_cstpncpy_#t~mem7| |ray_cstpncpy_#t~mem7|) 0)
 (*
 (+
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 |ray_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|)
 0) (* (+ honda_cstpncpy_~d~3.base ray_cstpncpy_~d~3.base) 0)
 (*
 (+
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 |ray_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|)
 0)
 (*
 (+ |honda_(select #length cstpncpy_#in~src.base)|
 |ray_(select #length cstpncpy_#in~src.base)|) 0)
 (* (+ |honda_cstpncpy_#in~src.offset| |ray_cstpncpy_#in~src.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)|
 |ray_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)|) 0)
 (* (+ |honda_cstpncpy_#t~mem1.offset| |ray_cstpncpy_#t~mem1.offset|) 0)
 (*
 (+ |honda_(select #length cstpncpy_#in~dst.base)|
 |ray_(select #length cstpncpy_#in~dst.base)|) 0)
 (* (+ |honda_cstpncpy_#t~mem0.base| |ray_cstpncpy_#t~mem0.base|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 |ray_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|)
 0) (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_cstpncpy_#in~n| |ray_cstpncpy_#in~n|) 0)
 (* (+ |honda_cstpncpy_#t~mem1.base| |ray_cstpncpy_#t~mem1.base|) 0)
 (* (+ |honda_cstpncpy_#t~post5.base| |ray_cstpncpy_#t~post5.base|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(select old(#length) cstpncpy_~#dst.base)|
 |ray_(select old(#length) cstpncpy_~#dst.base)|) 0)
 (*
 (+ |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)|
 |ray_(ite (select #valid cstpncpy_~d~3.base) 1 0)|) 0)
 (* (+ honda_cstpncpy_~s~3.base ray_cstpncpy_~s~3.base) 0)
 (*
 (+
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 |ray_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|)
 0)
 (*
 (+ |honda_(select #length cstpncpy_~s~3.base)|
 |ray_(select #length cstpncpy_~s~3.base)|) 0)
 (* (+ honda_cstpncpy_~n ray_cstpncpy_~n) 0)
 (* (+ |honda_cstpncpy_#in~dst.base| |ray_cstpncpy_#in~dst.base|) 0)
 (*
 (+ |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)|
 |ray_(ite (select #valid cstpncpy_#in~dst.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length cstpncpy_~#dst.base)|
 |ray_(select #length cstpncpy_~#dst.base)|) 0)
 (* (+ |honda_cstpncpy_#t~post4.base| |ray_cstpncpy_#t~post4.base|) 0)
 (*
 (+ |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)|
 |ray_(ite (select #valid cstpncpy_~#dst.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) cstpncpy_#in~dst.base)|
 |ray_(select old(#length) cstpncpy_#in~dst.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)|
 |ray_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)|) 0)
 (* (+ |honda_cstpncpy_#t~post5.offset| |ray_cstpncpy_#t~post5.offset|) 0)
 (*
 (+ |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)|
 |ray_(ite (select #valid cstpncpy_#in~src.base) 1 0)|) 0)
 (* (+ |honda_cstpncpy_#in~dst.offset| |ray_cstpncpy_#in~dst.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)|
 |ray_(ite (select #valid cstpncpy_~s~3.base) 1 0)|) 0)
 (* (+ honda_cstpncpy_~src.base ray_cstpncpy_~src.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ honda_cstpncpy_~d~3.offset ray_cstpncpy_~d~3.offset) 0)
 (* (+ |honda_cstpncpy_#t~post3| |ray_cstpncpy_#t~post3|) 0)
 (* (+ |honda_cstpncpy_~#dst.base| |ray_cstpncpy_~#dst.base|) 0)
 (* (+ honda_cstpncpy_~src.offset ray_cstpncpy_~src.offset) 0)
 (* (+ |honda_cstpncpy_#in~src.base| |ray_cstpncpy_#in~src.base|) 0)
 (*
 (+
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 |ray_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)|
 |ray_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)|) 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0) 
 (* honda_cstpncpy_~d~3.base 0) 
 (* |honda_cstpncpy_#t~post5.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* aux_3703 1) (* aux_3704 4294967296) 0) 0)
 (>=
 (+ (* (+ |honda_cstpncpy_#t~mem0.offset| |ray_cstpncpy_#t~mem0.offset|) 0)
 (*
 (+ |honda_(select #length cstpncpy_~d~3.base)|
 |ray_(select #length cstpncpy_~d~3.base)|) 0)
 (* (+ |honda_cstpncpy_#t~post4.offset| |ray_cstpncpy_#t~post4.offset|) 0)
 (* (+ honda_cstpncpy_~s~3.offset ray_cstpncpy_~s~3.offset) 0)
 (*
 (+
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 |ray_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|)
 0)
 (*
 (+ |honda_(select old(#length) cstpncpy_#in~src.base)|
 |ray_(select old(#length) cstpncpy_#in~src.base)|) 0)
 (* (+ |honda_cstpncpy_~#dst.offset| |ray_cstpncpy_~#dst.offset|) 0)
 (*
 (+
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 |ray_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|)
 0) (* (+ |honda_cstpncpy_#t~mem7| |ray_cstpncpy_#t~mem7|) 0)
 (*
 (+
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 |ray_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|)
 0) (* (+ honda_cstpncpy_~d~3.base ray_cstpncpy_~d~3.base) 0)
 (*
 (+
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 |ray_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|)
 0)
 (*
 (+ |honda_(select #length cstpncpy_#in~src.base)|
 |ray_(select #length cstpncpy_#in~src.base)|) 0)
 (* (+ |honda_cstpncpy_#in~src.offset| |ray_cstpncpy_#in~src.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)|
 |ray_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)|) 0)
 (* (+ |honda_cstpncpy_#t~mem1.offset| |ray_cstpncpy_#t~mem1.offset|) 0)
 (*
 (+ |honda_(select #length cstpncpy_#in~dst.base)|
 |ray_(select #length cstpncpy_#in~dst.base)|) 0)
 (* (+ |honda_cstpncpy_#t~mem0.base| |ray_cstpncpy_#t~mem0.base|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 |ray_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|)
 0) (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_cstpncpy_#in~n| |ray_cstpncpy_#in~n|) 0)
 (* (+ |honda_cstpncpy_#t~mem1.base| |ray_cstpncpy_#t~mem1.base|) 0)
 (* (+ |honda_cstpncpy_#t~post5.base| |ray_cstpncpy_#t~post5.base|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(select old(#length) cstpncpy_~#dst.base)|
 |ray_(select old(#length) cstpncpy_~#dst.base)|) 0)
 (*
 (+ |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)|
 |ray_(ite (select #valid cstpncpy_~d~3.base) 1 0)|) 0)
 (* (+ honda_cstpncpy_~s~3.base ray_cstpncpy_~s~3.base) 0)
 (*
 (+
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 |ray_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|)
 0)
 (*
 (+ |honda_(select #length cstpncpy_~s~3.base)|
 |ray_(select #length cstpncpy_~s~3.base)|) 0)
 (* (+ honda_cstpncpy_~n ray_cstpncpy_~n) 0)
 (* (+ |honda_cstpncpy_#in~dst.base| |ray_cstpncpy_#in~dst.base|) 0)
 (*
 (+ |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)|
 |ray_(ite (select #valid cstpncpy_#in~dst.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length cstpncpy_~#dst.base)|
 |ray_(select #length cstpncpy_~#dst.base)|) 0)
 (* (+ |honda_cstpncpy_#t~post4.base| |ray_cstpncpy_#t~post4.base|) 0)
 (*
 (+ |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)|
 |ray_(ite (select #valid cstpncpy_~#dst.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) cstpncpy_#in~dst.base)|
 |ray_(select old(#length) cstpncpy_#in~dst.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)|
 |ray_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)|) 0)
 (* (+ |honda_cstpncpy_#t~post5.offset| |ray_cstpncpy_#t~post5.offset|) 0)
 (*
 (+ |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)|
 |ray_(ite (select #valid cstpncpy_#in~src.base) 1 0)|) 0)
 (* (+ |honda_cstpncpy_#in~dst.offset| |ray_cstpncpy_#in~dst.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)|
 |ray_(ite (select #valid cstpncpy_~s~3.base) 1 0)|) 0)
 (* (+ honda_cstpncpy_~src.base ray_cstpncpy_~src.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ honda_cstpncpy_~d~3.offset ray_cstpncpy_~d~3.offset) 0)
 (* (+ |honda_cstpncpy_#t~post3| |ray_cstpncpy_#t~post3|) 0)
 (* (+ |honda_cstpncpy_~#dst.base| |ray_cstpncpy_~#dst.base|) 0)
 (* (+ honda_cstpncpy_~src.offset ray_cstpncpy_~src.offset) 0)
 (* (+ |honda_cstpncpy_#in~src.base| |ray_cstpncpy_#in~src.base|) 0)
 (*
 (+
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 |ray_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)|
 |ray_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)|) 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0) 
 (* honda_cstpncpy_~d~3.base 0) 
 (* |honda_cstpncpy_#t~post5.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* aux_3703 1) 0) 0)
 (>=
 (+ (* (+ |honda_cstpncpy_#t~mem0.offset| |ray_cstpncpy_#t~mem0.offset|) 0)
 (*
 (+ |honda_(select #length cstpncpy_~d~3.base)|
 |ray_(select #length cstpncpy_~d~3.base)|) 1)
 (* (+ |honda_cstpncpy_#t~post4.offset| |ray_cstpncpy_#t~post4.offset|) 0)
 (* (+ honda_cstpncpy_~s~3.offset ray_cstpncpy_~s~3.offset) 0)
 (*
 (+
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 |ray_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|)
 0)
 (*
 (+ |honda_(select old(#length) cstpncpy_#in~src.base)|
 |ray_(select old(#length) cstpncpy_#in~src.base)|) 0)
 (* (+ |honda_cstpncpy_~#dst.offset| |ray_cstpncpy_~#dst.offset|) 0)
 (*
 (+
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 |ray_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|)
 0) (* (+ |honda_cstpncpy_#t~mem7| |ray_cstpncpy_#t~mem7|) 0)
 (*
 (+
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 |ray_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|)
 0) (* (+ honda_cstpncpy_~d~3.base ray_cstpncpy_~d~3.base) 0)
 (*
 (+
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 |ray_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|)
 0)
 (*
 (+ |honda_(select #length cstpncpy_#in~src.base)|
 |ray_(select #length cstpncpy_#in~src.base)|) 0)
 (* (+ |honda_cstpncpy_#in~src.offset| |ray_cstpncpy_#in~src.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)|
 |ray_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)|) 0)
 (* (+ |honda_cstpncpy_#t~mem1.offset| |ray_cstpncpy_#t~mem1.offset|) 0)
 (*
 (+ |honda_(select #length cstpncpy_#in~dst.base)|
 |ray_(select #length cstpncpy_#in~dst.base)|) 0)
 (* (+ |honda_cstpncpy_#t~mem0.base| |ray_cstpncpy_#t~mem0.base|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 |ray_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|)
 0) (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_cstpncpy_#in~n| |ray_cstpncpy_#in~n|) 0)
 (* (+ |honda_cstpncpy_#t~mem1.base| |ray_cstpncpy_#t~mem1.base|) 0)
 (* (+ |honda_cstpncpy_#t~post5.base| |ray_cstpncpy_#t~post5.base|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(select old(#length) cstpncpy_~#dst.base)|
 |ray_(select old(#length) cstpncpy_~#dst.base)|) 0)
 (*
 (+ |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)|
 |ray_(ite (select #valid cstpncpy_~d~3.base) 1 0)|) 0)
 (* (+ honda_cstpncpy_~s~3.base ray_cstpncpy_~s~3.base) 0)
 (*
 (+
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 |ray_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|)
 0)
 (*
 (+ |honda_(select #length cstpncpy_~s~3.base)|
 |ray_(select #length cstpncpy_~s~3.base)|) 0)
 (* (+ honda_cstpncpy_~n ray_cstpncpy_~n) 0)
 (* (+ |honda_cstpncpy_#in~dst.base| |ray_cstpncpy_#in~dst.base|) 0)
 (*
 (+ |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)|
 |ray_(ite (select #valid cstpncpy_#in~dst.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length cstpncpy_~#dst.base)|
 |ray_(select #length cstpncpy_~#dst.base)|) 0)
 (* (+ |honda_cstpncpy_#t~post4.base| |ray_cstpncpy_#t~post4.base|) 0)
 (*
 (+ |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)|
 |ray_(ite (select #valid cstpncpy_~#dst.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) cstpncpy_#in~dst.base)|
 |ray_(select old(#length) cstpncpy_#in~dst.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)|
 |ray_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)|) 0)
 (* (+ |honda_cstpncpy_#t~post5.offset| |ray_cstpncpy_#t~post5.offset|) 0)
 (*
 (+ |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)|
 |ray_(ite (select #valid cstpncpy_#in~src.base) 1 0)|) 0)
 (* (+ |honda_cstpncpy_#in~dst.offset| |ray_cstpncpy_#in~dst.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)|
 |ray_(ite (select #valid cstpncpy_~s~3.base) 1 0)|) 0)
 (* (+ honda_cstpncpy_~src.base ray_cstpncpy_~src.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ honda_cstpncpy_~d~3.offset ray_cstpncpy_~d~3.offset) 0)
 (* (+ |honda_cstpncpy_#t~post3| |ray_cstpncpy_#t~post3|) 0)
 (* (+ |honda_cstpncpy_~#dst.base| |ray_cstpncpy_~#dst.base|) 0)
 (* (+ honda_cstpncpy_~src.offset ray_cstpncpy_~src.offset) 0)
 (* (+ |honda_cstpncpy_#in~src.base| |ray_cstpncpy_#in~src.base|) 0)
 (*
 (+
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 |ray_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)|
 |ray_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)|) 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| (- 1))
 (* |honda_cstpncpy_#t~post4.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0) 
 (* honda_cstpncpy_~d~3.base 0) 
 (* |honda_cstpncpy_#t~post5.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 0) 0)
 (>=
 (+ (* (+ |honda_cstpncpy_#t~mem0.offset| |ray_cstpncpy_#t~mem0.offset|) 0)
 (*
 (+ |honda_(select #length cstpncpy_~d~3.base)|
 |ray_(select #length cstpncpy_~d~3.base)|) 0)
 (* (+ |honda_cstpncpy_#t~post4.offset| |ray_cstpncpy_#t~post4.offset|) 0)
 (* (+ honda_cstpncpy_~s~3.offset ray_cstpncpy_~s~3.offset) 0)
 (*
 (+
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 |ray_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|)
 0)
 (*
 (+ |honda_(select old(#length) cstpncpy_#in~src.base)|
 |ray_(select old(#length) cstpncpy_#in~src.base)|) 0)
 (* (+ |honda_cstpncpy_~#dst.offset| |ray_cstpncpy_~#dst.offset|) 0)
 (*
 (+
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 |ray_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|)
 0) (* (+ |honda_cstpncpy_#t~mem7| |ray_cstpncpy_#t~mem7|) 0)
 (*
 (+
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 |ray_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|)
 0) (* (+ honda_cstpncpy_~d~3.base ray_cstpncpy_~d~3.base) 0)
 (*
 (+
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 |ray_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|)
 0)
 (*
 (+ |honda_(select #length cstpncpy_#in~src.base)|
 |ray_(select #length cstpncpy_#in~src.base)|) 0)
 (* (+ |honda_cstpncpy_#in~src.offset| |ray_cstpncpy_#in~src.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)|
 |ray_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)|) 0)
 (* (+ |honda_cstpncpy_#t~mem1.offset| |ray_cstpncpy_#t~mem1.offset|) 0)
 (*
 (+ |honda_(select #length cstpncpy_#in~dst.base)|
 |ray_(select #length cstpncpy_#in~dst.base)|) 0)
 (* (+ |honda_cstpncpy_#t~mem0.base| |ray_cstpncpy_#t~mem0.base|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 |ray_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|)
 0) (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_cstpncpy_#in~n| |ray_cstpncpy_#in~n|) 0)
 (* (+ |honda_cstpncpy_#t~mem1.base| |ray_cstpncpy_#t~mem1.base|) 0)
 (* (+ |honda_cstpncpy_#t~post5.base| |ray_cstpncpy_#t~post5.base|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(select old(#length) cstpncpy_~#dst.base)|
 |ray_(select old(#length) cstpncpy_~#dst.base)|) 0)
 (*
 (+ |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)|
 |ray_(ite (select #valid cstpncpy_~d~3.base) 1 0)|) 0)
 (* (+ honda_cstpncpy_~s~3.base ray_cstpncpy_~s~3.base) (- 1))
 (*
 (+
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 |ray_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|)
 0)
 (*
 (+ |honda_(select #length cstpncpy_~s~3.base)|
 |ray_(select #length cstpncpy_~s~3.base)|) 0)
 (* (+ honda_cstpncpy_~n ray_cstpncpy_~n) 0)
 (* (+ |honda_cstpncpy_#in~dst.base| |ray_cstpncpy_#in~dst.base|) 0)
 (*
 (+ |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)|
 |ray_(ite (select #valid cstpncpy_#in~dst.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length cstpncpy_~#dst.base)|
 |ray_(select #length cstpncpy_~#dst.base)|) 0)
 (* (+ |honda_cstpncpy_#t~post4.base| |ray_cstpncpy_#t~post4.base|) 0)
 (*
 (+ |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)|
 |ray_(ite (select #valid cstpncpy_~#dst.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) cstpncpy_#in~dst.base)|
 |ray_(select old(#length) cstpncpy_#in~dst.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)|
 |ray_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)|) 0)
 (* (+ |honda_cstpncpy_#t~post5.offset| |ray_cstpncpy_#t~post5.offset|) 0)
 (*
 (+ |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)|
 |ray_(ite (select #valid cstpncpy_#in~src.base) 1 0)|) 0)
 (* (+ |honda_cstpncpy_#in~dst.offset| |ray_cstpncpy_#in~dst.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)|
 |ray_(ite (select #valid cstpncpy_~s~3.base) 1 0)|) 0)
 (* (+ honda_cstpncpy_~src.base ray_cstpncpy_~src.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ honda_cstpncpy_~d~3.offset ray_cstpncpy_~d~3.offset) 0)
 (* (+ |honda_cstpncpy_#t~post3| |ray_cstpncpy_#t~post3|) 0)
 (* (+ |honda_cstpncpy_~#dst.base| |ray_cstpncpy_~#dst.base|) 0)
 (* (+ honda_cstpncpy_~src.offset ray_cstpncpy_~src.offset) 0)
 (* (+ |honda_cstpncpy_#in~src.base| |ray_cstpncpy_#in~src.base|) 0)
 (*
 (+
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 |ray_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)|
 |ray_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)|) 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0) 
 (* honda_cstpncpy_~d~3.base 0) 
 (* |honda_cstpncpy_#t~post5.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (* honda_cstpncpy_~s~3.base 1)
 (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 0) 0)
 (>=
 (+ (* (+ |honda_cstpncpy_#t~mem0.offset| |ray_cstpncpy_#t~mem0.offset|) 0)
 (*
 (+ |honda_(select #length cstpncpy_~d~3.base)|
 |ray_(select #length cstpncpy_~d~3.base)|) 0)
 (* (+ |honda_cstpncpy_#t~post4.offset| |ray_cstpncpy_#t~post4.offset|) 0)
 (* (+ honda_cstpncpy_~s~3.offset ray_cstpncpy_~s~3.offset) 1)
 (*
 (+
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 |ray_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|)
 0)
 (*
 (+ |honda_(select old(#length) cstpncpy_#in~src.base)|
 |ray_(select old(#length) cstpncpy_#in~src.base)|) 0)
 (* (+ |honda_cstpncpy_~#dst.offset| |ray_cstpncpy_~#dst.offset|) 0)
 (*
 (+
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 |ray_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|)
 0) (* (+ |honda_cstpncpy_#t~mem7| |ray_cstpncpy_#t~mem7|) 0)
 (*
 (+
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 |ray_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|)
 0) (* (+ honda_cstpncpy_~d~3.base ray_cstpncpy_~d~3.base) 0)
 (*
 (+
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 |ray_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|)
 0)
 (*
 (+ |honda_(select #length cstpncpy_#in~src.base)|
 |ray_(select #length cstpncpy_#in~src.base)|) 0)
 (* (+ |honda_cstpncpy_#in~src.offset| |ray_cstpncpy_#in~src.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)|
 |ray_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)|) 0)
 (* (+ |honda_cstpncpy_#t~mem1.offset| |ray_cstpncpy_#t~mem1.offset|) 0)
 (*
 (+ |honda_(select #length cstpncpy_#in~dst.base)|
 |ray_(select #length cstpncpy_#in~dst.base)|) 0)
 (* (+ |honda_cstpncpy_#t~mem0.base| |ray_cstpncpy_#t~mem0.base|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 |ray_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|)
 0) (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_cstpncpy_#in~n| |ray_cstpncpy_#in~n|) 0)
 (* (+ |honda_cstpncpy_#t~mem1.base| |ray_cstpncpy_#t~mem1.base|) 0)
 (* (+ |honda_cstpncpy_#t~post5.base| |ray_cstpncpy_#t~post5.base|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(select old(#length) cstpncpy_~#dst.base)|
 |ray_(select old(#length) cstpncpy_~#dst.base)|) 0)
 (*
 (+ |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)|
 |ray_(ite (select #valid cstpncpy_~d~3.base) 1 0)|) 0)
 (* (+ honda_cstpncpy_~s~3.base ray_cstpncpy_~s~3.base) 0)
 (*
 (+
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 |ray_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|)
 0)
 (*
 (+ |honda_(select #length cstpncpy_~s~3.base)|
 |ray_(select #length cstpncpy_~s~3.base)|) 0)
 (* (+ honda_cstpncpy_~n ray_cstpncpy_~n) 0)
 (* (+ |honda_cstpncpy_#in~dst.base| |ray_cstpncpy_#in~dst.base|) 0)
 (*
 (+ |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)|
 |ray_(ite (select #valid cstpncpy_#in~dst.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length cstpncpy_~#dst.base)|
 |ray_(select #length cstpncpy_~#dst.base)|) 0)
 (* (+ |honda_cstpncpy_#t~post4.base| |ray_cstpncpy_#t~post4.base|) 0)
 (*
 (+ |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)|
 |ray_(ite (select #valid cstpncpy_~#dst.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) cstpncpy_#in~dst.base)|
 |ray_(select old(#length) cstpncpy_#in~dst.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)|
 |ray_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)|) 0)
 (* (+ |honda_cstpncpy_#t~post5.offset| |ray_cstpncpy_#t~post5.offset|) 0)
 (*
 (+ |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)|
 |ray_(ite (select #valid cstpncpy_#in~src.base) 1 0)|) 0)
 (* (+ |honda_cstpncpy_#in~dst.offset| |ray_cstpncpy_#in~dst.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)|
 |ray_(ite (select #valid cstpncpy_~s~3.base) 1 0)|) 0)
 (* (+ honda_cstpncpy_~src.base ray_cstpncpy_~src.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ honda_cstpncpy_~d~3.offset ray_cstpncpy_~d~3.offset) 0)
 (* (+ |honda_cstpncpy_#t~post3| |ray_cstpncpy_#t~post3|) 0)
 (* (+ |honda_cstpncpy_~#dst.base| |ray_cstpncpy_~#dst.base|) 0)
 (* (+ honda_cstpncpy_~src.offset ray_cstpncpy_~src.offset) 0)
 (* (+ |honda_cstpncpy_#in~src.base| |ray_cstpncpy_#in~src.base|) 0)
 (*
 (+
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 |ray_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)|
 |ray_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)|) 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0) 
 (* honda_cstpncpy_~s~3.offset (- 1))
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0) 
 (* honda_cstpncpy_~d~3.base 0) 
 (* |honda_cstpncpy_#t~post5.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (- 1)) 0)
 (>=
 (+ (* (+ |honda_cstpncpy_#t~mem0.offset| |ray_cstpncpy_#t~mem0.offset|) 0)
 (*
 (+ |honda_(select #length cstpncpy_~d~3.base)|
 |ray_(select #length cstpncpy_~d~3.base)|) 0)
 (* (+ |honda_cstpncpy_#t~post4.offset| |ray_cstpncpy_#t~post4.offset|) 0)
 (* (+ honda_cstpncpy_~s~3.offset ray_cstpncpy_~s~3.offset) 0)
 (*
 (+
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 |ray_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|)
 0)
 (*
 (+ |honda_(select old(#length) cstpncpy_#in~src.base)|
 |ray_(select old(#length) cstpncpy_#in~src.base)|) 0)
 (* (+ |honda_cstpncpy_~#dst.offset| |ray_cstpncpy_~#dst.offset|) 0)
 (*
 (+
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 |ray_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|)
 0) (* (+ |honda_cstpncpy_#t~mem7| |ray_cstpncpy_#t~mem7|) 0)
 (*
 (+
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 |ray_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|)
 0) (* (+ honda_cstpncpy_~d~3.base ray_cstpncpy_~d~3.base) 0)
 (*
 (+
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 |ray_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|)
 0)
 (*
 (+ |honda_(select #length cstpncpy_#in~src.base)|
 |ray_(select #length cstpncpy_#in~src.base)|) 0)
 (* (+ |honda_cstpncpy_#in~src.offset| |ray_cstpncpy_#in~src.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)|
 |ray_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)|) 0)
 (* (+ |honda_cstpncpy_#t~mem1.offset| |ray_cstpncpy_#t~mem1.offset|) 0)
 (*
 (+ |honda_(select #length cstpncpy_#in~dst.base)|
 |ray_(select #length cstpncpy_#in~dst.base)|) 0)
 (* (+ |honda_cstpncpy_#t~mem0.base| |ray_cstpncpy_#t~mem0.base|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 |ray_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|)
 0) (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_cstpncpy_#in~n| |ray_cstpncpy_#in~n|) 0)
 (* (+ |honda_cstpncpy_#t~mem1.base| |ray_cstpncpy_#t~mem1.base|) 0)
 (* (+ |honda_cstpncpy_#t~post5.base| |ray_cstpncpy_#t~post5.base|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(select old(#length) cstpncpy_~#dst.base)|
 |ray_(select old(#length) cstpncpy_~#dst.base)|) 0)
 (*
 (+ |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)|
 |ray_(ite (select #valid cstpncpy_~d~3.base) 1 0)|) 0)
 (* (+ honda_cstpncpy_~s~3.base ray_cstpncpy_~s~3.base) 0)
 (*
 (+
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 |ray_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|)
 0)
 (*
 (+ |honda_(select #length cstpncpy_~s~3.base)|
 |ray_(select #length cstpncpy_~s~3.base)|) 0)
 (* (+ honda_cstpncpy_~n ray_cstpncpy_~n) 0)
 (* (+ |honda_cstpncpy_#in~dst.base| |ray_cstpncpy_#in~dst.base|) 0)
 (*
 (+ |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)|
 |ray_(ite (select #valid cstpncpy_#in~dst.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length cstpncpy_~#dst.base)|
 |ray_(select #length cstpncpy_~#dst.base)|) 0)
 (* (+ |honda_cstpncpy_#t~post4.base| |ray_cstpncpy_#t~post4.base|) 0)
 (*
 (+ |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)|
 |ray_(ite (select #valid cstpncpy_~#dst.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) cstpncpy_#in~dst.base)|
 |ray_(select old(#length) cstpncpy_#in~dst.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)|
 |ray_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)|) 0)
 (* (+ |honda_cstpncpy_#t~post5.offset| |ray_cstpncpy_#t~post5.offset|) 0)
 (*
 (+ |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)|
 |ray_(ite (select #valid cstpncpy_#in~src.base) 1 0)|) 0)
 (* (+ |honda_cstpncpy_#in~dst.offset| |ray_cstpncpy_#in~dst.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)|
 |ray_(ite (select #valid cstpncpy_~s~3.base) 1 0)|) 0)
 (* (+ honda_cstpncpy_~src.base ray_cstpncpy_~src.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ honda_cstpncpy_~d~3.offset ray_cstpncpy_~d~3.offset) 0)
 (* (+ |honda_cstpncpy_#t~post3| |ray_cstpncpy_#t~post3|) 0)
 (* (+ |honda_cstpncpy_~#dst.base| |ray_cstpncpy_~#dst.base|) 0)
 (* (+ honda_cstpncpy_~src.offset ray_cstpncpy_~src.offset) 0)
 (* (+ |honda_cstpncpy_#in~src.base| |ray_cstpncpy_#in~src.base|) 0)
 (*
 (+
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 |ray_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)|
 |ray_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)|) 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0) 
 (* honda_cstpncpy_~d~3.base 0) 
 (* |honda_cstpncpy_#t~post5.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 1)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (- 1)) 0)
 (>=
 (+ (* (+ |honda_cstpncpy_#t~mem0.offset| |ray_cstpncpy_#t~mem0.offset|) 0)
 (*
 (+ |honda_(select #length cstpncpy_~d~3.base)|
 |ray_(select #length cstpncpy_~d~3.base)|) 0)
 (* (+ |honda_cstpncpy_#t~post4.offset| |ray_cstpncpy_#t~post4.offset|) 0)
 (* (+ honda_cstpncpy_~s~3.offset ray_cstpncpy_~s~3.offset) 0)
 (*
 (+
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 |ray_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|)
 0)
 (*
 (+ |honda_(select old(#length) cstpncpy_#in~src.base)|
 |ray_(select old(#length) cstpncpy_#in~src.base)|) 0)
 (* (+ |honda_cstpncpy_~#dst.offset| |ray_cstpncpy_~#dst.offset|) 0)
 (*
 (+
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 |ray_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|)
 0) (* (+ |honda_cstpncpy_#t~mem7| |ray_cstpncpy_#t~mem7|) 0)
 (*
 (+
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 |ray_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|)
 0) (* (+ honda_cstpncpy_~d~3.base ray_cstpncpy_~d~3.base) 0)
 (*
 (+
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 |ray_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|)
 0)
 (*
 (+ |honda_(select #length cstpncpy_#in~src.base)|
 |ray_(select #length cstpncpy_#in~src.base)|) 0)
 (* (+ |honda_cstpncpy_#in~src.offset| |ray_cstpncpy_#in~src.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)|
 |ray_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)|) 0)
 (* (+ |honda_cstpncpy_#t~mem1.offset| |ray_cstpncpy_#t~mem1.offset|) 0)
 (*
 (+ |honda_(select #length cstpncpy_#in~dst.base)|
 |ray_(select #length cstpncpy_#in~dst.base)|) 0)
 (* (+ |honda_cstpncpy_#t~mem0.base| |ray_cstpncpy_#t~mem0.base|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 |ray_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|)
 0) (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_cstpncpy_#in~n| |ray_cstpncpy_#in~n|) 0)
 (* (+ |honda_cstpncpy_#t~mem1.base| |ray_cstpncpy_#t~mem1.base|) 0)
 (* (+ |honda_cstpncpy_#t~post5.base| |ray_cstpncpy_#t~post5.base|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(select old(#length) cstpncpy_~#dst.base)|
 |ray_(select old(#length) cstpncpy_~#dst.base)|) 0)
 (*
 (+ |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)|
 |ray_(ite (select #valid cstpncpy_~d~3.base) 1 0)|) 0)
 (* (+ honda_cstpncpy_~s~3.base ray_cstpncpy_~s~3.base) 0)
 (*
 (+
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 |ray_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|)
 0)
 (*
 (+ |honda_(select #length cstpncpy_~s~3.base)|
 |ray_(select #length cstpncpy_~s~3.base)|) 0)
 (* (+ honda_cstpncpy_~n ray_cstpncpy_~n) 1)
 (* (+ |honda_cstpncpy_#in~dst.base| |ray_cstpncpy_#in~dst.base|) 0)
 (*
 (+ |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)|
 |ray_(ite (select #valid cstpncpy_#in~dst.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length cstpncpy_~#dst.base)|
 |ray_(select #length cstpncpy_~#dst.base)|) 0)
 (* (+ |honda_cstpncpy_#t~post4.base| |ray_cstpncpy_#t~post4.base|) 0)
 (*
 (+ |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)|
 |ray_(ite (select #valid cstpncpy_~#dst.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) cstpncpy_#in~dst.base)|
 |ray_(select old(#length) cstpncpy_#in~dst.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)|
 |ray_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)|) 0)
 (* (+ |honda_cstpncpy_#t~post5.offset| |ray_cstpncpy_#t~post5.offset|) 0)
 (*
 (+ |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)|
 |ray_(ite (select #valid cstpncpy_#in~src.base) 1 0)|) 0)
 (* (+ |honda_cstpncpy_#in~dst.offset| |ray_cstpncpy_#in~dst.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)|
 |ray_(ite (select #valid cstpncpy_~s~3.base) 1 0)|) 0)
 (* (+ honda_cstpncpy_~src.base ray_cstpncpy_~src.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ honda_cstpncpy_~d~3.offset ray_cstpncpy_~d~3.offset) 0)
 (* (+ |honda_cstpncpy_#t~post3| |ray_cstpncpy_#t~post3|) 0)
 (* (+ |honda_cstpncpy_~#dst.base| |ray_cstpncpy_~#dst.base|) 0)
 (* (+ honda_cstpncpy_~src.offset ray_cstpncpy_~src.offset) 0)
 (* (+ |honda_cstpncpy_#in~src.base| |ray_cstpncpy_#in~src.base|) 0)
 (*
 (+
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 |ray_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)|
 |ray_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)|) 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0) 
 (* honda_cstpncpy_~d~3.base 0) 
 (* |honda_cstpncpy_#t~post5.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(select #length cstpncpy_~s~3.base)| 0)
 (* honda_cstpncpy_~n (- 1)) 
 (* |honda_cstpncpy_#t~post4.base| 0) 
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 1) 0)
 (>=
 (+ (* (+ |honda_cstpncpy_#t~mem0.offset| |ray_cstpncpy_#t~mem0.offset|) 0)
 (*
 (+ |honda_(select #length cstpncpy_~d~3.base)|
 |ray_(select #length cstpncpy_~d~3.base)|) 0)
 (* (+ |honda_cstpncpy_#t~post4.offset| |ray_cstpncpy_#t~post4.offset|) 0)
 (* (+ honda_cstpncpy_~s~3.offset ray_cstpncpy_~s~3.offset) 0)
 (*
 (+
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 |ray_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|)
 0)
 (*
 (+ |honda_(select old(#length) cstpncpy_#in~src.base)|
 |ray_(select old(#length) cstpncpy_#in~src.base)|) 0)
 (* (+ |honda_cstpncpy_~#dst.offset| |ray_cstpncpy_~#dst.offset|) 0)
 (*
 (+
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 |ray_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|)
 0) (* (+ |honda_cstpncpy_#t~mem7| |ray_cstpncpy_#t~mem7|) 0)
 (*
 (+
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 |ray_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|)
 0) (* (+ honda_cstpncpy_~d~3.base ray_cstpncpy_~d~3.base) 0)
 (*
 (+
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 |ray_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|)
 0)
 (*
 (+ |honda_(select #length cstpncpy_#in~src.base)|
 |ray_(select #length cstpncpy_#in~src.base)|) 0)
 (* (+ |honda_cstpncpy_#in~src.offset| |ray_cstpncpy_#in~src.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)|
 |ray_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)|) 0)
 (* (+ |honda_cstpncpy_#t~mem1.offset| |ray_cstpncpy_#t~mem1.offset|) 0)
 (*
 (+ |honda_(select #length cstpncpy_#in~dst.base)|
 |ray_(select #length cstpncpy_#in~dst.base)|) 0)
 (* (+ |honda_cstpncpy_#t~mem0.base| |ray_cstpncpy_#t~mem0.base|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 |ray_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|)
 0) (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_cstpncpy_#in~n| |ray_cstpncpy_#in~n|) 0)
 (* (+ |honda_cstpncpy_#t~mem1.base| |ray_cstpncpy_#t~mem1.base|) 0)
 (* (+ |honda_cstpncpy_#t~post5.base| |ray_cstpncpy_#t~post5.base|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(select old(#length) cstpncpy_~#dst.base)|
 |ray_(select old(#length) cstpncpy_~#dst.base)|) 0)
 (*
 (+ |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)|
 |ray_(ite (select #valid cstpncpy_~d~3.base) 1 0)|) 0)
 (* (+ honda_cstpncpy_~s~3.base ray_cstpncpy_~s~3.base) 0)
 (*
 (+
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 |ray_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|)
 0)
 (*
 (+ |honda_(select #length cstpncpy_~s~3.base)|
 |ray_(select #length cstpncpy_~s~3.base)|) 1)
 (* (+ honda_cstpncpy_~n ray_cstpncpy_~n) 0)
 (* (+ |honda_cstpncpy_#in~dst.base| |ray_cstpncpy_#in~dst.base|) 0)
 (*
 (+ |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)|
 |ray_(ite (select #valid cstpncpy_#in~dst.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length cstpncpy_~#dst.base)|
 |ray_(select #length cstpncpy_~#dst.base)|) 0)
 (* (+ |honda_cstpncpy_#t~post4.base| |ray_cstpncpy_#t~post4.base|) 0)
 (*
 (+ |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)|
 |ray_(ite (select #valid cstpncpy_~#dst.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) cstpncpy_#in~dst.base)|
 |ray_(select old(#length) cstpncpy_#in~dst.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)|
 |ray_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)|) 0)
 (* (+ |honda_cstpncpy_#t~post5.offset| |ray_cstpncpy_#t~post5.offset|) 0)
 (*
 (+ |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)|
 |ray_(ite (select #valid cstpncpy_#in~src.base) 1 0)|) 0)
 (* (+ |honda_cstpncpy_#in~dst.offset| |ray_cstpncpy_#in~dst.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)|
 |ray_(ite (select #valid cstpncpy_~s~3.base) 1 0)|) 0)
 (* (+ honda_cstpncpy_~src.base ray_cstpncpy_~src.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ honda_cstpncpy_~d~3.offset ray_cstpncpy_~d~3.offset) 0)
 (* (+ |honda_cstpncpy_#t~post3| |ray_cstpncpy_#t~post3|) 0)
 (* (+ |honda_cstpncpy_~#dst.base| |ray_cstpncpy_~#dst.base|) 0)
 (* (+ honda_cstpncpy_~src.offset ray_cstpncpy_~src.offset) 0)
 (* (+ |honda_cstpncpy_#in~src.base| |ray_cstpncpy_#in~src.base|) 0)
 (*
 (+
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 |ray_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)|
 |ray_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)|) 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0) 
 (* honda_cstpncpy_~d~3.base 0) 
 (* |honda_cstpncpy_#t~post5.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(select #length cstpncpy_~s~3.base)| (- 1))
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 0) 0)
 (>=
 (+ (* (+ |honda_cstpncpy_#t~mem0.offset| |ray_cstpncpy_#t~mem0.offset|) 0)
 (*
 (+ |honda_(select #length cstpncpy_~d~3.base)|
 |ray_(select #length cstpncpy_~d~3.base)|) 0)
 (* (+ |honda_cstpncpy_#t~post4.offset| |ray_cstpncpy_#t~post4.offset|) 0)
 (* (+ honda_cstpncpy_~s~3.offset ray_cstpncpy_~s~3.offset) 0)
 (*
 (+
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 |ray_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|)
 0)
 (*
 (+ |honda_(select old(#length) cstpncpy_#in~src.base)|
 |ray_(select old(#length) cstpncpy_#in~src.base)|) 0)
 (* (+ |honda_cstpncpy_~#dst.offset| |ray_cstpncpy_~#dst.offset|) 0)
 (*
 (+
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 |ray_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|)
 0) (* (+ |honda_cstpncpy_#t~mem7| |ray_cstpncpy_#t~mem7|) 0)
 (*
 (+
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 |ray_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|)
 0) (* (+ honda_cstpncpy_~d~3.base ray_cstpncpy_~d~3.base) 0)
 (*
 (+
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 |ray_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|)
 0)
 (*
 (+ |honda_(select #length cstpncpy_#in~src.base)|
 |ray_(select #length cstpncpy_#in~src.base)|) 0)
 (* (+ |honda_cstpncpy_#in~src.offset| |ray_cstpncpy_#in~src.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)|
 |ray_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)|) 0)
 (* (+ |honda_cstpncpy_#t~mem1.offset| |ray_cstpncpy_#t~mem1.offset|) 0)
 (*
 (+ |honda_(select #length cstpncpy_#in~dst.base)|
 |ray_(select #length cstpncpy_#in~dst.base)|) 0)
 (* (+ |honda_cstpncpy_#t~mem0.base| |ray_cstpncpy_#t~mem0.base|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 |ray_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|)
 0) (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_cstpncpy_#in~n| |ray_cstpncpy_#in~n|) 0)
 (* (+ |honda_cstpncpy_#t~mem1.base| |ray_cstpncpy_#t~mem1.base|) 0)
 (* (+ |honda_cstpncpy_#t~post5.base| |ray_cstpncpy_#t~post5.base|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(select old(#length) cstpncpy_~#dst.base)|
 |ray_(select old(#length) cstpncpy_~#dst.base)|) 0)
 (*
 (+ |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)|
 |ray_(ite (select #valid cstpncpy_~d~3.base) 1 0)|) 0)
 (* (+ honda_cstpncpy_~s~3.base ray_cstpncpy_~s~3.base) 0)
 (*
 (+
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 |ray_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|)
 0)
 (*
 (+ |honda_(select #length cstpncpy_~s~3.base)|
 |ray_(select #length cstpncpy_~s~3.base)|) 0)
 (* (+ honda_cstpncpy_~n ray_cstpncpy_~n) 0)
 (* (+ |honda_cstpncpy_#in~dst.base| |ray_cstpncpy_#in~dst.base|) 0)
 (*
 (+ |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)|
 |ray_(ite (select #valid cstpncpy_#in~dst.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length cstpncpy_~#dst.base)|
 |ray_(select #length cstpncpy_~#dst.base)|) 0)
 (* (+ |honda_cstpncpy_#t~post4.base| |ray_cstpncpy_#t~post4.base|) 0)
 (*
 (+ |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)|
 |ray_(ite (select #valid cstpncpy_~#dst.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) cstpncpy_#in~dst.base)|
 |ray_(select old(#length) cstpncpy_#in~dst.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)|
 |ray_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)|) 0)
 (* (+ |honda_cstpncpy_#t~post5.offset| |ray_cstpncpy_#t~post5.offset|) 0)
 (*
 (+ |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)|
 |ray_(ite (select #valid cstpncpy_#in~src.base) 1 0)|) 0)
 (* (+ |honda_cstpncpy_#in~dst.offset| |ray_cstpncpy_#in~dst.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)|
 |ray_(ite (select #valid cstpncpy_~s~3.base) 1 0)|) 0)
 (* (+ honda_cstpncpy_~src.base ray_cstpncpy_~src.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ honda_cstpncpy_~d~3.offset ray_cstpncpy_~d~3.offset) 0)
 (* (+ |honda_cstpncpy_#t~post3| |ray_cstpncpy_#t~post3|) 0)
 (* (+ |honda_cstpncpy_~#dst.base| |ray_cstpncpy_~#dst.base|) 0)
 (* (+ honda_cstpncpy_~src.offset ray_cstpncpy_~src.offset) 0)
 (* (+ |honda_cstpncpy_#in~src.base| |ray_cstpncpy_#in~src.base|) 0)
 (*
 (+
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 |ray_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)|
 |ray_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)|) 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 1) (* |honda_cstpncpy_#t~mem7| 0) 
 (* honda_cstpncpy_~d~3.base 0) 
 (* |honda_cstpncpy_#t~post5.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (- 1)) 0)
 (>=
 (+ (* (+ |honda_cstpncpy_#t~mem0.offset| |ray_cstpncpy_#t~mem0.offset|) 0)
 (*
 (+ |honda_(select #length cstpncpy_~d~3.base)|
 |ray_(select #length cstpncpy_~d~3.base)|) 0)
 (* (+ |honda_cstpncpy_#t~post4.offset| |ray_cstpncpy_#t~post4.offset|) 0)
 (* (+ honda_cstpncpy_~s~3.offset ray_cstpncpy_~s~3.offset) 0)
 (*
 (+
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 |ray_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|)
 0)
 (*
 (+ |honda_(select old(#length) cstpncpy_#in~src.base)|
 |ray_(select old(#length) cstpncpy_#in~src.base)|) 0)
 (* (+ |honda_cstpncpy_~#dst.offset| |ray_cstpncpy_~#dst.offset|) 0)
 (*
 (+
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 |ray_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|)
 0) (* (+ |honda_cstpncpy_#t~mem7| |ray_cstpncpy_#t~mem7|) 0)
 (*
 (+
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 |ray_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|)
 0) (* (+ honda_cstpncpy_~d~3.base ray_cstpncpy_~d~3.base) 0)
 (*
 (+
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 |ray_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|)
 0)
 (*
 (+ |honda_(select #length cstpncpy_#in~src.base)|
 |ray_(select #length cstpncpy_#in~src.base)|) 0)
 (* (+ |honda_cstpncpy_#in~src.offset| |ray_cstpncpy_#in~src.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)|
 |ray_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)|) 0)
 (* (+ |honda_cstpncpy_#t~mem1.offset| |ray_cstpncpy_#t~mem1.offset|) 0)
 (*
 (+ |honda_(select #length cstpncpy_#in~dst.base)|
 |ray_(select #length cstpncpy_#in~dst.base)|) 0)
 (* (+ |honda_cstpncpy_#t~mem0.base| |ray_cstpncpy_#t~mem0.base|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 |ray_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|)
 0) (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_cstpncpy_#in~n| |ray_cstpncpy_#in~n|) 0)
 (* (+ |honda_cstpncpy_#t~mem1.base| |ray_cstpncpy_#t~mem1.base|) 0)
 (* (+ |honda_cstpncpy_#t~post5.base| |ray_cstpncpy_#t~post5.base|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(select old(#length) cstpncpy_~#dst.base)|
 |ray_(select old(#length) cstpncpy_~#dst.base)|) 0)
 (*
 (+ |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)|
 |ray_(ite (select #valid cstpncpy_~d~3.base) 1 0)|) 0)
 (* (+ honda_cstpncpy_~s~3.base ray_cstpncpy_~s~3.base) 1)
 (*
 (+
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 |ray_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|)
 0)
 (*
 (+ |honda_(select #length cstpncpy_~s~3.base)|
 |ray_(select #length cstpncpy_~s~3.base)|) 0)
 (* (+ honda_cstpncpy_~n ray_cstpncpy_~n) 0)
 (* (+ |honda_cstpncpy_#in~dst.base| |ray_cstpncpy_#in~dst.base|) 0)
 (*
 (+ |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)|
 |ray_(ite (select #valid cstpncpy_#in~dst.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length cstpncpy_~#dst.base)|
 |ray_(select #length cstpncpy_~#dst.base)|) 0)
 (* (+ |honda_cstpncpy_#t~post4.base| |ray_cstpncpy_#t~post4.base|) 0)
 (*
 (+ |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)|
 |ray_(ite (select #valid cstpncpy_~#dst.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) cstpncpy_#in~dst.base)|
 |ray_(select old(#length) cstpncpy_#in~dst.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)|
 |ray_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)|) 0)
 (* (+ |honda_cstpncpy_#t~post5.offset| |ray_cstpncpy_#t~post5.offset|) 0)
 (*
 (+ |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)|
 |ray_(ite (select #valid cstpncpy_#in~src.base) 1 0)|) 0)
 (* (+ |honda_cstpncpy_#in~dst.offset| |ray_cstpncpy_#in~dst.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)|
 |ray_(ite (select #valid cstpncpy_~s~3.base) 1 0)|) 0)
 (* (+ honda_cstpncpy_~src.base ray_cstpncpy_~src.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ honda_cstpncpy_~d~3.offset ray_cstpncpy_~d~3.offset) 0)
 (* (+ |honda_cstpncpy_#t~post3| |ray_cstpncpy_#t~post3|) 0)
 (* (+ |honda_cstpncpy_~#dst.base| |ray_cstpncpy_~#dst.base|) 0)
 (* (+ honda_cstpncpy_~src.offset ray_cstpncpy_~src.offset) 0)
 (* (+ |honda_cstpncpy_#in~src.base| |ray_cstpncpy_#in~src.base|) 0)
 (*
 (+
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 |ray_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)|
 |ray_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)|) 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0) 
 (* honda_cstpncpy_~d~3.base 0) 
 (* |honda_cstpncpy_#t~post5.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (* honda_cstpncpy_~s~3.base (- 1))
 (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 0) 0)
 (>=
 (+ (* (+ |honda_cstpncpy_#t~mem0.offset| |ray_cstpncpy_#t~mem0.offset|) 0)
 (*
 (+ |honda_(select #length cstpncpy_~d~3.base)|
 |ray_(select #length cstpncpy_~d~3.base)|) 0)
 (* (+ |honda_cstpncpy_#t~post4.offset| |ray_cstpncpy_#t~post4.offset|) 0)
 (* (+ honda_cstpncpy_~s~3.offset ray_cstpncpy_~s~3.offset) 0)
 (*
 (+
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 |ray_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|)
 0)
 (*
 (+ |honda_(select old(#length) cstpncpy_#in~src.base)|
 |ray_(select old(#length) cstpncpy_#in~src.base)|) 0)
 (* (+ |honda_cstpncpy_~#dst.offset| |ray_cstpncpy_~#dst.offset|) 0)
 (*
 (+
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 |ray_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|)
 0) (* (+ |honda_cstpncpy_#t~mem7| |ray_cstpncpy_#t~mem7|) 0)
 (*
 (+
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 |ray_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|)
 0) (* (+ honda_cstpncpy_~d~3.base ray_cstpncpy_~d~3.base) 0)
 (*
 (+
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 |ray_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|)
 0)
 (*
 (+ |honda_(select #length cstpncpy_#in~src.base)|
 |ray_(select #length cstpncpy_#in~src.base)|) 0)
 (* (+ |honda_cstpncpy_#in~src.offset| |ray_cstpncpy_#in~src.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)|
 |ray_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)|) 0)
 (* (+ |honda_cstpncpy_#t~mem1.offset| |ray_cstpncpy_#t~mem1.offset|) 0)
 (*
 (+ |honda_(select #length cstpncpy_#in~dst.base)|
 |ray_(select #length cstpncpy_#in~dst.base)|) 0)
 (* (+ |honda_cstpncpy_#t~mem0.base| |ray_cstpncpy_#t~mem0.base|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 |ray_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|)
 0) (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_cstpncpy_#in~n| |ray_cstpncpy_#in~n|) 0)
 (* (+ |honda_cstpncpy_#t~mem1.base| |ray_cstpncpy_#t~mem1.base|) 0)
 (* (+ |honda_cstpncpy_#t~post5.base| |ray_cstpncpy_#t~post5.base|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(select old(#length) cstpncpy_~#dst.base)|
 |ray_(select old(#length) cstpncpy_~#dst.base)|) 0)
 (*
 (+ |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)|
 |ray_(ite (select #valid cstpncpy_~d~3.base) 1 0)|) 0)
 (* (+ honda_cstpncpy_~s~3.base ray_cstpncpy_~s~3.base) 0)
 (*
 (+
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 |ray_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|)
 0)
 (*
 (+ |honda_(select #length cstpncpy_~s~3.base)|
 |ray_(select #length cstpncpy_~s~3.base)|) 0)
 (* (+ honda_cstpncpy_~n ray_cstpncpy_~n) 0)
 (* (+ |honda_cstpncpy_#in~dst.base| |ray_cstpncpy_#in~dst.base|) 0)
 (*
 (+ |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)|
 |ray_(ite (select #valid cstpncpy_#in~dst.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length cstpncpy_~#dst.base)|
 |ray_(select #length cstpncpy_~#dst.base)|) 0)
 (* (+ |honda_cstpncpy_#t~post4.base| |ray_cstpncpy_#t~post4.base|) 0)
 (*
 (+ |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)|
 |ray_(ite (select #valid cstpncpy_~#dst.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) cstpncpy_#in~dst.base)|
 |ray_(select old(#length) cstpncpy_#in~dst.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)|
 |ray_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)|) 0)
 (* (+ |honda_cstpncpy_#t~post5.offset| |ray_cstpncpy_#t~post5.offset|) 0)
 (*
 (+ |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)|
 |ray_(ite (select #valid cstpncpy_#in~src.base) 1 0)|) 0)
 (* (+ |honda_cstpncpy_#in~dst.offset| |ray_cstpncpy_#in~dst.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)|
 |ray_(ite (select #valid cstpncpy_~s~3.base) 1 0)|) 0)
 (* (+ honda_cstpncpy_~src.base ray_cstpncpy_~src.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ honda_cstpncpy_~d~3.offset ray_cstpncpy_~d~3.offset) 0)
 (* (+ |honda_cstpncpy_#t~post3| |ray_cstpncpy_#t~post3|) 0)
 (* (+ |honda_cstpncpy_~#dst.base| |ray_cstpncpy_~#dst.base|) 0)
 (* (+ honda_cstpncpy_~src.offset ray_cstpncpy_~src.offset) 0)
 (* (+ |honda_cstpncpy_#in~src.base| |ray_cstpncpy_#in~src.base|) 0)
 (*
 (+
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 |ray_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)|
 |ray_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)|) 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 1)
 (* |honda_cstpncpy_#t~post4.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0) 
 (* honda_cstpncpy_~d~3.base 0) 
 (* |honda_cstpncpy_#t~post5.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset (- 1)) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (- 1)) 0)
 (>=
 (+ (* (+ |honda_cstpncpy_#t~mem0.offset| |ray_cstpncpy_#t~mem0.offset|) 0)
 (*
 (+ |honda_(select #length cstpncpy_~d~3.base)|
 |ray_(select #length cstpncpy_~d~3.base)|) 0)
 (* (+ |honda_cstpncpy_#t~post4.offset| |ray_cstpncpy_#t~post4.offset|) 0)
 (* (+ honda_cstpncpy_~s~3.offset ray_cstpncpy_~s~3.offset) 0)
 (*
 (+
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 |ray_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|)
 0)
 (*
 (+ |honda_(select old(#length) cstpncpy_#in~src.base)|
 |ray_(select old(#length) cstpncpy_#in~src.base)|) 0)
 (* (+ |honda_cstpncpy_~#dst.offset| |ray_cstpncpy_~#dst.offset|) 0)
 (*
 (+
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 |ray_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|)
 0) (* (+ |honda_cstpncpy_#t~mem7| |ray_cstpncpy_#t~mem7|) 0)
 (*
 (+
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 |ray_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|)
 0) (* (+ honda_cstpncpy_~d~3.base ray_cstpncpy_~d~3.base) 0)
 (*
 (+
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 |ray_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|)
 0)
 (*
 (+ |honda_(select #length cstpncpy_#in~src.base)|
 |ray_(select #length cstpncpy_#in~src.base)|) 0)
 (* (+ |honda_cstpncpy_#in~src.offset| |ray_cstpncpy_#in~src.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)|
 |ray_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)|) 0)
 (* (+ |honda_cstpncpy_#t~mem1.offset| |ray_cstpncpy_#t~mem1.offset|) 0)
 (*
 (+ |honda_(select #length cstpncpy_#in~dst.base)|
 |ray_(select #length cstpncpy_#in~dst.base)|) 0)
 (* (+ |honda_cstpncpy_#t~mem0.base| |ray_cstpncpy_#t~mem0.base|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 |ray_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|)
 0) (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_cstpncpy_#in~n| |ray_cstpncpy_#in~n|) 0)
 (* (+ |honda_cstpncpy_#t~mem1.base| |ray_cstpncpy_#t~mem1.base|) 0)
 (* (+ |honda_cstpncpy_#t~post5.base| |ray_cstpncpy_#t~post5.base|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(select old(#length) cstpncpy_~#dst.base)|
 |ray_(select old(#length) cstpncpy_~#dst.base)|) 0)
 (*
 (+ |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)|
 |ray_(ite (select #valid cstpncpy_~d~3.base) 1 0)|) 0)
 (* (+ honda_cstpncpy_~s~3.base ray_cstpncpy_~s~3.base) 0)
 (*
 (+
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 |ray_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|)
 0)
 (*
 (+ |honda_(select #length cstpncpy_~s~3.base)|
 |ray_(select #length cstpncpy_~s~3.base)|) 0)
 (* (+ honda_cstpncpy_~n ray_cstpncpy_~n) 0)
 (* (+ |honda_cstpncpy_#in~dst.base| |ray_cstpncpy_#in~dst.base|) 0)
 (*
 (+ |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)|
 |ray_(ite (select #valid cstpncpy_#in~dst.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length cstpncpy_~#dst.base)|
 |ray_(select #length cstpncpy_~#dst.base)|) 0)
 (* (+ |honda_cstpncpy_#t~post4.base| |ray_cstpncpy_#t~post4.base|) 0)
 (*
 (+ |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)|
 |ray_(ite (select #valid cstpncpy_~#dst.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) cstpncpy_#in~dst.base)|
 |ray_(select old(#length) cstpncpy_#in~dst.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)|
 |ray_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)|) 0)
 (* (+ |honda_cstpncpy_#t~post5.offset| |ray_cstpncpy_#t~post5.offset|) 0)
 (*
 (+ |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)|
 |ray_(ite (select #valid cstpncpy_#in~src.base) 1 0)|) 0)
 (* (+ |honda_cstpncpy_#in~dst.offset| |ray_cstpncpy_#in~dst.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)|
 |ray_(ite (select #valid cstpncpy_~s~3.base) 1 0)|) 0)
 (* (+ honda_cstpncpy_~src.base ray_cstpncpy_~src.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ honda_cstpncpy_~d~3.offset ray_cstpncpy_~d~3.offset) 0)
 (* (+ |honda_cstpncpy_#t~post3| |ray_cstpncpy_#t~post3|) 0)
 (* (+ |honda_cstpncpy_~#dst.base| |ray_cstpncpy_~#dst.base|) 0)
 (* (+ honda_cstpncpy_~src.offset ray_cstpncpy_~src.offset) 0)
 (* (+ |honda_cstpncpy_#in~src.base| |ray_cstpncpy_#in~src.base|) 0)
 (*
 (+
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 |ray_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)|
 |ray_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)|) 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0) 
 (* honda_cstpncpy_~d~3.base 0) 
 (* |honda_cstpncpy_#t~post5.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 1)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (- 1)) 0)
 (>=
 (+ (* (+ |honda_cstpncpy_#t~mem0.offset| |ray_cstpncpy_#t~mem0.offset|) 0)
 (*
 (+ |honda_(select #length cstpncpy_~d~3.base)|
 |ray_(select #length cstpncpy_~d~3.base)|) 0)
 (* (+ |honda_cstpncpy_#t~post4.offset| |ray_cstpncpy_#t~post4.offset|) 0)
 (* (+ honda_cstpncpy_~s~3.offset ray_cstpncpy_~s~3.offset) 0)
 (*
 (+
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 |ray_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|)
 0)
 (*
 (+ |honda_(select old(#length) cstpncpy_#in~src.base)|
 |ray_(select old(#length) cstpncpy_#in~src.base)|) 0)
 (* (+ |honda_cstpncpy_~#dst.offset| |ray_cstpncpy_~#dst.offset|) 0)
 (*
 (+
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 |ray_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|)
 0) (* (+ |honda_cstpncpy_#t~mem7| |ray_cstpncpy_#t~mem7|) 0)
 (*
 (+
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 |ray_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|)
 0) (* (+ honda_cstpncpy_~d~3.base ray_cstpncpy_~d~3.base) 0)
 (*
 (+
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 |ray_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|)
 0)
 (*
 (+ |honda_(select #length cstpncpy_#in~src.base)|
 |ray_(select #length cstpncpy_#in~src.base)|) 0)
 (* (+ |honda_cstpncpy_#in~src.offset| |ray_cstpncpy_#in~src.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)|
 |ray_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)|) 0)
 (* (+ |honda_cstpncpy_#t~mem1.offset| |ray_cstpncpy_#t~mem1.offset|) 0)
 (*
 (+ |honda_(select #length cstpncpy_#in~dst.base)|
 |ray_(select #length cstpncpy_#in~dst.base)|) 0)
 (* (+ |honda_cstpncpy_#t~mem0.base| |ray_cstpncpy_#t~mem0.base|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 |ray_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|)
 0) (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_cstpncpy_#in~n| |ray_cstpncpy_#in~n|) 0)
 (* (+ |honda_cstpncpy_#t~mem1.base| |ray_cstpncpy_#t~mem1.base|) 0)
 (* (+ |honda_cstpncpy_#t~post5.base| |ray_cstpncpy_#t~post5.base|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(select old(#length) cstpncpy_~#dst.base)|
 |ray_(select old(#length) cstpncpy_~#dst.base)|) 0)
 (*
 (+ |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)|
 |ray_(ite (select #valid cstpncpy_~d~3.base) 1 0)|) 0)
 (* (+ honda_cstpncpy_~s~3.base ray_cstpncpy_~s~3.base) 0)
 (*
 (+
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 |ray_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|)
 0)
 (*
 (+ |honda_(select #length cstpncpy_~s~3.base)|
 |ray_(select #length cstpncpy_~s~3.base)|) 0)
 (* (+ honda_cstpncpy_~n ray_cstpncpy_~n) 0)
 (* (+ |honda_cstpncpy_#in~dst.base| |ray_cstpncpy_#in~dst.base|) 0)
 (*
 (+ |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)|
 |ray_(ite (select #valid cstpncpy_#in~dst.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length cstpncpy_~#dst.base)|
 |ray_(select #length cstpncpy_~#dst.base)|) 0)
 (* (+ |honda_cstpncpy_#t~post4.base| |ray_cstpncpy_#t~post4.base|) 0)
 (*
 (+ |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)|
 |ray_(ite (select #valid cstpncpy_~#dst.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) cstpncpy_#in~dst.base)|
 |ray_(select old(#length) cstpncpy_#in~dst.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)|
 |ray_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)|) 0)
 (* (+ |honda_cstpncpy_#t~post5.offset| |ray_cstpncpy_#t~post5.offset|) 0)
 (*
 (+ |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)|
 |ray_(ite (select #valid cstpncpy_#in~src.base) 1 0)|) 0)
 (* (+ |honda_cstpncpy_#in~dst.offset| |ray_cstpncpy_#in~dst.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)|
 |ray_(ite (select #valid cstpncpy_~s~3.base) 1 0)|) 0)
 (* (+ honda_cstpncpy_~src.base ray_cstpncpy_~src.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ honda_cstpncpy_~d~3.offset ray_cstpncpy_~d~3.offset) 0)
 (* (+ |honda_cstpncpy_#t~post3| |ray_cstpncpy_#t~post3|) 0)
 (* (+ |honda_cstpncpy_~#dst.base| |ray_cstpncpy_~#dst.base|) 0)
 (* (+ honda_cstpncpy_~src.offset ray_cstpncpy_~src.offset) 0)
 (* (+ |honda_cstpncpy_#in~src.base| |ray_cstpncpy_#in~src.base|) 0)
 (*
 (+
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 |ray_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)|
 |ray_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)|) 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0) 
 (* honda_cstpncpy_~d~3.base 0) 
 (* |honda_cstpncpy_#t~post5.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* aux_3703 (- 1)) (* aux_3698 1) 
 (- 1)) 0)
 (= |ray_cstpncpy_#t~mem0.offset| (* |ray_cstpncpy_#t~mem0.offset| lambda))
 (=
 |ray_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 (*
 |ray_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 lambda))
 (= |ray_(select old(#length) cstpncpy_#in~src.base)|
 (* |ray_(select old(#length) cstpncpy_#in~src.base)| lambda))
 (= |ray_cstpncpy_~#dst.offset| (* |ray_cstpncpy_~#dst.offset| lambda))
 (=
 |ray_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 (*
 |ray_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 lambda))
 (=
 |ray_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 (*
 |ray_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 lambda))
 (= |ray_(select #length cstpncpy_#in~src.base)|
 (* |ray_(select #length cstpncpy_#in~src.base)| lambda))
 (= |ray_cstpncpy_#in~src.offset| (* |ray_cstpncpy_#in~src.offset| lambda))
 (= |ray_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)|
 (* |ray_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| lambda))
 (= |ray_cstpncpy_#t~mem1.offset| (* |ray_cstpncpy_#t~mem1.offset| lambda))
 (= |ray_(select #length cstpncpy_#in~dst.base)|
 (* |ray_(select #length cstpncpy_#in~dst.base)| lambda))
 (= |ray_cstpncpy_#t~mem0.base| (* |ray_cstpncpy_#t~mem0.base| lambda))
 (=
 |ray_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 (*
 |ray_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 lambda)) (= |ray_#NULL.offset| (* |ray_#NULL.offset| lambda))
 (= |ray_cstpncpy_#in~n| (* |ray_cstpncpy_#in~n| lambda))
 (= |ray_cstpncpy_#t~mem1.base| (* |ray_cstpncpy_#t~mem1.base| lambda))
 (= |ray_#NULL.base| (* |ray_#NULL.base| lambda))
 (= |ray_(select old(#length) cstpncpy_~#dst.base)|
 (* |ray_(select old(#length) cstpncpy_~#dst.base)| lambda))
 (=
 |ray_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 (*
 |ray_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 lambda))
 (= |ray_cstpncpy_#in~dst.base| (* |ray_cstpncpy_#in~dst.base| lambda))
 (= |ray_(ite (select #valid cstpncpy_#in~dst.base) 1 0)|
 (* |ray_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| lambda))
 (= |ray_(select #length cstpncpy_~#dst.base)|
 (* |ray_(select #length cstpncpy_~#dst.base)| lambda))
 (= |ray_(ite (select #valid cstpncpy_~#dst.base) 1 0)|
 (* |ray_(ite (select #valid cstpncpy_~#dst.base) 1 0)| lambda))
 (= |ray_(select old(#length) cstpncpy_#in~dst.base)|
 (* |ray_(select old(#length) cstpncpy_#in~dst.base)| lambda))
 (= |ray_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)|
 (* |ray_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| lambda))
 (= |ray_(ite (select #valid cstpncpy_#in~src.base) 1 0)|
 (* |ray_(ite (select #valid cstpncpy_#in~src.base) 1 0)| lambda))
 (= |ray_cstpncpy_#in~dst.offset| (* |ray_cstpncpy_#in~dst.offset| lambda))
 (= |ray_(ite (select #valid 0) 1 0)|
 (* |ray_(ite (select #valid 0) 1 0)| lambda))
 (= ray_cstpncpy_~src.base (* ray_cstpncpy_~src.base lambda))
 (= |ray_(ite (select old(#valid) 0) 1 0)|
 (* |ray_(ite (select old(#valid) 0) 1 0)| lambda))
 (= |ray_cstpncpy_~#dst.base| (* |ray_cstpncpy_~#dst.base| lambda))
 (= ray_cstpncpy_~src.offset (* ray_cstpncpy_~src.offset lambda))
 (= |ray_cstpncpy_#in~src.base| (* |ray_cstpncpy_#in~src.base| lambda))
 (=
 |ray_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 (*
 |ray_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 lambda))
 (= |ray_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)|
 (* |ray_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| lambda))
 (>=
 (+ (* (* |ray_cstpncpy_#t~mem0.offset| lambda) 0)
 (* (* |ray_(select #length cstpncpy_~d~3.base)| lambda) 0)
 (* (* |ray_cstpncpy_#t~post4.offset| lambda) 0)
 (* (* ray_cstpncpy_~s~3.offset lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 lambda) 0)
 (* (* |ray_(select old(#length) cstpncpy_#in~src.base)| lambda) 0)
 (* (* |ray_cstpncpy_~#dst.offset| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 lambda) 0) (* (* |ray_cstpncpy_#t~mem7| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 lambda) 0) (* (* ray_cstpncpy_~d~3.base lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 lambda) 0) (* (* |ray_(select #length cstpncpy_#in~src.base)| lambda) 0)
 (* (* |ray_cstpncpy_#in~src.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| lambda) 0)
 (* (* |ray_cstpncpy_#t~mem1.offset| lambda) 0)
 (* (* |ray_(select #length cstpncpy_#in~dst.base)| lambda) 0)
 (* (* |ray_cstpncpy_#t~mem0.base| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_cstpncpy_#in~n| lambda) 0)
 (* (* |ray_cstpncpy_#t~mem1.base| lambda) 0)
 (* (* |ray_cstpncpy_#t~post5.base| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(select old(#length) cstpncpy_~#dst.base)| lambda) 0)
 (* (* |ray_(ite (select #valid cstpncpy_~d~3.base) 1 0)| lambda) 0)
 (* (* ray_cstpncpy_~s~3.base lambda) 0)
 (*
 (*
 |ray_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 lambda) 0) (* (* |ray_(select #length cstpncpy_~s~3.base)| lambda) (- 1))
 (* (* ray_cstpncpy_~n lambda) 0)
 (* (* |ray_cstpncpy_#in~dst.base| lambda) 0)
 (* (* |ray_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length cstpncpy_~#dst.base)| lambda) 0)
 (* (* |ray_cstpncpy_#t~post4.base| lambda) 0)
 (* (* |ray_(ite (select #valid cstpncpy_~#dst.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) cstpncpy_#in~dst.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| lambda) 0)
 (* (* |ray_cstpncpy_#t~post5.offset| lambda) 0)
 (* (* |ray_(ite (select #valid cstpncpy_#in~src.base) 1 0)| lambda) 0)
 (* (* |ray_cstpncpy_#in~dst.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid cstpncpy_~s~3.base) 1 0)| lambda) 0)
 (* (* ray_cstpncpy_~src.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* ray_cstpncpy_~d~3.offset lambda) 0)
 (* (* |ray_cstpncpy_#t~post3| lambda) 0)
 (* (* |ray_cstpncpy_~#dst.base| lambda) 0)
 (* (* ray_cstpncpy_~src.offset lambda) 0)
 (* (* |ray_cstpncpy_#in~src.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| lambda) 0)
 (* |ray_(select #length cstpncpy_~d~3.base)| 0)
 (* |ray_cstpncpy_#t~post4.offset| 0) 
 (* ray_cstpncpy_~s~3.offset 0)
 (*
 |ray_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |ray_cstpncpy_#t~mem7| 0) 
 (* ray_cstpncpy_~d~3.base 0) 
 (* |ray_cstpncpy_#t~post5.base| 0)
 (* |ray_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (* ray_cstpncpy_~s~3.base 0) 
 (* |ray_(select #length cstpncpy_~s~3.base)| 1) 
 (* ray_cstpncpy_~n 0) (* |ray_cstpncpy_#t~post4.base| 0)
 (* |ray_cstpncpy_#t~post5.offset| 0)
 (* |ray_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* ray_cstpncpy_~d~3.offset 0) 
 (* |ray_cstpncpy_#t~post3| 0)) 0)
 (>=
 (+ (* (* |ray_cstpncpy_#t~mem0.offset| lambda) 0)
 (* (* |ray_(select #length cstpncpy_~d~3.base)| lambda) 0)
 (* (* |ray_cstpncpy_#t~post4.offset| lambda) 0)
 (* (* ray_cstpncpy_~s~3.offset lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 lambda) 0)
 (* (* |ray_(select old(#length) cstpncpy_#in~src.base)| lambda) 0)
 (* (* |ray_cstpncpy_~#dst.offset| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 lambda) 0) (* (* |ray_cstpncpy_#t~mem7| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 lambda) 0) (* (* ray_cstpncpy_~d~3.base lambda) (- 1))
 (*
 (*
 |ray_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 lambda) 0) (* (* |ray_(select #length cstpncpy_#in~src.base)| lambda) 0)
 (* (* |ray_cstpncpy_#in~src.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| lambda) 0)
 (* (* |ray_cstpncpy_#t~mem1.offset| lambda) 0)
 (* (* |ray_(select #length cstpncpy_#in~dst.base)| lambda) 0)
 (* (* |ray_cstpncpy_#t~mem0.base| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_cstpncpy_#in~n| lambda) 0)
 (* (* |ray_cstpncpy_#t~mem1.base| lambda) 0)
 (* (* |ray_cstpncpy_#t~post5.base| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(select old(#length) cstpncpy_~#dst.base)| lambda) 0)
 (* (* |ray_(ite (select #valid cstpncpy_~d~3.base) 1 0)| lambda) 0)
 (* (* ray_cstpncpy_~s~3.base lambda) 0)
 (*
 (*
 |ray_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 lambda) 0) (* (* |ray_(select #length cstpncpy_~s~3.base)| lambda) 0)
 (* (* ray_cstpncpy_~n lambda) 0)
 (* (* |ray_cstpncpy_#in~dst.base| lambda) 0)
 (* (* |ray_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length cstpncpy_~#dst.base)| lambda) 0)
 (* (* |ray_cstpncpy_#t~post4.base| lambda) 0)
 (* (* |ray_(ite (select #valid cstpncpy_~#dst.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) cstpncpy_#in~dst.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| lambda) 0)
 (* (* |ray_cstpncpy_#t~post5.offset| lambda) 0)
 (* (* |ray_(ite (select #valid cstpncpy_#in~src.base) 1 0)| lambda) 0)
 (* (* |ray_cstpncpy_#in~dst.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid cstpncpy_~s~3.base) 1 0)| lambda) 0)
 (* (* ray_cstpncpy_~src.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* ray_cstpncpy_~d~3.offset lambda) 0)
 (* (* |ray_cstpncpy_#t~post3| lambda) 0)
 (* (* |ray_cstpncpy_~#dst.base| lambda) 0)
 (* (* ray_cstpncpy_~src.offset lambda) 0)
 (* (* |ray_cstpncpy_#in~src.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| lambda) 0)
 (* |ray_(select #length cstpncpy_~d~3.base)| 0)
 (* |ray_cstpncpy_#t~post4.offset| 0) 
 (* ray_cstpncpy_~s~3.offset 0)
 (*
 |ray_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |ray_cstpncpy_#t~mem7| 0) 
 (* ray_cstpncpy_~d~3.base 1) 
 (* |ray_cstpncpy_#t~post5.base| 0)
 (* |ray_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (* ray_cstpncpy_~s~3.base 0) 
 (* |ray_(select #length cstpncpy_~s~3.base)| 0) 
 (* ray_cstpncpy_~n 0) (* |ray_cstpncpy_#t~post4.base| 0)
 (* |ray_cstpncpy_#t~post5.offset| 0)
 (* |ray_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* ray_cstpncpy_~d~3.offset 0) 
 (* |ray_cstpncpy_#t~post3| 0)) 0)
 (>=
 (+ (* (* |ray_cstpncpy_#t~mem0.offset| lambda) 0)
 (* (* |ray_(select #length cstpncpy_~d~3.base)| lambda) 0)
 (* (* |ray_cstpncpy_#t~post4.offset| lambda) 0)
 (* (* ray_cstpncpy_~s~3.offset lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 lambda) 0)
 (* (* |ray_(select old(#length) cstpncpy_#in~src.base)| lambda) 0)
 (* (* |ray_cstpncpy_~#dst.offset| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 lambda) 0) (* (* |ray_cstpncpy_#t~mem7| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 lambda) 0) (* (* ray_cstpncpy_~d~3.base lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 lambda) 0) (* (* |ray_(select #length cstpncpy_#in~src.base)| lambda) 0)
 (* (* |ray_cstpncpy_#in~src.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| lambda) 0)
 (* (* |ray_cstpncpy_#t~mem1.offset| lambda) 0)
 (* (* |ray_(select #length cstpncpy_#in~dst.base)| lambda) 0)
 (* (* |ray_cstpncpy_#t~mem0.base| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_cstpncpy_#in~n| lambda) 0)
 (* (* |ray_cstpncpy_#t~mem1.base| lambda) 0)
 (* (* |ray_cstpncpy_#t~post5.base| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(select old(#length) cstpncpy_~#dst.base)| lambda) 0)
 (* (* |ray_(ite (select #valid cstpncpy_~d~3.base) 1 0)| lambda) 0)
 (* (* ray_cstpncpy_~s~3.base lambda) 0)
 (*
 (*
 |ray_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 lambda) 0) (* (* |ray_(select #length cstpncpy_~s~3.base)| lambda) 0)
 (* (* ray_cstpncpy_~n lambda) 0)
 (* (* |ray_cstpncpy_#in~dst.base| lambda) 0)
 (* (* |ray_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length cstpncpy_~#dst.base)| lambda) 0)
 (* (* |ray_cstpncpy_#t~post4.base| lambda) 0)
 (* (* |ray_(ite (select #valid cstpncpy_~#dst.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) cstpncpy_#in~dst.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| lambda) 0)
 (* (* |ray_cstpncpy_#t~post5.offset| lambda) 0)
 (* (* |ray_(ite (select #valid cstpncpy_#in~src.base) 1 0)| lambda) 0)
 (* (* |ray_cstpncpy_#in~dst.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid cstpncpy_~s~3.base) 1 0)| lambda) 0)
 (* (* ray_cstpncpy_~src.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* ray_cstpncpy_~d~3.offset lambda) (- 1))
 (* (* |ray_cstpncpy_#t~post3| lambda) 0)
 (* (* |ray_cstpncpy_~#dst.base| lambda) 0)
 (* (* ray_cstpncpy_~src.offset lambda) 0)
 (* (* |ray_cstpncpy_#in~src.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| lambda) 0)
 (* |ray_(select #length cstpncpy_~d~3.base)| 0)
 (* |ray_cstpncpy_#t~post4.offset| 0) 
 (* ray_cstpncpy_~s~3.offset 0)
 (*
 |ray_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |ray_cstpncpy_#t~mem7| 0) 
 (* ray_cstpncpy_~d~3.base 0) 
 (* |ray_cstpncpy_#t~post5.base| 0)
 (* |ray_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (* ray_cstpncpy_~s~3.base 0) 
 (* |ray_(select #length cstpncpy_~s~3.base)| 0) 
 (* ray_cstpncpy_~n 0) (* |ray_cstpncpy_#t~post4.base| 0)
 (* |ray_cstpncpy_#t~post5.offset| 0)
 (* |ray_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* ray_cstpncpy_~d~3.offset 1) 
 (* |ray_cstpncpy_#t~post3| 0)) 0)
 (>=
 (+ (* (* |ray_cstpncpy_#t~mem0.offset| lambda) 0)
 (* (* |ray_(select #length cstpncpy_~d~3.base)| lambda) 0)
 (* (* |ray_cstpncpy_#t~post4.offset| lambda) 0)
 (* (* ray_cstpncpy_~s~3.offset lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 lambda) 0)
 (* (* |ray_(select old(#length) cstpncpy_#in~src.base)| lambda) 0)
 (* (* |ray_cstpncpy_~#dst.offset| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 lambda) 0) (* (* |ray_cstpncpy_#t~mem7| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 lambda) 0) (* (* ray_cstpncpy_~d~3.base lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 lambda) 0) (* (* |ray_(select #length cstpncpy_#in~src.base)| lambda) 0)
 (* (* |ray_cstpncpy_#in~src.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| lambda) 0)
 (* (* |ray_cstpncpy_#t~mem1.offset| lambda) 0)
 (* (* |ray_(select #length cstpncpy_#in~dst.base)| lambda) 0)
 (* (* |ray_cstpncpy_#t~mem0.base| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_cstpncpy_#in~n| lambda) 0)
 (* (* |ray_cstpncpy_#t~mem1.base| lambda) 0)
 (* (* |ray_cstpncpy_#t~post5.base| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(select old(#length) cstpncpy_~#dst.base)| lambda) 0)
 (* (* |ray_(ite (select #valid cstpncpy_~d~3.base) 1 0)| lambda) 1)
 (* (* ray_cstpncpy_~s~3.base lambda) 0)
 (*
 (*
 |ray_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 lambda) 0) (* (* |ray_(select #length cstpncpy_~s~3.base)| lambda) 0)
 (* (* ray_cstpncpy_~n lambda) 0)
 (* (* |ray_cstpncpy_#in~dst.base| lambda) 0)
 (* (* |ray_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length cstpncpy_~#dst.base)| lambda) 0)
 (* (* |ray_cstpncpy_#t~post4.base| lambda) 0)
 (* (* |ray_(ite (select #valid cstpncpy_~#dst.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) cstpncpy_#in~dst.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| lambda) 0)
 (* (* |ray_cstpncpy_#t~post5.offset| lambda) 0)
 (* (* |ray_(ite (select #valid cstpncpy_#in~src.base) 1 0)| lambda) 0)
 (* (* |ray_cstpncpy_#in~dst.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid cstpncpy_~s~3.base) 1 0)| lambda) 0)
 (* (* ray_cstpncpy_~src.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* ray_cstpncpy_~d~3.offset lambda) 0)
 (* (* |ray_cstpncpy_#t~post3| lambda) 0)
 (* (* |ray_cstpncpy_~#dst.base| lambda) 0)
 (* (* ray_cstpncpy_~src.offset lambda) 0)
 (* (* |ray_cstpncpy_#in~src.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| lambda) 0)
 (* |ray_(select #length cstpncpy_~d~3.base)| 0)
 (* |ray_cstpncpy_#t~post4.offset| 0) 
 (* ray_cstpncpy_~s~3.offset 0)
 (*
 |ray_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |ray_cstpncpy_#t~mem7| 0) 
 (* ray_cstpncpy_~d~3.base 0) 
 (* |ray_cstpncpy_#t~post5.base| 0)
 (* |ray_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (* ray_cstpncpy_~s~3.base 0) 
 (* |ray_(select #length cstpncpy_~s~3.base)| 0) 
 (* ray_cstpncpy_~n 0) (* |ray_cstpncpy_#t~post4.base| 0)
 (* |ray_cstpncpy_#t~post5.offset| 0)
 (* |ray_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* ray_cstpncpy_~d~3.offset 0) 
 (* |ray_cstpncpy_#t~post3| 0)) 0)
 (>=
 (+ (* (* |ray_cstpncpy_#t~mem0.offset| lambda) 0)
 (* (* |ray_(select #length cstpncpy_~d~3.base)| lambda) (- 1))
 (* (* |ray_cstpncpy_#t~post4.offset| lambda) 0)
 (* (* ray_cstpncpy_~s~3.offset lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 lambda) 0)
 (* (* |ray_(select old(#length) cstpncpy_#in~src.base)| lambda) 0)
 (* (* |ray_cstpncpy_~#dst.offset| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 lambda) 0) (* (* |ray_cstpncpy_#t~mem7| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 lambda) 0) (* (* ray_cstpncpy_~d~3.base lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 lambda) 0) (* (* |ray_(select #length cstpncpy_#in~src.base)| lambda) 0)
 (* (* |ray_cstpncpy_#in~src.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| lambda) 0)
 (* (* |ray_cstpncpy_#t~mem1.offset| lambda) 0)
 (* (* |ray_(select #length cstpncpy_#in~dst.base)| lambda) 0)
 (* (* |ray_cstpncpy_#t~mem0.base| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_cstpncpy_#in~n| lambda) 0)
 (* (* |ray_cstpncpy_#t~mem1.base| lambda) 0)
 (* (* |ray_cstpncpy_#t~post5.base| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(select old(#length) cstpncpy_~#dst.base)| lambda) 0)
 (* (* |ray_(ite (select #valid cstpncpy_~d~3.base) 1 0)| lambda) 0)
 (* (* ray_cstpncpy_~s~3.base lambda) 0)
 (*
 (*
 |ray_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 lambda) 0) (* (* |ray_(select #length cstpncpy_~s~3.base)| lambda) 0)
 (* (* ray_cstpncpy_~n lambda) 0)
 (* (* |ray_cstpncpy_#in~dst.base| lambda) 0)
 (* (* |ray_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length cstpncpy_~#dst.base)| lambda) 0)
 (* (* |ray_cstpncpy_#t~post4.base| lambda) 0)
 (* (* |ray_(ite (select #valid cstpncpy_~#dst.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) cstpncpy_#in~dst.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| lambda) 0)
 (* (* |ray_cstpncpy_#t~post5.offset| lambda) 0)
 (* (* |ray_(ite (select #valid cstpncpy_#in~src.base) 1 0)| lambda) 0)
 (* (* |ray_cstpncpy_#in~dst.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid cstpncpy_~s~3.base) 1 0)| lambda) 0)
 (* (* ray_cstpncpy_~src.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* ray_cstpncpy_~d~3.offset lambda) 0)
 (* (* |ray_cstpncpy_#t~post3| lambda) 0)
 (* (* |ray_cstpncpy_~#dst.base| lambda) 0)
 (* (* ray_cstpncpy_~src.offset lambda) 0)
 (* (* |ray_cstpncpy_#in~src.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| lambda) 0)
 (* |ray_(select #length cstpncpy_~d~3.base)| 1)
 (* |ray_cstpncpy_#t~post4.offset| 0) 
 (* ray_cstpncpy_~s~3.offset 0)
 (*
 |ray_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |ray_cstpncpy_#t~mem7| 0) 
 (* ray_cstpncpy_~d~3.base 0) 
 (* |ray_cstpncpy_#t~post5.base| 0)
 (* |ray_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (* ray_cstpncpy_~s~3.base 0) 
 (* |ray_(select #length cstpncpy_~s~3.base)| 0) 
 (* ray_cstpncpy_~n 0) (* |ray_cstpncpy_#t~post4.base| 0)
 (* |ray_cstpncpy_#t~post5.offset| 0)
 (* |ray_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* ray_cstpncpy_~d~3.offset 0) 
 (* |ray_cstpncpy_#t~post3| 0)) 0)
 (>=
 (+ (* (* |ray_cstpncpy_#t~mem0.offset| lambda) 0)
 (* (* |ray_(select #length cstpncpy_~d~3.base)| lambda) 0)
 (* (* |ray_cstpncpy_#t~post4.offset| lambda) 0)
 (* (* ray_cstpncpy_~s~3.offset lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 lambda) 0)
 (* (* |ray_(select old(#length) cstpncpy_#in~src.base)| lambda) 0)
 (* (* |ray_cstpncpy_~#dst.offset| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 lambda) 0) (* (* |ray_cstpncpy_#t~mem7| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 lambda) 0) (* (* ray_cstpncpy_~d~3.base lambda) 1)
 (*
 (*
 |ray_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 lambda) 0) (* (* |ray_(select #length cstpncpy_#in~src.base)| lambda) 0)
 (* (* |ray_cstpncpy_#in~src.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| lambda) 0)
 (* (* |ray_cstpncpy_#t~mem1.offset| lambda) 0)
 (* (* |ray_(select #length cstpncpy_#in~dst.base)| lambda) 0)
 (* (* |ray_cstpncpy_#t~mem0.base| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_cstpncpy_#in~n| lambda) 0)
 (* (* |ray_cstpncpy_#t~mem1.base| lambda) 0)
 (* (* |ray_cstpncpy_#t~post5.base| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(select old(#length) cstpncpy_~#dst.base)| lambda) 0)
 (* (* |ray_(ite (select #valid cstpncpy_~d~3.base) 1 0)| lambda) 0)
 (* (* ray_cstpncpy_~s~3.base lambda) 0)
 (*
 (*
 |ray_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 lambda) 0) (* (* |ray_(select #length cstpncpy_~s~3.base)| lambda) 0)
 (* (* ray_cstpncpy_~n lambda) 0)
 (* (* |ray_cstpncpy_#in~dst.base| lambda) 0)
 (* (* |ray_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length cstpncpy_~#dst.base)| lambda) 0)
 (* (* |ray_cstpncpy_#t~post4.base| lambda) 0)
 (* (* |ray_(ite (select #valid cstpncpy_~#dst.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) cstpncpy_#in~dst.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| lambda) 0)
 (* (* |ray_cstpncpy_#t~post5.offset| lambda) 0)
 (* (* |ray_(ite (select #valid cstpncpy_#in~src.base) 1 0)| lambda) 0)
 (* (* |ray_cstpncpy_#in~dst.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid cstpncpy_~s~3.base) 1 0)| lambda) 0)
 (* (* ray_cstpncpy_~src.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* ray_cstpncpy_~d~3.offset lambda) 0)
 (* (* |ray_cstpncpy_#t~post3| lambda) 0)
 (* (* |ray_cstpncpy_~#dst.base| lambda) 0)
 (* (* ray_cstpncpy_~src.offset lambda) 0)
 (* (* |ray_cstpncpy_#in~src.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| lambda) 0)
 (* |ray_(select #length cstpncpy_~d~3.base)| 0)
 (* |ray_cstpncpy_#t~post4.offset| 0) 
 (* ray_cstpncpy_~s~3.offset 0)
 (*
 |ray_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |ray_cstpncpy_#t~mem7| 0) 
 (* ray_cstpncpy_~d~3.base (- 1)) 
 (* |ray_cstpncpy_#t~post5.base| 0)
 (* |ray_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (* ray_cstpncpy_~s~3.base 0) 
 (* |ray_(select #length cstpncpy_~s~3.base)| 0) 
 (* ray_cstpncpy_~n 0) (* |ray_cstpncpy_#t~post4.base| 0)
 (* |ray_cstpncpy_#t~post5.offset| 0)
 (* |ray_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* ray_cstpncpy_~d~3.offset 0) 
 (* |ray_cstpncpy_#t~post3| 0)) 0)
 (>=
 (+ (* (* |ray_cstpncpy_#t~mem0.offset| lambda) 0)
 (* (* |ray_(select #length cstpncpy_~d~3.base)| lambda) 0)
 (* (* |ray_cstpncpy_#t~post4.offset| lambda) 0)
 (* (* ray_cstpncpy_~s~3.offset lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 lambda) 0)
 (* (* |ray_(select old(#length) cstpncpy_#in~src.base)| lambda) 0)
 (* (* |ray_cstpncpy_~#dst.offset| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 lambda) 0) (* (* |ray_cstpncpy_#t~mem7| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 lambda) 0) (* (* ray_cstpncpy_~d~3.base lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 lambda) 0) (* (* |ray_(select #length cstpncpy_#in~src.base)| lambda) 0)
 (* (* |ray_cstpncpy_#in~src.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| lambda) 0)
 (* (* |ray_cstpncpy_#t~mem1.offset| lambda) 0)
 (* (* |ray_(select #length cstpncpy_#in~dst.base)| lambda) 0)
 (* (* |ray_cstpncpy_#t~mem0.base| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_cstpncpy_#in~n| lambda) 0)
 (* (* |ray_cstpncpy_#t~mem1.base| lambda) 0)
 (* (* |ray_cstpncpy_#t~post5.base| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(select old(#length) cstpncpy_~#dst.base)| lambda) 0)
 (* (* |ray_(ite (select #valid cstpncpy_~d~3.base) 1 0)| lambda) 0)
 (* (* ray_cstpncpy_~s~3.base lambda) 0)
 (*
 (*
 |ray_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 lambda) 0) (* (* |ray_(select #length cstpncpy_~s~3.base)| lambda) 0)
 (* (* ray_cstpncpy_~n lambda) 0)
 (* (* |ray_cstpncpy_#in~dst.base| lambda) 0)
 (* (* |ray_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length cstpncpy_~#dst.base)| lambda) 0)
 (* (* |ray_cstpncpy_#t~post4.base| lambda) 0)
 (* (* |ray_(ite (select #valid cstpncpy_~#dst.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) cstpncpy_#in~dst.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| lambda) 0)
 (* (* |ray_cstpncpy_#t~post5.offset| lambda) 0)
 (* (* |ray_(ite (select #valid cstpncpy_#in~src.base) 1 0)| lambda) 0)
 (* (* |ray_cstpncpy_#in~dst.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid cstpncpy_~s~3.base) 1 0)| lambda) 0)
 (* (* ray_cstpncpy_~src.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* ray_cstpncpy_~d~3.offset lambda) 0)
 (* (* |ray_cstpncpy_#t~post3| lambda) 0)
 (* (* |ray_cstpncpy_~#dst.base| lambda) 0)
 (* (* ray_cstpncpy_~src.offset lambda) 0)
 (* (* |ray_cstpncpy_#in~src.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| lambda) 0)
 (* |ray_(select #length cstpncpy_~d~3.base)| 0)
 (* |ray_cstpncpy_#t~post4.offset| 0) 
 (* ray_cstpncpy_~s~3.offset (- 1))
 (*
 |ray_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |ray_cstpncpy_#t~mem7| 0) 
 (* ray_cstpncpy_~d~3.base 0) 
 (* |ray_cstpncpy_#t~post5.base| 0)
 (* |ray_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (* ray_cstpncpy_~s~3.base 0) 
 (* |ray_(select #length cstpncpy_~s~3.base)| 1) 
 (* ray_cstpncpy_~n 0) (* |ray_cstpncpy_#t~post4.base| 0)
 (* |ray_cstpncpy_#t~post5.offset| 0)
 (* |ray_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* ray_cstpncpy_~d~3.offset 0) 
 (* |ray_cstpncpy_#t~post3| 0)) 0)
 (>=
 (+ (* (* |ray_cstpncpy_#t~mem0.offset| lambda) 0)
 (* (* |ray_(select #length cstpncpy_~d~3.base)| lambda) 0)
 (* (* |ray_cstpncpy_#t~post4.offset| lambda) 0)
 (* (* ray_cstpncpy_~s~3.offset lambda) (- 1))
 (*
 (*
 |ray_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 lambda) 0)
 (* (* |ray_(select old(#length) cstpncpy_#in~src.base)| lambda) 0)
 (* (* |ray_cstpncpy_~#dst.offset| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 lambda) 0) (* (* |ray_cstpncpy_#t~mem7| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 lambda) 0) (* (* ray_cstpncpy_~d~3.base lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 lambda) 0) (* (* |ray_(select #length cstpncpy_#in~src.base)| lambda) 0)
 (* (* |ray_cstpncpy_#in~src.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| lambda) 0)
 (* (* |ray_cstpncpy_#t~mem1.offset| lambda) 0)
 (* (* |ray_(select #length cstpncpy_#in~dst.base)| lambda) 0)
 (* (* |ray_cstpncpy_#t~mem0.base| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_cstpncpy_#in~n| lambda) 0)
 (* (* |ray_cstpncpy_#t~mem1.base| lambda) 0)
 (* (* |ray_cstpncpy_#t~post5.base| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(select old(#length) cstpncpy_~#dst.base)| lambda) 0)
 (* (* |ray_(ite (select #valid cstpncpy_~d~3.base) 1 0)| lambda) 0)
 (* (* ray_cstpncpy_~s~3.base lambda) 0)
 (*
 (*
 |ray_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 lambda) 0) (* (* |ray_(select #length cstpncpy_~s~3.base)| lambda) 0)
 (* (* ray_cstpncpy_~n lambda) 0)
 (* (* |ray_cstpncpy_#in~dst.base| lambda) 0)
 (* (* |ray_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length cstpncpy_~#dst.base)| lambda) 0)
 (* (* |ray_cstpncpy_#t~post4.base| lambda) 0)
 (* (* |ray_(ite (select #valid cstpncpy_~#dst.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) cstpncpy_#in~dst.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| lambda) 0)
 (* (* |ray_cstpncpy_#t~post5.offset| lambda) 0)
 (* (* |ray_(ite (select #valid cstpncpy_#in~src.base) 1 0)| lambda) 0)
 (* (* |ray_cstpncpy_#in~dst.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid cstpncpy_~s~3.base) 1 0)| lambda) 0)
 (* (* ray_cstpncpy_~src.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* ray_cstpncpy_~d~3.offset lambda) 0)
 (* (* |ray_cstpncpy_#t~post3| lambda) 0)
 (* (* |ray_cstpncpy_~#dst.base| lambda) 0)
 (* (* ray_cstpncpy_~src.offset lambda) 0)
 (* (* |ray_cstpncpy_#in~src.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| lambda) 0)
 (* |ray_(select #length cstpncpy_~d~3.base)| 0)
 (* |ray_cstpncpy_#t~post4.offset| 0) 
 (* ray_cstpncpy_~s~3.offset 1)
 (*
 |ray_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |ray_cstpncpy_#t~mem7| 0) 
 (* ray_cstpncpy_~d~3.base 0) 
 (* |ray_cstpncpy_#t~post5.base| 0)
 (* |ray_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (* ray_cstpncpy_~s~3.base 0) 
 (* |ray_(select #length cstpncpy_~s~3.base)| 0) 
 (* ray_cstpncpy_~n 0) (* |ray_cstpncpy_#t~post4.base| 0)
 (* |ray_cstpncpy_#t~post5.offset| 0)
 (* |ray_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* ray_cstpncpy_~d~3.offset 0) 
 (* |ray_cstpncpy_#t~post3| 0)) 0)
 (>=
 (+ (* (* |ray_cstpncpy_#t~mem0.offset| lambda) 0)
 (* (* |ray_(select #length cstpncpy_~d~3.base)| lambda) 0)
 (* (* |ray_cstpncpy_#t~post4.offset| lambda) 0)
 (* (* ray_cstpncpy_~s~3.offset lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 lambda) 0)
 (* (* |ray_(select old(#length) cstpncpy_#in~src.base)| lambda) 0)
 (* (* |ray_cstpncpy_~#dst.offset| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 lambda) 0) (* (* |ray_cstpncpy_#t~mem7| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 lambda) 0) (* (* ray_cstpncpy_~d~3.base lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 lambda) 0) (* (* |ray_(select #length cstpncpy_#in~src.base)| lambda) 0)
 (* (* |ray_cstpncpy_#in~src.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| lambda) 0)
 (* (* |ray_cstpncpy_#t~mem1.offset| lambda) 0)
 (* (* |ray_(select #length cstpncpy_#in~dst.base)| lambda) 0)
 (* (* |ray_cstpncpy_#t~mem0.base| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_cstpncpy_#in~n| lambda) 0)
 (* (* |ray_cstpncpy_#t~mem1.base| lambda) 0)
 (* (* |ray_cstpncpy_#t~post5.base| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(select old(#length) cstpncpy_~#dst.base)| lambda) 0)
 (* (* |ray_(ite (select #valid cstpncpy_~d~3.base) 1 0)| lambda) 0)
 (* (* ray_cstpncpy_~s~3.base lambda) 0)
 (*
 (*
 |ray_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 lambda) 0) (* (* |ray_(select #length cstpncpy_~s~3.base)| lambda) 0)
 (* (* ray_cstpncpy_~n lambda) (- 1))
 (* (* |ray_cstpncpy_#in~dst.base| lambda) 0)
 (* (* |ray_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length cstpncpy_~#dst.base)| lambda) 0)
 (* (* |ray_cstpncpy_#t~post4.base| lambda) 0)
 (* (* |ray_(ite (select #valid cstpncpy_~#dst.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) cstpncpy_#in~dst.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| lambda) 0)
 (* (* |ray_cstpncpy_#t~post5.offset| lambda) 0)
 (* (* |ray_(ite (select #valid cstpncpy_#in~src.base) 1 0)| lambda) 0)
 (* (* |ray_cstpncpy_#in~dst.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid cstpncpy_~s~3.base) 1 0)| lambda) 0)
 (* (* ray_cstpncpy_~src.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* ray_cstpncpy_~d~3.offset lambda) 0)
 (* (* |ray_cstpncpy_#t~post3| lambda) 0)
 (* (* |ray_cstpncpy_~#dst.base| lambda) 0)
 (* (* ray_cstpncpy_~src.offset lambda) 0)
 (* (* |ray_cstpncpy_#in~src.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| lambda) 0)
 (* |ray_(select #length cstpncpy_~d~3.base)| 0)
 (* |ray_cstpncpy_#t~post4.offset| 0) 
 (* ray_cstpncpy_~s~3.offset 0)
 (*
 |ray_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |ray_cstpncpy_#t~mem7| 0) 
 (* ray_cstpncpy_~d~3.base 0) 
 (* |ray_cstpncpy_#t~post5.base| 0)
 (* |ray_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (* ray_cstpncpy_~s~3.base 0) 
 (* |ray_(select #length cstpncpy_~s~3.base)| 0) 
 (* ray_cstpncpy_~n 1) (* |ray_cstpncpy_#t~post4.base| 0)
 (* |ray_cstpncpy_#t~post5.offset| 0)
 (* |ray_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* ray_cstpncpy_~d~3.offset 0) 
 (* |ray_cstpncpy_#t~post3| 0)) 0)
 (>=
 (+ (* (* |ray_cstpncpy_#t~mem0.offset| lambda) 0)
 (* (* |ray_(select #length cstpncpy_~d~3.base)| lambda) 0)
 (* (* |ray_cstpncpy_#t~post4.offset| lambda) 0)
 (* (* ray_cstpncpy_~s~3.offset lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 lambda) 0)
 (* (* |ray_(select old(#length) cstpncpy_#in~src.base)| lambda) 0)
 (* (* |ray_cstpncpy_~#dst.offset| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 lambda) 0) (* (* |ray_cstpncpy_#t~mem7| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 lambda) 0) (* (* ray_cstpncpy_~d~3.base lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 lambda) 0) (* (* |ray_(select #length cstpncpy_#in~src.base)| lambda) 0)
 (* (* |ray_cstpncpy_#in~src.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| lambda) 0)
 (* (* |ray_cstpncpy_#t~mem1.offset| lambda) 0)
 (* (* |ray_(select #length cstpncpy_#in~dst.base)| lambda) 0)
 (* (* |ray_cstpncpy_#t~mem0.base| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_cstpncpy_#in~n| lambda) 0)
 (* (* |ray_cstpncpy_#t~mem1.base| lambda) 0)
 (* (* |ray_cstpncpy_#t~post5.base| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(select old(#length) cstpncpy_~#dst.base)| lambda) 0)
 (* (* |ray_(ite (select #valid cstpncpy_~d~3.base) 1 0)| lambda) 0)
 (* (* ray_cstpncpy_~s~3.base lambda) 0)
 (*
 (*
 |ray_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 lambda) 0) (* (* |ray_(select #length cstpncpy_~s~3.base)| lambda) 0)
 (* (* ray_cstpncpy_~n lambda) 0)
 (* (* |ray_cstpncpy_#in~dst.base| lambda) 0)
 (* (* |ray_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length cstpncpy_~#dst.base)| lambda) 0)
 (* (* |ray_cstpncpy_#t~post4.base| lambda) 0)
 (* (* |ray_(ite (select #valid cstpncpy_~#dst.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) cstpncpy_#in~dst.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| lambda) 0)
 (* (* |ray_cstpncpy_#t~post5.offset| lambda) 0)
 (* (* |ray_(ite (select #valid cstpncpy_#in~src.base) 1 0)| lambda) 0)
 (* (* |ray_cstpncpy_#in~dst.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid cstpncpy_~s~3.base) 1 0)| lambda) 0)
 (* (* ray_cstpncpy_~src.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* ray_cstpncpy_~d~3.offset lambda) 1)
 (* (* |ray_cstpncpy_#t~post3| lambda) 0)
 (* (* |ray_cstpncpy_~#dst.base| lambda) 0)
 (* (* ray_cstpncpy_~src.offset lambda) 0)
 (* (* |ray_cstpncpy_#in~src.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| lambda) 0)
 (* |ray_(select #length cstpncpy_~d~3.base)| 0)
 (* |ray_cstpncpy_#t~post4.offset| 0) 
 (* ray_cstpncpy_~s~3.offset 0)
 (*
 |ray_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |ray_cstpncpy_#t~mem7| 0) 
 (* ray_cstpncpy_~d~3.base 0) 
 (* |ray_cstpncpy_#t~post5.base| 0)
 (* |ray_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (* ray_cstpncpy_~s~3.base 0) 
 (* |ray_(select #length cstpncpy_~s~3.base)| 0) 
 (* ray_cstpncpy_~n 0) (* |ray_cstpncpy_#t~post4.base| 0)
 (* |ray_cstpncpy_#t~post5.offset| 0)
 (* |ray_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* ray_cstpncpy_~d~3.offset (- 1)) 
 (* |ray_cstpncpy_#t~post3| 0)) 0)
 (>=
 (+ (* (* |ray_cstpncpy_#t~mem0.offset| lambda) 0)
 (* (* |ray_(select #length cstpncpy_~d~3.base)| lambda) 0)
 (* (* |ray_cstpncpy_#t~post4.offset| lambda) 0)
 (* (* ray_cstpncpy_~s~3.offset lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 lambda) 0)
 (* (* |ray_(select old(#length) cstpncpy_#in~src.base)| lambda) 0)
 (* (* |ray_cstpncpy_~#dst.offset| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 lambda) 0) (* (* |ray_cstpncpy_#t~mem7| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 lambda) 0) (* (* ray_cstpncpy_~d~3.base lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 lambda) 0) (* (* |ray_(select #length cstpncpy_#in~src.base)| lambda) 0)
 (* (* |ray_cstpncpy_#in~src.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| lambda) 0)
 (* (* |ray_cstpncpy_#t~mem1.offset| lambda) 0)
 (* (* |ray_(select #length cstpncpy_#in~dst.base)| lambda) 0)
 (* (* |ray_cstpncpy_#t~mem0.base| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_cstpncpy_#in~n| lambda) 0)
 (* (* |ray_cstpncpy_#t~mem1.base| lambda) 0)
 (* (* |ray_cstpncpy_#t~post5.base| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(select old(#length) cstpncpy_~#dst.base)| lambda) 0)
 (* (* |ray_(ite (select #valid cstpncpy_~d~3.base) 1 0)| lambda) 0)
 (* (* ray_cstpncpy_~s~3.base lambda) 1)
 (*
 (*
 |ray_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 lambda) 0) (* (* |ray_(select #length cstpncpy_~s~3.base)| lambda) 0)
 (* (* ray_cstpncpy_~n lambda) 0)
 (* (* |ray_cstpncpy_#in~dst.base| lambda) 0)
 (* (* |ray_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length cstpncpy_~#dst.base)| lambda) 0)
 (* (* |ray_cstpncpy_#t~post4.base| lambda) 0)
 (* (* |ray_(ite (select #valid cstpncpy_~#dst.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) cstpncpy_#in~dst.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| lambda) 0)
 (* (* |ray_cstpncpy_#t~post5.offset| lambda) 0)
 (* (* |ray_(ite (select #valid cstpncpy_#in~src.base) 1 0)| lambda) 0)
 (* (* |ray_cstpncpy_#in~dst.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid cstpncpy_~s~3.base) 1 0)| lambda) 0)
 (* (* ray_cstpncpy_~src.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* ray_cstpncpy_~d~3.offset lambda) 0)
 (* (* |ray_cstpncpy_#t~post3| lambda) 0)
 (* (* |ray_cstpncpy_~#dst.base| lambda) 0)
 (* (* ray_cstpncpy_~src.offset lambda) 0)
 (* (* |ray_cstpncpy_#in~src.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| lambda) 0)
 (* |ray_(select #length cstpncpy_~d~3.base)| 0)
 (* |ray_cstpncpy_#t~post4.offset| 0) 
 (* ray_cstpncpy_~s~3.offset 0)
 (*
 |ray_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |ray_cstpncpy_#t~mem7| 0) 
 (* ray_cstpncpy_~d~3.base (- 1)) 
 (* |ray_cstpncpy_#t~post5.base| 0)
 (* |ray_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (* ray_cstpncpy_~s~3.base 0) 
 (* |ray_(select #length cstpncpy_~s~3.base)| 0) 
 (* ray_cstpncpy_~n 0) (* |ray_cstpncpy_#t~post4.base| 0)
 (* |ray_cstpncpy_#t~post5.offset| 0)
 (* |ray_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* ray_cstpncpy_~d~3.offset 0) 
 (* |ray_cstpncpy_#t~post3| 0)) 0)
 (>=
 (+ (* (* |ray_cstpncpy_#t~mem0.offset| lambda) 0)
 (* (* |ray_(select #length cstpncpy_~d~3.base)| lambda) 0)
 (* (* |ray_cstpncpy_#t~post4.offset| lambda) 0)
 (* (* ray_cstpncpy_~s~3.offset lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 lambda) 0)
 (* (* |ray_(select old(#length) cstpncpy_#in~src.base)| lambda) 0)
 (* (* |ray_cstpncpy_~#dst.offset| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 lambda) 0) (* (* |ray_cstpncpy_#t~mem7| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 lambda) 0) (* (* ray_cstpncpy_~d~3.base lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 lambda) 0) (* (* |ray_(select #length cstpncpy_#in~src.base)| lambda) 0)
 (* (* |ray_cstpncpy_#in~src.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| lambda) 0)
 (* (* |ray_cstpncpy_#t~mem1.offset| lambda) 0)
 (* (* |ray_(select #length cstpncpy_#in~dst.base)| lambda) 0)
 (* (* |ray_cstpncpy_#t~mem0.base| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_cstpncpy_#in~n| lambda) 0)
 (* (* |ray_cstpncpy_#t~mem1.base| lambda) 0)
 (* (* |ray_cstpncpy_#t~post5.base| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(select old(#length) cstpncpy_~#dst.base)| lambda) 0)
 (* (* |ray_(ite (select #valid cstpncpy_~d~3.base) 1 0)| lambda) 0)
 (* (* ray_cstpncpy_~s~3.base lambda) 0)
 (*
 (*
 |ray_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 lambda) 0) (* (* |ray_(select #length cstpncpy_~s~3.base)| lambda) 0)
 (* (* ray_cstpncpy_~n lambda) 0)
 (* (* |ray_cstpncpy_#in~dst.base| lambda) 0)
 (* (* |ray_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length cstpncpy_~#dst.base)| lambda) 0)
 (* (* |ray_cstpncpy_#t~post4.base| lambda) 0)
 (* (* |ray_(ite (select #valid cstpncpy_~#dst.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) cstpncpy_#in~dst.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| lambda) 0)
 (* (* |ray_cstpncpy_#t~post5.offset| lambda) 0)
 (* (* |ray_(ite (select #valid cstpncpy_#in~src.base) 1 0)| lambda) 0)
 (* (* |ray_cstpncpy_#in~dst.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid cstpncpy_~s~3.base) 1 0)| lambda) 1)
 (* (* ray_cstpncpy_~src.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* ray_cstpncpy_~d~3.offset lambda) 0)
 (* (* |ray_cstpncpy_#t~post3| lambda) 0)
 (* (* |ray_cstpncpy_~#dst.base| lambda) 0)
 (* (* ray_cstpncpy_~src.offset lambda) 0)
 (* (* |ray_cstpncpy_#in~src.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| lambda) 0)
 (* |ray_(select #length cstpncpy_~d~3.base)| 0)
 (* |ray_cstpncpy_#t~post4.offset| 0) 
 (* ray_cstpncpy_~s~3.offset 0)
 (*
 |ray_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |ray_cstpncpy_#t~mem7| 0) 
 (* ray_cstpncpy_~d~3.base 0) 
 (* |ray_cstpncpy_#t~post5.base| 0)
 (* |ray_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (* ray_cstpncpy_~s~3.base 0) 
 (* |ray_(select #length cstpncpy_~s~3.base)| 0) 
 (* ray_cstpncpy_~n 0) (* |ray_cstpncpy_#t~post4.base| 0)
 (* |ray_cstpncpy_#t~post5.offset| 0)
 (* |ray_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* ray_cstpncpy_~d~3.offset 0) 
 (* |ray_cstpncpy_#t~post3| 0)) 0)
 (>=
 (+ (* (* |ray_cstpncpy_#t~mem0.offset| lambda) 0)
 (* (* |ray_(select #length cstpncpy_~d~3.base)| lambda) 0)
 (* (* |ray_cstpncpy_#t~post4.offset| lambda) 0)
 (* (* ray_cstpncpy_~s~3.offset lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 lambda) 0)
 (* (* |ray_(select old(#length) cstpncpy_#in~src.base)| lambda) 0)
 (* (* |ray_cstpncpy_~#dst.offset| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 lambda) 0) (* (* |ray_cstpncpy_#t~mem7| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 lambda) 0) (* (* ray_cstpncpy_~d~3.base lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 lambda) 0) (* (* |ray_(select #length cstpncpy_#in~src.base)| lambda) 0)
 (* (* |ray_cstpncpy_#in~src.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| lambda) 0)
 (* (* |ray_cstpncpy_#t~mem1.offset| lambda) 0)
 (* (* |ray_(select #length cstpncpy_#in~dst.base)| lambda) 0)
 (* (* |ray_cstpncpy_#t~mem0.base| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_cstpncpy_#in~n| lambda) 0)
 (* (* |ray_cstpncpy_#t~mem1.base| lambda) 0)
 (* (* |ray_cstpncpy_#t~post5.base| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(select old(#length) cstpncpy_~#dst.base)| lambda) 0)
 (* (* |ray_(ite (select #valid cstpncpy_~d~3.base) 1 0)| lambda) 0)
 (* (* ray_cstpncpy_~s~3.base lambda) 0)
 (*
 (*
 |ray_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 lambda) 0) (* (* |ray_(select #length cstpncpy_~s~3.base)| lambda) 0)
 (* (* ray_cstpncpy_~n lambda) 0)
 (* (* |ray_cstpncpy_#in~dst.base| lambda) 0)
 (* (* |ray_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length cstpncpy_~#dst.base)| lambda) 0)
 (* (* |ray_cstpncpy_#t~post4.base| lambda) 0)
 (* (* |ray_(ite (select #valid cstpncpy_~#dst.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) cstpncpy_#in~dst.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| lambda) 0)
 (* (* |ray_cstpncpy_#t~post5.offset| lambda) 0)
 (* (* |ray_(ite (select #valid cstpncpy_#in~src.base) 1 0)| lambda) 0)
 (* (* |ray_cstpncpy_#in~dst.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid cstpncpy_~s~3.base) 1 0)| lambda) 0)
 (* (* ray_cstpncpy_~src.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* ray_cstpncpy_~d~3.offset lambda) 0)
 (* (* |ray_cstpncpy_#t~post3| lambda) 0)
 (* (* |ray_cstpncpy_~#dst.base| lambda) 0)
 (* (* ray_cstpncpy_~src.offset lambda) 0)
 (* (* |ray_cstpncpy_#in~src.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| lambda) 0)
 (* |ray_(select #length cstpncpy_~d~3.base)| 0)
 (* |ray_cstpncpy_#t~post4.offset| 0) 
 (* ray_cstpncpy_~s~3.offset 0)
 (*
 |ray_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |ray_cstpncpy_#t~mem7| 0) 
 (* ray_cstpncpy_~d~3.base 0) 
 (* |ray_cstpncpy_#t~post5.base| 0)
 (* |ray_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (* ray_cstpncpy_~s~3.base 0) 
 (* |ray_(select #length cstpncpy_~s~3.base)| 0) 
 (* ray_cstpncpy_~n (- 1)) 
 (* |ray_cstpncpy_#t~post4.base| 0) 
 (* |ray_cstpncpy_#t~post5.offset| 0)
 (* |ray_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* ray_cstpncpy_~d~3.offset 0) 
 (* |ray_cstpncpy_#t~post3| 0) 
 (* aux_3710 1) (* aux_3711 4294967296)) 0)
 (>=
 (+ (* (* |ray_cstpncpy_#t~mem0.offset| lambda) 0)
 (* (* |ray_(select #length cstpncpy_~d~3.base)| lambda) 0)
 (* (* |ray_cstpncpy_#t~post4.offset| lambda) 0)
 (* (* ray_cstpncpy_~s~3.offset lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 lambda) 0)
 (* (* |ray_(select old(#length) cstpncpy_#in~src.base)| lambda) 0)
 (* (* |ray_cstpncpy_~#dst.offset| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 lambda) 0) (* (* |ray_cstpncpy_#t~mem7| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 lambda) 0) (* (* ray_cstpncpy_~d~3.base lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 lambda) 0) (* (* |ray_(select #length cstpncpy_#in~src.base)| lambda) 0)
 (* (* |ray_cstpncpy_#in~src.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| lambda) 0)
 (* (* |ray_cstpncpy_#t~mem1.offset| lambda) 0)
 (* (* |ray_(select #length cstpncpy_#in~dst.base)| lambda) 0)
 (* (* |ray_cstpncpy_#t~mem0.base| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_cstpncpy_#in~n| lambda) 0)
 (* (* |ray_cstpncpy_#t~mem1.base| lambda) 0)
 (* (* |ray_cstpncpy_#t~post5.base| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(select old(#length) cstpncpy_~#dst.base)| lambda) 0)
 (* (* |ray_(ite (select #valid cstpncpy_~d~3.base) 1 0)| lambda) 0)
 (* (* ray_cstpncpy_~s~3.base lambda) 0)
 (*
 (*
 |ray_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 lambda) 0) (* (* |ray_(select #length cstpncpy_~s~3.base)| lambda) 0)
 (* (* ray_cstpncpy_~n lambda) 0)
 (* (* |ray_cstpncpy_#in~dst.base| lambda) 0)
 (* (* |ray_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length cstpncpy_~#dst.base)| lambda) 0)
 (* (* |ray_cstpncpy_#t~post4.base| lambda) 0)
 (* (* |ray_(ite (select #valid cstpncpy_~#dst.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) cstpncpy_#in~dst.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| lambda) 0)
 (* (* |ray_cstpncpy_#t~post5.offset| lambda) 0)
 (* (* |ray_(ite (select #valid cstpncpy_#in~src.base) 1 0)| lambda) 0)
 (* (* |ray_cstpncpy_#in~dst.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid cstpncpy_~s~3.base) 1 0)| lambda) 0)
 (* (* ray_cstpncpy_~src.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* ray_cstpncpy_~d~3.offset lambda) 0)
 (* (* |ray_cstpncpy_#t~post3| lambda) 0)
 (* (* |ray_cstpncpy_~#dst.base| lambda) 0)
 (* (* ray_cstpncpy_~src.offset lambda) 0)
 (* (* |ray_cstpncpy_#in~src.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| lambda) 0)
 (* |ray_(select #length cstpncpy_~d~3.base)| 0)
 (* |ray_cstpncpy_#t~post4.offset| 0) 
 (* ray_cstpncpy_~s~3.offset 0)
 (*
 |ray_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |ray_cstpncpy_#t~mem7| 0) 
 (* ray_cstpncpy_~d~3.base 0) 
 (* |ray_cstpncpy_#t~post5.base| 0)
 (* |ray_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (* ray_cstpncpy_~s~3.base 0) 
 (* |ray_(select #length cstpncpy_~s~3.base)| 0) 
 (* ray_cstpncpy_~n 0) (* |ray_cstpncpy_#t~post4.base| 0)
 (* |ray_cstpncpy_#t~post5.offset| 0)
 (* |ray_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* ray_cstpncpy_~d~3.offset 0) 
 (* |ray_cstpncpy_#t~post3| 0) 
 (* aux_3710 (- 1))) 0)
 (>=
 (+ (* (* |ray_cstpncpy_#t~mem0.offset| lambda) 0)
 (* (* |ray_(select #length cstpncpy_~d~3.base)| lambda) 0)
 (* (* |ray_cstpncpy_#t~post4.offset| lambda) 0)
 (* (* ray_cstpncpy_~s~3.offset lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 lambda) 0)
 (* (* |ray_(select old(#length) cstpncpy_#in~src.base)| lambda) 0)
 (* (* |ray_cstpncpy_~#dst.offset| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 lambda) 0) (* (* |ray_cstpncpy_#t~mem7| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 lambda) 0) (* (* ray_cstpncpy_~d~3.base lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 lambda) 0) (* (* |ray_(select #length cstpncpy_#in~src.base)| lambda) 0)
 (* (* |ray_cstpncpy_#in~src.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| lambda) 0)
 (* (* |ray_cstpncpy_#t~mem1.offset| lambda) 0)
 (* (* |ray_(select #length cstpncpy_#in~dst.base)| lambda) 0)
 (* (* |ray_cstpncpy_#t~mem0.base| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_cstpncpy_#in~n| lambda) 0)
 (* (* |ray_cstpncpy_#t~mem1.base| lambda) 0)
 (* (* |ray_cstpncpy_#t~post5.base| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(select old(#length) cstpncpy_~#dst.base)| lambda) 0)
 (* (* |ray_(ite (select #valid cstpncpy_~d~3.base) 1 0)| lambda) 0)
 (* (* ray_cstpncpy_~s~3.base lambda) 0)
 (*
 (*
 |ray_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 lambda) 0) (* (* |ray_(select #length cstpncpy_~s~3.base)| lambda) 0)
 (* (* ray_cstpncpy_~n lambda) 0)
 (* (* |ray_cstpncpy_#in~dst.base| lambda) 0)
 (* (* |ray_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length cstpncpy_~#dst.base)| lambda) 0)
 (* (* |ray_cstpncpy_#t~post4.base| lambda) 0)
 (* (* |ray_(ite (select #valid cstpncpy_~#dst.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) cstpncpy_#in~dst.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| lambda) 0)
 (* (* |ray_cstpncpy_#t~post5.offset| lambda) 0)
 (* (* |ray_(ite (select #valid cstpncpy_#in~src.base) 1 0)| lambda) 0)
 (* (* |ray_cstpncpy_#in~dst.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid cstpncpy_~s~3.base) 1 0)| lambda) 0)
 (* (* ray_cstpncpy_~src.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* ray_cstpncpy_~d~3.offset lambda) 0)
 (* (* |ray_cstpncpy_#t~post3| lambda) 0)
 (* (* |ray_cstpncpy_~#dst.base| lambda) 0)
 (* (* ray_cstpncpy_~src.offset lambda) 0)
 (* (* |ray_cstpncpy_#in~src.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| lambda) 0)
 (* |ray_(select #length cstpncpy_~d~3.base)| 0)
 (* |ray_cstpncpy_#t~post4.offset| 0) 
 (* ray_cstpncpy_~s~3.offset 0)
 (*
 |ray_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |ray_cstpncpy_#t~mem7| 0) 
 (* ray_cstpncpy_~d~3.base 0) 
 (* |ray_cstpncpy_#t~post5.base| 0)
 (* |ray_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (* ray_cstpncpy_~s~3.base 0) 
 (* |ray_(select #length cstpncpy_~s~3.base)| 0) 
 (* ray_cstpncpy_~n 1) (* |ray_cstpncpy_#t~post4.base| 0)
 (* |ray_cstpncpy_#t~post5.offset| 0)
 (* |ray_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* ray_cstpncpy_~d~3.offset 0) 
 (* |ray_cstpncpy_#t~post3| 0) 
 (* aux_3710 (- 1)) (* aux_3711 (- 4294967296))) 0)
 (>=
 (+ (* (* |ray_cstpncpy_#t~mem0.offset| lambda) 0)
 (* (* |ray_(select #length cstpncpy_~d~3.base)| lambda) 0)
 (* (* |ray_cstpncpy_#t~post4.offset| lambda) 0)
 (* (* ray_cstpncpy_~s~3.offset lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 lambda) 0)
 (* (* |ray_(select old(#length) cstpncpy_#in~src.base)| lambda) 0)
 (* (* |ray_cstpncpy_~#dst.offset| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 lambda) 0) (* (* |ray_cstpncpy_#t~mem7| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 lambda) 0) (* (* ray_cstpncpy_~d~3.base lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 lambda) 0) (* (* |ray_(select #length cstpncpy_#in~src.base)| lambda) 0)
 (* (* |ray_cstpncpy_#in~src.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| lambda) 0)
 (* (* |ray_cstpncpy_#t~mem1.offset| lambda) 0)
 (* (* |ray_(select #length cstpncpy_#in~dst.base)| lambda) 0)
 (* (* |ray_cstpncpy_#t~mem0.base| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_cstpncpy_#in~n| lambda) 0)
 (* (* |ray_cstpncpy_#t~mem1.base| lambda) 0)
 (* (* |ray_cstpncpy_#t~post5.base| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(select old(#length) cstpncpy_~#dst.base)| lambda) 0)
 (* (* |ray_(ite (select #valid cstpncpy_~d~3.base) 1 0)| lambda) 0)
 (* (* ray_cstpncpy_~s~3.base lambda) 0)
 (*
 (*
 |ray_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 lambda) 0) (* (* |ray_(select #length cstpncpy_~s~3.base)| lambda) 0)
 (* (* ray_cstpncpy_~n lambda) 0)
 (* (* |ray_cstpncpy_#in~dst.base| lambda) 0)
 (* (* |ray_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length cstpncpy_~#dst.base)| lambda) 0)
 (* (* |ray_cstpncpy_#t~post4.base| lambda) 0)
 (* (* |ray_(ite (select #valid cstpncpy_~#dst.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) cstpncpy_#in~dst.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| lambda) 0)
 (* (* |ray_cstpncpy_#t~post5.offset| lambda) 0)
 (* (* |ray_(ite (select #valid cstpncpy_#in~src.base) 1 0)| lambda) 0)
 (* (* |ray_cstpncpy_#in~dst.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid cstpncpy_~s~3.base) 1 0)| lambda) 0)
 (* (* ray_cstpncpy_~src.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* ray_cstpncpy_~d~3.offset lambda) 0)
 (* (* |ray_cstpncpy_#t~post3| lambda) 0)
 (* (* |ray_cstpncpy_~#dst.base| lambda) 0)
 (* (* ray_cstpncpy_~src.offset lambda) 0)
 (* (* |ray_cstpncpy_#in~src.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| lambda) 0)
 (* |ray_(select #length cstpncpy_~d~3.base)| 0)
 (* |ray_cstpncpy_#t~post4.offset| 0) 
 (* ray_cstpncpy_~s~3.offset 0)
 (*
 |ray_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |ray_cstpncpy_#t~mem7| 0) 
 (* ray_cstpncpy_~d~3.base 0) 
 (* |ray_cstpncpy_#t~post5.base| 0)
 (* |ray_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (* ray_cstpncpy_~s~3.base 0) 
 (* |ray_(select #length cstpncpy_~s~3.base)| 0) 
 (* ray_cstpncpy_~n 0) (* |ray_cstpncpy_#t~post4.base| 0)
 (* |ray_cstpncpy_#t~post5.offset| 0)
 (* |ray_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* ray_cstpncpy_~d~3.offset 0) 
 (* |ray_cstpncpy_#t~post3| 0) 
 (* aux_3715 (- 1)) (* aux_3716 (- 4294967296))) 0)
 (>=
 (+ (* (* |ray_cstpncpy_#t~mem0.offset| lambda) 0)
 (* (* |ray_(select #length cstpncpy_~d~3.base)| lambda) 0)
 (* (* |ray_cstpncpy_#t~post4.offset| lambda) 0)
 (* (* ray_cstpncpy_~s~3.offset lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 lambda) 0)
 (* (* |ray_(select old(#length) cstpncpy_#in~src.base)| lambda) 0)
 (* (* |ray_cstpncpy_~#dst.offset| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 lambda) 0) (* (* |ray_cstpncpy_#t~mem7| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 lambda) 0) (* (* ray_cstpncpy_~d~3.base lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 lambda) 0) (* (* |ray_(select #length cstpncpy_#in~src.base)| lambda) 0)
 (* (* |ray_cstpncpy_#in~src.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| lambda) 0)
 (* (* |ray_cstpncpy_#t~mem1.offset| lambda) 0)
 (* (* |ray_(select #length cstpncpy_#in~dst.base)| lambda) 0)
 (* (* |ray_cstpncpy_#t~mem0.base| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_cstpncpy_#in~n| lambda) 0)
 (* (* |ray_cstpncpy_#t~mem1.base| lambda) 0)
 (* (* |ray_cstpncpy_#t~post5.base| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(select old(#length) cstpncpy_~#dst.base)| lambda) 0)
 (* (* |ray_(ite (select #valid cstpncpy_~d~3.base) 1 0)| lambda) 0)
 (* (* ray_cstpncpy_~s~3.base lambda) 0)
 (*
 (*
 |ray_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 lambda) 0) (* (* |ray_(select #length cstpncpy_~s~3.base)| lambda) 0)
 (* (* ray_cstpncpy_~n lambda) 0)
 (* (* |ray_cstpncpy_#in~dst.base| lambda) 0)
 (* (* |ray_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length cstpncpy_~#dst.base)| lambda) 0)
 (* (* |ray_cstpncpy_#t~post4.base| lambda) 0)
 (* (* |ray_(ite (select #valid cstpncpy_~#dst.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) cstpncpy_#in~dst.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| lambda) 0)
 (* (* |ray_cstpncpy_#t~post5.offset| lambda) 0)
 (* (* |ray_(ite (select #valid cstpncpy_#in~src.base) 1 0)| lambda) 0)
 (* (* |ray_cstpncpy_#in~dst.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid cstpncpy_~s~3.base) 1 0)| lambda) 0)
 (* (* ray_cstpncpy_~src.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* ray_cstpncpy_~d~3.offset lambda) 0)
 (* (* |ray_cstpncpy_#t~post3| lambda) 0)
 (* (* |ray_cstpncpy_~#dst.base| lambda) 0)
 (* (* ray_cstpncpy_~src.offset lambda) 0)
 (* (* |ray_cstpncpy_#in~src.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| lambda) 0)
 (* |ray_(select #length cstpncpy_~d~3.base)| 0)
 (* |ray_cstpncpy_#t~post4.offset| 0) 
 (* ray_cstpncpy_~s~3.offset 0)
 (*
 |ray_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |ray_cstpncpy_#t~mem7| 0) 
 (* ray_cstpncpy_~d~3.base 0) 
 (* |ray_cstpncpy_#t~post5.base| 0)
 (* |ray_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (* ray_cstpncpy_~s~3.base 0) 
 (* |ray_(select #length cstpncpy_~s~3.base)| 0) 
 (* ray_cstpncpy_~n 0) (* |ray_cstpncpy_#t~post4.base| 0)
 (* |ray_cstpncpy_#t~post5.offset| 0)
 (* |ray_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* ray_cstpncpy_~d~3.offset 0) 
 (* |ray_cstpncpy_#t~post3| 0) 
 (* aux_3715 1) (* aux_3716 4294967296)) 0)
 (>=
 (+ (* (* |ray_cstpncpy_#t~mem0.offset| lambda) 0)
 (* (* |ray_(select #length cstpncpy_~d~3.base)| lambda) 0)
 (* (* |ray_cstpncpy_#t~post4.offset| lambda) 0)
 (* (* ray_cstpncpy_~s~3.offset lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 lambda) 0)
 (* (* |ray_(select old(#length) cstpncpy_#in~src.base)| lambda) 0)
 (* (* |ray_cstpncpy_~#dst.offset| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 lambda) 0) (* (* |ray_cstpncpy_#t~mem7| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 lambda) 0) (* (* ray_cstpncpy_~d~3.base lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 lambda) 0) (* (* |ray_(select #length cstpncpy_#in~src.base)| lambda) 0)
 (* (* |ray_cstpncpy_#in~src.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| lambda) 0)
 (* (* |ray_cstpncpy_#t~mem1.offset| lambda) 0)
 (* (* |ray_(select #length cstpncpy_#in~dst.base)| lambda) 0)
 (* (* |ray_cstpncpy_#t~mem0.base| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_cstpncpy_#in~n| lambda) 0)
 (* (* |ray_cstpncpy_#t~mem1.base| lambda) 0)
 (* (* |ray_cstpncpy_#t~post5.base| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(select old(#length) cstpncpy_~#dst.base)| lambda) 0)
 (* (* |ray_(ite (select #valid cstpncpy_~d~3.base) 1 0)| lambda) 0)
 (* (* ray_cstpncpy_~s~3.base lambda) 0)
 (*
 (*
 |ray_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 lambda) 0) (* (* |ray_(select #length cstpncpy_~s~3.base)| lambda) 0)
 (* (* ray_cstpncpy_~n lambda) 0)
 (* (* |ray_cstpncpy_#in~dst.base| lambda) 0)
 (* (* |ray_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length cstpncpy_~#dst.base)| lambda) 0)
 (* (* |ray_cstpncpy_#t~post4.base| lambda) 0)
 (* (* |ray_(ite (select #valid cstpncpy_~#dst.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) cstpncpy_#in~dst.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| lambda) 0)
 (* (* |ray_cstpncpy_#t~post5.offset| lambda) 0)
 (* (* |ray_(ite (select #valid cstpncpy_#in~src.base) 1 0)| lambda) 0)
 (* (* |ray_cstpncpy_#in~dst.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid cstpncpy_~s~3.base) 1 0)| lambda) 0)
 (* (* ray_cstpncpy_~src.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* ray_cstpncpy_~d~3.offset lambda) 0)
 (* (* |ray_cstpncpy_#t~post3| lambda) 0)
 (* (* |ray_cstpncpy_~#dst.base| lambda) 0)
 (* (* ray_cstpncpy_~src.offset lambda) 0)
 (* (* |ray_cstpncpy_#in~src.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| lambda) 0)
 (* |ray_(select #length cstpncpy_~d~3.base)| 0)
 (* |ray_cstpncpy_#t~post4.offset| 0) 
 (* ray_cstpncpy_~s~3.offset 0)
 (*
 |ray_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |ray_cstpncpy_#t~mem7| 0) 
 (* ray_cstpncpy_~d~3.base 0) 
 (* |ray_cstpncpy_#t~post5.base| 0)
 (* |ray_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (* ray_cstpncpy_~s~3.base 0) 
 (* |ray_(select #length cstpncpy_~s~3.base)| 0) 
 (* ray_cstpncpy_~n 0) (* |ray_cstpncpy_#t~post4.base| 0)
 (* |ray_cstpncpy_#t~post5.offset| 0)
 (* |ray_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* ray_cstpncpy_~d~3.offset 0) 
 (* |ray_cstpncpy_#t~post3| 0) 
 (* aux_3715 1)) 0)
 (>=
 (+ (* (* |ray_cstpncpy_#t~mem0.offset| lambda) 0)
 (* (* |ray_(select #length cstpncpy_~d~3.base)| lambda) 1)
 (* (* |ray_cstpncpy_#t~post4.offset| lambda) 0)
 (* (* ray_cstpncpy_~s~3.offset lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 lambda) 0)
 (* (* |ray_(select old(#length) cstpncpy_#in~src.base)| lambda) 0)
 (* (* |ray_cstpncpy_~#dst.offset| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 lambda) 0) (* (* |ray_cstpncpy_#t~mem7| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 lambda) 0) (* (* ray_cstpncpy_~d~3.base lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 lambda) 0) (* (* |ray_(select #length cstpncpy_#in~src.base)| lambda) 0)
 (* (* |ray_cstpncpy_#in~src.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| lambda) 0)
 (* (* |ray_cstpncpy_#t~mem1.offset| lambda) 0)
 (* (* |ray_(select #length cstpncpy_#in~dst.base)| lambda) 0)
 (* (* |ray_cstpncpy_#t~mem0.base| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_cstpncpy_#in~n| lambda) 0)
 (* (* |ray_cstpncpy_#t~mem1.base| lambda) 0)
 (* (* |ray_cstpncpy_#t~post5.base| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(select old(#length) cstpncpy_~#dst.base)| lambda) 0)
 (* (* |ray_(ite (select #valid cstpncpy_~d~3.base) 1 0)| lambda) 0)
 (* (* ray_cstpncpy_~s~3.base lambda) 0)
 (*
 (*
 |ray_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 lambda) 0) (* (* |ray_(select #length cstpncpy_~s~3.base)| lambda) 0)
 (* (* ray_cstpncpy_~n lambda) 0)
 (* (* |ray_cstpncpy_#in~dst.base| lambda) 0)
 (* (* |ray_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length cstpncpy_~#dst.base)| lambda) 0)
 (* (* |ray_cstpncpy_#t~post4.base| lambda) 0)
 (* (* |ray_(ite (select #valid cstpncpy_~#dst.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) cstpncpy_#in~dst.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| lambda) 0)
 (* (* |ray_cstpncpy_#t~post5.offset| lambda) 0)
 (* (* |ray_(ite (select #valid cstpncpy_#in~src.base) 1 0)| lambda) 0)
 (* (* |ray_cstpncpy_#in~dst.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid cstpncpy_~s~3.base) 1 0)| lambda) 0)
 (* (* ray_cstpncpy_~src.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* ray_cstpncpy_~d~3.offset lambda) 0)
 (* (* |ray_cstpncpy_#t~post3| lambda) 0)
 (* (* |ray_cstpncpy_~#dst.base| lambda) 0)
 (* (* ray_cstpncpy_~src.offset lambda) 0)
 (* (* |ray_cstpncpy_#in~src.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| lambda) 0)
 (* |ray_(select #length cstpncpy_~d~3.base)| (- 1))
 (* |ray_cstpncpy_#t~post4.offset| 0) 
 (* ray_cstpncpy_~s~3.offset 0)
 (*
 |ray_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |ray_cstpncpy_#t~mem7| 0) 
 (* ray_cstpncpy_~d~3.base 0) 
 (* |ray_cstpncpy_#t~post5.base| 0)
 (* |ray_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (* ray_cstpncpy_~s~3.base 0) 
 (* |ray_(select #length cstpncpy_~s~3.base)| 0) 
 (* ray_cstpncpy_~n 0) (* |ray_cstpncpy_#t~post4.base| 0)
 (* |ray_cstpncpy_#t~post5.offset| 0)
 (* |ray_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* ray_cstpncpy_~d~3.offset 0) 
 (* |ray_cstpncpy_#t~post3| 0)) 0)
 (>=
 (+ (* (* |ray_cstpncpy_#t~mem0.offset| lambda) 0)
 (* (* |ray_(select #length cstpncpy_~d~3.base)| lambda) 0)
 (* (* |ray_cstpncpy_#t~post4.offset| lambda) 0)
 (* (* ray_cstpncpy_~s~3.offset lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 lambda) 0)
 (* (* |ray_(select old(#length) cstpncpy_#in~src.base)| lambda) 0)
 (* (* |ray_cstpncpy_~#dst.offset| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 lambda) 0) (* (* |ray_cstpncpy_#t~mem7| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 lambda) 0) (* (* ray_cstpncpy_~d~3.base lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 lambda) 0) (* (* |ray_(select #length cstpncpy_#in~src.base)| lambda) 0)
 (* (* |ray_cstpncpy_#in~src.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| lambda) 0)
 (* (* |ray_cstpncpy_#t~mem1.offset| lambda) 0)
 (* (* |ray_(select #length cstpncpy_#in~dst.base)| lambda) 0)
 (* (* |ray_cstpncpy_#t~mem0.base| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_cstpncpy_#in~n| lambda) 0)
 (* (* |ray_cstpncpy_#t~mem1.base| lambda) 0)
 (* (* |ray_cstpncpy_#t~post5.base| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(select old(#length) cstpncpy_~#dst.base)| lambda) 0)
 (* (* |ray_(ite (select #valid cstpncpy_~d~3.base) 1 0)| lambda) 0)
 (* (* ray_cstpncpy_~s~3.base lambda) (- 1))
 (*
 (*
 |ray_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 lambda) 0) (* (* |ray_(select #length cstpncpy_~s~3.base)| lambda) 0)
 (* (* ray_cstpncpy_~n lambda) 0)
 (* (* |ray_cstpncpy_#in~dst.base| lambda) 0)
 (* (* |ray_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length cstpncpy_~#dst.base)| lambda) 0)
 (* (* |ray_cstpncpy_#t~post4.base| lambda) 0)
 (* (* |ray_(ite (select #valid cstpncpy_~#dst.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) cstpncpy_#in~dst.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| lambda) 0)
 (* (* |ray_cstpncpy_#t~post5.offset| lambda) 0)
 (* (* |ray_(ite (select #valid cstpncpy_#in~src.base) 1 0)| lambda) 0)
 (* (* |ray_cstpncpy_#in~dst.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid cstpncpy_~s~3.base) 1 0)| lambda) 0)
 (* (* ray_cstpncpy_~src.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* ray_cstpncpy_~d~3.offset lambda) 0)
 (* (* |ray_cstpncpy_#t~post3| lambda) 0)
 (* (* |ray_cstpncpy_~#dst.base| lambda) 0)
 (* (* ray_cstpncpy_~src.offset lambda) 0)
 (* (* |ray_cstpncpy_#in~src.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| lambda) 0)
 (* |ray_(select #length cstpncpy_~d~3.base)| 0)
 (* |ray_cstpncpy_#t~post4.offset| 0) 
 (* ray_cstpncpy_~s~3.offset 0)
 (*
 |ray_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |ray_cstpncpy_#t~mem7| 0) 
 (* ray_cstpncpy_~d~3.base 0) 
 (* |ray_cstpncpy_#t~post5.base| 0)
 (* |ray_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (* ray_cstpncpy_~s~3.base 1) 
 (* |ray_(select #length cstpncpy_~s~3.base)| 0) 
 (* ray_cstpncpy_~n 0) (* |ray_cstpncpy_#t~post4.base| 0)
 (* |ray_cstpncpy_#t~post5.offset| 0)
 (* |ray_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* ray_cstpncpy_~d~3.offset 0) 
 (* |ray_cstpncpy_#t~post3| 0)) 0)
 (>=
 (+ (* (* |ray_cstpncpy_#t~mem0.offset| lambda) 0)
 (* (* |ray_(select #length cstpncpy_~d~3.base)| lambda) 0)
 (* (* |ray_cstpncpy_#t~post4.offset| lambda) 0)
 (* (* ray_cstpncpy_~s~3.offset lambda) 1)
 (*
 (*
 |ray_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 lambda) 0)
 (* (* |ray_(select old(#length) cstpncpy_#in~src.base)| lambda) 0)
 (* (* |ray_cstpncpy_~#dst.offset| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 lambda) 0) (* (* |ray_cstpncpy_#t~mem7| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 lambda) 0) (* (* ray_cstpncpy_~d~3.base lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 lambda) 0) (* (* |ray_(select #length cstpncpy_#in~src.base)| lambda) 0)
 (* (* |ray_cstpncpy_#in~src.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| lambda) 0)
 (* (* |ray_cstpncpy_#t~mem1.offset| lambda) 0)
 (* (* |ray_(select #length cstpncpy_#in~dst.base)| lambda) 0)
 (* (* |ray_cstpncpy_#t~mem0.base| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_cstpncpy_#in~n| lambda) 0)
 (* (* |ray_cstpncpy_#t~mem1.base| lambda) 0)
 (* (* |ray_cstpncpy_#t~post5.base| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(select old(#length) cstpncpy_~#dst.base)| lambda) 0)
 (* (* |ray_(ite (select #valid cstpncpy_~d~3.base) 1 0)| lambda) 0)
 (* (* ray_cstpncpy_~s~3.base lambda) 0)
 (*
 (*
 |ray_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 lambda) 0) (* (* |ray_(select #length cstpncpy_~s~3.base)| lambda) 0)
 (* (* ray_cstpncpy_~n lambda) 0)
 (* (* |ray_cstpncpy_#in~dst.base| lambda) 0)
 (* (* |ray_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length cstpncpy_~#dst.base)| lambda) 0)
 (* (* |ray_cstpncpy_#t~post4.base| lambda) 0)
 (* (* |ray_(ite (select #valid cstpncpy_~#dst.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) cstpncpy_#in~dst.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| lambda) 0)
 (* (* |ray_cstpncpy_#t~post5.offset| lambda) 0)
 (* (* |ray_(ite (select #valid cstpncpy_#in~src.base) 1 0)| lambda) 0)
 (* (* |ray_cstpncpy_#in~dst.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid cstpncpy_~s~3.base) 1 0)| lambda) 0)
 (* (* ray_cstpncpy_~src.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* ray_cstpncpy_~d~3.offset lambda) 0)
 (* (* |ray_cstpncpy_#t~post3| lambda) 0)
 (* (* |ray_cstpncpy_~#dst.base| lambda) 0)
 (* (* ray_cstpncpy_~src.offset lambda) 0)
 (* (* |ray_cstpncpy_#in~src.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| lambda) 0)
 (* |ray_(select #length cstpncpy_~d~3.base)| 0)
 (* |ray_cstpncpy_#t~post4.offset| 0) 
 (* ray_cstpncpy_~s~3.offset (- 1))
 (*
 |ray_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |ray_cstpncpy_#t~mem7| 0) 
 (* ray_cstpncpy_~d~3.base 0) 
 (* |ray_cstpncpy_#t~post5.base| 0)
 (* |ray_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (* ray_cstpncpy_~s~3.base 0) 
 (* |ray_(select #length cstpncpy_~s~3.base)| 0) 
 (* ray_cstpncpy_~n 0) (* |ray_cstpncpy_#t~post4.base| 0)
 (* |ray_cstpncpy_#t~post5.offset| 0)
 (* |ray_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* ray_cstpncpy_~d~3.offset 0) 
 (* |ray_cstpncpy_#t~post3| 0)) 0)
 (>=
 (+ (* (* |ray_cstpncpy_#t~mem0.offset| lambda) 0)
 (* (* |ray_(select #length cstpncpy_~d~3.base)| lambda) 0)
 (* (* |ray_cstpncpy_#t~post4.offset| lambda) 0)
 (* (* ray_cstpncpy_~s~3.offset lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 lambda) 0)
 (* (* |ray_(select old(#length) cstpncpy_#in~src.base)| lambda) 0)
 (* (* |ray_cstpncpy_~#dst.offset| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 lambda) 0) (* (* |ray_cstpncpy_#t~mem7| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 lambda) 0) (* (* ray_cstpncpy_~d~3.base lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 lambda) 0) (* (* |ray_(select #length cstpncpy_#in~src.base)| lambda) 0)
 (* (* |ray_cstpncpy_#in~src.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| lambda) 0)
 (* (* |ray_cstpncpy_#t~mem1.offset| lambda) 0)
 (* (* |ray_(select #length cstpncpy_#in~dst.base)| lambda) 0)
 (* (* |ray_cstpncpy_#t~mem0.base| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_cstpncpy_#in~n| lambda) 0)
 (* (* |ray_cstpncpy_#t~mem1.base| lambda) 0)
 (* (* |ray_cstpncpy_#t~post5.base| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(select old(#length) cstpncpy_~#dst.base)| lambda) 0)
 (* (* |ray_(ite (select #valid cstpncpy_~d~3.base) 1 0)| lambda) 0)
 (* (* ray_cstpncpy_~s~3.base lambda) 0)
 (*
 (*
 |ray_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 lambda) 0) (* (* |ray_(select #length cstpncpy_~s~3.base)| lambda) 0)
 (* (* ray_cstpncpy_~n lambda) 0)
 (* (* |ray_cstpncpy_#in~dst.base| lambda) 0)
 (* (* |ray_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length cstpncpy_~#dst.base)| lambda) 0)
 (* (* |ray_cstpncpy_#t~post4.base| lambda) 0)
 (* (* |ray_(ite (select #valid cstpncpy_~#dst.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) cstpncpy_#in~dst.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| lambda) 0)
 (* (* |ray_cstpncpy_#t~post5.offset| lambda) 0)
 (* (* |ray_(ite (select #valid cstpncpy_#in~src.base) 1 0)| lambda) 0)
 (* (* |ray_cstpncpy_#in~dst.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid cstpncpy_~s~3.base) 1 0)| lambda) 0)
 (* (* ray_cstpncpy_~src.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* ray_cstpncpy_~d~3.offset lambda) 0)
 (* (* |ray_cstpncpy_#t~post3| lambda) 0)
 (* (* |ray_cstpncpy_~#dst.base| lambda) 0)
 (* (* ray_cstpncpy_~src.offset lambda) 0)
 (* (* |ray_cstpncpy_#in~src.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| lambda) 0)
 (* |ray_(select #length cstpncpy_~d~3.base)| 0)
 (* |ray_cstpncpy_#t~post4.offset| 0) 
 (* ray_cstpncpy_~s~3.offset 0)
 (*
 |ray_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |ray_cstpncpy_#t~mem7| 0) 
 (* ray_cstpncpy_~d~3.base 0) 
 (* |ray_cstpncpy_#t~post5.base| 0)
 (* |ray_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (* ray_cstpncpy_~s~3.base 0) 
 (* |ray_(select #length cstpncpy_~s~3.base)| 0) 
 (* ray_cstpncpy_~n 0) (* |ray_cstpncpy_#t~post4.base| 0)
 (* |ray_cstpncpy_#t~post5.offset| 0)
 (* |ray_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 1)
 (* ray_cstpncpy_~d~3.offset 0) 
 (* |ray_cstpncpy_#t~post3| 0)) 0)
 (>=
 (+ (* (* |ray_cstpncpy_#t~mem0.offset| lambda) 0)
 (* (* |ray_(select #length cstpncpy_~d~3.base)| lambda) 0)
 (* (* |ray_cstpncpy_#t~post4.offset| lambda) 0)
 (* (* ray_cstpncpy_~s~3.offset lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 lambda) 0)
 (* (* |ray_(select old(#length) cstpncpy_#in~src.base)| lambda) 0)
 (* (* |ray_cstpncpy_~#dst.offset| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 lambda) 0) (* (* |ray_cstpncpy_#t~mem7| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 lambda) 0) (* (* ray_cstpncpy_~d~3.base lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 lambda) 0) (* (* |ray_(select #length cstpncpy_#in~src.base)| lambda) 0)
 (* (* |ray_cstpncpy_#in~src.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| lambda) 0)
 (* (* |ray_cstpncpy_#t~mem1.offset| lambda) 0)
 (* (* |ray_(select #length cstpncpy_#in~dst.base)| lambda) 0)
 (* (* |ray_cstpncpy_#t~mem0.base| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_cstpncpy_#in~n| lambda) 0)
 (* (* |ray_cstpncpy_#t~mem1.base| lambda) 0)
 (* (* |ray_cstpncpy_#t~post5.base| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(select old(#length) cstpncpy_~#dst.base)| lambda) 0)
 (* (* |ray_(ite (select #valid cstpncpy_~d~3.base) 1 0)| lambda) 0)
 (* (* ray_cstpncpy_~s~3.base lambda) 0)
 (*
 (*
 |ray_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 lambda) 0) (* (* |ray_(select #length cstpncpy_~s~3.base)| lambda) 0)
 (* (* ray_cstpncpy_~n lambda) 1)
 (* (* |ray_cstpncpy_#in~dst.base| lambda) 0)
 (* (* |ray_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length cstpncpy_~#dst.base)| lambda) 0)
 (* (* |ray_cstpncpy_#t~post4.base| lambda) 0)
 (* (* |ray_(ite (select #valid cstpncpy_~#dst.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) cstpncpy_#in~dst.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| lambda) 0)
 (* (* |ray_cstpncpy_#t~post5.offset| lambda) 0)
 (* (* |ray_(ite (select #valid cstpncpy_#in~src.base) 1 0)| lambda) 0)
 (* (* |ray_cstpncpy_#in~dst.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid cstpncpy_~s~3.base) 1 0)| lambda) 0)
 (* (* ray_cstpncpy_~src.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* ray_cstpncpy_~d~3.offset lambda) 0)
 (* (* |ray_cstpncpy_#t~post3| lambda) 0)
 (* (* |ray_cstpncpy_~#dst.base| lambda) 0)
 (* (* ray_cstpncpy_~src.offset lambda) 0)
 (* (* |ray_cstpncpy_#in~src.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| lambda) 0)
 (* |ray_(select #length cstpncpy_~d~3.base)| 0)
 (* |ray_cstpncpy_#t~post4.offset| 0) 
 (* ray_cstpncpy_~s~3.offset 0)
 (*
 |ray_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |ray_cstpncpy_#t~mem7| 0) 
 (* ray_cstpncpy_~d~3.base 0) 
 (* |ray_cstpncpy_#t~post5.base| 0)
 (* |ray_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (* ray_cstpncpy_~s~3.base 0) 
 (* |ray_(select #length cstpncpy_~s~3.base)| 0) 
 (* ray_cstpncpy_~n (- 1)) 
 (* |ray_cstpncpy_#t~post4.base| 0) 
 (* |ray_cstpncpy_#t~post5.offset| 0)
 (* |ray_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* ray_cstpncpy_~d~3.offset 0) 
 (* |ray_cstpncpy_#t~post3| 0)) 0)
 (>=
 (+ (* (* |ray_cstpncpy_#t~mem0.offset| lambda) 0)
 (* (* |ray_(select #length cstpncpy_~d~3.base)| lambda) 0)
 (* (* |ray_cstpncpy_#t~post4.offset| lambda) 0)
 (* (* ray_cstpncpy_~s~3.offset lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 lambda) 0)
 (* (* |ray_(select old(#length) cstpncpy_#in~src.base)| lambda) 0)
 (* (* |ray_cstpncpy_~#dst.offset| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 lambda) 0) (* (* |ray_cstpncpy_#t~mem7| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 lambda) 0) (* (* ray_cstpncpy_~d~3.base lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 lambda) 0) (* (* |ray_(select #length cstpncpy_#in~src.base)| lambda) 0)
 (* (* |ray_cstpncpy_#in~src.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| lambda) 0)
 (* (* |ray_cstpncpy_#t~mem1.offset| lambda) 0)
 (* (* |ray_(select #length cstpncpy_#in~dst.base)| lambda) 0)
 (* (* |ray_cstpncpy_#t~mem0.base| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_cstpncpy_#in~n| lambda) 0)
 (* (* |ray_cstpncpy_#t~mem1.base| lambda) 0)
 (* (* |ray_cstpncpy_#t~post5.base| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(select old(#length) cstpncpy_~#dst.base)| lambda) 0)
 (* (* |ray_(ite (select #valid cstpncpy_~d~3.base) 1 0)| lambda) 0)
 (* (* ray_cstpncpy_~s~3.base lambda) 0)
 (*
 (*
 |ray_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 lambda) 0) (* (* |ray_(select #length cstpncpy_~s~3.base)| lambda) 1)
 (* (* ray_cstpncpy_~n lambda) 0)
 (* (* |ray_cstpncpy_#in~dst.base| lambda) 0)
 (* (* |ray_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length cstpncpy_~#dst.base)| lambda) 0)
 (* (* |ray_cstpncpy_#t~post4.base| lambda) 0)
 (* (* |ray_(ite (select #valid cstpncpy_~#dst.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) cstpncpy_#in~dst.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| lambda) 0)
 (* (* |ray_cstpncpy_#t~post5.offset| lambda) 0)
 (* (* |ray_(ite (select #valid cstpncpy_#in~src.base) 1 0)| lambda) 0)
 (* (* |ray_cstpncpy_#in~dst.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid cstpncpy_~s~3.base) 1 0)| lambda) 0)
 (* (* ray_cstpncpy_~src.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* ray_cstpncpy_~d~3.offset lambda) 0)
 (* (* |ray_cstpncpy_#t~post3| lambda) 0)
 (* (* |ray_cstpncpy_~#dst.base| lambda) 0)
 (* (* ray_cstpncpy_~src.offset lambda) 0)
 (* (* |ray_cstpncpy_#in~src.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| lambda) 0)
 (* |ray_(select #length cstpncpy_~d~3.base)| 0)
 (* |ray_cstpncpy_#t~post4.offset| 0) 
 (* ray_cstpncpy_~s~3.offset 0)
 (*
 |ray_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |ray_cstpncpy_#t~mem7| 0) 
 (* ray_cstpncpy_~d~3.base 0) 
 (* |ray_cstpncpy_#t~post5.base| 0)
 (* |ray_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (* ray_cstpncpy_~s~3.base 0)
 (* |ray_(select #length cstpncpy_~s~3.base)| (- 1)) 
 (* ray_cstpncpy_~n 0) (* |ray_cstpncpy_#t~post4.base| 0)
 (* |ray_cstpncpy_#t~post5.offset| 0)
 (* |ray_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* ray_cstpncpy_~d~3.offset 0) 
 (* |ray_cstpncpy_#t~post3| 0)) 0)
 (>=
 (+ (* (* |ray_cstpncpy_#t~mem0.offset| lambda) 0)
 (* (* |ray_(select #length cstpncpy_~d~3.base)| lambda) 0)
 (* (* |ray_cstpncpy_#t~post4.offset| lambda) 0)
 (* (* ray_cstpncpy_~s~3.offset lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 lambda) 0)
 (* (* |ray_(select old(#length) cstpncpy_#in~src.base)| lambda) 0)
 (* (* |ray_cstpncpy_~#dst.offset| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 lambda) 0) (* (* |ray_cstpncpy_#t~mem7| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 lambda) 0) (* (* ray_cstpncpy_~d~3.base lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 lambda) 0) (* (* |ray_(select #length cstpncpy_#in~src.base)| lambda) 0)
 (* (* |ray_cstpncpy_#in~src.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| lambda) 0)
 (* (* |ray_cstpncpy_#t~mem1.offset| lambda) 0)
 (* (* |ray_(select #length cstpncpy_#in~dst.base)| lambda) 0)
 (* (* |ray_cstpncpy_#t~mem0.base| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_cstpncpy_#in~n| lambda) 0)
 (* (* |ray_cstpncpy_#t~mem1.base| lambda) 0)
 (* (* |ray_cstpncpy_#t~post5.base| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(select old(#length) cstpncpy_~#dst.base)| lambda) 0)
 (* (* |ray_(ite (select #valid cstpncpy_~d~3.base) 1 0)| lambda) 0)
 (* (* ray_cstpncpy_~s~3.base lambda) 0)
 (*
 (*
 |ray_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 lambda) 0) (* (* |ray_(select #length cstpncpy_~s~3.base)| lambda) 0)
 (* (* ray_cstpncpy_~n lambda) 0)
 (* (* |ray_cstpncpy_#in~dst.base| lambda) 0)
 (* (* |ray_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length cstpncpy_~#dst.base)| lambda) 0)
 (* (* |ray_cstpncpy_#t~post4.base| lambda) 0)
 (* (* |ray_(ite (select #valid cstpncpy_~#dst.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) cstpncpy_#in~dst.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| lambda) 0)
 (* (* |ray_cstpncpy_#t~post5.offset| lambda) 0)
 (* (* |ray_(ite (select #valid cstpncpy_#in~src.base) 1 0)| lambda) 0)
 (* (* |ray_cstpncpy_#in~dst.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid cstpncpy_~s~3.base) 1 0)| lambda) 0)
 (* (* ray_cstpncpy_~src.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* ray_cstpncpy_~d~3.offset lambda) 0)
 (* (* |ray_cstpncpy_#t~post3| lambda) 0)
 (* (* |ray_cstpncpy_~#dst.base| lambda) 0)
 (* (* ray_cstpncpy_~src.offset lambda) 0)
 (* (* |ray_cstpncpy_#in~src.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| lambda) 0)
 (* |ray_(select #length cstpncpy_~d~3.base)| 0)
 (* |ray_cstpncpy_#t~post4.offset| 0) 
 (* ray_cstpncpy_~s~3.offset 0)
 (*
 |ray_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 1) (* |ray_cstpncpy_#t~mem7| 0) 
 (* ray_cstpncpy_~d~3.base 0) 
 (* |ray_cstpncpy_#t~post5.base| 0)
 (* |ray_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (* ray_cstpncpy_~s~3.base 0) 
 (* |ray_(select #length cstpncpy_~s~3.base)| 0) 
 (* ray_cstpncpy_~n 0) (* |ray_cstpncpy_#t~post4.base| 0)
 (* |ray_cstpncpy_#t~post5.offset| 0)
 (* |ray_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* ray_cstpncpy_~d~3.offset 0) 
 (* |ray_cstpncpy_#t~post3| 0)) 0)
 (>=
 (+ (* (* |ray_cstpncpy_#t~mem0.offset| lambda) 0)
 (* (* |ray_(select #length cstpncpy_~d~3.base)| lambda) 0)
 (* (* |ray_cstpncpy_#t~post4.offset| lambda) 0)
 (* (* ray_cstpncpy_~s~3.offset lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 lambda) 0)
 (* (* |ray_(select old(#length) cstpncpy_#in~src.base)| lambda) 0)
 (* (* |ray_cstpncpy_~#dst.offset| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 lambda) 0) (* (* |ray_cstpncpy_#t~mem7| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 lambda) 0) (* (* ray_cstpncpy_~d~3.base lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 lambda) 0) (* (* |ray_(select #length cstpncpy_#in~src.base)| lambda) 0)
 (* (* |ray_cstpncpy_#in~src.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| lambda) 0)
 (* (* |ray_cstpncpy_#t~mem1.offset| lambda) 0)
 (* (* |ray_(select #length cstpncpy_#in~dst.base)| lambda) 0)
 (* (* |ray_cstpncpy_#t~mem0.base| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_cstpncpy_#in~n| lambda) 0)
 (* (* |ray_cstpncpy_#t~mem1.base| lambda) 0)
 (* (* |ray_cstpncpy_#t~post5.base| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(select old(#length) cstpncpy_~#dst.base)| lambda) 0)
 (* (* |ray_(ite (select #valid cstpncpy_~d~3.base) 1 0)| lambda) 0)
 (* (* ray_cstpncpy_~s~3.base lambda) 1)
 (*
 (*
 |ray_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 lambda) 0) (* (* |ray_(select #length cstpncpy_~s~3.base)| lambda) 0)
 (* (* ray_cstpncpy_~n lambda) 0)
 (* (* |ray_cstpncpy_#in~dst.base| lambda) 0)
 (* (* |ray_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length cstpncpy_~#dst.base)| lambda) 0)
 (* (* |ray_cstpncpy_#t~post4.base| lambda) 0)
 (* (* |ray_(ite (select #valid cstpncpy_~#dst.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) cstpncpy_#in~dst.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| lambda) 0)
 (* (* |ray_cstpncpy_#t~post5.offset| lambda) 0)
 (* (* |ray_(ite (select #valid cstpncpy_#in~src.base) 1 0)| lambda) 0)
 (* (* |ray_cstpncpy_#in~dst.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid cstpncpy_~s~3.base) 1 0)| lambda) 0)
 (* (* ray_cstpncpy_~src.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* ray_cstpncpy_~d~3.offset lambda) 0)
 (* (* |ray_cstpncpy_#t~post3| lambda) 0)
 (* (* |ray_cstpncpy_~#dst.base| lambda) 0)
 (* (* ray_cstpncpy_~src.offset lambda) 0)
 (* (* |ray_cstpncpy_#in~src.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| lambda) 0)
 (* |ray_(select #length cstpncpy_~d~3.base)| 0)
 (* |ray_cstpncpy_#t~post4.offset| 0) 
 (* ray_cstpncpy_~s~3.offset 0)
 (*
 |ray_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |ray_cstpncpy_#t~mem7| 0) 
 (* ray_cstpncpy_~d~3.base 0) 
 (* |ray_cstpncpy_#t~post5.base| 0)
 (* |ray_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (* ray_cstpncpy_~s~3.base (- 1))
 (* |ray_(select #length cstpncpy_~s~3.base)| 0) 
 (* ray_cstpncpy_~n 0) (* |ray_cstpncpy_#t~post4.base| 0)
 (* |ray_cstpncpy_#t~post5.offset| 0)
 (* |ray_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* ray_cstpncpy_~d~3.offset 0) 
 (* |ray_cstpncpy_#t~post3| 0)) 0)
 (>=
 (+ (* (* |ray_cstpncpy_#t~mem0.offset| lambda) 0)
 (* (* |ray_(select #length cstpncpy_~d~3.base)| lambda) 0)
 (* (* |ray_cstpncpy_#t~post4.offset| lambda) 0)
 (* (* ray_cstpncpy_~s~3.offset lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 lambda) 0)
 (* (* |ray_(select old(#length) cstpncpy_#in~src.base)| lambda) 0)
 (* (* |ray_cstpncpy_~#dst.offset| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 lambda) 0) (* (* |ray_cstpncpy_#t~mem7| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 lambda) 0) (* (* ray_cstpncpy_~d~3.base lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 lambda) 0) (* (* |ray_(select #length cstpncpy_#in~src.base)| lambda) 0)
 (* (* |ray_cstpncpy_#in~src.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| lambda) 0)
 (* (* |ray_cstpncpy_#t~mem1.offset| lambda) 0)
 (* (* |ray_(select #length cstpncpy_#in~dst.base)| lambda) 0)
 (* (* |ray_cstpncpy_#t~mem0.base| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_cstpncpy_#in~n| lambda) 0)
 (* (* |ray_cstpncpy_#t~mem1.base| lambda) 0)
 (* (* |ray_cstpncpy_#t~post5.base| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(select old(#length) cstpncpy_~#dst.base)| lambda) 0)
 (* (* |ray_(ite (select #valid cstpncpy_~d~3.base) 1 0)| lambda) 0)
 (* (* ray_cstpncpy_~s~3.base lambda) 0)
 (*
 (*
 |ray_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 lambda) 0) (* (* |ray_(select #length cstpncpy_~s~3.base)| lambda) 0)
 (* (* ray_cstpncpy_~n lambda) 0)
 (* (* |ray_cstpncpy_#in~dst.base| lambda) 0)
 (* (* |ray_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length cstpncpy_~#dst.base)| lambda) 0)
 (* (* |ray_cstpncpy_#t~post4.base| lambda) 0)
 (* (* |ray_(ite (select #valid cstpncpy_~#dst.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) cstpncpy_#in~dst.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| lambda) 0)
 (* (* |ray_cstpncpy_#t~post5.offset| lambda) 0)
 (* (* |ray_(ite (select #valid cstpncpy_#in~src.base) 1 0)| lambda) 0)
 (* (* |ray_cstpncpy_#in~dst.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid cstpncpy_~s~3.base) 1 0)| lambda) 0)
 (* (* ray_cstpncpy_~src.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* ray_cstpncpy_~d~3.offset lambda) 0)
 (* (* |ray_cstpncpy_#t~post3| lambda) 0)
 (* (* |ray_cstpncpy_~#dst.base| lambda) 0)
 (* (* ray_cstpncpy_~src.offset lambda) 0)
 (* (* |ray_cstpncpy_#in~src.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| lambda) 0)
 (* |ray_(select #length cstpncpy_~d~3.base)| 1)
 (* |ray_cstpncpy_#t~post4.offset| 0) 
 (* ray_cstpncpy_~s~3.offset 0)
 (*
 |ray_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |ray_cstpncpy_#t~mem7| 0) 
 (* ray_cstpncpy_~d~3.base 0) 
 (* |ray_cstpncpy_#t~post5.base| 0)
 (* |ray_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (* ray_cstpncpy_~s~3.base 0) 
 (* |ray_(select #length cstpncpy_~s~3.base)| 0) 
 (* ray_cstpncpy_~n 0) (* |ray_cstpncpy_#t~post4.base| 0)
 (* |ray_cstpncpy_#t~post5.offset| 0)
 (* |ray_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* ray_cstpncpy_~d~3.offset (- 1)) 
 (* |ray_cstpncpy_#t~post3| 0)) 0)
 (>=
 (+ (* (* |ray_cstpncpy_#t~mem0.offset| lambda) 0)
 (* (* |ray_(select #length cstpncpy_~d~3.base)| lambda) 0)
 (* (* |ray_cstpncpy_#t~post4.offset| lambda) 0)
 (* (* ray_cstpncpy_~s~3.offset lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 lambda) 0)
 (* (* |ray_(select old(#length) cstpncpy_#in~src.base)| lambda) 0)
 (* (* |ray_cstpncpy_~#dst.offset| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 lambda) 0) (* (* |ray_cstpncpy_#t~mem7| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 lambda) 0) (* (* ray_cstpncpy_~d~3.base lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 lambda) 0) (* (* |ray_(select #length cstpncpy_#in~src.base)| lambda) 0)
 (* (* |ray_cstpncpy_#in~src.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| lambda) 0)
 (* (* |ray_cstpncpy_#t~mem1.offset| lambda) 0)
 (* (* |ray_(select #length cstpncpy_#in~dst.base)| lambda) 0)
 (* (* |ray_cstpncpy_#t~mem0.base| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_cstpncpy_#in~n| lambda) 0)
 (* (* |ray_cstpncpy_#t~mem1.base| lambda) 0)
 (* (* |ray_cstpncpy_#t~post5.base| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(select old(#length) cstpncpy_~#dst.base)| lambda) 0)
 (* (* |ray_(ite (select #valid cstpncpy_~d~3.base) 1 0)| lambda) 0)
 (* (* ray_cstpncpy_~s~3.base lambda) 0)
 (*
 (*
 |ray_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 lambda) 0) (* (* |ray_(select #length cstpncpy_~s~3.base)| lambda) 0)
 (* (* ray_cstpncpy_~n lambda) 0)
 (* (* |ray_cstpncpy_#in~dst.base| lambda) 0)
 (* (* |ray_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length cstpncpy_~#dst.base)| lambda) 0)
 (* (* |ray_cstpncpy_#t~post4.base| lambda) 0)
 (* (* |ray_(ite (select #valid cstpncpy_~#dst.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) cstpncpy_#in~dst.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| lambda) 0)
 (* (* |ray_cstpncpy_#t~post5.offset| lambda) 0)
 (* (* |ray_(ite (select #valid cstpncpy_#in~src.base) 1 0)| lambda) 0)
 (* (* |ray_cstpncpy_#in~dst.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid cstpncpy_~s~3.base) 1 0)| lambda) 0)
 (* (* ray_cstpncpy_~src.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* ray_cstpncpy_~d~3.offset lambda) 0)
 (* (* |ray_cstpncpy_#t~post3| lambda) 0)
 (* (* |ray_cstpncpy_~#dst.base| lambda) 0)
 (* (* ray_cstpncpy_~src.offset lambda) 0)
 (* (* |ray_cstpncpy_#in~src.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| lambda) 0)
 (* |ray_(select #length cstpncpy_~d~3.base)| 0)
 (* |ray_cstpncpy_#t~post4.offset| 0) 
 (* ray_cstpncpy_~s~3.offset 0)
 (*
 |ray_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |ray_cstpncpy_#t~mem7| 0) 
 (* ray_cstpncpy_~d~3.base 0) 
 (* |ray_cstpncpy_#t~post5.base| 0)
 (* |ray_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 1)
 (* ray_cstpncpy_~s~3.base 0) 
 (* |ray_(select #length cstpncpy_~s~3.base)| 0) 
 (* ray_cstpncpy_~n 0) (* |ray_cstpncpy_#t~post4.base| 0)
 (* |ray_cstpncpy_#t~post5.offset| 0)
 (* |ray_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* ray_cstpncpy_~d~3.offset 0) 
 (* |ray_cstpncpy_#t~post3| 0)) 0)
 (>=
 (+ (* (* |ray_cstpncpy_#t~mem0.offset| lambda) 0)
 (* (* |ray_(select #length cstpncpy_~d~3.base)| lambda) 0)
 (* (* |ray_cstpncpy_#t~post4.offset| lambda) 0)
 (* (* ray_cstpncpy_~s~3.offset lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 lambda) 0)
 (* (* |ray_(select old(#length) cstpncpy_#in~src.base)| lambda) 0)
 (* (* |ray_cstpncpy_~#dst.offset| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 lambda) 0) (* (* |ray_cstpncpy_#t~mem7| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 lambda) 0) (* (* ray_cstpncpy_~d~3.base lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 lambda) 0) (* (* |ray_(select #length cstpncpy_#in~src.base)| lambda) 0)
 (* (* |ray_cstpncpy_#in~src.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| lambda) 0)
 (* (* |ray_cstpncpy_#t~mem1.offset| lambda) 0)
 (* (* |ray_(select #length cstpncpy_#in~dst.base)| lambda) 0)
 (* (* |ray_cstpncpy_#t~mem0.base| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_cstpncpy_#in~n| lambda) 0)
 (* (* |ray_cstpncpy_#t~mem1.base| lambda) 0)
 (* (* |ray_cstpncpy_#t~post5.base| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(select old(#length) cstpncpy_~#dst.base)| lambda) 0)
 (* (* |ray_(ite (select #valid cstpncpy_~d~3.base) 1 0)| lambda) 0)
 (* (* ray_cstpncpy_~s~3.base lambda) 0)
 (*
 (*
 |ray_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 lambda) 0) (* (* |ray_(select #length cstpncpy_~s~3.base)| lambda) 0)
 (* (* ray_cstpncpy_~n lambda) 0)
 (* (* |ray_cstpncpy_#in~dst.base| lambda) 0)
 (* (* |ray_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length cstpncpy_~#dst.base)| lambda) 0)
 (* (* |ray_cstpncpy_#t~post4.base| lambda) 0)
 (* (* |ray_(ite (select #valid cstpncpy_~#dst.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) cstpncpy_#in~dst.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| lambda) 0)
 (* (* |ray_cstpncpy_#t~post5.offset| lambda) 0)
 (* (* |ray_(ite (select #valid cstpncpy_#in~src.base) 1 0)| lambda) 0)
 (* (* |ray_cstpncpy_#in~dst.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid cstpncpy_~s~3.base) 1 0)| lambda) 0)
 (* (* ray_cstpncpy_~src.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* ray_cstpncpy_~d~3.offset lambda) 0)
 (* (* |ray_cstpncpy_#t~post3| lambda) 0)
 (* (* |ray_cstpncpy_~#dst.base| lambda) 0)
 (* (* ray_cstpncpy_~src.offset lambda) 0)
 (* (* |ray_cstpncpy_#in~src.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| lambda) 0)
 (* |ray_(select #length cstpncpy_~d~3.base)| 0)
 (* |ray_cstpncpy_#t~post4.offset| 0) 
 (* ray_cstpncpy_~s~3.offset 0)
 (*
 |ray_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |ray_cstpncpy_#t~mem7| 0) 
 (* ray_cstpncpy_~d~3.base 0) 
 (* |ray_cstpncpy_#t~post5.base| 0)
 (* |ray_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (* ray_cstpncpy_~s~3.base 0) 
 (* |ray_(select #length cstpncpy_~s~3.base)| 0) 
 (* ray_cstpncpy_~n 0) (* |ray_cstpncpy_#t~post4.base| 0)
 (* |ray_cstpncpy_#t~post5.offset| 0)
 (* |ray_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* ray_cstpncpy_~d~3.offset 0) 
 (* |ray_cstpncpy_#t~post3| 0) 
 (* aux_3715 (- 1)) (* aux_3710 1)) 0) 
 (= lambda lambda))
 (and
 (= |honda_cstpncpy_#t~mem0.offset|
 (+ |honda_cstpncpy_#t~mem0.offset| |ray_cstpncpy_#t~mem0.offset|))
 (=
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 (+
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 |ray_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|))
 (= |honda_(select old(#length) cstpncpy_#in~src.base)|
 (+ |honda_(select old(#length) cstpncpy_#in~src.base)|
 |ray_(select old(#length) cstpncpy_#in~src.base)|))
 (= |honda_cstpncpy_~#dst.offset|
 (+ |honda_cstpncpy_~#dst.offset| |ray_cstpncpy_~#dst.offset|))
 (=
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 (+
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 |ray_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|))
 (=
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 (+
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 |ray_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|))
 (= |honda_(select #length cstpncpy_#in~src.base)|
 (+ |honda_(select #length cstpncpy_#in~src.base)|
 |ray_(select #length cstpncpy_#in~src.base)|))
 (= |honda_cstpncpy_#in~src.offset|
 (+ |honda_cstpncpy_#in~src.offset| |ray_cstpncpy_#in~src.offset|))
 (= |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)|
 (+ |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)|
 |ray_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)|))
 (= |honda_cstpncpy_#t~mem1.offset|
 (+ |honda_cstpncpy_#t~mem1.offset| |ray_cstpncpy_#t~mem1.offset|))
 (= |honda_(select #length cstpncpy_#in~dst.base)|
 (+ |honda_(select #length cstpncpy_#in~dst.base)|
 |ray_(select #length cstpncpy_#in~dst.base)|))
 (= |honda_cstpncpy_#t~mem0.base|
 (+ |honda_cstpncpy_#t~mem0.base| |ray_cstpncpy_#t~mem0.base|))
 (=
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 (+
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 |ray_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|))
 (= |honda_#NULL.offset| (+ |honda_#NULL.offset| |ray_#NULL.offset|))
 (= |honda_cstpncpy_#in~n| (+ |honda_cstpncpy_#in~n| |ray_cstpncpy_#in~n|))
 (= |honda_cstpncpy_#t~mem1.base|
 (+ |honda_cstpncpy_#t~mem1.base| |ray_cstpncpy_#t~mem1.base|))
 (= |honda_#NULL.base| (+ |honda_#NULL.base| |ray_#NULL.base|))
 (= |honda_(select old(#length) cstpncpy_~#dst.base)|
 (+ |honda_(select old(#length) cstpncpy_~#dst.base)|
 |ray_(select old(#length) cstpncpy_~#dst.base)|))
 (=
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 (+
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 |ray_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|))
 (= |honda_cstpncpy_#in~dst.base|
 (+ |honda_cstpncpy_#in~dst.base| |ray_cstpncpy_#in~dst.base|))
 (= |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)|
 (+ |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)|
 |ray_(ite (select #valid cstpncpy_#in~dst.base) 1 0)|))
 (= |honda_(select #length cstpncpy_~#dst.base)|
 (+ |honda_(select #length cstpncpy_~#dst.base)|
 |ray_(select #length cstpncpy_~#dst.base)|))
 (= |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)|
 (+ |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)|
 |ray_(ite (select #valid cstpncpy_~#dst.base) 1 0)|))
 (= |honda_(select old(#length) cstpncpy_#in~dst.base)|
 (+ |honda_(select old(#length) cstpncpy_#in~dst.base)|
 |ray_(select old(#length) cstpncpy_#in~dst.base)|))
 (= |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)|
 (+ |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)|
 |ray_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)|))
 (= |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)|
 (+ |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)|
 |ray_(ite (select #valid cstpncpy_#in~src.base) 1 0)|))
 (= |honda_cstpncpy_#in~dst.offset|
 (+ |honda_cstpncpy_#in~dst.offset| |ray_cstpncpy_#in~dst.offset|))
 (= |honda_(ite (select #valid 0) 1 0)|
 (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|))
 (= honda_cstpncpy_~src.base
 (+ honda_cstpncpy_~src.base ray_cstpncpy_~src.base))
 (= |honda_(ite (select old(#valid) 0) 1 0)|
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|))
 (= |honda_cstpncpy_~#dst.base|
 (+ |honda_cstpncpy_~#dst.base| |ray_cstpncpy_~#dst.base|))
 (= honda_cstpncpy_~src.offset
 (+ honda_cstpncpy_~src.offset ray_cstpncpy_~src.offset))
 (= |honda_cstpncpy_#in~src.base|
 (+ |honda_cstpncpy_#in~src.base| |ray_cstpncpy_#in~src.base|))
 (=
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 (+
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 |ray_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|))
 (= |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)|
 (+ |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)|
 |ray_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)|))
 (>=
 (+ (* (+ |honda_cstpncpy_#t~mem0.offset| |ray_cstpncpy_#t~mem0.offset|) 0)
 (*
 (+ |honda_(select #length cstpncpy_~d~3.base)|
 |ray_(select #length cstpncpy_~d~3.base)|) 0)
 (* (+ |honda_cstpncpy_#t~post4.offset| |ray_cstpncpy_#t~post4.offset|) 0)
 (* (+ honda_cstpncpy_~s~3.offset ray_cstpncpy_~s~3.offset) 0)
 (*
 (+
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 |ray_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|)
 0)
 (*
 (+ |honda_(select old(#length) cstpncpy_#in~src.base)|
 |ray_(select old(#length) cstpncpy_#in~src.base)|) 0)
 (* (+ |honda_cstpncpy_~#dst.offset| |ray_cstpncpy_~#dst.offset|) 0)
 (*
 (+
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 |ray_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|)
 0) (* (+ |honda_cstpncpy_#t~mem7| |ray_cstpncpy_#t~mem7|) 0)
 (*
 (+
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 |ray_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|)
 0) (* (+ honda_cstpncpy_~d~3.base ray_cstpncpy_~d~3.base) 0)
 (*
 (+
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 |ray_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|)
 0)
 (*
 (+ |honda_(select #length cstpncpy_#in~src.base)|
 |ray_(select #length cstpncpy_#in~src.base)|) 0)
 (* (+ |honda_cstpncpy_#in~src.offset| |ray_cstpncpy_#in~src.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)|
 |ray_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)|) 0)
 (* (+ |honda_cstpncpy_#t~mem1.offset| |ray_cstpncpy_#t~mem1.offset|) 0)
 (*
 (+ |honda_(select #length cstpncpy_#in~dst.base)|
 |ray_(select #length cstpncpy_#in~dst.base)|) 0)
 (* (+ |honda_cstpncpy_#t~mem0.base| |ray_cstpncpy_#t~mem0.base|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 |ray_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|)
 0) (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_cstpncpy_#in~n| |ray_cstpncpy_#in~n|) 0)
 (* (+ |honda_cstpncpy_#t~mem1.base| |ray_cstpncpy_#t~mem1.base|) 0)
 (* (+ |honda_cstpncpy_#t~post5.base| |ray_cstpncpy_#t~post5.base|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(select old(#length) cstpncpy_~#dst.base)|
 |ray_(select old(#length) cstpncpy_~#dst.base)|) 0)
 (*
 (+ |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)|
 |ray_(ite (select #valid cstpncpy_~d~3.base) 1 0)|) 0)
 (* (+ honda_cstpncpy_~s~3.base ray_cstpncpy_~s~3.base) 0)
 (*
 (+
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 |ray_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|)
 0)
 (*
 (+ |honda_(select #length cstpncpy_~s~3.base)|
 |ray_(select #length cstpncpy_~s~3.base)|) 
 (- 1)) (* (+ honda_cstpncpy_~n ray_cstpncpy_~n) 0)
 (* (+ |honda_cstpncpy_#in~dst.base| |ray_cstpncpy_#in~dst.base|) 0)
 (*
 (+ |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)|
 |ray_(ite (select #valid cstpncpy_#in~dst.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length cstpncpy_~#dst.base)|
 |ray_(select #length cstpncpy_~#dst.base)|) 0)
 (* (+ |honda_cstpncpy_#t~post4.base| |ray_cstpncpy_#t~post4.base|) 0)
 (*
 (+ |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)|
 |ray_(ite (select #valid cstpncpy_~#dst.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) cstpncpy_#in~dst.base)|
 |ray_(select old(#length) cstpncpy_#in~dst.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)|
 |ray_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)|) 0)
 (* (+ |honda_cstpncpy_#t~post5.offset| |ray_cstpncpy_#t~post5.offset|) 0)
 (*
 (+ |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)|
 |ray_(ite (select #valid cstpncpy_#in~src.base) 1 0)|) 0)
 (* (+ |honda_cstpncpy_#in~dst.offset| |ray_cstpncpy_#in~dst.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)|
 |ray_(ite (select #valid cstpncpy_~s~3.base) 1 0)|) 0)
 (* (+ honda_cstpncpy_~src.base ray_cstpncpy_~src.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ honda_cstpncpy_~d~3.offset ray_cstpncpy_~d~3.offset) 0)
 (* (+ |honda_cstpncpy_#t~post3| |ray_cstpncpy_#t~post3|) 0)
 (* (+ |honda_cstpncpy_~#dst.base| |ray_cstpncpy_~#dst.base|) 0)
 (* (+ honda_cstpncpy_~src.offset ray_cstpncpy_~src.offset) 0)
 (* (+ |honda_cstpncpy_#in~src.base| |ray_cstpncpy_#in~src.base|) 0)
 (*
 (+
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 |ray_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)|
 |ray_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)|) 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0) 
 (* honda_cstpncpy_~d~3.base 0) 
 (* |honda_cstpncpy_#t~post5.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(select #length cstpncpy_~s~3.base)| 1) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 0) 0)
 (>=
 (+ (* (+ |honda_cstpncpy_#t~mem0.offset| |ray_cstpncpy_#t~mem0.offset|) 0)
 (*
 (+ |honda_(select #length cstpncpy_~d~3.base)|
 |ray_(select #length cstpncpy_~d~3.base)|) 0)
 (* (+ |honda_cstpncpy_#t~post4.offset| |ray_cstpncpy_#t~post4.offset|) 0)
 (* (+ honda_cstpncpy_~s~3.offset ray_cstpncpy_~s~3.offset) 0)
 (*
 (+
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 |ray_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|)
 0)
 (*
 (+ |honda_(select old(#length) cstpncpy_#in~src.base)|
 |ray_(select old(#length) cstpncpy_#in~src.base)|) 0)
 (* (+ |honda_cstpncpy_~#dst.offset| |ray_cstpncpy_~#dst.offset|) 0)
 (*
 (+
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 |ray_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|)
 0) (* (+ |honda_cstpncpy_#t~mem7| |ray_cstpncpy_#t~mem7|) 0)
 (*
 (+
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 |ray_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|)
 0) (* (+ honda_cstpncpy_~d~3.base ray_cstpncpy_~d~3.base) (- 1))
 (*
 (+
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 |ray_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|)
 0)
 (*
 (+ |honda_(select #length cstpncpy_#in~src.base)|
 |ray_(select #length cstpncpy_#in~src.base)|) 0)
 (* (+ |honda_cstpncpy_#in~src.offset| |ray_cstpncpy_#in~src.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)|
 |ray_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)|) 0)
 (* (+ |honda_cstpncpy_#t~mem1.offset| |ray_cstpncpy_#t~mem1.offset|) 0)
 (*
 (+ |honda_(select #length cstpncpy_#in~dst.base)|
 |ray_(select #length cstpncpy_#in~dst.base)|) 0)
 (* (+ |honda_cstpncpy_#t~mem0.base| |ray_cstpncpy_#t~mem0.base|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 |ray_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|)
 0) (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_cstpncpy_#in~n| |ray_cstpncpy_#in~n|) 0)
 (* (+ |honda_cstpncpy_#t~mem1.base| |ray_cstpncpy_#t~mem1.base|) 0)
 (* (+ |honda_cstpncpy_#t~post5.base| |ray_cstpncpy_#t~post5.base|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(select old(#length) cstpncpy_~#dst.base)|
 |ray_(select old(#length) cstpncpy_~#dst.base)|) 0)
 (*
 (+ |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)|
 |ray_(ite (select #valid cstpncpy_~d~3.base) 1 0)|) 0)
 (* (+ honda_cstpncpy_~s~3.base ray_cstpncpy_~s~3.base) 0)
 (*
 (+
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 |ray_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|)
 0)
 (*
 (+ |honda_(select #length cstpncpy_~s~3.base)|
 |ray_(select #length cstpncpy_~s~3.base)|) 0)
 (* (+ honda_cstpncpy_~n ray_cstpncpy_~n) 0)
 (* (+ |honda_cstpncpy_#in~dst.base| |ray_cstpncpy_#in~dst.base|) 0)
 (*
 (+ |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)|
 |ray_(ite (select #valid cstpncpy_#in~dst.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length cstpncpy_~#dst.base)|
 |ray_(select #length cstpncpy_~#dst.base)|) 0)
 (* (+ |honda_cstpncpy_#t~post4.base| |ray_cstpncpy_#t~post4.base|) 0)
 (*
 (+ |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)|
 |ray_(ite (select #valid cstpncpy_~#dst.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) cstpncpy_#in~dst.base)|
 |ray_(select old(#length) cstpncpy_#in~dst.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)|
 |ray_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)|) 0)
 (* (+ |honda_cstpncpy_#t~post5.offset| |ray_cstpncpy_#t~post5.offset|) 0)
 (*
 (+ |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)|
 |ray_(ite (select #valid cstpncpy_#in~src.base) 1 0)|) 0)
 (* (+ |honda_cstpncpy_#in~dst.offset| |ray_cstpncpy_#in~dst.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)|
 |ray_(ite (select #valid cstpncpy_~s~3.base) 1 0)|) 0)
 (* (+ honda_cstpncpy_~src.base ray_cstpncpy_~src.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ honda_cstpncpy_~d~3.offset ray_cstpncpy_~d~3.offset) 0)
 (* (+ |honda_cstpncpy_#t~post3| |ray_cstpncpy_#t~post3|) 0)
 (* (+ |honda_cstpncpy_~#dst.base| |ray_cstpncpy_~#dst.base|) 0)
 (* (+ honda_cstpncpy_~src.offset ray_cstpncpy_~src.offset) 0)
 (* (+ |honda_cstpncpy_#in~src.base| |ray_cstpncpy_#in~src.base|) 0)
 (*
 (+
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 |ray_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)|
 |ray_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)|) 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0) 
 (* honda_cstpncpy_~d~3.base 1) 
 (* |honda_cstpncpy_#t~post5.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 0) 0)
 (>=
 (+ (* (+ |honda_cstpncpy_#t~mem0.offset| |ray_cstpncpy_#t~mem0.offset|) 0)
 (*
 (+ |honda_(select #length cstpncpy_~d~3.base)|
 |ray_(select #length cstpncpy_~d~3.base)|) 0)
 (* (+ |honda_cstpncpy_#t~post4.offset| |ray_cstpncpy_#t~post4.offset|) 0)
 (* (+ honda_cstpncpy_~s~3.offset ray_cstpncpy_~s~3.offset) 0)
 (*
 (+
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 |ray_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|)
 0)
 (*
 (+ |honda_(select old(#length) cstpncpy_#in~src.base)|
 |ray_(select old(#length) cstpncpy_#in~src.base)|) 0)
 (* (+ |honda_cstpncpy_~#dst.offset| |ray_cstpncpy_~#dst.offset|) 0)
 (*
 (+
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 |ray_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|)
 0) (* (+ |honda_cstpncpy_#t~mem7| |ray_cstpncpy_#t~mem7|) 0)
 (*
 (+
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 |ray_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|)
 0) (* (+ honda_cstpncpy_~d~3.base ray_cstpncpy_~d~3.base) 0)
 (*
 (+
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 |ray_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|)
 0)
 (*
 (+ |honda_(select #length cstpncpy_#in~src.base)|
 |ray_(select #length cstpncpy_#in~src.base)|) 0)
 (* (+ |honda_cstpncpy_#in~src.offset| |ray_cstpncpy_#in~src.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)|
 |ray_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)|) 0)
 (* (+ |honda_cstpncpy_#t~mem1.offset| |ray_cstpncpy_#t~mem1.offset|) 0)
 (*
 (+ |honda_(select #length cstpncpy_#in~dst.base)|
 |ray_(select #length cstpncpy_#in~dst.base)|) 0)
 (* (+ |honda_cstpncpy_#t~mem0.base| |ray_cstpncpy_#t~mem0.base|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 |ray_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|)
 0) (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_cstpncpy_#in~n| |ray_cstpncpy_#in~n|) 0)
 (* (+ |honda_cstpncpy_#t~mem1.base| |ray_cstpncpy_#t~mem1.base|) 0)
 (* (+ |honda_cstpncpy_#t~post5.base| |ray_cstpncpy_#t~post5.base|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(select old(#length) cstpncpy_~#dst.base)|
 |ray_(select old(#length) cstpncpy_~#dst.base)|) 0)
 (*
 (+ |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)|
 |ray_(ite (select #valid cstpncpy_~d~3.base) 1 0)|) 0)
 (* (+ honda_cstpncpy_~s~3.base ray_cstpncpy_~s~3.base) 0)
 (*
 (+
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 |ray_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|)
 0)
 (*
 (+ |honda_(select #length cstpncpy_~s~3.base)|
 |ray_(select #length cstpncpy_~s~3.base)|) 0)
 (* (+ honda_cstpncpy_~n ray_cstpncpy_~n) 0)
 (* (+ |honda_cstpncpy_#in~dst.base| |ray_cstpncpy_#in~dst.base|) 0)
 (*
 (+ |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)|
 |ray_(ite (select #valid cstpncpy_#in~dst.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length cstpncpy_~#dst.base)|
 |ray_(select #length cstpncpy_~#dst.base)|) 0)
 (* (+ |honda_cstpncpy_#t~post4.base| |ray_cstpncpy_#t~post4.base|) 0)
 (*
 (+ |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)|
 |ray_(ite (select #valid cstpncpy_~#dst.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) cstpncpy_#in~dst.base)|
 |ray_(select old(#length) cstpncpy_#in~dst.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)|
 |ray_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)|) 0)
 (* (+ |honda_cstpncpy_#t~post5.offset| |ray_cstpncpy_#t~post5.offset|) 0)
 (*
 (+ |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)|
 |ray_(ite (select #valid cstpncpy_#in~src.base) 1 0)|) 0)
 (* (+ |honda_cstpncpy_#in~dst.offset| |ray_cstpncpy_#in~dst.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)|
 |ray_(ite (select #valid cstpncpy_~s~3.base) 1 0)|) 0)
 (* (+ honda_cstpncpy_~src.base ray_cstpncpy_~src.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ honda_cstpncpy_~d~3.offset ray_cstpncpy_~d~3.offset) (- 1))
 (* (+ |honda_cstpncpy_#t~post3| |ray_cstpncpy_#t~post3|) 0)
 (* (+ |honda_cstpncpy_~#dst.base| |ray_cstpncpy_~#dst.base|) 0)
 (* (+ honda_cstpncpy_~src.offset ray_cstpncpy_~src.offset) 0)
 (* (+ |honda_cstpncpy_#in~src.base| |ray_cstpncpy_#in~src.base|) 0)
 (*
 (+
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 |ray_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)|
 |ray_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)|) 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0) 
 (* honda_cstpncpy_~d~3.base 0) 
 (* |honda_cstpncpy_#t~post5.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 1) 
 (* |honda_cstpncpy_#t~post3| 0) 1) 0)
 (>=
 (+ (* (+ |honda_cstpncpy_#t~mem0.offset| |ray_cstpncpy_#t~mem0.offset|) 0)
 (*
 (+ |honda_(select #length cstpncpy_~d~3.base)|
 |ray_(select #length cstpncpy_~d~3.base)|) 0)
 (* (+ |honda_cstpncpy_#t~post4.offset| |ray_cstpncpy_#t~post4.offset|) 0)
 (* (+ honda_cstpncpy_~s~3.offset ray_cstpncpy_~s~3.offset) 0)
 (*
 (+
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 |ray_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|)
 0)
 (*
 (+ |honda_(select old(#length) cstpncpy_#in~src.base)|
 |ray_(select old(#length) cstpncpy_#in~src.base)|) 0)
 (* (+ |honda_cstpncpy_~#dst.offset| |ray_cstpncpy_~#dst.offset|) 0)
 (*
 (+
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 |ray_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|)
 0) (* (+ |honda_cstpncpy_#t~mem7| |ray_cstpncpy_#t~mem7|) 0)
 (*
 (+
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 |ray_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|)
 0) (* (+ honda_cstpncpy_~d~3.base ray_cstpncpy_~d~3.base) 0)
 (*
 (+
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 |ray_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|)
 0)
 (*
 (+ |honda_(select #length cstpncpy_#in~src.base)|
 |ray_(select #length cstpncpy_#in~src.base)|) 0)
 (* (+ |honda_cstpncpy_#in~src.offset| |ray_cstpncpy_#in~src.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)|
 |ray_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)|) 0)
 (* (+ |honda_cstpncpy_#t~mem1.offset| |ray_cstpncpy_#t~mem1.offset|) 0)
 (*
 (+ |honda_(select #length cstpncpy_#in~dst.base)|
 |ray_(select #length cstpncpy_#in~dst.base)|) 0)
 (* (+ |honda_cstpncpy_#t~mem0.base| |ray_cstpncpy_#t~mem0.base|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 |ray_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|)
 0) (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_cstpncpy_#in~n| |ray_cstpncpy_#in~n|) 0)
 (* (+ |honda_cstpncpy_#t~mem1.base| |ray_cstpncpy_#t~mem1.base|) 0)
 (* (+ |honda_cstpncpy_#t~post5.base| |ray_cstpncpy_#t~post5.base|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(select old(#length) cstpncpy_~#dst.base)|
 |ray_(select old(#length) cstpncpy_~#dst.base)|) 0)
 (*
 (+ |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)|
 |ray_(ite (select #valid cstpncpy_~d~3.base) 1 0)|) 0)
 (* (+ honda_cstpncpy_~s~3.base ray_cstpncpy_~s~3.base) (- 1))
 (*
 (+
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 |ray_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|)
 0)
 (*
 (+ |honda_(select #length cstpncpy_~s~3.base)|
 |ray_(select #length cstpncpy_~s~3.base)|) 0)
 (* (+ honda_cstpncpy_~n ray_cstpncpy_~n) 0)
 (* (+ |honda_cstpncpy_#in~dst.base| |ray_cstpncpy_#in~dst.base|) 0)
 (*
 (+ |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)|
 |ray_(ite (select #valid cstpncpy_#in~dst.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length cstpncpy_~#dst.base)|
 |ray_(select #length cstpncpy_~#dst.base)|) 0)
 (* (+ |honda_cstpncpy_#t~post4.base| |ray_cstpncpy_#t~post4.base|) 0)
 (*
 (+ |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)|
 |ray_(ite (select #valid cstpncpy_~#dst.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) cstpncpy_#in~dst.base)|
 |ray_(select old(#length) cstpncpy_#in~dst.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)|
 |ray_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)|) 0)
 (* (+ |honda_cstpncpy_#t~post5.offset| |ray_cstpncpy_#t~post5.offset|) 0)
 (*
 (+ |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)|
 |ray_(ite (select #valid cstpncpy_#in~src.base) 1 0)|) 0)
 (* (+ |honda_cstpncpy_#in~dst.offset| |ray_cstpncpy_#in~dst.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)|
 |ray_(ite (select #valid cstpncpy_~s~3.base) 1 0)|) 0)
 (* (+ honda_cstpncpy_~src.base ray_cstpncpy_~src.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ honda_cstpncpy_~d~3.offset ray_cstpncpy_~d~3.offset) 0)
 (* (+ |honda_cstpncpy_#t~post3| |ray_cstpncpy_#t~post3|) 0)
 (* (+ |honda_cstpncpy_~#dst.base| |ray_cstpncpy_~#dst.base|) 0)
 (* (+ honda_cstpncpy_~src.offset ray_cstpncpy_~src.offset) 0)
 (* (+ |honda_cstpncpy_#in~src.base| |ray_cstpncpy_#in~src.base|) 0)
 (*
 (+
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 |ray_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)|
 |ray_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)|) 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0) 
 (* honda_cstpncpy_~d~3.base 1) 
 (* |honda_cstpncpy_#t~post5.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (- 1)) 0)
 (>=
 (+ (* (+ |honda_cstpncpy_#t~mem0.offset| |ray_cstpncpy_#t~mem0.offset|) 0)
 (*
 (+ |honda_(select #length cstpncpy_~d~3.base)|
 |ray_(select #length cstpncpy_~d~3.base)|) 0)
 (* (+ |honda_cstpncpy_#t~post4.offset| |ray_cstpncpy_#t~post4.offset|) 0)
 (* (+ honda_cstpncpy_~s~3.offset ray_cstpncpy_~s~3.offset) 0)
 (*
 (+
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 |ray_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|)
 0)
 (*
 (+ |honda_(select old(#length) cstpncpy_#in~src.base)|
 |ray_(select old(#length) cstpncpy_#in~src.base)|) 0)
 (* (+ |honda_cstpncpy_~#dst.offset| |ray_cstpncpy_~#dst.offset|) 0)
 (*
 (+
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 |ray_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|)
 0) (* (+ |honda_cstpncpy_#t~mem7| |ray_cstpncpy_#t~mem7|) 0)
 (*
 (+
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 |ray_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|)
 0) (* (+ honda_cstpncpy_~d~3.base ray_cstpncpy_~d~3.base) 0)
 (*
 (+
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 |ray_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|)
 0)
 (*
 (+ |honda_(select #length cstpncpy_#in~src.base)|
 |ray_(select #length cstpncpy_#in~src.base)|) 0)
 (* (+ |honda_cstpncpy_#in~src.offset| |ray_cstpncpy_#in~src.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)|
 |ray_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)|) 0)
 (* (+ |honda_cstpncpy_#t~mem1.offset| |ray_cstpncpy_#t~mem1.offset|) 0)
 (*
 (+ |honda_(select #length cstpncpy_#in~dst.base)|
 |ray_(select #length cstpncpy_#in~dst.base)|) 0)
 (* (+ |honda_cstpncpy_#t~mem0.base| |ray_cstpncpy_#t~mem0.base|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 |ray_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|)
 0) (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_cstpncpy_#in~n| |ray_cstpncpy_#in~n|) 0)
 (* (+ |honda_cstpncpy_#t~mem1.base| |ray_cstpncpy_#t~mem1.base|) 0)
 (* (+ |honda_cstpncpy_#t~post5.base| |ray_cstpncpy_#t~post5.base|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(select old(#length) cstpncpy_~#dst.base)|
 |ray_(select old(#length) cstpncpy_~#dst.base)|) 0)
 (*
 (+ |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)|
 |ray_(ite (select #valid cstpncpy_~d~3.base) 1 0)|) 1)
 (* (+ honda_cstpncpy_~s~3.base ray_cstpncpy_~s~3.base) 0)
 (*
 (+
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 |ray_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|)
 0)
 (*
 (+ |honda_(select #length cstpncpy_~s~3.base)|
 |ray_(select #length cstpncpy_~s~3.base)|) 0)
 (* (+ honda_cstpncpy_~n ray_cstpncpy_~n) 0)
 (* (+ |honda_cstpncpy_#in~dst.base| |ray_cstpncpy_#in~dst.base|) 0)
 (*
 (+ |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)|
 |ray_(ite (select #valid cstpncpy_#in~dst.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length cstpncpy_~#dst.base)|
 |ray_(select #length cstpncpy_~#dst.base)|) 0)
 (* (+ |honda_cstpncpy_#t~post4.base| |ray_cstpncpy_#t~post4.base|) 0)
 (*
 (+ |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)|
 |ray_(ite (select #valid cstpncpy_~#dst.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) cstpncpy_#in~dst.base)|
 |ray_(select old(#length) cstpncpy_#in~dst.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)|
 |ray_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)|) 0)
 (* (+ |honda_cstpncpy_#t~post5.offset| |ray_cstpncpy_#t~post5.offset|) 0)
 (*
 (+ |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)|
 |ray_(ite (select #valid cstpncpy_#in~src.base) 1 0)|) 0)
 (* (+ |honda_cstpncpy_#in~dst.offset| |ray_cstpncpy_#in~dst.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)|
 |ray_(ite (select #valid cstpncpy_~s~3.base) 1 0)|) 0)
 (* (+ honda_cstpncpy_~src.base ray_cstpncpy_~src.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ honda_cstpncpy_~d~3.offset ray_cstpncpy_~d~3.offset) 0)
 (* (+ |honda_cstpncpy_#t~post3| |ray_cstpncpy_#t~post3|) 0)
 (* (+ |honda_cstpncpy_~#dst.base| |ray_cstpncpy_~#dst.base|) 0)
 (* (+ honda_cstpncpy_~src.offset ray_cstpncpy_~src.offset) 0)
 (* (+ |honda_cstpncpy_#in~src.base| |ray_cstpncpy_#in~src.base|) 0)
 (*
 (+
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 |ray_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)|
 |ray_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)|) 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0) 
 (* honda_cstpncpy_~d~3.base 0) 
 (* |honda_cstpncpy_#t~post5.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (- 1)) 0)
 (>=
 (+ (* (+ |honda_cstpncpy_#t~mem0.offset| |ray_cstpncpy_#t~mem0.offset|) 0)
 (*
 (+ |honda_(select #length cstpncpy_~d~3.base)|
 |ray_(select #length cstpncpy_~d~3.base)|) 
 (- 1))
 (* (+ |honda_cstpncpy_#t~post4.offset| |ray_cstpncpy_#t~post4.offset|) 0)
 (* (+ honda_cstpncpy_~s~3.offset ray_cstpncpy_~s~3.offset) 0)
 (*
 (+
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 |ray_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|)
 0)
 (*
 (+ |honda_(select old(#length) cstpncpy_#in~src.base)|
 |ray_(select old(#length) cstpncpy_#in~src.base)|) 0)
 (* (+ |honda_cstpncpy_~#dst.offset| |ray_cstpncpy_~#dst.offset|) 0)
 (*
 (+
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 |ray_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|)
 0) (* (+ |honda_cstpncpy_#t~mem7| |ray_cstpncpy_#t~mem7|) 0)
 (*
 (+
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 |ray_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|)
 0) (* (+ honda_cstpncpy_~d~3.base ray_cstpncpy_~d~3.base) 0)
 (*
 (+
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 |ray_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|)
 0)
 (*
 (+ |honda_(select #length cstpncpy_#in~src.base)|
 |ray_(select #length cstpncpy_#in~src.base)|) 0)
 (* (+ |honda_cstpncpy_#in~src.offset| |ray_cstpncpy_#in~src.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)|
 |ray_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)|) 0)
 (* (+ |honda_cstpncpy_#t~mem1.offset| |ray_cstpncpy_#t~mem1.offset|) 0)
 (*
 (+ |honda_(select #length cstpncpy_#in~dst.base)|
 |ray_(select #length cstpncpy_#in~dst.base)|) 0)
 (* (+ |honda_cstpncpy_#t~mem0.base| |ray_cstpncpy_#t~mem0.base|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 |ray_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|)
 0) (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_cstpncpy_#in~n| |ray_cstpncpy_#in~n|) 0)
 (* (+ |honda_cstpncpy_#t~mem1.base| |ray_cstpncpy_#t~mem1.base|) 0)
 (* (+ |honda_cstpncpy_#t~post5.base| |ray_cstpncpy_#t~post5.base|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(select old(#length) cstpncpy_~#dst.base)|
 |ray_(select old(#length) cstpncpy_~#dst.base)|) 0)
 (*
 (+ |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)|
 |ray_(ite (select #valid cstpncpy_~d~3.base) 1 0)|) 0)
 (* (+ honda_cstpncpy_~s~3.base ray_cstpncpy_~s~3.base) 0)
 (*
 (+
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 |ray_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|)
 0)
 (*
 (+ |honda_(select #length cstpncpy_~s~3.base)|
 |ray_(select #length cstpncpy_~s~3.base)|) 0)
 (* (+ honda_cstpncpy_~n ray_cstpncpy_~n) 0)
 (* (+ |honda_cstpncpy_#in~dst.base| |ray_cstpncpy_#in~dst.base|) 0)
 (*
 (+ |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)|
 |ray_(ite (select #valid cstpncpy_#in~dst.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length cstpncpy_~#dst.base)|
 |ray_(select #length cstpncpy_~#dst.base)|) 0)
 (* (+ |honda_cstpncpy_#t~post4.base| |ray_cstpncpy_#t~post4.base|) 0)
 (*
 (+ |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)|
 |ray_(ite (select #valid cstpncpy_~#dst.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) cstpncpy_#in~dst.base)|
 |ray_(select old(#length) cstpncpy_#in~dst.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)|
 |ray_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)|) 0)
 (* (+ |honda_cstpncpy_#t~post5.offset| |ray_cstpncpy_#t~post5.offset|) 0)
 (*
 (+ |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)|
 |ray_(ite (select #valid cstpncpy_#in~src.base) 1 0)|) 0)
 (* (+ |honda_cstpncpy_#in~dst.offset| |ray_cstpncpy_#in~dst.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)|
 |ray_(ite (select #valid cstpncpy_~s~3.base) 1 0)|) 0)
 (* (+ honda_cstpncpy_~src.base ray_cstpncpy_~src.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ honda_cstpncpy_~d~3.offset ray_cstpncpy_~d~3.offset) 0)
 (* (+ |honda_cstpncpy_#t~post3| |ray_cstpncpy_#t~post3|) 0)
 (* (+ |honda_cstpncpy_~#dst.base| |ray_cstpncpy_~#dst.base|) 0)
 (* (+ honda_cstpncpy_~src.offset ray_cstpncpy_~src.offset) 0)
 (* (+ |honda_cstpncpy_#in~src.base| |ray_cstpncpy_#in~src.base|) 0)
 (*
 (+
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 |ray_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)|
 |ray_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)|) 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 1)
 (* |honda_cstpncpy_#t~post4.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0) 
 (* honda_cstpncpy_~d~3.base 0) 
 (* |honda_cstpncpy_#t~post5.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 0) 0)
 (>=
 (+ (* (+ |honda_cstpncpy_#t~mem0.offset| |ray_cstpncpy_#t~mem0.offset|) 0)
 (*
 (+ |honda_(select #length cstpncpy_~d~3.base)|
 |ray_(select #length cstpncpy_~d~3.base)|) 0)
 (* (+ |honda_cstpncpy_#t~post4.offset| |ray_cstpncpy_#t~post4.offset|) 0)
 (* (+ honda_cstpncpy_~s~3.offset ray_cstpncpy_~s~3.offset) 0)
 (*
 (+
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 |ray_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|)
 0)
 (*
 (+ |honda_(select old(#length) cstpncpy_#in~src.base)|
 |ray_(select old(#length) cstpncpy_#in~src.base)|) 0)
 (* (+ |honda_cstpncpy_~#dst.offset| |ray_cstpncpy_~#dst.offset|) 0)
 (*
 (+
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 |ray_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|)
 0) (* (+ |honda_cstpncpy_#t~mem7| |ray_cstpncpy_#t~mem7|) 0)
 (*
 (+
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 |ray_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|)
 0) (* (+ honda_cstpncpy_~d~3.base ray_cstpncpy_~d~3.base) 1)
 (*
 (+
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 |ray_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|)
 0)
 (*
 (+ |honda_(select #length cstpncpy_#in~src.base)|
 |ray_(select #length cstpncpy_#in~src.base)|) 0)
 (* (+ |honda_cstpncpy_#in~src.offset| |ray_cstpncpy_#in~src.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)|
 |ray_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)|) 0)
 (* (+ |honda_cstpncpy_#t~mem1.offset| |ray_cstpncpy_#t~mem1.offset|) 0)
 (*
 (+ |honda_(select #length cstpncpy_#in~dst.base)|
 |ray_(select #length cstpncpy_#in~dst.base)|) 0)
 (* (+ |honda_cstpncpy_#t~mem0.base| |ray_cstpncpy_#t~mem0.base|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 |ray_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|)
 0) (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_cstpncpy_#in~n| |ray_cstpncpy_#in~n|) 0)
 (* (+ |honda_cstpncpy_#t~mem1.base| |ray_cstpncpy_#t~mem1.base|) 0)
 (* (+ |honda_cstpncpy_#t~post5.base| |ray_cstpncpy_#t~post5.base|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(select old(#length) cstpncpy_~#dst.base)|
 |ray_(select old(#length) cstpncpy_~#dst.base)|) 0)
 (*
 (+ |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)|
 |ray_(ite (select #valid cstpncpy_~d~3.base) 1 0)|) 0)
 (* (+ honda_cstpncpy_~s~3.base ray_cstpncpy_~s~3.base) 0)
 (*
 (+
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 |ray_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|)
 0)
 (*
 (+ |honda_(select #length cstpncpy_~s~3.base)|
 |ray_(select #length cstpncpy_~s~3.base)|) 0)
 (* (+ honda_cstpncpy_~n ray_cstpncpy_~n) 0)
 (* (+ |honda_cstpncpy_#in~dst.base| |ray_cstpncpy_#in~dst.base|) 0)
 (*
 (+ |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)|
 |ray_(ite (select #valid cstpncpy_#in~dst.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length cstpncpy_~#dst.base)|
 |ray_(select #length cstpncpy_~#dst.base)|) 0)
 (* (+ |honda_cstpncpy_#t~post4.base| |ray_cstpncpy_#t~post4.base|) 0)
 (*
 (+ |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)|
 |ray_(ite (select #valid cstpncpy_~#dst.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) cstpncpy_#in~dst.base)|
 |ray_(select old(#length) cstpncpy_#in~dst.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)|
 |ray_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)|) 0)
 (* (+ |honda_cstpncpy_#t~post5.offset| |ray_cstpncpy_#t~post5.offset|) 0)
 (*
 (+ |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)|
 |ray_(ite (select #valid cstpncpy_#in~src.base) 1 0)|) 0)
 (* (+ |honda_cstpncpy_#in~dst.offset| |ray_cstpncpy_#in~dst.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)|
 |ray_(ite (select #valid cstpncpy_~s~3.base) 1 0)|) 0)
 (* (+ honda_cstpncpy_~src.base ray_cstpncpy_~src.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ honda_cstpncpy_~d~3.offset ray_cstpncpy_~d~3.offset) 0)
 (* (+ |honda_cstpncpy_#t~post3| |ray_cstpncpy_#t~post3|) 0)
 (* (+ |honda_cstpncpy_~#dst.base| |ray_cstpncpy_~#dst.base|) 0)
 (* (+ honda_cstpncpy_~src.offset ray_cstpncpy_~src.offset) 0)
 (* (+ |honda_cstpncpy_#in~src.base| |ray_cstpncpy_#in~src.base|) 0)
 (*
 (+
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 |ray_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)|
 |ray_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)|) 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0) 
 (* honda_cstpncpy_~d~3.base (- 1)) 
 (* |honda_cstpncpy_#t~post5.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 0) 0)
 (>=
 (+ (* (+ |honda_cstpncpy_#t~mem0.offset| |ray_cstpncpy_#t~mem0.offset|) 0)
 (*
 (+ |honda_(select #length cstpncpy_~d~3.base)|
 |ray_(select #length cstpncpy_~d~3.base)|) 0)
 (* (+ |honda_cstpncpy_#t~post4.offset| |ray_cstpncpy_#t~post4.offset|) 0)
 (* (+ honda_cstpncpy_~s~3.offset ray_cstpncpy_~s~3.offset) 0)
 (*
 (+
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 |ray_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|)
 0)
 (*
 (+ |honda_(select old(#length) cstpncpy_#in~src.base)|
 |ray_(select old(#length) cstpncpy_#in~src.base)|) 0)
 (* (+ |honda_cstpncpy_~#dst.offset| |ray_cstpncpy_~#dst.offset|) 0)
 (*
 (+
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 |ray_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|)
 0) (* (+ |honda_cstpncpy_#t~mem7| |ray_cstpncpy_#t~mem7|) 0)
 (*
 (+
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 |ray_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|)
 0) (* (+ honda_cstpncpy_~d~3.base ray_cstpncpy_~d~3.base) 0)
 (*
 (+
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 |ray_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|)
 0)
 (*
 (+ |honda_(select #length cstpncpy_#in~src.base)|
 |ray_(select #length cstpncpy_#in~src.base)|) 0)
 (* (+ |honda_cstpncpy_#in~src.offset| |ray_cstpncpy_#in~src.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)|
 |ray_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)|) 0)
 (* (+ |honda_cstpncpy_#t~mem1.offset| |ray_cstpncpy_#t~mem1.offset|) 0)
 (*
 (+ |honda_(select #length cstpncpy_#in~dst.base)|
 |ray_(select #length cstpncpy_#in~dst.base)|) 0)
 (* (+ |honda_cstpncpy_#t~mem0.base| |ray_cstpncpy_#t~mem0.base|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 |ray_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|)
 0) (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_cstpncpy_#in~n| |ray_cstpncpy_#in~n|) 0)
 (* (+ |honda_cstpncpy_#t~mem1.base| |ray_cstpncpy_#t~mem1.base|) 0)
 (* (+ |honda_cstpncpy_#t~post5.base| |ray_cstpncpy_#t~post5.base|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(select old(#length) cstpncpy_~#dst.base)|
 |ray_(select old(#length) cstpncpy_~#dst.base)|) 0)
 (*
 (+ |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)|
 |ray_(ite (select #valid cstpncpy_~d~3.base) 1 0)|) 0)
 (* (+ honda_cstpncpy_~s~3.base ray_cstpncpy_~s~3.base) 0)
 (*
 (+
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 |ray_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|)
 0)
 (*
 (+ |honda_(select #length cstpncpy_~s~3.base)|
 |ray_(select #length cstpncpy_~s~3.base)|) 0)
 (* (+ honda_cstpncpy_~n ray_cstpncpy_~n) 0)
 (* (+ |honda_cstpncpy_#in~dst.base| |ray_cstpncpy_#in~dst.base|) 0)
 (*
 (+ |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)|
 |ray_(ite (select #valid cstpncpy_#in~dst.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length cstpncpy_~#dst.base)|
 |ray_(select #length cstpncpy_~#dst.base)|) 0)
 (* (+ |honda_cstpncpy_#t~post4.base| |ray_cstpncpy_#t~post4.base|) 0)
 (*
 (+ |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)|
 |ray_(ite (select #valid cstpncpy_~#dst.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) cstpncpy_#in~dst.base)|
 |ray_(select old(#length) cstpncpy_#in~dst.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)|
 |ray_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)|) 0)
 (* (+ |honda_cstpncpy_#t~post5.offset| |ray_cstpncpy_#t~post5.offset|) 0)
 (*
 (+ |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)|
 |ray_(ite (select #valid cstpncpy_#in~src.base) 1 0)|) 0)
 (* (+ |honda_cstpncpy_#in~dst.offset| |ray_cstpncpy_#in~dst.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)|
 |ray_(ite (select #valid cstpncpy_~s~3.base) 1 0)|) 0)
 (* (+ honda_cstpncpy_~src.base ray_cstpncpy_~src.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ honda_cstpncpy_~d~3.offset ray_cstpncpy_~d~3.offset) 0)
 (* (+ |honda_cstpncpy_#t~post3| |ray_cstpncpy_#t~post3|) 0)
 (* (+ |honda_cstpncpy_~#dst.base| |ray_cstpncpy_~#dst.base|) 0)
 (* (+ honda_cstpncpy_~src.offset ray_cstpncpy_~src.offset) 0)
 (* (+ |honda_cstpncpy_#in~src.base| |ray_cstpncpy_#in~src.base|) 0)
 (*
 (+
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 |ray_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)|
 |ray_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)|) 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0) 
 (* honda_cstpncpy_~s~3.offset (- 1))
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0) 
 (* honda_cstpncpy_~d~3.base 0) 
 (* |honda_cstpncpy_#t~post5.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(select #length cstpncpy_~s~3.base)| 1) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (- 1)) 0)
 (>=
 (+ (* (+ |honda_cstpncpy_#t~mem0.offset| |ray_cstpncpy_#t~mem0.offset|) 0)
 (*
 (+ |honda_(select #length cstpncpy_~d~3.base)|
 |ray_(select #length cstpncpy_~d~3.base)|) 0)
 (* (+ |honda_cstpncpy_#t~post4.offset| |ray_cstpncpy_#t~post4.offset|) 0)
 (* (+ honda_cstpncpy_~s~3.offset ray_cstpncpy_~s~3.offset) (- 1))
 (*
 (+
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 |ray_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|)
 0)
 (*
 (+ |honda_(select old(#length) cstpncpy_#in~src.base)|
 |ray_(select old(#length) cstpncpy_#in~src.base)|) 0)
 (* (+ |honda_cstpncpy_~#dst.offset| |ray_cstpncpy_~#dst.offset|) 0)
 (*
 (+
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 |ray_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|)
 0) (* (+ |honda_cstpncpy_#t~mem7| |ray_cstpncpy_#t~mem7|) 0)
 (*
 (+
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 |ray_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|)
 0) (* (+ honda_cstpncpy_~d~3.base ray_cstpncpy_~d~3.base) 0)
 (*
 (+
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 |ray_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|)
 0)
 (*
 (+ |honda_(select #length cstpncpy_#in~src.base)|
 |ray_(select #length cstpncpy_#in~src.base)|) 0)
 (* (+ |honda_cstpncpy_#in~src.offset| |ray_cstpncpy_#in~src.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)|
 |ray_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)|) 0)
 (* (+ |honda_cstpncpy_#t~mem1.offset| |ray_cstpncpy_#t~mem1.offset|) 0)
 (*
 (+ |honda_(select #length cstpncpy_#in~dst.base)|
 |ray_(select #length cstpncpy_#in~dst.base)|) 0)
 (* (+ |honda_cstpncpy_#t~mem0.base| |ray_cstpncpy_#t~mem0.base|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 |ray_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|)
 0) (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_cstpncpy_#in~n| |ray_cstpncpy_#in~n|) 0)
 (* (+ |honda_cstpncpy_#t~mem1.base| |ray_cstpncpy_#t~mem1.base|) 0)
 (* (+ |honda_cstpncpy_#t~post5.base| |ray_cstpncpy_#t~post5.base|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(select old(#length) cstpncpy_~#dst.base)|
 |ray_(select old(#length) cstpncpy_~#dst.base)|) 0)
 (*
 (+ |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)|
 |ray_(ite (select #valid cstpncpy_~d~3.base) 1 0)|) 0)
 (* (+ honda_cstpncpy_~s~3.base ray_cstpncpy_~s~3.base) 0)
 (*
 (+
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 |ray_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|)
 0)
 (*
 (+ |honda_(select #length cstpncpy_~s~3.base)|
 |ray_(select #length cstpncpy_~s~3.base)|) 0)
 (* (+ honda_cstpncpy_~n ray_cstpncpy_~n) 0)
 (* (+ |honda_cstpncpy_#in~dst.base| |ray_cstpncpy_#in~dst.base|) 0)
 (*
 (+ |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)|
 |ray_(ite (select #valid cstpncpy_#in~dst.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length cstpncpy_~#dst.base)|
 |ray_(select #length cstpncpy_~#dst.base)|) 0)
 (* (+ |honda_cstpncpy_#t~post4.base| |ray_cstpncpy_#t~post4.base|) 0)
 (*
 (+ |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)|
 |ray_(ite (select #valid cstpncpy_~#dst.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) cstpncpy_#in~dst.base)|
 |ray_(select old(#length) cstpncpy_#in~dst.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)|
 |ray_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)|) 0)
 (* (+ |honda_cstpncpy_#t~post5.offset| |ray_cstpncpy_#t~post5.offset|) 0)
 (*
 (+ |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)|
 |ray_(ite (select #valid cstpncpy_#in~src.base) 1 0)|) 0)
 (* (+ |honda_cstpncpy_#in~dst.offset| |ray_cstpncpy_#in~dst.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)|
 |ray_(ite (select #valid cstpncpy_~s~3.base) 1 0)|) 0)
 (* (+ honda_cstpncpy_~src.base ray_cstpncpy_~src.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ honda_cstpncpy_~d~3.offset ray_cstpncpy_~d~3.offset) 0)
 (* (+ |honda_cstpncpy_#t~post3| |ray_cstpncpy_#t~post3|) 0)
 (* (+ |honda_cstpncpy_~#dst.base| |ray_cstpncpy_~#dst.base|) 0)
 (* (+ honda_cstpncpy_~src.offset ray_cstpncpy_~src.offset) 0)
 (* (+ |honda_cstpncpy_#in~src.base| |ray_cstpncpy_#in~src.base|) 0)
 (*
 (+
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 |ray_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)|
 |ray_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)|) 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 1)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0) 
 (* honda_cstpncpy_~d~3.base 0) 
 (* |honda_cstpncpy_#t~post5.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 1) 0)
 (>=
 (+ (* (+ |honda_cstpncpy_#t~mem0.offset| |ray_cstpncpy_#t~mem0.offset|) 0)
 (*
 (+ |honda_(select #length cstpncpy_~d~3.base)|
 |ray_(select #length cstpncpy_~d~3.base)|) 0)
 (* (+ |honda_cstpncpy_#t~post4.offset| |ray_cstpncpy_#t~post4.offset|) 0)
 (* (+ honda_cstpncpy_~s~3.offset ray_cstpncpy_~s~3.offset) 0)
 (*
 (+
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 |ray_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|)
 0)
 (*
 (+ |honda_(select old(#length) cstpncpy_#in~src.base)|
 |ray_(select old(#length) cstpncpy_#in~src.base)|) 0)
 (* (+ |honda_cstpncpy_~#dst.offset| |ray_cstpncpy_~#dst.offset|) 0)
 (*
 (+
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 |ray_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|)
 0) (* (+ |honda_cstpncpy_#t~mem7| |ray_cstpncpy_#t~mem7|) 0)
 (*
 (+
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 |ray_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|)
 0) (* (+ honda_cstpncpy_~d~3.base ray_cstpncpy_~d~3.base) 0)
 (*
 (+
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 |ray_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|)
 0)
 (*
 (+ |honda_(select #length cstpncpy_#in~src.base)|
 |ray_(select #length cstpncpy_#in~src.base)|) 0)
 (* (+ |honda_cstpncpy_#in~src.offset| |ray_cstpncpy_#in~src.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)|
 |ray_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)|) 0)
 (* (+ |honda_cstpncpy_#t~mem1.offset| |ray_cstpncpy_#t~mem1.offset|) 0)
 (*
 (+ |honda_(select #length cstpncpy_#in~dst.base)|
 |ray_(select #length cstpncpy_#in~dst.base)|) 0)
 (* (+ |honda_cstpncpy_#t~mem0.base| |ray_cstpncpy_#t~mem0.base|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 |ray_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|)
 0) (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_cstpncpy_#in~n| |ray_cstpncpy_#in~n|) 0)
 (* (+ |honda_cstpncpy_#t~mem1.base| |ray_cstpncpy_#t~mem1.base|) 0)
 (* (+ |honda_cstpncpy_#t~post5.base| |ray_cstpncpy_#t~post5.base|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(select old(#length) cstpncpy_~#dst.base)|
 |ray_(select old(#length) cstpncpy_~#dst.base)|) 0)
 (*
 (+ |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)|
 |ray_(ite (select #valid cstpncpy_~d~3.base) 1 0)|) 0)
 (* (+ honda_cstpncpy_~s~3.base ray_cstpncpy_~s~3.base) 0)
 (*
 (+
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 |ray_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|)
 0)
 (*
 (+ |honda_(select #length cstpncpy_~s~3.base)|
 |ray_(select #length cstpncpy_~s~3.base)|) 0)
 (* (+ honda_cstpncpy_~n ray_cstpncpy_~n) (- 1))
 (* (+ |honda_cstpncpy_#in~dst.base| |ray_cstpncpy_#in~dst.base|) 0)
 (*
 (+ |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)|
 |ray_(ite (select #valid cstpncpy_#in~dst.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length cstpncpy_~#dst.base)|
 |ray_(select #length cstpncpy_~#dst.base)|) 0)
 (* (+ |honda_cstpncpy_#t~post4.base| |ray_cstpncpy_#t~post4.base|) 0)
 (*
 (+ |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)|
 |ray_(ite (select #valid cstpncpy_~#dst.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) cstpncpy_#in~dst.base)|
 |ray_(select old(#length) cstpncpy_#in~dst.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)|
 |ray_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)|) 0)
 (* (+ |honda_cstpncpy_#t~post5.offset| |ray_cstpncpy_#t~post5.offset|) 0)
 (*
 (+ |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)|
 |ray_(ite (select #valid cstpncpy_#in~src.base) 1 0)|) 0)
 (* (+ |honda_cstpncpy_#in~dst.offset| |ray_cstpncpy_#in~dst.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)|
 |ray_(ite (select #valid cstpncpy_~s~3.base) 1 0)|) 0)
 (* (+ honda_cstpncpy_~src.base ray_cstpncpy_~src.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ honda_cstpncpy_~d~3.offset ray_cstpncpy_~d~3.offset) 0)
 (* (+ |honda_cstpncpy_#t~post3| |ray_cstpncpy_#t~post3|) 0)
 (* (+ |honda_cstpncpy_~#dst.base| |ray_cstpncpy_~#dst.base|) 0)
 (* (+ honda_cstpncpy_~src.offset ray_cstpncpy_~src.offset) 0)
 (* (+ |honda_cstpncpy_#in~src.base| |ray_cstpncpy_#in~src.base|) 0)
 (*
 (+
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 |ray_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)|
 |ray_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)|) 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0) 
 (* honda_cstpncpy_~d~3.base 0) 
 (* |honda_cstpncpy_#t~post5.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 1) (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (- 1)) 0)
 (>=
 (+ (* (+ |honda_cstpncpy_#t~mem0.offset| |ray_cstpncpy_#t~mem0.offset|) 0)
 (*
 (+ |honda_(select #length cstpncpy_~d~3.base)|
 |ray_(select #length cstpncpy_~d~3.base)|) 0)
 (* (+ |honda_cstpncpy_#t~post4.offset| |ray_cstpncpy_#t~post4.offset|) 0)
 (* (+ honda_cstpncpy_~s~3.offset ray_cstpncpy_~s~3.offset) 0)
 (*
 (+
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 |ray_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|)
 0)
 (*
 (+ |honda_(select old(#length) cstpncpy_#in~src.base)|
 |ray_(select old(#length) cstpncpy_#in~src.base)|) 0)
 (* (+ |honda_cstpncpy_~#dst.offset| |ray_cstpncpy_~#dst.offset|) 0)
 (*
 (+
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 |ray_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|)
 0) (* (+ |honda_cstpncpy_#t~mem7| |ray_cstpncpy_#t~mem7|) 0)
 (*
 (+
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 |ray_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|)
 0) (* (+ honda_cstpncpy_~d~3.base ray_cstpncpy_~d~3.base) 0)
 (*
 (+
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 |ray_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|)
 0)
 (*
 (+ |honda_(select #length cstpncpy_#in~src.base)|
 |ray_(select #length cstpncpy_#in~src.base)|) 0)
 (* (+ |honda_cstpncpy_#in~src.offset| |ray_cstpncpy_#in~src.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)|
 |ray_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)|) 0)
 (* (+ |honda_cstpncpy_#t~mem1.offset| |ray_cstpncpy_#t~mem1.offset|) 0)
 (*
 (+ |honda_(select #length cstpncpy_#in~dst.base)|
 |ray_(select #length cstpncpy_#in~dst.base)|) 0)
 (* (+ |honda_cstpncpy_#t~mem0.base| |ray_cstpncpy_#t~mem0.base|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 |ray_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|)
 0) (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_cstpncpy_#in~n| |ray_cstpncpy_#in~n|) 0)
 (* (+ |honda_cstpncpy_#t~mem1.base| |ray_cstpncpy_#t~mem1.base|) 0)
 (* (+ |honda_cstpncpy_#t~post5.base| |ray_cstpncpy_#t~post5.base|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(select old(#length) cstpncpy_~#dst.base)|
 |ray_(select old(#length) cstpncpy_~#dst.base)|) 0)
 (*
 (+ |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)|
 |ray_(ite (select #valid cstpncpy_~d~3.base) 1 0)|) 0)
 (* (+ honda_cstpncpy_~s~3.base ray_cstpncpy_~s~3.base) 0)
 (*
 (+
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 |ray_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|)
 0)
 (*
 (+ |honda_(select #length cstpncpy_~s~3.base)|
 |ray_(select #length cstpncpy_~s~3.base)|) 0)
 (* (+ honda_cstpncpy_~n ray_cstpncpy_~n) 0)
 (* (+ |honda_cstpncpy_#in~dst.base| |ray_cstpncpy_#in~dst.base|) 0)
 (*
 (+ |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)|
 |ray_(ite (select #valid cstpncpy_#in~dst.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length cstpncpy_~#dst.base)|
 |ray_(select #length cstpncpy_~#dst.base)|) 0)
 (* (+ |honda_cstpncpy_#t~post4.base| |ray_cstpncpy_#t~post4.base|) 0)
 (*
 (+ |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)|
 |ray_(ite (select #valid cstpncpy_~#dst.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) cstpncpy_#in~dst.base)|
 |ray_(select old(#length) cstpncpy_#in~dst.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)|
 |ray_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)|) 0)
 (* (+ |honda_cstpncpy_#t~post5.offset| |ray_cstpncpy_#t~post5.offset|) 0)
 (*
 (+ |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)|
 |ray_(ite (select #valid cstpncpy_#in~src.base) 1 0)|) 0)
 (* (+ |honda_cstpncpy_#in~dst.offset| |ray_cstpncpy_#in~dst.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)|
 |ray_(ite (select #valid cstpncpy_~s~3.base) 1 0)|) 0)
 (* (+ honda_cstpncpy_~src.base ray_cstpncpy_~src.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ honda_cstpncpy_~d~3.offset ray_cstpncpy_~d~3.offset) 1)
 (* (+ |honda_cstpncpy_#t~post3| |ray_cstpncpy_#t~post3|) 0)
 (* (+ |honda_cstpncpy_~#dst.base| |ray_cstpncpy_~#dst.base|) 0)
 (* (+ honda_cstpncpy_~src.offset ray_cstpncpy_~src.offset) 0)
 (* (+ |honda_cstpncpy_#in~src.base| |ray_cstpncpy_#in~src.base|) 0)
 (*
 (+
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 |ray_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)|
 |ray_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)|) 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0) 
 (* honda_cstpncpy_~d~3.base 0) 
 (* |honda_cstpncpy_#t~post5.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset (- 1)) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (- 1)) 0)
 (>=
 (+ (* (+ |honda_cstpncpy_#t~mem0.offset| |ray_cstpncpy_#t~mem0.offset|) 0)
 (*
 (+ |honda_(select #length cstpncpy_~d~3.base)|
 |ray_(select #length cstpncpy_~d~3.base)|) 0)
 (* (+ |honda_cstpncpy_#t~post4.offset| |ray_cstpncpy_#t~post4.offset|) 0)
 (* (+ honda_cstpncpy_~s~3.offset ray_cstpncpy_~s~3.offset) 0)
 (*
 (+
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 |ray_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|)
 0)
 (*
 (+ |honda_(select old(#length) cstpncpy_#in~src.base)|
 |ray_(select old(#length) cstpncpy_#in~src.base)|) 0)
 (* (+ |honda_cstpncpy_~#dst.offset| |ray_cstpncpy_~#dst.offset|) 0)
 (*
 (+
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 |ray_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|)
 0) (* (+ |honda_cstpncpy_#t~mem7| |ray_cstpncpy_#t~mem7|) 0)
 (*
 (+
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 |ray_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|)
 0) (* (+ honda_cstpncpy_~d~3.base ray_cstpncpy_~d~3.base) 0)
 (*
 (+
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 |ray_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|)
 0)
 (*
 (+ |honda_(select #length cstpncpy_#in~src.base)|
 |ray_(select #length cstpncpy_#in~src.base)|) 0)
 (* (+ |honda_cstpncpy_#in~src.offset| |ray_cstpncpy_#in~src.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)|
 |ray_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)|) 0)
 (* (+ |honda_cstpncpy_#t~mem1.offset| |ray_cstpncpy_#t~mem1.offset|) 0)
 (*
 (+ |honda_(select #length cstpncpy_#in~dst.base)|
 |ray_(select #length cstpncpy_#in~dst.base)|) 0)
 (* (+ |honda_cstpncpy_#t~mem0.base| |ray_cstpncpy_#t~mem0.base|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 |ray_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|)
 0) (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_cstpncpy_#in~n| |ray_cstpncpy_#in~n|) 0)
 (* (+ |honda_cstpncpy_#t~mem1.base| |ray_cstpncpy_#t~mem1.base|) 0)
 (* (+ |honda_cstpncpy_#t~post5.base| |ray_cstpncpy_#t~post5.base|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(select old(#length) cstpncpy_~#dst.base)|
 |ray_(select old(#length) cstpncpy_~#dst.base)|) 0)
 (*
 (+ |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)|
 |ray_(ite (select #valid cstpncpy_~d~3.base) 1 0)|) 0)
 (* (+ honda_cstpncpy_~s~3.base ray_cstpncpy_~s~3.base) 0)
 (*
 (+
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 |ray_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|)
 0)
 (*
 (+ |honda_(select #length cstpncpy_~s~3.base)|
 |ray_(select #length cstpncpy_~s~3.base)|) 0)
 (* (+ honda_cstpncpy_~n ray_cstpncpy_~n) 0)
 (* (+ |honda_cstpncpy_#in~dst.base| |ray_cstpncpy_#in~dst.base|) 0)
 (*
 (+ |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)|
 |ray_(ite (select #valid cstpncpy_#in~dst.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length cstpncpy_~#dst.base)|
 |ray_(select #length cstpncpy_~#dst.base)|) 0)
 (* (+ |honda_cstpncpy_#t~post4.base| |ray_cstpncpy_#t~post4.base|) 0)
 (*
 (+ |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)|
 |ray_(ite (select #valid cstpncpy_~#dst.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) cstpncpy_#in~dst.base)|
 |ray_(select old(#length) cstpncpy_#in~dst.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)|
 |ray_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)|) 0)
 (* (+ |honda_cstpncpy_#t~post5.offset| |ray_cstpncpy_#t~post5.offset|) 0)
 (*
 (+ |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)|
 |ray_(ite (select #valid cstpncpy_#in~src.base) 1 0)|) 0)
 (* (+ |honda_cstpncpy_#in~dst.offset| |ray_cstpncpy_#in~dst.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)|
 |ray_(ite (select #valid cstpncpy_~s~3.base) 1 0)|) 0)
 (* (+ honda_cstpncpy_~src.base ray_cstpncpy_~src.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ honda_cstpncpy_~d~3.offset ray_cstpncpy_~d~3.offset) 0)
 (* (+ |honda_cstpncpy_#t~post3| |ray_cstpncpy_#t~post3|) 0)
 (* (+ |honda_cstpncpy_~#dst.base| |ray_cstpncpy_~#dst.base|) 0)
 (* (+ honda_cstpncpy_~src.offset ray_cstpncpy_~src.offset) 0)
 (* (+ |honda_cstpncpy_#in~src.base| |ray_cstpncpy_#in~src.base|) 0)
 (*
 (+
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 |ray_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)|
 |ray_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)|) 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 (- 1)) (* |honda_cstpncpy_#t~mem7| 0) 
 (* honda_cstpncpy_~d~3.base 0) 
 (* |honda_cstpncpy_#t~post5.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (- 1)) 0)
 (>=
 (+ (* (+ |honda_cstpncpy_#t~mem0.offset| |ray_cstpncpy_#t~mem0.offset|) 0)
 (*
 (+ |honda_(select #length cstpncpy_~d~3.base)|
 |ray_(select #length cstpncpy_~d~3.base)|) 0)
 (* (+ |honda_cstpncpy_#t~post4.offset| |ray_cstpncpy_#t~post4.offset|) 0)
 (* (+ honda_cstpncpy_~s~3.offset ray_cstpncpy_~s~3.offset) 0)
 (*
 (+
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 |ray_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|)
 0)
 (*
 (+ |honda_(select old(#length) cstpncpy_#in~src.base)|
 |ray_(select old(#length) cstpncpy_#in~src.base)|) 0)
 (* (+ |honda_cstpncpy_~#dst.offset| |ray_cstpncpy_~#dst.offset|) 0)
 (*
 (+
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 |ray_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|)
 0) (* (+ |honda_cstpncpy_#t~mem7| |ray_cstpncpy_#t~mem7|) 0)
 (*
 (+
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 |ray_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|)
 0) (* (+ honda_cstpncpy_~d~3.base ray_cstpncpy_~d~3.base) 0)
 (*
 (+
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 |ray_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|)
 0)
 (*
 (+ |honda_(select #length cstpncpy_#in~src.base)|
 |ray_(select #length cstpncpy_#in~src.base)|) 0)
 (* (+ |honda_cstpncpy_#in~src.offset| |ray_cstpncpy_#in~src.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)|
 |ray_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)|) 0)
 (* (+ |honda_cstpncpy_#t~mem1.offset| |ray_cstpncpy_#t~mem1.offset|) 0)
 (*
 (+ |honda_(select #length cstpncpy_#in~dst.base)|
 |ray_(select #length cstpncpy_#in~dst.base)|) 0)
 (* (+ |honda_cstpncpy_#t~mem0.base| |ray_cstpncpy_#t~mem0.base|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 |ray_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|)
 0) (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_cstpncpy_#in~n| |ray_cstpncpy_#in~n|) 0)
 (* (+ |honda_cstpncpy_#t~mem1.base| |ray_cstpncpy_#t~mem1.base|) 0)
 (* (+ |honda_cstpncpy_#t~post5.base| |ray_cstpncpy_#t~post5.base|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(select old(#length) cstpncpy_~#dst.base)|
 |ray_(select old(#length) cstpncpy_~#dst.base)|) 0)
 (*
 (+ |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)|
 |ray_(ite (select #valid cstpncpy_~d~3.base) 1 0)|) 0)
 (* (+ honda_cstpncpy_~s~3.base ray_cstpncpy_~s~3.base) 0)
 (*
 (+
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 |ray_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|)
 0)
 (*
 (+ |honda_(select #length cstpncpy_~s~3.base)|
 |ray_(select #length cstpncpy_~s~3.base)|) 0)
 (* (+ honda_cstpncpy_~n ray_cstpncpy_~n) 0)
 (* (+ |honda_cstpncpy_#in~dst.base| |ray_cstpncpy_#in~dst.base|) 0)
 (*
 (+ |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)|
 |ray_(ite (select #valid cstpncpy_#in~dst.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length cstpncpy_~#dst.base)|
 |ray_(select #length cstpncpy_~#dst.base)|) 0)
 (* (+ |honda_cstpncpy_#t~post4.base| |ray_cstpncpy_#t~post4.base|) 0)
 (*
 (+ |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)|
 |ray_(ite (select #valid cstpncpy_~#dst.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) cstpncpy_#in~dst.base)|
 |ray_(select old(#length) cstpncpy_#in~dst.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)|
 |ray_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)|) 0)
 (* (+ |honda_cstpncpy_#t~post5.offset| |ray_cstpncpy_#t~post5.offset|) 0)
 (*
 (+ |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)|
 |ray_(ite (select #valid cstpncpy_#in~src.base) 1 0)|) 0)
 (* (+ |honda_cstpncpy_#in~dst.offset| |ray_cstpncpy_#in~dst.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)|
 |ray_(ite (select #valid cstpncpy_~s~3.base) 1 0)|) 1)
 (* (+ honda_cstpncpy_~src.base ray_cstpncpy_~src.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ honda_cstpncpy_~d~3.offset ray_cstpncpy_~d~3.offset) 0)
 (* (+ |honda_cstpncpy_#t~post3| |ray_cstpncpy_#t~post3|) 0)
 (* (+ |honda_cstpncpy_~#dst.base| |ray_cstpncpy_~#dst.base|) 0)
 (* (+ honda_cstpncpy_~src.offset ray_cstpncpy_~src.offset) 0)
 (* (+ |honda_cstpncpy_#in~src.base| |ray_cstpncpy_#in~src.base|) 0)
 (*
 (+
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 |ray_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)|
 |ray_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)|) 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0) 
 (* honda_cstpncpy_~d~3.base 0) 
 (* |honda_cstpncpy_#t~post5.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (- 1)) 0)
 (>=
 (+ (* (+ |honda_cstpncpy_#t~mem0.offset| |ray_cstpncpy_#t~mem0.offset|) 0)
 (*
 (+ |honda_(select #length cstpncpy_~d~3.base)|
 |ray_(select #length cstpncpy_~d~3.base)|) 0)
 (* (+ |honda_cstpncpy_#t~post4.offset| |ray_cstpncpy_#t~post4.offset|) 0)
 (* (+ honda_cstpncpy_~s~3.offset ray_cstpncpy_~s~3.offset) 0)
 (*
 (+
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 |ray_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|)
 0)
 (*
 (+ |honda_(select old(#length) cstpncpy_#in~src.base)|
 |ray_(select old(#length) cstpncpy_#in~src.base)|) 0)
 (* (+ |honda_cstpncpy_~#dst.offset| |ray_cstpncpy_~#dst.offset|) 0)
 (*
 (+
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 |ray_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|)
 0) (* (+ |honda_cstpncpy_#t~mem7| |ray_cstpncpy_#t~mem7|) 0)
 (*
 (+
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 |ray_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|)
 0) (* (+ honda_cstpncpy_~d~3.base ray_cstpncpy_~d~3.base) 0)
 (*
 (+
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 |ray_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|)
 0)
 (*
 (+ |honda_(select #length cstpncpy_#in~src.base)|
 |ray_(select #length cstpncpy_#in~src.base)|) 0)
 (* (+ |honda_cstpncpy_#in~src.offset| |ray_cstpncpy_#in~src.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)|
 |ray_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)|) 0)
 (* (+ |honda_cstpncpy_#t~mem1.offset| |ray_cstpncpy_#t~mem1.offset|) 0)
 (*
 (+ |honda_(select #length cstpncpy_#in~dst.base)|
 |ray_(select #length cstpncpy_#in~dst.base)|) 0)
 (* (+ |honda_cstpncpy_#t~mem0.base| |ray_cstpncpy_#t~mem0.base|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 |ray_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|)
 0) (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_cstpncpy_#in~n| |ray_cstpncpy_#in~n|) 0)
 (* (+ |honda_cstpncpy_#t~mem1.base| |ray_cstpncpy_#t~mem1.base|) 0)
 (* (+ |honda_cstpncpy_#t~post5.base| |ray_cstpncpy_#t~post5.base|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(select old(#length) cstpncpy_~#dst.base)|
 |ray_(select old(#length) cstpncpy_~#dst.base)|) 0)
 (*
 (+ |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)|
 |ray_(ite (select #valid cstpncpy_~d~3.base) 1 0)|) 0)
 (* (+ honda_cstpncpy_~s~3.base ray_cstpncpy_~s~3.base) 0)
 (*
 (+
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 |ray_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|)
 0)
 (*
 (+ |honda_(select #length cstpncpy_~s~3.base)|
 |ray_(select #length cstpncpy_~s~3.base)|) 0)
 (* (+ honda_cstpncpy_~n ray_cstpncpy_~n) 0)
 (* (+ |honda_cstpncpy_#in~dst.base| |ray_cstpncpy_#in~dst.base|) 0)
 (*
 (+ |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)|
 |ray_(ite (select #valid cstpncpy_#in~dst.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length cstpncpy_~#dst.base)|
 |ray_(select #length cstpncpy_~#dst.base)|) 0)
 (* (+ |honda_cstpncpy_#t~post4.base| |ray_cstpncpy_#t~post4.base|) 0)
 (*
 (+ |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)|
 |ray_(ite (select #valid cstpncpy_~#dst.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) cstpncpy_#in~dst.base)|
 |ray_(select old(#length) cstpncpy_#in~dst.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)|
 |ray_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)|) 0)
 (* (+ |honda_cstpncpy_#t~post5.offset| |ray_cstpncpy_#t~post5.offset|) 0)
 (*
 (+ |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)|
 |ray_(ite (select #valid cstpncpy_#in~src.base) 1 0)|) 0)
 (* (+ |honda_cstpncpy_#in~dst.offset| |ray_cstpncpy_#in~dst.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)|
 |ray_(ite (select #valid cstpncpy_~s~3.base) 1 0)|) 0)
 (* (+ honda_cstpncpy_~src.base ray_cstpncpy_~src.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ honda_cstpncpy_~d~3.offset ray_cstpncpy_~d~3.offset) 0)
 (* (+ |honda_cstpncpy_#t~post3| |ray_cstpncpy_#t~post3|) 0)
 (* (+ |honda_cstpncpy_~#dst.base| |ray_cstpncpy_~#dst.base|) 0)
 (* (+ honda_cstpncpy_~src.offset ray_cstpncpy_~src.offset) 0)
 (* (+ |honda_cstpncpy_#in~src.base| |ray_cstpncpy_#in~src.base|) 0)
 (*
 (+
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 |ray_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)|
 |ray_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)|) 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0) 
 (* honda_cstpncpy_~d~3.base 0) 
 (* |honda_cstpncpy_#t~post5.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(select #length cstpncpy_~s~3.base)| 0)
 (* honda_cstpncpy_~n (- 1)) 
 (* |honda_cstpncpy_#t~post4.base| 0) 
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* aux_3722 1) (* aux_3723 4294967296) 1) 0)
 (>=
 (+ (* (+ |honda_cstpncpy_#t~mem0.offset| |ray_cstpncpy_#t~mem0.offset|) 0)
 (*
 (+ |honda_(select #length cstpncpy_~d~3.base)|
 |ray_(select #length cstpncpy_~d~3.base)|) 0)
 (* (+ |honda_cstpncpy_#t~post4.offset| |ray_cstpncpy_#t~post4.offset|) 0)
 (* (+ honda_cstpncpy_~s~3.offset ray_cstpncpy_~s~3.offset) 0)
 (*
 (+
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 |ray_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|)
 0)
 (*
 (+ |honda_(select old(#length) cstpncpy_#in~src.base)|
 |ray_(select old(#length) cstpncpy_#in~src.base)|) 0)
 (* (+ |honda_cstpncpy_~#dst.offset| |ray_cstpncpy_~#dst.offset|) 0)
 (*
 (+
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 |ray_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|)
 0) (* (+ |honda_cstpncpy_#t~mem7| |ray_cstpncpy_#t~mem7|) 0)
 (*
 (+
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 |ray_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|)
 0) (* (+ honda_cstpncpy_~d~3.base ray_cstpncpy_~d~3.base) 0)
 (*
 (+
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 |ray_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|)
 0)
 (*
 (+ |honda_(select #length cstpncpy_#in~src.base)|
 |ray_(select #length cstpncpy_#in~src.base)|) 0)
 (* (+ |honda_cstpncpy_#in~src.offset| |ray_cstpncpy_#in~src.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)|
 |ray_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)|) 0)
 (* (+ |honda_cstpncpy_#t~mem1.offset| |ray_cstpncpy_#t~mem1.offset|) 0)
 (*
 (+ |honda_(select #length cstpncpy_#in~dst.base)|
 |ray_(select #length cstpncpy_#in~dst.base)|) 0)
 (* (+ |honda_cstpncpy_#t~mem0.base| |ray_cstpncpy_#t~mem0.base|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 |ray_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|)
 0) (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_cstpncpy_#in~n| |ray_cstpncpy_#in~n|) 0)
 (* (+ |honda_cstpncpy_#t~mem1.base| |ray_cstpncpy_#t~mem1.base|) 0)
 (* (+ |honda_cstpncpy_#t~post5.base| |ray_cstpncpy_#t~post5.base|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(select old(#length) cstpncpy_~#dst.base)|
 |ray_(select old(#length) cstpncpy_~#dst.base)|) 0)
 (*
 (+ |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)|
 |ray_(ite (select #valid cstpncpy_~d~3.base) 1 0)|) 0)
 (* (+ honda_cstpncpy_~s~3.base ray_cstpncpy_~s~3.base) 0)
 (*
 (+
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 |ray_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|)
 0)
 (*
 (+ |honda_(select #length cstpncpy_~s~3.base)|
 |ray_(select #length cstpncpy_~s~3.base)|) 0)
 (* (+ honda_cstpncpy_~n ray_cstpncpy_~n) 0)
 (* (+ |honda_cstpncpy_#in~dst.base| |ray_cstpncpy_#in~dst.base|) 0)
 (*
 (+ |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)|
 |ray_(ite (select #valid cstpncpy_#in~dst.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length cstpncpy_~#dst.base)|
 |ray_(select #length cstpncpy_~#dst.base)|) 0)
 (* (+ |honda_cstpncpy_#t~post4.base| |ray_cstpncpy_#t~post4.base|) 0)
 (*
 (+ |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)|
 |ray_(ite (select #valid cstpncpy_~#dst.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) cstpncpy_#in~dst.base)|
 |ray_(select old(#length) cstpncpy_#in~dst.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)|
 |ray_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)|) 0)
 (* (+ |honda_cstpncpy_#t~post5.offset| |ray_cstpncpy_#t~post5.offset|) 0)
 (*
 (+ |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)|
 |ray_(ite (select #valid cstpncpy_#in~src.base) 1 0)|) 0)
 (* (+ |honda_cstpncpy_#in~dst.offset| |ray_cstpncpy_#in~dst.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)|
 |ray_(ite (select #valid cstpncpy_~s~3.base) 1 0)|) 0)
 (* (+ honda_cstpncpy_~src.base ray_cstpncpy_~src.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ honda_cstpncpy_~d~3.offset ray_cstpncpy_~d~3.offset) 0)
 (* (+ |honda_cstpncpy_#t~post3| |ray_cstpncpy_#t~post3|) 0)
 (* (+ |honda_cstpncpy_~#dst.base| |ray_cstpncpy_~#dst.base|) 0)
 (* (+ honda_cstpncpy_~src.offset ray_cstpncpy_~src.offset) 0)
 (* (+ |honda_cstpncpy_#in~src.base| |ray_cstpncpy_#in~src.base|) 0)
 (*
 (+
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 |ray_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)|
 |ray_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)|) 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0) 
 (* honda_cstpncpy_~d~3.base 0) 
 (* |honda_cstpncpy_#t~post5.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* aux_3722 (- 1)) 4294967295) 0)
 (>=
 (+ (* (+ |honda_cstpncpy_#t~mem0.offset| |ray_cstpncpy_#t~mem0.offset|) 0)
 (*
 (+ |honda_(select #length cstpncpy_~d~3.base)|
 |ray_(select #length cstpncpy_~d~3.base)|) 0)
 (* (+ |honda_cstpncpy_#t~post4.offset| |ray_cstpncpy_#t~post4.offset|) 0)
 (* (+ honda_cstpncpy_~s~3.offset ray_cstpncpy_~s~3.offset) 0)
 (*
 (+
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 |ray_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|)
 0)
 (*
 (+ |honda_(select old(#length) cstpncpy_#in~src.base)|
 |ray_(select old(#length) cstpncpy_#in~src.base)|) 0)
 (* (+ |honda_cstpncpy_~#dst.offset| |ray_cstpncpy_~#dst.offset|) 0)
 (*
 (+
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 |ray_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|)
 0) (* (+ |honda_cstpncpy_#t~mem7| |ray_cstpncpy_#t~mem7|) 0)
 (*
 (+
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 |ray_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|)
 0) (* (+ honda_cstpncpy_~d~3.base ray_cstpncpy_~d~3.base) 0)
 (*
 (+
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 |ray_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|)
 0)
 (*
 (+ |honda_(select #length cstpncpy_#in~src.base)|
 |ray_(select #length cstpncpy_#in~src.base)|) 0)
 (* (+ |honda_cstpncpy_#in~src.offset| |ray_cstpncpy_#in~src.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)|
 |ray_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)|) 0)
 (* (+ |honda_cstpncpy_#t~mem1.offset| |ray_cstpncpy_#t~mem1.offset|) 0)
 (*
 (+ |honda_(select #length cstpncpy_#in~dst.base)|
 |ray_(select #length cstpncpy_#in~dst.base)|) 0)
 (* (+ |honda_cstpncpy_#t~mem0.base| |ray_cstpncpy_#t~mem0.base|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 |ray_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|)
 0) (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_cstpncpy_#in~n| |ray_cstpncpy_#in~n|) 0)
 (* (+ |honda_cstpncpy_#t~mem1.base| |ray_cstpncpy_#t~mem1.base|) 0)
 (* (+ |honda_cstpncpy_#t~post5.base| |ray_cstpncpy_#t~post5.base|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(select old(#length) cstpncpy_~#dst.base)|
 |ray_(select old(#length) cstpncpy_~#dst.base)|) 0)
 (*
 (+ |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)|
 |ray_(ite (select #valid cstpncpy_~d~3.base) 1 0)|) 0)
 (* (+ honda_cstpncpy_~s~3.base ray_cstpncpy_~s~3.base) 0)
 (*
 (+
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 |ray_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|)
 0)
 (*
 (+ |honda_(select #length cstpncpy_~s~3.base)|
 |ray_(select #length cstpncpy_~s~3.base)|) 0)
 (* (+ honda_cstpncpy_~n ray_cstpncpy_~n) 0)
 (* (+ |honda_cstpncpy_#in~dst.base| |ray_cstpncpy_#in~dst.base|) 0)
 (*
 (+ |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)|
 |ray_(ite (select #valid cstpncpy_#in~dst.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length cstpncpy_~#dst.base)|
 |ray_(select #length cstpncpy_~#dst.base)|) 0)
 (* (+ |honda_cstpncpy_#t~post4.base| |ray_cstpncpy_#t~post4.base|) 0)
 (*
 (+ |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)|
 |ray_(ite (select #valid cstpncpy_~#dst.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) cstpncpy_#in~dst.base)|
 |ray_(select old(#length) cstpncpy_#in~dst.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)|
 |ray_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)|) 0)
 (* (+ |honda_cstpncpy_#t~post5.offset| |ray_cstpncpy_#t~post5.offset|) 0)
 (*
 (+ |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)|
 |ray_(ite (select #valid cstpncpy_#in~src.base) 1 0)|) 0)
 (* (+ |honda_cstpncpy_#in~dst.offset| |ray_cstpncpy_#in~dst.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)|
 |ray_(ite (select #valid cstpncpy_~s~3.base) 1 0)|) 0)
 (* (+ honda_cstpncpy_~src.base ray_cstpncpy_~src.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ honda_cstpncpy_~d~3.offset ray_cstpncpy_~d~3.offset) 0)
 (* (+ |honda_cstpncpy_#t~post3| |ray_cstpncpy_#t~post3|) 0)
 (* (+ |honda_cstpncpy_~#dst.base| |ray_cstpncpy_~#dst.base|) 0)
 (* (+ honda_cstpncpy_~src.offset ray_cstpncpy_~src.offset) 0)
 (* (+ |honda_cstpncpy_#in~src.base| |ray_cstpncpy_#in~src.base|) 0)
 (*
 (+
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 |ray_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)|
 |ray_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)|) 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0) 
 (* honda_cstpncpy_~d~3.base 0) 
 (* |honda_cstpncpy_#t~post5.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 1) (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* aux_3722 (- 1)) (* aux_3723 (- 4294967296)) 
 (- 1)) 0)
 (>=
 (+ (* (+ |honda_cstpncpy_#t~mem0.offset| |ray_cstpncpy_#t~mem0.offset|) 0)
 (*
 (+ |honda_(select #length cstpncpy_~d~3.base)|
 |ray_(select #length cstpncpy_~d~3.base)|) 0)
 (* (+ |honda_cstpncpy_#t~post4.offset| |ray_cstpncpy_#t~post4.offset|) 0)
 (* (+ honda_cstpncpy_~s~3.offset ray_cstpncpy_~s~3.offset) 0)
 (*
 (+
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 |ray_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|)
 0)
 (*
 (+ |honda_(select old(#length) cstpncpy_#in~src.base)|
 |ray_(select old(#length) cstpncpy_#in~src.base)|) 0)
 (* (+ |honda_cstpncpy_~#dst.offset| |ray_cstpncpy_~#dst.offset|) 0)
 (*
 (+
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 |ray_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|)
 0) (* (+ |honda_cstpncpy_#t~mem7| |ray_cstpncpy_#t~mem7|) 0)
 (*
 (+
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 |ray_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|)
 0) (* (+ honda_cstpncpy_~d~3.base ray_cstpncpy_~d~3.base) 0)
 (*
 (+
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 |ray_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|)
 0)
 (*
 (+ |honda_(select #length cstpncpy_#in~src.base)|
 |ray_(select #length cstpncpy_#in~src.base)|) 0)
 (* (+ |honda_cstpncpy_#in~src.offset| |ray_cstpncpy_#in~src.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)|
 |ray_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)|) 0)
 (* (+ |honda_cstpncpy_#t~mem1.offset| |ray_cstpncpy_#t~mem1.offset|) 0)
 (*
 (+ |honda_(select #length cstpncpy_#in~dst.base)|
 |ray_(select #length cstpncpy_#in~dst.base)|) 0)
 (* (+ |honda_cstpncpy_#t~mem0.base| |ray_cstpncpy_#t~mem0.base|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 |ray_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|)
 0) (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_cstpncpy_#in~n| |ray_cstpncpy_#in~n|) 0)
 (* (+ |honda_cstpncpy_#t~mem1.base| |ray_cstpncpy_#t~mem1.base|) 0)
 (* (+ |honda_cstpncpy_#t~post5.base| |ray_cstpncpy_#t~post5.base|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(select old(#length) cstpncpy_~#dst.base)|
 |ray_(select old(#length) cstpncpy_~#dst.base)|) 0)
 (*
 (+ |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)|
 |ray_(ite (select #valid cstpncpy_~d~3.base) 1 0)|) 0)
 (* (+ honda_cstpncpy_~s~3.base ray_cstpncpy_~s~3.base) 0)
 (*
 (+
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 |ray_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|)
 0)
 (*
 (+ |honda_(select #length cstpncpy_~s~3.base)|
 |ray_(select #length cstpncpy_~s~3.base)|) 0)
 (* (+ honda_cstpncpy_~n ray_cstpncpy_~n) 0)
 (* (+ |honda_cstpncpy_#in~dst.base| |ray_cstpncpy_#in~dst.base|) 0)
 (*
 (+ |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)|
 |ray_(ite (select #valid cstpncpy_#in~dst.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length cstpncpy_~#dst.base)|
 |ray_(select #length cstpncpy_~#dst.base)|) 0)
 (* (+ |honda_cstpncpy_#t~post4.base| |ray_cstpncpy_#t~post4.base|) 0)
 (*
 (+ |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)|
 |ray_(ite (select #valid cstpncpy_~#dst.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) cstpncpy_#in~dst.base)|
 |ray_(select old(#length) cstpncpy_#in~dst.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)|
 |ray_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)|) 0)
 (* (+ |honda_cstpncpy_#t~post5.offset| |ray_cstpncpy_#t~post5.offset|) 0)
 (*
 (+ |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)|
 |ray_(ite (select #valid cstpncpy_#in~src.base) 1 0)|) 0)
 (* (+ |honda_cstpncpy_#in~dst.offset| |ray_cstpncpy_#in~dst.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)|
 |ray_(ite (select #valid cstpncpy_~s~3.base) 1 0)|) 0)
 (* (+ honda_cstpncpy_~src.base ray_cstpncpy_~src.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ honda_cstpncpy_~d~3.offset ray_cstpncpy_~d~3.offset) 0)
 (* (+ |honda_cstpncpy_#t~post3| |ray_cstpncpy_#t~post3|) 0)
 (* (+ |honda_cstpncpy_~#dst.base| |ray_cstpncpy_~#dst.base|) 0)
 (* (+ honda_cstpncpy_~src.offset ray_cstpncpy_~src.offset) 0)
 (* (+ |honda_cstpncpy_#in~src.base| |ray_cstpncpy_#in~src.base|) 0)
 (*
 (+
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 |ray_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)|
 |ray_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)|) 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0) 
 (* honda_cstpncpy_~d~3.base 0) 
 (* |honda_cstpncpy_#t~post5.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* aux_3727 (- 1)) (* aux_3728 (- 4294967296)) 0) 0)
 (>=
 (+ (* (+ |honda_cstpncpy_#t~mem0.offset| |ray_cstpncpy_#t~mem0.offset|) 0)
 (*
 (+ |honda_(select #length cstpncpy_~d~3.base)|
 |ray_(select #length cstpncpy_~d~3.base)|) 0)
 (* (+ |honda_cstpncpy_#t~post4.offset| |ray_cstpncpy_#t~post4.offset|) 0)
 (* (+ honda_cstpncpy_~s~3.offset ray_cstpncpy_~s~3.offset) 0)
 (*
 (+
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 |ray_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|)
 0)
 (*
 (+ |honda_(select old(#length) cstpncpy_#in~src.base)|
 |ray_(select old(#length) cstpncpy_#in~src.base)|) 0)
 (* (+ |honda_cstpncpy_~#dst.offset| |ray_cstpncpy_~#dst.offset|) 0)
 (*
 (+
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 |ray_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|)
 0) (* (+ |honda_cstpncpy_#t~mem7| |ray_cstpncpy_#t~mem7|) 0)
 (*
 (+
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 |ray_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|)
 0) (* (+ honda_cstpncpy_~d~3.base ray_cstpncpy_~d~3.base) 0)
 (*
 (+
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 |ray_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|)
 0)
 (*
 (+ |honda_(select #length cstpncpy_#in~src.base)|
 |ray_(select #length cstpncpy_#in~src.base)|) 0)
 (* (+ |honda_cstpncpy_#in~src.offset| |ray_cstpncpy_#in~src.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)|
 |ray_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)|) 0)
 (* (+ |honda_cstpncpy_#t~mem1.offset| |ray_cstpncpy_#t~mem1.offset|) 0)
 (*
 (+ |honda_(select #length cstpncpy_#in~dst.base)|
 |ray_(select #length cstpncpy_#in~dst.base)|) 0)
 (* (+ |honda_cstpncpy_#t~mem0.base| |ray_cstpncpy_#t~mem0.base|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 |ray_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|)
 0) (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_cstpncpy_#in~n| |ray_cstpncpy_#in~n|) 0)
 (* (+ |honda_cstpncpy_#t~mem1.base| |ray_cstpncpy_#t~mem1.base|) 0)
 (* (+ |honda_cstpncpy_#t~post5.base| |ray_cstpncpy_#t~post5.base|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(select old(#length) cstpncpy_~#dst.base)|
 |ray_(select old(#length) cstpncpy_~#dst.base)|) 0)
 (*
 (+ |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)|
 |ray_(ite (select #valid cstpncpy_~d~3.base) 1 0)|) 0)
 (* (+ honda_cstpncpy_~s~3.base ray_cstpncpy_~s~3.base) 0)
 (*
 (+
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 |ray_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|)
 0)
 (*
 (+ |honda_(select #length cstpncpy_~s~3.base)|
 |ray_(select #length cstpncpy_~s~3.base)|) 0)
 (* (+ honda_cstpncpy_~n ray_cstpncpy_~n) 0)
 (* (+ |honda_cstpncpy_#in~dst.base| |ray_cstpncpy_#in~dst.base|) 0)
 (*
 (+ |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)|
 |ray_(ite (select #valid cstpncpy_#in~dst.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length cstpncpy_~#dst.base)|
 |ray_(select #length cstpncpy_~#dst.base)|) 0)
 (* (+ |honda_cstpncpy_#t~post4.base| |ray_cstpncpy_#t~post4.base|) 0)
 (*
 (+ |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)|
 |ray_(ite (select #valid cstpncpy_~#dst.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) cstpncpy_#in~dst.base)|
 |ray_(select old(#length) cstpncpy_#in~dst.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)|
 |ray_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)|) 0)
 (* (+ |honda_cstpncpy_#t~post5.offset| |ray_cstpncpy_#t~post5.offset|) 0)
 (*
 (+ |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)|
 |ray_(ite (select #valid cstpncpy_#in~src.base) 1 0)|) 0)
 (* (+ |honda_cstpncpy_#in~dst.offset| |ray_cstpncpy_#in~dst.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)|
 |ray_(ite (select #valid cstpncpy_~s~3.base) 1 0)|) 0)
 (* (+ honda_cstpncpy_~src.base ray_cstpncpy_~src.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ honda_cstpncpy_~d~3.offset ray_cstpncpy_~d~3.offset) 0)
 (* (+ |honda_cstpncpy_#t~post3| |ray_cstpncpy_#t~post3|) 0)
 (* (+ |honda_cstpncpy_~#dst.base| |ray_cstpncpy_~#dst.base|) 0)
 (* (+ honda_cstpncpy_~src.offset ray_cstpncpy_~src.offset) 0)
 (* (+ |honda_cstpncpy_#in~src.base| |ray_cstpncpy_#in~src.base|) 0)
 (*
 (+
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 |ray_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)|
 |ray_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)|) 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0) 
 (* honda_cstpncpy_~d~3.base 0) 
 (* |honda_cstpncpy_#t~post5.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* aux_3727 1) (* aux_3728 4294967296) 0) 0)
 (>=
 (+ (* (+ |honda_cstpncpy_#t~mem0.offset| |ray_cstpncpy_#t~mem0.offset|) 0)
 (*
 (+ |honda_(select #length cstpncpy_~d~3.base)|
 |ray_(select #length cstpncpy_~d~3.base)|) 0)
 (* (+ |honda_cstpncpy_#t~post4.offset| |ray_cstpncpy_#t~post4.offset|) 0)
 (* (+ honda_cstpncpy_~s~3.offset ray_cstpncpy_~s~3.offset) 0)
 (*
 (+
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 |ray_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|)
 0)
 (*
 (+ |honda_(select old(#length) cstpncpy_#in~src.base)|
 |ray_(select old(#length) cstpncpy_#in~src.base)|) 0)
 (* (+ |honda_cstpncpy_~#dst.offset| |ray_cstpncpy_~#dst.offset|) 0)
 (*
 (+
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 |ray_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|)
 0) (* (+ |honda_cstpncpy_#t~mem7| |ray_cstpncpy_#t~mem7|) 0)
 (*
 (+
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 |ray_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|)
 0) (* (+ honda_cstpncpy_~d~3.base ray_cstpncpy_~d~3.base) 0)
 (*
 (+
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 |ray_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|)
 0)
 (*
 (+ |honda_(select #length cstpncpy_#in~src.base)|
 |ray_(select #length cstpncpy_#in~src.base)|) 0)
 (* (+ |honda_cstpncpy_#in~src.offset| |ray_cstpncpy_#in~src.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)|
 |ray_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)|) 0)
 (* (+ |honda_cstpncpy_#t~mem1.offset| |ray_cstpncpy_#t~mem1.offset|) 0)
 (*
 (+ |honda_(select #length cstpncpy_#in~dst.base)|
 |ray_(select #length cstpncpy_#in~dst.base)|) 0)
 (* (+ |honda_cstpncpy_#t~mem0.base| |ray_cstpncpy_#t~mem0.base|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 |ray_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|)
 0) (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_cstpncpy_#in~n| |ray_cstpncpy_#in~n|) 0)
 (* (+ |honda_cstpncpy_#t~mem1.base| |ray_cstpncpy_#t~mem1.base|) 0)
 (* (+ |honda_cstpncpy_#t~post5.base| |ray_cstpncpy_#t~post5.base|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(select old(#length) cstpncpy_~#dst.base)|
 |ray_(select old(#length) cstpncpy_~#dst.base)|) 0)
 (*
 (+ |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)|
 |ray_(ite (select #valid cstpncpy_~d~3.base) 1 0)|) 0)
 (* (+ honda_cstpncpy_~s~3.base ray_cstpncpy_~s~3.base) 0)
 (*
 (+
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 |ray_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|)
 0)
 (*
 (+ |honda_(select #length cstpncpy_~s~3.base)|
 |ray_(select #length cstpncpy_~s~3.base)|) 0)
 (* (+ honda_cstpncpy_~n ray_cstpncpy_~n) 0)
 (* (+ |honda_cstpncpy_#in~dst.base| |ray_cstpncpy_#in~dst.base|) 0)
 (*
 (+ |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)|
 |ray_(ite (select #valid cstpncpy_#in~dst.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length cstpncpy_~#dst.base)|
 |ray_(select #length cstpncpy_~#dst.base)|) 0)
 (* (+ |honda_cstpncpy_#t~post4.base| |ray_cstpncpy_#t~post4.base|) 0)
 (*
 (+ |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)|
 |ray_(ite (select #valid cstpncpy_~#dst.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) cstpncpy_#in~dst.base)|
 |ray_(select old(#length) cstpncpy_#in~dst.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)|
 |ray_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)|) 0)
 (* (+ |honda_cstpncpy_#t~post5.offset| |ray_cstpncpy_#t~post5.offset|) 0)
 (*
 (+ |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)|
 |ray_(ite (select #valid cstpncpy_#in~src.base) 1 0)|) 0)
 (* (+ |honda_cstpncpy_#in~dst.offset| |ray_cstpncpy_#in~dst.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)|
 |ray_(ite (select #valid cstpncpy_~s~3.base) 1 0)|) 0)
 (* (+ honda_cstpncpy_~src.base ray_cstpncpy_~src.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ honda_cstpncpy_~d~3.offset ray_cstpncpy_~d~3.offset) 0)
 (* (+ |honda_cstpncpy_#t~post3| |ray_cstpncpy_#t~post3|) 0)
 (* (+ |honda_cstpncpy_~#dst.base| |ray_cstpncpy_~#dst.base|) 0)
 (* (+ honda_cstpncpy_~src.offset ray_cstpncpy_~src.offset) 0)
 (* (+ |honda_cstpncpy_#in~src.base| |ray_cstpncpy_#in~src.base|) 0)
 (*
 (+
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 |ray_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)|
 |ray_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)|) 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0) 
 (* honda_cstpncpy_~d~3.base 0) 
 (* |honda_cstpncpy_#t~post5.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* aux_3727 1) 0) 0)
 (>=
 (+ (* (+ |honda_cstpncpy_#t~mem0.offset| |ray_cstpncpy_#t~mem0.offset|) 0)
 (*
 (+ |honda_(select #length cstpncpy_~d~3.base)|
 |ray_(select #length cstpncpy_~d~3.base)|) 1)
 (* (+ |honda_cstpncpy_#t~post4.offset| |ray_cstpncpy_#t~post4.offset|) 0)
 (* (+ honda_cstpncpy_~s~3.offset ray_cstpncpy_~s~3.offset) 0)
 (*
 (+
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 |ray_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|)
 0)
 (*
 (+ |honda_(select old(#length) cstpncpy_#in~src.base)|
 |ray_(select old(#length) cstpncpy_#in~src.base)|) 0)
 (* (+ |honda_cstpncpy_~#dst.offset| |ray_cstpncpy_~#dst.offset|) 0)
 (*
 (+
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 |ray_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|)
 0) (* (+ |honda_cstpncpy_#t~mem7| |ray_cstpncpy_#t~mem7|) 0)
 (*
 (+
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 |ray_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|)
 0) (* (+ honda_cstpncpy_~d~3.base ray_cstpncpy_~d~3.base) 0)
 (*
 (+
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 |ray_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|)
 0)
 (*
 (+ |honda_(select #length cstpncpy_#in~src.base)|
 |ray_(select #length cstpncpy_#in~src.base)|) 0)
 (* (+ |honda_cstpncpy_#in~src.offset| |ray_cstpncpy_#in~src.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)|
 |ray_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)|) 0)
 (* (+ |honda_cstpncpy_#t~mem1.offset| |ray_cstpncpy_#t~mem1.offset|) 0)
 (*
 (+ |honda_(select #length cstpncpy_#in~dst.base)|
 |ray_(select #length cstpncpy_#in~dst.base)|) 0)
 (* (+ |honda_cstpncpy_#t~mem0.base| |ray_cstpncpy_#t~mem0.base|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 |ray_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|)
 0) (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_cstpncpy_#in~n| |ray_cstpncpy_#in~n|) 0)
 (* (+ |honda_cstpncpy_#t~mem1.base| |ray_cstpncpy_#t~mem1.base|) 0)
 (* (+ |honda_cstpncpy_#t~post5.base| |ray_cstpncpy_#t~post5.base|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(select old(#length) cstpncpy_~#dst.base)|
 |ray_(select old(#length) cstpncpy_~#dst.base)|) 0)
 (*
 (+ |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)|
 |ray_(ite (select #valid cstpncpy_~d~3.base) 1 0)|) 0)
 (* (+ honda_cstpncpy_~s~3.base ray_cstpncpy_~s~3.base) 0)
 (*
 (+
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 |ray_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|)
 0)
 (*
 (+ |honda_(select #length cstpncpy_~s~3.base)|
 |ray_(select #length cstpncpy_~s~3.base)|) 0)
 (* (+ honda_cstpncpy_~n ray_cstpncpy_~n) 0)
 (* (+ |honda_cstpncpy_#in~dst.base| |ray_cstpncpy_#in~dst.base|) 0)
 (*
 (+ |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)|
 |ray_(ite (select #valid cstpncpy_#in~dst.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length cstpncpy_~#dst.base)|
 |ray_(select #length cstpncpy_~#dst.base)|) 0)
 (* (+ |honda_cstpncpy_#t~post4.base| |ray_cstpncpy_#t~post4.base|) 0)
 (*
 (+ |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)|
 |ray_(ite (select #valid cstpncpy_~#dst.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) cstpncpy_#in~dst.base)|
 |ray_(select old(#length) cstpncpy_#in~dst.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)|
 |ray_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)|) 0)
 (* (+ |honda_cstpncpy_#t~post5.offset| |ray_cstpncpy_#t~post5.offset|) 0)
 (*
 (+ |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)|
 |ray_(ite (select #valid cstpncpy_#in~src.base) 1 0)|) 0)
 (* (+ |honda_cstpncpy_#in~dst.offset| |ray_cstpncpy_#in~dst.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)|
 |ray_(ite (select #valid cstpncpy_~s~3.base) 1 0)|) 0)
 (* (+ honda_cstpncpy_~src.base ray_cstpncpy_~src.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ honda_cstpncpy_~d~3.offset ray_cstpncpy_~d~3.offset) 0)
 (* (+ |honda_cstpncpy_#t~post3| |ray_cstpncpy_#t~post3|) 0)
 (* (+ |honda_cstpncpy_~#dst.base| |ray_cstpncpy_~#dst.base|) 0)
 (* (+ honda_cstpncpy_~src.offset ray_cstpncpy_~src.offset) 0)
 (* (+ |honda_cstpncpy_#in~src.base| |ray_cstpncpy_#in~src.base|) 0)
 (*
 (+
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 |ray_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)|
 |ray_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)|) 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| (- 1))
 (* |honda_cstpncpy_#t~post4.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0) 
 (* honda_cstpncpy_~d~3.base 0) 
 (* |honda_cstpncpy_#t~post5.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 0) 0)
 (>=
 (+ (* (+ |honda_cstpncpy_#t~mem0.offset| |ray_cstpncpy_#t~mem0.offset|) 0)
 (*
 (+ |honda_(select #length cstpncpy_~d~3.base)|
 |ray_(select #length cstpncpy_~d~3.base)|) 0)
 (* (+ |honda_cstpncpy_#t~post4.offset| |ray_cstpncpy_#t~post4.offset|) 0)
 (* (+ honda_cstpncpy_~s~3.offset ray_cstpncpy_~s~3.offset) 0)
 (*
 (+
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 |ray_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|)
 0)
 (*
 (+ |honda_(select old(#length) cstpncpy_#in~src.base)|
 |ray_(select old(#length) cstpncpy_#in~src.base)|) 0)
 (* (+ |honda_cstpncpy_~#dst.offset| |ray_cstpncpy_~#dst.offset|) 0)
 (*
 (+
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 |ray_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|)
 0) (* (+ |honda_cstpncpy_#t~mem7| |ray_cstpncpy_#t~mem7|) 0)
 (*
 (+
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 |ray_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|)
 0) (* (+ honda_cstpncpy_~d~3.base ray_cstpncpy_~d~3.base) 0)
 (*
 (+
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 |ray_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|)
 0)
 (*
 (+ |honda_(select #length cstpncpy_#in~src.base)|
 |ray_(select #length cstpncpy_#in~src.base)|) 0)
 (* (+ |honda_cstpncpy_#in~src.offset| |ray_cstpncpy_#in~src.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)|
 |ray_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)|) 0)
 (* (+ |honda_cstpncpy_#t~mem1.offset| |ray_cstpncpy_#t~mem1.offset|) 0)
 (*
 (+ |honda_(select #length cstpncpy_#in~dst.base)|
 |ray_(select #length cstpncpy_#in~dst.base)|) 0)
 (* (+ |honda_cstpncpy_#t~mem0.base| |ray_cstpncpy_#t~mem0.base|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 |ray_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|)
 0) (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_cstpncpy_#in~n| |ray_cstpncpy_#in~n|) 0)
 (* (+ |honda_cstpncpy_#t~mem1.base| |ray_cstpncpy_#t~mem1.base|) 0)
 (* (+ |honda_cstpncpy_#t~post5.base| |ray_cstpncpy_#t~post5.base|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(select old(#length) cstpncpy_~#dst.base)|
 |ray_(select old(#length) cstpncpy_~#dst.base)|) 0)
 (*
 (+ |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)|
 |ray_(ite (select #valid cstpncpy_~d~3.base) 1 0)|) 0)
 (* (+ honda_cstpncpy_~s~3.base ray_cstpncpy_~s~3.base) (- 1))
 (*
 (+
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 |ray_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|)
 0)
 (*
 (+ |honda_(select #length cstpncpy_~s~3.base)|
 |ray_(select #length cstpncpy_~s~3.base)|) 0)
 (* (+ honda_cstpncpy_~n ray_cstpncpy_~n) 0)
 (* (+ |honda_cstpncpy_#in~dst.base| |ray_cstpncpy_#in~dst.base|) 0)
 (*
 (+ |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)|
 |ray_(ite (select #valid cstpncpy_#in~dst.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length cstpncpy_~#dst.base)|
 |ray_(select #length cstpncpy_~#dst.base)|) 0)
 (* (+ |honda_cstpncpy_#t~post4.base| |ray_cstpncpy_#t~post4.base|) 0)
 (*
 (+ |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)|
 |ray_(ite (select #valid cstpncpy_~#dst.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) cstpncpy_#in~dst.base)|
 |ray_(select old(#length) cstpncpy_#in~dst.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)|
 |ray_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)|) 0)
 (* (+ |honda_cstpncpy_#t~post5.offset| |ray_cstpncpy_#t~post5.offset|) 0)
 (*
 (+ |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)|
 |ray_(ite (select #valid cstpncpy_#in~src.base) 1 0)|) 0)
 (* (+ |honda_cstpncpy_#in~dst.offset| |ray_cstpncpy_#in~dst.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)|
 |ray_(ite (select #valid cstpncpy_~s~3.base) 1 0)|) 0)
 (* (+ honda_cstpncpy_~src.base ray_cstpncpy_~src.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ honda_cstpncpy_~d~3.offset ray_cstpncpy_~d~3.offset) 0)
 (* (+ |honda_cstpncpy_#t~post3| |ray_cstpncpy_#t~post3|) 0)
 (* (+ |honda_cstpncpy_~#dst.base| |ray_cstpncpy_~#dst.base|) 0)
 (* (+ honda_cstpncpy_~src.offset ray_cstpncpy_~src.offset) 0)
 (* (+ |honda_cstpncpy_#in~src.base| |ray_cstpncpy_#in~src.base|) 0)
 (*
 (+
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 |ray_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)|
 |ray_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)|) 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0) 
 (* honda_cstpncpy_~d~3.base 0) 
 (* |honda_cstpncpy_#t~post5.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (* honda_cstpncpy_~s~3.base 1)
 (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 0) 0)
 (>=
 (+ (* (+ |honda_cstpncpy_#t~mem0.offset| |ray_cstpncpy_#t~mem0.offset|) 0)
 (*
 (+ |honda_(select #length cstpncpy_~d~3.base)|
 |ray_(select #length cstpncpy_~d~3.base)|) 0)
 (* (+ |honda_cstpncpy_#t~post4.offset| |ray_cstpncpy_#t~post4.offset|) 0)
 (* (+ honda_cstpncpy_~s~3.offset ray_cstpncpy_~s~3.offset) 1)
 (*
 (+
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 |ray_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|)
 0)
 (*
 (+ |honda_(select old(#length) cstpncpy_#in~src.base)|
 |ray_(select old(#length) cstpncpy_#in~src.base)|) 0)
 (* (+ |honda_cstpncpy_~#dst.offset| |ray_cstpncpy_~#dst.offset|) 0)
 (*
 (+
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 |ray_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|)
 0) (* (+ |honda_cstpncpy_#t~mem7| |ray_cstpncpy_#t~mem7|) 0)
 (*
 (+
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 |ray_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|)
 0) (* (+ honda_cstpncpy_~d~3.base ray_cstpncpy_~d~3.base) 0)
 (*
 (+
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 |ray_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|)
 0)
 (*
 (+ |honda_(select #length cstpncpy_#in~src.base)|
 |ray_(select #length cstpncpy_#in~src.base)|) 0)
 (* (+ |honda_cstpncpy_#in~src.offset| |ray_cstpncpy_#in~src.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)|
 |ray_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)|) 0)
 (* (+ |honda_cstpncpy_#t~mem1.offset| |ray_cstpncpy_#t~mem1.offset|) 0)
 (*
 (+ |honda_(select #length cstpncpy_#in~dst.base)|
 |ray_(select #length cstpncpy_#in~dst.base)|) 0)
 (* (+ |honda_cstpncpy_#t~mem0.base| |ray_cstpncpy_#t~mem0.base|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 |ray_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|)
 0) (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_cstpncpy_#in~n| |ray_cstpncpy_#in~n|) 0)
 (* (+ |honda_cstpncpy_#t~mem1.base| |ray_cstpncpy_#t~mem1.base|) 0)
 (* (+ |honda_cstpncpy_#t~post5.base| |ray_cstpncpy_#t~post5.base|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(select old(#length) cstpncpy_~#dst.base)|
 |ray_(select old(#length) cstpncpy_~#dst.base)|) 0)
 (*
 (+ |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)|
 |ray_(ite (select #valid cstpncpy_~d~3.base) 1 0)|) 0)
 (* (+ honda_cstpncpy_~s~3.base ray_cstpncpy_~s~3.base) 0)
 (*
 (+
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 |ray_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|)
 0)
 (*
 (+ |honda_(select #length cstpncpy_~s~3.base)|
 |ray_(select #length cstpncpy_~s~3.base)|) 0)
 (* (+ honda_cstpncpy_~n ray_cstpncpy_~n) 0)
 (* (+ |honda_cstpncpy_#in~dst.base| |ray_cstpncpy_#in~dst.base|) 0)
 (*
 (+ |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)|
 |ray_(ite (select #valid cstpncpy_#in~dst.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length cstpncpy_~#dst.base)|
 |ray_(select #length cstpncpy_~#dst.base)|) 0)
 (* (+ |honda_cstpncpy_#t~post4.base| |ray_cstpncpy_#t~post4.base|) 0)
 (*
 (+ |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)|
 |ray_(ite (select #valid cstpncpy_~#dst.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) cstpncpy_#in~dst.base)|
 |ray_(select old(#length) cstpncpy_#in~dst.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)|
 |ray_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)|) 0)
 (* (+ |honda_cstpncpy_#t~post5.offset| |ray_cstpncpy_#t~post5.offset|) 0)
 (*
 (+ |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)|
 |ray_(ite (select #valid cstpncpy_#in~src.base) 1 0)|) 0)
 (* (+ |honda_cstpncpy_#in~dst.offset| |ray_cstpncpy_#in~dst.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)|
 |ray_(ite (select #valid cstpncpy_~s~3.base) 1 0)|) 0)
 (* (+ honda_cstpncpy_~src.base ray_cstpncpy_~src.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ honda_cstpncpy_~d~3.offset ray_cstpncpy_~d~3.offset) 0)
 (* (+ |honda_cstpncpy_#t~post3| |ray_cstpncpy_#t~post3|) 0)
 (* (+ |honda_cstpncpy_~#dst.base| |ray_cstpncpy_~#dst.base|) 0)
 (* (+ honda_cstpncpy_~src.offset ray_cstpncpy_~src.offset) 0)
 (* (+ |honda_cstpncpy_#in~src.base| |ray_cstpncpy_#in~src.base|) 0)
 (*
 (+
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 |ray_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)|
 |ray_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)|) 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0) 
 (* honda_cstpncpy_~s~3.offset (- 1))
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0) 
 (* honda_cstpncpy_~d~3.base 0) 
 (* |honda_cstpncpy_#t~post5.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (- 1)) 0)
 (>=
 (+ (* (+ |honda_cstpncpy_#t~mem0.offset| |ray_cstpncpy_#t~mem0.offset|) 0)
 (*
 (+ |honda_(select #length cstpncpy_~d~3.base)|
 |ray_(select #length cstpncpy_~d~3.base)|) 0)
 (* (+ |honda_cstpncpy_#t~post4.offset| |ray_cstpncpy_#t~post4.offset|) 0)
 (* (+ honda_cstpncpy_~s~3.offset ray_cstpncpy_~s~3.offset) 0)
 (*
 (+
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 |ray_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|)
 0)
 (*
 (+ |honda_(select old(#length) cstpncpy_#in~src.base)|
 |ray_(select old(#length) cstpncpy_#in~src.base)|) 0)
 (* (+ |honda_cstpncpy_~#dst.offset| |ray_cstpncpy_~#dst.offset|) 0)
 (*
 (+
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 |ray_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|)
 0) (* (+ |honda_cstpncpy_#t~mem7| |ray_cstpncpy_#t~mem7|) 0)
 (*
 (+
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 |ray_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|)
 0) (* (+ honda_cstpncpy_~d~3.base ray_cstpncpy_~d~3.base) 0)
 (*
 (+
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 |ray_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|)
 0)
 (*
 (+ |honda_(select #length cstpncpy_#in~src.base)|
 |ray_(select #length cstpncpy_#in~src.base)|) 0)
 (* (+ |honda_cstpncpy_#in~src.offset| |ray_cstpncpy_#in~src.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)|
 |ray_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)|) 0)
 (* (+ |honda_cstpncpy_#t~mem1.offset| |ray_cstpncpy_#t~mem1.offset|) 0)
 (*
 (+ |honda_(select #length cstpncpy_#in~dst.base)|
 |ray_(select #length cstpncpy_#in~dst.base)|) 0)
 (* (+ |honda_cstpncpy_#t~mem0.base| |ray_cstpncpy_#t~mem0.base|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 |ray_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|)
 0) (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_cstpncpy_#in~n| |ray_cstpncpy_#in~n|) 0)
 (* (+ |honda_cstpncpy_#t~mem1.base| |ray_cstpncpy_#t~mem1.base|) 0)
 (* (+ |honda_cstpncpy_#t~post5.base| |ray_cstpncpy_#t~post5.base|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(select old(#length) cstpncpy_~#dst.base)|
 |ray_(select old(#length) cstpncpy_~#dst.base)|) 0)
 (*
 (+ |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)|
 |ray_(ite (select #valid cstpncpy_~d~3.base) 1 0)|) 0)
 (* (+ honda_cstpncpy_~s~3.base ray_cstpncpy_~s~3.base) 0)
 (*
 (+
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 |ray_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|)
 0)
 (*
 (+ |honda_(select #length cstpncpy_~s~3.base)|
 |ray_(select #length cstpncpy_~s~3.base)|) 0)
 (* (+ honda_cstpncpy_~n ray_cstpncpy_~n) 0)
 (* (+ |honda_cstpncpy_#in~dst.base| |ray_cstpncpy_#in~dst.base|) 0)
 (*
 (+ |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)|
 |ray_(ite (select #valid cstpncpy_#in~dst.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length cstpncpy_~#dst.base)|
 |ray_(select #length cstpncpy_~#dst.base)|) 0)
 (* (+ |honda_cstpncpy_#t~post4.base| |ray_cstpncpy_#t~post4.base|) 0)
 (*
 (+ |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)|
 |ray_(ite (select #valid cstpncpy_~#dst.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) cstpncpy_#in~dst.base)|
 |ray_(select old(#length) cstpncpy_#in~dst.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)|
 |ray_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)|) 0)
 (* (+ |honda_cstpncpy_#t~post5.offset| |ray_cstpncpy_#t~post5.offset|) 0)
 (*
 (+ |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)|
 |ray_(ite (select #valid cstpncpy_#in~src.base) 1 0)|) 0)
 (* (+ |honda_cstpncpy_#in~dst.offset| |ray_cstpncpy_#in~dst.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)|
 |ray_(ite (select #valid cstpncpy_~s~3.base) 1 0)|) 0)
 (* (+ honda_cstpncpy_~src.base ray_cstpncpy_~src.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ honda_cstpncpy_~d~3.offset ray_cstpncpy_~d~3.offset) 0)
 (* (+ |honda_cstpncpy_#t~post3| |ray_cstpncpy_#t~post3|) 0)
 (* (+ |honda_cstpncpy_~#dst.base| |ray_cstpncpy_~#dst.base|) 0)
 (* (+ honda_cstpncpy_~src.offset ray_cstpncpy_~src.offset) 0)
 (* (+ |honda_cstpncpy_#in~src.base| |ray_cstpncpy_#in~src.base|) 0)
 (*
 (+
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 |ray_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)|
 |ray_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)|) 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0) 
 (* honda_cstpncpy_~d~3.base 0) 
 (* |honda_cstpncpy_#t~post5.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 1)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (- 1)) 0)
 (>=
 (+ (* (+ |honda_cstpncpy_#t~mem0.offset| |ray_cstpncpy_#t~mem0.offset|) 0)
 (*
 (+ |honda_(select #length cstpncpy_~d~3.base)|
 |ray_(select #length cstpncpy_~d~3.base)|) 0)
 (* (+ |honda_cstpncpy_#t~post4.offset| |ray_cstpncpy_#t~post4.offset|) 0)
 (* (+ honda_cstpncpy_~s~3.offset ray_cstpncpy_~s~3.offset) 0)
 (*
 (+
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 |ray_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|)
 0)
 (*
 (+ |honda_(select old(#length) cstpncpy_#in~src.base)|
 |ray_(select old(#length) cstpncpy_#in~src.base)|) 0)
 (* (+ |honda_cstpncpy_~#dst.offset| |ray_cstpncpy_~#dst.offset|) 0)
 (*
 (+
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 |ray_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|)
 0) (* (+ |honda_cstpncpy_#t~mem7| |ray_cstpncpy_#t~mem7|) 0)
 (*
 (+
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 |ray_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|)
 0) (* (+ honda_cstpncpy_~d~3.base ray_cstpncpy_~d~3.base) 0)
 (*
 (+
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 |ray_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|)
 0)
 (*
 (+ |honda_(select #length cstpncpy_#in~src.base)|
 |ray_(select #length cstpncpy_#in~src.base)|) 0)
 (* (+ |honda_cstpncpy_#in~src.offset| |ray_cstpncpy_#in~src.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)|
 |ray_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)|) 0)
 (* (+ |honda_cstpncpy_#t~mem1.offset| |ray_cstpncpy_#t~mem1.offset|) 0)
 (*
 (+ |honda_(select #length cstpncpy_#in~dst.base)|
 |ray_(select #length cstpncpy_#in~dst.base)|) 0)
 (* (+ |honda_cstpncpy_#t~mem0.base| |ray_cstpncpy_#t~mem0.base|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 |ray_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|)
 0) (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_cstpncpy_#in~n| |ray_cstpncpy_#in~n|) 0)
 (* (+ |honda_cstpncpy_#t~mem1.base| |ray_cstpncpy_#t~mem1.base|) 0)
 (* (+ |honda_cstpncpy_#t~post5.base| |ray_cstpncpy_#t~post5.base|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(select old(#length) cstpncpy_~#dst.base)|
 |ray_(select old(#length) cstpncpy_~#dst.base)|) 0)
 (*
 (+ |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)|
 |ray_(ite (select #valid cstpncpy_~d~3.base) 1 0)|) 0)
 (* (+ honda_cstpncpy_~s~3.base ray_cstpncpy_~s~3.base) 0)
 (*
 (+
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 |ray_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|)
 0)
 (*
 (+ |honda_(select #length cstpncpy_~s~3.base)|
 |ray_(select #length cstpncpy_~s~3.base)|) 0)
 (* (+ honda_cstpncpy_~n ray_cstpncpy_~n) 1)
 (* (+ |honda_cstpncpy_#in~dst.base| |ray_cstpncpy_#in~dst.base|) 0)
 (*
 (+ |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)|
 |ray_(ite (select #valid cstpncpy_#in~dst.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length cstpncpy_~#dst.base)|
 |ray_(select #length cstpncpy_~#dst.base)|) 0)
 (* (+ |honda_cstpncpy_#t~post4.base| |ray_cstpncpy_#t~post4.base|) 0)
 (*
 (+ |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)|
 |ray_(ite (select #valid cstpncpy_~#dst.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) cstpncpy_#in~dst.base)|
 |ray_(select old(#length) cstpncpy_#in~dst.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)|
 |ray_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)|) 0)
 (* (+ |honda_cstpncpy_#t~post5.offset| |ray_cstpncpy_#t~post5.offset|) 0)
 (*
 (+ |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)|
 |ray_(ite (select #valid cstpncpy_#in~src.base) 1 0)|) 0)
 (* (+ |honda_cstpncpy_#in~dst.offset| |ray_cstpncpy_#in~dst.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)|
 |ray_(ite (select #valid cstpncpy_~s~3.base) 1 0)|) 0)
 (* (+ honda_cstpncpy_~src.base ray_cstpncpy_~src.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ honda_cstpncpy_~d~3.offset ray_cstpncpy_~d~3.offset) 0)
 (* (+ |honda_cstpncpy_#t~post3| |ray_cstpncpy_#t~post3|) 0)
 (* (+ |honda_cstpncpy_~#dst.base| |ray_cstpncpy_~#dst.base|) 0)
 (* (+ honda_cstpncpy_~src.offset ray_cstpncpy_~src.offset) 0)
 (* (+ |honda_cstpncpy_#in~src.base| |ray_cstpncpy_#in~src.base|) 0)
 (*
 (+
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 |ray_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)|
 |ray_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)|) 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0) 
 (* honda_cstpncpy_~d~3.base 0) 
 (* |honda_cstpncpy_#t~post5.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(select #length cstpncpy_~s~3.base)| 0)
 (* honda_cstpncpy_~n (- 1)) 
 (* |honda_cstpncpy_#t~post4.base| 0) 
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 1) 0)
 (>=
 (+ (* (+ |honda_cstpncpy_#t~mem0.offset| |ray_cstpncpy_#t~mem0.offset|) 0)
 (*
 (+ |honda_(select #length cstpncpy_~d~3.base)|
 |ray_(select #length cstpncpy_~d~3.base)|) 0)
 (* (+ |honda_cstpncpy_#t~post4.offset| |ray_cstpncpy_#t~post4.offset|) 0)
 (* (+ honda_cstpncpy_~s~3.offset ray_cstpncpy_~s~3.offset) 0)
 (*
 (+
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 |ray_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|)
 0)
 (*
 (+ |honda_(select old(#length) cstpncpy_#in~src.base)|
 |ray_(select old(#length) cstpncpy_#in~src.base)|) 0)
 (* (+ |honda_cstpncpy_~#dst.offset| |ray_cstpncpy_~#dst.offset|) 0)
 (*
 (+
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 |ray_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|)
 0) (* (+ |honda_cstpncpy_#t~mem7| |ray_cstpncpy_#t~mem7|) 0)
 (*
 (+
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 |ray_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|)
 0) (* (+ honda_cstpncpy_~d~3.base ray_cstpncpy_~d~3.base) 0)
 (*
 (+
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 |ray_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|)
 0)
 (*
 (+ |honda_(select #length cstpncpy_#in~src.base)|
 |ray_(select #length cstpncpy_#in~src.base)|) 0)
 (* (+ |honda_cstpncpy_#in~src.offset| |ray_cstpncpy_#in~src.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)|
 |ray_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)|) 0)
 (* (+ |honda_cstpncpy_#t~mem1.offset| |ray_cstpncpy_#t~mem1.offset|) 0)
 (*
 (+ |honda_(select #length cstpncpy_#in~dst.base)|
 |ray_(select #length cstpncpy_#in~dst.base)|) 0)
 (* (+ |honda_cstpncpy_#t~mem0.base| |ray_cstpncpy_#t~mem0.base|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 |ray_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|)
 0) (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_cstpncpy_#in~n| |ray_cstpncpy_#in~n|) 0)
 (* (+ |honda_cstpncpy_#t~mem1.base| |ray_cstpncpy_#t~mem1.base|) 0)
 (* (+ |honda_cstpncpy_#t~post5.base| |ray_cstpncpy_#t~post5.base|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(select old(#length) cstpncpy_~#dst.base)|
 |ray_(select old(#length) cstpncpy_~#dst.base)|) 0)
 (*
 (+ |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)|
 |ray_(ite (select #valid cstpncpy_~d~3.base) 1 0)|) 0)
 (* (+ honda_cstpncpy_~s~3.base ray_cstpncpy_~s~3.base) 0)
 (*
 (+
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 |ray_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|)
 0)
 (*
 (+ |honda_(select #length cstpncpy_~s~3.base)|
 |ray_(select #length cstpncpy_~s~3.base)|) 1)
 (* (+ honda_cstpncpy_~n ray_cstpncpy_~n) 0)
 (* (+ |honda_cstpncpy_#in~dst.base| |ray_cstpncpy_#in~dst.base|) 0)
 (*
 (+ |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)|
 |ray_(ite (select #valid cstpncpy_#in~dst.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length cstpncpy_~#dst.base)|
 |ray_(select #length cstpncpy_~#dst.base)|) 0)
 (* (+ |honda_cstpncpy_#t~post4.base| |ray_cstpncpy_#t~post4.base|) 0)
 (*
 (+ |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)|
 |ray_(ite (select #valid cstpncpy_~#dst.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) cstpncpy_#in~dst.base)|
 |ray_(select old(#length) cstpncpy_#in~dst.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)|
 |ray_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)|) 0)
 (* (+ |honda_cstpncpy_#t~post5.offset| |ray_cstpncpy_#t~post5.offset|) 0)
 (*
 (+ |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)|
 |ray_(ite (select #valid cstpncpy_#in~src.base) 1 0)|) 0)
 (* (+ |honda_cstpncpy_#in~dst.offset| |ray_cstpncpy_#in~dst.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)|
 |ray_(ite (select #valid cstpncpy_~s~3.base) 1 0)|) 0)
 (* (+ honda_cstpncpy_~src.base ray_cstpncpy_~src.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ honda_cstpncpy_~d~3.offset ray_cstpncpy_~d~3.offset) 0)
 (* (+ |honda_cstpncpy_#t~post3| |ray_cstpncpy_#t~post3|) 0)
 (* (+ |honda_cstpncpy_~#dst.base| |ray_cstpncpy_~#dst.base|) 0)
 (* (+ honda_cstpncpy_~src.offset ray_cstpncpy_~src.offset) 0)
 (* (+ |honda_cstpncpy_#in~src.base| |ray_cstpncpy_#in~src.base|) 0)
 (*
 (+
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 |ray_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)|
 |ray_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)|) 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0) 
 (* honda_cstpncpy_~d~3.base 0) 
 (* |honda_cstpncpy_#t~post5.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(select #length cstpncpy_~s~3.base)| (- 1))
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 0) 0)
 (>=
 (+ (* (+ |honda_cstpncpy_#t~mem0.offset| |ray_cstpncpy_#t~mem0.offset|) 0)
 (*
 (+ |honda_(select #length cstpncpy_~d~3.base)|
 |ray_(select #length cstpncpy_~d~3.base)|) 0)
 (* (+ |honda_cstpncpy_#t~post4.offset| |ray_cstpncpy_#t~post4.offset|) 0)
 (* (+ honda_cstpncpy_~s~3.offset ray_cstpncpy_~s~3.offset) 0)
 (*
 (+
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 |ray_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|)
 0)
 (*
 (+ |honda_(select old(#length) cstpncpy_#in~src.base)|
 |ray_(select old(#length) cstpncpy_#in~src.base)|) 0)
 (* (+ |honda_cstpncpy_~#dst.offset| |ray_cstpncpy_~#dst.offset|) 0)
 (*
 (+
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 |ray_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|)
 0) (* (+ |honda_cstpncpy_#t~mem7| |ray_cstpncpy_#t~mem7|) 0)
 (*
 (+
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 |ray_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|)
 0) (* (+ honda_cstpncpy_~d~3.base ray_cstpncpy_~d~3.base) 0)
 (*
 (+
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 |ray_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|)
 0)
 (*
 (+ |honda_(select #length cstpncpy_#in~src.base)|
 |ray_(select #length cstpncpy_#in~src.base)|) 0)
 (* (+ |honda_cstpncpy_#in~src.offset| |ray_cstpncpy_#in~src.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)|
 |ray_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)|) 0)
 (* (+ |honda_cstpncpy_#t~mem1.offset| |ray_cstpncpy_#t~mem1.offset|) 0)
 (*
 (+ |honda_(select #length cstpncpy_#in~dst.base)|
 |ray_(select #length cstpncpy_#in~dst.base)|) 0)
 (* (+ |honda_cstpncpy_#t~mem0.base| |ray_cstpncpy_#t~mem0.base|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 |ray_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|)
 0) (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_cstpncpy_#in~n| |ray_cstpncpy_#in~n|) 0)
 (* (+ |honda_cstpncpy_#t~mem1.base| |ray_cstpncpy_#t~mem1.base|) 0)
 (* (+ |honda_cstpncpy_#t~post5.base| |ray_cstpncpy_#t~post5.base|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(select old(#length) cstpncpy_~#dst.base)|
 |ray_(select old(#length) cstpncpy_~#dst.base)|) 0)
 (*
 (+ |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)|
 |ray_(ite (select #valid cstpncpy_~d~3.base) 1 0)|) 0)
 (* (+ honda_cstpncpy_~s~3.base ray_cstpncpy_~s~3.base) 1)
 (*
 (+
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 |ray_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|)
 0)
 (*
 (+ |honda_(select #length cstpncpy_~s~3.base)|
 |ray_(select #length cstpncpy_~s~3.base)|) 0)
 (* (+ honda_cstpncpy_~n ray_cstpncpy_~n) 0)
 (* (+ |honda_cstpncpy_#in~dst.base| |ray_cstpncpy_#in~dst.base|) 0)
 (*
 (+ |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)|
 |ray_(ite (select #valid cstpncpy_#in~dst.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length cstpncpy_~#dst.base)|
 |ray_(select #length cstpncpy_~#dst.base)|) 0)
 (* (+ |honda_cstpncpy_#t~post4.base| |ray_cstpncpy_#t~post4.base|) 0)
 (*
 (+ |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)|
 |ray_(ite (select #valid cstpncpy_~#dst.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) cstpncpy_#in~dst.base)|
 |ray_(select old(#length) cstpncpy_#in~dst.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)|
 |ray_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)|) 0)
 (* (+ |honda_cstpncpy_#t~post5.offset| |ray_cstpncpy_#t~post5.offset|) 0)
 (*
 (+ |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)|
 |ray_(ite (select #valid cstpncpy_#in~src.base) 1 0)|) 0)
 (* (+ |honda_cstpncpy_#in~dst.offset| |ray_cstpncpy_#in~dst.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)|
 |ray_(ite (select #valid cstpncpy_~s~3.base) 1 0)|) 0)
 (* (+ honda_cstpncpy_~src.base ray_cstpncpy_~src.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ honda_cstpncpy_~d~3.offset ray_cstpncpy_~d~3.offset) 0)
 (* (+ |honda_cstpncpy_#t~post3| |ray_cstpncpy_#t~post3|) 0)
 (* (+ |honda_cstpncpy_~#dst.base| |ray_cstpncpy_~#dst.base|) 0)
 (* (+ honda_cstpncpy_~src.offset ray_cstpncpy_~src.offset) 0)
 (* (+ |honda_cstpncpy_#in~src.base| |ray_cstpncpy_#in~src.base|) 0)
 (*
 (+
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 |ray_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)|
 |ray_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)|) 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0) 
 (* honda_cstpncpy_~d~3.base 0) 
 (* |honda_cstpncpy_#t~post5.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (* honda_cstpncpy_~s~3.base (- 1))
 (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 0) 0)
 (>=
 (+ (* (+ |honda_cstpncpy_#t~mem0.offset| |ray_cstpncpy_#t~mem0.offset|) 0)
 (*
 (+ |honda_(select #length cstpncpy_~d~3.base)|
 |ray_(select #length cstpncpy_~d~3.base)|) 0)
 (* (+ |honda_cstpncpy_#t~post4.offset| |ray_cstpncpy_#t~post4.offset|) 0)
 (* (+ honda_cstpncpy_~s~3.offset ray_cstpncpy_~s~3.offset) 0)
 (*
 (+
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 |ray_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|)
 0)
 (*
 (+ |honda_(select old(#length) cstpncpy_#in~src.base)|
 |ray_(select old(#length) cstpncpy_#in~src.base)|) 0)
 (* (+ |honda_cstpncpy_~#dst.offset| |ray_cstpncpy_~#dst.offset|) 0)
 (*
 (+
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 |ray_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|)
 0) (* (+ |honda_cstpncpy_#t~mem7| |ray_cstpncpy_#t~mem7|) 0)
 (*
 (+
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 |ray_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|)
 0) (* (+ honda_cstpncpy_~d~3.base ray_cstpncpy_~d~3.base) 0)
 (*
 (+
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 |ray_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|)
 0)
 (*
 (+ |honda_(select #length cstpncpy_#in~src.base)|
 |ray_(select #length cstpncpy_#in~src.base)|) 0)
 (* (+ |honda_cstpncpy_#in~src.offset| |ray_cstpncpy_#in~src.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)|
 |ray_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)|) 0)
 (* (+ |honda_cstpncpy_#t~mem1.offset| |ray_cstpncpy_#t~mem1.offset|) 0)
 (*
 (+ |honda_(select #length cstpncpy_#in~dst.base)|
 |ray_(select #length cstpncpy_#in~dst.base)|) 0)
 (* (+ |honda_cstpncpy_#t~mem0.base| |ray_cstpncpy_#t~mem0.base|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 |ray_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|)
 0) (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_cstpncpy_#in~n| |ray_cstpncpy_#in~n|) 0)
 (* (+ |honda_cstpncpy_#t~mem1.base| |ray_cstpncpy_#t~mem1.base|) 0)
 (* (+ |honda_cstpncpy_#t~post5.base| |ray_cstpncpy_#t~post5.base|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(select old(#length) cstpncpy_~#dst.base)|
 |ray_(select old(#length) cstpncpy_~#dst.base)|) 0)
 (*
 (+ |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)|
 |ray_(ite (select #valid cstpncpy_~d~3.base) 1 0)|) 0)
 (* (+ honda_cstpncpy_~s~3.base ray_cstpncpy_~s~3.base) 0)
 (*
 (+
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 |ray_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|)
 0)
 (*
 (+ |honda_(select #length cstpncpy_~s~3.base)|
 |ray_(select #length cstpncpy_~s~3.base)|) 0)
 (* (+ honda_cstpncpy_~n ray_cstpncpy_~n) 0)
 (* (+ |honda_cstpncpy_#in~dst.base| |ray_cstpncpy_#in~dst.base|) 0)
 (*
 (+ |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)|
 |ray_(ite (select #valid cstpncpy_#in~dst.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length cstpncpy_~#dst.base)|
 |ray_(select #length cstpncpy_~#dst.base)|) 0)
 (* (+ |honda_cstpncpy_#t~post4.base| |ray_cstpncpy_#t~post4.base|) 0)
 (*
 (+ |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)|
 |ray_(ite (select #valid cstpncpy_~#dst.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) cstpncpy_#in~dst.base)|
 |ray_(select old(#length) cstpncpy_#in~dst.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)|
 |ray_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)|) 0)
 (* (+ |honda_cstpncpy_#t~post5.offset| |ray_cstpncpy_#t~post5.offset|) 0)
 (*
 (+ |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)|
 |ray_(ite (select #valid cstpncpy_#in~src.base) 1 0)|) 0)
 (* (+ |honda_cstpncpy_#in~dst.offset| |ray_cstpncpy_#in~dst.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)|
 |ray_(ite (select #valid cstpncpy_~s~3.base) 1 0)|) 0)
 (* (+ honda_cstpncpy_~src.base ray_cstpncpy_~src.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ honda_cstpncpy_~d~3.offset ray_cstpncpy_~d~3.offset) 0)
 (* (+ |honda_cstpncpy_#t~post3| |ray_cstpncpy_#t~post3|) 0)
 (* (+ |honda_cstpncpy_~#dst.base| |ray_cstpncpy_~#dst.base|) 0)
 (* (+ honda_cstpncpy_~src.offset ray_cstpncpy_~src.offset) 0)
 (* (+ |honda_cstpncpy_#in~src.base| |ray_cstpncpy_#in~src.base|) 0)
 (*
 (+
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 |ray_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)|
 |ray_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)|) 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 1)
 (* |honda_cstpncpy_#t~post4.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0) 
 (* honda_cstpncpy_~d~3.base 0) 
 (* |honda_cstpncpy_#t~post5.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset (- 1)) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (- 1)) 0)
 (>=
 (+ (* (+ |honda_cstpncpy_#t~mem0.offset| |ray_cstpncpy_#t~mem0.offset|) 0)
 (*
 (+ |honda_(select #length cstpncpy_~d~3.base)|
 |ray_(select #length cstpncpy_~d~3.base)|) 0)
 (* (+ |honda_cstpncpy_#t~post4.offset| |ray_cstpncpy_#t~post4.offset|) 0)
 (* (+ honda_cstpncpy_~s~3.offset ray_cstpncpy_~s~3.offset) 0)
 (*
 (+
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 |ray_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|)
 0)
 (*
 (+ |honda_(select old(#length) cstpncpy_#in~src.base)|
 |ray_(select old(#length) cstpncpy_#in~src.base)|) 0)
 (* (+ |honda_cstpncpy_~#dst.offset| |ray_cstpncpy_~#dst.offset|) 0)
 (*
 (+
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 |ray_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|)
 0) (* (+ |honda_cstpncpy_#t~mem7| |ray_cstpncpy_#t~mem7|) 0)
 (*
 (+
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 |ray_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|)
 0) (* (+ honda_cstpncpy_~d~3.base ray_cstpncpy_~d~3.base) 0)
 (*
 (+
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 |ray_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|)
 0)
 (*
 (+ |honda_(select #length cstpncpy_#in~src.base)|
 |ray_(select #length cstpncpy_#in~src.base)|) 0)
 (* (+ |honda_cstpncpy_#in~src.offset| |ray_cstpncpy_#in~src.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)|
 |ray_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)|) 0)
 (* (+ |honda_cstpncpy_#t~mem1.offset| |ray_cstpncpy_#t~mem1.offset|) 0)
 (*
 (+ |honda_(select #length cstpncpy_#in~dst.base)|
 |ray_(select #length cstpncpy_#in~dst.base)|) 0)
 (* (+ |honda_cstpncpy_#t~mem0.base| |ray_cstpncpy_#t~mem0.base|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 |ray_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|)
 0) (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_cstpncpy_#in~n| |ray_cstpncpy_#in~n|) 0)
 (* (+ |honda_cstpncpy_#t~mem1.base| |ray_cstpncpy_#t~mem1.base|) 0)
 (* (+ |honda_cstpncpy_#t~post5.base| |ray_cstpncpy_#t~post5.base|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(select old(#length) cstpncpy_~#dst.base)|
 |ray_(select old(#length) cstpncpy_~#dst.base)|) 0)
 (*
 (+ |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)|
 |ray_(ite (select #valid cstpncpy_~d~3.base) 1 0)|) 0)
 (* (+ honda_cstpncpy_~s~3.base ray_cstpncpy_~s~3.base) 0)
 (*
 (+
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 |ray_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|)
 0)
 (*
 (+ |honda_(select #length cstpncpy_~s~3.base)|
 |ray_(select #length cstpncpy_~s~3.base)|) 0)
 (* (+ honda_cstpncpy_~n ray_cstpncpy_~n) 0)
 (* (+ |honda_cstpncpy_#in~dst.base| |ray_cstpncpy_#in~dst.base|) 0)
 (*
 (+ |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)|
 |ray_(ite (select #valid cstpncpy_#in~dst.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length cstpncpy_~#dst.base)|
 |ray_(select #length cstpncpy_~#dst.base)|) 0)
 (* (+ |honda_cstpncpy_#t~post4.base| |ray_cstpncpy_#t~post4.base|) 0)
 (*
 (+ |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)|
 |ray_(ite (select #valid cstpncpy_~#dst.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) cstpncpy_#in~dst.base)|
 |ray_(select old(#length) cstpncpy_#in~dst.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)|
 |ray_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)|) 0)
 (* (+ |honda_cstpncpy_#t~post5.offset| |ray_cstpncpy_#t~post5.offset|) 0)
 (*
 (+ |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)|
 |ray_(ite (select #valid cstpncpy_#in~src.base) 1 0)|) 0)
 (* (+ |honda_cstpncpy_#in~dst.offset| |ray_cstpncpy_#in~dst.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)|
 |ray_(ite (select #valid cstpncpy_~s~3.base) 1 0)|) 0)
 (* (+ honda_cstpncpy_~src.base ray_cstpncpy_~src.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ honda_cstpncpy_~d~3.offset ray_cstpncpy_~d~3.offset) 0)
 (* (+ |honda_cstpncpy_#t~post3| |ray_cstpncpy_#t~post3|) 0)
 (* (+ |honda_cstpncpy_~#dst.base| |ray_cstpncpy_~#dst.base|) 0)
 (* (+ honda_cstpncpy_~src.offset ray_cstpncpy_~src.offset) 0)
 (* (+ |honda_cstpncpy_#in~src.base| |ray_cstpncpy_#in~src.base|) 0)
 (*
 (+
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 |ray_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)|
 |ray_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)|) 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0) 
 (* honda_cstpncpy_~d~3.base 0) 
 (* |honda_cstpncpy_#t~post5.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 1)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (- 1)) 0)
 (>=
 (+ (* (+ |honda_cstpncpy_#t~mem0.offset| |ray_cstpncpy_#t~mem0.offset|) 0)
 (*
 (+ |honda_(select #length cstpncpy_~d~3.base)|
 |ray_(select #length cstpncpy_~d~3.base)|) 0)
 (* (+ |honda_cstpncpy_#t~post4.offset| |ray_cstpncpy_#t~post4.offset|) 0)
 (* (+ honda_cstpncpy_~s~3.offset ray_cstpncpy_~s~3.offset) 0)
 (*
 (+
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 |ray_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|)
 0)
 (*
 (+ |honda_(select old(#length) cstpncpy_#in~src.base)|
 |ray_(select old(#length) cstpncpy_#in~src.base)|) 0)
 (* (+ |honda_cstpncpy_~#dst.offset| |ray_cstpncpy_~#dst.offset|) 0)
 (*
 (+
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 |ray_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|)
 0) (* (+ |honda_cstpncpy_#t~mem7| |ray_cstpncpy_#t~mem7|) 0)
 (*
 (+
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 |ray_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|)
 0) (* (+ honda_cstpncpy_~d~3.base ray_cstpncpy_~d~3.base) 0)
 (*
 (+
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 |ray_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|)
 0)
 (*
 (+ |honda_(select #length cstpncpy_#in~src.base)|
 |ray_(select #length cstpncpy_#in~src.base)|) 0)
 (* (+ |honda_cstpncpy_#in~src.offset| |ray_cstpncpy_#in~src.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)|
 |ray_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)|) 0)
 (* (+ |honda_cstpncpy_#t~mem1.offset| |ray_cstpncpy_#t~mem1.offset|) 0)
 (*
 (+ |honda_(select #length cstpncpy_#in~dst.base)|
 |ray_(select #length cstpncpy_#in~dst.base)|) 0)
 (* (+ |honda_cstpncpy_#t~mem0.base| |ray_cstpncpy_#t~mem0.base|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 |ray_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|)
 0) (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_cstpncpy_#in~n| |ray_cstpncpy_#in~n|) 0)
 (* (+ |honda_cstpncpy_#t~mem1.base| |ray_cstpncpy_#t~mem1.base|) 0)
 (* (+ |honda_cstpncpy_#t~post5.base| |ray_cstpncpy_#t~post5.base|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(select old(#length) cstpncpy_~#dst.base)|
 |ray_(select old(#length) cstpncpy_~#dst.base)|) 0)
 (*
 (+ |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)|
 |ray_(ite (select #valid cstpncpy_~d~3.base) 1 0)|) 0)
 (* (+ honda_cstpncpy_~s~3.base ray_cstpncpy_~s~3.base) 0)
 (*
 (+
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 |ray_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|)
 0)
 (*
 (+ |honda_(select #length cstpncpy_~s~3.base)|
 |ray_(select #length cstpncpy_~s~3.base)|) 0)
 (* (+ honda_cstpncpy_~n ray_cstpncpy_~n) 0)
 (* (+ |honda_cstpncpy_#in~dst.base| |ray_cstpncpy_#in~dst.base|) 0)
 (*
 (+ |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)|
 |ray_(ite (select #valid cstpncpy_#in~dst.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length cstpncpy_~#dst.base)|
 |ray_(select #length cstpncpy_~#dst.base)|) 0)
 (* (+ |honda_cstpncpy_#t~post4.base| |ray_cstpncpy_#t~post4.base|) 0)
 (*
 (+ |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)|
 |ray_(ite (select #valid cstpncpy_~#dst.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) cstpncpy_#in~dst.base)|
 |ray_(select old(#length) cstpncpy_#in~dst.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)|
 |ray_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)|) 0)
 (* (+ |honda_cstpncpy_#t~post5.offset| |ray_cstpncpy_#t~post5.offset|) 0)
 (*
 (+ |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)|
 |ray_(ite (select #valid cstpncpy_#in~src.base) 1 0)|) 0)
 (* (+ |honda_cstpncpy_#in~dst.offset| |ray_cstpncpy_#in~dst.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)|
 |ray_(ite (select #valid cstpncpy_~s~3.base) 1 0)|) 0)
 (* (+ honda_cstpncpy_~src.base ray_cstpncpy_~src.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ honda_cstpncpy_~d~3.offset ray_cstpncpy_~d~3.offset) 0)
 (* (+ |honda_cstpncpy_#t~post3| |ray_cstpncpy_#t~post3|) 0)
 (* (+ |honda_cstpncpy_~#dst.base| |ray_cstpncpy_~#dst.base|) 0)
 (* (+ honda_cstpncpy_~src.offset ray_cstpncpy_~src.offset) 0)
 (* (+ |honda_cstpncpy_#in~src.base| |ray_cstpncpy_#in~src.base|) 0)
 (*
 (+
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 |ray_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)|
 |ray_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)|) 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0) 
 (* honda_cstpncpy_~d~3.base 0) 
 (* |honda_cstpncpy_#t~post5.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* aux_3727 (- 1)) (* aux_3722 1) 
 (- 1)) 0)
 (= |ray_cstpncpy_#t~mem0.offset| (* |ray_cstpncpy_#t~mem0.offset| lambda))
 (=
 |ray_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 (*
 |ray_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 lambda))
 (= |ray_(select old(#length) cstpncpy_#in~src.base)|
 (* |ray_(select old(#length) cstpncpy_#in~src.base)| lambda))
 (= |ray_cstpncpy_~#dst.offset| (* |ray_cstpncpy_~#dst.offset| lambda))
 (=
 |ray_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 (*
 |ray_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 lambda))
 (=
 |ray_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 (*
 |ray_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 lambda))
 (= |ray_(select #length cstpncpy_#in~src.base)|
 (* |ray_(select #length cstpncpy_#in~src.base)| lambda))
 (= |ray_cstpncpy_#in~src.offset| (* |ray_cstpncpy_#in~src.offset| lambda))
 (= |ray_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)|
 (* |ray_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| lambda))
 (= |ray_cstpncpy_#t~mem1.offset| (* |ray_cstpncpy_#t~mem1.offset| lambda))
 (= |ray_(select #length cstpncpy_#in~dst.base)|
 (* |ray_(select #length cstpncpy_#in~dst.base)| lambda))
 (= |ray_cstpncpy_#t~mem0.base| (* |ray_cstpncpy_#t~mem0.base| lambda))
 (=
 |ray_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 (*
 |ray_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 lambda)) (= |ray_#NULL.offset| (* |ray_#NULL.offset| lambda))
 (= |ray_cstpncpy_#in~n| (* |ray_cstpncpy_#in~n| lambda))
 (= |ray_cstpncpy_#t~mem1.base| (* |ray_cstpncpy_#t~mem1.base| lambda))
 (= |ray_#NULL.base| (* |ray_#NULL.base| lambda))
 (= |ray_(select old(#length) cstpncpy_~#dst.base)|
 (* |ray_(select old(#length) cstpncpy_~#dst.base)| lambda))
 (=
 |ray_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 (*
 |ray_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 lambda))
 (= |ray_cstpncpy_#in~dst.base| (* |ray_cstpncpy_#in~dst.base| lambda))
 (= |ray_(ite (select #valid cstpncpy_#in~dst.base) 1 0)|
 (* |ray_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| lambda))
 (= |ray_(select #length cstpncpy_~#dst.base)|
 (* |ray_(select #length cstpncpy_~#dst.base)| lambda))
 (= |ray_(ite (select #valid cstpncpy_~#dst.base) 1 0)|
 (* |ray_(ite (select #valid cstpncpy_~#dst.base) 1 0)| lambda))
 (= |ray_(select old(#length) cstpncpy_#in~dst.base)|
 (* |ray_(select old(#length) cstpncpy_#in~dst.base)| lambda))
 (= |ray_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)|
 (* |ray_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| lambda))
 (= |ray_(ite (select #valid cstpncpy_#in~src.base) 1 0)|
 (* |ray_(ite (select #valid cstpncpy_#in~src.base) 1 0)| lambda))
 (= |ray_cstpncpy_#in~dst.offset| (* |ray_cstpncpy_#in~dst.offset| lambda))
 (= |ray_(ite (select #valid 0) 1 0)|
 (* |ray_(ite (select #valid 0) 1 0)| lambda))
 (= ray_cstpncpy_~src.base (* ray_cstpncpy_~src.base lambda))
 (= |ray_(ite (select old(#valid) 0) 1 0)|
 (* |ray_(ite (select old(#valid) 0) 1 0)| lambda))
 (= |ray_cstpncpy_~#dst.base| (* |ray_cstpncpy_~#dst.base| lambda))
 (= ray_cstpncpy_~src.offset (* ray_cstpncpy_~src.offset lambda))
 (= |ray_cstpncpy_#in~src.base| (* |ray_cstpncpy_#in~src.base| lambda))
 (=
 |ray_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 (*
 |ray_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 lambda))
 (= |ray_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)|
 (* |ray_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| lambda))
 (>=
 (+ (* (* |ray_cstpncpy_#t~mem0.offset| lambda) 0)
 (* (* |ray_(select #length cstpncpy_~d~3.base)| lambda) 0)
 (* (* |ray_cstpncpy_#t~post4.offset| lambda) 0)
 (* (* ray_cstpncpy_~s~3.offset lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 lambda) 0)
 (* (* |ray_(select old(#length) cstpncpy_#in~src.base)| lambda) 0)
 (* (* |ray_cstpncpy_~#dst.offset| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 lambda) 0) (* (* |ray_cstpncpy_#t~mem7| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 lambda) 0) (* (* ray_cstpncpy_~d~3.base lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 lambda) 0) (* (* |ray_(select #length cstpncpy_#in~src.base)| lambda) 0)
 (* (* |ray_cstpncpy_#in~src.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| lambda) 0)
 (* (* |ray_cstpncpy_#t~mem1.offset| lambda) 0)
 (* (* |ray_(select #length cstpncpy_#in~dst.base)| lambda) 0)
 (* (* |ray_cstpncpy_#t~mem0.base| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_cstpncpy_#in~n| lambda) 0)
 (* (* |ray_cstpncpy_#t~mem1.base| lambda) 0)
 (* (* |ray_cstpncpy_#t~post5.base| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(select old(#length) cstpncpy_~#dst.base)| lambda) 0)
 (* (* |ray_(ite (select #valid cstpncpy_~d~3.base) 1 0)| lambda) 0)
 (* (* ray_cstpncpy_~s~3.base lambda) 0)
 (*
 (*
 |ray_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 lambda) 0) (* (* |ray_(select #length cstpncpy_~s~3.base)| lambda) (- 1))
 (* (* ray_cstpncpy_~n lambda) 0)
 (* (* |ray_cstpncpy_#in~dst.base| lambda) 0)
 (* (* |ray_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length cstpncpy_~#dst.base)| lambda) 0)
 (* (* |ray_cstpncpy_#t~post4.base| lambda) 0)
 (* (* |ray_(ite (select #valid cstpncpy_~#dst.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) cstpncpy_#in~dst.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| lambda) 0)
 (* (* |ray_cstpncpy_#t~post5.offset| lambda) 0)
 (* (* |ray_(ite (select #valid cstpncpy_#in~src.base) 1 0)| lambda) 0)
 (* (* |ray_cstpncpy_#in~dst.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid cstpncpy_~s~3.base) 1 0)| lambda) 0)
 (* (* ray_cstpncpy_~src.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* ray_cstpncpy_~d~3.offset lambda) 0)
 (* (* |ray_cstpncpy_#t~post3| lambda) 0)
 (* (* |ray_cstpncpy_~#dst.base| lambda) 0)
 (* (* ray_cstpncpy_~src.offset lambda) 0)
 (* (* |ray_cstpncpy_#in~src.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| lambda) 0)
 (* |ray_(select #length cstpncpy_~d~3.base)| 0)
 (* |ray_cstpncpy_#t~post4.offset| 0) 
 (* ray_cstpncpy_~s~3.offset 0)
 (*
 |ray_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |ray_cstpncpy_#t~mem7| 0) 
 (* ray_cstpncpy_~d~3.base 0) 
 (* |ray_cstpncpy_#t~post5.base| 0)
 (* |ray_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (* ray_cstpncpy_~s~3.base 0) 
 (* |ray_(select #length cstpncpy_~s~3.base)| 1) 
 (* ray_cstpncpy_~n 0) (* |ray_cstpncpy_#t~post4.base| 0)
 (* |ray_cstpncpy_#t~post5.offset| 0)
 (* |ray_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* ray_cstpncpy_~d~3.offset 0) 
 (* |ray_cstpncpy_#t~post3| 0)) 0)
 (>=
 (+ (* (* |ray_cstpncpy_#t~mem0.offset| lambda) 0)
 (* (* |ray_(select #length cstpncpy_~d~3.base)| lambda) 0)
 (* (* |ray_cstpncpy_#t~post4.offset| lambda) 0)
 (* (* ray_cstpncpy_~s~3.offset lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 lambda) 0)
 (* (* |ray_(select old(#length) cstpncpy_#in~src.base)| lambda) 0)
 (* (* |ray_cstpncpy_~#dst.offset| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 lambda) 0) (* (* |ray_cstpncpy_#t~mem7| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 lambda) 0) (* (* ray_cstpncpy_~d~3.base lambda) (- 1))
 (*
 (*
 |ray_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 lambda) 0) (* (* |ray_(select #length cstpncpy_#in~src.base)| lambda) 0)
 (* (* |ray_cstpncpy_#in~src.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| lambda) 0)
 (* (* |ray_cstpncpy_#t~mem1.offset| lambda) 0)
 (* (* |ray_(select #length cstpncpy_#in~dst.base)| lambda) 0)
 (* (* |ray_cstpncpy_#t~mem0.base| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_cstpncpy_#in~n| lambda) 0)
 (* (* |ray_cstpncpy_#t~mem1.base| lambda) 0)
 (* (* |ray_cstpncpy_#t~post5.base| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(select old(#length) cstpncpy_~#dst.base)| lambda) 0)
 (* (* |ray_(ite (select #valid cstpncpy_~d~3.base) 1 0)| lambda) 0)
 (* (* ray_cstpncpy_~s~3.base lambda) 0)
 (*
 (*
 |ray_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 lambda) 0) (* (* |ray_(select #length cstpncpy_~s~3.base)| lambda) 0)
 (* (* ray_cstpncpy_~n lambda) 0)
 (* (* |ray_cstpncpy_#in~dst.base| lambda) 0)
 (* (* |ray_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length cstpncpy_~#dst.base)| lambda) 0)
 (* (* |ray_cstpncpy_#t~post4.base| lambda) 0)
 (* (* |ray_(ite (select #valid cstpncpy_~#dst.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) cstpncpy_#in~dst.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| lambda) 0)
 (* (* |ray_cstpncpy_#t~post5.offset| lambda) 0)
 (* (* |ray_(ite (select #valid cstpncpy_#in~src.base) 1 0)| lambda) 0)
 (* (* |ray_cstpncpy_#in~dst.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid cstpncpy_~s~3.base) 1 0)| lambda) 0)
 (* (* ray_cstpncpy_~src.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* ray_cstpncpy_~d~3.offset lambda) 0)
 (* (* |ray_cstpncpy_#t~post3| lambda) 0)
 (* (* |ray_cstpncpy_~#dst.base| lambda) 0)
 (* (* ray_cstpncpy_~src.offset lambda) 0)
 (* (* |ray_cstpncpy_#in~src.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| lambda) 0)
 (* |ray_(select #length cstpncpy_~d~3.base)| 0)
 (* |ray_cstpncpy_#t~post4.offset| 0) 
 (* ray_cstpncpy_~s~3.offset 0)
 (*
 |ray_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |ray_cstpncpy_#t~mem7| 0) 
 (* ray_cstpncpy_~d~3.base 1) 
 (* |ray_cstpncpy_#t~post5.base| 0)
 (* |ray_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (* ray_cstpncpy_~s~3.base 0) 
 (* |ray_(select #length cstpncpy_~s~3.base)| 0) 
 (* ray_cstpncpy_~n 0) (* |ray_cstpncpy_#t~post4.base| 0)
 (* |ray_cstpncpy_#t~post5.offset| 0)
 (* |ray_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* ray_cstpncpy_~d~3.offset 0) 
 (* |ray_cstpncpy_#t~post3| 0)) 0)
 (>=
 (+ (* (* |ray_cstpncpy_#t~mem0.offset| lambda) 0)
 (* (* |ray_(select #length cstpncpy_~d~3.base)| lambda) 0)
 (* (* |ray_cstpncpy_#t~post4.offset| lambda) 0)
 (* (* ray_cstpncpy_~s~3.offset lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 lambda) 0)
 (* (* |ray_(select old(#length) cstpncpy_#in~src.base)| lambda) 0)
 (* (* |ray_cstpncpy_~#dst.offset| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 lambda) 0) (* (* |ray_cstpncpy_#t~mem7| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 lambda) 0) (* (* ray_cstpncpy_~d~3.base lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 lambda) 0) (* (* |ray_(select #length cstpncpy_#in~src.base)| lambda) 0)
 (* (* |ray_cstpncpy_#in~src.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| lambda) 0)
 (* (* |ray_cstpncpy_#t~mem1.offset| lambda) 0)
 (* (* |ray_(select #length cstpncpy_#in~dst.base)| lambda) 0)
 (* (* |ray_cstpncpy_#t~mem0.base| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_cstpncpy_#in~n| lambda) 0)
 (* (* |ray_cstpncpy_#t~mem1.base| lambda) 0)
 (* (* |ray_cstpncpy_#t~post5.base| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(select old(#length) cstpncpy_~#dst.base)| lambda) 0)
 (* (* |ray_(ite (select #valid cstpncpy_~d~3.base) 1 0)| lambda) 0)
 (* (* ray_cstpncpy_~s~3.base lambda) 0)
 (*
 (*
 |ray_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 lambda) 0) (* (* |ray_(select #length cstpncpy_~s~3.base)| lambda) 0)
 (* (* ray_cstpncpy_~n lambda) 0)
 (* (* |ray_cstpncpy_#in~dst.base| lambda) 0)
 (* (* |ray_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length cstpncpy_~#dst.base)| lambda) 0)
 (* (* |ray_cstpncpy_#t~post4.base| lambda) 0)
 (* (* |ray_(ite (select #valid cstpncpy_~#dst.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) cstpncpy_#in~dst.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| lambda) 0)
 (* (* |ray_cstpncpy_#t~post5.offset| lambda) 0)
 (* (* |ray_(ite (select #valid cstpncpy_#in~src.base) 1 0)| lambda) 0)
 (* (* |ray_cstpncpy_#in~dst.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid cstpncpy_~s~3.base) 1 0)| lambda) 0)
 (* (* ray_cstpncpy_~src.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* ray_cstpncpy_~d~3.offset lambda) (- 1))
 (* (* |ray_cstpncpy_#t~post3| lambda) 0)
 (* (* |ray_cstpncpy_~#dst.base| lambda) 0)
 (* (* ray_cstpncpy_~src.offset lambda) 0)
 (* (* |ray_cstpncpy_#in~src.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| lambda) 0)
 (* |ray_(select #length cstpncpy_~d~3.base)| 0)
 (* |ray_cstpncpy_#t~post4.offset| 0) 
 (* ray_cstpncpy_~s~3.offset 0)
 (*
 |ray_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |ray_cstpncpy_#t~mem7| 0) 
 (* ray_cstpncpy_~d~3.base 0) 
 (* |ray_cstpncpy_#t~post5.base| 0)
 (* |ray_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (* ray_cstpncpy_~s~3.base 0) 
 (* |ray_(select #length cstpncpy_~s~3.base)| 0) 
 (* ray_cstpncpy_~n 0) (* |ray_cstpncpy_#t~post4.base| 0)
 (* |ray_cstpncpy_#t~post5.offset| 0)
 (* |ray_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* ray_cstpncpy_~d~3.offset 1) 
 (* |ray_cstpncpy_#t~post3| 0)) 0)
 (>=
 (+ (* (* |ray_cstpncpy_#t~mem0.offset| lambda) 0)
 (* (* |ray_(select #length cstpncpy_~d~3.base)| lambda) 0)
 (* (* |ray_cstpncpy_#t~post4.offset| lambda) 0)
 (* (* ray_cstpncpy_~s~3.offset lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 lambda) 0)
 (* (* |ray_(select old(#length) cstpncpy_#in~src.base)| lambda) 0)
 (* (* |ray_cstpncpy_~#dst.offset| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 lambda) 0) (* (* |ray_cstpncpy_#t~mem7| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 lambda) 0) (* (* ray_cstpncpy_~d~3.base lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 lambda) 0) (* (* |ray_(select #length cstpncpy_#in~src.base)| lambda) 0)
 (* (* |ray_cstpncpy_#in~src.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| lambda) 0)
 (* (* |ray_cstpncpy_#t~mem1.offset| lambda) 0)
 (* (* |ray_(select #length cstpncpy_#in~dst.base)| lambda) 0)
 (* (* |ray_cstpncpy_#t~mem0.base| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_cstpncpy_#in~n| lambda) 0)
 (* (* |ray_cstpncpy_#t~mem1.base| lambda) 0)
 (* (* |ray_cstpncpy_#t~post5.base| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(select old(#length) cstpncpy_~#dst.base)| lambda) 0)
 (* (* |ray_(ite (select #valid cstpncpy_~d~3.base) 1 0)| lambda) 0)
 (* (* ray_cstpncpy_~s~3.base lambda) (- 1))
 (*
 (*
 |ray_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 lambda) 0) (* (* |ray_(select #length cstpncpy_~s~3.base)| lambda) 0)
 (* (* ray_cstpncpy_~n lambda) 0)
 (* (* |ray_cstpncpy_#in~dst.base| lambda) 0)
 (* (* |ray_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length cstpncpy_~#dst.base)| lambda) 0)
 (* (* |ray_cstpncpy_#t~post4.base| lambda) 0)
 (* (* |ray_(ite (select #valid cstpncpy_~#dst.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) cstpncpy_#in~dst.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| lambda) 0)
 (* (* |ray_cstpncpy_#t~post5.offset| lambda) 0)
 (* (* |ray_(ite (select #valid cstpncpy_#in~src.base) 1 0)| lambda) 0)
 (* (* |ray_cstpncpy_#in~dst.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid cstpncpy_~s~3.base) 1 0)| lambda) 0)
 (* (* ray_cstpncpy_~src.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* ray_cstpncpy_~d~3.offset lambda) 0)
 (* (* |ray_cstpncpy_#t~post3| lambda) 0)
 (* (* |ray_cstpncpy_~#dst.base| lambda) 0)
 (* (* ray_cstpncpy_~src.offset lambda) 0)
 (* (* |ray_cstpncpy_#in~src.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| lambda) 0)
 (* |ray_(select #length cstpncpy_~d~3.base)| 0)
 (* |ray_cstpncpy_#t~post4.offset| 0) 
 (* ray_cstpncpy_~s~3.offset 0)
 (*
 |ray_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |ray_cstpncpy_#t~mem7| 0) 
 (* ray_cstpncpy_~d~3.base 1) 
 (* |ray_cstpncpy_#t~post5.base| 0)
 (* |ray_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (* ray_cstpncpy_~s~3.base 0) 
 (* |ray_(select #length cstpncpy_~s~3.base)| 0) 
 (* ray_cstpncpy_~n 0) (* |ray_cstpncpy_#t~post4.base| 0)
 (* |ray_cstpncpy_#t~post5.offset| 0)
 (* |ray_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* ray_cstpncpy_~d~3.offset 0) 
 (* |ray_cstpncpy_#t~post3| 0)) 0)
 (>=
 (+ (* (* |ray_cstpncpy_#t~mem0.offset| lambda) 0)
 (* (* |ray_(select #length cstpncpy_~d~3.base)| lambda) 0)
 (* (* |ray_cstpncpy_#t~post4.offset| lambda) 0)
 (* (* ray_cstpncpy_~s~3.offset lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 lambda) 0)
 (* (* |ray_(select old(#length) cstpncpy_#in~src.base)| lambda) 0)
 (* (* |ray_cstpncpy_~#dst.offset| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 lambda) 0) (* (* |ray_cstpncpy_#t~mem7| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 lambda) 0) (* (* ray_cstpncpy_~d~3.base lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 lambda) 0) (* (* |ray_(select #length cstpncpy_#in~src.base)| lambda) 0)
 (* (* |ray_cstpncpy_#in~src.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| lambda) 0)
 (* (* |ray_cstpncpy_#t~mem1.offset| lambda) 0)
 (* (* |ray_(select #length cstpncpy_#in~dst.base)| lambda) 0)
 (* (* |ray_cstpncpy_#t~mem0.base| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_cstpncpy_#in~n| lambda) 0)
 (* (* |ray_cstpncpy_#t~mem1.base| lambda) 0)
 (* (* |ray_cstpncpy_#t~post5.base| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(select old(#length) cstpncpy_~#dst.base)| lambda) 0)
 (* (* |ray_(ite (select #valid cstpncpy_~d~3.base) 1 0)| lambda) 1)
 (* (* ray_cstpncpy_~s~3.base lambda) 0)
 (*
 (*
 |ray_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 lambda) 0) (* (* |ray_(select #length cstpncpy_~s~3.base)| lambda) 0)
 (* (* ray_cstpncpy_~n lambda) 0)
 (* (* |ray_cstpncpy_#in~dst.base| lambda) 0)
 (* (* |ray_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length cstpncpy_~#dst.base)| lambda) 0)
 (* (* |ray_cstpncpy_#t~post4.base| lambda) 0)
 (* (* |ray_(ite (select #valid cstpncpy_~#dst.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) cstpncpy_#in~dst.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| lambda) 0)
 (* (* |ray_cstpncpy_#t~post5.offset| lambda) 0)
 (* (* |ray_(ite (select #valid cstpncpy_#in~src.base) 1 0)| lambda) 0)
 (* (* |ray_cstpncpy_#in~dst.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid cstpncpy_~s~3.base) 1 0)| lambda) 0)
 (* (* ray_cstpncpy_~src.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* ray_cstpncpy_~d~3.offset lambda) 0)
 (* (* |ray_cstpncpy_#t~post3| lambda) 0)
 (* (* |ray_cstpncpy_~#dst.base| lambda) 0)
 (* (* ray_cstpncpy_~src.offset lambda) 0)
 (* (* |ray_cstpncpy_#in~src.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| lambda) 0)
 (* |ray_(select #length cstpncpy_~d~3.base)| 0)
 (* |ray_cstpncpy_#t~post4.offset| 0) 
 (* ray_cstpncpy_~s~3.offset 0)
 (*
 |ray_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |ray_cstpncpy_#t~mem7| 0) 
 (* ray_cstpncpy_~d~3.base 0) 
 (* |ray_cstpncpy_#t~post5.base| 0)
 (* |ray_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (* ray_cstpncpy_~s~3.base 0) 
 (* |ray_(select #length cstpncpy_~s~3.base)| 0) 
 (* ray_cstpncpy_~n 0) (* |ray_cstpncpy_#t~post4.base| 0)
 (* |ray_cstpncpy_#t~post5.offset| 0)
 (* |ray_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* ray_cstpncpy_~d~3.offset 0) 
 (* |ray_cstpncpy_#t~post3| 0)) 0)
 (>=
 (+ (* (* |ray_cstpncpy_#t~mem0.offset| lambda) 0)
 (* (* |ray_(select #length cstpncpy_~d~3.base)| lambda) (- 1))
 (* (* |ray_cstpncpy_#t~post4.offset| lambda) 0)
 (* (* ray_cstpncpy_~s~3.offset lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 lambda) 0)
 (* (* |ray_(select old(#length) cstpncpy_#in~src.base)| lambda) 0)
 (* (* |ray_cstpncpy_~#dst.offset| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 lambda) 0) (* (* |ray_cstpncpy_#t~mem7| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 lambda) 0) (* (* ray_cstpncpy_~d~3.base lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 lambda) 0) (* (* |ray_(select #length cstpncpy_#in~src.base)| lambda) 0)
 (* (* |ray_cstpncpy_#in~src.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| lambda) 0)
 (* (* |ray_cstpncpy_#t~mem1.offset| lambda) 0)
 (* (* |ray_(select #length cstpncpy_#in~dst.base)| lambda) 0)
 (* (* |ray_cstpncpy_#t~mem0.base| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_cstpncpy_#in~n| lambda) 0)
 (* (* |ray_cstpncpy_#t~mem1.base| lambda) 0)
 (* (* |ray_cstpncpy_#t~post5.base| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(select old(#length) cstpncpy_~#dst.base)| lambda) 0)
 (* (* |ray_(ite (select #valid cstpncpy_~d~3.base) 1 0)| lambda) 0)
 (* (* ray_cstpncpy_~s~3.base lambda) 0)
 (*
 (*
 |ray_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 lambda) 0) (* (* |ray_(select #length cstpncpy_~s~3.base)| lambda) 0)
 (* (* ray_cstpncpy_~n lambda) 0)
 (* (* |ray_cstpncpy_#in~dst.base| lambda) 0)
 (* (* |ray_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length cstpncpy_~#dst.base)| lambda) 0)
 (* (* |ray_cstpncpy_#t~post4.base| lambda) 0)
 (* (* |ray_(ite (select #valid cstpncpy_~#dst.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) cstpncpy_#in~dst.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| lambda) 0)
 (* (* |ray_cstpncpy_#t~post5.offset| lambda) 0)
 (* (* |ray_(ite (select #valid cstpncpy_#in~src.base) 1 0)| lambda) 0)
 (* (* |ray_cstpncpy_#in~dst.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid cstpncpy_~s~3.base) 1 0)| lambda) 0)
 (* (* ray_cstpncpy_~src.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* ray_cstpncpy_~d~3.offset lambda) 0)
 (* (* |ray_cstpncpy_#t~post3| lambda) 0)
 (* (* |ray_cstpncpy_~#dst.base| lambda) 0)
 (* (* ray_cstpncpy_~src.offset lambda) 0)
 (* (* |ray_cstpncpy_#in~src.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| lambda) 0)
 (* |ray_(select #length cstpncpy_~d~3.base)| 1)
 (* |ray_cstpncpy_#t~post4.offset| 0) 
 (* ray_cstpncpy_~s~3.offset 0)
 (*
 |ray_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |ray_cstpncpy_#t~mem7| 0) 
 (* ray_cstpncpy_~d~3.base 0) 
 (* |ray_cstpncpy_#t~post5.base| 0)
 (* |ray_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (* ray_cstpncpy_~s~3.base 0) 
 (* |ray_(select #length cstpncpy_~s~3.base)| 0) 
 (* ray_cstpncpy_~n 0) (* |ray_cstpncpy_#t~post4.base| 0)
 (* |ray_cstpncpy_#t~post5.offset| 0)
 (* |ray_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* ray_cstpncpy_~d~3.offset 0) 
 (* |ray_cstpncpy_#t~post3| 0)) 0)
 (>=
 (+ (* (* |ray_cstpncpy_#t~mem0.offset| lambda) 0)
 (* (* |ray_(select #length cstpncpy_~d~3.base)| lambda) 0)
 (* (* |ray_cstpncpy_#t~post4.offset| lambda) 0)
 (* (* ray_cstpncpy_~s~3.offset lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 lambda) 0)
 (* (* |ray_(select old(#length) cstpncpy_#in~src.base)| lambda) 0)
 (* (* |ray_cstpncpy_~#dst.offset| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 lambda) 0) (* (* |ray_cstpncpy_#t~mem7| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 lambda) 0) (* (* ray_cstpncpy_~d~3.base lambda) 1)
 (*
 (*
 |ray_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 lambda) 0) (* (* |ray_(select #length cstpncpy_#in~src.base)| lambda) 0)
 (* (* |ray_cstpncpy_#in~src.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| lambda) 0)
 (* (* |ray_cstpncpy_#t~mem1.offset| lambda) 0)
 (* (* |ray_(select #length cstpncpy_#in~dst.base)| lambda) 0)
 (* (* |ray_cstpncpy_#t~mem0.base| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_cstpncpy_#in~n| lambda) 0)
 (* (* |ray_cstpncpy_#t~mem1.base| lambda) 0)
 (* (* |ray_cstpncpy_#t~post5.base| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(select old(#length) cstpncpy_~#dst.base)| lambda) 0)
 (* (* |ray_(ite (select #valid cstpncpy_~d~3.base) 1 0)| lambda) 0)
 (* (* ray_cstpncpy_~s~3.base lambda) 0)
 (*
 (*
 |ray_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 lambda) 0) (* (* |ray_(select #length cstpncpy_~s~3.base)| lambda) 0)
 (* (* ray_cstpncpy_~n lambda) 0)
 (* (* |ray_cstpncpy_#in~dst.base| lambda) 0)
 (* (* |ray_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length cstpncpy_~#dst.base)| lambda) 0)
 (* (* |ray_cstpncpy_#t~post4.base| lambda) 0)
 (* (* |ray_(ite (select #valid cstpncpy_~#dst.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) cstpncpy_#in~dst.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| lambda) 0)
 (* (* |ray_cstpncpy_#t~post5.offset| lambda) 0)
 (* (* |ray_(ite (select #valid cstpncpy_#in~src.base) 1 0)| lambda) 0)
 (* (* |ray_cstpncpy_#in~dst.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid cstpncpy_~s~3.base) 1 0)| lambda) 0)
 (* (* ray_cstpncpy_~src.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* ray_cstpncpy_~d~3.offset lambda) 0)
 (* (* |ray_cstpncpy_#t~post3| lambda) 0)
 (* (* |ray_cstpncpy_~#dst.base| lambda) 0)
 (* (* ray_cstpncpy_~src.offset lambda) 0)
 (* (* |ray_cstpncpy_#in~src.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| lambda) 0)
 (* |ray_(select #length cstpncpy_~d~3.base)| 0)
 (* |ray_cstpncpy_#t~post4.offset| 0) 
 (* ray_cstpncpy_~s~3.offset 0)
 (*
 |ray_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |ray_cstpncpy_#t~mem7| 0) 
 (* ray_cstpncpy_~d~3.base (- 1)) 
 (* |ray_cstpncpy_#t~post5.base| 0)
 (* |ray_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (* ray_cstpncpy_~s~3.base 0) 
 (* |ray_(select #length cstpncpy_~s~3.base)| 0) 
 (* ray_cstpncpy_~n 0) (* |ray_cstpncpy_#t~post4.base| 0)
 (* |ray_cstpncpy_#t~post5.offset| 0)
 (* |ray_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* ray_cstpncpy_~d~3.offset 0) 
 (* |ray_cstpncpy_#t~post3| 0)) 0)
 (>=
 (+ (* (* |ray_cstpncpy_#t~mem0.offset| lambda) 0)
 (* (* |ray_(select #length cstpncpy_~d~3.base)| lambda) 0)
 (* (* |ray_cstpncpy_#t~post4.offset| lambda) 0)
 (* (* ray_cstpncpy_~s~3.offset lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 lambda) 0)
 (* (* |ray_(select old(#length) cstpncpy_#in~src.base)| lambda) 0)
 (* (* |ray_cstpncpy_~#dst.offset| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 lambda) 0) (* (* |ray_cstpncpy_#t~mem7| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 lambda) 0) (* (* ray_cstpncpy_~d~3.base lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 lambda) 0) (* (* |ray_(select #length cstpncpy_#in~src.base)| lambda) 0)
 (* (* |ray_cstpncpy_#in~src.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| lambda) 0)
 (* (* |ray_cstpncpy_#t~mem1.offset| lambda) 0)
 (* (* |ray_(select #length cstpncpy_#in~dst.base)| lambda) 0)
 (* (* |ray_cstpncpy_#t~mem0.base| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_cstpncpy_#in~n| lambda) 0)
 (* (* |ray_cstpncpy_#t~mem1.base| lambda) 0)
 (* (* |ray_cstpncpy_#t~post5.base| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(select old(#length) cstpncpy_~#dst.base)| lambda) 0)
 (* (* |ray_(ite (select #valid cstpncpy_~d~3.base) 1 0)| lambda) 0)
 (* (* ray_cstpncpy_~s~3.base lambda) 0)
 (*
 (*
 |ray_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 lambda) 0) (* (* |ray_(select #length cstpncpy_~s~3.base)| lambda) 0)
 (* (* ray_cstpncpy_~n lambda) 0)
 (* (* |ray_cstpncpy_#in~dst.base| lambda) 0)
 (* (* |ray_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length cstpncpy_~#dst.base)| lambda) 0)
 (* (* |ray_cstpncpy_#t~post4.base| lambda) 0)
 (* (* |ray_(ite (select #valid cstpncpy_~#dst.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) cstpncpy_#in~dst.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| lambda) 0)
 (* (* |ray_cstpncpy_#t~post5.offset| lambda) 0)
 (* (* |ray_(ite (select #valid cstpncpy_#in~src.base) 1 0)| lambda) 0)
 (* (* |ray_cstpncpy_#in~dst.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid cstpncpy_~s~3.base) 1 0)| lambda) 0)
 (* (* ray_cstpncpy_~src.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* ray_cstpncpy_~d~3.offset lambda) 0)
 (* (* |ray_cstpncpy_#t~post3| lambda) 0)
 (* (* |ray_cstpncpy_~#dst.base| lambda) 0)
 (* (* ray_cstpncpy_~src.offset lambda) 0)
 (* (* |ray_cstpncpy_#in~src.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| lambda) 0)
 (* |ray_(select #length cstpncpy_~d~3.base)| 0)
 (* |ray_cstpncpy_#t~post4.offset| 0) 
 (* ray_cstpncpy_~s~3.offset (- 1))
 (*
 |ray_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |ray_cstpncpy_#t~mem7| 0) 
 (* ray_cstpncpy_~d~3.base 0) 
 (* |ray_cstpncpy_#t~post5.base| 0)
 (* |ray_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (* ray_cstpncpy_~s~3.base 0) 
 (* |ray_(select #length cstpncpy_~s~3.base)| 1) 
 (* ray_cstpncpy_~n 0) (* |ray_cstpncpy_#t~post4.base| 0)
 (* |ray_cstpncpy_#t~post5.offset| 0)
 (* |ray_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* ray_cstpncpy_~d~3.offset 0) 
 (* |ray_cstpncpy_#t~post3| 0)) 0)
 (>=
 (+ (* (* |ray_cstpncpy_#t~mem0.offset| lambda) 0)
 (* (* |ray_(select #length cstpncpy_~d~3.base)| lambda) 0)
 (* (* |ray_cstpncpy_#t~post4.offset| lambda) 0)
 (* (* ray_cstpncpy_~s~3.offset lambda) (- 1))
 (*
 (*
 |ray_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 lambda) 0)
 (* (* |ray_(select old(#length) cstpncpy_#in~src.base)| lambda) 0)
 (* (* |ray_cstpncpy_~#dst.offset| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 lambda) 0) (* (* |ray_cstpncpy_#t~mem7| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 lambda) 0) (* (* ray_cstpncpy_~d~3.base lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 lambda) 0) (* (* |ray_(select #length cstpncpy_#in~src.base)| lambda) 0)
 (* (* |ray_cstpncpy_#in~src.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| lambda) 0)
 (* (* |ray_cstpncpy_#t~mem1.offset| lambda) 0)
 (* (* |ray_(select #length cstpncpy_#in~dst.base)| lambda) 0)
 (* (* |ray_cstpncpy_#t~mem0.base| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_cstpncpy_#in~n| lambda) 0)
 (* (* |ray_cstpncpy_#t~mem1.base| lambda) 0)
 (* (* |ray_cstpncpy_#t~post5.base| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(select old(#length) cstpncpy_~#dst.base)| lambda) 0)
 (* (* |ray_(ite (select #valid cstpncpy_~d~3.base) 1 0)| lambda) 0)
 (* (* ray_cstpncpy_~s~3.base lambda) 0)
 (*
 (*
 |ray_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 lambda) 0) (* (* |ray_(select #length cstpncpy_~s~3.base)| lambda) 0)
 (* (* ray_cstpncpy_~n lambda) 0)
 (* (* |ray_cstpncpy_#in~dst.base| lambda) 0)
 (* (* |ray_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length cstpncpy_~#dst.base)| lambda) 0)
 (* (* |ray_cstpncpy_#t~post4.base| lambda) 0)
 (* (* |ray_(ite (select #valid cstpncpy_~#dst.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) cstpncpy_#in~dst.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| lambda) 0)
 (* (* |ray_cstpncpy_#t~post5.offset| lambda) 0)
 (* (* |ray_(ite (select #valid cstpncpy_#in~src.base) 1 0)| lambda) 0)
 (* (* |ray_cstpncpy_#in~dst.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid cstpncpy_~s~3.base) 1 0)| lambda) 0)
 (* (* ray_cstpncpy_~src.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* ray_cstpncpy_~d~3.offset lambda) 0)
 (* (* |ray_cstpncpy_#t~post3| lambda) 0)
 (* (* |ray_cstpncpy_~#dst.base| lambda) 0)
 (* (* ray_cstpncpy_~src.offset lambda) 0)
 (* (* |ray_cstpncpy_#in~src.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| lambda) 0)
 (* |ray_(select #length cstpncpy_~d~3.base)| 0)
 (* |ray_cstpncpy_#t~post4.offset| 0) 
 (* ray_cstpncpy_~s~3.offset 1)
 (*
 |ray_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |ray_cstpncpy_#t~mem7| 0) 
 (* ray_cstpncpy_~d~3.base 0) 
 (* |ray_cstpncpy_#t~post5.base| 0)
 (* |ray_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (* ray_cstpncpy_~s~3.base 0) 
 (* |ray_(select #length cstpncpy_~s~3.base)| 0) 
 (* ray_cstpncpy_~n 0) (* |ray_cstpncpy_#t~post4.base| 0)
 (* |ray_cstpncpy_#t~post5.offset| 0)
 (* |ray_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* ray_cstpncpy_~d~3.offset 0) 
 (* |ray_cstpncpy_#t~post3| 0)) 0)
 (>=
 (+ (* (* |ray_cstpncpy_#t~mem0.offset| lambda) 0)
 (* (* |ray_(select #length cstpncpy_~d~3.base)| lambda) 0)
 (* (* |ray_cstpncpy_#t~post4.offset| lambda) 0)
 (* (* ray_cstpncpy_~s~3.offset lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 lambda) 0)
 (* (* |ray_(select old(#length) cstpncpy_#in~src.base)| lambda) 0)
 (* (* |ray_cstpncpy_~#dst.offset| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 lambda) 0) (* (* |ray_cstpncpy_#t~mem7| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 lambda) 0) (* (* ray_cstpncpy_~d~3.base lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 lambda) 0) (* (* |ray_(select #length cstpncpy_#in~src.base)| lambda) 0)
 (* (* |ray_cstpncpy_#in~src.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| lambda) 0)
 (* (* |ray_cstpncpy_#t~mem1.offset| lambda) 0)
 (* (* |ray_(select #length cstpncpy_#in~dst.base)| lambda) 0)
 (* (* |ray_cstpncpy_#t~mem0.base| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_cstpncpy_#in~n| lambda) 0)
 (* (* |ray_cstpncpy_#t~mem1.base| lambda) 0)
 (* (* |ray_cstpncpy_#t~post5.base| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(select old(#length) cstpncpy_~#dst.base)| lambda) 0)
 (* (* |ray_(ite (select #valid cstpncpy_~d~3.base) 1 0)| lambda) 0)
 (* (* ray_cstpncpy_~s~3.base lambda) 0)
 (*
 (*
 |ray_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 lambda) 0) (* (* |ray_(select #length cstpncpy_~s~3.base)| lambda) 0)
 (* (* ray_cstpncpy_~n lambda) (- 1))
 (* (* |ray_cstpncpy_#in~dst.base| lambda) 0)
 (* (* |ray_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length cstpncpy_~#dst.base)| lambda) 0)
 (* (* |ray_cstpncpy_#t~post4.base| lambda) 0)
 (* (* |ray_(ite (select #valid cstpncpy_~#dst.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) cstpncpy_#in~dst.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| lambda) 0)
 (* (* |ray_cstpncpy_#t~post5.offset| lambda) 0)
 (* (* |ray_(ite (select #valid cstpncpy_#in~src.base) 1 0)| lambda) 0)
 (* (* |ray_cstpncpy_#in~dst.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid cstpncpy_~s~3.base) 1 0)| lambda) 0)
 (* (* ray_cstpncpy_~src.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* ray_cstpncpy_~d~3.offset lambda) 0)
 (* (* |ray_cstpncpy_#t~post3| lambda) 0)
 (* (* |ray_cstpncpy_~#dst.base| lambda) 0)
 (* (* ray_cstpncpy_~src.offset lambda) 0)
 (* (* |ray_cstpncpy_#in~src.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| lambda) 0)
 (* |ray_(select #length cstpncpy_~d~3.base)| 0)
 (* |ray_cstpncpy_#t~post4.offset| 0) 
 (* ray_cstpncpy_~s~3.offset 0)
 (*
 |ray_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |ray_cstpncpy_#t~mem7| 0) 
 (* ray_cstpncpy_~d~3.base 0) 
 (* |ray_cstpncpy_#t~post5.base| 0)
 (* |ray_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (* ray_cstpncpy_~s~3.base 0) 
 (* |ray_(select #length cstpncpy_~s~3.base)| 0) 
 (* ray_cstpncpy_~n 1) (* |ray_cstpncpy_#t~post4.base| 0)
 (* |ray_cstpncpy_#t~post5.offset| 0)
 (* |ray_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* ray_cstpncpy_~d~3.offset 0) 
 (* |ray_cstpncpy_#t~post3| 0)) 0)
 (>=
 (+ (* (* |ray_cstpncpy_#t~mem0.offset| lambda) 0)
 (* (* |ray_(select #length cstpncpy_~d~3.base)| lambda) 0)
 (* (* |ray_cstpncpy_#t~post4.offset| lambda) 0)
 (* (* ray_cstpncpy_~s~3.offset lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 lambda) 0)
 (* (* |ray_(select old(#length) cstpncpy_#in~src.base)| lambda) 0)
 (* (* |ray_cstpncpy_~#dst.offset| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 lambda) 0) (* (* |ray_cstpncpy_#t~mem7| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 lambda) 0) (* (* ray_cstpncpy_~d~3.base lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 lambda) 0) (* (* |ray_(select #length cstpncpy_#in~src.base)| lambda) 0)
 (* (* |ray_cstpncpy_#in~src.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| lambda) 0)
 (* (* |ray_cstpncpy_#t~mem1.offset| lambda) 0)
 (* (* |ray_(select #length cstpncpy_#in~dst.base)| lambda) 0)
 (* (* |ray_cstpncpy_#t~mem0.base| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_cstpncpy_#in~n| lambda) 0)
 (* (* |ray_cstpncpy_#t~mem1.base| lambda) 0)
 (* (* |ray_cstpncpy_#t~post5.base| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(select old(#length) cstpncpy_~#dst.base)| lambda) 0)
 (* (* |ray_(ite (select #valid cstpncpy_~d~3.base) 1 0)| lambda) 0)
 (* (* ray_cstpncpy_~s~3.base lambda) 0)
 (*
 (*
 |ray_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 lambda) 0) (* (* |ray_(select #length cstpncpy_~s~3.base)| lambda) 0)
 (* (* ray_cstpncpy_~n lambda) 0)
 (* (* |ray_cstpncpy_#in~dst.base| lambda) 0)
 (* (* |ray_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length cstpncpy_~#dst.base)| lambda) 0)
 (* (* |ray_cstpncpy_#t~post4.base| lambda) 0)
 (* (* |ray_(ite (select #valid cstpncpy_~#dst.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) cstpncpy_#in~dst.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| lambda) 0)
 (* (* |ray_cstpncpy_#t~post5.offset| lambda) 0)
 (* (* |ray_(ite (select #valid cstpncpy_#in~src.base) 1 0)| lambda) 0)
 (* (* |ray_cstpncpy_#in~dst.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid cstpncpy_~s~3.base) 1 0)| lambda) 0)
 (* (* ray_cstpncpy_~src.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* ray_cstpncpy_~d~3.offset lambda) 1)
 (* (* |ray_cstpncpy_#t~post3| lambda) 0)
 (* (* |ray_cstpncpy_~#dst.base| lambda) 0)
 (* (* ray_cstpncpy_~src.offset lambda) 0)
 (* (* |ray_cstpncpy_#in~src.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| lambda) 0)
 (* |ray_(select #length cstpncpy_~d~3.base)| 0)
 (* |ray_cstpncpy_#t~post4.offset| 0) 
 (* ray_cstpncpy_~s~3.offset 0)
 (*
 |ray_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |ray_cstpncpy_#t~mem7| 0) 
 (* ray_cstpncpy_~d~3.base 0) 
 (* |ray_cstpncpy_#t~post5.base| 0)
 (* |ray_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (* ray_cstpncpy_~s~3.base 0) 
 (* |ray_(select #length cstpncpy_~s~3.base)| 0) 
 (* ray_cstpncpy_~n 0) (* |ray_cstpncpy_#t~post4.base| 0)
 (* |ray_cstpncpy_#t~post5.offset| 0)
 (* |ray_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* ray_cstpncpy_~d~3.offset (- 1)) 
 (* |ray_cstpncpy_#t~post3| 0)) 0)
 (>=
 (+ (* (* |ray_cstpncpy_#t~mem0.offset| lambda) 0)
 (* (* |ray_(select #length cstpncpy_~d~3.base)| lambda) 0)
 (* (* |ray_cstpncpy_#t~post4.offset| lambda) 0)
 (* (* ray_cstpncpy_~s~3.offset lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 lambda) 0)
 (* (* |ray_(select old(#length) cstpncpy_#in~src.base)| lambda) 0)
 (* (* |ray_cstpncpy_~#dst.offset| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 lambda) 0) (* (* |ray_cstpncpy_#t~mem7| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 lambda) 0) (* (* ray_cstpncpy_~d~3.base lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 lambda) 0) (* (* |ray_(select #length cstpncpy_#in~src.base)| lambda) 0)
 (* (* |ray_cstpncpy_#in~src.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| lambda) 0)
 (* (* |ray_cstpncpy_#t~mem1.offset| lambda) 0)
 (* (* |ray_(select #length cstpncpy_#in~dst.base)| lambda) 0)
 (* (* |ray_cstpncpy_#t~mem0.base| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_cstpncpy_#in~n| lambda) 0)
 (* (* |ray_cstpncpy_#t~mem1.base| lambda) 0)
 (* (* |ray_cstpncpy_#t~post5.base| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(select old(#length) cstpncpy_~#dst.base)| lambda) 0)
 (* (* |ray_(ite (select #valid cstpncpy_~d~3.base) 1 0)| lambda) 0)
 (* (* ray_cstpncpy_~s~3.base lambda) 0)
 (*
 (*
 |ray_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 lambda) 0) (* (* |ray_(select #length cstpncpy_~s~3.base)| lambda) 0)
 (* (* ray_cstpncpy_~n lambda) 0)
 (* (* |ray_cstpncpy_#in~dst.base| lambda) 0)
 (* (* |ray_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length cstpncpy_~#dst.base)| lambda) 0)
 (* (* |ray_cstpncpy_#t~post4.base| lambda) 0)
 (* (* |ray_(ite (select #valid cstpncpy_~#dst.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) cstpncpy_#in~dst.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| lambda) 0)
 (* (* |ray_cstpncpy_#t~post5.offset| lambda) 0)
 (* (* |ray_(ite (select #valid cstpncpy_#in~src.base) 1 0)| lambda) 0)
 (* (* |ray_cstpncpy_#in~dst.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid cstpncpy_~s~3.base) 1 0)| lambda) 0)
 (* (* ray_cstpncpy_~src.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* ray_cstpncpy_~d~3.offset lambda) 0)
 (* (* |ray_cstpncpy_#t~post3| lambda) 0)
 (* (* |ray_cstpncpy_~#dst.base| lambda) 0)
 (* (* ray_cstpncpy_~src.offset lambda) 0)
 (* (* |ray_cstpncpy_#in~src.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| lambda) 0)
 (* |ray_(select #length cstpncpy_~d~3.base)| 0)
 (* |ray_cstpncpy_#t~post4.offset| 0) 
 (* ray_cstpncpy_~s~3.offset 0)
 (*
 |ray_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 (- 1)) (* |ray_cstpncpy_#t~mem7| 0) 
 (* ray_cstpncpy_~d~3.base 0) 
 (* |ray_cstpncpy_#t~post5.base| 0)
 (* |ray_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (* ray_cstpncpy_~s~3.base 0) 
 (* |ray_(select #length cstpncpy_~s~3.base)| 0) 
 (* ray_cstpncpy_~n 0) (* |ray_cstpncpy_#t~post4.base| 0)
 (* |ray_cstpncpy_#t~post5.offset| 0)
 (* |ray_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* ray_cstpncpy_~d~3.offset 0) 
 (* |ray_cstpncpy_#t~post3| 0)) 0)
 (>=
 (+ (* (* |ray_cstpncpy_#t~mem0.offset| lambda) 0)
 (* (* |ray_(select #length cstpncpy_~d~3.base)| lambda) 0)
 (* (* |ray_cstpncpy_#t~post4.offset| lambda) 0)
 (* (* ray_cstpncpy_~s~3.offset lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 lambda) 0)
 (* (* |ray_(select old(#length) cstpncpy_#in~src.base)| lambda) 0)
 (* (* |ray_cstpncpy_~#dst.offset| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 lambda) 0) (* (* |ray_cstpncpy_#t~mem7| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 lambda) 0) (* (* ray_cstpncpy_~d~3.base lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 lambda) 0) (* (* |ray_(select #length cstpncpy_#in~src.base)| lambda) 0)
 (* (* |ray_cstpncpy_#in~src.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| lambda) 0)
 (* (* |ray_cstpncpy_#t~mem1.offset| lambda) 0)
 (* (* |ray_(select #length cstpncpy_#in~dst.base)| lambda) 0)
 (* (* |ray_cstpncpy_#t~mem0.base| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_cstpncpy_#in~n| lambda) 0)
 (* (* |ray_cstpncpy_#t~mem1.base| lambda) 0)
 (* (* |ray_cstpncpy_#t~post5.base| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(select old(#length) cstpncpy_~#dst.base)| lambda) 0)
 (* (* |ray_(ite (select #valid cstpncpy_~d~3.base) 1 0)| lambda) 0)
 (* (* ray_cstpncpy_~s~3.base lambda) 0)
 (*
 (*
 |ray_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 lambda) 0) (* (* |ray_(select #length cstpncpy_~s~3.base)| lambda) 0)
 (* (* ray_cstpncpy_~n lambda) 0)
 (* (* |ray_cstpncpy_#in~dst.base| lambda) 0)
 (* (* |ray_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length cstpncpy_~#dst.base)| lambda) 0)
 (* (* |ray_cstpncpy_#t~post4.base| lambda) 0)
 (* (* |ray_(ite (select #valid cstpncpy_~#dst.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) cstpncpy_#in~dst.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| lambda) 0)
 (* (* |ray_cstpncpy_#t~post5.offset| lambda) 0)
 (* (* |ray_(ite (select #valid cstpncpy_#in~src.base) 1 0)| lambda) 0)
 (* (* |ray_cstpncpy_#in~dst.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid cstpncpy_~s~3.base) 1 0)| lambda) 1)
 (* (* ray_cstpncpy_~src.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* ray_cstpncpy_~d~3.offset lambda) 0)
 (* (* |ray_cstpncpy_#t~post3| lambda) 0)
 (* (* |ray_cstpncpy_~#dst.base| lambda) 0)
 (* (* ray_cstpncpy_~src.offset lambda) 0)
 (* (* |ray_cstpncpy_#in~src.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| lambda) 0)
 (* |ray_(select #length cstpncpy_~d~3.base)| 0)
 (* |ray_cstpncpy_#t~post4.offset| 0) 
 (* ray_cstpncpy_~s~3.offset 0)
 (*
 |ray_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |ray_cstpncpy_#t~mem7| 0) 
 (* ray_cstpncpy_~d~3.base 0) 
 (* |ray_cstpncpy_#t~post5.base| 0)
 (* |ray_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (* ray_cstpncpy_~s~3.base 0) 
 (* |ray_(select #length cstpncpy_~s~3.base)| 0) 
 (* ray_cstpncpy_~n 0) (* |ray_cstpncpy_#t~post4.base| 0)
 (* |ray_cstpncpy_#t~post5.offset| 0)
 (* |ray_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* ray_cstpncpy_~d~3.offset 0) 
 (* |ray_cstpncpy_#t~post3| 0)) 0)
 (>=
 (+ (* (* |ray_cstpncpy_#t~mem0.offset| lambda) 0)
 (* (* |ray_(select #length cstpncpy_~d~3.base)| lambda) 0)
 (* (* |ray_cstpncpy_#t~post4.offset| lambda) 0)
 (* (* ray_cstpncpy_~s~3.offset lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 lambda) 0)
 (* (* |ray_(select old(#length) cstpncpy_#in~src.base)| lambda) 0)
 (* (* |ray_cstpncpy_~#dst.offset| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 lambda) 0) (* (* |ray_cstpncpy_#t~mem7| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 lambda) 0) (* (* ray_cstpncpy_~d~3.base lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 lambda) 0) (* (* |ray_(select #length cstpncpy_#in~src.base)| lambda) 0)
 (* (* |ray_cstpncpy_#in~src.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| lambda) 0)
 (* (* |ray_cstpncpy_#t~mem1.offset| lambda) 0)
 (* (* |ray_(select #length cstpncpy_#in~dst.base)| lambda) 0)
 (* (* |ray_cstpncpy_#t~mem0.base| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_cstpncpy_#in~n| lambda) 0)
 (* (* |ray_cstpncpy_#t~mem1.base| lambda) 0)
 (* (* |ray_cstpncpy_#t~post5.base| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(select old(#length) cstpncpy_~#dst.base)| lambda) 0)
 (* (* |ray_(ite (select #valid cstpncpy_~d~3.base) 1 0)| lambda) 0)
 (* (* ray_cstpncpy_~s~3.base lambda) 0)
 (*
 (*
 |ray_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 lambda) 0) (* (* |ray_(select #length cstpncpy_~s~3.base)| lambda) 0)
 (* (* ray_cstpncpy_~n lambda) 0)
 (* (* |ray_cstpncpy_#in~dst.base| lambda) 0)
 (* (* |ray_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length cstpncpy_~#dst.base)| lambda) 0)
 (* (* |ray_cstpncpy_#t~post4.base| lambda) 0)
 (* (* |ray_(ite (select #valid cstpncpy_~#dst.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) cstpncpy_#in~dst.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| lambda) 0)
 (* (* |ray_cstpncpy_#t~post5.offset| lambda) 0)
 (* (* |ray_(ite (select #valid cstpncpy_#in~src.base) 1 0)| lambda) 0)
 (* (* |ray_cstpncpy_#in~dst.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid cstpncpy_~s~3.base) 1 0)| lambda) 0)
 (* (* ray_cstpncpy_~src.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* ray_cstpncpy_~d~3.offset lambda) 0)
 (* (* |ray_cstpncpy_#t~post3| lambda) 0)
 (* (* |ray_cstpncpy_~#dst.base| lambda) 0)
 (* (* ray_cstpncpy_~src.offset lambda) 0)
 (* (* |ray_cstpncpy_#in~src.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| lambda) 0)
 (* |ray_(select #length cstpncpy_~d~3.base)| 0)
 (* |ray_cstpncpy_#t~post4.offset| 0) 
 (* ray_cstpncpy_~s~3.offset 0)
 (*
 |ray_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |ray_cstpncpy_#t~mem7| 0) 
 (* ray_cstpncpy_~d~3.base 0) 
 (* |ray_cstpncpy_#t~post5.base| 0)
 (* |ray_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (* ray_cstpncpy_~s~3.base 0) 
 (* |ray_(select #length cstpncpy_~s~3.base)| 0) 
 (* ray_cstpncpy_~n (- 1)) 
 (* |ray_cstpncpy_#t~post4.base| 0) 
 (* |ray_cstpncpy_#t~post5.offset| 0)
 (* |ray_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* ray_cstpncpy_~d~3.offset 0) 
 (* |ray_cstpncpy_#t~post3| 0) 
 (* aux_3734 1) (* aux_3735 4294967296)) 0)
 (>=
 (+ (* (* |ray_cstpncpy_#t~mem0.offset| lambda) 0)
 (* (* |ray_(select #length cstpncpy_~d~3.base)| lambda) 0)
 (* (* |ray_cstpncpy_#t~post4.offset| lambda) 0)
 (* (* ray_cstpncpy_~s~3.offset lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 lambda) 0)
 (* (* |ray_(select old(#length) cstpncpy_#in~src.base)| lambda) 0)
 (* (* |ray_cstpncpy_~#dst.offset| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 lambda) 0) (* (* |ray_cstpncpy_#t~mem7| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 lambda) 0) (* (* ray_cstpncpy_~d~3.base lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 lambda) 0) (* (* |ray_(select #length cstpncpy_#in~src.base)| lambda) 0)
 (* (* |ray_cstpncpy_#in~src.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| lambda) 0)
 (* (* |ray_cstpncpy_#t~mem1.offset| lambda) 0)
 (* (* |ray_(select #length cstpncpy_#in~dst.base)| lambda) 0)
 (* (* |ray_cstpncpy_#t~mem0.base| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_cstpncpy_#in~n| lambda) 0)
 (* (* |ray_cstpncpy_#t~mem1.base| lambda) 0)
 (* (* |ray_cstpncpy_#t~post5.base| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(select old(#length) cstpncpy_~#dst.base)| lambda) 0)
 (* (* |ray_(ite (select #valid cstpncpy_~d~3.base) 1 0)| lambda) 0)
 (* (* ray_cstpncpy_~s~3.base lambda) 0)
 (*
 (*
 |ray_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 lambda) 0) (* (* |ray_(select #length cstpncpy_~s~3.base)| lambda) 0)
 (* (* ray_cstpncpy_~n lambda) 0)
 (* (* |ray_cstpncpy_#in~dst.base| lambda) 0)
 (* (* |ray_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length cstpncpy_~#dst.base)| lambda) 0)
 (* (* |ray_cstpncpy_#t~post4.base| lambda) 0)
 (* (* |ray_(ite (select #valid cstpncpy_~#dst.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) cstpncpy_#in~dst.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| lambda) 0)
 (* (* |ray_cstpncpy_#t~post5.offset| lambda) 0)
 (* (* |ray_(ite (select #valid cstpncpy_#in~src.base) 1 0)| lambda) 0)
 (* (* |ray_cstpncpy_#in~dst.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid cstpncpy_~s~3.base) 1 0)| lambda) 0)
 (* (* ray_cstpncpy_~src.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* ray_cstpncpy_~d~3.offset lambda) 0)
 (* (* |ray_cstpncpy_#t~post3| lambda) 0)
 (* (* |ray_cstpncpy_~#dst.base| lambda) 0)
 (* (* ray_cstpncpy_~src.offset lambda) 0)
 (* (* |ray_cstpncpy_#in~src.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| lambda) 0)
 (* |ray_(select #length cstpncpy_~d~3.base)| 0)
 (* |ray_cstpncpy_#t~post4.offset| 0) 
 (* ray_cstpncpy_~s~3.offset 0)
 (*
 |ray_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |ray_cstpncpy_#t~mem7| 0) 
 (* ray_cstpncpy_~d~3.base 0) 
 (* |ray_cstpncpy_#t~post5.base| 0)
 (* |ray_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (* ray_cstpncpy_~s~3.base 0) 
 (* |ray_(select #length cstpncpy_~s~3.base)| 0) 
 (* ray_cstpncpy_~n 0) (* |ray_cstpncpy_#t~post4.base| 0)
 (* |ray_cstpncpy_#t~post5.offset| 0)
 (* |ray_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* ray_cstpncpy_~d~3.offset 0) 
 (* |ray_cstpncpy_#t~post3| 0) 
 (* aux_3734 (- 1))) 0)
 (>=
 (+ (* (* |ray_cstpncpy_#t~mem0.offset| lambda) 0)
 (* (* |ray_(select #length cstpncpy_~d~3.base)| lambda) 0)
 (* (* |ray_cstpncpy_#t~post4.offset| lambda) 0)
 (* (* ray_cstpncpy_~s~3.offset lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 lambda) 0)
 (* (* |ray_(select old(#length) cstpncpy_#in~src.base)| lambda) 0)
 (* (* |ray_cstpncpy_~#dst.offset| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 lambda) 0) (* (* |ray_cstpncpy_#t~mem7| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 lambda) 0) (* (* ray_cstpncpy_~d~3.base lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 lambda) 0) (* (* |ray_(select #length cstpncpy_#in~src.base)| lambda) 0)
 (* (* |ray_cstpncpy_#in~src.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| lambda) 0)
 (* (* |ray_cstpncpy_#t~mem1.offset| lambda) 0)
 (* (* |ray_(select #length cstpncpy_#in~dst.base)| lambda) 0)
 (* (* |ray_cstpncpy_#t~mem0.base| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_cstpncpy_#in~n| lambda) 0)
 (* (* |ray_cstpncpy_#t~mem1.base| lambda) 0)
 (* (* |ray_cstpncpy_#t~post5.base| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(select old(#length) cstpncpy_~#dst.base)| lambda) 0)
 (* (* |ray_(ite (select #valid cstpncpy_~d~3.base) 1 0)| lambda) 0)
 (* (* ray_cstpncpy_~s~3.base lambda) 0)
 (*
 (*
 |ray_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 lambda) 0) (* (* |ray_(select #length cstpncpy_~s~3.base)| lambda) 0)
 (* (* ray_cstpncpy_~n lambda) 0)
 (* (* |ray_cstpncpy_#in~dst.base| lambda) 0)
 (* (* |ray_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length cstpncpy_~#dst.base)| lambda) 0)
 (* (* |ray_cstpncpy_#t~post4.base| lambda) 0)
 (* (* |ray_(ite (select #valid cstpncpy_~#dst.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) cstpncpy_#in~dst.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| lambda) 0)
 (* (* |ray_cstpncpy_#t~post5.offset| lambda) 0)
 (* (* |ray_(ite (select #valid cstpncpy_#in~src.base) 1 0)| lambda) 0)
 (* (* |ray_cstpncpy_#in~dst.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid cstpncpy_~s~3.base) 1 0)| lambda) 0)
 (* (* ray_cstpncpy_~src.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* ray_cstpncpy_~d~3.offset lambda) 0)
 (* (* |ray_cstpncpy_#t~post3| lambda) 0)
 (* (* |ray_cstpncpy_~#dst.base| lambda) 0)
 (* (* ray_cstpncpy_~src.offset lambda) 0)
 (* (* |ray_cstpncpy_#in~src.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| lambda) 0)
 (* |ray_(select #length cstpncpy_~d~3.base)| 0)
 (* |ray_cstpncpy_#t~post4.offset| 0) 
 (* ray_cstpncpy_~s~3.offset 0)
 (*
 |ray_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |ray_cstpncpy_#t~mem7| 0) 
 (* ray_cstpncpy_~d~3.base 0) 
 (* |ray_cstpncpy_#t~post5.base| 0)
 (* |ray_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (* ray_cstpncpy_~s~3.base 0) 
 (* |ray_(select #length cstpncpy_~s~3.base)| 0) 
 (* ray_cstpncpy_~n 1) (* |ray_cstpncpy_#t~post4.base| 0)
 (* |ray_cstpncpy_#t~post5.offset| 0)
 (* |ray_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* ray_cstpncpy_~d~3.offset 0) 
 (* |ray_cstpncpy_#t~post3| 0) 
 (* aux_3734 (- 1)) (* aux_3735 (- 4294967296))) 0)
 (>=
 (+ (* (* |ray_cstpncpy_#t~mem0.offset| lambda) 0)
 (* (* |ray_(select #length cstpncpy_~d~3.base)| lambda) 0)
 (* (* |ray_cstpncpy_#t~post4.offset| lambda) 0)
 (* (* ray_cstpncpy_~s~3.offset lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 lambda) 0)
 (* (* |ray_(select old(#length) cstpncpy_#in~src.base)| lambda) 0)
 (* (* |ray_cstpncpy_~#dst.offset| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 lambda) 0) (* (* |ray_cstpncpy_#t~mem7| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 lambda) 0) (* (* ray_cstpncpy_~d~3.base lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 lambda) 0) (* (* |ray_(select #length cstpncpy_#in~src.base)| lambda) 0)
 (* (* |ray_cstpncpy_#in~src.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| lambda) 0)
 (* (* |ray_cstpncpy_#t~mem1.offset| lambda) 0)
 (* (* |ray_(select #length cstpncpy_#in~dst.base)| lambda) 0)
 (* (* |ray_cstpncpy_#t~mem0.base| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_cstpncpy_#in~n| lambda) 0)
 (* (* |ray_cstpncpy_#t~mem1.base| lambda) 0)
 (* (* |ray_cstpncpy_#t~post5.base| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(select old(#length) cstpncpy_~#dst.base)| lambda) 0)
 (* (* |ray_(ite (select #valid cstpncpy_~d~3.base) 1 0)| lambda) 0)
 (* (* ray_cstpncpy_~s~3.base lambda) 0)
 (*
 (*
 |ray_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 lambda) 0) (* (* |ray_(select #length cstpncpy_~s~3.base)| lambda) 0)
 (* (* ray_cstpncpy_~n lambda) 0)
 (* (* |ray_cstpncpy_#in~dst.base| lambda) 0)
 (* (* |ray_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length cstpncpy_~#dst.base)| lambda) 0)
 (* (* |ray_cstpncpy_#t~post4.base| lambda) 0)
 (* (* |ray_(ite (select #valid cstpncpy_~#dst.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) cstpncpy_#in~dst.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| lambda) 0)
 (* (* |ray_cstpncpy_#t~post5.offset| lambda) 0)
 (* (* |ray_(ite (select #valid cstpncpy_#in~src.base) 1 0)| lambda) 0)
 (* (* |ray_cstpncpy_#in~dst.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid cstpncpy_~s~3.base) 1 0)| lambda) 0)
 (* (* ray_cstpncpy_~src.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* ray_cstpncpy_~d~3.offset lambda) 0)
 (* (* |ray_cstpncpy_#t~post3| lambda) 0)
 (* (* |ray_cstpncpy_~#dst.base| lambda) 0)
 (* (* ray_cstpncpy_~src.offset lambda) 0)
 (* (* |ray_cstpncpy_#in~src.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| lambda) 0)
 (* |ray_(select #length cstpncpy_~d~3.base)| 0)
 (* |ray_cstpncpy_#t~post4.offset| 0) 
 (* ray_cstpncpy_~s~3.offset 0)
 (*
 |ray_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |ray_cstpncpy_#t~mem7| 0) 
 (* ray_cstpncpy_~d~3.base 0) 
 (* |ray_cstpncpy_#t~post5.base| 0)
 (* |ray_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (* ray_cstpncpy_~s~3.base 0) 
 (* |ray_(select #length cstpncpy_~s~3.base)| 0) 
 (* ray_cstpncpy_~n 0) (* |ray_cstpncpy_#t~post4.base| 0)
 (* |ray_cstpncpy_#t~post5.offset| 0)
 (* |ray_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* ray_cstpncpy_~d~3.offset 0) 
 (* |ray_cstpncpy_#t~post3| 0) 
 (* aux_3739 (- 1)) (* aux_3740 (- 4294967296))) 0)
 (>=
 (+ (* (* |ray_cstpncpy_#t~mem0.offset| lambda) 0)
 (* (* |ray_(select #length cstpncpy_~d~3.base)| lambda) 0)
 (* (* |ray_cstpncpy_#t~post4.offset| lambda) 0)
 (* (* ray_cstpncpy_~s~3.offset lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 lambda) 0)
 (* (* |ray_(select old(#length) cstpncpy_#in~src.base)| lambda) 0)
 (* (* |ray_cstpncpy_~#dst.offset| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 lambda) 0) (* (* |ray_cstpncpy_#t~mem7| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 lambda) 0) (* (* ray_cstpncpy_~d~3.base lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 lambda) 0) (* (* |ray_(select #length cstpncpy_#in~src.base)| lambda) 0)
 (* (* |ray_cstpncpy_#in~src.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| lambda) 0)
 (* (* |ray_cstpncpy_#t~mem1.offset| lambda) 0)
 (* (* |ray_(select #length cstpncpy_#in~dst.base)| lambda) 0)
 (* (* |ray_cstpncpy_#t~mem0.base| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_cstpncpy_#in~n| lambda) 0)
 (* (* |ray_cstpncpy_#t~mem1.base| lambda) 0)
 (* (* |ray_cstpncpy_#t~post5.base| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(select old(#length) cstpncpy_~#dst.base)| lambda) 0)
 (* (* |ray_(ite (select #valid cstpncpy_~d~3.base) 1 0)| lambda) 0)
 (* (* ray_cstpncpy_~s~3.base lambda) 0)
 (*
 (*
 |ray_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 lambda) 0) (* (* |ray_(select #length cstpncpy_~s~3.base)| lambda) 0)
 (* (* ray_cstpncpy_~n lambda) 0)
 (* (* |ray_cstpncpy_#in~dst.base| lambda) 0)
 (* (* |ray_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length cstpncpy_~#dst.base)| lambda) 0)
 (* (* |ray_cstpncpy_#t~post4.base| lambda) 0)
 (* (* |ray_(ite (select #valid cstpncpy_~#dst.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) cstpncpy_#in~dst.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| lambda) 0)
 (* (* |ray_cstpncpy_#t~post5.offset| lambda) 0)
 (* (* |ray_(ite (select #valid cstpncpy_#in~src.base) 1 0)| lambda) 0)
 (* (* |ray_cstpncpy_#in~dst.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid cstpncpy_~s~3.base) 1 0)| lambda) 0)
 (* (* ray_cstpncpy_~src.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* ray_cstpncpy_~d~3.offset lambda) 0)
 (* (* |ray_cstpncpy_#t~post3| lambda) 0)
 (* (* |ray_cstpncpy_~#dst.base| lambda) 0)
 (* (* ray_cstpncpy_~src.offset lambda) 0)
 (* (* |ray_cstpncpy_#in~src.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| lambda) 0)
 (* |ray_(select #length cstpncpy_~d~3.base)| 0)
 (* |ray_cstpncpy_#t~post4.offset| 0) 
 (* ray_cstpncpy_~s~3.offset 0)
 (*
 |ray_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |ray_cstpncpy_#t~mem7| 0) 
 (* ray_cstpncpy_~d~3.base 0) 
 (* |ray_cstpncpy_#t~post5.base| 0)
 (* |ray_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (* ray_cstpncpy_~s~3.base 0) 
 (* |ray_(select #length cstpncpy_~s~3.base)| 0) 
 (* ray_cstpncpy_~n 0) (* |ray_cstpncpy_#t~post4.base| 0)
 (* |ray_cstpncpy_#t~post5.offset| 0)
 (* |ray_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* ray_cstpncpy_~d~3.offset 0) 
 (* |ray_cstpncpy_#t~post3| 0) 
 (* aux_3739 1) (* aux_3740 4294967296)) 0)
 (>=
 (+ (* (* |ray_cstpncpy_#t~mem0.offset| lambda) 0)
 (* (* |ray_(select #length cstpncpy_~d~3.base)| lambda) 0)
 (* (* |ray_cstpncpy_#t~post4.offset| lambda) 0)
 (* (* ray_cstpncpy_~s~3.offset lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 lambda) 0)
 (* (* |ray_(select old(#length) cstpncpy_#in~src.base)| lambda) 0)
 (* (* |ray_cstpncpy_~#dst.offset| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 lambda) 0) (* (* |ray_cstpncpy_#t~mem7| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 lambda) 0) (* (* ray_cstpncpy_~d~3.base lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 lambda) 0) (* (* |ray_(select #length cstpncpy_#in~src.base)| lambda) 0)
 (* (* |ray_cstpncpy_#in~src.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| lambda) 0)
 (* (* |ray_cstpncpy_#t~mem1.offset| lambda) 0)
 (* (* |ray_(select #length cstpncpy_#in~dst.base)| lambda) 0)
 (* (* |ray_cstpncpy_#t~mem0.base| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_cstpncpy_#in~n| lambda) 0)
 (* (* |ray_cstpncpy_#t~mem1.base| lambda) 0)
 (* (* |ray_cstpncpy_#t~post5.base| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(select old(#length) cstpncpy_~#dst.base)| lambda) 0)
 (* (* |ray_(ite (select #valid cstpncpy_~d~3.base) 1 0)| lambda) 0)
 (* (* ray_cstpncpy_~s~3.base lambda) 0)
 (*
 (*
 |ray_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 lambda) 0) (* (* |ray_(select #length cstpncpy_~s~3.base)| lambda) 0)
 (* (* ray_cstpncpy_~n lambda) 0)
 (* (* |ray_cstpncpy_#in~dst.base| lambda) 0)
 (* (* |ray_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length cstpncpy_~#dst.base)| lambda) 0)
 (* (* |ray_cstpncpy_#t~post4.base| lambda) 0)
 (* (* |ray_(ite (select #valid cstpncpy_~#dst.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) cstpncpy_#in~dst.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| lambda) 0)
 (* (* |ray_cstpncpy_#t~post5.offset| lambda) 0)
 (* (* |ray_(ite (select #valid cstpncpy_#in~src.base) 1 0)| lambda) 0)
 (* (* |ray_cstpncpy_#in~dst.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid cstpncpy_~s~3.base) 1 0)| lambda) 0)
 (* (* ray_cstpncpy_~src.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* ray_cstpncpy_~d~3.offset lambda) 0)
 (* (* |ray_cstpncpy_#t~post3| lambda) 0)
 (* (* |ray_cstpncpy_~#dst.base| lambda) 0)
 (* (* ray_cstpncpy_~src.offset lambda) 0)
 (* (* |ray_cstpncpy_#in~src.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| lambda) 0)
 (* |ray_(select #length cstpncpy_~d~3.base)| 0)
 (* |ray_cstpncpy_#t~post4.offset| 0) 
 (* ray_cstpncpy_~s~3.offset 0)
 (*
 |ray_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |ray_cstpncpy_#t~mem7| 0) 
 (* ray_cstpncpy_~d~3.base 0) 
 (* |ray_cstpncpy_#t~post5.base| 0)
 (* |ray_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (* ray_cstpncpy_~s~3.base 0) 
 (* |ray_(select #length cstpncpy_~s~3.base)| 0) 
 (* ray_cstpncpy_~n 0) (* |ray_cstpncpy_#t~post4.base| 0)
 (* |ray_cstpncpy_#t~post5.offset| 0)
 (* |ray_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* ray_cstpncpy_~d~3.offset 0) 
 (* |ray_cstpncpy_#t~post3| 0) 
 (* aux_3739 1)) 0)
 (>=
 (+ (* (* |ray_cstpncpy_#t~mem0.offset| lambda) 0)
 (* (* |ray_(select #length cstpncpy_~d~3.base)| lambda) 1)
 (* (* |ray_cstpncpy_#t~post4.offset| lambda) 0)
 (* (* ray_cstpncpy_~s~3.offset lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 lambda) 0)
 (* (* |ray_(select old(#length) cstpncpy_#in~src.base)| lambda) 0)
 (* (* |ray_cstpncpy_~#dst.offset| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 lambda) 0) (* (* |ray_cstpncpy_#t~mem7| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 lambda) 0) (* (* ray_cstpncpy_~d~3.base lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 lambda) 0) (* (* |ray_(select #length cstpncpy_#in~src.base)| lambda) 0)
 (* (* |ray_cstpncpy_#in~src.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| lambda) 0)
 (* (* |ray_cstpncpy_#t~mem1.offset| lambda) 0)
 (* (* |ray_(select #length cstpncpy_#in~dst.base)| lambda) 0)
 (* (* |ray_cstpncpy_#t~mem0.base| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_cstpncpy_#in~n| lambda) 0)
 (* (* |ray_cstpncpy_#t~mem1.base| lambda) 0)
 (* (* |ray_cstpncpy_#t~post5.base| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(select old(#length) cstpncpy_~#dst.base)| lambda) 0)
 (* (* |ray_(ite (select #valid cstpncpy_~d~3.base) 1 0)| lambda) 0)
 (* (* ray_cstpncpy_~s~3.base lambda) 0)
 (*
 (*
 |ray_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 lambda) 0) (* (* |ray_(select #length cstpncpy_~s~3.base)| lambda) 0)
 (* (* ray_cstpncpy_~n lambda) 0)
 (* (* |ray_cstpncpy_#in~dst.base| lambda) 0)
 (* (* |ray_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length cstpncpy_~#dst.base)| lambda) 0)
 (* (* |ray_cstpncpy_#t~post4.base| lambda) 0)
 (* (* |ray_(ite (select #valid cstpncpy_~#dst.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) cstpncpy_#in~dst.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| lambda) 0)
 (* (* |ray_cstpncpy_#t~post5.offset| lambda) 0)
 (* (* |ray_(ite (select #valid cstpncpy_#in~src.base) 1 0)| lambda) 0)
 (* (* |ray_cstpncpy_#in~dst.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid cstpncpy_~s~3.base) 1 0)| lambda) 0)
 (* (* ray_cstpncpy_~src.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* ray_cstpncpy_~d~3.offset lambda) 0)
 (* (* |ray_cstpncpy_#t~post3| lambda) 0)
 (* (* |ray_cstpncpy_~#dst.base| lambda) 0)
 (* (* ray_cstpncpy_~src.offset lambda) 0)
 (* (* |ray_cstpncpy_#in~src.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| lambda) 0)
 (* |ray_(select #length cstpncpy_~d~3.base)| (- 1))
 (* |ray_cstpncpy_#t~post4.offset| 0) 
 (* ray_cstpncpy_~s~3.offset 0)
 (*
 |ray_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |ray_cstpncpy_#t~mem7| 0) 
 (* ray_cstpncpy_~d~3.base 0) 
 (* |ray_cstpncpy_#t~post5.base| 0)
 (* |ray_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (* ray_cstpncpy_~s~3.base 0) 
 (* |ray_(select #length cstpncpy_~s~3.base)| 0) 
 (* ray_cstpncpy_~n 0) (* |ray_cstpncpy_#t~post4.base| 0)
 (* |ray_cstpncpy_#t~post5.offset| 0)
 (* |ray_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* ray_cstpncpy_~d~3.offset 0) 
 (* |ray_cstpncpy_#t~post3| 0)) 0)
 (>=
 (+ (* (* |ray_cstpncpy_#t~mem0.offset| lambda) 0)
 (* (* |ray_(select #length cstpncpy_~d~3.base)| lambda) 0)
 (* (* |ray_cstpncpy_#t~post4.offset| lambda) 0)
 (* (* ray_cstpncpy_~s~3.offset lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 lambda) 0)
 (* (* |ray_(select old(#length) cstpncpy_#in~src.base)| lambda) 0)
 (* (* |ray_cstpncpy_~#dst.offset| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 lambda) 0) (* (* |ray_cstpncpy_#t~mem7| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 lambda) 0) (* (* ray_cstpncpy_~d~3.base lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 lambda) 0) (* (* |ray_(select #length cstpncpy_#in~src.base)| lambda) 0)
 (* (* |ray_cstpncpy_#in~src.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| lambda) 0)
 (* (* |ray_cstpncpy_#t~mem1.offset| lambda) 0)
 (* (* |ray_(select #length cstpncpy_#in~dst.base)| lambda) 0)
 (* (* |ray_cstpncpy_#t~mem0.base| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_cstpncpy_#in~n| lambda) 0)
 (* (* |ray_cstpncpy_#t~mem1.base| lambda) 0)
 (* (* |ray_cstpncpy_#t~post5.base| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(select old(#length) cstpncpy_~#dst.base)| lambda) 0)
 (* (* |ray_(ite (select #valid cstpncpy_~d~3.base) 1 0)| lambda) 0)
 (* (* ray_cstpncpy_~s~3.base lambda) (- 1))
 (*
 (*
 |ray_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 lambda) 0) (* (* |ray_(select #length cstpncpy_~s~3.base)| lambda) 0)
 (* (* ray_cstpncpy_~n lambda) 0)
 (* (* |ray_cstpncpy_#in~dst.base| lambda) 0)
 (* (* |ray_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length cstpncpy_~#dst.base)| lambda) 0)
 (* (* |ray_cstpncpy_#t~post4.base| lambda) 0)
 (* (* |ray_(ite (select #valid cstpncpy_~#dst.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) cstpncpy_#in~dst.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| lambda) 0)
 (* (* |ray_cstpncpy_#t~post5.offset| lambda) 0)
 (* (* |ray_(ite (select #valid cstpncpy_#in~src.base) 1 0)| lambda) 0)
 (* (* |ray_cstpncpy_#in~dst.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid cstpncpy_~s~3.base) 1 0)| lambda) 0)
 (* (* ray_cstpncpy_~src.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* ray_cstpncpy_~d~3.offset lambda) 0)
 (* (* |ray_cstpncpy_#t~post3| lambda) 0)
 (* (* |ray_cstpncpy_~#dst.base| lambda) 0)
 (* (* ray_cstpncpy_~src.offset lambda) 0)
 (* (* |ray_cstpncpy_#in~src.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| lambda) 0)
 (* |ray_(select #length cstpncpy_~d~3.base)| 0)
 (* |ray_cstpncpy_#t~post4.offset| 0) 
 (* ray_cstpncpy_~s~3.offset 0)
 (*
 |ray_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |ray_cstpncpy_#t~mem7| 0) 
 (* ray_cstpncpy_~d~3.base 0) 
 (* |ray_cstpncpy_#t~post5.base| 0)
 (* |ray_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (* ray_cstpncpy_~s~3.base 1) 
 (* |ray_(select #length cstpncpy_~s~3.base)| 0) 
 (* ray_cstpncpy_~n 0) (* |ray_cstpncpy_#t~post4.base| 0)
 (* |ray_cstpncpy_#t~post5.offset| 0)
 (* |ray_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* ray_cstpncpy_~d~3.offset 0) 
 (* |ray_cstpncpy_#t~post3| 0)) 0)
 (>=
 (+ (* (* |ray_cstpncpy_#t~mem0.offset| lambda) 0)
 (* (* |ray_(select #length cstpncpy_~d~3.base)| lambda) 0)
 (* (* |ray_cstpncpy_#t~post4.offset| lambda) 0)
 (* (* ray_cstpncpy_~s~3.offset lambda) 1)
 (*
 (*
 |ray_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 lambda) 0)
 (* (* |ray_(select old(#length) cstpncpy_#in~src.base)| lambda) 0)
 (* (* |ray_cstpncpy_~#dst.offset| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 lambda) 0) (* (* |ray_cstpncpy_#t~mem7| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 lambda) 0) (* (* ray_cstpncpy_~d~3.base lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 lambda) 0) (* (* |ray_(select #length cstpncpy_#in~src.base)| lambda) 0)
 (* (* |ray_cstpncpy_#in~src.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| lambda) 0)
 (* (* |ray_cstpncpy_#t~mem1.offset| lambda) 0)
 (* (* |ray_(select #length cstpncpy_#in~dst.base)| lambda) 0)
 (* (* |ray_cstpncpy_#t~mem0.base| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_cstpncpy_#in~n| lambda) 0)
 (* (* |ray_cstpncpy_#t~mem1.base| lambda) 0)
 (* (* |ray_cstpncpy_#t~post5.base| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(select old(#length) cstpncpy_~#dst.base)| lambda) 0)
 (* (* |ray_(ite (select #valid cstpncpy_~d~3.base) 1 0)| lambda) 0)
 (* (* ray_cstpncpy_~s~3.base lambda) 0)
 (*
 (*
 |ray_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 lambda) 0) (* (* |ray_(select #length cstpncpy_~s~3.base)| lambda) 0)
 (* (* ray_cstpncpy_~n lambda) 0)
 (* (* |ray_cstpncpy_#in~dst.base| lambda) 0)
 (* (* |ray_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length cstpncpy_~#dst.base)| lambda) 0)
 (* (* |ray_cstpncpy_#t~post4.base| lambda) 0)
 (* (* |ray_(ite (select #valid cstpncpy_~#dst.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) cstpncpy_#in~dst.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| lambda) 0)
 (* (* |ray_cstpncpy_#t~post5.offset| lambda) 0)
 (* (* |ray_(ite (select #valid cstpncpy_#in~src.base) 1 0)| lambda) 0)
 (* (* |ray_cstpncpy_#in~dst.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid cstpncpy_~s~3.base) 1 0)| lambda) 0)
 (* (* ray_cstpncpy_~src.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* ray_cstpncpy_~d~3.offset lambda) 0)
 (* (* |ray_cstpncpy_#t~post3| lambda) 0)
 (* (* |ray_cstpncpy_~#dst.base| lambda) 0)
 (* (* ray_cstpncpy_~src.offset lambda) 0)
 (* (* |ray_cstpncpy_#in~src.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| lambda) 0)
 (* |ray_(select #length cstpncpy_~d~3.base)| 0)
 (* |ray_cstpncpy_#t~post4.offset| 0) 
 (* ray_cstpncpy_~s~3.offset (- 1))
 (*
 |ray_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |ray_cstpncpy_#t~mem7| 0) 
 (* ray_cstpncpy_~d~3.base 0) 
 (* |ray_cstpncpy_#t~post5.base| 0)
 (* |ray_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (* ray_cstpncpy_~s~3.base 0) 
 (* |ray_(select #length cstpncpy_~s~3.base)| 0) 
 (* ray_cstpncpy_~n 0) (* |ray_cstpncpy_#t~post4.base| 0)
 (* |ray_cstpncpy_#t~post5.offset| 0)
 (* |ray_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* ray_cstpncpy_~d~3.offset 0) 
 (* |ray_cstpncpy_#t~post3| 0)) 0)
 (>=
 (+ (* (* |ray_cstpncpy_#t~mem0.offset| lambda) 0)
 (* (* |ray_(select #length cstpncpy_~d~3.base)| lambda) 0)
 (* (* |ray_cstpncpy_#t~post4.offset| lambda) 0)
 (* (* ray_cstpncpy_~s~3.offset lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 lambda) 0)
 (* (* |ray_(select old(#length) cstpncpy_#in~src.base)| lambda) 0)
 (* (* |ray_cstpncpy_~#dst.offset| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 lambda) 0) (* (* |ray_cstpncpy_#t~mem7| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 lambda) 0) (* (* ray_cstpncpy_~d~3.base lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 lambda) 0) (* (* |ray_(select #length cstpncpy_#in~src.base)| lambda) 0)
 (* (* |ray_cstpncpy_#in~src.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| lambda) 0)
 (* (* |ray_cstpncpy_#t~mem1.offset| lambda) 0)
 (* (* |ray_(select #length cstpncpy_#in~dst.base)| lambda) 0)
 (* (* |ray_cstpncpy_#t~mem0.base| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_cstpncpy_#in~n| lambda) 0)
 (* (* |ray_cstpncpy_#t~mem1.base| lambda) 0)
 (* (* |ray_cstpncpy_#t~post5.base| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(select old(#length) cstpncpy_~#dst.base)| lambda) 0)
 (* (* |ray_(ite (select #valid cstpncpy_~d~3.base) 1 0)| lambda) 0)
 (* (* ray_cstpncpy_~s~3.base lambda) 0)
 (*
 (*
 |ray_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 lambda) 0) (* (* |ray_(select #length cstpncpy_~s~3.base)| lambda) 0)
 (* (* ray_cstpncpy_~n lambda) 0)
 (* (* |ray_cstpncpy_#in~dst.base| lambda) 0)
 (* (* |ray_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length cstpncpy_~#dst.base)| lambda) 0)
 (* (* |ray_cstpncpy_#t~post4.base| lambda) 0)
 (* (* |ray_(ite (select #valid cstpncpy_~#dst.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) cstpncpy_#in~dst.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| lambda) 0)
 (* (* |ray_cstpncpy_#t~post5.offset| lambda) 0)
 (* (* |ray_(ite (select #valid cstpncpy_#in~src.base) 1 0)| lambda) 0)
 (* (* |ray_cstpncpy_#in~dst.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid cstpncpy_~s~3.base) 1 0)| lambda) 0)
 (* (* ray_cstpncpy_~src.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* ray_cstpncpy_~d~3.offset lambda) 0)
 (* (* |ray_cstpncpy_#t~post3| lambda) 0)
 (* (* |ray_cstpncpy_~#dst.base| lambda) 0)
 (* (* ray_cstpncpy_~src.offset lambda) 0)
 (* (* |ray_cstpncpy_#in~src.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| lambda) 0)
 (* |ray_(select #length cstpncpy_~d~3.base)| 0)
 (* |ray_cstpncpy_#t~post4.offset| 0) 
 (* ray_cstpncpy_~s~3.offset 0)
 (*
 |ray_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |ray_cstpncpy_#t~mem7| 0) 
 (* ray_cstpncpy_~d~3.base 0) 
 (* |ray_cstpncpy_#t~post5.base| 0)
 (* |ray_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (* ray_cstpncpy_~s~3.base 0) 
 (* |ray_(select #length cstpncpy_~s~3.base)| 0) 
 (* ray_cstpncpy_~n 0) (* |ray_cstpncpy_#t~post4.base| 0)
 (* |ray_cstpncpy_#t~post5.offset| 0)
 (* |ray_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 1)
 (* ray_cstpncpy_~d~3.offset 0) 
 (* |ray_cstpncpy_#t~post3| 0)) 0)
 (>=
 (+ (* (* |ray_cstpncpy_#t~mem0.offset| lambda) 0)
 (* (* |ray_(select #length cstpncpy_~d~3.base)| lambda) 0)
 (* (* |ray_cstpncpy_#t~post4.offset| lambda) 0)
 (* (* ray_cstpncpy_~s~3.offset lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 lambda) 0)
 (* (* |ray_(select old(#length) cstpncpy_#in~src.base)| lambda) 0)
 (* (* |ray_cstpncpy_~#dst.offset| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 lambda) 0) (* (* |ray_cstpncpy_#t~mem7| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 lambda) 0) (* (* ray_cstpncpy_~d~3.base lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 lambda) 0) (* (* |ray_(select #length cstpncpy_#in~src.base)| lambda) 0)
 (* (* |ray_cstpncpy_#in~src.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| lambda) 0)
 (* (* |ray_cstpncpy_#t~mem1.offset| lambda) 0)
 (* (* |ray_(select #length cstpncpy_#in~dst.base)| lambda) 0)
 (* (* |ray_cstpncpy_#t~mem0.base| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_cstpncpy_#in~n| lambda) 0)
 (* (* |ray_cstpncpy_#t~mem1.base| lambda) 0)
 (* (* |ray_cstpncpy_#t~post5.base| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(select old(#length) cstpncpy_~#dst.base)| lambda) 0)
 (* (* |ray_(ite (select #valid cstpncpy_~d~3.base) 1 0)| lambda) 0)
 (* (* ray_cstpncpy_~s~3.base lambda) 0)
 (*
 (*
 |ray_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 lambda) 0) (* (* |ray_(select #length cstpncpy_~s~3.base)| lambda) 0)
 (* (* ray_cstpncpy_~n lambda) 1)
 (* (* |ray_cstpncpy_#in~dst.base| lambda) 0)
 (* (* |ray_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length cstpncpy_~#dst.base)| lambda) 0)
 (* (* |ray_cstpncpy_#t~post4.base| lambda) 0)
 (* (* |ray_(ite (select #valid cstpncpy_~#dst.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) cstpncpy_#in~dst.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| lambda) 0)
 (* (* |ray_cstpncpy_#t~post5.offset| lambda) 0)
 (* (* |ray_(ite (select #valid cstpncpy_#in~src.base) 1 0)| lambda) 0)
 (* (* |ray_cstpncpy_#in~dst.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid cstpncpy_~s~3.base) 1 0)| lambda) 0)
 (* (* ray_cstpncpy_~src.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* ray_cstpncpy_~d~3.offset lambda) 0)
 (* (* |ray_cstpncpy_#t~post3| lambda) 0)
 (* (* |ray_cstpncpy_~#dst.base| lambda) 0)
 (* (* ray_cstpncpy_~src.offset lambda) 0)
 (* (* |ray_cstpncpy_#in~src.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| lambda) 0)
 (* |ray_(select #length cstpncpy_~d~3.base)| 0)
 (* |ray_cstpncpy_#t~post4.offset| 0) 
 (* ray_cstpncpy_~s~3.offset 0)
 (*
 |ray_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |ray_cstpncpy_#t~mem7| 0) 
 (* ray_cstpncpy_~d~3.base 0) 
 (* |ray_cstpncpy_#t~post5.base| 0)
 (* |ray_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (* ray_cstpncpy_~s~3.base 0) 
 (* |ray_(select #length cstpncpy_~s~3.base)| 0) 
 (* ray_cstpncpy_~n (- 1)) 
 (* |ray_cstpncpy_#t~post4.base| 0) 
 (* |ray_cstpncpy_#t~post5.offset| 0)
 (* |ray_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* ray_cstpncpy_~d~3.offset 0) 
 (* |ray_cstpncpy_#t~post3| 0)) 0)
 (>=
 (+ (* (* |ray_cstpncpy_#t~mem0.offset| lambda) 0)
 (* (* |ray_(select #length cstpncpy_~d~3.base)| lambda) 0)
 (* (* |ray_cstpncpy_#t~post4.offset| lambda) 0)
 (* (* ray_cstpncpy_~s~3.offset lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 lambda) 0)
 (* (* |ray_(select old(#length) cstpncpy_#in~src.base)| lambda) 0)
 (* (* |ray_cstpncpy_~#dst.offset| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 lambda) 0) (* (* |ray_cstpncpy_#t~mem7| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 lambda) 0) (* (* ray_cstpncpy_~d~3.base lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 lambda) 0) (* (* |ray_(select #length cstpncpy_#in~src.base)| lambda) 0)
 (* (* |ray_cstpncpy_#in~src.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| lambda) 0)
 (* (* |ray_cstpncpy_#t~mem1.offset| lambda) 0)
 (* (* |ray_(select #length cstpncpy_#in~dst.base)| lambda) 0)
 (* (* |ray_cstpncpy_#t~mem0.base| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_cstpncpy_#in~n| lambda) 0)
 (* (* |ray_cstpncpy_#t~mem1.base| lambda) 0)
 (* (* |ray_cstpncpy_#t~post5.base| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(select old(#length) cstpncpy_~#dst.base)| lambda) 0)
 (* (* |ray_(ite (select #valid cstpncpy_~d~3.base) 1 0)| lambda) 0)
 (* (* ray_cstpncpy_~s~3.base lambda) 0)
 (*
 (*
 |ray_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 lambda) 0) (* (* |ray_(select #length cstpncpy_~s~3.base)| lambda) 1)
 (* (* ray_cstpncpy_~n lambda) 0)
 (* (* |ray_cstpncpy_#in~dst.base| lambda) 0)
 (* (* |ray_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length cstpncpy_~#dst.base)| lambda) 0)
 (* (* |ray_cstpncpy_#t~post4.base| lambda) 0)
 (* (* |ray_(ite (select #valid cstpncpy_~#dst.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) cstpncpy_#in~dst.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| lambda) 0)
 (* (* |ray_cstpncpy_#t~post5.offset| lambda) 0)
 (* (* |ray_(ite (select #valid cstpncpy_#in~src.base) 1 0)| lambda) 0)
 (* (* |ray_cstpncpy_#in~dst.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid cstpncpy_~s~3.base) 1 0)| lambda) 0)
 (* (* ray_cstpncpy_~src.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* ray_cstpncpy_~d~3.offset lambda) 0)
 (* (* |ray_cstpncpy_#t~post3| lambda) 0)
 (* (* |ray_cstpncpy_~#dst.base| lambda) 0)
 (* (* ray_cstpncpy_~src.offset lambda) 0)
 (* (* |ray_cstpncpy_#in~src.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| lambda) 0)
 (* |ray_(select #length cstpncpy_~d~3.base)| 0)
 (* |ray_cstpncpy_#t~post4.offset| 0) 
 (* ray_cstpncpy_~s~3.offset 0)
 (*
 |ray_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |ray_cstpncpy_#t~mem7| 0) 
 (* ray_cstpncpy_~d~3.base 0) 
 (* |ray_cstpncpy_#t~post5.base| 0)
 (* |ray_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (* ray_cstpncpy_~s~3.base 0)
 (* |ray_(select #length cstpncpy_~s~3.base)| (- 1)) 
 (* ray_cstpncpy_~n 0) (* |ray_cstpncpy_#t~post4.base| 0)
 (* |ray_cstpncpy_#t~post5.offset| 0)
 (* |ray_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* ray_cstpncpy_~d~3.offset 0) 
 (* |ray_cstpncpy_#t~post3| 0)) 0)
 (>=
 (+ (* (* |ray_cstpncpy_#t~mem0.offset| lambda) 0)
 (* (* |ray_(select #length cstpncpy_~d~3.base)| lambda) 0)
 (* (* |ray_cstpncpy_#t~post4.offset| lambda) 0)
 (* (* ray_cstpncpy_~s~3.offset lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 lambda) 0)
 (* (* |ray_(select old(#length) cstpncpy_#in~src.base)| lambda) 0)
 (* (* |ray_cstpncpy_~#dst.offset| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 lambda) 0) (* (* |ray_cstpncpy_#t~mem7| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 lambda) 0) (* (* ray_cstpncpy_~d~3.base lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 lambda) 0) (* (* |ray_(select #length cstpncpy_#in~src.base)| lambda) 0)
 (* (* |ray_cstpncpy_#in~src.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| lambda) 0)
 (* (* |ray_cstpncpy_#t~mem1.offset| lambda) 0)
 (* (* |ray_(select #length cstpncpy_#in~dst.base)| lambda) 0)
 (* (* |ray_cstpncpy_#t~mem0.base| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_cstpncpy_#in~n| lambda) 0)
 (* (* |ray_cstpncpy_#t~mem1.base| lambda) 0)
 (* (* |ray_cstpncpy_#t~post5.base| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(select old(#length) cstpncpy_~#dst.base)| lambda) 0)
 (* (* |ray_(ite (select #valid cstpncpy_~d~3.base) 1 0)| lambda) 0)
 (* (* ray_cstpncpy_~s~3.base lambda) 1)
 (*
 (*
 |ray_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 lambda) 0) (* (* |ray_(select #length cstpncpy_~s~3.base)| lambda) 0)
 (* (* ray_cstpncpy_~n lambda) 0)
 (* (* |ray_cstpncpy_#in~dst.base| lambda) 0)
 (* (* |ray_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length cstpncpy_~#dst.base)| lambda) 0)
 (* (* |ray_cstpncpy_#t~post4.base| lambda) 0)
 (* (* |ray_(ite (select #valid cstpncpy_~#dst.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) cstpncpy_#in~dst.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| lambda) 0)
 (* (* |ray_cstpncpy_#t~post5.offset| lambda) 0)
 (* (* |ray_(ite (select #valid cstpncpy_#in~src.base) 1 0)| lambda) 0)
 (* (* |ray_cstpncpy_#in~dst.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid cstpncpy_~s~3.base) 1 0)| lambda) 0)
 (* (* ray_cstpncpy_~src.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* ray_cstpncpy_~d~3.offset lambda) 0)
 (* (* |ray_cstpncpy_#t~post3| lambda) 0)
 (* (* |ray_cstpncpy_~#dst.base| lambda) 0)
 (* (* ray_cstpncpy_~src.offset lambda) 0)
 (* (* |ray_cstpncpy_#in~src.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| lambda) 0)
 (* |ray_(select #length cstpncpy_~d~3.base)| 0)
 (* |ray_cstpncpy_#t~post4.offset| 0) 
 (* ray_cstpncpy_~s~3.offset 0)
 (*
 |ray_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |ray_cstpncpy_#t~mem7| 0) 
 (* ray_cstpncpy_~d~3.base 0) 
 (* |ray_cstpncpy_#t~post5.base| 0)
 (* |ray_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (* ray_cstpncpy_~s~3.base (- 1))
 (* |ray_(select #length cstpncpy_~s~3.base)| 0) 
 (* ray_cstpncpy_~n 0) (* |ray_cstpncpy_#t~post4.base| 0)
 (* |ray_cstpncpy_#t~post5.offset| 0)
 (* |ray_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* ray_cstpncpy_~d~3.offset 0) 
 (* |ray_cstpncpy_#t~post3| 0)) 0)
 (>=
 (+ (* (* |ray_cstpncpy_#t~mem0.offset| lambda) 0)
 (* (* |ray_(select #length cstpncpy_~d~3.base)| lambda) 0)
 (* (* |ray_cstpncpy_#t~post4.offset| lambda) 0)
 (* (* ray_cstpncpy_~s~3.offset lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 lambda) 0)
 (* (* |ray_(select old(#length) cstpncpy_#in~src.base)| lambda) 0)
 (* (* |ray_cstpncpy_~#dst.offset| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 lambda) 0) (* (* |ray_cstpncpy_#t~mem7| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 lambda) 0) (* (* ray_cstpncpy_~d~3.base lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 lambda) 0) (* (* |ray_(select #length cstpncpy_#in~src.base)| lambda) 0)
 (* (* |ray_cstpncpy_#in~src.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| lambda) 0)
 (* (* |ray_cstpncpy_#t~mem1.offset| lambda) 0)
 (* (* |ray_(select #length cstpncpy_#in~dst.base)| lambda) 0)
 (* (* |ray_cstpncpy_#t~mem0.base| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_cstpncpy_#in~n| lambda) 0)
 (* (* |ray_cstpncpy_#t~mem1.base| lambda) 0)
 (* (* |ray_cstpncpy_#t~post5.base| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(select old(#length) cstpncpy_~#dst.base)| lambda) 0)
 (* (* |ray_(ite (select #valid cstpncpy_~d~3.base) 1 0)| lambda) 0)
 (* (* ray_cstpncpy_~s~3.base lambda) 0)
 (*
 (*
 |ray_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 lambda) 0) (* (* |ray_(select #length cstpncpy_~s~3.base)| lambda) 0)
 (* (* ray_cstpncpy_~n lambda) 0)
 (* (* |ray_cstpncpy_#in~dst.base| lambda) 0)
 (* (* |ray_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length cstpncpy_~#dst.base)| lambda) 0)
 (* (* |ray_cstpncpy_#t~post4.base| lambda) 0)
 (* (* |ray_(ite (select #valid cstpncpy_~#dst.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) cstpncpy_#in~dst.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| lambda) 0)
 (* (* |ray_cstpncpy_#t~post5.offset| lambda) 0)
 (* (* |ray_(ite (select #valid cstpncpy_#in~src.base) 1 0)| lambda) 0)
 (* (* |ray_cstpncpy_#in~dst.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid cstpncpy_~s~3.base) 1 0)| lambda) 0)
 (* (* ray_cstpncpy_~src.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* ray_cstpncpy_~d~3.offset lambda) 0)
 (* (* |ray_cstpncpy_#t~post3| lambda) 0)
 (* (* |ray_cstpncpy_~#dst.base| lambda) 0)
 (* (* ray_cstpncpy_~src.offset lambda) 0)
 (* (* |ray_cstpncpy_#in~src.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| lambda) 0)
 (* |ray_(select #length cstpncpy_~d~3.base)| 1)
 (* |ray_cstpncpy_#t~post4.offset| 0) 
 (* ray_cstpncpy_~s~3.offset 0)
 (*
 |ray_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |ray_cstpncpy_#t~mem7| 0) 
 (* ray_cstpncpy_~d~3.base 0) 
 (* |ray_cstpncpy_#t~post5.base| 0)
 (* |ray_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (* ray_cstpncpy_~s~3.base 0) 
 (* |ray_(select #length cstpncpy_~s~3.base)| 0) 
 (* ray_cstpncpy_~n 0) (* |ray_cstpncpy_#t~post4.base| 0)
 (* |ray_cstpncpy_#t~post5.offset| 0)
 (* |ray_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* ray_cstpncpy_~d~3.offset (- 1)) 
 (* |ray_cstpncpy_#t~post3| 0)) 0)
 (>=
 (+ (* (* |ray_cstpncpy_#t~mem0.offset| lambda) 0)
 (* (* |ray_(select #length cstpncpy_~d~3.base)| lambda) 0)
 (* (* |ray_cstpncpy_#t~post4.offset| lambda) 0)
 (* (* ray_cstpncpy_~s~3.offset lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 lambda) 0)
 (* (* |ray_(select old(#length) cstpncpy_#in~src.base)| lambda) 0)
 (* (* |ray_cstpncpy_~#dst.offset| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 lambda) 0) (* (* |ray_cstpncpy_#t~mem7| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 lambda) 0) (* (* ray_cstpncpy_~d~3.base lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 lambda) 0) (* (* |ray_(select #length cstpncpy_#in~src.base)| lambda) 0)
 (* (* |ray_cstpncpy_#in~src.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| lambda) 0)
 (* (* |ray_cstpncpy_#t~mem1.offset| lambda) 0)
 (* (* |ray_(select #length cstpncpy_#in~dst.base)| lambda) 0)
 (* (* |ray_cstpncpy_#t~mem0.base| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_cstpncpy_#in~n| lambda) 0)
 (* (* |ray_cstpncpy_#t~mem1.base| lambda) 0)
 (* (* |ray_cstpncpy_#t~post5.base| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(select old(#length) cstpncpy_~#dst.base)| lambda) 0)
 (* (* |ray_(ite (select #valid cstpncpy_~d~3.base) 1 0)| lambda) 0)
 (* (* ray_cstpncpy_~s~3.base lambda) 0)
 (*
 (*
 |ray_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 lambda) 0) (* (* |ray_(select #length cstpncpy_~s~3.base)| lambda) 0)
 (* (* ray_cstpncpy_~n lambda) 0)
 (* (* |ray_cstpncpy_#in~dst.base| lambda) 0)
 (* (* |ray_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length cstpncpy_~#dst.base)| lambda) 0)
 (* (* |ray_cstpncpy_#t~post4.base| lambda) 0)
 (* (* |ray_(ite (select #valid cstpncpy_~#dst.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) cstpncpy_#in~dst.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| lambda) 0)
 (* (* |ray_cstpncpy_#t~post5.offset| lambda) 0)
 (* (* |ray_(ite (select #valid cstpncpy_#in~src.base) 1 0)| lambda) 0)
 (* (* |ray_cstpncpy_#in~dst.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid cstpncpy_~s~3.base) 1 0)| lambda) 0)
 (* (* ray_cstpncpy_~src.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* ray_cstpncpy_~d~3.offset lambda) 0)
 (* (* |ray_cstpncpy_#t~post3| lambda) 0)
 (* (* |ray_cstpncpy_~#dst.base| lambda) 0)
 (* (* ray_cstpncpy_~src.offset lambda) 0)
 (* (* |ray_cstpncpy_#in~src.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| lambda) 0)
 (* |ray_(select #length cstpncpy_~d~3.base)| 0)
 (* |ray_cstpncpy_#t~post4.offset| 0) 
 (* ray_cstpncpy_~s~3.offset 0)
 (*
 |ray_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |ray_cstpncpy_#t~mem7| 0) 
 (* ray_cstpncpy_~d~3.base 0) 
 (* |ray_cstpncpy_#t~post5.base| 0)
 (* |ray_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 1)
 (* ray_cstpncpy_~s~3.base 0) 
 (* |ray_(select #length cstpncpy_~s~3.base)| 0) 
 (* ray_cstpncpy_~n 0) (* |ray_cstpncpy_#t~post4.base| 0)
 (* |ray_cstpncpy_#t~post5.offset| 0)
 (* |ray_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* ray_cstpncpy_~d~3.offset 0) 
 (* |ray_cstpncpy_#t~post3| 0)) 0)
 (>=
 (+ (* (* |ray_cstpncpy_#t~mem0.offset| lambda) 0)
 (* (* |ray_(select #length cstpncpy_~d~3.base)| lambda) 0)
 (* (* |ray_cstpncpy_#t~post4.offset| lambda) 0)
 (* (* ray_cstpncpy_~s~3.offset lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 lambda) 0)
 (* (* |ray_(select old(#length) cstpncpy_#in~src.base)| lambda) 0)
 (* (* |ray_cstpncpy_~#dst.offset| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 lambda) 0) (* (* |ray_cstpncpy_#t~mem7| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 lambda) 0) (* (* ray_cstpncpy_~d~3.base lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 lambda) 0) (* (* |ray_(select #length cstpncpy_#in~src.base)| lambda) 0)
 (* (* |ray_cstpncpy_#in~src.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| lambda) 0)
 (* (* |ray_cstpncpy_#t~mem1.offset| lambda) 0)
 (* (* |ray_(select #length cstpncpy_#in~dst.base)| lambda) 0)
 (* (* |ray_cstpncpy_#t~mem0.base| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_cstpncpy_#in~n| lambda) 0)
 (* (* |ray_cstpncpy_#t~mem1.base| lambda) 0)
 (* (* |ray_cstpncpy_#t~post5.base| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(select old(#length) cstpncpy_~#dst.base)| lambda) 0)
 (* (* |ray_(ite (select #valid cstpncpy_~d~3.base) 1 0)| lambda) 0)
 (* (* ray_cstpncpy_~s~3.base lambda) 0)
 (*
 (*
 |ray_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 lambda) 0) (* (* |ray_(select #length cstpncpy_~s~3.base)| lambda) 0)
 (* (* ray_cstpncpy_~n lambda) 0)
 (* (* |ray_cstpncpy_#in~dst.base| lambda) 0)
 (* (* |ray_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length cstpncpy_~#dst.base)| lambda) 0)
 (* (* |ray_cstpncpy_#t~post4.base| lambda) 0)
 (* (* |ray_(ite (select #valid cstpncpy_~#dst.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) cstpncpy_#in~dst.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| lambda) 0)
 (* (* |ray_cstpncpy_#t~post5.offset| lambda) 0)
 (* (* |ray_(ite (select #valid cstpncpy_#in~src.base) 1 0)| lambda) 0)
 (* (* |ray_cstpncpy_#in~dst.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid cstpncpy_~s~3.base) 1 0)| lambda) 0)
 (* (* ray_cstpncpy_~src.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* ray_cstpncpy_~d~3.offset lambda) 0)
 (* (* |ray_cstpncpy_#t~post3| lambda) 0)
 (* (* |ray_cstpncpy_~#dst.base| lambda) 0)
 (* (* ray_cstpncpy_~src.offset lambda) 0)
 (* (* |ray_cstpncpy_#in~src.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| lambda) 0)
 (* |ray_(select #length cstpncpy_~d~3.base)| 0)
 (* |ray_cstpncpy_#t~post4.offset| 0) 
 (* ray_cstpncpy_~s~3.offset 0)
 (*
 |ray_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |ray_cstpncpy_#t~mem7| 0) 
 (* ray_cstpncpy_~d~3.base 0) 
 (* |ray_cstpncpy_#t~post5.base| 0)
 (* |ray_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (* ray_cstpncpy_~s~3.base 0) 
 (* |ray_(select #length cstpncpy_~s~3.base)| 0) 
 (* ray_cstpncpy_~n 0) (* |ray_cstpncpy_#t~post4.base| 0)
 (* |ray_cstpncpy_#t~post5.offset| 0)
 (* |ray_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* ray_cstpncpy_~d~3.offset 0) 
 (* |ray_cstpncpy_#t~post3| 0) 
 (* aux_3739 (- 1)) (* aux_3734 1)) 0) 
 (= lambda lambda))
 (and
 (= |honda_cstpncpy_#t~mem0.offset|
 (+ |honda_cstpncpy_#t~mem0.offset| |ray_cstpncpy_#t~mem0.offset|))
 (=
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 (+
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 |ray_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|))
 (= |honda_(select old(#length) cstpncpy_#in~src.base)|
 (+ |honda_(select old(#length) cstpncpy_#in~src.base)|
 |ray_(select old(#length) cstpncpy_#in~src.base)|))
 (= |honda_cstpncpy_~#dst.offset|
 (+ |honda_cstpncpy_~#dst.offset| |ray_cstpncpy_~#dst.offset|))
 (=
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 (+
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 |ray_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|))
 (=
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 (+
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 |ray_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|))
 (= |honda_(select #length cstpncpy_#in~src.base)|
 (+ |honda_(select #length cstpncpy_#in~src.base)|
 |ray_(select #length cstpncpy_#in~src.base)|))
 (= |honda_cstpncpy_#in~src.offset|
 (+ |honda_cstpncpy_#in~src.offset| |ray_cstpncpy_#in~src.offset|))
 (= |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)|
 (+ |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)|
 |ray_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)|))
 (= |honda_cstpncpy_#t~mem1.offset|
 (+ |honda_cstpncpy_#t~mem1.offset| |ray_cstpncpy_#t~mem1.offset|))
 (= |honda_(select #length cstpncpy_#in~dst.base)|
 (+ |honda_(select #length cstpncpy_#in~dst.base)|
 |ray_(select #length cstpncpy_#in~dst.base)|))
 (= |honda_cstpncpy_#t~mem0.base|
 (+ |honda_cstpncpy_#t~mem0.base| |ray_cstpncpy_#t~mem0.base|))
 (=
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 (+
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 |ray_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|))
 (= |honda_#NULL.offset| (+ |honda_#NULL.offset| |ray_#NULL.offset|))
 (= |honda_cstpncpy_#in~n| (+ |honda_cstpncpy_#in~n| |ray_cstpncpy_#in~n|))
 (= |honda_cstpncpy_#t~mem1.base|
 (+ |honda_cstpncpy_#t~mem1.base| |ray_cstpncpy_#t~mem1.base|))
 (= |honda_#NULL.base| (+ |honda_#NULL.base| |ray_#NULL.base|))
 (= |honda_(select old(#length) cstpncpy_~#dst.base)|
 (+ |honda_(select old(#length) cstpncpy_~#dst.base)|
 |ray_(select old(#length) cstpncpy_~#dst.base)|))
 (=
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 (+
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 |ray_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|))
 (= |honda_cstpncpy_#in~dst.base|
 (+ |honda_cstpncpy_#in~dst.base| |ray_cstpncpy_#in~dst.base|))
 (= |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)|
 (+ |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)|
 |ray_(ite (select #valid cstpncpy_#in~dst.base) 1 0)|))
 (= |honda_(select #length cstpncpy_~#dst.base)|
 (+ |honda_(select #length cstpncpy_~#dst.base)|
 |ray_(select #length cstpncpy_~#dst.base)|))
 (= |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)|
 (+ |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)|
 |ray_(ite (select #valid cstpncpy_~#dst.base) 1 0)|))
 (= |honda_(select old(#length) cstpncpy_#in~dst.base)|
 (+ |honda_(select old(#length) cstpncpy_#in~dst.base)|
 |ray_(select old(#length) cstpncpy_#in~dst.base)|))
 (= |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)|
 (+ |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)|
 |ray_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)|))
 (= |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)|
 (+ |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)|
 |ray_(ite (select #valid cstpncpy_#in~src.base) 1 0)|))
 (= |honda_cstpncpy_#in~dst.offset|
 (+ |honda_cstpncpy_#in~dst.offset| |ray_cstpncpy_#in~dst.offset|))
 (= |honda_(ite (select #valid 0) 1 0)|
 (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|))
 (= honda_cstpncpy_~src.base
 (+ honda_cstpncpy_~src.base ray_cstpncpy_~src.base))
 (= |honda_(ite (select old(#valid) 0) 1 0)|
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|))
 (= |honda_cstpncpy_~#dst.base|
 (+ |honda_cstpncpy_~#dst.base| |ray_cstpncpy_~#dst.base|))
 (= honda_cstpncpy_~src.offset
 (+ honda_cstpncpy_~src.offset ray_cstpncpy_~src.offset))
 (= |honda_cstpncpy_#in~src.base|
 (+ |honda_cstpncpy_#in~src.base| |ray_cstpncpy_#in~src.base|))
 (=
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 (+
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 |ray_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|))
 (= |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)|
 (+ |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)|
 |ray_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)|))
 (>=
 (+ (* (+ |honda_cstpncpy_#t~mem0.offset| |ray_cstpncpy_#t~mem0.offset|) 0)
 (*
 (+ |honda_(select #length cstpncpy_~d~3.base)|
 |ray_(select #length cstpncpy_~d~3.base)|) 0)
 (* (+ |honda_cstpncpy_#t~post4.offset| |ray_cstpncpy_#t~post4.offset|) 0)
 (* (+ honda_cstpncpy_~s~3.offset ray_cstpncpy_~s~3.offset) 0)
 (*
 (+
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 |ray_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|)
 0)
 (*
 (+ |honda_(select old(#length) cstpncpy_#in~src.base)|
 |ray_(select old(#length) cstpncpy_#in~src.base)|) 0)
 (* (+ |honda_cstpncpy_~#dst.offset| |ray_cstpncpy_~#dst.offset|) 0)
 (*
 (+
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 |ray_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|)
 0) (* (+ |honda_cstpncpy_#t~mem7| |ray_cstpncpy_#t~mem7|) 0)
 (*
 (+
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 |ray_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|)
 0) (* (+ honda_cstpncpy_~d~3.base ray_cstpncpy_~d~3.base) 0)
 (*
 (+
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 |ray_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|)
 0)
 (*
 (+ |honda_(select #length cstpncpy_#in~src.base)|
 |ray_(select #length cstpncpy_#in~src.base)|) 0)
 (* (+ |honda_cstpncpy_#in~src.offset| |ray_cstpncpy_#in~src.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)|
 |ray_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)|) 0)
 (* (+ |honda_cstpncpy_#t~mem1.offset| |ray_cstpncpy_#t~mem1.offset|) 0)
 (*
 (+ |honda_(select #length cstpncpy_#in~dst.base)|
 |ray_(select #length cstpncpy_#in~dst.base)|) 0)
 (* (+ |honda_cstpncpy_#t~mem0.base| |ray_cstpncpy_#t~mem0.base|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 |ray_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|)
 0) (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_cstpncpy_#in~n| |ray_cstpncpy_#in~n|) 0)
 (* (+ |honda_cstpncpy_#t~mem1.base| |ray_cstpncpy_#t~mem1.base|) 0)
 (* (+ |honda_cstpncpy_#t~post5.base| |ray_cstpncpy_#t~post5.base|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(select old(#length) cstpncpy_~#dst.base)|
 |ray_(select old(#length) cstpncpy_~#dst.base)|) 0)
 (*
 (+ |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)|
 |ray_(ite (select #valid cstpncpy_~d~3.base) 1 0)|) 0)
 (* (+ honda_cstpncpy_~s~3.base ray_cstpncpy_~s~3.base) 0)
 (*
 (+
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 |ray_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|)
 0)
 (*
 (+ |honda_(select #length cstpncpy_~s~3.base)|
 |ray_(select #length cstpncpy_~s~3.base)|) 
 (- 1)) (* (+ honda_cstpncpy_~n ray_cstpncpy_~n) 0)
 (* (+ |honda_cstpncpy_#in~dst.base| |ray_cstpncpy_#in~dst.base|) 0)
 (*
 (+ |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)|
 |ray_(ite (select #valid cstpncpy_#in~dst.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length cstpncpy_~#dst.base)|
 |ray_(select #length cstpncpy_~#dst.base)|) 0)
 (* (+ |honda_cstpncpy_#t~post4.base| |ray_cstpncpy_#t~post4.base|) 0)
 (*
 (+ |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)|
 |ray_(ite (select #valid cstpncpy_~#dst.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) cstpncpy_#in~dst.base)|
 |ray_(select old(#length) cstpncpy_#in~dst.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)|
 |ray_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)|) 0)
 (* (+ |honda_cstpncpy_#t~post5.offset| |ray_cstpncpy_#t~post5.offset|) 0)
 (*
 (+ |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)|
 |ray_(ite (select #valid cstpncpy_#in~src.base) 1 0)|) 0)
 (* (+ |honda_cstpncpy_#in~dst.offset| |ray_cstpncpy_#in~dst.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)|
 |ray_(ite (select #valid cstpncpy_~s~3.base) 1 0)|) 0)
 (* (+ honda_cstpncpy_~src.base ray_cstpncpy_~src.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ honda_cstpncpy_~d~3.offset ray_cstpncpy_~d~3.offset) 0)
 (* (+ |honda_cstpncpy_#t~post3| |ray_cstpncpy_#t~post3|) 0)
 (* (+ |honda_cstpncpy_~#dst.base| |ray_cstpncpy_~#dst.base|) 0)
 (* (+ honda_cstpncpy_~src.offset ray_cstpncpy_~src.offset) 0)
 (* (+ |honda_cstpncpy_#in~src.base| |ray_cstpncpy_#in~src.base|) 0)
 (*
 (+
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 |ray_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)|
 |ray_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)|) 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0) 
 (* honda_cstpncpy_~d~3.base 0) 
 (* |honda_cstpncpy_#t~post5.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(select #length cstpncpy_~s~3.base)| 1) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 0) 0)
 (>=
 (+ (* (+ |honda_cstpncpy_#t~mem0.offset| |ray_cstpncpy_#t~mem0.offset|) 0)
 (*
 (+ |honda_(select #length cstpncpy_~d~3.base)|
 |ray_(select #length cstpncpy_~d~3.base)|) 0)
 (* (+ |honda_cstpncpy_#t~post4.offset| |ray_cstpncpy_#t~post4.offset|) 0)
 (* (+ honda_cstpncpy_~s~3.offset ray_cstpncpy_~s~3.offset) 0)
 (*
 (+
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 |ray_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|)
 0)
 (*
 (+ |honda_(select old(#length) cstpncpy_#in~src.base)|
 |ray_(select old(#length) cstpncpy_#in~src.base)|) 0)
 (* (+ |honda_cstpncpy_~#dst.offset| |ray_cstpncpy_~#dst.offset|) 0)
 (*
 (+
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 |ray_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|)
 0) (* (+ |honda_cstpncpy_#t~mem7| |ray_cstpncpy_#t~mem7|) 0)
 (*
 (+
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 |ray_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|)
 0) (* (+ honda_cstpncpy_~d~3.base ray_cstpncpy_~d~3.base) (- 1))
 (*
 (+
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 |ray_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|)
 0)
 (*
 (+ |honda_(select #length cstpncpy_#in~src.base)|
 |ray_(select #length cstpncpy_#in~src.base)|) 0)
 (* (+ |honda_cstpncpy_#in~src.offset| |ray_cstpncpy_#in~src.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)|
 |ray_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)|) 0)
 (* (+ |honda_cstpncpy_#t~mem1.offset| |ray_cstpncpy_#t~mem1.offset|) 0)
 (*
 (+ |honda_(select #length cstpncpy_#in~dst.base)|
 |ray_(select #length cstpncpy_#in~dst.base)|) 0)
 (* (+ |honda_cstpncpy_#t~mem0.base| |ray_cstpncpy_#t~mem0.base|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 |ray_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|)
 0) (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_cstpncpy_#in~n| |ray_cstpncpy_#in~n|) 0)
 (* (+ |honda_cstpncpy_#t~mem1.base| |ray_cstpncpy_#t~mem1.base|) 0)
 (* (+ |honda_cstpncpy_#t~post5.base| |ray_cstpncpy_#t~post5.base|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(select old(#length) cstpncpy_~#dst.base)|
 |ray_(select old(#length) cstpncpy_~#dst.base)|) 0)
 (*
 (+ |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)|
 |ray_(ite (select #valid cstpncpy_~d~3.base) 1 0)|) 0)
 (* (+ honda_cstpncpy_~s~3.base ray_cstpncpy_~s~3.base) 0)
 (*
 (+
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 |ray_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|)
 0)
 (*
 (+ |honda_(select #length cstpncpy_~s~3.base)|
 |ray_(select #length cstpncpy_~s~3.base)|) 0)
 (* (+ honda_cstpncpy_~n ray_cstpncpy_~n) 0)
 (* (+ |honda_cstpncpy_#in~dst.base| |ray_cstpncpy_#in~dst.base|) 0)
 (*
 (+ |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)|
 |ray_(ite (select #valid cstpncpy_#in~dst.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length cstpncpy_~#dst.base)|
 |ray_(select #length cstpncpy_~#dst.base)|) 0)
 (* (+ |honda_cstpncpy_#t~post4.base| |ray_cstpncpy_#t~post4.base|) 0)
 (*
 (+ |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)|
 |ray_(ite (select #valid cstpncpy_~#dst.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) cstpncpy_#in~dst.base)|
 |ray_(select old(#length) cstpncpy_#in~dst.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)|
 |ray_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)|) 0)
 (* (+ |honda_cstpncpy_#t~post5.offset| |ray_cstpncpy_#t~post5.offset|) 0)
 (*
 (+ |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)|
 |ray_(ite (select #valid cstpncpy_#in~src.base) 1 0)|) 0)
 (* (+ |honda_cstpncpy_#in~dst.offset| |ray_cstpncpy_#in~dst.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)|
 |ray_(ite (select #valid cstpncpy_~s~3.base) 1 0)|) 0)
 (* (+ honda_cstpncpy_~src.base ray_cstpncpy_~src.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ honda_cstpncpy_~d~3.offset ray_cstpncpy_~d~3.offset) 0)
 (* (+ |honda_cstpncpy_#t~post3| |ray_cstpncpy_#t~post3|) 0)
 (* (+ |honda_cstpncpy_~#dst.base| |ray_cstpncpy_~#dst.base|) 0)
 (* (+ honda_cstpncpy_~src.offset ray_cstpncpy_~src.offset) 0)
 (* (+ |honda_cstpncpy_#in~src.base| |ray_cstpncpy_#in~src.base|) 0)
 (*
 (+
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 |ray_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)|
 |ray_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)|) 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0) 
 (* honda_cstpncpy_~d~3.base 1) 
 (* |honda_cstpncpy_#t~post5.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 0) 0)
 (>=
 (+ (* (+ |honda_cstpncpy_#t~mem0.offset| |ray_cstpncpy_#t~mem0.offset|) 0)
 (*
 (+ |honda_(select #length cstpncpy_~d~3.base)|
 |ray_(select #length cstpncpy_~d~3.base)|) 0)
 (* (+ |honda_cstpncpy_#t~post4.offset| |ray_cstpncpy_#t~post4.offset|) 0)
 (* (+ honda_cstpncpy_~s~3.offset ray_cstpncpy_~s~3.offset) 0)
 (*
 (+
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 |ray_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|)
 0)
 (*
 (+ |honda_(select old(#length) cstpncpy_#in~src.base)|
 |ray_(select old(#length) cstpncpy_#in~src.base)|) 0)
 (* (+ |honda_cstpncpy_~#dst.offset| |ray_cstpncpy_~#dst.offset|) 0)
 (*
 (+
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 |ray_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|)
 0) (* (+ |honda_cstpncpy_#t~mem7| |ray_cstpncpy_#t~mem7|) 0)
 (*
 (+
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 |ray_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|)
 0) (* (+ honda_cstpncpy_~d~3.base ray_cstpncpy_~d~3.base) 0)
 (*
 (+
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 |ray_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|)
 0)
 (*
 (+ |honda_(select #length cstpncpy_#in~src.base)|
 |ray_(select #length cstpncpy_#in~src.base)|) 0)
 (* (+ |honda_cstpncpy_#in~src.offset| |ray_cstpncpy_#in~src.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)|
 |ray_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)|) 0)
 (* (+ |honda_cstpncpy_#t~mem1.offset| |ray_cstpncpy_#t~mem1.offset|) 0)
 (*
 (+ |honda_(select #length cstpncpy_#in~dst.base)|
 |ray_(select #length cstpncpy_#in~dst.base)|) 0)
 (* (+ |honda_cstpncpy_#t~mem0.base| |ray_cstpncpy_#t~mem0.base|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 |ray_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|)
 0) (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_cstpncpy_#in~n| |ray_cstpncpy_#in~n|) 0)
 (* (+ |honda_cstpncpy_#t~mem1.base| |ray_cstpncpy_#t~mem1.base|) 0)
 (* (+ |honda_cstpncpy_#t~post5.base| |ray_cstpncpy_#t~post5.base|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(select old(#length) cstpncpy_~#dst.base)|
 |ray_(select old(#length) cstpncpy_~#dst.base)|) 0)
 (*
 (+ |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)|
 |ray_(ite (select #valid cstpncpy_~d~3.base) 1 0)|) 0)
 (* (+ honda_cstpncpy_~s~3.base ray_cstpncpy_~s~3.base) 0)
 (*
 (+
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 |ray_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|)
 0)
 (*
 (+ |honda_(select #length cstpncpy_~s~3.base)|
 |ray_(select #length cstpncpy_~s~3.base)|) 0)
 (* (+ honda_cstpncpy_~n ray_cstpncpy_~n) 0)
 (* (+ |honda_cstpncpy_#in~dst.base| |ray_cstpncpy_#in~dst.base|) 0)
 (*
 (+ |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)|
 |ray_(ite (select #valid cstpncpy_#in~dst.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length cstpncpy_~#dst.base)|
 |ray_(select #length cstpncpy_~#dst.base)|) 0)
 (* (+ |honda_cstpncpy_#t~post4.base| |ray_cstpncpy_#t~post4.base|) 0)
 (*
 (+ |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)|
 |ray_(ite (select #valid cstpncpy_~#dst.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) cstpncpy_#in~dst.base)|
 |ray_(select old(#length) cstpncpy_#in~dst.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)|
 |ray_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)|) 0)
 (* (+ |honda_cstpncpy_#t~post5.offset| |ray_cstpncpy_#t~post5.offset|) 0)
 (*
 (+ |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)|
 |ray_(ite (select #valid cstpncpy_#in~src.base) 1 0)|) 0)
 (* (+ |honda_cstpncpy_#in~dst.offset| |ray_cstpncpy_#in~dst.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)|
 |ray_(ite (select #valid cstpncpy_~s~3.base) 1 0)|) 0)
 (* (+ honda_cstpncpy_~src.base ray_cstpncpy_~src.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ honda_cstpncpy_~d~3.offset ray_cstpncpy_~d~3.offset) (- 1))
 (* (+ |honda_cstpncpy_#t~post3| |ray_cstpncpy_#t~post3|) 0)
 (* (+ |honda_cstpncpy_~#dst.base| |ray_cstpncpy_~#dst.base|) 0)
 (* (+ honda_cstpncpy_~src.offset ray_cstpncpy_~src.offset) 0)
 (* (+ |honda_cstpncpy_#in~src.base| |ray_cstpncpy_#in~src.base|) 0)
 (*
 (+
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 |ray_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)|
 |ray_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)|) 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0) 
 (* honda_cstpncpy_~d~3.base 0) 
 (* |honda_cstpncpy_#t~post5.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 1) 
 (* |honda_cstpncpy_#t~post3| 0) 1) 0)
 (>=
 (+ (* (+ |honda_cstpncpy_#t~mem0.offset| |ray_cstpncpy_#t~mem0.offset|) 0)
 (*
 (+ |honda_(select #length cstpncpy_~d~3.base)|
 |ray_(select #length cstpncpy_~d~3.base)|) 0)
 (* (+ |honda_cstpncpy_#t~post4.offset| |ray_cstpncpy_#t~post4.offset|) 0)
 (* (+ honda_cstpncpy_~s~3.offset ray_cstpncpy_~s~3.offset) 0)
 (*
 (+
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 |ray_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|)
 0)
 (*
 (+ |honda_(select old(#length) cstpncpy_#in~src.base)|
 |ray_(select old(#length) cstpncpy_#in~src.base)|) 0)
 (* (+ |honda_cstpncpy_~#dst.offset| |ray_cstpncpy_~#dst.offset|) 0)
 (*
 (+
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 |ray_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|)
 0) (* (+ |honda_cstpncpy_#t~mem7| |ray_cstpncpy_#t~mem7|) 0)
 (*
 (+
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 |ray_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|)
 0) (* (+ honda_cstpncpy_~d~3.base ray_cstpncpy_~d~3.base) 0)
 (*
 (+
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 |ray_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|)
 0)
 (*
 (+ |honda_(select #length cstpncpy_#in~src.base)|
 |ray_(select #length cstpncpy_#in~src.base)|) 0)
 (* (+ |honda_cstpncpy_#in~src.offset| |ray_cstpncpy_#in~src.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)|
 |ray_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)|) 0)
 (* (+ |honda_cstpncpy_#t~mem1.offset| |ray_cstpncpy_#t~mem1.offset|) 0)
 (*
 (+ |honda_(select #length cstpncpy_#in~dst.base)|
 |ray_(select #length cstpncpy_#in~dst.base)|) 0)
 (* (+ |honda_cstpncpy_#t~mem0.base| |ray_cstpncpy_#t~mem0.base|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 |ray_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|)
 0) (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_cstpncpy_#in~n| |ray_cstpncpy_#in~n|) 0)
 (* (+ |honda_cstpncpy_#t~mem1.base| |ray_cstpncpy_#t~mem1.base|) 0)
 (* (+ |honda_cstpncpy_#t~post5.base| |ray_cstpncpy_#t~post5.base|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(select old(#length) cstpncpy_~#dst.base)|
 |ray_(select old(#length) cstpncpy_~#dst.base)|) 0)
 (*
 (+ |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)|
 |ray_(ite (select #valid cstpncpy_~d~3.base) 1 0)|) 1)
 (* (+ honda_cstpncpy_~s~3.base ray_cstpncpy_~s~3.base) 0)
 (*
 (+
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 |ray_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|)
 0)
 (*
 (+ |honda_(select #length cstpncpy_~s~3.base)|
 |ray_(select #length cstpncpy_~s~3.base)|) 0)
 (* (+ honda_cstpncpy_~n ray_cstpncpy_~n) 0)
 (* (+ |honda_cstpncpy_#in~dst.base| |ray_cstpncpy_#in~dst.base|) 0)
 (*
 (+ |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)|
 |ray_(ite (select #valid cstpncpy_#in~dst.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length cstpncpy_~#dst.base)|
 |ray_(select #length cstpncpy_~#dst.base)|) 0)
 (* (+ |honda_cstpncpy_#t~post4.base| |ray_cstpncpy_#t~post4.base|) 0)
 (*
 (+ |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)|
 |ray_(ite (select #valid cstpncpy_~#dst.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) cstpncpy_#in~dst.base)|
 |ray_(select old(#length) cstpncpy_#in~dst.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)|
 |ray_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)|) 0)
 (* (+ |honda_cstpncpy_#t~post5.offset| |ray_cstpncpy_#t~post5.offset|) 0)
 (*
 (+ |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)|
 |ray_(ite (select #valid cstpncpy_#in~src.base) 1 0)|) 0)
 (* (+ |honda_cstpncpy_#in~dst.offset| |ray_cstpncpy_#in~dst.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)|
 |ray_(ite (select #valid cstpncpy_~s~3.base) 1 0)|) 0)
 (* (+ honda_cstpncpy_~src.base ray_cstpncpy_~src.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ honda_cstpncpy_~d~3.offset ray_cstpncpy_~d~3.offset) 0)
 (* (+ |honda_cstpncpy_#t~post3| |ray_cstpncpy_#t~post3|) 0)
 (* (+ |honda_cstpncpy_~#dst.base| |ray_cstpncpy_~#dst.base|) 0)
 (* (+ honda_cstpncpy_~src.offset ray_cstpncpy_~src.offset) 0)
 (* (+ |honda_cstpncpy_#in~src.base| |ray_cstpncpy_#in~src.base|) 0)
 (*
 (+
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 |ray_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)|
 |ray_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)|) 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0) 
 (* honda_cstpncpy_~d~3.base 0) 
 (* |honda_cstpncpy_#t~post5.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (- 1)) 0)
 (>=
 (+ (* (+ |honda_cstpncpy_#t~mem0.offset| |ray_cstpncpy_#t~mem0.offset|) 0)
 (*
 (+ |honda_(select #length cstpncpy_~d~3.base)|
 |ray_(select #length cstpncpy_~d~3.base)|) 
 (- 1))
 (* (+ |honda_cstpncpy_#t~post4.offset| |ray_cstpncpy_#t~post4.offset|) 0)
 (* (+ honda_cstpncpy_~s~3.offset ray_cstpncpy_~s~3.offset) 0)
 (*
 (+
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 |ray_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|)
 0)
 (*
 (+ |honda_(select old(#length) cstpncpy_#in~src.base)|
 |ray_(select old(#length) cstpncpy_#in~src.base)|) 0)
 (* (+ |honda_cstpncpy_~#dst.offset| |ray_cstpncpy_~#dst.offset|) 0)
 (*
 (+
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 |ray_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|)
 0) (* (+ |honda_cstpncpy_#t~mem7| |ray_cstpncpy_#t~mem7|) 0)
 (*
 (+
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 |ray_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|)
 0) (* (+ honda_cstpncpy_~d~3.base ray_cstpncpy_~d~3.base) 0)
 (*
 (+
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 |ray_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|)
 0)
 (*
 (+ |honda_(select #length cstpncpy_#in~src.base)|
 |ray_(select #length cstpncpy_#in~src.base)|) 0)
 (* (+ |honda_cstpncpy_#in~src.offset| |ray_cstpncpy_#in~src.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)|
 |ray_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)|) 0)
 (* (+ |honda_cstpncpy_#t~mem1.offset| |ray_cstpncpy_#t~mem1.offset|) 0)
 (*
 (+ |honda_(select #length cstpncpy_#in~dst.base)|
 |ray_(select #length cstpncpy_#in~dst.base)|) 0)
 (* (+ |honda_cstpncpy_#t~mem0.base| |ray_cstpncpy_#t~mem0.base|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 |ray_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|)
 0) (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_cstpncpy_#in~n| |ray_cstpncpy_#in~n|) 0)
 (* (+ |honda_cstpncpy_#t~mem1.base| |ray_cstpncpy_#t~mem1.base|) 0)
 (* (+ |honda_cstpncpy_#t~post5.base| |ray_cstpncpy_#t~post5.base|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(select old(#length) cstpncpy_~#dst.base)|
 |ray_(select old(#length) cstpncpy_~#dst.base)|) 0)
 (*
 (+ |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)|
 |ray_(ite (select #valid cstpncpy_~d~3.base) 1 0)|) 0)
 (* (+ honda_cstpncpy_~s~3.base ray_cstpncpy_~s~3.base) 0)
 (*
 (+
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 |ray_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|)
 0)
 (*
 (+ |honda_(select #length cstpncpy_~s~3.base)|
 |ray_(select #length cstpncpy_~s~3.base)|) 0)
 (* (+ honda_cstpncpy_~n ray_cstpncpy_~n) 0)
 (* (+ |honda_cstpncpy_#in~dst.base| |ray_cstpncpy_#in~dst.base|) 0)
 (*
 (+ |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)|
 |ray_(ite (select #valid cstpncpy_#in~dst.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length cstpncpy_~#dst.base)|
 |ray_(select #length cstpncpy_~#dst.base)|) 0)
 (* (+ |honda_cstpncpy_#t~post4.base| |ray_cstpncpy_#t~post4.base|) 0)
 (*
 (+ |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)|
 |ray_(ite (select #valid cstpncpy_~#dst.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) cstpncpy_#in~dst.base)|
 |ray_(select old(#length) cstpncpy_#in~dst.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)|
 |ray_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)|) 0)
 (* (+ |honda_cstpncpy_#t~post5.offset| |ray_cstpncpy_#t~post5.offset|) 0)
 (*
 (+ |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)|
 |ray_(ite (select #valid cstpncpy_#in~src.base) 1 0)|) 0)
 (* (+ |honda_cstpncpy_#in~dst.offset| |ray_cstpncpy_#in~dst.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)|
 |ray_(ite (select #valid cstpncpy_~s~3.base) 1 0)|) 0)
 (* (+ honda_cstpncpy_~src.base ray_cstpncpy_~src.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ honda_cstpncpy_~d~3.offset ray_cstpncpy_~d~3.offset) 0)
 (* (+ |honda_cstpncpy_#t~post3| |ray_cstpncpy_#t~post3|) 0)
 (* (+ |honda_cstpncpy_~#dst.base| |ray_cstpncpy_~#dst.base|) 0)
 (* (+ honda_cstpncpy_~src.offset ray_cstpncpy_~src.offset) 0)
 (* (+ |honda_cstpncpy_#in~src.base| |ray_cstpncpy_#in~src.base|) 0)
 (*
 (+
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 |ray_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)|
 |ray_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)|) 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 1)
 (* |honda_cstpncpy_#t~post4.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0) 
 (* honda_cstpncpy_~d~3.base 0) 
 (* |honda_cstpncpy_#t~post5.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 0) 0)
 (>=
 (+ (* (+ |honda_cstpncpy_#t~mem0.offset| |ray_cstpncpy_#t~mem0.offset|) 0)
 (*
 (+ |honda_(select #length cstpncpy_~d~3.base)|
 |ray_(select #length cstpncpy_~d~3.base)|) 0)
 (* (+ |honda_cstpncpy_#t~post4.offset| |ray_cstpncpy_#t~post4.offset|) 0)
 (* (+ honda_cstpncpy_~s~3.offset ray_cstpncpy_~s~3.offset) 0)
 (*
 (+
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 |ray_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|)
 0)
 (*
 (+ |honda_(select old(#length) cstpncpy_#in~src.base)|
 |ray_(select old(#length) cstpncpy_#in~src.base)|) 0)
 (* (+ |honda_cstpncpy_~#dst.offset| |ray_cstpncpy_~#dst.offset|) 0)
 (*
 (+
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 |ray_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|)
 0) (* (+ |honda_cstpncpy_#t~mem7| |ray_cstpncpy_#t~mem7|) 0)
 (*
 (+
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 |ray_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|)
 0) (* (+ honda_cstpncpy_~d~3.base ray_cstpncpy_~d~3.base) 1)
 (*
 (+
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 |ray_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|)
 0)
 (*
 (+ |honda_(select #length cstpncpy_#in~src.base)|
 |ray_(select #length cstpncpy_#in~src.base)|) 0)
 (* (+ |honda_cstpncpy_#in~src.offset| |ray_cstpncpy_#in~src.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)|
 |ray_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)|) 0)
 (* (+ |honda_cstpncpy_#t~mem1.offset| |ray_cstpncpy_#t~mem1.offset|) 0)
 (*
 (+ |honda_(select #length cstpncpy_#in~dst.base)|
 |ray_(select #length cstpncpy_#in~dst.base)|) 0)
 (* (+ |honda_cstpncpy_#t~mem0.base| |ray_cstpncpy_#t~mem0.base|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 |ray_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|)
 0) (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_cstpncpy_#in~n| |ray_cstpncpy_#in~n|) 0)
 (* (+ |honda_cstpncpy_#t~mem1.base| |ray_cstpncpy_#t~mem1.base|) 0)
 (* (+ |honda_cstpncpy_#t~post5.base| |ray_cstpncpy_#t~post5.base|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(select old(#length) cstpncpy_~#dst.base)|
 |ray_(select old(#length) cstpncpy_~#dst.base)|) 0)
 (*
 (+ |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)|
 |ray_(ite (select #valid cstpncpy_~d~3.base) 1 0)|) 0)
 (* (+ honda_cstpncpy_~s~3.base ray_cstpncpy_~s~3.base) 0)
 (*
 (+
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 |ray_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|)
 0)
 (*
 (+ |honda_(select #length cstpncpy_~s~3.base)|
 |ray_(select #length cstpncpy_~s~3.base)|) 0)
 (* (+ honda_cstpncpy_~n ray_cstpncpy_~n) 0)
 (* (+ |honda_cstpncpy_#in~dst.base| |ray_cstpncpy_#in~dst.base|) 0)
 (*
 (+ |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)|
 |ray_(ite (select #valid cstpncpy_#in~dst.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length cstpncpy_~#dst.base)|
 |ray_(select #length cstpncpy_~#dst.base)|) 0)
 (* (+ |honda_cstpncpy_#t~post4.base| |ray_cstpncpy_#t~post4.base|) 0)
 (*
 (+ |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)|
 |ray_(ite (select #valid cstpncpy_~#dst.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) cstpncpy_#in~dst.base)|
 |ray_(select old(#length) cstpncpy_#in~dst.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)|
 |ray_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)|) 0)
 (* (+ |honda_cstpncpy_#t~post5.offset| |ray_cstpncpy_#t~post5.offset|) 0)
 (*
 (+ |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)|
 |ray_(ite (select #valid cstpncpy_#in~src.base) 1 0)|) 0)
 (* (+ |honda_cstpncpy_#in~dst.offset| |ray_cstpncpy_#in~dst.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)|
 |ray_(ite (select #valid cstpncpy_~s~3.base) 1 0)|) 0)
 (* (+ honda_cstpncpy_~src.base ray_cstpncpy_~src.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ honda_cstpncpy_~d~3.offset ray_cstpncpy_~d~3.offset) 0)
 (* (+ |honda_cstpncpy_#t~post3| |ray_cstpncpy_#t~post3|) 0)
 (* (+ |honda_cstpncpy_~#dst.base| |ray_cstpncpy_~#dst.base|) 0)
 (* (+ honda_cstpncpy_~src.offset ray_cstpncpy_~src.offset) 0)
 (* (+ |honda_cstpncpy_#in~src.base| |ray_cstpncpy_#in~src.base|) 0)
 (*
 (+
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 |ray_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)|
 |ray_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)|) 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0) 
 (* honda_cstpncpy_~d~3.base (- 1)) 
 (* |honda_cstpncpy_#t~post5.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 0) 0)
 (>=
 (+ (* (+ |honda_cstpncpy_#t~mem0.offset| |ray_cstpncpy_#t~mem0.offset|) 0)
 (*
 (+ |honda_(select #length cstpncpy_~d~3.base)|
 |ray_(select #length cstpncpy_~d~3.base)|) 0)
 (* (+ |honda_cstpncpy_#t~post4.offset| |ray_cstpncpy_#t~post4.offset|) 0)
 (* (+ honda_cstpncpy_~s~3.offset ray_cstpncpy_~s~3.offset) 0)
 (*
 (+
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 |ray_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|)
 0)
 (*
 (+ |honda_(select old(#length) cstpncpy_#in~src.base)|
 |ray_(select old(#length) cstpncpy_#in~src.base)|) 0)
 (* (+ |honda_cstpncpy_~#dst.offset| |ray_cstpncpy_~#dst.offset|) 0)
 (*
 (+
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 |ray_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|)
 0) (* (+ |honda_cstpncpy_#t~mem7| |ray_cstpncpy_#t~mem7|) 0)
 (*
 (+
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 |ray_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|)
 0) (* (+ honda_cstpncpy_~d~3.base ray_cstpncpy_~d~3.base) 0)
 (*
 (+
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 |ray_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|)
 0)
 (*
 (+ |honda_(select #length cstpncpy_#in~src.base)|
 |ray_(select #length cstpncpy_#in~src.base)|) 0)
 (* (+ |honda_cstpncpy_#in~src.offset| |ray_cstpncpy_#in~src.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)|
 |ray_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)|) 0)
 (* (+ |honda_cstpncpy_#t~mem1.offset| |ray_cstpncpy_#t~mem1.offset|) 0)
 (*
 (+ |honda_(select #length cstpncpy_#in~dst.base)|
 |ray_(select #length cstpncpy_#in~dst.base)|) 0)
 (* (+ |honda_cstpncpy_#t~mem0.base| |ray_cstpncpy_#t~mem0.base|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 |ray_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|)
 0) (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_cstpncpy_#in~n| |ray_cstpncpy_#in~n|) 0)
 (* (+ |honda_cstpncpy_#t~mem1.base| |ray_cstpncpy_#t~mem1.base|) 0)
 (* (+ |honda_cstpncpy_#t~post5.base| |ray_cstpncpy_#t~post5.base|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(select old(#length) cstpncpy_~#dst.base)|
 |ray_(select old(#length) cstpncpy_~#dst.base)|) 0)
 (*
 (+ |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)|
 |ray_(ite (select #valid cstpncpy_~d~3.base) 1 0)|) 0)
 (* (+ honda_cstpncpy_~s~3.base ray_cstpncpy_~s~3.base) 0)
 (*
 (+
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 |ray_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|)
 0)
 (*
 (+ |honda_(select #length cstpncpy_~s~3.base)|
 |ray_(select #length cstpncpy_~s~3.base)|) 0)
 (* (+ honda_cstpncpy_~n ray_cstpncpy_~n) 0)
 (* (+ |honda_cstpncpy_#in~dst.base| |ray_cstpncpy_#in~dst.base|) 0)
 (*
 (+ |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)|
 |ray_(ite (select #valid cstpncpy_#in~dst.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length cstpncpy_~#dst.base)|
 |ray_(select #length cstpncpy_~#dst.base)|) 0)
 (* (+ |honda_cstpncpy_#t~post4.base| |ray_cstpncpy_#t~post4.base|) 0)
 (*
 (+ |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)|
 |ray_(ite (select #valid cstpncpy_~#dst.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) cstpncpy_#in~dst.base)|
 |ray_(select old(#length) cstpncpy_#in~dst.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)|
 |ray_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)|) 0)
 (* (+ |honda_cstpncpy_#t~post5.offset| |ray_cstpncpy_#t~post5.offset|) 0)
 (*
 (+ |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)|
 |ray_(ite (select #valid cstpncpy_#in~src.base) 1 0)|) 0)
 (* (+ |honda_cstpncpy_#in~dst.offset| |ray_cstpncpy_#in~dst.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)|
 |ray_(ite (select #valid cstpncpy_~s~3.base) 1 0)|) 0)
 (* (+ honda_cstpncpy_~src.base ray_cstpncpy_~src.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ honda_cstpncpy_~d~3.offset ray_cstpncpy_~d~3.offset) 0)
 (* (+ |honda_cstpncpy_#t~post3| |ray_cstpncpy_#t~post3|) 0)
 (* (+ |honda_cstpncpy_~#dst.base| |ray_cstpncpy_~#dst.base|) 0)
 (* (+ honda_cstpncpy_~src.offset ray_cstpncpy_~src.offset) 0)
 (* (+ |honda_cstpncpy_#in~src.base| |ray_cstpncpy_#in~src.base|) 0)
 (*
 (+
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 |ray_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)|
 |ray_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)|) 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0) 
 (* honda_cstpncpy_~s~3.offset (- 1))
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0) 
 (* honda_cstpncpy_~d~3.base 0) 
 (* |honda_cstpncpy_#t~post5.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(select #length cstpncpy_~s~3.base)| 1) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (- 1)) 0)
 (>=
 (+ (* (+ |honda_cstpncpy_#t~mem0.offset| |ray_cstpncpy_#t~mem0.offset|) 0)
 (*
 (+ |honda_(select #length cstpncpy_~d~3.base)|
 |ray_(select #length cstpncpy_~d~3.base)|) 0)
 (* (+ |honda_cstpncpy_#t~post4.offset| |ray_cstpncpy_#t~post4.offset|) 0)
 (* (+ honda_cstpncpy_~s~3.offset ray_cstpncpy_~s~3.offset) (- 1))
 (*
 (+
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 |ray_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|)
 0)
 (*
 (+ |honda_(select old(#length) cstpncpy_#in~src.base)|
 |ray_(select old(#length) cstpncpy_#in~src.base)|) 0)
 (* (+ |honda_cstpncpy_~#dst.offset| |ray_cstpncpy_~#dst.offset|) 0)
 (*
 (+
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 |ray_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|)
 0) (* (+ |honda_cstpncpy_#t~mem7| |ray_cstpncpy_#t~mem7|) 0)
 (*
 (+
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 |ray_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|)
 0) (* (+ honda_cstpncpy_~d~3.base ray_cstpncpy_~d~3.base) 0)
 (*
 (+
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 |ray_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|)
 0)
 (*
 (+ |honda_(select #length cstpncpy_#in~src.base)|
 |ray_(select #length cstpncpy_#in~src.base)|) 0)
 (* (+ |honda_cstpncpy_#in~src.offset| |ray_cstpncpy_#in~src.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)|
 |ray_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)|) 0)
 (* (+ |honda_cstpncpy_#t~mem1.offset| |ray_cstpncpy_#t~mem1.offset|) 0)
 (*
 (+ |honda_(select #length cstpncpy_#in~dst.base)|
 |ray_(select #length cstpncpy_#in~dst.base)|) 0)
 (* (+ |honda_cstpncpy_#t~mem0.base| |ray_cstpncpy_#t~mem0.base|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 |ray_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|)
 0) (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_cstpncpy_#in~n| |ray_cstpncpy_#in~n|) 0)
 (* (+ |honda_cstpncpy_#t~mem1.base| |ray_cstpncpy_#t~mem1.base|) 0)
 (* (+ |honda_cstpncpy_#t~post5.base| |ray_cstpncpy_#t~post5.base|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(select old(#length) cstpncpy_~#dst.base)|
 |ray_(select old(#length) cstpncpy_~#dst.base)|) 0)
 (*
 (+ |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)|
 |ray_(ite (select #valid cstpncpy_~d~3.base) 1 0)|) 0)
 (* (+ honda_cstpncpy_~s~3.base ray_cstpncpy_~s~3.base) 0)
 (*
 (+
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 |ray_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|)
 0)
 (*
 (+ |honda_(select #length cstpncpy_~s~3.base)|
 |ray_(select #length cstpncpy_~s~3.base)|) 0)
 (* (+ honda_cstpncpy_~n ray_cstpncpy_~n) 0)
 (* (+ |honda_cstpncpy_#in~dst.base| |ray_cstpncpy_#in~dst.base|) 0)
 (*
 (+ |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)|
 |ray_(ite (select #valid cstpncpy_#in~dst.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length cstpncpy_~#dst.base)|
 |ray_(select #length cstpncpy_~#dst.base)|) 0)
 (* (+ |honda_cstpncpy_#t~post4.base| |ray_cstpncpy_#t~post4.base|) 0)
 (*
 (+ |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)|
 |ray_(ite (select #valid cstpncpy_~#dst.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) cstpncpy_#in~dst.base)|
 |ray_(select old(#length) cstpncpy_#in~dst.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)|
 |ray_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)|) 0)
 (* (+ |honda_cstpncpy_#t~post5.offset| |ray_cstpncpy_#t~post5.offset|) 0)
 (*
 (+ |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)|
 |ray_(ite (select #valid cstpncpy_#in~src.base) 1 0)|) 0)
 (* (+ |honda_cstpncpy_#in~dst.offset| |ray_cstpncpy_#in~dst.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)|
 |ray_(ite (select #valid cstpncpy_~s~3.base) 1 0)|) 0)
 (* (+ honda_cstpncpy_~src.base ray_cstpncpy_~src.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ honda_cstpncpy_~d~3.offset ray_cstpncpy_~d~3.offset) 0)
 (* (+ |honda_cstpncpy_#t~post3| |ray_cstpncpy_#t~post3|) 0)
 (* (+ |honda_cstpncpy_~#dst.base| |ray_cstpncpy_~#dst.base|) 0)
 (* (+ honda_cstpncpy_~src.offset ray_cstpncpy_~src.offset) 0)
 (* (+ |honda_cstpncpy_#in~src.base| |ray_cstpncpy_#in~src.base|) 0)
 (*
 (+
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 |ray_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)|
 |ray_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)|) 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 1)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0) 
 (* honda_cstpncpy_~d~3.base 0) 
 (* |honda_cstpncpy_#t~post5.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 1) 0)
 (>=
 (+ (* (+ |honda_cstpncpy_#t~mem0.offset| |ray_cstpncpy_#t~mem0.offset|) 0)
 (*
 (+ |honda_(select #length cstpncpy_~d~3.base)|
 |ray_(select #length cstpncpy_~d~3.base)|) 0)
 (* (+ |honda_cstpncpy_#t~post4.offset| |ray_cstpncpy_#t~post4.offset|) 0)
 (* (+ honda_cstpncpy_~s~3.offset ray_cstpncpy_~s~3.offset) 0)
 (*
 (+
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 |ray_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|)
 0)
 (*
 (+ |honda_(select old(#length) cstpncpy_#in~src.base)|
 |ray_(select old(#length) cstpncpy_#in~src.base)|) 0)
 (* (+ |honda_cstpncpy_~#dst.offset| |ray_cstpncpy_~#dst.offset|) 0)
 (*
 (+
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 |ray_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|)
 0) (* (+ |honda_cstpncpy_#t~mem7| |ray_cstpncpy_#t~mem7|) 0)
 (*
 (+
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 |ray_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|)
 0) (* (+ honda_cstpncpy_~d~3.base ray_cstpncpy_~d~3.base) 0)
 (*
 (+
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 |ray_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|)
 0)
 (*
 (+ |honda_(select #length cstpncpy_#in~src.base)|
 |ray_(select #length cstpncpy_#in~src.base)|) 0)
 (* (+ |honda_cstpncpy_#in~src.offset| |ray_cstpncpy_#in~src.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)|
 |ray_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)|) 0)
 (* (+ |honda_cstpncpy_#t~mem1.offset| |ray_cstpncpy_#t~mem1.offset|) 0)
 (*
 (+ |honda_(select #length cstpncpy_#in~dst.base)|
 |ray_(select #length cstpncpy_#in~dst.base)|) 0)
 (* (+ |honda_cstpncpy_#t~mem0.base| |ray_cstpncpy_#t~mem0.base|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 |ray_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|)
 0) (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_cstpncpy_#in~n| |ray_cstpncpy_#in~n|) 0)
 (* (+ |honda_cstpncpy_#t~mem1.base| |ray_cstpncpy_#t~mem1.base|) 0)
 (* (+ |honda_cstpncpy_#t~post5.base| |ray_cstpncpy_#t~post5.base|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(select old(#length) cstpncpy_~#dst.base)|
 |ray_(select old(#length) cstpncpy_~#dst.base)|) 0)
 (*
 (+ |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)|
 |ray_(ite (select #valid cstpncpy_~d~3.base) 1 0)|) 0)
 (* (+ honda_cstpncpy_~s~3.base ray_cstpncpy_~s~3.base) 0)
 (*
 (+
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 |ray_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|)
 0)
 (*
 (+ |honda_(select #length cstpncpy_~s~3.base)|
 |ray_(select #length cstpncpy_~s~3.base)|) 0)
 (* (+ honda_cstpncpy_~n ray_cstpncpy_~n) (- 1))
 (* (+ |honda_cstpncpy_#in~dst.base| |ray_cstpncpy_#in~dst.base|) 0)
 (*
 (+ |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)|
 |ray_(ite (select #valid cstpncpy_#in~dst.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length cstpncpy_~#dst.base)|
 |ray_(select #length cstpncpy_~#dst.base)|) 0)
 (* (+ |honda_cstpncpy_#t~post4.base| |ray_cstpncpy_#t~post4.base|) 0)
 (*
 (+ |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)|
 |ray_(ite (select #valid cstpncpy_~#dst.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) cstpncpy_#in~dst.base)|
 |ray_(select old(#length) cstpncpy_#in~dst.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)|
 |ray_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)|) 0)
 (* (+ |honda_cstpncpy_#t~post5.offset| |ray_cstpncpy_#t~post5.offset|) 0)
 (*
 (+ |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)|
 |ray_(ite (select #valid cstpncpy_#in~src.base) 1 0)|) 0)
 (* (+ |honda_cstpncpy_#in~dst.offset| |ray_cstpncpy_#in~dst.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)|
 |ray_(ite (select #valid cstpncpy_~s~3.base) 1 0)|) 0)
 (* (+ honda_cstpncpy_~src.base ray_cstpncpy_~src.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ honda_cstpncpy_~d~3.offset ray_cstpncpy_~d~3.offset) 0)
 (* (+ |honda_cstpncpy_#t~post3| |ray_cstpncpy_#t~post3|) 0)
 (* (+ |honda_cstpncpy_~#dst.base| |ray_cstpncpy_~#dst.base|) 0)
 (* (+ honda_cstpncpy_~src.offset ray_cstpncpy_~src.offset) 0)
 (* (+ |honda_cstpncpy_#in~src.base| |ray_cstpncpy_#in~src.base|) 0)
 (*
 (+
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 |ray_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)|
 |ray_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)|) 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0) 
 (* honda_cstpncpy_~d~3.base 0) 
 (* |honda_cstpncpy_#t~post5.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 1) (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (- 1)) 0)
 (>=
 (+ (* (+ |honda_cstpncpy_#t~mem0.offset| |ray_cstpncpy_#t~mem0.offset|) 0)
 (*
 (+ |honda_(select #length cstpncpy_~d~3.base)|
 |ray_(select #length cstpncpy_~d~3.base)|) 0)
 (* (+ |honda_cstpncpy_#t~post4.offset| |ray_cstpncpy_#t~post4.offset|) 0)
 (* (+ honda_cstpncpy_~s~3.offset ray_cstpncpy_~s~3.offset) 0)
 (*
 (+
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 |ray_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|)
 0)
 (*
 (+ |honda_(select old(#length) cstpncpy_#in~src.base)|
 |ray_(select old(#length) cstpncpy_#in~src.base)|) 0)
 (* (+ |honda_cstpncpy_~#dst.offset| |ray_cstpncpy_~#dst.offset|) 0)
 (*
 (+
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 |ray_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|)
 0) (* (+ |honda_cstpncpy_#t~mem7| |ray_cstpncpy_#t~mem7|) 0)
 (*
 (+
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 |ray_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|)
 0) (* (+ honda_cstpncpy_~d~3.base ray_cstpncpy_~d~3.base) 0)
 (*
 (+
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 |ray_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|)
 0)
 (*
 (+ |honda_(select #length cstpncpy_#in~src.base)|
 |ray_(select #length cstpncpy_#in~src.base)|) 0)
 (* (+ |honda_cstpncpy_#in~src.offset| |ray_cstpncpy_#in~src.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)|
 |ray_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)|) 0)
 (* (+ |honda_cstpncpy_#t~mem1.offset| |ray_cstpncpy_#t~mem1.offset|) 0)
 (*
 (+ |honda_(select #length cstpncpy_#in~dst.base)|
 |ray_(select #length cstpncpy_#in~dst.base)|) 0)
 (* (+ |honda_cstpncpy_#t~mem0.base| |ray_cstpncpy_#t~mem0.base|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 |ray_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|)
 0) (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_cstpncpy_#in~n| |ray_cstpncpy_#in~n|) 0)
 (* (+ |honda_cstpncpy_#t~mem1.base| |ray_cstpncpy_#t~mem1.base|) 0)
 (* (+ |honda_cstpncpy_#t~post5.base| |ray_cstpncpy_#t~post5.base|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(select old(#length) cstpncpy_~#dst.base)|
 |ray_(select old(#length) cstpncpy_~#dst.base)|) 0)
 (*
 (+ |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)|
 |ray_(ite (select #valid cstpncpy_~d~3.base) 1 0)|) 0)
 (* (+ honda_cstpncpy_~s~3.base ray_cstpncpy_~s~3.base) 0)
 (*
 (+
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 |ray_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|)
 0)
 (*
 (+ |honda_(select #length cstpncpy_~s~3.base)|
 |ray_(select #length cstpncpy_~s~3.base)|) 0)
 (* (+ honda_cstpncpy_~n ray_cstpncpy_~n) 0)
 (* (+ |honda_cstpncpy_#in~dst.base| |ray_cstpncpy_#in~dst.base|) 0)
 (*
 (+ |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)|
 |ray_(ite (select #valid cstpncpy_#in~dst.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length cstpncpy_~#dst.base)|
 |ray_(select #length cstpncpy_~#dst.base)|) 0)
 (* (+ |honda_cstpncpy_#t~post4.base| |ray_cstpncpy_#t~post4.base|) 0)
 (*
 (+ |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)|
 |ray_(ite (select #valid cstpncpy_~#dst.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) cstpncpy_#in~dst.base)|
 |ray_(select old(#length) cstpncpy_#in~dst.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)|
 |ray_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)|) 0)
 (* (+ |honda_cstpncpy_#t~post5.offset| |ray_cstpncpy_#t~post5.offset|) 0)
 (*
 (+ |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)|
 |ray_(ite (select #valid cstpncpy_#in~src.base) 1 0)|) 0)
 (* (+ |honda_cstpncpy_#in~dst.offset| |ray_cstpncpy_#in~dst.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)|
 |ray_(ite (select #valid cstpncpy_~s~3.base) 1 0)|) 0)
 (* (+ honda_cstpncpy_~src.base ray_cstpncpy_~src.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ honda_cstpncpy_~d~3.offset ray_cstpncpy_~d~3.offset) 1)
 (* (+ |honda_cstpncpy_#t~post3| |ray_cstpncpy_#t~post3|) 0)
 (* (+ |honda_cstpncpy_~#dst.base| |ray_cstpncpy_~#dst.base|) 0)
 (* (+ honda_cstpncpy_~src.offset ray_cstpncpy_~src.offset) 0)
 (* (+ |honda_cstpncpy_#in~src.base| |ray_cstpncpy_#in~src.base|) 0)
 (*
 (+
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 |ray_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)|
 |ray_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)|) 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0) 
 (* honda_cstpncpy_~d~3.base 0) 
 (* |honda_cstpncpy_#t~post5.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset (- 1)) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (- 1)) 0)
 (>=
 (+ (* (+ |honda_cstpncpy_#t~mem0.offset| |ray_cstpncpy_#t~mem0.offset|) 0)
 (*
 (+ |honda_(select #length cstpncpy_~d~3.base)|
 |ray_(select #length cstpncpy_~d~3.base)|) 0)
 (* (+ |honda_cstpncpy_#t~post4.offset| |ray_cstpncpy_#t~post4.offset|) 0)
 (* (+ honda_cstpncpy_~s~3.offset ray_cstpncpy_~s~3.offset) 0)
 (*
 (+
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 |ray_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|)
 0)
 (*
 (+ |honda_(select old(#length) cstpncpy_#in~src.base)|
 |ray_(select old(#length) cstpncpy_#in~src.base)|) 0)
 (* (+ |honda_cstpncpy_~#dst.offset| |ray_cstpncpy_~#dst.offset|) 0)
 (*
 (+
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 |ray_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|)
 0) (* (+ |honda_cstpncpy_#t~mem7| |ray_cstpncpy_#t~mem7|) 0)
 (*
 (+
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 |ray_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|)
 0) (* (+ honda_cstpncpy_~d~3.base ray_cstpncpy_~d~3.base) 0)
 (*
 (+
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 |ray_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|)
 0)
 (*
 (+ |honda_(select #length cstpncpy_#in~src.base)|
 |ray_(select #length cstpncpy_#in~src.base)|) 0)
 (* (+ |honda_cstpncpy_#in~src.offset| |ray_cstpncpy_#in~src.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)|
 |ray_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)|) 0)
 (* (+ |honda_cstpncpy_#t~mem1.offset| |ray_cstpncpy_#t~mem1.offset|) 0)
 (*
 (+ |honda_(select #length cstpncpy_#in~dst.base)|
 |ray_(select #length cstpncpy_#in~dst.base)|) 0)
 (* (+ |honda_cstpncpy_#t~mem0.base| |ray_cstpncpy_#t~mem0.base|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 |ray_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|)
 0) (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_cstpncpy_#in~n| |ray_cstpncpy_#in~n|) 0)
 (* (+ |honda_cstpncpy_#t~mem1.base| |ray_cstpncpy_#t~mem1.base|) 0)
 (* (+ |honda_cstpncpy_#t~post5.base| |ray_cstpncpy_#t~post5.base|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(select old(#length) cstpncpy_~#dst.base)|
 |ray_(select old(#length) cstpncpy_~#dst.base)|) 0)
 (*
 (+ |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)|
 |ray_(ite (select #valid cstpncpy_~d~3.base) 1 0)|) 0)
 (* (+ honda_cstpncpy_~s~3.base ray_cstpncpy_~s~3.base) 1)
 (*
 (+
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 |ray_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|)
 0)
 (*
 (+ |honda_(select #length cstpncpy_~s~3.base)|
 |ray_(select #length cstpncpy_~s~3.base)|) 0)
 (* (+ honda_cstpncpy_~n ray_cstpncpy_~n) 0)
 (* (+ |honda_cstpncpy_#in~dst.base| |ray_cstpncpy_#in~dst.base|) 0)
 (*
 (+ |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)|
 |ray_(ite (select #valid cstpncpy_#in~dst.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length cstpncpy_~#dst.base)|
 |ray_(select #length cstpncpy_~#dst.base)|) 0)
 (* (+ |honda_cstpncpy_#t~post4.base| |ray_cstpncpy_#t~post4.base|) 0)
 (*
 (+ |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)|
 |ray_(ite (select #valid cstpncpy_~#dst.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) cstpncpy_#in~dst.base)|
 |ray_(select old(#length) cstpncpy_#in~dst.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)|
 |ray_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)|) 0)
 (* (+ |honda_cstpncpy_#t~post5.offset| |ray_cstpncpy_#t~post5.offset|) 0)
 (*
 (+ |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)|
 |ray_(ite (select #valid cstpncpy_#in~src.base) 1 0)|) 0)
 (* (+ |honda_cstpncpy_#in~dst.offset| |ray_cstpncpy_#in~dst.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)|
 |ray_(ite (select #valid cstpncpy_~s~3.base) 1 0)|) 0)
 (* (+ honda_cstpncpy_~src.base ray_cstpncpy_~src.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ honda_cstpncpy_~d~3.offset ray_cstpncpy_~d~3.offset) 0)
 (* (+ |honda_cstpncpy_#t~post3| |ray_cstpncpy_#t~post3|) 0)
 (* (+ |honda_cstpncpy_~#dst.base| |ray_cstpncpy_~#dst.base|) 0)
 (* (+ honda_cstpncpy_~src.offset ray_cstpncpy_~src.offset) 0)
 (* (+ |honda_cstpncpy_#in~src.base| |ray_cstpncpy_#in~src.base|) 0)
 (*
 (+
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 |ray_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)|
 |ray_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)|) 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0) 
 (* honda_cstpncpy_~d~3.base (- 1)) 
 (* |honda_cstpncpy_#t~post5.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (- 1)) 0)
 (>=
 (+ (* (+ |honda_cstpncpy_#t~mem0.offset| |ray_cstpncpy_#t~mem0.offset|) 0)
 (*
 (+ |honda_(select #length cstpncpy_~d~3.base)|
 |ray_(select #length cstpncpy_~d~3.base)|) 0)
 (* (+ |honda_cstpncpy_#t~post4.offset| |ray_cstpncpy_#t~post4.offset|) 0)
 (* (+ honda_cstpncpy_~s~3.offset ray_cstpncpy_~s~3.offset) 0)
 (*
 (+
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 |ray_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|)
 0)
 (*
 (+ |honda_(select old(#length) cstpncpy_#in~src.base)|
 |ray_(select old(#length) cstpncpy_#in~src.base)|) 0)
 (* (+ |honda_cstpncpy_~#dst.offset| |ray_cstpncpy_~#dst.offset|) 0)
 (*
 (+
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 |ray_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|)
 0) (* (+ |honda_cstpncpy_#t~mem7| |ray_cstpncpy_#t~mem7|) 0)
 (*
 (+
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 |ray_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|)
 0) (* (+ honda_cstpncpy_~d~3.base ray_cstpncpy_~d~3.base) 0)
 (*
 (+
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 |ray_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|)
 0)
 (*
 (+ |honda_(select #length cstpncpy_#in~src.base)|
 |ray_(select #length cstpncpy_#in~src.base)|) 0)
 (* (+ |honda_cstpncpy_#in~src.offset| |ray_cstpncpy_#in~src.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)|
 |ray_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)|) 0)
 (* (+ |honda_cstpncpy_#t~mem1.offset| |ray_cstpncpy_#t~mem1.offset|) 0)
 (*
 (+ |honda_(select #length cstpncpy_#in~dst.base)|
 |ray_(select #length cstpncpy_#in~dst.base)|) 0)
 (* (+ |honda_cstpncpy_#t~mem0.base| |ray_cstpncpy_#t~mem0.base|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 |ray_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|)
 0) (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_cstpncpy_#in~n| |ray_cstpncpy_#in~n|) 0)
 (* (+ |honda_cstpncpy_#t~mem1.base| |ray_cstpncpy_#t~mem1.base|) 0)
 (* (+ |honda_cstpncpy_#t~post5.base| |ray_cstpncpy_#t~post5.base|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(select old(#length) cstpncpy_~#dst.base)|
 |ray_(select old(#length) cstpncpy_~#dst.base)|) 0)
 (*
 (+ |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)|
 |ray_(ite (select #valid cstpncpy_~d~3.base) 1 0)|) 0)
 (* (+ honda_cstpncpy_~s~3.base ray_cstpncpy_~s~3.base) 0)
 (*
 (+
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 |ray_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|)
 0)
 (*
 (+ |honda_(select #length cstpncpy_~s~3.base)|
 |ray_(select #length cstpncpy_~s~3.base)|) 0)
 (* (+ honda_cstpncpy_~n ray_cstpncpy_~n) 0)
 (* (+ |honda_cstpncpy_#in~dst.base| |ray_cstpncpy_#in~dst.base|) 0)
 (*
 (+ |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)|
 |ray_(ite (select #valid cstpncpy_#in~dst.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length cstpncpy_~#dst.base)|
 |ray_(select #length cstpncpy_~#dst.base)|) 0)
 (* (+ |honda_cstpncpy_#t~post4.base| |ray_cstpncpy_#t~post4.base|) 0)
 (*
 (+ |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)|
 |ray_(ite (select #valid cstpncpy_~#dst.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) cstpncpy_#in~dst.base)|
 |ray_(select old(#length) cstpncpy_#in~dst.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)|
 |ray_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)|) 0)
 (* (+ |honda_cstpncpy_#t~post5.offset| |ray_cstpncpy_#t~post5.offset|) 0)
 (*
 (+ |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)|
 |ray_(ite (select #valid cstpncpy_#in~src.base) 1 0)|) 0)
 (* (+ |honda_cstpncpy_#in~dst.offset| |ray_cstpncpy_#in~dst.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)|
 |ray_(ite (select #valid cstpncpy_~s~3.base) 1 0)|) 0)
 (* (+ honda_cstpncpy_~src.base ray_cstpncpy_~src.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ honda_cstpncpy_~d~3.offset ray_cstpncpy_~d~3.offset) 0)
 (* (+ |honda_cstpncpy_#t~post3| |ray_cstpncpy_#t~post3|) 0)
 (* (+ |honda_cstpncpy_~#dst.base| |ray_cstpncpy_~#dst.base|) 0)
 (* (+ honda_cstpncpy_~src.offset ray_cstpncpy_~src.offset) 0)
 (* (+ |honda_cstpncpy_#in~src.base| |ray_cstpncpy_#in~src.base|) 0)
 (*
 (+
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 |ray_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)|
 |ray_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)|) 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 (- 1)) (* |honda_cstpncpy_#t~mem7| 0) 
 (* honda_cstpncpy_~d~3.base 0) 
 (* |honda_cstpncpy_#t~post5.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (- 1)) 0)
 (>=
 (+ (* (+ |honda_cstpncpy_#t~mem0.offset| |ray_cstpncpy_#t~mem0.offset|) 0)
 (*
 (+ |honda_(select #length cstpncpy_~d~3.base)|
 |ray_(select #length cstpncpy_~d~3.base)|) 0)
 (* (+ |honda_cstpncpy_#t~post4.offset| |ray_cstpncpy_#t~post4.offset|) 0)
 (* (+ honda_cstpncpy_~s~3.offset ray_cstpncpy_~s~3.offset) 0)
 (*
 (+
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 |ray_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|)
 0)
 (*
 (+ |honda_(select old(#length) cstpncpy_#in~src.base)|
 |ray_(select old(#length) cstpncpy_#in~src.base)|) 0)
 (* (+ |honda_cstpncpy_~#dst.offset| |ray_cstpncpy_~#dst.offset|) 0)
 (*
 (+
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 |ray_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|)
 0) (* (+ |honda_cstpncpy_#t~mem7| |ray_cstpncpy_#t~mem7|) 0)
 (*
 (+
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 |ray_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|)
 0) (* (+ honda_cstpncpy_~d~3.base ray_cstpncpy_~d~3.base) 0)
 (*
 (+
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 |ray_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|)
 0)
 (*
 (+ |honda_(select #length cstpncpy_#in~src.base)|
 |ray_(select #length cstpncpy_#in~src.base)|) 0)
 (* (+ |honda_cstpncpy_#in~src.offset| |ray_cstpncpy_#in~src.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)|
 |ray_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)|) 0)
 (* (+ |honda_cstpncpy_#t~mem1.offset| |ray_cstpncpy_#t~mem1.offset|) 0)
 (*
 (+ |honda_(select #length cstpncpy_#in~dst.base)|
 |ray_(select #length cstpncpy_#in~dst.base)|) 0)
 (* (+ |honda_cstpncpy_#t~mem0.base| |ray_cstpncpy_#t~mem0.base|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 |ray_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|)
 0) (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_cstpncpy_#in~n| |ray_cstpncpy_#in~n|) 0)
 (* (+ |honda_cstpncpy_#t~mem1.base| |ray_cstpncpy_#t~mem1.base|) 0)
 (* (+ |honda_cstpncpy_#t~post5.base| |ray_cstpncpy_#t~post5.base|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(select old(#length) cstpncpy_~#dst.base)|
 |ray_(select old(#length) cstpncpy_~#dst.base)|) 0)
 (*
 (+ |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)|
 |ray_(ite (select #valid cstpncpy_~d~3.base) 1 0)|) 0)
 (* (+ honda_cstpncpy_~s~3.base ray_cstpncpy_~s~3.base) 0)
 (*
 (+
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 |ray_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|)
 0)
 (*
 (+ |honda_(select #length cstpncpy_~s~3.base)|
 |ray_(select #length cstpncpy_~s~3.base)|) 0)
 (* (+ honda_cstpncpy_~n ray_cstpncpy_~n) 0)
 (* (+ |honda_cstpncpy_#in~dst.base| |ray_cstpncpy_#in~dst.base|) 0)
 (*
 (+ |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)|
 |ray_(ite (select #valid cstpncpy_#in~dst.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length cstpncpy_~#dst.base)|
 |ray_(select #length cstpncpy_~#dst.base)|) 0)
 (* (+ |honda_cstpncpy_#t~post4.base| |ray_cstpncpy_#t~post4.base|) 0)
 (*
 (+ |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)|
 |ray_(ite (select #valid cstpncpy_~#dst.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) cstpncpy_#in~dst.base)|
 |ray_(select old(#length) cstpncpy_#in~dst.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)|
 |ray_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)|) 0)
 (* (+ |honda_cstpncpy_#t~post5.offset| |ray_cstpncpy_#t~post5.offset|) 0)
 (*
 (+ |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)|
 |ray_(ite (select #valid cstpncpy_#in~src.base) 1 0)|) 0)
 (* (+ |honda_cstpncpy_#in~dst.offset| |ray_cstpncpy_#in~dst.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)|
 |ray_(ite (select #valid cstpncpy_~s~3.base) 1 0)|) 1)
 (* (+ honda_cstpncpy_~src.base ray_cstpncpy_~src.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ honda_cstpncpy_~d~3.offset ray_cstpncpy_~d~3.offset) 0)
 (* (+ |honda_cstpncpy_#t~post3| |ray_cstpncpy_#t~post3|) 0)
 (* (+ |honda_cstpncpy_~#dst.base| |ray_cstpncpy_~#dst.base|) 0)
 (* (+ honda_cstpncpy_~src.offset ray_cstpncpy_~src.offset) 0)
 (* (+ |honda_cstpncpy_#in~src.base| |ray_cstpncpy_#in~src.base|) 0)
 (*
 (+
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 |ray_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)|
 |ray_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)|) 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0) 
 (* honda_cstpncpy_~d~3.base 0) 
 (* |honda_cstpncpy_#t~post5.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (- 1)) 0)
 (>=
 (+ (* (+ |honda_cstpncpy_#t~mem0.offset| |ray_cstpncpy_#t~mem0.offset|) 0)
 (*
 (+ |honda_(select #length cstpncpy_~d~3.base)|
 |ray_(select #length cstpncpy_~d~3.base)|) 0)
 (* (+ |honda_cstpncpy_#t~post4.offset| |ray_cstpncpy_#t~post4.offset|) 0)
 (* (+ honda_cstpncpy_~s~3.offset ray_cstpncpy_~s~3.offset) 0)
 (*
 (+
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 |ray_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|)
 0)
 (*
 (+ |honda_(select old(#length) cstpncpy_#in~src.base)|
 |ray_(select old(#length) cstpncpy_#in~src.base)|) 0)
 (* (+ |honda_cstpncpy_~#dst.offset| |ray_cstpncpy_~#dst.offset|) 0)
 (*
 (+
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 |ray_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|)
 0) (* (+ |honda_cstpncpy_#t~mem7| |ray_cstpncpy_#t~mem7|) 0)
 (*
 (+
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 |ray_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|)
 0) (* (+ honda_cstpncpy_~d~3.base ray_cstpncpy_~d~3.base) 0)
 (*
 (+
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 |ray_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|)
 0)
 (*
 (+ |honda_(select #length cstpncpy_#in~src.base)|
 |ray_(select #length cstpncpy_#in~src.base)|) 0)
 (* (+ |honda_cstpncpy_#in~src.offset| |ray_cstpncpy_#in~src.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)|
 |ray_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)|) 0)
 (* (+ |honda_cstpncpy_#t~mem1.offset| |ray_cstpncpy_#t~mem1.offset|) 0)
 (*
 (+ |honda_(select #length cstpncpy_#in~dst.base)|
 |ray_(select #length cstpncpy_#in~dst.base)|) 0)
 (* (+ |honda_cstpncpy_#t~mem0.base| |ray_cstpncpy_#t~mem0.base|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 |ray_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|)
 0) (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_cstpncpy_#in~n| |ray_cstpncpy_#in~n|) 0)
 (* (+ |honda_cstpncpy_#t~mem1.base| |ray_cstpncpy_#t~mem1.base|) 0)
 (* (+ |honda_cstpncpy_#t~post5.base| |ray_cstpncpy_#t~post5.base|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(select old(#length) cstpncpy_~#dst.base)|
 |ray_(select old(#length) cstpncpy_~#dst.base)|) 0)
 (*
 (+ |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)|
 |ray_(ite (select #valid cstpncpy_~d~3.base) 1 0)|) 0)
 (* (+ honda_cstpncpy_~s~3.base ray_cstpncpy_~s~3.base) 0)
 (*
 (+
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 |ray_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|)
 0)
 (*
 (+ |honda_(select #length cstpncpy_~s~3.base)|
 |ray_(select #length cstpncpy_~s~3.base)|) 0)
 (* (+ honda_cstpncpy_~n ray_cstpncpy_~n) 0)
 (* (+ |honda_cstpncpy_#in~dst.base| |ray_cstpncpy_#in~dst.base|) 0)
 (*
 (+ |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)|
 |ray_(ite (select #valid cstpncpy_#in~dst.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length cstpncpy_~#dst.base)|
 |ray_(select #length cstpncpy_~#dst.base)|) 0)
 (* (+ |honda_cstpncpy_#t~post4.base| |ray_cstpncpy_#t~post4.base|) 0)
 (*
 (+ |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)|
 |ray_(ite (select #valid cstpncpy_~#dst.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) cstpncpy_#in~dst.base)|
 |ray_(select old(#length) cstpncpy_#in~dst.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)|
 |ray_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)|) 0)
 (* (+ |honda_cstpncpy_#t~post5.offset| |ray_cstpncpy_#t~post5.offset|) 0)
 (*
 (+ |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)|
 |ray_(ite (select #valid cstpncpy_#in~src.base) 1 0)|) 0)
 (* (+ |honda_cstpncpy_#in~dst.offset| |ray_cstpncpy_#in~dst.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)|
 |ray_(ite (select #valid cstpncpy_~s~3.base) 1 0)|) 0)
 (* (+ honda_cstpncpy_~src.base ray_cstpncpy_~src.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ honda_cstpncpy_~d~3.offset ray_cstpncpy_~d~3.offset) 0)
 (* (+ |honda_cstpncpy_#t~post3| |ray_cstpncpy_#t~post3|) 0)
 (* (+ |honda_cstpncpy_~#dst.base| |ray_cstpncpy_~#dst.base|) 0)
 (* (+ honda_cstpncpy_~src.offset ray_cstpncpy_~src.offset) 0)
 (* (+ |honda_cstpncpy_#in~src.base| |ray_cstpncpy_#in~src.base|) 0)
 (*
 (+
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 |ray_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)|
 |ray_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)|) 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0) 
 (* honda_cstpncpy_~d~3.base 0) 
 (* |honda_cstpncpy_#t~post5.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(select #length cstpncpy_~s~3.base)| 0)
 (* honda_cstpncpy_~n (- 1)) 
 (* |honda_cstpncpy_#t~post4.base| 0) 
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* aux_3746 1) (* aux_3747 4294967296) 1) 0)
 (>=
 (+ (* (+ |honda_cstpncpy_#t~mem0.offset| |ray_cstpncpy_#t~mem0.offset|) 0)
 (*
 (+ |honda_(select #length cstpncpy_~d~3.base)|
 |ray_(select #length cstpncpy_~d~3.base)|) 0)
 (* (+ |honda_cstpncpy_#t~post4.offset| |ray_cstpncpy_#t~post4.offset|) 0)
 (* (+ honda_cstpncpy_~s~3.offset ray_cstpncpy_~s~3.offset) 0)
 (*
 (+
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 |ray_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|)
 0)
 (*
 (+ |honda_(select old(#length) cstpncpy_#in~src.base)|
 |ray_(select old(#length) cstpncpy_#in~src.base)|) 0)
 (* (+ |honda_cstpncpy_~#dst.offset| |ray_cstpncpy_~#dst.offset|) 0)
 (*
 (+
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 |ray_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|)
 0) (* (+ |honda_cstpncpy_#t~mem7| |ray_cstpncpy_#t~mem7|) 0)
 (*
 (+
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 |ray_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|)
 0) (* (+ honda_cstpncpy_~d~3.base ray_cstpncpy_~d~3.base) 0)
 (*
 (+
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 |ray_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|)
 0)
 (*
 (+ |honda_(select #length cstpncpy_#in~src.base)|
 |ray_(select #length cstpncpy_#in~src.base)|) 0)
 (* (+ |honda_cstpncpy_#in~src.offset| |ray_cstpncpy_#in~src.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)|
 |ray_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)|) 0)
 (* (+ |honda_cstpncpy_#t~mem1.offset| |ray_cstpncpy_#t~mem1.offset|) 0)
 (*
 (+ |honda_(select #length cstpncpy_#in~dst.base)|
 |ray_(select #length cstpncpy_#in~dst.base)|) 0)
 (* (+ |honda_cstpncpy_#t~mem0.base| |ray_cstpncpy_#t~mem0.base|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 |ray_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|)
 0) (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_cstpncpy_#in~n| |ray_cstpncpy_#in~n|) 0)
 (* (+ |honda_cstpncpy_#t~mem1.base| |ray_cstpncpy_#t~mem1.base|) 0)
 (* (+ |honda_cstpncpy_#t~post5.base| |ray_cstpncpy_#t~post5.base|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(select old(#length) cstpncpy_~#dst.base)|
 |ray_(select old(#length) cstpncpy_~#dst.base)|) 0)
 (*
 (+ |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)|
 |ray_(ite (select #valid cstpncpy_~d~3.base) 1 0)|) 0)
 (* (+ honda_cstpncpy_~s~3.base ray_cstpncpy_~s~3.base) 0)
 (*
 (+
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 |ray_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|)
 0)
 (*
 (+ |honda_(select #length cstpncpy_~s~3.base)|
 |ray_(select #length cstpncpy_~s~3.base)|) 0)
 (* (+ honda_cstpncpy_~n ray_cstpncpy_~n) 0)
 (* (+ |honda_cstpncpy_#in~dst.base| |ray_cstpncpy_#in~dst.base|) 0)
 (*
 (+ |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)|
 |ray_(ite (select #valid cstpncpy_#in~dst.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length cstpncpy_~#dst.base)|
 |ray_(select #length cstpncpy_~#dst.base)|) 0)
 (* (+ |honda_cstpncpy_#t~post4.base| |ray_cstpncpy_#t~post4.base|) 0)
 (*
 (+ |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)|
 |ray_(ite (select #valid cstpncpy_~#dst.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) cstpncpy_#in~dst.base)|
 |ray_(select old(#length) cstpncpy_#in~dst.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)|
 |ray_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)|) 0)
 (* (+ |honda_cstpncpy_#t~post5.offset| |ray_cstpncpy_#t~post5.offset|) 0)
 (*
 (+ |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)|
 |ray_(ite (select #valid cstpncpy_#in~src.base) 1 0)|) 0)
 (* (+ |honda_cstpncpy_#in~dst.offset| |ray_cstpncpy_#in~dst.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)|
 |ray_(ite (select #valid cstpncpy_~s~3.base) 1 0)|) 0)
 (* (+ honda_cstpncpy_~src.base ray_cstpncpy_~src.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ honda_cstpncpy_~d~3.offset ray_cstpncpy_~d~3.offset) 0)
 (* (+ |honda_cstpncpy_#t~post3| |ray_cstpncpy_#t~post3|) 0)
 (* (+ |honda_cstpncpy_~#dst.base| |ray_cstpncpy_~#dst.base|) 0)
 (* (+ honda_cstpncpy_~src.offset ray_cstpncpy_~src.offset) 0)
 (* (+ |honda_cstpncpy_#in~src.base| |ray_cstpncpy_#in~src.base|) 0)
 (*
 (+
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 |ray_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)|
 |ray_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)|) 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0) 
 (* honda_cstpncpy_~d~3.base 0) 
 (* |honda_cstpncpy_#t~post5.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* aux_3746 (- 1)) 4294967295) 0)
 (>=
 (+ (* (+ |honda_cstpncpy_#t~mem0.offset| |ray_cstpncpy_#t~mem0.offset|) 0)
 (*
 (+ |honda_(select #length cstpncpy_~d~3.base)|
 |ray_(select #length cstpncpy_~d~3.base)|) 0)
 (* (+ |honda_cstpncpy_#t~post4.offset| |ray_cstpncpy_#t~post4.offset|) 0)
 (* (+ honda_cstpncpy_~s~3.offset ray_cstpncpy_~s~3.offset) 0)
 (*
 (+
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 |ray_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|)
 0)
 (*
 (+ |honda_(select old(#length) cstpncpy_#in~src.base)|
 |ray_(select old(#length) cstpncpy_#in~src.base)|) 0)
 (* (+ |honda_cstpncpy_~#dst.offset| |ray_cstpncpy_~#dst.offset|) 0)
 (*
 (+
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 |ray_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|)
 0) (* (+ |honda_cstpncpy_#t~mem7| |ray_cstpncpy_#t~mem7|) 0)
 (*
 (+
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 |ray_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|)
 0) (* (+ honda_cstpncpy_~d~3.base ray_cstpncpy_~d~3.base) 0)
 (*
 (+
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 |ray_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|)
 0)
 (*
 (+ |honda_(select #length cstpncpy_#in~src.base)|
 |ray_(select #length cstpncpy_#in~src.base)|) 0)
 (* (+ |honda_cstpncpy_#in~src.offset| |ray_cstpncpy_#in~src.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)|
 |ray_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)|) 0)
 (* (+ |honda_cstpncpy_#t~mem1.offset| |ray_cstpncpy_#t~mem1.offset|) 0)
 (*
 (+ |honda_(select #length cstpncpy_#in~dst.base)|
 |ray_(select #length cstpncpy_#in~dst.base)|) 0)
 (* (+ |honda_cstpncpy_#t~mem0.base| |ray_cstpncpy_#t~mem0.base|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 |ray_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|)
 0) (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_cstpncpy_#in~n| |ray_cstpncpy_#in~n|) 0)
 (* (+ |honda_cstpncpy_#t~mem1.base| |ray_cstpncpy_#t~mem1.base|) 0)
 (* (+ |honda_cstpncpy_#t~post5.base| |ray_cstpncpy_#t~post5.base|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(select old(#length) cstpncpy_~#dst.base)|
 |ray_(select old(#length) cstpncpy_~#dst.base)|) 0)
 (*
 (+ |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)|
 |ray_(ite (select #valid cstpncpy_~d~3.base) 1 0)|) 0)
 (* (+ honda_cstpncpy_~s~3.base ray_cstpncpy_~s~3.base) 0)
 (*
 (+
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 |ray_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|)
 0)
 (*
 (+ |honda_(select #length cstpncpy_~s~3.base)|
 |ray_(select #length cstpncpy_~s~3.base)|) 0)
 (* (+ honda_cstpncpy_~n ray_cstpncpy_~n) 0)
 (* (+ |honda_cstpncpy_#in~dst.base| |ray_cstpncpy_#in~dst.base|) 0)
 (*
 (+ |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)|
 |ray_(ite (select #valid cstpncpy_#in~dst.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length cstpncpy_~#dst.base)|
 |ray_(select #length cstpncpy_~#dst.base)|) 0)
 (* (+ |honda_cstpncpy_#t~post4.base| |ray_cstpncpy_#t~post4.base|) 0)
 (*
 (+ |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)|
 |ray_(ite (select #valid cstpncpy_~#dst.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) cstpncpy_#in~dst.base)|
 |ray_(select old(#length) cstpncpy_#in~dst.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)|
 |ray_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)|) 0)
 (* (+ |honda_cstpncpy_#t~post5.offset| |ray_cstpncpy_#t~post5.offset|) 0)
 (*
 (+ |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)|
 |ray_(ite (select #valid cstpncpy_#in~src.base) 1 0)|) 0)
 (* (+ |honda_cstpncpy_#in~dst.offset| |ray_cstpncpy_#in~dst.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)|
 |ray_(ite (select #valid cstpncpy_~s~3.base) 1 0)|) 0)
 (* (+ honda_cstpncpy_~src.base ray_cstpncpy_~src.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ honda_cstpncpy_~d~3.offset ray_cstpncpy_~d~3.offset) 0)
 (* (+ |honda_cstpncpy_#t~post3| |ray_cstpncpy_#t~post3|) 0)
 (* (+ |honda_cstpncpy_~#dst.base| |ray_cstpncpy_~#dst.base|) 0)
 (* (+ honda_cstpncpy_~src.offset ray_cstpncpy_~src.offset) 0)
 (* (+ |honda_cstpncpy_#in~src.base| |ray_cstpncpy_#in~src.base|) 0)
 (*
 (+
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 |ray_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)|
 |ray_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)|) 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0) 
 (* honda_cstpncpy_~d~3.base 0) 
 (* |honda_cstpncpy_#t~post5.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 1) (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* aux_3746 (- 1)) (* aux_3747 (- 4294967296)) 
 (- 1)) 0)
 (>=
 (+ (* (+ |honda_cstpncpy_#t~mem0.offset| |ray_cstpncpy_#t~mem0.offset|) 0)
 (*
 (+ |honda_(select #length cstpncpy_~d~3.base)|
 |ray_(select #length cstpncpy_~d~3.base)|) 0)
 (* (+ |honda_cstpncpy_#t~post4.offset| |ray_cstpncpy_#t~post4.offset|) 0)
 (* (+ honda_cstpncpy_~s~3.offset ray_cstpncpy_~s~3.offset) 0)
 (*
 (+
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 |ray_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|)
 0)
 (*
 (+ |honda_(select old(#length) cstpncpy_#in~src.base)|
 |ray_(select old(#length) cstpncpy_#in~src.base)|) 0)
 (* (+ |honda_cstpncpy_~#dst.offset| |ray_cstpncpy_~#dst.offset|) 0)
 (*
 (+
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 |ray_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|)
 0) (* (+ |honda_cstpncpy_#t~mem7| |ray_cstpncpy_#t~mem7|) 0)
 (*
 (+
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 |ray_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|)
 0) (* (+ honda_cstpncpy_~d~3.base ray_cstpncpy_~d~3.base) 0)
 (*
 (+
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 |ray_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|)
 0)
 (*
 (+ |honda_(select #length cstpncpy_#in~src.base)|
 |ray_(select #length cstpncpy_#in~src.base)|) 0)
 (* (+ |honda_cstpncpy_#in~src.offset| |ray_cstpncpy_#in~src.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)|
 |ray_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)|) 0)
 (* (+ |honda_cstpncpy_#t~mem1.offset| |ray_cstpncpy_#t~mem1.offset|) 0)
 (*
 (+ |honda_(select #length cstpncpy_#in~dst.base)|
 |ray_(select #length cstpncpy_#in~dst.base)|) 0)
 (* (+ |honda_cstpncpy_#t~mem0.base| |ray_cstpncpy_#t~mem0.base|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 |ray_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|)
 0) (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_cstpncpy_#in~n| |ray_cstpncpy_#in~n|) 0)
 (* (+ |honda_cstpncpy_#t~mem1.base| |ray_cstpncpy_#t~mem1.base|) 0)
 (* (+ |honda_cstpncpy_#t~post5.base| |ray_cstpncpy_#t~post5.base|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(select old(#length) cstpncpy_~#dst.base)|
 |ray_(select old(#length) cstpncpy_~#dst.base)|) 0)
 (*
 (+ |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)|
 |ray_(ite (select #valid cstpncpy_~d~3.base) 1 0)|) 0)
 (* (+ honda_cstpncpy_~s~3.base ray_cstpncpy_~s~3.base) 0)
 (*
 (+
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 |ray_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|)
 0)
 (*
 (+ |honda_(select #length cstpncpy_~s~3.base)|
 |ray_(select #length cstpncpy_~s~3.base)|) 0)
 (* (+ honda_cstpncpy_~n ray_cstpncpy_~n) 0)
 (* (+ |honda_cstpncpy_#in~dst.base| |ray_cstpncpy_#in~dst.base|) 0)
 (*
 (+ |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)|
 |ray_(ite (select #valid cstpncpy_#in~dst.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length cstpncpy_~#dst.base)|
 |ray_(select #length cstpncpy_~#dst.base)|) 0)
 (* (+ |honda_cstpncpy_#t~post4.base| |ray_cstpncpy_#t~post4.base|) 0)
 (*
 (+ |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)|
 |ray_(ite (select #valid cstpncpy_~#dst.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) cstpncpy_#in~dst.base)|
 |ray_(select old(#length) cstpncpy_#in~dst.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)|
 |ray_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)|) 0)
 (* (+ |honda_cstpncpy_#t~post5.offset| |ray_cstpncpy_#t~post5.offset|) 0)
 (*
 (+ |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)|
 |ray_(ite (select #valid cstpncpy_#in~src.base) 1 0)|) 0)
 (* (+ |honda_cstpncpy_#in~dst.offset| |ray_cstpncpy_#in~dst.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)|
 |ray_(ite (select #valid cstpncpy_~s~3.base) 1 0)|) 0)
 (* (+ honda_cstpncpy_~src.base ray_cstpncpy_~src.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ honda_cstpncpy_~d~3.offset ray_cstpncpy_~d~3.offset) 0)
 (* (+ |honda_cstpncpy_#t~post3| |ray_cstpncpy_#t~post3|) 0)
 (* (+ |honda_cstpncpy_~#dst.base| |ray_cstpncpy_~#dst.base|) 0)
 (* (+ honda_cstpncpy_~src.offset ray_cstpncpy_~src.offset) 0)
 (* (+ |honda_cstpncpy_#in~src.base| |ray_cstpncpy_#in~src.base|) 0)
 (*
 (+
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 |ray_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)|
 |ray_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)|) 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0) 
 (* honda_cstpncpy_~d~3.base 0) 
 (* |honda_cstpncpy_#t~post5.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* aux_3751 (- 1)) (* aux_3752 (- 4294967296)) 0) 0)
 (>=
 (+ (* (+ |honda_cstpncpy_#t~mem0.offset| |ray_cstpncpy_#t~mem0.offset|) 0)
 (*
 (+ |honda_(select #length cstpncpy_~d~3.base)|
 |ray_(select #length cstpncpy_~d~3.base)|) 0)
 (* (+ |honda_cstpncpy_#t~post4.offset| |ray_cstpncpy_#t~post4.offset|) 0)
 (* (+ honda_cstpncpy_~s~3.offset ray_cstpncpy_~s~3.offset) 0)
 (*
 (+
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 |ray_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|)
 0)
 (*
 (+ |honda_(select old(#length) cstpncpy_#in~src.base)|
 |ray_(select old(#length) cstpncpy_#in~src.base)|) 0)
 (* (+ |honda_cstpncpy_~#dst.offset| |ray_cstpncpy_~#dst.offset|) 0)
 (*
 (+
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 |ray_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|)
 0) (* (+ |honda_cstpncpy_#t~mem7| |ray_cstpncpy_#t~mem7|) 0)
 (*
 (+
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 |ray_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|)
 0) (* (+ honda_cstpncpy_~d~3.base ray_cstpncpy_~d~3.base) 0)
 (*
 (+
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 |ray_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|)
 0)
 (*
 (+ |honda_(select #length cstpncpy_#in~src.base)|
 |ray_(select #length cstpncpy_#in~src.base)|) 0)
 (* (+ |honda_cstpncpy_#in~src.offset| |ray_cstpncpy_#in~src.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)|
 |ray_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)|) 0)
 (* (+ |honda_cstpncpy_#t~mem1.offset| |ray_cstpncpy_#t~mem1.offset|) 0)
 (*
 (+ |honda_(select #length cstpncpy_#in~dst.base)|
 |ray_(select #length cstpncpy_#in~dst.base)|) 0)
 (* (+ |honda_cstpncpy_#t~mem0.base| |ray_cstpncpy_#t~mem0.base|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 |ray_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|)
 0) (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_cstpncpy_#in~n| |ray_cstpncpy_#in~n|) 0)
 (* (+ |honda_cstpncpy_#t~mem1.base| |ray_cstpncpy_#t~mem1.base|) 0)
 (* (+ |honda_cstpncpy_#t~post5.base| |ray_cstpncpy_#t~post5.base|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(select old(#length) cstpncpy_~#dst.base)|
 |ray_(select old(#length) cstpncpy_~#dst.base)|) 0)
 (*
 (+ |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)|
 |ray_(ite (select #valid cstpncpy_~d~3.base) 1 0)|) 0)
 (* (+ honda_cstpncpy_~s~3.base ray_cstpncpy_~s~3.base) 0)
 (*
 (+
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 |ray_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|)
 0)
 (*
 (+ |honda_(select #length cstpncpy_~s~3.base)|
 |ray_(select #length cstpncpy_~s~3.base)|) 0)
 (* (+ honda_cstpncpy_~n ray_cstpncpy_~n) 0)
 (* (+ |honda_cstpncpy_#in~dst.base| |ray_cstpncpy_#in~dst.base|) 0)
 (*
 (+ |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)|
 |ray_(ite (select #valid cstpncpy_#in~dst.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length cstpncpy_~#dst.base)|
 |ray_(select #length cstpncpy_~#dst.base)|) 0)
 (* (+ |honda_cstpncpy_#t~post4.base| |ray_cstpncpy_#t~post4.base|) 0)
 (*
 (+ |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)|
 |ray_(ite (select #valid cstpncpy_~#dst.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) cstpncpy_#in~dst.base)|
 |ray_(select old(#length) cstpncpy_#in~dst.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)|
 |ray_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)|) 0)
 (* (+ |honda_cstpncpy_#t~post5.offset| |ray_cstpncpy_#t~post5.offset|) 0)
 (*
 (+ |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)|
 |ray_(ite (select #valid cstpncpy_#in~src.base) 1 0)|) 0)
 (* (+ |honda_cstpncpy_#in~dst.offset| |ray_cstpncpy_#in~dst.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)|
 |ray_(ite (select #valid cstpncpy_~s~3.base) 1 0)|) 0)
 (* (+ honda_cstpncpy_~src.base ray_cstpncpy_~src.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ honda_cstpncpy_~d~3.offset ray_cstpncpy_~d~3.offset) 0)
 (* (+ |honda_cstpncpy_#t~post3| |ray_cstpncpy_#t~post3|) 0)
 (* (+ |honda_cstpncpy_~#dst.base| |ray_cstpncpy_~#dst.base|) 0)
 (* (+ honda_cstpncpy_~src.offset ray_cstpncpy_~src.offset) 0)
 (* (+ |honda_cstpncpy_#in~src.base| |ray_cstpncpy_#in~src.base|) 0)
 (*
 (+
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 |ray_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)|
 |ray_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)|) 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0) 
 (* honda_cstpncpy_~d~3.base 0) 
 (* |honda_cstpncpy_#t~post5.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* aux_3751 1) (* aux_3752 4294967296) 0) 0)
 (>=
 (+ (* (+ |honda_cstpncpy_#t~mem0.offset| |ray_cstpncpy_#t~mem0.offset|) 0)
 (*
 (+ |honda_(select #length cstpncpy_~d~3.base)|
 |ray_(select #length cstpncpy_~d~3.base)|) 0)
 (* (+ |honda_cstpncpy_#t~post4.offset| |ray_cstpncpy_#t~post4.offset|) 0)
 (* (+ honda_cstpncpy_~s~3.offset ray_cstpncpy_~s~3.offset) 0)
 (*
 (+
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 |ray_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|)
 0)
 (*
 (+ |honda_(select old(#length) cstpncpy_#in~src.base)|
 |ray_(select old(#length) cstpncpy_#in~src.base)|) 0)
 (* (+ |honda_cstpncpy_~#dst.offset| |ray_cstpncpy_~#dst.offset|) 0)
 (*
 (+
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 |ray_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|)
 0) (* (+ |honda_cstpncpy_#t~mem7| |ray_cstpncpy_#t~mem7|) 0)
 (*
 (+
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 |ray_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|)
 0) (* (+ honda_cstpncpy_~d~3.base ray_cstpncpy_~d~3.base) 0)
 (*
 (+
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 |ray_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|)
 0)
 (*
 (+ |honda_(select #length cstpncpy_#in~src.base)|
 |ray_(select #length cstpncpy_#in~src.base)|) 0)
 (* (+ |honda_cstpncpy_#in~src.offset| |ray_cstpncpy_#in~src.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)|
 |ray_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)|) 0)
 (* (+ |honda_cstpncpy_#t~mem1.offset| |ray_cstpncpy_#t~mem1.offset|) 0)
 (*
 (+ |honda_(select #length cstpncpy_#in~dst.base)|
 |ray_(select #length cstpncpy_#in~dst.base)|) 0)
 (* (+ |honda_cstpncpy_#t~mem0.base| |ray_cstpncpy_#t~mem0.base|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 |ray_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|)
 0) (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_cstpncpy_#in~n| |ray_cstpncpy_#in~n|) 0)
 (* (+ |honda_cstpncpy_#t~mem1.base| |ray_cstpncpy_#t~mem1.base|) 0)
 (* (+ |honda_cstpncpy_#t~post5.base| |ray_cstpncpy_#t~post5.base|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(select old(#length) cstpncpy_~#dst.base)|
 |ray_(select old(#length) cstpncpy_~#dst.base)|) 0)
 (*
 (+ |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)|
 |ray_(ite (select #valid cstpncpy_~d~3.base) 1 0)|) 0)
 (* (+ honda_cstpncpy_~s~3.base ray_cstpncpy_~s~3.base) 0)
 (*
 (+
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 |ray_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|)
 0)
 (*
 (+ |honda_(select #length cstpncpy_~s~3.base)|
 |ray_(select #length cstpncpy_~s~3.base)|) 0)
 (* (+ honda_cstpncpy_~n ray_cstpncpy_~n) 0)
 (* (+ |honda_cstpncpy_#in~dst.base| |ray_cstpncpy_#in~dst.base|) 0)
 (*
 (+ |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)|
 |ray_(ite (select #valid cstpncpy_#in~dst.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length cstpncpy_~#dst.base)|
 |ray_(select #length cstpncpy_~#dst.base)|) 0)
 (* (+ |honda_cstpncpy_#t~post4.base| |ray_cstpncpy_#t~post4.base|) 0)
 (*
 (+ |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)|
 |ray_(ite (select #valid cstpncpy_~#dst.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) cstpncpy_#in~dst.base)|
 |ray_(select old(#length) cstpncpy_#in~dst.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)|
 |ray_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)|) 0)
 (* (+ |honda_cstpncpy_#t~post5.offset| |ray_cstpncpy_#t~post5.offset|) 0)
 (*
 (+ |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)|
 |ray_(ite (select #valid cstpncpy_#in~src.base) 1 0)|) 0)
 (* (+ |honda_cstpncpy_#in~dst.offset| |ray_cstpncpy_#in~dst.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)|
 |ray_(ite (select #valid cstpncpy_~s~3.base) 1 0)|) 0)
 (* (+ honda_cstpncpy_~src.base ray_cstpncpy_~src.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ honda_cstpncpy_~d~3.offset ray_cstpncpy_~d~3.offset) 0)
 (* (+ |honda_cstpncpy_#t~post3| |ray_cstpncpy_#t~post3|) 0)
 (* (+ |honda_cstpncpy_~#dst.base| |ray_cstpncpy_~#dst.base|) 0)
 (* (+ honda_cstpncpy_~src.offset ray_cstpncpy_~src.offset) 0)
 (* (+ |honda_cstpncpy_#in~src.base| |ray_cstpncpy_#in~src.base|) 0)
 (*
 (+
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 |ray_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)|
 |ray_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)|) 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0) 
 (* honda_cstpncpy_~d~3.base 0) 
 (* |honda_cstpncpy_#t~post5.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* aux_3751 1) 0) 0)
 (>=
 (+ (* (+ |honda_cstpncpy_#t~mem0.offset| |ray_cstpncpy_#t~mem0.offset|) 0)
 (*
 (+ |honda_(select #length cstpncpy_~d~3.base)|
 |ray_(select #length cstpncpy_~d~3.base)|) 1)
 (* (+ |honda_cstpncpy_#t~post4.offset| |ray_cstpncpy_#t~post4.offset|) 0)
 (* (+ honda_cstpncpy_~s~3.offset ray_cstpncpy_~s~3.offset) 0)
 (*
 (+
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 |ray_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|)
 0)
 (*
 (+ |honda_(select old(#length) cstpncpy_#in~src.base)|
 |ray_(select old(#length) cstpncpy_#in~src.base)|) 0)
 (* (+ |honda_cstpncpy_~#dst.offset| |ray_cstpncpy_~#dst.offset|) 0)
 (*
 (+
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 |ray_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|)
 0) (* (+ |honda_cstpncpy_#t~mem7| |ray_cstpncpy_#t~mem7|) 0)
 (*
 (+
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 |ray_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|)
 0) (* (+ honda_cstpncpy_~d~3.base ray_cstpncpy_~d~3.base) 0)
 (*
 (+
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 |ray_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|)
 0)
 (*
 (+ |honda_(select #length cstpncpy_#in~src.base)|
 |ray_(select #length cstpncpy_#in~src.base)|) 0)
 (* (+ |honda_cstpncpy_#in~src.offset| |ray_cstpncpy_#in~src.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)|
 |ray_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)|) 0)
 (* (+ |honda_cstpncpy_#t~mem1.offset| |ray_cstpncpy_#t~mem1.offset|) 0)
 (*
 (+ |honda_(select #length cstpncpy_#in~dst.base)|
 |ray_(select #length cstpncpy_#in~dst.base)|) 0)
 (* (+ |honda_cstpncpy_#t~mem0.base| |ray_cstpncpy_#t~mem0.base|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 |ray_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|)
 0) (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_cstpncpy_#in~n| |ray_cstpncpy_#in~n|) 0)
 (* (+ |honda_cstpncpy_#t~mem1.base| |ray_cstpncpy_#t~mem1.base|) 0)
 (* (+ |honda_cstpncpy_#t~post5.base| |ray_cstpncpy_#t~post5.base|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(select old(#length) cstpncpy_~#dst.base)|
 |ray_(select old(#length) cstpncpy_~#dst.base)|) 0)
 (*
 (+ |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)|
 |ray_(ite (select #valid cstpncpy_~d~3.base) 1 0)|) 0)
 (* (+ honda_cstpncpy_~s~3.base ray_cstpncpy_~s~3.base) 0)
 (*
 (+
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 |ray_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|)
 0)
 (*
 (+ |honda_(select #length cstpncpy_~s~3.base)|
 |ray_(select #length cstpncpy_~s~3.base)|) 0)
 (* (+ honda_cstpncpy_~n ray_cstpncpy_~n) 0)
 (* (+ |honda_cstpncpy_#in~dst.base| |ray_cstpncpy_#in~dst.base|) 0)
 (*
 (+ |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)|
 |ray_(ite (select #valid cstpncpy_#in~dst.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length cstpncpy_~#dst.base)|
 |ray_(select #length cstpncpy_~#dst.base)|) 0)
 (* (+ |honda_cstpncpy_#t~post4.base| |ray_cstpncpy_#t~post4.base|) 0)
 (*
 (+ |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)|
 |ray_(ite (select #valid cstpncpy_~#dst.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) cstpncpy_#in~dst.base)|
 |ray_(select old(#length) cstpncpy_#in~dst.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)|
 |ray_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)|) 0)
 (* (+ |honda_cstpncpy_#t~post5.offset| |ray_cstpncpy_#t~post5.offset|) 0)
 (*
 (+ |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)|
 |ray_(ite (select #valid cstpncpy_#in~src.base) 1 0)|) 0)
 (* (+ |honda_cstpncpy_#in~dst.offset| |ray_cstpncpy_#in~dst.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)|
 |ray_(ite (select #valid cstpncpy_~s~3.base) 1 0)|) 0)
 (* (+ honda_cstpncpy_~src.base ray_cstpncpy_~src.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ honda_cstpncpy_~d~3.offset ray_cstpncpy_~d~3.offset) 0)
 (* (+ |honda_cstpncpy_#t~post3| |ray_cstpncpy_#t~post3|) 0)
 (* (+ |honda_cstpncpy_~#dst.base| |ray_cstpncpy_~#dst.base|) 0)
 (* (+ honda_cstpncpy_~src.offset ray_cstpncpy_~src.offset) 0)
 (* (+ |honda_cstpncpy_#in~src.base| |ray_cstpncpy_#in~src.base|) 0)
 (*
 (+
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 |ray_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)|
 |ray_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)|) 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| (- 1))
 (* |honda_cstpncpy_#t~post4.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0) 
 (* honda_cstpncpy_~d~3.base 0) 
 (* |honda_cstpncpy_#t~post5.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 0) 0)
 (>=
 (+ (* (+ |honda_cstpncpy_#t~mem0.offset| |ray_cstpncpy_#t~mem0.offset|) 0)
 (*
 (+ |honda_(select #length cstpncpy_~d~3.base)|
 |ray_(select #length cstpncpy_~d~3.base)|) 0)
 (* (+ |honda_cstpncpy_#t~post4.offset| |ray_cstpncpy_#t~post4.offset|) 0)
 (* (+ honda_cstpncpy_~s~3.offset ray_cstpncpy_~s~3.offset) 0)
 (*
 (+
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 |ray_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|)
 0)
 (*
 (+ |honda_(select old(#length) cstpncpy_#in~src.base)|
 |ray_(select old(#length) cstpncpy_#in~src.base)|) 0)
 (* (+ |honda_cstpncpy_~#dst.offset| |ray_cstpncpy_~#dst.offset|) 0)
 (*
 (+
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 |ray_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|)
 0) (* (+ |honda_cstpncpy_#t~mem7| |ray_cstpncpy_#t~mem7|) 0)
 (*
 (+
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 |ray_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|)
 0) (* (+ honda_cstpncpy_~d~3.base ray_cstpncpy_~d~3.base) 0)
 (*
 (+
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 |ray_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|)
 0)
 (*
 (+ |honda_(select #length cstpncpy_#in~src.base)|
 |ray_(select #length cstpncpy_#in~src.base)|) 0)
 (* (+ |honda_cstpncpy_#in~src.offset| |ray_cstpncpy_#in~src.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)|
 |ray_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)|) 0)
 (* (+ |honda_cstpncpy_#t~mem1.offset| |ray_cstpncpy_#t~mem1.offset|) 0)
 (*
 (+ |honda_(select #length cstpncpy_#in~dst.base)|
 |ray_(select #length cstpncpy_#in~dst.base)|) 0)
 (* (+ |honda_cstpncpy_#t~mem0.base| |ray_cstpncpy_#t~mem0.base|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 |ray_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|)
 0) (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_cstpncpy_#in~n| |ray_cstpncpy_#in~n|) 0)
 (* (+ |honda_cstpncpy_#t~mem1.base| |ray_cstpncpy_#t~mem1.base|) 0)
 (* (+ |honda_cstpncpy_#t~post5.base| |ray_cstpncpy_#t~post5.base|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(select old(#length) cstpncpy_~#dst.base)|
 |ray_(select old(#length) cstpncpy_~#dst.base)|) 0)
 (*
 (+ |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)|
 |ray_(ite (select #valid cstpncpy_~d~3.base) 1 0)|) 0)
 (* (+ honda_cstpncpy_~s~3.base ray_cstpncpy_~s~3.base) (- 1))
 (*
 (+
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 |ray_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|)
 0)
 (*
 (+ |honda_(select #length cstpncpy_~s~3.base)|
 |ray_(select #length cstpncpy_~s~3.base)|) 0)
 (* (+ honda_cstpncpy_~n ray_cstpncpy_~n) 0)
 (* (+ |honda_cstpncpy_#in~dst.base| |ray_cstpncpy_#in~dst.base|) 0)
 (*
 (+ |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)|
 |ray_(ite (select #valid cstpncpy_#in~dst.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length cstpncpy_~#dst.base)|
 |ray_(select #length cstpncpy_~#dst.base)|) 0)
 (* (+ |honda_cstpncpy_#t~post4.base| |ray_cstpncpy_#t~post4.base|) 0)
 (*
 (+ |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)|
 |ray_(ite (select #valid cstpncpy_~#dst.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) cstpncpy_#in~dst.base)|
 |ray_(select old(#length) cstpncpy_#in~dst.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)|
 |ray_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)|) 0)
 (* (+ |honda_cstpncpy_#t~post5.offset| |ray_cstpncpy_#t~post5.offset|) 0)
 (*
 (+ |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)|
 |ray_(ite (select #valid cstpncpy_#in~src.base) 1 0)|) 0)
 (* (+ |honda_cstpncpy_#in~dst.offset| |ray_cstpncpy_#in~dst.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)|
 |ray_(ite (select #valid cstpncpy_~s~3.base) 1 0)|) 0)
 (* (+ honda_cstpncpy_~src.base ray_cstpncpy_~src.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ honda_cstpncpy_~d~3.offset ray_cstpncpy_~d~3.offset) 0)
 (* (+ |honda_cstpncpy_#t~post3| |ray_cstpncpy_#t~post3|) 0)
 (* (+ |honda_cstpncpy_~#dst.base| |ray_cstpncpy_~#dst.base|) 0)
 (* (+ honda_cstpncpy_~src.offset ray_cstpncpy_~src.offset) 0)
 (* (+ |honda_cstpncpy_#in~src.base| |ray_cstpncpy_#in~src.base|) 0)
 (*
 (+
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 |ray_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)|
 |ray_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)|) 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0) 
 (* honda_cstpncpy_~d~3.base 0) 
 (* |honda_cstpncpy_#t~post5.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (* honda_cstpncpy_~s~3.base 1)
 (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 0) 0)
 (>=
 (+ (* (+ |honda_cstpncpy_#t~mem0.offset| |ray_cstpncpy_#t~mem0.offset|) 0)
 (*
 (+ |honda_(select #length cstpncpy_~d~3.base)|
 |ray_(select #length cstpncpy_~d~3.base)|) 0)
 (* (+ |honda_cstpncpy_#t~post4.offset| |ray_cstpncpy_#t~post4.offset|) 0)
 (* (+ honda_cstpncpy_~s~3.offset ray_cstpncpy_~s~3.offset) 1)
 (*
 (+
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 |ray_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|)
 0)
 (*
 (+ |honda_(select old(#length) cstpncpy_#in~src.base)|
 |ray_(select old(#length) cstpncpy_#in~src.base)|) 0)
 (* (+ |honda_cstpncpy_~#dst.offset| |ray_cstpncpy_~#dst.offset|) 0)
 (*
 (+
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 |ray_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|)
 0) (* (+ |honda_cstpncpy_#t~mem7| |ray_cstpncpy_#t~mem7|) 0)
 (*
 (+
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 |ray_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|)
 0) (* (+ honda_cstpncpy_~d~3.base ray_cstpncpy_~d~3.base) 0)
 (*
 (+
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 |ray_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|)
 0)
 (*
 (+ |honda_(select #length cstpncpy_#in~src.base)|
 |ray_(select #length cstpncpy_#in~src.base)|) 0)
 (* (+ |honda_cstpncpy_#in~src.offset| |ray_cstpncpy_#in~src.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)|
 |ray_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)|) 0)
 (* (+ |honda_cstpncpy_#t~mem1.offset| |ray_cstpncpy_#t~mem1.offset|) 0)
 (*
 (+ |honda_(select #length cstpncpy_#in~dst.base)|
 |ray_(select #length cstpncpy_#in~dst.base)|) 0)
 (* (+ |honda_cstpncpy_#t~mem0.base| |ray_cstpncpy_#t~mem0.base|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 |ray_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|)
 0) (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_cstpncpy_#in~n| |ray_cstpncpy_#in~n|) 0)
 (* (+ |honda_cstpncpy_#t~mem1.base| |ray_cstpncpy_#t~mem1.base|) 0)
 (* (+ |honda_cstpncpy_#t~post5.base| |ray_cstpncpy_#t~post5.base|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(select old(#length) cstpncpy_~#dst.base)|
 |ray_(select old(#length) cstpncpy_~#dst.base)|) 0)
 (*
 (+ |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)|
 |ray_(ite (select #valid cstpncpy_~d~3.base) 1 0)|) 0)
 (* (+ honda_cstpncpy_~s~3.base ray_cstpncpy_~s~3.base) 0)
 (*
 (+
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 |ray_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|)
 0)
 (*
 (+ |honda_(select #length cstpncpy_~s~3.base)|
 |ray_(select #length cstpncpy_~s~3.base)|) 0)
 (* (+ honda_cstpncpy_~n ray_cstpncpy_~n) 0)
 (* (+ |honda_cstpncpy_#in~dst.base| |ray_cstpncpy_#in~dst.base|) 0)
 (*
 (+ |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)|
 |ray_(ite (select #valid cstpncpy_#in~dst.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length cstpncpy_~#dst.base)|
 |ray_(select #length cstpncpy_~#dst.base)|) 0)
 (* (+ |honda_cstpncpy_#t~post4.base| |ray_cstpncpy_#t~post4.base|) 0)
 (*
 (+ |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)|
 |ray_(ite (select #valid cstpncpy_~#dst.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) cstpncpy_#in~dst.base)|
 |ray_(select old(#length) cstpncpy_#in~dst.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)|
 |ray_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)|) 0)
 (* (+ |honda_cstpncpy_#t~post5.offset| |ray_cstpncpy_#t~post5.offset|) 0)
 (*
 (+ |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)|
 |ray_(ite (select #valid cstpncpy_#in~src.base) 1 0)|) 0)
 (* (+ |honda_cstpncpy_#in~dst.offset| |ray_cstpncpy_#in~dst.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)|
 |ray_(ite (select #valid cstpncpy_~s~3.base) 1 0)|) 0)
 (* (+ honda_cstpncpy_~src.base ray_cstpncpy_~src.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ honda_cstpncpy_~d~3.offset ray_cstpncpy_~d~3.offset) 0)
 (* (+ |honda_cstpncpy_#t~post3| |ray_cstpncpy_#t~post3|) 0)
 (* (+ |honda_cstpncpy_~#dst.base| |ray_cstpncpy_~#dst.base|) 0)
 (* (+ honda_cstpncpy_~src.offset ray_cstpncpy_~src.offset) 0)
 (* (+ |honda_cstpncpy_#in~src.base| |ray_cstpncpy_#in~src.base|) 0)
 (*
 (+
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 |ray_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)|
 |ray_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)|) 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0) 
 (* honda_cstpncpy_~s~3.offset (- 1))
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0) 
 (* honda_cstpncpy_~d~3.base 0) 
 (* |honda_cstpncpy_#t~post5.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (- 1)) 0)
 (>=
 (+ (* (+ |honda_cstpncpy_#t~mem0.offset| |ray_cstpncpy_#t~mem0.offset|) 0)
 (*
 (+ |honda_(select #length cstpncpy_~d~3.base)|
 |ray_(select #length cstpncpy_~d~3.base)|) 0)
 (* (+ |honda_cstpncpy_#t~post4.offset| |ray_cstpncpy_#t~post4.offset|) 0)
 (* (+ honda_cstpncpy_~s~3.offset ray_cstpncpy_~s~3.offset) 0)
 (*
 (+
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 |ray_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|)
 0)
 (*
 (+ |honda_(select old(#length) cstpncpy_#in~src.base)|
 |ray_(select old(#length) cstpncpy_#in~src.base)|) 0)
 (* (+ |honda_cstpncpy_~#dst.offset| |ray_cstpncpy_~#dst.offset|) 0)
 (*
 (+
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 |ray_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|)
 0) (* (+ |honda_cstpncpy_#t~mem7| |ray_cstpncpy_#t~mem7|) 0)
 (*
 (+
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 |ray_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|)
 0) (* (+ honda_cstpncpy_~d~3.base ray_cstpncpy_~d~3.base) 0)
 (*
 (+
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 |ray_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|)
 0)
 (*
 (+ |honda_(select #length cstpncpy_#in~src.base)|
 |ray_(select #length cstpncpy_#in~src.base)|) 0)
 (* (+ |honda_cstpncpy_#in~src.offset| |ray_cstpncpy_#in~src.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)|
 |ray_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)|) 0)
 (* (+ |honda_cstpncpy_#t~mem1.offset| |ray_cstpncpy_#t~mem1.offset|) 0)
 (*
 (+ |honda_(select #length cstpncpy_#in~dst.base)|
 |ray_(select #length cstpncpy_#in~dst.base)|) 0)
 (* (+ |honda_cstpncpy_#t~mem0.base| |ray_cstpncpy_#t~mem0.base|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 |ray_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|)
 0) (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_cstpncpy_#in~n| |ray_cstpncpy_#in~n|) 0)
 (* (+ |honda_cstpncpy_#t~mem1.base| |ray_cstpncpy_#t~mem1.base|) 0)
 (* (+ |honda_cstpncpy_#t~post5.base| |ray_cstpncpy_#t~post5.base|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(select old(#length) cstpncpy_~#dst.base)|
 |ray_(select old(#length) cstpncpy_~#dst.base)|) 0)
 (*
 (+ |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)|
 |ray_(ite (select #valid cstpncpy_~d~3.base) 1 0)|) 0)
 (* (+ honda_cstpncpy_~s~3.base ray_cstpncpy_~s~3.base) 0)
 (*
 (+
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 |ray_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|)
 0)
 (*
 (+ |honda_(select #length cstpncpy_~s~3.base)|
 |ray_(select #length cstpncpy_~s~3.base)|) 0)
 (* (+ honda_cstpncpy_~n ray_cstpncpy_~n) 0)
 (* (+ |honda_cstpncpy_#in~dst.base| |ray_cstpncpy_#in~dst.base|) 0)
 (*
 (+ |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)|
 |ray_(ite (select #valid cstpncpy_#in~dst.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length cstpncpy_~#dst.base)|
 |ray_(select #length cstpncpy_~#dst.base)|) 0)
 (* (+ |honda_cstpncpy_#t~post4.base| |ray_cstpncpy_#t~post4.base|) 0)
 (*
 (+ |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)|
 |ray_(ite (select #valid cstpncpy_~#dst.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) cstpncpy_#in~dst.base)|
 |ray_(select old(#length) cstpncpy_#in~dst.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)|
 |ray_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)|) 0)
 (* (+ |honda_cstpncpy_#t~post5.offset| |ray_cstpncpy_#t~post5.offset|) 0)
 (*
 (+ |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)|
 |ray_(ite (select #valid cstpncpy_#in~src.base) 1 0)|) 0)
 (* (+ |honda_cstpncpy_#in~dst.offset| |ray_cstpncpy_#in~dst.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)|
 |ray_(ite (select #valid cstpncpy_~s~3.base) 1 0)|) 0)
 (* (+ honda_cstpncpy_~src.base ray_cstpncpy_~src.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ honda_cstpncpy_~d~3.offset ray_cstpncpy_~d~3.offset) 0)
 (* (+ |honda_cstpncpy_#t~post3| |ray_cstpncpy_#t~post3|) 0)
 (* (+ |honda_cstpncpy_~#dst.base| |ray_cstpncpy_~#dst.base|) 0)
 (* (+ honda_cstpncpy_~src.offset ray_cstpncpy_~src.offset) 0)
 (* (+ |honda_cstpncpy_#in~src.base| |ray_cstpncpy_#in~src.base|) 0)
 (*
 (+
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 |ray_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)|
 |ray_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)|) 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0) 
 (* honda_cstpncpy_~d~3.base 0) 
 (* |honda_cstpncpy_#t~post5.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 1)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (- 1)) 0)
 (>=
 (+ (* (+ |honda_cstpncpy_#t~mem0.offset| |ray_cstpncpy_#t~mem0.offset|) 0)
 (*
 (+ |honda_(select #length cstpncpy_~d~3.base)|
 |ray_(select #length cstpncpy_~d~3.base)|) 0)
 (* (+ |honda_cstpncpy_#t~post4.offset| |ray_cstpncpy_#t~post4.offset|) 0)
 (* (+ honda_cstpncpy_~s~3.offset ray_cstpncpy_~s~3.offset) 0)
 (*
 (+
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 |ray_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|)
 0)
 (*
 (+ |honda_(select old(#length) cstpncpy_#in~src.base)|
 |ray_(select old(#length) cstpncpy_#in~src.base)|) 0)
 (* (+ |honda_cstpncpy_~#dst.offset| |ray_cstpncpy_~#dst.offset|) 0)
 (*
 (+
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 |ray_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|)
 0) (* (+ |honda_cstpncpy_#t~mem7| |ray_cstpncpy_#t~mem7|) 0)
 (*
 (+
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 |ray_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|)
 0) (* (+ honda_cstpncpy_~d~3.base ray_cstpncpy_~d~3.base) 0)
 (*
 (+
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 |ray_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|)
 0)
 (*
 (+ |honda_(select #length cstpncpy_#in~src.base)|
 |ray_(select #length cstpncpy_#in~src.base)|) 0)
 (* (+ |honda_cstpncpy_#in~src.offset| |ray_cstpncpy_#in~src.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)|
 |ray_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)|) 0)
 (* (+ |honda_cstpncpy_#t~mem1.offset| |ray_cstpncpy_#t~mem1.offset|) 0)
 (*
 (+ |honda_(select #length cstpncpy_#in~dst.base)|
 |ray_(select #length cstpncpy_#in~dst.base)|) 0)
 (* (+ |honda_cstpncpy_#t~mem0.base| |ray_cstpncpy_#t~mem0.base|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 |ray_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|)
 0) (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_cstpncpy_#in~n| |ray_cstpncpy_#in~n|) 0)
 (* (+ |honda_cstpncpy_#t~mem1.base| |ray_cstpncpy_#t~mem1.base|) 0)
 (* (+ |honda_cstpncpy_#t~post5.base| |ray_cstpncpy_#t~post5.base|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(select old(#length) cstpncpy_~#dst.base)|
 |ray_(select old(#length) cstpncpy_~#dst.base)|) 0)
 (*
 (+ |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)|
 |ray_(ite (select #valid cstpncpy_~d~3.base) 1 0)|) 0)
 (* (+ honda_cstpncpy_~s~3.base ray_cstpncpy_~s~3.base) 0)
 (*
 (+
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 |ray_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|)
 0)
 (*
 (+ |honda_(select #length cstpncpy_~s~3.base)|
 |ray_(select #length cstpncpy_~s~3.base)|) 0)
 (* (+ honda_cstpncpy_~n ray_cstpncpy_~n) 1)
 (* (+ |honda_cstpncpy_#in~dst.base| |ray_cstpncpy_#in~dst.base|) 0)
 (*
 (+ |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)|
 |ray_(ite (select #valid cstpncpy_#in~dst.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length cstpncpy_~#dst.base)|
 |ray_(select #length cstpncpy_~#dst.base)|) 0)
 (* (+ |honda_cstpncpy_#t~post4.base| |ray_cstpncpy_#t~post4.base|) 0)
 (*
 (+ |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)|
 |ray_(ite (select #valid cstpncpy_~#dst.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) cstpncpy_#in~dst.base)|
 |ray_(select old(#length) cstpncpy_#in~dst.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)|
 |ray_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)|) 0)
 (* (+ |honda_cstpncpy_#t~post5.offset| |ray_cstpncpy_#t~post5.offset|) 0)
 (*
 (+ |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)|
 |ray_(ite (select #valid cstpncpy_#in~src.base) 1 0)|) 0)
 (* (+ |honda_cstpncpy_#in~dst.offset| |ray_cstpncpy_#in~dst.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)|
 |ray_(ite (select #valid cstpncpy_~s~3.base) 1 0)|) 0)
 (* (+ honda_cstpncpy_~src.base ray_cstpncpy_~src.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ honda_cstpncpy_~d~3.offset ray_cstpncpy_~d~3.offset) 0)
 (* (+ |honda_cstpncpy_#t~post3| |ray_cstpncpy_#t~post3|) 0)
 (* (+ |honda_cstpncpy_~#dst.base| |ray_cstpncpy_~#dst.base|) 0)
 (* (+ honda_cstpncpy_~src.offset ray_cstpncpy_~src.offset) 0)
 (* (+ |honda_cstpncpy_#in~src.base| |ray_cstpncpy_#in~src.base|) 0)
 (*
 (+
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 |ray_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)|
 |ray_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)|) 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0) 
 (* honda_cstpncpy_~d~3.base 0) 
 (* |honda_cstpncpy_#t~post5.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(select #length cstpncpy_~s~3.base)| 0)
 (* honda_cstpncpy_~n (- 1)) 
 (* |honda_cstpncpy_#t~post4.base| 0) 
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 1) 0)
 (>=
 (+ (* (+ |honda_cstpncpy_#t~mem0.offset| |ray_cstpncpy_#t~mem0.offset|) 0)
 (*
 (+ |honda_(select #length cstpncpy_~d~3.base)|
 |ray_(select #length cstpncpy_~d~3.base)|) 0)
 (* (+ |honda_cstpncpy_#t~post4.offset| |ray_cstpncpy_#t~post4.offset|) 0)
 (* (+ honda_cstpncpy_~s~3.offset ray_cstpncpy_~s~3.offset) 0)
 (*
 (+
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 |ray_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|)
 0)
 (*
 (+ |honda_(select old(#length) cstpncpy_#in~src.base)|
 |ray_(select old(#length) cstpncpy_#in~src.base)|) 0)
 (* (+ |honda_cstpncpy_~#dst.offset| |ray_cstpncpy_~#dst.offset|) 0)
 (*
 (+
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 |ray_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|)
 0) (* (+ |honda_cstpncpy_#t~mem7| |ray_cstpncpy_#t~mem7|) 0)
 (*
 (+
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 |ray_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|)
 0) (* (+ honda_cstpncpy_~d~3.base ray_cstpncpy_~d~3.base) 0)
 (*
 (+
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 |ray_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|)
 0)
 (*
 (+ |honda_(select #length cstpncpy_#in~src.base)|
 |ray_(select #length cstpncpy_#in~src.base)|) 0)
 (* (+ |honda_cstpncpy_#in~src.offset| |ray_cstpncpy_#in~src.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)|
 |ray_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)|) 0)
 (* (+ |honda_cstpncpy_#t~mem1.offset| |ray_cstpncpy_#t~mem1.offset|) 0)
 (*
 (+ |honda_(select #length cstpncpy_#in~dst.base)|
 |ray_(select #length cstpncpy_#in~dst.base)|) 0)
 (* (+ |honda_cstpncpy_#t~mem0.base| |ray_cstpncpy_#t~mem0.base|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 |ray_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|)
 0) (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_cstpncpy_#in~n| |ray_cstpncpy_#in~n|) 0)
 (* (+ |honda_cstpncpy_#t~mem1.base| |ray_cstpncpy_#t~mem1.base|) 0)
 (* (+ |honda_cstpncpy_#t~post5.base| |ray_cstpncpy_#t~post5.base|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(select old(#length) cstpncpy_~#dst.base)|
 |ray_(select old(#length) cstpncpy_~#dst.base)|) 0)
 (*
 (+ |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)|
 |ray_(ite (select #valid cstpncpy_~d~3.base) 1 0)|) 0)
 (* (+ honda_cstpncpy_~s~3.base ray_cstpncpy_~s~3.base) 0)
 (*
 (+
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 |ray_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|)
 0)
 (*
 (+ |honda_(select #length cstpncpy_~s~3.base)|
 |ray_(select #length cstpncpy_~s~3.base)|) 1)
 (* (+ honda_cstpncpy_~n ray_cstpncpy_~n) 0)
 (* (+ |honda_cstpncpy_#in~dst.base| |ray_cstpncpy_#in~dst.base|) 0)
 (*
 (+ |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)|
 |ray_(ite (select #valid cstpncpy_#in~dst.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length cstpncpy_~#dst.base)|
 |ray_(select #length cstpncpy_~#dst.base)|) 0)
 (* (+ |honda_cstpncpy_#t~post4.base| |ray_cstpncpy_#t~post4.base|) 0)
 (*
 (+ |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)|
 |ray_(ite (select #valid cstpncpy_~#dst.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) cstpncpy_#in~dst.base)|
 |ray_(select old(#length) cstpncpy_#in~dst.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)|
 |ray_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)|) 0)
 (* (+ |honda_cstpncpy_#t~post5.offset| |ray_cstpncpy_#t~post5.offset|) 0)
 (*
 (+ |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)|
 |ray_(ite (select #valid cstpncpy_#in~src.base) 1 0)|) 0)
 (* (+ |honda_cstpncpy_#in~dst.offset| |ray_cstpncpy_#in~dst.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)|
 |ray_(ite (select #valid cstpncpy_~s~3.base) 1 0)|) 0)
 (* (+ honda_cstpncpy_~src.base ray_cstpncpy_~src.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ honda_cstpncpy_~d~3.offset ray_cstpncpy_~d~3.offset) 0)
 (* (+ |honda_cstpncpy_#t~post3| |ray_cstpncpy_#t~post3|) 0)
 (* (+ |honda_cstpncpy_~#dst.base| |ray_cstpncpy_~#dst.base|) 0)
 (* (+ honda_cstpncpy_~src.offset ray_cstpncpy_~src.offset) 0)
 (* (+ |honda_cstpncpy_#in~src.base| |ray_cstpncpy_#in~src.base|) 0)
 (*
 (+
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 |ray_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)|
 |ray_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)|) 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0) 
 (* honda_cstpncpy_~d~3.base 0) 
 (* |honda_cstpncpy_#t~post5.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(select #length cstpncpy_~s~3.base)| (- 1))
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 0) 0)
 (>=
 (+ (* (+ |honda_cstpncpy_#t~mem0.offset| |ray_cstpncpy_#t~mem0.offset|) 0)
 (*
 (+ |honda_(select #length cstpncpy_~d~3.base)|
 |ray_(select #length cstpncpy_~d~3.base)|) 0)
 (* (+ |honda_cstpncpy_#t~post4.offset| |ray_cstpncpy_#t~post4.offset|) 0)
 (* (+ honda_cstpncpy_~s~3.offset ray_cstpncpy_~s~3.offset) 0)
 (*
 (+
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 |ray_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|)
 0)
 (*
 (+ |honda_(select old(#length) cstpncpy_#in~src.base)|
 |ray_(select old(#length) cstpncpy_#in~src.base)|) 0)
 (* (+ |honda_cstpncpy_~#dst.offset| |ray_cstpncpy_~#dst.offset|) 0)
 (*
 (+
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 |ray_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|)
 0) (* (+ |honda_cstpncpy_#t~mem7| |ray_cstpncpy_#t~mem7|) 0)
 (*
 (+
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 |ray_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|)
 0) (* (+ honda_cstpncpy_~d~3.base ray_cstpncpy_~d~3.base) 0)
 (*
 (+
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 |ray_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|)
 0)
 (*
 (+ |honda_(select #length cstpncpy_#in~src.base)|
 |ray_(select #length cstpncpy_#in~src.base)|) 0)
 (* (+ |honda_cstpncpy_#in~src.offset| |ray_cstpncpy_#in~src.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)|
 |ray_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)|) 0)
 (* (+ |honda_cstpncpy_#t~mem1.offset| |ray_cstpncpy_#t~mem1.offset|) 0)
 (*
 (+ |honda_(select #length cstpncpy_#in~dst.base)|
 |ray_(select #length cstpncpy_#in~dst.base)|) 0)
 (* (+ |honda_cstpncpy_#t~mem0.base| |ray_cstpncpy_#t~mem0.base|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 |ray_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|)
 0) (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_cstpncpy_#in~n| |ray_cstpncpy_#in~n|) 0)
 (* (+ |honda_cstpncpy_#t~mem1.base| |ray_cstpncpy_#t~mem1.base|) 0)
 (* (+ |honda_cstpncpy_#t~post5.base| |ray_cstpncpy_#t~post5.base|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(select old(#length) cstpncpy_~#dst.base)|
 |ray_(select old(#length) cstpncpy_~#dst.base)|) 0)
 (*
 (+ |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)|
 |ray_(ite (select #valid cstpncpy_~d~3.base) 1 0)|) 0)
 (* (+ honda_cstpncpy_~s~3.base ray_cstpncpy_~s~3.base) 1)
 (*
 (+
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 |ray_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|)
 0)
 (*
 (+ |honda_(select #length cstpncpy_~s~3.base)|
 |ray_(select #length cstpncpy_~s~3.base)|) 0)
 (* (+ honda_cstpncpy_~n ray_cstpncpy_~n) 0)
 (* (+ |honda_cstpncpy_#in~dst.base| |ray_cstpncpy_#in~dst.base|) 0)
 (*
 (+ |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)|
 |ray_(ite (select #valid cstpncpy_#in~dst.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length cstpncpy_~#dst.base)|
 |ray_(select #length cstpncpy_~#dst.base)|) 0)
 (* (+ |honda_cstpncpy_#t~post4.base| |ray_cstpncpy_#t~post4.base|) 0)
 (*
 (+ |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)|
 |ray_(ite (select #valid cstpncpy_~#dst.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) cstpncpy_#in~dst.base)|
 |ray_(select old(#length) cstpncpy_#in~dst.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)|
 |ray_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)|) 0)
 (* (+ |honda_cstpncpy_#t~post5.offset| |ray_cstpncpy_#t~post5.offset|) 0)
 (*
 (+ |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)|
 |ray_(ite (select #valid cstpncpy_#in~src.base) 1 0)|) 0)
 (* (+ |honda_cstpncpy_#in~dst.offset| |ray_cstpncpy_#in~dst.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)|
 |ray_(ite (select #valid cstpncpy_~s~3.base) 1 0)|) 0)
 (* (+ honda_cstpncpy_~src.base ray_cstpncpy_~src.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ honda_cstpncpy_~d~3.offset ray_cstpncpy_~d~3.offset) 0)
 (* (+ |honda_cstpncpy_#t~post3| |ray_cstpncpy_#t~post3|) 0)
 (* (+ |honda_cstpncpy_~#dst.base| |ray_cstpncpy_~#dst.base|) 0)
 (* (+ honda_cstpncpy_~src.offset ray_cstpncpy_~src.offset) 0)
 (* (+ |honda_cstpncpy_#in~src.base| |ray_cstpncpy_#in~src.base|) 0)
 (*
 (+
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 |ray_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)|
 |ray_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)|) 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0) 
 (* honda_cstpncpy_~d~3.base 0) 
 (* |honda_cstpncpy_#t~post5.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (* honda_cstpncpy_~s~3.base (- 1))
 (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 0) 0)
 (>=
 (+ (* (+ |honda_cstpncpy_#t~mem0.offset| |ray_cstpncpy_#t~mem0.offset|) 0)
 (*
 (+ |honda_(select #length cstpncpy_~d~3.base)|
 |ray_(select #length cstpncpy_~d~3.base)|) 0)
 (* (+ |honda_cstpncpy_#t~post4.offset| |ray_cstpncpy_#t~post4.offset|) 0)
 (* (+ honda_cstpncpy_~s~3.offset ray_cstpncpy_~s~3.offset) 0)
 (*
 (+
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 |ray_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|)
 0)
 (*
 (+ |honda_(select old(#length) cstpncpy_#in~src.base)|
 |ray_(select old(#length) cstpncpy_#in~src.base)|) 0)
 (* (+ |honda_cstpncpy_~#dst.offset| |ray_cstpncpy_~#dst.offset|) 0)
 (*
 (+
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 |ray_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|)
 0) (* (+ |honda_cstpncpy_#t~mem7| |ray_cstpncpy_#t~mem7|) 0)
 (*
 (+
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 |ray_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|)
 0) (* (+ honda_cstpncpy_~d~3.base ray_cstpncpy_~d~3.base) 0)
 (*
 (+
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 |ray_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|)
 0)
 (*
 (+ |honda_(select #length cstpncpy_#in~src.base)|
 |ray_(select #length cstpncpy_#in~src.base)|) 0)
 (* (+ |honda_cstpncpy_#in~src.offset| |ray_cstpncpy_#in~src.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)|
 |ray_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)|) 0)
 (* (+ |honda_cstpncpy_#t~mem1.offset| |ray_cstpncpy_#t~mem1.offset|) 0)
 (*
 (+ |honda_(select #length cstpncpy_#in~dst.base)|
 |ray_(select #length cstpncpy_#in~dst.base)|) 0)
 (* (+ |honda_cstpncpy_#t~mem0.base| |ray_cstpncpy_#t~mem0.base|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 |ray_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|)
 0) (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_cstpncpy_#in~n| |ray_cstpncpy_#in~n|) 0)
 (* (+ |honda_cstpncpy_#t~mem1.base| |ray_cstpncpy_#t~mem1.base|) 0)
 (* (+ |honda_cstpncpy_#t~post5.base| |ray_cstpncpy_#t~post5.base|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(select old(#length) cstpncpy_~#dst.base)|
 |ray_(select old(#length) cstpncpy_~#dst.base)|) 0)
 (*
 (+ |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)|
 |ray_(ite (select #valid cstpncpy_~d~3.base) 1 0)|) 0)
 (* (+ honda_cstpncpy_~s~3.base ray_cstpncpy_~s~3.base) 0)
 (*
 (+
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 |ray_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|)
 0)
 (*
 (+ |honda_(select #length cstpncpy_~s~3.base)|
 |ray_(select #length cstpncpy_~s~3.base)|) 0)
 (* (+ honda_cstpncpy_~n ray_cstpncpy_~n) 0)
 (* (+ |honda_cstpncpy_#in~dst.base| |ray_cstpncpy_#in~dst.base|) 0)
 (*
 (+ |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)|
 |ray_(ite (select #valid cstpncpy_#in~dst.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length cstpncpy_~#dst.base)|
 |ray_(select #length cstpncpy_~#dst.base)|) 0)
 (* (+ |honda_cstpncpy_#t~post4.base| |ray_cstpncpy_#t~post4.base|) 0)
 (*
 (+ |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)|
 |ray_(ite (select #valid cstpncpy_~#dst.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) cstpncpy_#in~dst.base)|
 |ray_(select old(#length) cstpncpy_#in~dst.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)|
 |ray_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)|) 0)
 (* (+ |honda_cstpncpy_#t~post5.offset| |ray_cstpncpy_#t~post5.offset|) 0)
 (*
 (+ |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)|
 |ray_(ite (select #valid cstpncpy_#in~src.base) 1 0)|) 0)
 (* (+ |honda_cstpncpy_#in~dst.offset| |ray_cstpncpy_#in~dst.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)|
 |ray_(ite (select #valid cstpncpy_~s~3.base) 1 0)|) 0)
 (* (+ honda_cstpncpy_~src.base ray_cstpncpy_~src.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ honda_cstpncpy_~d~3.offset ray_cstpncpy_~d~3.offset) 0)
 (* (+ |honda_cstpncpy_#t~post3| |ray_cstpncpy_#t~post3|) 0)
 (* (+ |honda_cstpncpy_~#dst.base| |ray_cstpncpy_~#dst.base|) 0)
 (* (+ honda_cstpncpy_~src.offset ray_cstpncpy_~src.offset) 0)
 (* (+ |honda_cstpncpy_#in~src.base| |ray_cstpncpy_#in~src.base|) 0)
 (*
 (+
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 |ray_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)|
 |ray_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)|) 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 1)
 (* |honda_cstpncpy_#t~post4.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0) 
 (* honda_cstpncpy_~d~3.base 0) 
 (* |honda_cstpncpy_#t~post5.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset (- 1)) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (- 1)) 0)
 (>=
 (+ (* (+ |honda_cstpncpy_#t~mem0.offset| |ray_cstpncpy_#t~mem0.offset|) 0)
 (*
 (+ |honda_(select #length cstpncpy_~d~3.base)|
 |ray_(select #length cstpncpy_~d~3.base)|) 0)
 (* (+ |honda_cstpncpy_#t~post4.offset| |ray_cstpncpy_#t~post4.offset|) 0)
 (* (+ honda_cstpncpy_~s~3.offset ray_cstpncpy_~s~3.offset) 0)
 (*
 (+
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 |ray_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|)
 0)
 (*
 (+ |honda_(select old(#length) cstpncpy_#in~src.base)|
 |ray_(select old(#length) cstpncpy_#in~src.base)|) 0)
 (* (+ |honda_cstpncpy_~#dst.offset| |ray_cstpncpy_~#dst.offset|) 0)
 (*
 (+
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 |ray_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|)
 0) (* (+ |honda_cstpncpy_#t~mem7| |ray_cstpncpy_#t~mem7|) 0)
 (*
 (+
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 |ray_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|)
 0) (* (+ honda_cstpncpy_~d~3.base ray_cstpncpy_~d~3.base) 0)
 (*
 (+
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 |ray_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|)
 0)
 (*
 (+ |honda_(select #length cstpncpy_#in~src.base)|
 |ray_(select #length cstpncpy_#in~src.base)|) 0)
 (* (+ |honda_cstpncpy_#in~src.offset| |ray_cstpncpy_#in~src.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)|
 |ray_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)|) 0)
 (* (+ |honda_cstpncpy_#t~mem1.offset| |ray_cstpncpy_#t~mem1.offset|) 0)
 (*
 (+ |honda_(select #length cstpncpy_#in~dst.base)|
 |ray_(select #length cstpncpy_#in~dst.base)|) 0)
 (* (+ |honda_cstpncpy_#t~mem0.base| |ray_cstpncpy_#t~mem0.base|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 |ray_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|)
 0) (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_cstpncpy_#in~n| |ray_cstpncpy_#in~n|) 0)
 (* (+ |honda_cstpncpy_#t~mem1.base| |ray_cstpncpy_#t~mem1.base|) 0)
 (* (+ |honda_cstpncpy_#t~post5.base| |ray_cstpncpy_#t~post5.base|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(select old(#length) cstpncpy_~#dst.base)|
 |ray_(select old(#length) cstpncpy_~#dst.base)|) 0)
 (*
 (+ |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)|
 |ray_(ite (select #valid cstpncpy_~d~3.base) 1 0)|) 0)
 (* (+ honda_cstpncpy_~s~3.base ray_cstpncpy_~s~3.base) 0)
 (*
 (+
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 |ray_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|)
 0)
 (*
 (+ |honda_(select #length cstpncpy_~s~3.base)|
 |ray_(select #length cstpncpy_~s~3.base)|) 0)
 (* (+ honda_cstpncpy_~n ray_cstpncpy_~n) 0)
 (* (+ |honda_cstpncpy_#in~dst.base| |ray_cstpncpy_#in~dst.base|) 0)
 (*
 (+ |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)|
 |ray_(ite (select #valid cstpncpy_#in~dst.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length cstpncpy_~#dst.base)|
 |ray_(select #length cstpncpy_~#dst.base)|) 0)
 (* (+ |honda_cstpncpy_#t~post4.base| |ray_cstpncpy_#t~post4.base|) 0)
 (*
 (+ |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)|
 |ray_(ite (select #valid cstpncpy_~#dst.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) cstpncpy_#in~dst.base)|
 |ray_(select old(#length) cstpncpy_#in~dst.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)|
 |ray_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)|) 0)
 (* (+ |honda_cstpncpy_#t~post5.offset| |ray_cstpncpy_#t~post5.offset|) 0)
 (*
 (+ |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)|
 |ray_(ite (select #valid cstpncpy_#in~src.base) 1 0)|) 0)
 (* (+ |honda_cstpncpy_#in~dst.offset| |ray_cstpncpy_#in~dst.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)|
 |ray_(ite (select #valid cstpncpy_~s~3.base) 1 0)|) 0)
 (* (+ honda_cstpncpy_~src.base ray_cstpncpy_~src.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ honda_cstpncpy_~d~3.offset ray_cstpncpy_~d~3.offset) 0)
 (* (+ |honda_cstpncpy_#t~post3| |ray_cstpncpy_#t~post3|) 0)
 (* (+ |honda_cstpncpy_~#dst.base| |ray_cstpncpy_~#dst.base|) 0)
 (* (+ honda_cstpncpy_~src.offset ray_cstpncpy_~src.offset) 0)
 (* (+ |honda_cstpncpy_#in~src.base| |ray_cstpncpy_#in~src.base|) 0)
 (*
 (+
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 |ray_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)|
 |ray_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)|) 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0) 
 (* honda_cstpncpy_~d~3.base 0) 
 (* |honda_cstpncpy_#t~post5.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 1)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (- 1)) 0)
 (>=
 (+ (* (+ |honda_cstpncpy_#t~mem0.offset| |ray_cstpncpy_#t~mem0.offset|) 0)
 (*
 (+ |honda_(select #length cstpncpy_~d~3.base)|
 |ray_(select #length cstpncpy_~d~3.base)|) 0)
 (* (+ |honda_cstpncpy_#t~post4.offset| |ray_cstpncpy_#t~post4.offset|) 0)
 (* (+ honda_cstpncpy_~s~3.offset ray_cstpncpy_~s~3.offset) 0)
 (*
 (+
 |honda_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 |ray_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|)
 0)
 (*
 (+ |honda_(select old(#length) cstpncpy_#in~src.base)|
 |ray_(select old(#length) cstpncpy_#in~src.base)|) 0)
 (* (+ |honda_cstpncpy_~#dst.offset| |ray_cstpncpy_~#dst.offset|) 0)
 (*
 (+
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 |ray_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|)
 0) (* (+ |honda_cstpncpy_#t~mem7| |ray_cstpncpy_#t~mem7|) 0)
 (*
 (+
 |honda_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 |ray_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|)
 0) (* (+ honda_cstpncpy_~d~3.base ray_cstpncpy_~d~3.base) 0)
 (*
 (+
 |honda_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 |ray_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|)
 0)
 (*
 (+ |honda_(select #length cstpncpy_#in~src.base)|
 |ray_(select #length cstpncpy_#in~src.base)|) 0)
 (* (+ |honda_cstpncpy_#in~src.offset| |ray_cstpncpy_#in~src.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)|
 |ray_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)|) 0)
 (* (+ |honda_cstpncpy_#t~mem1.offset| |ray_cstpncpy_#t~mem1.offset|) 0)
 (*
 (+ |honda_(select #length cstpncpy_#in~dst.base)|
 |ray_(select #length cstpncpy_#in~dst.base)|) 0)
 (* (+ |honda_cstpncpy_#t~mem0.base| |ray_cstpncpy_#t~mem0.base|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 |ray_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|)
 0) (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_cstpncpy_#in~n| |ray_cstpncpy_#in~n|) 0)
 (* (+ |honda_cstpncpy_#t~mem1.base| |ray_cstpncpy_#t~mem1.base|) 0)
 (* (+ |honda_cstpncpy_#t~post5.base| |ray_cstpncpy_#t~post5.base|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(select old(#length) cstpncpy_~#dst.base)|
 |ray_(select old(#length) cstpncpy_~#dst.base)|) 0)
 (*
 (+ |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)|
 |ray_(ite (select #valid cstpncpy_~d~3.base) 1 0)|) 0)
 (* (+ honda_cstpncpy_~s~3.base ray_cstpncpy_~s~3.base) 0)
 (*
 (+
 |honda_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 |ray_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|)
 0)
 (*
 (+ |honda_(select #length cstpncpy_~s~3.base)|
 |ray_(select #length cstpncpy_~s~3.base)|) 0)
 (* (+ honda_cstpncpy_~n ray_cstpncpy_~n) 0)
 (* (+ |honda_cstpncpy_#in~dst.base| |ray_cstpncpy_#in~dst.base|) 0)
 (*
 (+ |honda_(ite (select #valid cstpncpy_#in~dst.base) 1 0)|
 |ray_(ite (select #valid cstpncpy_#in~dst.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length cstpncpy_~#dst.base)|
 |ray_(select #length cstpncpy_~#dst.base)|) 0)
 (* (+ |honda_cstpncpy_#t~post4.base| |ray_cstpncpy_#t~post4.base|) 0)
 (*
 (+ |honda_(ite (select #valid cstpncpy_~#dst.base) 1 0)|
 |ray_(ite (select #valid cstpncpy_~#dst.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) cstpncpy_#in~dst.base)|
 |ray_(select old(#length) cstpncpy_#in~dst.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)|
 |ray_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)|) 0)
 (* (+ |honda_cstpncpy_#t~post5.offset| |ray_cstpncpy_#t~post5.offset|) 0)
 (*
 (+ |honda_(ite (select #valid cstpncpy_#in~src.base) 1 0)|
 |ray_(ite (select #valid cstpncpy_#in~src.base) 1 0)|) 0)
 (* (+ |honda_cstpncpy_#in~dst.offset| |ray_cstpncpy_#in~dst.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)|
 |ray_(ite (select #valid cstpncpy_~s~3.base) 1 0)|) 0)
 (* (+ honda_cstpncpy_~src.base ray_cstpncpy_~src.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ honda_cstpncpy_~d~3.offset ray_cstpncpy_~d~3.offset) 0)
 (* (+ |honda_cstpncpy_#t~post3| |ray_cstpncpy_#t~post3|) 0)
 (* (+ |honda_cstpncpy_~#dst.base| |ray_cstpncpy_~#dst.base|) 0)
 (* (+ honda_cstpncpy_~src.offset ray_cstpncpy_~src.offset) 0)
 (* (+ |honda_cstpncpy_#in~src.base| |ray_cstpncpy_#in~src.base|) 0)
 (*
 (+
 |honda_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 |ray_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)|
 |ray_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)|) 0)
 (* |honda_(select #length cstpncpy_~d~3.base)| 0)
 (* |honda_cstpncpy_#t~post4.offset| 0) 
 (* honda_cstpncpy_~s~3.offset 0)
 (*
 |honda_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |honda_cstpncpy_#t~mem7| 0) 
 (* honda_cstpncpy_~d~3.base 0) 
 (* |honda_cstpncpy_#t~post5.base| 0)
 (* |honda_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (* honda_cstpncpy_~s~3.base 0)
 (* |honda_(select #length cstpncpy_~s~3.base)| 0) 
 (* honda_cstpncpy_~n 0) (* |honda_cstpncpy_#t~post4.base| 0)
 (* |honda_cstpncpy_#t~post5.offset| 0)
 (* |honda_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* honda_cstpncpy_~d~3.offset 0) 
 (* |honda_cstpncpy_#t~post3| 0) 
 (* aux_3751 (- 1)) (* aux_3746 1) 
 (- 1)) 0)
 (= |ray_cstpncpy_#t~mem0.offset| (* |ray_cstpncpy_#t~mem0.offset| lambda))
 (=
 |ray_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 (*
 |ray_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 lambda))
 (= |ray_(select old(#length) cstpncpy_#in~src.base)|
 (* |ray_(select old(#length) cstpncpy_#in~src.base)| lambda))
 (= |ray_cstpncpy_~#dst.offset| (* |ray_cstpncpy_~#dst.offset| lambda))
 (=
 |ray_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 (*
 |ray_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 lambda))
 (=
 |ray_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 (*
 |ray_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 lambda))
 (= |ray_(select #length cstpncpy_#in~src.base)|
 (* |ray_(select #length cstpncpy_#in~src.base)| lambda))
 (= |ray_cstpncpy_#in~src.offset| (* |ray_cstpncpy_#in~src.offset| lambda))
 (= |ray_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)|
 (* |ray_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| lambda))
 (= |ray_cstpncpy_#t~mem1.offset| (* |ray_cstpncpy_#t~mem1.offset| lambda))
 (= |ray_(select #length cstpncpy_#in~dst.base)|
 (* |ray_(select #length cstpncpy_#in~dst.base)| lambda))
 (= |ray_cstpncpy_#t~mem0.base| (* |ray_cstpncpy_#t~mem0.base| lambda))
 (=
 |ray_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 (*
 |ray_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 lambda)) (= |ray_#NULL.offset| (* |ray_#NULL.offset| lambda))
 (= |ray_cstpncpy_#in~n| (* |ray_cstpncpy_#in~n| lambda))
 (= |ray_cstpncpy_#t~mem1.base| (* |ray_cstpncpy_#t~mem1.base| lambda))
 (= |ray_#NULL.base| (* |ray_#NULL.base| lambda))
 (= |ray_(select old(#length) cstpncpy_~#dst.base)|
 (* |ray_(select old(#length) cstpncpy_~#dst.base)| lambda))
 (=
 |ray_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 (*
 |ray_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 lambda))
 (= |ray_cstpncpy_#in~dst.base| (* |ray_cstpncpy_#in~dst.base| lambda))
 (= |ray_(ite (select #valid cstpncpy_#in~dst.base) 1 0)|
 (* |ray_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| lambda))
 (= |ray_(select #length cstpncpy_~#dst.base)|
 (* |ray_(select #length cstpncpy_~#dst.base)| lambda))
 (= |ray_(ite (select #valid cstpncpy_~#dst.base) 1 0)|
 (* |ray_(ite (select #valid cstpncpy_~#dst.base) 1 0)| lambda))
 (= |ray_(select old(#length) cstpncpy_#in~dst.base)|
 (* |ray_(select old(#length) cstpncpy_#in~dst.base)| lambda))
 (= |ray_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)|
 (* |ray_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| lambda))
 (= |ray_(ite (select #valid cstpncpy_#in~src.base) 1 0)|
 (* |ray_(ite (select #valid cstpncpy_#in~src.base) 1 0)| lambda))
 (= |ray_cstpncpy_#in~dst.offset| (* |ray_cstpncpy_#in~dst.offset| lambda))
 (= |ray_(ite (select #valid 0) 1 0)|
 (* |ray_(ite (select #valid 0) 1 0)| lambda))
 (= ray_cstpncpy_~src.base (* ray_cstpncpy_~src.base lambda))
 (= |ray_(ite (select old(#valid) 0) 1 0)|
 (* |ray_(ite (select old(#valid) 0) 1 0)| lambda))
 (= |ray_cstpncpy_~#dst.base| (* |ray_cstpncpy_~#dst.base| lambda))
 (= ray_cstpncpy_~src.offset (* ray_cstpncpy_~src.offset lambda))
 (= |ray_cstpncpy_#in~src.base| (* |ray_cstpncpy_#in~src.base| lambda))
 (=
 |ray_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 (*
 |ray_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 lambda))
 (= |ray_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)|
 (* |ray_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| lambda))
 (>=
 (+ (* (* |ray_cstpncpy_#t~mem0.offset| lambda) 0)
 (* (* |ray_(select #length cstpncpy_~d~3.base)| lambda) 0)
 (* (* |ray_cstpncpy_#t~post4.offset| lambda) 0)
 (* (* ray_cstpncpy_~s~3.offset lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 lambda) 0)
 (* (* |ray_(select old(#length) cstpncpy_#in~src.base)| lambda) 0)
 (* (* |ray_cstpncpy_~#dst.offset| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 lambda) 0) (* (* |ray_cstpncpy_#t~mem7| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 lambda) 0) (* (* ray_cstpncpy_~d~3.base lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 lambda) 0) (* (* |ray_(select #length cstpncpy_#in~src.base)| lambda) 0)
 (* (* |ray_cstpncpy_#in~src.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| lambda) 0)
 (* (* |ray_cstpncpy_#t~mem1.offset| lambda) 0)
 (* (* |ray_(select #length cstpncpy_#in~dst.base)| lambda) 0)
 (* (* |ray_cstpncpy_#t~mem0.base| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_cstpncpy_#in~n| lambda) 0)
 (* (* |ray_cstpncpy_#t~mem1.base| lambda) 0)
 (* (* |ray_cstpncpy_#t~post5.base| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(select old(#length) cstpncpy_~#dst.base)| lambda) 0)
 (* (* |ray_(ite (select #valid cstpncpy_~d~3.base) 1 0)| lambda) 0)
 (* (* ray_cstpncpy_~s~3.base lambda) 0)
 (*
 (*
 |ray_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 lambda) 0) (* (* |ray_(select #length cstpncpy_~s~3.base)| lambda) (- 1))
 (* (* ray_cstpncpy_~n lambda) 0)
 (* (* |ray_cstpncpy_#in~dst.base| lambda) 0)
 (* (* |ray_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length cstpncpy_~#dst.base)| lambda) 0)
 (* (* |ray_cstpncpy_#t~post4.base| lambda) 0)
 (* (* |ray_(ite (select #valid cstpncpy_~#dst.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) cstpncpy_#in~dst.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| lambda) 0)
 (* (* |ray_cstpncpy_#t~post5.offset| lambda) 0)
 (* (* |ray_(ite (select #valid cstpncpy_#in~src.base) 1 0)| lambda) 0)
 (* (* |ray_cstpncpy_#in~dst.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid cstpncpy_~s~3.base) 1 0)| lambda) 0)
 (* (* ray_cstpncpy_~src.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* ray_cstpncpy_~d~3.offset lambda) 0)
 (* (* |ray_cstpncpy_#t~post3| lambda) 0)
 (* (* |ray_cstpncpy_~#dst.base| lambda) 0)
 (* (* ray_cstpncpy_~src.offset lambda) 0)
 (* (* |ray_cstpncpy_#in~src.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| lambda) 0)
 (* |ray_(select #length cstpncpy_~d~3.base)| 0)
 (* |ray_cstpncpy_#t~post4.offset| 0) 
 (* ray_cstpncpy_~s~3.offset 0)
 (*
 |ray_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |ray_cstpncpy_#t~mem7| 0) 
 (* ray_cstpncpy_~d~3.base 0) 
 (* |ray_cstpncpy_#t~post5.base| 0)
 (* |ray_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (* ray_cstpncpy_~s~3.base 0) 
 (* |ray_(select #length cstpncpy_~s~3.base)| 1) 
 (* ray_cstpncpy_~n 0) (* |ray_cstpncpy_#t~post4.base| 0)
 (* |ray_cstpncpy_#t~post5.offset| 0)
 (* |ray_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* ray_cstpncpy_~d~3.offset 0) 
 (* |ray_cstpncpy_#t~post3| 0)) 0)
 (>=
 (+ (* (* |ray_cstpncpy_#t~mem0.offset| lambda) 0)
 (* (* |ray_(select #length cstpncpy_~d~3.base)| lambda) 0)
 (* (* |ray_cstpncpy_#t~post4.offset| lambda) 0)
 (* (* ray_cstpncpy_~s~3.offset lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 lambda) 0)
 (* (* |ray_(select old(#length) cstpncpy_#in~src.base)| lambda) 0)
 (* (* |ray_cstpncpy_~#dst.offset| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 lambda) 0) (* (* |ray_cstpncpy_#t~mem7| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 lambda) 0) (* (* ray_cstpncpy_~d~3.base lambda) (- 1))
 (*
 (*
 |ray_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 lambda) 0) (* (* |ray_(select #length cstpncpy_#in~src.base)| lambda) 0)
 (* (* |ray_cstpncpy_#in~src.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| lambda) 0)
 (* (* |ray_cstpncpy_#t~mem1.offset| lambda) 0)
 (* (* |ray_(select #length cstpncpy_#in~dst.base)| lambda) 0)
 (* (* |ray_cstpncpy_#t~mem0.base| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_cstpncpy_#in~n| lambda) 0)
 (* (* |ray_cstpncpy_#t~mem1.base| lambda) 0)
 (* (* |ray_cstpncpy_#t~post5.base| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(select old(#length) cstpncpy_~#dst.base)| lambda) 0)
 (* (* |ray_(ite (select #valid cstpncpy_~d~3.base) 1 0)| lambda) 0)
 (* (* ray_cstpncpy_~s~3.base lambda) 0)
 (*
 (*
 |ray_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 lambda) 0) (* (* |ray_(select #length cstpncpy_~s~3.base)| lambda) 0)
 (* (* ray_cstpncpy_~n lambda) 0)
 (* (* |ray_cstpncpy_#in~dst.base| lambda) 0)
 (* (* |ray_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length cstpncpy_~#dst.base)| lambda) 0)
 (* (* |ray_cstpncpy_#t~post4.base| lambda) 0)
 (* (* |ray_(ite (select #valid cstpncpy_~#dst.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) cstpncpy_#in~dst.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| lambda) 0)
 (* (* |ray_cstpncpy_#t~post5.offset| lambda) 0)
 (* (* |ray_(ite (select #valid cstpncpy_#in~src.base) 1 0)| lambda) 0)
 (* (* |ray_cstpncpy_#in~dst.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid cstpncpy_~s~3.base) 1 0)| lambda) 0)
 (* (* ray_cstpncpy_~src.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* ray_cstpncpy_~d~3.offset lambda) 0)
 (* (* |ray_cstpncpy_#t~post3| lambda) 0)
 (* (* |ray_cstpncpy_~#dst.base| lambda) 0)
 (* (* ray_cstpncpy_~src.offset lambda) 0)
 (* (* |ray_cstpncpy_#in~src.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| lambda) 0)
 (* |ray_(select #length cstpncpy_~d~3.base)| 0)
 (* |ray_cstpncpy_#t~post4.offset| 0) 
 (* ray_cstpncpy_~s~3.offset 0)
 (*
 |ray_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |ray_cstpncpy_#t~mem7| 0) 
 (* ray_cstpncpy_~d~3.base 1) 
 (* |ray_cstpncpy_#t~post5.base| 0)
 (* |ray_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (* ray_cstpncpy_~s~3.base 0) 
 (* |ray_(select #length cstpncpy_~s~3.base)| 0) 
 (* ray_cstpncpy_~n 0) (* |ray_cstpncpy_#t~post4.base| 0)
 (* |ray_cstpncpy_#t~post5.offset| 0)
 (* |ray_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* ray_cstpncpy_~d~3.offset 0) 
 (* |ray_cstpncpy_#t~post3| 0)) 0)
 (>=
 (+ (* (* |ray_cstpncpy_#t~mem0.offset| lambda) 0)
 (* (* |ray_(select #length cstpncpy_~d~3.base)| lambda) 0)
 (* (* |ray_cstpncpy_#t~post4.offset| lambda) 0)
 (* (* ray_cstpncpy_~s~3.offset lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 lambda) 0)
 (* (* |ray_(select old(#length) cstpncpy_#in~src.base)| lambda) 0)
 (* (* |ray_cstpncpy_~#dst.offset| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 lambda) 0) (* (* |ray_cstpncpy_#t~mem7| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 lambda) 0) (* (* ray_cstpncpy_~d~3.base lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 lambda) 0) (* (* |ray_(select #length cstpncpy_#in~src.base)| lambda) 0)
 (* (* |ray_cstpncpy_#in~src.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| lambda) 0)
 (* (* |ray_cstpncpy_#t~mem1.offset| lambda) 0)
 (* (* |ray_(select #length cstpncpy_#in~dst.base)| lambda) 0)
 (* (* |ray_cstpncpy_#t~mem0.base| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_cstpncpy_#in~n| lambda) 0)
 (* (* |ray_cstpncpy_#t~mem1.base| lambda) 0)
 (* (* |ray_cstpncpy_#t~post5.base| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(select old(#length) cstpncpy_~#dst.base)| lambda) 0)
 (* (* |ray_(ite (select #valid cstpncpy_~d~3.base) 1 0)| lambda) 0)
 (* (* ray_cstpncpy_~s~3.base lambda) 0)
 (*
 (*
 |ray_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 lambda) 0) (* (* |ray_(select #length cstpncpy_~s~3.base)| lambda) 0)
 (* (* ray_cstpncpy_~n lambda) 0)
 (* (* |ray_cstpncpy_#in~dst.base| lambda) 0)
 (* (* |ray_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length cstpncpy_~#dst.base)| lambda) 0)
 (* (* |ray_cstpncpy_#t~post4.base| lambda) 0)
 (* (* |ray_(ite (select #valid cstpncpy_~#dst.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) cstpncpy_#in~dst.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| lambda) 0)
 (* (* |ray_cstpncpy_#t~post5.offset| lambda) 0)
 (* (* |ray_(ite (select #valid cstpncpy_#in~src.base) 1 0)| lambda) 0)
 (* (* |ray_cstpncpy_#in~dst.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid cstpncpy_~s~3.base) 1 0)| lambda) 0)
 (* (* ray_cstpncpy_~src.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* ray_cstpncpy_~d~3.offset lambda) (- 1))
 (* (* |ray_cstpncpy_#t~post3| lambda) 0)
 (* (* |ray_cstpncpy_~#dst.base| lambda) 0)
 (* (* ray_cstpncpy_~src.offset lambda) 0)
 (* (* |ray_cstpncpy_#in~src.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| lambda) 0)
 (* |ray_(select #length cstpncpy_~d~3.base)| 0)
 (* |ray_cstpncpy_#t~post4.offset| 0) 
 (* ray_cstpncpy_~s~3.offset 0)
 (*
 |ray_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |ray_cstpncpy_#t~mem7| 0) 
 (* ray_cstpncpy_~d~3.base 0) 
 (* |ray_cstpncpy_#t~post5.base| 0)
 (* |ray_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (* ray_cstpncpy_~s~3.base 0) 
 (* |ray_(select #length cstpncpy_~s~3.base)| 0) 
 (* ray_cstpncpy_~n 0) (* |ray_cstpncpy_#t~post4.base| 0)
 (* |ray_cstpncpy_#t~post5.offset| 0)
 (* |ray_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* ray_cstpncpy_~d~3.offset 1) 
 (* |ray_cstpncpy_#t~post3| 0)) 0)
 (>=
 (+ (* (* |ray_cstpncpy_#t~mem0.offset| lambda) 0)
 (* (* |ray_(select #length cstpncpy_~d~3.base)| lambda) 0)
 (* (* |ray_cstpncpy_#t~post4.offset| lambda) 0)
 (* (* ray_cstpncpy_~s~3.offset lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 lambda) 0)
 (* (* |ray_(select old(#length) cstpncpy_#in~src.base)| lambda) 0)
 (* (* |ray_cstpncpy_~#dst.offset| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 lambda) 0) (* (* |ray_cstpncpy_#t~mem7| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 lambda) 0) (* (* ray_cstpncpy_~d~3.base lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 lambda) 0) (* (* |ray_(select #length cstpncpy_#in~src.base)| lambda) 0)
 (* (* |ray_cstpncpy_#in~src.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| lambda) 0)
 (* (* |ray_cstpncpy_#t~mem1.offset| lambda) 0)
 (* (* |ray_(select #length cstpncpy_#in~dst.base)| lambda) 0)
 (* (* |ray_cstpncpy_#t~mem0.base| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_cstpncpy_#in~n| lambda) 0)
 (* (* |ray_cstpncpy_#t~mem1.base| lambda) 0)
 (* (* |ray_cstpncpy_#t~post5.base| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(select old(#length) cstpncpy_~#dst.base)| lambda) 0)
 (* (* |ray_(ite (select #valid cstpncpy_~d~3.base) 1 0)| lambda) 1)
 (* (* ray_cstpncpy_~s~3.base lambda) 0)
 (*
 (*
 |ray_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 lambda) 0) (* (* |ray_(select #length cstpncpy_~s~3.base)| lambda) 0)
 (* (* ray_cstpncpy_~n lambda) 0)
 (* (* |ray_cstpncpy_#in~dst.base| lambda) 0)
 (* (* |ray_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length cstpncpy_~#dst.base)| lambda) 0)
 (* (* |ray_cstpncpy_#t~post4.base| lambda) 0)
 (* (* |ray_(ite (select #valid cstpncpy_~#dst.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) cstpncpy_#in~dst.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| lambda) 0)
 (* (* |ray_cstpncpy_#t~post5.offset| lambda) 0)
 (* (* |ray_(ite (select #valid cstpncpy_#in~src.base) 1 0)| lambda) 0)
 (* (* |ray_cstpncpy_#in~dst.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid cstpncpy_~s~3.base) 1 0)| lambda) 0)
 (* (* ray_cstpncpy_~src.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* ray_cstpncpy_~d~3.offset lambda) 0)
 (* (* |ray_cstpncpy_#t~post3| lambda) 0)
 (* (* |ray_cstpncpy_~#dst.base| lambda) 0)
 (* (* ray_cstpncpy_~src.offset lambda) 0)
 (* (* |ray_cstpncpy_#in~src.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| lambda) 0)
 (* |ray_(select #length cstpncpy_~d~3.base)| 0)
 (* |ray_cstpncpy_#t~post4.offset| 0) 
 (* ray_cstpncpy_~s~3.offset 0)
 (*
 |ray_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |ray_cstpncpy_#t~mem7| 0) 
 (* ray_cstpncpy_~d~3.base 0) 
 (* |ray_cstpncpy_#t~post5.base| 0)
 (* |ray_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (* ray_cstpncpy_~s~3.base 0) 
 (* |ray_(select #length cstpncpy_~s~3.base)| 0) 
 (* ray_cstpncpy_~n 0) (* |ray_cstpncpy_#t~post4.base| 0)
 (* |ray_cstpncpy_#t~post5.offset| 0)
 (* |ray_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* ray_cstpncpy_~d~3.offset 0) 
 (* |ray_cstpncpy_#t~post3| 0)) 0)
 (>=
 (+ (* (* |ray_cstpncpy_#t~mem0.offset| lambda) 0)
 (* (* |ray_(select #length cstpncpy_~d~3.base)| lambda) (- 1))
 (* (* |ray_cstpncpy_#t~post4.offset| lambda) 0)
 (* (* ray_cstpncpy_~s~3.offset lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 lambda) 0)
 (* (* |ray_(select old(#length) cstpncpy_#in~src.base)| lambda) 0)
 (* (* |ray_cstpncpy_~#dst.offset| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 lambda) 0) (* (* |ray_cstpncpy_#t~mem7| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 lambda) 0) (* (* ray_cstpncpy_~d~3.base lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 lambda) 0) (* (* |ray_(select #length cstpncpy_#in~src.base)| lambda) 0)
 (* (* |ray_cstpncpy_#in~src.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| lambda) 0)
 (* (* |ray_cstpncpy_#t~mem1.offset| lambda) 0)
 (* (* |ray_(select #length cstpncpy_#in~dst.base)| lambda) 0)
 (* (* |ray_cstpncpy_#t~mem0.base| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_cstpncpy_#in~n| lambda) 0)
 (* (* |ray_cstpncpy_#t~mem1.base| lambda) 0)
 (* (* |ray_cstpncpy_#t~post5.base| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(select old(#length) cstpncpy_~#dst.base)| lambda) 0)
 (* (* |ray_(ite (select #valid cstpncpy_~d~3.base) 1 0)| lambda) 0)
 (* (* ray_cstpncpy_~s~3.base lambda) 0)
 (*
 (*
 |ray_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 lambda) 0) (* (* |ray_(select #length cstpncpy_~s~3.base)| lambda) 0)
 (* (* ray_cstpncpy_~n lambda) 0)
 (* (* |ray_cstpncpy_#in~dst.base| lambda) 0)
 (* (* |ray_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length cstpncpy_~#dst.base)| lambda) 0)
 (* (* |ray_cstpncpy_#t~post4.base| lambda) 0)
 (* (* |ray_(ite (select #valid cstpncpy_~#dst.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) cstpncpy_#in~dst.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| lambda) 0)
 (* (* |ray_cstpncpy_#t~post5.offset| lambda) 0)
 (* (* |ray_(ite (select #valid cstpncpy_#in~src.base) 1 0)| lambda) 0)
 (* (* |ray_cstpncpy_#in~dst.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid cstpncpy_~s~3.base) 1 0)| lambda) 0)
 (* (* ray_cstpncpy_~src.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* ray_cstpncpy_~d~3.offset lambda) 0)
 (* (* |ray_cstpncpy_#t~post3| lambda) 0)
 (* (* |ray_cstpncpy_~#dst.base| lambda) 0)
 (* (* ray_cstpncpy_~src.offset lambda) 0)
 (* (* |ray_cstpncpy_#in~src.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| lambda) 0)
 (* |ray_(select #length cstpncpy_~d~3.base)| 1)
 (* |ray_cstpncpy_#t~post4.offset| 0) 
 (* ray_cstpncpy_~s~3.offset 0)
 (*
 |ray_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |ray_cstpncpy_#t~mem7| 0) 
 (* ray_cstpncpy_~d~3.base 0) 
 (* |ray_cstpncpy_#t~post5.base| 0)
 (* |ray_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (* ray_cstpncpy_~s~3.base 0) 
 (* |ray_(select #length cstpncpy_~s~3.base)| 0) 
 (* ray_cstpncpy_~n 0) (* |ray_cstpncpy_#t~post4.base| 0)
 (* |ray_cstpncpy_#t~post5.offset| 0)
 (* |ray_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* ray_cstpncpy_~d~3.offset 0) 
 (* |ray_cstpncpy_#t~post3| 0)) 0)
 (>=
 (+ (* (* |ray_cstpncpy_#t~mem0.offset| lambda) 0)
 (* (* |ray_(select #length cstpncpy_~d~3.base)| lambda) 0)
 (* (* |ray_cstpncpy_#t~post4.offset| lambda) 0)
 (* (* ray_cstpncpy_~s~3.offset lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 lambda) 0)
 (* (* |ray_(select old(#length) cstpncpy_#in~src.base)| lambda) 0)
 (* (* |ray_cstpncpy_~#dst.offset| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 lambda) 0) (* (* |ray_cstpncpy_#t~mem7| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 lambda) 0) (* (* ray_cstpncpy_~d~3.base lambda) 1)
 (*
 (*
 |ray_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 lambda) 0) (* (* |ray_(select #length cstpncpy_#in~src.base)| lambda) 0)
 (* (* |ray_cstpncpy_#in~src.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| lambda) 0)
 (* (* |ray_cstpncpy_#t~mem1.offset| lambda) 0)
 (* (* |ray_(select #length cstpncpy_#in~dst.base)| lambda) 0)
 (* (* |ray_cstpncpy_#t~mem0.base| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_cstpncpy_#in~n| lambda) 0)
 (* (* |ray_cstpncpy_#t~mem1.base| lambda) 0)
 (* (* |ray_cstpncpy_#t~post5.base| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(select old(#length) cstpncpy_~#dst.base)| lambda) 0)
 (* (* |ray_(ite (select #valid cstpncpy_~d~3.base) 1 0)| lambda) 0)
 (* (* ray_cstpncpy_~s~3.base lambda) 0)
 (*
 (*
 |ray_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 lambda) 0) (* (* |ray_(select #length cstpncpy_~s~3.base)| lambda) 0)
 (* (* ray_cstpncpy_~n lambda) 0)
 (* (* |ray_cstpncpy_#in~dst.base| lambda) 0)
 (* (* |ray_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length cstpncpy_~#dst.base)| lambda) 0)
 (* (* |ray_cstpncpy_#t~post4.base| lambda) 0)
 (* (* |ray_(ite (select #valid cstpncpy_~#dst.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) cstpncpy_#in~dst.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| lambda) 0)
 (* (* |ray_cstpncpy_#t~post5.offset| lambda) 0)
 (* (* |ray_(ite (select #valid cstpncpy_#in~src.base) 1 0)| lambda) 0)
 (* (* |ray_cstpncpy_#in~dst.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid cstpncpy_~s~3.base) 1 0)| lambda) 0)
 (* (* ray_cstpncpy_~src.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* ray_cstpncpy_~d~3.offset lambda) 0)
 (* (* |ray_cstpncpy_#t~post3| lambda) 0)
 (* (* |ray_cstpncpy_~#dst.base| lambda) 0)
 (* (* ray_cstpncpy_~src.offset lambda) 0)
 (* (* |ray_cstpncpy_#in~src.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| lambda) 0)
 (* |ray_(select #length cstpncpy_~d~3.base)| 0)
 (* |ray_cstpncpy_#t~post4.offset| 0) 
 (* ray_cstpncpy_~s~3.offset 0)
 (*
 |ray_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |ray_cstpncpy_#t~mem7| 0) 
 (* ray_cstpncpy_~d~3.base (- 1)) 
 (* |ray_cstpncpy_#t~post5.base| 0)
 (* |ray_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (* ray_cstpncpy_~s~3.base 0) 
 (* |ray_(select #length cstpncpy_~s~3.base)| 0) 
 (* ray_cstpncpy_~n 0) (* |ray_cstpncpy_#t~post4.base| 0)
 (* |ray_cstpncpy_#t~post5.offset| 0)
 (* |ray_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* ray_cstpncpy_~d~3.offset 0) 
 (* |ray_cstpncpy_#t~post3| 0)) 0)
 (>=
 (+ (* (* |ray_cstpncpy_#t~mem0.offset| lambda) 0)
 (* (* |ray_(select #length cstpncpy_~d~3.base)| lambda) 0)
 (* (* |ray_cstpncpy_#t~post4.offset| lambda) 0)
 (* (* ray_cstpncpy_~s~3.offset lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 lambda) 0)
 (* (* |ray_(select old(#length) cstpncpy_#in~src.base)| lambda) 0)
 (* (* |ray_cstpncpy_~#dst.offset| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 lambda) 0) (* (* |ray_cstpncpy_#t~mem7| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 lambda) 0) (* (* ray_cstpncpy_~d~3.base lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 lambda) 0) (* (* |ray_(select #length cstpncpy_#in~src.base)| lambda) 0)
 (* (* |ray_cstpncpy_#in~src.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| lambda) 0)
 (* (* |ray_cstpncpy_#t~mem1.offset| lambda) 0)
 (* (* |ray_(select #length cstpncpy_#in~dst.base)| lambda) 0)
 (* (* |ray_cstpncpy_#t~mem0.base| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_cstpncpy_#in~n| lambda) 0)
 (* (* |ray_cstpncpy_#t~mem1.base| lambda) 0)
 (* (* |ray_cstpncpy_#t~post5.base| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(select old(#length) cstpncpy_~#dst.base)| lambda) 0)
 (* (* |ray_(ite (select #valid cstpncpy_~d~3.base) 1 0)| lambda) 0)
 (* (* ray_cstpncpy_~s~3.base lambda) 0)
 (*
 (*
 |ray_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 lambda) 0) (* (* |ray_(select #length cstpncpy_~s~3.base)| lambda) 0)
 (* (* ray_cstpncpy_~n lambda) 0)
 (* (* |ray_cstpncpy_#in~dst.base| lambda) 0)
 (* (* |ray_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length cstpncpy_~#dst.base)| lambda) 0)
 (* (* |ray_cstpncpy_#t~post4.base| lambda) 0)
 (* (* |ray_(ite (select #valid cstpncpy_~#dst.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) cstpncpy_#in~dst.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| lambda) 0)
 (* (* |ray_cstpncpy_#t~post5.offset| lambda) 0)
 (* (* |ray_(ite (select #valid cstpncpy_#in~src.base) 1 0)| lambda) 0)
 (* (* |ray_cstpncpy_#in~dst.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid cstpncpy_~s~3.base) 1 0)| lambda) 0)
 (* (* ray_cstpncpy_~src.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* ray_cstpncpy_~d~3.offset lambda) 0)
 (* (* |ray_cstpncpy_#t~post3| lambda) 0)
 (* (* |ray_cstpncpy_~#dst.base| lambda) 0)
 (* (* ray_cstpncpy_~src.offset lambda) 0)
 (* (* |ray_cstpncpy_#in~src.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| lambda) 0)
 (* |ray_(select #length cstpncpy_~d~3.base)| 0)
 (* |ray_cstpncpy_#t~post4.offset| 0) 
 (* ray_cstpncpy_~s~3.offset (- 1))
 (*
 |ray_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |ray_cstpncpy_#t~mem7| 0) 
 (* ray_cstpncpy_~d~3.base 0) 
 (* |ray_cstpncpy_#t~post5.base| 0)
 (* |ray_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (* ray_cstpncpy_~s~3.base 0) 
 (* |ray_(select #length cstpncpy_~s~3.base)| 1) 
 (* ray_cstpncpy_~n 0) (* |ray_cstpncpy_#t~post4.base| 0)
 (* |ray_cstpncpy_#t~post5.offset| 0)
 (* |ray_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* ray_cstpncpy_~d~3.offset 0) 
 (* |ray_cstpncpy_#t~post3| 0)) 0)
 (>=
 (+ (* (* |ray_cstpncpy_#t~mem0.offset| lambda) 0)
 (* (* |ray_(select #length cstpncpy_~d~3.base)| lambda) 0)
 (* (* |ray_cstpncpy_#t~post4.offset| lambda) 0)
 (* (* ray_cstpncpy_~s~3.offset lambda) (- 1))
 (*
 (*
 |ray_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 lambda) 0)
 (* (* |ray_(select old(#length) cstpncpy_#in~src.base)| lambda) 0)
 (* (* |ray_cstpncpy_~#dst.offset| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 lambda) 0) (* (* |ray_cstpncpy_#t~mem7| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 lambda) 0) (* (* ray_cstpncpy_~d~3.base lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 lambda) 0) (* (* |ray_(select #length cstpncpy_#in~src.base)| lambda) 0)
 (* (* |ray_cstpncpy_#in~src.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| lambda) 0)
 (* (* |ray_cstpncpy_#t~mem1.offset| lambda) 0)
 (* (* |ray_(select #length cstpncpy_#in~dst.base)| lambda) 0)
 (* (* |ray_cstpncpy_#t~mem0.base| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_cstpncpy_#in~n| lambda) 0)
 (* (* |ray_cstpncpy_#t~mem1.base| lambda) 0)
 (* (* |ray_cstpncpy_#t~post5.base| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(select old(#length) cstpncpy_~#dst.base)| lambda) 0)
 (* (* |ray_(ite (select #valid cstpncpy_~d~3.base) 1 0)| lambda) 0)
 (* (* ray_cstpncpy_~s~3.base lambda) 0)
 (*
 (*
 |ray_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 lambda) 0) (* (* |ray_(select #length cstpncpy_~s~3.base)| lambda) 0)
 (* (* ray_cstpncpy_~n lambda) 0)
 (* (* |ray_cstpncpy_#in~dst.base| lambda) 0)
 (* (* |ray_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length cstpncpy_~#dst.base)| lambda) 0)
 (* (* |ray_cstpncpy_#t~post4.base| lambda) 0)
 (* (* |ray_(ite (select #valid cstpncpy_~#dst.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) cstpncpy_#in~dst.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| lambda) 0)
 (* (* |ray_cstpncpy_#t~post5.offset| lambda) 0)
 (* (* |ray_(ite (select #valid cstpncpy_#in~src.base) 1 0)| lambda) 0)
 (* (* |ray_cstpncpy_#in~dst.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid cstpncpy_~s~3.base) 1 0)| lambda) 0)
 (* (* ray_cstpncpy_~src.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* ray_cstpncpy_~d~3.offset lambda) 0)
 (* (* |ray_cstpncpy_#t~post3| lambda) 0)
 (* (* |ray_cstpncpy_~#dst.base| lambda) 0)
 (* (* ray_cstpncpy_~src.offset lambda) 0)
 (* (* |ray_cstpncpy_#in~src.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| lambda) 0)
 (* |ray_(select #length cstpncpy_~d~3.base)| 0)
 (* |ray_cstpncpy_#t~post4.offset| 0) 
 (* ray_cstpncpy_~s~3.offset 1)
 (*
 |ray_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |ray_cstpncpy_#t~mem7| 0) 
 (* ray_cstpncpy_~d~3.base 0) 
 (* |ray_cstpncpy_#t~post5.base| 0)
 (* |ray_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (* ray_cstpncpy_~s~3.base 0) 
 (* |ray_(select #length cstpncpy_~s~3.base)| 0) 
 (* ray_cstpncpy_~n 0) (* |ray_cstpncpy_#t~post4.base| 0)
 (* |ray_cstpncpy_#t~post5.offset| 0)
 (* |ray_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* ray_cstpncpy_~d~3.offset 0) 
 (* |ray_cstpncpy_#t~post3| 0)) 0)
 (>=
 (+ (* (* |ray_cstpncpy_#t~mem0.offset| lambda) 0)
 (* (* |ray_(select #length cstpncpy_~d~3.base)| lambda) 0)
 (* (* |ray_cstpncpy_#t~post4.offset| lambda) 0)
 (* (* ray_cstpncpy_~s~3.offset lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 lambda) 0)
 (* (* |ray_(select old(#length) cstpncpy_#in~src.base)| lambda) 0)
 (* (* |ray_cstpncpy_~#dst.offset| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 lambda) 0) (* (* |ray_cstpncpy_#t~mem7| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 lambda) 0) (* (* ray_cstpncpy_~d~3.base lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 lambda) 0) (* (* |ray_(select #length cstpncpy_#in~src.base)| lambda) 0)
 (* (* |ray_cstpncpy_#in~src.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| lambda) 0)
 (* (* |ray_cstpncpy_#t~mem1.offset| lambda) 0)
 (* (* |ray_(select #length cstpncpy_#in~dst.base)| lambda) 0)
 (* (* |ray_cstpncpy_#t~mem0.base| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_cstpncpy_#in~n| lambda) 0)
 (* (* |ray_cstpncpy_#t~mem1.base| lambda) 0)
 (* (* |ray_cstpncpy_#t~post5.base| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(select old(#length) cstpncpy_~#dst.base)| lambda) 0)
 (* (* |ray_(ite (select #valid cstpncpy_~d~3.base) 1 0)| lambda) 0)
 (* (* ray_cstpncpy_~s~3.base lambda) 0)
 (*
 (*
 |ray_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 lambda) 0) (* (* |ray_(select #length cstpncpy_~s~3.base)| lambda) 0)
 (* (* ray_cstpncpy_~n lambda) (- 1))
 (* (* |ray_cstpncpy_#in~dst.base| lambda) 0)
 (* (* |ray_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length cstpncpy_~#dst.base)| lambda) 0)
 (* (* |ray_cstpncpy_#t~post4.base| lambda) 0)
 (* (* |ray_(ite (select #valid cstpncpy_~#dst.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) cstpncpy_#in~dst.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| lambda) 0)
 (* (* |ray_cstpncpy_#t~post5.offset| lambda) 0)
 (* (* |ray_(ite (select #valid cstpncpy_#in~src.base) 1 0)| lambda) 0)
 (* (* |ray_cstpncpy_#in~dst.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid cstpncpy_~s~3.base) 1 0)| lambda) 0)
 (* (* ray_cstpncpy_~src.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* ray_cstpncpy_~d~3.offset lambda) 0)
 (* (* |ray_cstpncpy_#t~post3| lambda) 0)
 (* (* |ray_cstpncpy_~#dst.base| lambda) 0)
 (* (* ray_cstpncpy_~src.offset lambda) 0)
 (* (* |ray_cstpncpy_#in~src.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| lambda) 0)
 (* |ray_(select #length cstpncpy_~d~3.base)| 0)
 (* |ray_cstpncpy_#t~post4.offset| 0) 
 (* ray_cstpncpy_~s~3.offset 0)
 (*
 |ray_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |ray_cstpncpy_#t~mem7| 0) 
 (* ray_cstpncpy_~d~3.base 0) 
 (* |ray_cstpncpy_#t~post5.base| 0)
 (* |ray_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (* ray_cstpncpy_~s~3.base 0) 
 (* |ray_(select #length cstpncpy_~s~3.base)| 0) 
 (* ray_cstpncpy_~n 1) (* |ray_cstpncpy_#t~post4.base| 0)
 (* |ray_cstpncpy_#t~post5.offset| 0)
 (* |ray_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* ray_cstpncpy_~d~3.offset 0) 
 (* |ray_cstpncpy_#t~post3| 0)) 0)
 (>=
 (+ (* (* |ray_cstpncpy_#t~mem0.offset| lambda) 0)
 (* (* |ray_(select #length cstpncpy_~d~3.base)| lambda) 0)
 (* (* |ray_cstpncpy_#t~post4.offset| lambda) 0)
 (* (* ray_cstpncpy_~s~3.offset lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 lambda) 0)
 (* (* |ray_(select old(#length) cstpncpy_#in~src.base)| lambda) 0)
 (* (* |ray_cstpncpy_~#dst.offset| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 lambda) 0) (* (* |ray_cstpncpy_#t~mem7| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 lambda) 0) (* (* ray_cstpncpy_~d~3.base lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 lambda) 0) (* (* |ray_(select #length cstpncpy_#in~src.base)| lambda) 0)
 (* (* |ray_cstpncpy_#in~src.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| lambda) 0)
 (* (* |ray_cstpncpy_#t~mem1.offset| lambda) 0)
 (* (* |ray_(select #length cstpncpy_#in~dst.base)| lambda) 0)
 (* (* |ray_cstpncpy_#t~mem0.base| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_cstpncpy_#in~n| lambda) 0)
 (* (* |ray_cstpncpy_#t~mem1.base| lambda) 0)
 (* (* |ray_cstpncpy_#t~post5.base| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(select old(#length) cstpncpy_~#dst.base)| lambda) 0)
 (* (* |ray_(ite (select #valid cstpncpy_~d~3.base) 1 0)| lambda) 0)
 (* (* ray_cstpncpy_~s~3.base lambda) 0)
 (*
 (*
 |ray_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 lambda) 0) (* (* |ray_(select #length cstpncpy_~s~3.base)| lambda) 0)
 (* (* ray_cstpncpy_~n lambda) 0)
 (* (* |ray_cstpncpy_#in~dst.base| lambda) 0)
 (* (* |ray_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length cstpncpy_~#dst.base)| lambda) 0)
 (* (* |ray_cstpncpy_#t~post4.base| lambda) 0)
 (* (* |ray_(ite (select #valid cstpncpy_~#dst.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) cstpncpy_#in~dst.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| lambda) 0)
 (* (* |ray_cstpncpy_#t~post5.offset| lambda) 0)
 (* (* |ray_(ite (select #valid cstpncpy_#in~src.base) 1 0)| lambda) 0)
 (* (* |ray_cstpncpy_#in~dst.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid cstpncpy_~s~3.base) 1 0)| lambda) 0)
 (* (* ray_cstpncpy_~src.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* ray_cstpncpy_~d~3.offset lambda) 1)
 (* (* |ray_cstpncpy_#t~post3| lambda) 0)
 (* (* |ray_cstpncpy_~#dst.base| lambda) 0)
 (* (* ray_cstpncpy_~src.offset lambda) 0)
 (* (* |ray_cstpncpy_#in~src.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| lambda) 0)
 (* |ray_(select #length cstpncpy_~d~3.base)| 0)
 (* |ray_cstpncpy_#t~post4.offset| 0) 
 (* ray_cstpncpy_~s~3.offset 0)
 (*
 |ray_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |ray_cstpncpy_#t~mem7| 0) 
 (* ray_cstpncpy_~d~3.base 0) 
 (* |ray_cstpncpy_#t~post5.base| 0)
 (* |ray_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (* ray_cstpncpy_~s~3.base 0) 
 (* |ray_(select #length cstpncpy_~s~3.base)| 0) 
 (* ray_cstpncpy_~n 0) (* |ray_cstpncpy_#t~post4.base| 0)
 (* |ray_cstpncpy_#t~post5.offset| 0)
 (* |ray_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* ray_cstpncpy_~d~3.offset (- 1)) 
 (* |ray_cstpncpy_#t~post3| 0)) 0)
 (>=
 (+ (* (* |ray_cstpncpy_#t~mem0.offset| lambda) 0)
 (* (* |ray_(select #length cstpncpy_~d~3.base)| lambda) 0)
 (* (* |ray_cstpncpy_#t~post4.offset| lambda) 0)
 (* (* ray_cstpncpy_~s~3.offset lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 lambda) 0)
 (* (* |ray_(select old(#length) cstpncpy_#in~src.base)| lambda) 0)
 (* (* |ray_cstpncpy_~#dst.offset| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 lambda) 0) (* (* |ray_cstpncpy_#t~mem7| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 lambda) 0) (* (* ray_cstpncpy_~d~3.base lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 lambda) 0) (* (* |ray_(select #length cstpncpy_#in~src.base)| lambda) 0)
 (* (* |ray_cstpncpy_#in~src.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| lambda) 0)
 (* (* |ray_cstpncpy_#t~mem1.offset| lambda) 0)
 (* (* |ray_(select #length cstpncpy_#in~dst.base)| lambda) 0)
 (* (* |ray_cstpncpy_#t~mem0.base| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_cstpncpy_#in~n| lambda) 0)
 (* (* |ray_cstpncpy_#t~mem1.base| lambda) 0)
 (* (* |ray_cstpncpy_#t~post5.base| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(select old(#length) cstpncpy_~#dst.base)| lambda) 0)
 (* (* |ray_(ite (select #valid cstpncpy_~d~3.base) 1 0)| lambda) 0)
 (* (* ray_cstpncpy_~s~3.base lambda) 1)
 (*
 (*
 |ray_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 lambda) 0) (* (* |ray_(select #length cstpncpy_~s~3.base)| lambda) 0)
 (* (* ray_cstpncpy_~n lambda) 0)
 (* (* |ray_cstpncpy_#in~dst.base| lambda) 0)
 (* (* |ray_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length cstpncpy_~#dst.base)| lambda) 0)
 (* (* |ray_cstpncpy_#t~post4.base| lambda) 0)
 (* (* |ray_(ite (select #valid cstpncpy_~#dst.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) cstpncpy_#in~dst.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| lambda) 0)
 (* (* |ray_cstpncpy_#t~post5.offset| lambda) 0)
 (* (* |ray_(ite (select #valid cstpncpy_#in~src.base) 1 0)| lambda) 0)
 (* (* |ray_cstpncpy_#in~dst.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid cstpncpy_~s~3.base) 1 0)| lambda) 0)
 (* (* ray_cstpncpy_~src.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* ray_cstpncpy_~d~3.offset lambda) 0)
 (* (* |ray_cstpncpy_#t~post3| lambda) 0)
 (* (* |ray_cstpncpy_~#dst.base| lambda) 0)
 (* (* ray_cstpncpy_~src.offset lambda) 0)
 (* (* |ray_cstpncpy_#in~src.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| lambda) 0)
 (* |ray_(select #length cstpncpy_~d~3.base)| 0)
 (* |ray_cstpncpy_#t~post4.offset| 0) 
 (* ray_cstpncpy_~s~3.offset 0)
 (*
 |ray_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |ray_cstpncpy_#t~mem7| 0) 
 (* ray_cstpncpy_~d~3.base (- 1)) 
 (* |ray_cstpncpy_#t~post5.base| 0)
 (* |ray_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (* ray_cstpncpy_~s~3.base 0) 
 (* |ray_(select #length cstpncpy_~s~3.base)| 0) 
 (* ray_cstpncpy_~n 0) (* |ray_cstpncpy_#t~post4.base| 0)
 (* |ray_cstpncpy_#t~post5.offset| 0)
 (* |ray_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* ray_cstpncpy_~d~3.offset 0) 
 (* |ray_cstpncpy_#t~post3| 0)) 0)
 (>=
 (+ (* (* |ray_cstpncpy_#t~mem0.offset| lambda) 0)
 (* (* |ray_(select #length cstpncpy_~d~3.base)| lambda) 0)
 (* (* |ray_cstpncpy_#t~post4.offset| lambda) 0)
 (* (* ray_cstpncpy_~s~3.offset lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 lambda) 0)
 (* (* |ray_(select old(#length) cstpncpy_#in~src.base)| lambda) 0)
 (* (* |ray_cstpncpy_~#dst.offset| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 lambda) 0) (* (* |ray_cstpncpy_#t~mem7| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 lambda) 0) (* (* ray_cstpncpy_~d~3.base lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 lambda) 0) (* (* |ray_(select #length cstpncpy_#in~src.base)| lambda) 0)
 (* (* |ray_cstpncpy_#in~src.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| lambda) 0)
 (* (* |ray_cstpncpy_#t~mem1.offset| lambda) 0)
 (* (* |ray_(select #length cstpncpy_#in~dst.base)| lambda) 0)
 (* (* |ray_cstpncpy_#t~mem0.base| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_cstpncpy_#in~n| lambda) 0)
 (* (* |ray_cstpncpy_#t~mem1.base| lambda) 0)
 (* (* |ray_cstpncpy_#t~post5.base| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(select old(#length) cstpncpy_~#dst.base)| lambda) 0)
 (* (* |ray_(ite (select #valid cstpncpy_~d~3.base) 1 0)| lambda) 0)
 (* (* ray_cstpncpy_~s~3.base lambda) 0)
 (*
 (*
 |ray_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 lambda) 0) (* (* |ray_(select #length cstpncpy_~s~3.base)| lambda) 0)
 (* (* ray_cstpncpy_~n lambda) 0)
 (* (* |ray_cstpncpy_#in~dst.base| lambda) 0)
 (* (* |ray_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length cstpncpy_~#dst.base)| lambda) 0)
 (* (* |ray_cstpncpy_#t~post4.base| lambda) 0)
 (* (* |ray_(ite (select #valid cstpncpy_~#dst.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) cstpncpy_#in~dst.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| lambda) 0)
 (* (* |ray_cstpncpy_#t~post5.offset| lambda) 0)
 (* (* |ray_(ite (select #valid cstpncpy_#in~src.base) 1 0)| lambda) 0)
 (* (* |ray_cstpncpy_#in~dst.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid cstpncpy_~s~3.base) 1 0)| lambda) 0)
 (* (* ray_cstpncpy_~src.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* ray_cstpncpy_~d~3.offset lambda) 0)
 (* (* |ray_cstpncpy_#t~post3| lambda) 0)
 (* (* |ray_cstpncpy_~#dst.base| lambda) 0)
 (* (* ray_cstpncpy_~src.offset lambda) 0)
 (* (* |ray_cstpncpy_#in~src.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| lambda) 0)
 (* |ray_(select #length cstpncpy_~d~3.base)| 0)
 (* |ray_cstpncpy_#t~post4.offset| 0) 
 (* ray_cstpncpy_~s~3.offset 0)
 (*
 |ray_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 (- 1)) (* |ray_cstpncpy_#t~mem7| 0) 
 (* ray_cstpncpy_~d~3.base 0) 
 (* |ray_cstpncpy_#t~post5.base| 0)
 (* |ray_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (* ray_cstpncpy_~s~3.base 0) 
 (* |ray_(select #length cstpncpy_~s~3.base)| 0) 
 (* ray_cstpncpy_~n 0) (* |ray_cstpncpy_#t~post4.base| 0)
 (* |ray_cstpncpy_#t~post5.offset| 0)
 (* |ray_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* ray_cstpncpy_~d~3.offset 0) 
 (* |ray_cstpncpy_#t~post3| 0)) 0)
 (>=
 (+ (* (* |ray_cstpncpy_#t~mem0.offset| lambda) 0)
 (* (* |ray_(select #length cstpncpy_~d~3.base)| lambda) 0)
 (* (* |ray_cstpncpy_#t~post4.offset| lambda) 0)
 (* (* ray_cstpncpy_~s~3.offset lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 lambda) 0)
 (* (* |ray_(select old(#length) cstpncpy_#in~src.base)| lambda) 0)
 (* (* |ray_cstpncpy_~#dst.offset| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 lambda) 0) (* (* |ray_cstpncpy_#t~mem7| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 lambda) 0) (* (* ray_cstpncpy_~d~3.base lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 lambda) 0) (* (* |ray_(select #length cstpncpy_#in~src.base)| lambda) 0)
 (* (* |ray_cstpncpy_#in~src.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| lambda) 0)
 (* (* |ray_cstpncpy_#t~mem1.offset| lambda) 0)
 (* (* |ray_(select #length cstpncpy_#in~dst.base)| lambda) 0)
 (* (* |ray_cstpncpy_#t~mem0.base| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_cstpncpy_#in~n| lambda) 0)
 (* (* |ray_cstpncpy_#t~mem1.base| lambda) 0)
 (* (* |ray_cstpncpy_#t~post5.base| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(select old(#length) cstpncpy_~#dst.base)| lambda) 0)
 (* (* |ray_(ite (select #valid cstpncpy_~d~3.base) 1 0)| lambda) 0)
 (* (* ray_cstpncpy_~s~3.base lambda) 0)
 (*
 (*
 |ray_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 lambda) 0) (* (* |ray_(select #length cstpncpy_~s~3.base)| lambda) 0)
 (* (* ray_cstpncpy_~n lambda) 0)
 (* (* |ray_cstpncpy_#in~dst.base| lambda) 0)
 (* (* |ray_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length cstpncpy_~#dst.base)| lambda) 0)
 (* (* |ray_cstpncpy_#t~post4.base| lambda) 0)
 (* (* |ray_(ite (select #valid cstpncpy_~#dst.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) cstpncpy_#in~dst.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| lambda) 0)
 (* (* |ray_cstpncpy_#t~post5.offset| lambda) 0)
 (* (* |ray_(ite (select #valid cstpncpy_#in~src.base) 1 0)| lambda) 0)
 (* (* |ray_cstpncpy_#in~dst.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid cstpncpy_~s~3.base) 1 0)| lambda) 1)
 (* (* ray_cstpncpy_~src.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* ray_cstpncpy_~d~3.offset lambda) 0)
 (* (* |ray_cstpncpy_#t~post3| lambda) 0)
 (* (* |ray_cstpncpy_~#dst.base| lambda) 0)
 (* (* ray_cstpncpy_~src.offset lambda) 0)
 (* (* |ray_cstpncpy_#in~src.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| lambda) 0)
 (* |ray_(select #length cstpncpy_~d~3.base)| 0)
 (* |ray_cstpncpy_#t~post4.offset| 0) 
 (* ray_cstpncpy_~s~3.offset 0)
 (*
 |ray_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |ray_cstpncpy_#t~mem7| 0) 
 (* ray_cstpncpy_~d~3.base 0) 
 (* |ray_cstpncpy_#t~post5.base| 0)
 (* |ray_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (* ray_cstpncpy_~s~3.base 0) 
 (* |ray_(select #length cstpncpy_~s~3.base)| 0) 
 (* ray_cstpncpy_~n 0) (* |ray_cstpncpy_#t~post4.base| 0)
 (* |ray_cstpncpy_#t~post5.offset| 0)
 (* |ray_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* ray_cstpncpy_~d~3.offset 0) 
 (* |ray_cstpncpy_#t~post3| 0)) 0)
 (>=
 (+ (* (* |ray_cstpncpy_#t~mem0.offset| lambda) 0)
 (* (* |ray_(select #length cstpncpy_~d~3.base)| lambda) 0)
 (* (* |ray_cstpncpy_#t~post4.offset| lambda) 0)
 (* (* ray_cstpncpy_~s~3.offset lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 lambda) 0)
 (* (* |ray_(select old(#length) cstpncpy_#in~src.base)| lambda) 0)
 (* (* |ray_cstpncpy_~#dst.offset| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 lambda) 0) (* (* |ray_cstpncpy_#t~mem7| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 lambda) 0) (* (* ray_cstpncpy_~d~3.base lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 lambda) 0) (* (* |ray_(select #length cstpncpy_#in~src.base)| lambda) 0)
 (* (* |ray_cstpncpy_#in~src.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| lambda) 0)
 (* (* |ray_cstpncpy_#t~mem1.offset| lambda) 0)
 (* (* |ray_(select #length cstpncpy_#in~dst.base)| lambda) 0)
 (* (* |ray_cstpncpy_#t~mem0.base| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_cstpncpy_#in~n| lambda) 0)
 (* (* |ray_cstpncpy_#t~mem1.base| lambda) 0)
 (* (* |ray_cstpncpy_#t~post5.base| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(select old(#length) cstpncpy_~#dst.base)| lambda) 0)
 (* (* |ray_(ite (select #valid cstpncpy_~d~3.base) 1 0)| lambda) 0)
 (* (* ray_cstpncpy_~s~3.base lambda) 0)
 (*
 (*
 |ray_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 lambda) 0) (* (* |ray_(select #length cstpncpy_~s~3.base)| lambda) 0)
 (* (* ray_cstpncpy_~n lambda) 0)
 (* (* |ray_cstpncpy_#in~dst.base| lambda) 0)
 (* (* |ray_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length cstpncpy_~#dst.base)| lambda) 0)
 (* (* |ray_cstpncpy_#t~post4.base| lambda) 0)
 (* (* |ray_(ite (select #valid cstpncpy_~#dst.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) cstpncpy_#in~dst.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| lambda) 0)
 (* (* |ray_cstpncpy_#t~post5.offset| lambda) 0)
 (* (* |ray_(ite (select #valid cstpncpy_#in~src.base) 1 0)| lambda) 0)
 (* (* |ray_cstpncpy_#in~dst.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid cstpncpy_~s~3.base) 1 0)| lambda) 0)
 (* (* ray_cstpncpy_~src.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* ray_cstpncpy_~d~3.offset lambda) 0)
 (* (* |ray_cstpncpy_#t~post3| lambda) 0)
 (* (* |ray_cstpncpy_~#dst.base| lambda) 0)
 (* (* ray_cstpncpy_~src.offset lambda) 0)
 (* (* |ray_cstpncpy_#in~src.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| lambda) 0)
 (* |ray_(select #length cstpncpy_~d~3.base)| 0)
 (* |ray_cstpncpy_#t~post4.offset| 0) 
 (* ray_cstpncpy_~s~3.offset 0)
 (*
 |ray_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |ray_cstpncpy_#t~mem7| 0) 
 (* ray_cstpncpy_~d~3.base 0) 
 (* |ray_cstpncpy_#t~post5.base| 0)
 (* |ray_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (* ray_cstpncpy_~s~3.base 0) 
 (* |ray_(select #length cstpncpy_~s~3.base)| 0) 
 (* ray_cstpncpy_~n (- 1)) 
 (* |ray_cstpncpy_#t~post4.base| 0) 
 (* |ray_cstpncpy_#t~post5.offset| 0)
 (* |ray_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* ray_cstpncpy_~d~3.offset 0) 
 (* |ray_cstpncpy_#t~post3| 0) 
 (* aux_3758 1) (* aux_3759 4294967296)) 0)
 (>=
 (+ (* (* |ray_cstpncpy_#t~mem0.offset| lambda) 0)
 (* (* |ray_(select #length cstpncpy_~d~3.base)| lambda) 0)
 (* (* |ray_cstpncpy_#t~post4.offset| lambda) 0)
 (* (* ray_cstpncpy_~s~3.offset lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 lambda) 0)
 (* (* |ray_(select old(#length) cstpncpy_#in~src.base)| lambda) 0)
 (* (* |ray_cstpncpy_~#dst.offset| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 lambda) 0) (* (* |ray_cstpncpy_#t~mem7| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 lambda) 0) (* (* ray_cstpncpy_~d~3.base lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 lambda) 0) (* (* |ray_(select #length cstpncpy_#in~src.base)| lambda) 0)
 (* (* |ray_cstpncpy_#in~src.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| lambda) 0)
 (* (* |ray_cstpncpy_#t~mem1.offset| lambda) 0)
 (* (* |ray_(select #length cstpncpy_#in~dst.base)| lambda) 0)
 (* (* |ray_cstpncpy_#t~mem0.base| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_cstpncpy_#in~n| lambda) 0)
 (* (* |ray_cstpncpy_#t~mem1.base| lambda) 0)
 (* (* |ray_cstpncpy_#t~post5.base| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(select old(#length) cstpncpy_~#dst.base)| lambda) 0)
 (* (* |ray_(ite (select #valid cstpncpy_~d~3.base) 1 0)| lambda) 0)
 (* (* ray_cstpncpy_~s~3.base lambda) 0)
 (*
 (*
 |ray_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 lambda) 0) (* (* |ray_(select #length cstpncpy_~s~3.base)| lambda) 0)
 (* (* ray_cstpncpy_~n lambda) 0)
 (* (* |ray_cstpncpy_#in~dst.base| lambda) 0)
 (* (* |ray_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length cstpncpy_~#dst.base)| lambda) 0)
 (* (* |ray_cstpncpy_#t~post4.base| lambda) 0)
 (* (* |ray_(ite (select #valid cstpncpy_~#dst.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) cstpncpy_#in~dst.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| lambda) 0)
 (* (* |ray_cstpncpy_#t~post5.offset| lambda) 0)
 (* (* |ray_(ite (select #valid cstpncpy_#in~src.base) 1 0)| lambda) 0)
 (* (* |ray_cstpncpy_#in~dst.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid cstpncpy_~s~3.base) 1 0)| lambda) 0)
 (* (* ray_cstpncpy_~src.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* ray_cstpncpy_~d~3.offset lambda) 0)
 (* (* |ray_cstpncpy_#t~post3| lambda) 0)
 (* (* |ray_cstpncpy_~#dst.base| lambda) 0)
 (* (* ray_cstpncpy_~src.offset lambda) 0)
 (* (* |ray_cstpncpy_#in~src.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| lambda) 0)
 (* |ray_(select #length cstpncpy_~d~3.base)| 0)
 (* |ray_cstpncpy_#t~post4.offset| 0) 
 (* ray_cstpncpy_~s~3.offset 0)
 (*
 |ray_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |ray_cstpncpy_#t~mem7| 0) 
 (* ray_cstpncpy_~d~3.base 0) 
 (* |ray_cstpncpy_#t~post5.base| 0)
 (* |ray_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (* ray_cstpncpy_~s~3.base 0) 
 (* |ray_(select #length cstpncpy_~s~3.base)| 0) 
 (* ray_cstpncpy_~n 0) (* |ray_cstpncpy_#t~post4.base| 0)
 (* |ray_cstpncpy_#t~post5.offset| 0)
 (* |ray_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* ray_cstpncpy_~d~3.offset 0) 
 (* |ray_cstpncpy_#t~post3| 0) 
 (* aux_3758 (- 1))) 0)
 (>=
 (+ (* (* |ray_cstpncpy_#t~mem0.offset| lambda) 0)
 (* (* |ray_(select #length cstpncpy_~d~3.base)| lambda) 0)
 (* (* |ray_cstpncpy_#t~post4.offset| lambda) 0)
 (* (* ray_cstpncpy_~s~3.offset lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 lambda) 0)
 (* (* |ray_(select old(#length) cstpncpy_#in~src.base)| lambda) 0)
 (* (* |ray_cstpncpy_~#dst.offset| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 lambda) 0) (* (* |ray_cstpncpy_#t~mem7| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 lambda) 0) (* (* ray_cstpncpy_~d~3.base lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 lambda) 0) (* (* |ray_(select #length cstpncpy_#in~src.base)| lambda) 0)
 (* (* |ray_cstpncpy_#in~src.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| lambda) 0)
 (* (* |ray_cstpncpy_#t~mem1.offset| lambda) 0)
 (* (* |ray_(select #length cstpncpy_#in~dst.base)| lambda) 0)
 (* (* |ray_cstpncpy_#t~mem0.base| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_cstpncpy_#in~n| lambda) 0)
 (* (* |ray_cstpncpy_#t~mem1.base| lambda) 0)
 (* (* |ray_cstpncpy_#t~post5.base| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(select old(#length) cstpncpy_~#dst.base)| lambda) 0)
 (* (* |ray_(ite (select #valid cstpncpy_~d~3.base) 1 0)| lambda) 0)
 (* (* ray_cstpncpy_~s~3.base lambda) 0)
 (*
 (*
 |ray_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 lambda) 0) (* (* |ray_(select #length cstpncpy_~s~3.base)| lambda) 0)
 (* (* ray_cstpncpy_~n lambda) 0)
 (* (* |ray_cstpncpy_#in~dst.base| lambda) 0)
 (* (* |ray_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length cstpncpy_~#dst.base)| lambda) 0)
 (* (* |ray_cstpncpy_#t~post4.base| lambda) 0)
 (* (* |ray_(ite (select #valid cstpncpy_~#dst.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) cstpncpy_#in~dst.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| lambda) 0)
 (* (* |ray_cstpncpy_#t~post5.offset| lambda) 0)
 (* (* |ray_(ite (select #valid cstpncpy_#in~src.base) 1 0)| lambda) 0)
 (* (* |ray_cstpncpy_#in~dst.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid cstpncpy_~s~3.base) 1 0)| lambda) 0)
 (* (* ray_cstpncpy_~src.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* ray_cstpncpy_~d~3.offset lambda) 0)
 (* (* |ray_cstpncpy_#t~post3| lambda) 0)
 (* (* |ray_cstpncpy_~#dst.base| lambda) 0)
 (* (* ray_cstpncpy_~src.offset lambda) 0)
 (* (* |ray_cstpncpy_#in~src.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| lambda) 0)
 (* |ray_(select #length cstpncpy_~d~3.base)| 0)
 (* |ray_cstpncpy_#t~post4.offset| 0) 
 (* ray_cstpncpy_~s~3.offset 0)
 (*
 |ray_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |ray_cstpncpy_#t~mem7| 0) 
 (* ray_cstpncpy_~d~3.base 0) 
 (* |ray_cstpncpy_#t~post5.base| 0)
 (* |ray_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (* ray_cstpncpy_~s~3.base 0) 
 (* |ray_(select #length cstpncpy_~s~3.base)| 0) 
 (* ray_cstpncpy_~n 1) (* |ray_cstpncpy_#t~post4.base| 0)
 (* |ray_cstpncpy_#t~post5.offset| 0)
 (* |ray_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* ray_cstpncpy_~d~3.offset 0) 
 (* |ray_cstpncpy_#t~post3| 0) 
 (* aux_3758 (- 1)) (* aux_3759 (- 4294967296))) 0)
 (>=
 (+ (* (* |ray_cstpncpy_#t~mem0.offset| lambda) 0)
 (* (* |ray_(select #length cstpncpy_~d~3.base)| lambda) 0)
 (* (* |ray_cstpncpy_#t~post4.offset| lambda) 0)
 (* (* ray_cstpncpy_~s~3.offset lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 lambda) 0)
 (* (* |ray_(select old(#length) cstpncpy_#in~src.base)| lambda) 0)
 (* (* |ray_cstpncpy_~#dst.offset| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 lambda) 0) (* (* |ray_cstpncpy_#t~mem7| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 lambda) 0) (* (* ray_cstpncpy_~d~3.base lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 lambda) 0) (* (* |ray_(select #length cstpncpy_#in~src.base)| lambda) 0)
 (* (* |ray_cstpncpy_#in~src.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| lambda) 0)
 (* (* |ray_cstpncpy_#t~mem1.offset| lambda) 0)
 (* (* |ray_(select #length cstpncpy_#in~dst.base)| lambda) 0)
 (* (* |ray_cstpncpy_#t~mem0.base| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_cstpncpy_#in~n| lambda) 0)
 (* (* |ray_cstpncpy_#t~mem1.base| lambda) 0)
 (* (* |ray_cstpncpy_#t~post5.base| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(select old(#length) cstpncpy_~#dst.base)| lambda) 0)
 (* (* |ray_(ite (select #valid cstpncpy_~d~3.base) 1 0)| lambda) 0)
 (* (* ray_cstpncpy_~s~3.base lambda) 0)
 (*
 (*
 |ray_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 lambda) 0) (* (* |ray_(select #length cstpncpy_~s~3.base)| lambda) 0)
 (* (* ray_cstpncpy_~n lambda) 0)
 (* (* |ray_cstpncpy_#in~dst.base| lambda) 0)
 (* (* |ray_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length cstpncpy_~#dst.base)| lambda) 0)
 (* (* |ray_cstpncpy_#t~post4.base| lambda) 0)
 (* (* |ray_(ite (select #valid cstpncpy_~#dst.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) cstpncpy_#in~dst.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| lambda) 0)
 (* (* |ray_cstpncpy_#t~post5.offset| lambda) 0)
 (* (* |ray_(ite (select #valid cstpncpy_#in~src.base) 1 0)| lambda) 0)
 (* (* |ray_cstpncpy_#in~dst.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid cstpncpy_~s~3.base) 1 0)| lambda) 0)
 (* (* ray_cstpncpy_~src.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* ray_cstpncpy_~d~3.offset lambda) 0)
 (* (* |ray_cstpncpy_#t~post3| lambda) 0)
 (* (* |ray_cstpncpy_~#dst.base| lambda) 0)
 (* (* ray_cstpncpy_~src.offset lambda) 0)
 (* (* |ray_cstpncpy_#in~src.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| lambda) 0)
 (* |ray_(select #length cstpncpy_~d~3.base)| 0)
 (* |ray_cstpncpy_#t~post4.offset| 0) 
 (* ray_cstpncpy_~s~3.offset 0)
 (*
 |ray_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |ray_cstpncpy_#t~mem7| 0) 
 (* ray_cstpncpy_~d~3.base 0) 
 (* |ray_cstpncpy_#t~post5.base| 0)
 (* |ray_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (* ray_cstpncpy_~s~3.base 0) 
 (* |ray_(select #length cstpncpy_~s~3.base)| 0) 
 (* ray_cstpncpy_~n 0) (* |ray_cstpncpy_#t~post4.base| 0)
 (* |ray_cstpncpy_#t~post5.offset| 0)
 (* |ray_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* ray_cstpncpy_~d~3.offset 0) 
 (* |ray_cstpncpy_#t~post3| 0) 
 (* aux_3763 (- 1)) (* aux_3764 (- 4294967296))) 0)
 (>=
 (+ (* (* |ray_cstpncpy_#t~mem0.offset| lambda) 0)
 (* (* |ray_(select #length cstpncpy_~d~3.base)| lambda) 0)
 (* (* |ray_cstpncpy_#t~post4.offset| lambda) 0)
 (* (* ray_cstpncpy_~s~3.offset lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 lambda) 0)
 (* (* |ray_(select old(#length) cstpncpy_#in~src.base)| lambda) 0)
 (* (* |ray_cstpncpy_~#dst.offset| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 lambda) 0) (* (* |ray_cstpncpy_#t~mem7| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 lambda) 0) (* (* ray_cstpncpy_~d~3.base lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 lambda) 0) (* (* |ray_(select #length cstpncpy_#in~src.base)| lambda) 0)
 (* (* |ray_cstpncpy_#in~src.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| lambda) 0)
 (* (* |ray_cstpncpy_#t~mem1.offset| lambda) 0)
 (* (* |ray_(select #length cstpncpy_#in~dst.base)| lambda) 0)
 (* (* |ray_cstpncpy_#t~mem0.base| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_cstpncpy_#in~n| lambda) 0)
 (* (* |ray_cstpncpy_#t~mem1.base| lambda) 0)
 (* (* |ray_cstpncpy_#t~post5.base| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(select old(#length) cstpncpy_~#dst.base)| lambda) 0)
 (* (* |ray_(ite (select #valid cstpncpy_~d~3.base) 1 0)| lambda) 0)
 (* (* ray_cstpncpy_~s~3.base lambda) 0)
 (*
 (*
 |ray_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 lambda) 0) (* (* |ray_(select #length cstpncpy_~s~3.base)| lambda) 0)
 (* (* ray_cstpncpy_~n lambda) 0)
 (* (* |ray_cstpncpy_#in~dst.base| lambda) 0)
 (* (* |ray_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length cstpncpy_~#dst.base)| lambda) 0)
 (* (* |ray_cstpncpy_#t~post4.base| lambda) 0)
 (* (* |ray_(ite (select #valid cstpncpy_~#dst.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) cstpncpy_#in~dst.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| lambda) 0)
 (* (* |ray_cstpncpy_#t~post5.offset| lambda) 0)
 (* (* |ray_(ite (select #valid cstpncpy_#in~src.base) 1 0)| lambda) 0)
 (* (* |ray_cstpncpy_#in~dst.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid cstpncpy_~s~3.base) 1 0)| lambda) 0)
 (* (* ray_cstpncpy_~src.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* ray_cstpncpy_~d~3.offset lambda) 0)
 (* (* |ray_cstpncpy_#t~post3| lambda) 0)
 (* (* |ray_cstpncpy_~#dst.base| lambda) 0)
 (* (* ray_cstpncpy_~src.offset lambda) 0)
 (* (* |ray_cstpncpy_#in~src.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| lambda) 0)
 (* |ray_(select #length cstpncpy_~d~3.base)| 0)
 (* |ray_cstpncpy_#t~post4.offset| 0) 
 (* ray_cstpncpy_~s~3.offset 0)
 (*
 |ray_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |ray_cstpncpy_#t~mem7| 0) 
 (* ray_cstpncpy_~d~3.base 0) 
 (* |ray_cstpncpy_#t~post5.base| 0)
 (* |ray_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (* ray_cstpncpy_~s~3.base 0) 
 (* |ray_(select #length cstpncpy_~s~3.base)| 0) 
 (* ray_cstpncpy_~n 0) (* |ray_cstpncpy_#t~post4.base| 0)
 (* |ray_cstpncpy_#t~post5.offset| 0)
 (* |ray_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* ray_cstpncpy_~d~3.offset 0) 
 (* |ray_cstpncpy_#t~post3| 0) 
 (* aux_3763 1) (* aux_3764 4294967296)) 0)
 (>=
 (+ (* (* |ray_cstpncpy_#t~mem0.offset| lambda) 0)
 (* (* |ray_(select #length cstpncpy_~d~3.base)| lambda) 0)
 (* (* |ray_cstpncpy_#t~post4.offset| lambda) 0)
 (* (* ray_cstpncpy_~s~3.offset lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 lambda) 0)
 (* (* |ray_(select old(#length) cstpncpy_#in~src.base)| lambda) 0)
 (* (* |ray_cstpncpy_~#dst.offset| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 lambda) 0) (* (* |ray_cstpncpy_#t~mem7| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 lambda) 0) (* (* ray_cstpncpy_~d~3.base lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 lambda) 0) (* (* |ray_(select #length cstpncpy_#in~src.base)| lambda) 0)
 (* (* |ray_cstpncpy_#in~src.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| lambda) 0)
 (* (* |ray_cstpncpy_#t~mem1.offset| lambda) 0)
 (* (* |ray_(select #length cstpncpy_#in~dst.base)| lambda) 0)
 (* (* |ray_cstpncpy_#t~mem0.base| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_cstpncpy_#in~n| lambda) 0)
 (* (* |ray_cstpncpy_#t~mem1.base| lambda) 0)
 (* (* |ray_cstpncpy_#t~post5.base| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(select old(#length) cstpncpy_~#dst.base)| lambda) 0)
 (* (* |ray_(ite (select #valid cstpncpy_~d~3.base) 1 0)| lambda) 0)
 (* (* ray_cstpncpy_~s~3.base lambda) 0)
 (*
 (*
 |ray_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 lambda) 0) (* (* |ray_(select #length cstpncpy_~s~3.base)| lambda) 0)
 (* (* ray_cstpncpy_~n lambda) 0)
 (* (* |ray_cstpncpy_#in~dst.base| lambda) 0)
 (* (* |ray_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length cstpncpy_~#dst.base)| lambda) 0)
 (* (* |ray_cstpncpy_#t~post4.base| lambda) 0)
 (* (* |ray_(ite (select #valid cstpncpy_~#dst.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) cstpncpy_#in~dst.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| lambda) 0)
 (* (* |ray_cstpncpy_#t~post5.offset| lambda) 0)
 (* (* |ray_(ite (select #valid cstpncpy_#in~src.base) 1 0)| lambda) 0)
 (* (* |ray_cstpncpy_#in~dst.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid cstpncpy_~s~3.base) 1 0)| lambda) 0)
 (* (* ray_cstpncpy_~src.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* ray_cstpncpy_~d~3.offset lambda) 0)
 (* (* |ray_cstpncpy_#t~post3| lambda) 0)
 (* (* |ray_cstpncpy_~#dst.base| lambda) 0)
 (* (* ray_cstpncpy_~src.offset lambda) 0)
 (* (* |ray_cstpncpy_#in~src.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| lambda) 0)
 (* |ray_(select #length cstpncpy_~d~3.base)| 0)
 (* |ray_cstpncpy_#t~post4.offset| 0) 
 (* ray_cstpncpy_~s~3.offset 0)
 (*
 |ray_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |ray_cstpncpy_#t~mem7| 0) 
 (* ray_cstpncpy_~d~3.base 0) 
 (* |ray_cstpncpy_#t~post5.base| 0)
 (* |ray_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (* ray_cstpncpy_~s~3.base 0) 
 (* |ray_(select #length cstpncpy_~s~3.base)| 0) 
 (* ray_cstpncpy_~n 0) (* |ray_cstpncpy_#t~post4.base| 0)
 (* |ray_cstpncpy_#t~post5.offset| 0)
 (* |ray_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* ray_cstpncpy_~d~3.offset 0) 
 (* |ray_cstpncpy_#t~post3| 0) 
 (* aux_3763 1)) 0)
 (>=
 (+ (* (* |ray_cstpncpy_#t~mem0.offset| lambda) 0)
 (* (* |ray_(select #length cstpncpy_~d~3.base)| lambda) 1)
 (* (* |ray_cstpncpy_#t~post4.offset| lambda) 0)
 (* (* ray_cstpncpy_~s~3.offset lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 lambda) 0)
 (* (* |ray_(select old(#length) cstpncpy_#in~src.base)| lambda) 0)
 (* (* |ray_cstpncpy_~#dst.offset| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 lambda) 0) (* (* |ray_cstpncpy_#t~mem7| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 lambda) 0) (* (* ray_cstpncpy_~d~3.base lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 lambda) 0) (* (* |ray_(select #length cstpncpy_#in~src.base)| lambda) 0)
 (* (* |ray_cstpncpy_#in~src.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| lambda) 0)
 (* (* |ray_cstpncpy_#t~mem1.offset| lambda) 0)
 (* (* |ray_(select #length cstpncpy_#in~dst.base)| lambda) 0)
 (* (* |ray_cstpncpy_#t~mem0.base| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_cstpncpy_#in~n| lambda) 0)
 (* (* |ray_cstpncpy_#t~mem1.base| lambda) 0)
 (* (* |ray_cstpncpy_#t~post5.base| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(select old(#length) cstpncpy_~#dst.base)| lambda) 0)
 (* (* |ray_(ite (select #valid cstpncpy_~d~3.base) 1 0)| lambda) 0)
 (* (* ray_cstpncpy_~s~3.base lambda) 0)
 (*
 (*
 |ray_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 lambda) 0) (* (* |ray_(select #length cstpncpy_~s~3.base)| lambda) 0)
 (* (* ray_cstpncpy_~n lambda) 0)
 (* (* |ray_cstpncpy_#in~dst.base| lambda) 0)
 (* (* |ray_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length cstpncpy_~#dst.base)| lambda) 0)
 (* (* |ray_cstpncpy_#t~post4.base| lambda) 0)
 (* (* |ray_(ite (select #valid cstpncpy_~#dst.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) cstpncpy_#in~dst.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| lambda) 0)
 (* (* |ray_cstpncpy_#t~post5.offset| lambda) 0)
 (* (* |ray_(ite (select #valid cstpncpy_#in~src.base) 1 0)| lambda) 0)
 (* (* |ray_cstpncpy_#in~dst.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid cstpncpy_~s~3.base) 1 0)| lambda) 0)
 (* (* ray_cstpncpy_~src.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* ray_cstpncpy_~d~3.offset lambda) 0)
 (* (* |ray_cstpncpy_#t~post3| lambda) 0)
 (* (* |ray_cstpncpy_~#dst.base| lambda) 0)
 (* (* ray_cstpncpy_~src.offset lambda) 0)
 (* (* |ray_cstpncpy_#in~src.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| lambda) 0)
 (* |ray_(select #length cstpncpy_~d~3.base)| (- 1))
 (* |ray_cstpncpy_#t~post4.offset| 0) 
 (* ray_cstpncpy_~s~3.offset 0)
 (*
 |ray_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |ray_cstpncpy_#t~mem7| 0) 
 (* ray_cstpncpy_~d~3.base 0) 
 (* |ray_cstpncpy_#t~post5.base| 0)
 (* |ray_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (* ray_cstpncpy_~s~3.base 0) 
 (* |ray_(select #length cstpncpy_~s~3.base)| 0) 
 (* ray_cstpncpy_~n 0) (* |ray_cstpncpy_#t~post4.base| 0)
 (* |ray_cstpncpy_#t~post5.offset| 0)
 (* |ray_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* ray_cstpncpy_~d~3.offset 0) 
 (* |ray_cstpncpy_#t~post3| 0)) 0)
 (>=
 (+ (* (* |ray_cstpncpy_#t~mem0.offset| lambda) 0)
 (* (* |ray_(select #length cstpncpy_~d~3.base)| lambda) 0)
 (* (* |ray_cstpncpy_#t~post4.offset| lambda) 0)
 (* (* ray_cstpncpy_~s~3.offset lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 lambda) 0)
 (* (* |ray_(select old(#length) cstpncpy_#in~src.base)| lambda) 0)
 (* (* |ray_cstpncpy_~#dst.offset| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 lambda) 0) (* (* |ray_cstpncpy_#t~mem7| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 lambda) 0) (* (* ray_cstpncpy_~d~3.base lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 lambda) 0) (* (* |ray_(select #length cstpncpy_#in~src.base)| lambda) 0)
 (* (* |ray_cstpncpy_#in~src.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| lambda) 0)
 (* (* |ray_cstpncpy_#t~mem1.offset| lambda) 0)
 (* (* |ray_(select #length cstpncpy_#in~dst.base)| lambda) 0)
 (* (* |ray_cstpncpy_#t~mem0.base| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_cstpncpy_#in~n| lambda) 0)
 (* (* |ray_cstpncpy_#t~mem1.base| lambda) 0)
 (* (* |ray_cstpncpy_#t~post5.base| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(select old(#length) cstpncpy_~#dst.base)| lambda) 0)
 (* (* |ray_(ite (select #valid cstpncpy_~d~3.base) 1 0)| lambda) 0)
 (* (* ray_cstpncpy_~s~3.base lambda) (- 1))
 (*
 (*
 |ray_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 lambda) 0) (* (* |ray_(select #length cstpncpy_~s~3.base)| lambda) 0)
 (* (* ray_cstpncpy_~n lambda) 0)
 (* (* |ray_cstpncpy_#in~dst.base| lambda) 0)
 (* (* |ray_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length cstpncpy_~#dst.base)| lambda) 0)
 (* (* |ray_cstpncpy_#t~post4.base| lambda) 0)
 (* (* |ray_(ite (select #valid cstpncpy_~#dst.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) cstpncpy_#in~dst.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| lambda) 0)
 (* (* |ray_cstpncpy_#t~post5.offset| lambda) 0)
 (* (* |ray_(ite (select #valid cstpncpy_#in~src.base) 1 0)| lambda) 0)
 (* (* |ray_cstpncpy_#in~dst.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid cstpncpy_~s~3.base) 1 0)| lambda) 0)
 (* (* ray_cstpncpy_~src.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* ray_cstpncpy_~d~3.offset lambda) 0)
 (* (* |ray_cstpncpy_#t~post3| lambda) 0)
 (* (* |ray_cstpncpy_~#dst.base| lambda) 0)
 (* (* ray_cstpncpy_~src.offset lambda) 0)
 (* (* |ray_cstpncpy_#in~src.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| lambda) 0)
 (* |ray_(select #length cstpncpy_~d~3.base)| 0)
 (* |ray_cstpncpy_#t~post4.offset| 0) 
 (* ray_cstpncpy_~s~3.offset 0)
 (*
 |ray_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |ray_cstpncpy_#t~mem7| 0) 
 (* ray_cstpncpy_~d~3.base 0) 
 (* |ray_cstpncpy_#t~post5.base| 0)
 (* |ray_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (* ray_cstpncpy_~s~3.base 1) 
 (* |ray_(select #length cstpncpy_~s~3.base)| 0) 
 (* ray_cstpncpy_~n 0) (* |ray_cstpncpy_#t~post4.base| 0)
 (* |ray_cstpncpy_#t~post5.offset| 0)
 (* |ray_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* ray_cstpncpy_~d~3.offset 0) 
 (* |ray_cstpncpy_#t~post3| 0)) 0)
 (>=
 (+ (* (* |ray_cstpncpy_#t~mem0.offset| lambda) 0)
 (* (* |ray_(select #length cstpncpy_~d~3.base)| lambda) 0)
 (* (* |ray_cstpncpy_#t~post4.offset| lambda) 0)
 (* (* ray_cstpncpy_~s~3.offset lambda) 1)
 (*
 (*
 |ray_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 lambda) 0)
 (* (* |ray_(select old(#length) cstpncpy_#in~src.base)| lambda) 0)
 (* (* |ray_cstpncpy_~#dst.offset| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 lambda) 0) (* (* |ray_cstpncpy_#t~mem7| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 lambda) 0) (* (* ray_cstpncpy_~d~3.base lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 lambda) 0) (* (* |ray_(select #length cstpncpy_#in~src.base)| lambda) 0)
 (* (* |ray_cstpncpy_#in~src.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| lambda) 0)
 (* (* |ray_cstpncpy_#t~mem1.offset| lambda) 0)
 (* (* |ray_(select #length cstpncpy_#in~dst.base)| lambda) 0)
 (* (* |ray_cstpncpy_#t~mem0.base| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_cstpncpy_#in~n| lambda) 0)
 (* (* |ray_cstpncpy_#t~mem1.base| lambda) 0)
 (* (* |ray_cstpncpy_#t~post5.base| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(select old(#length) cstpncpy_~#dst.base)| lambda) 0)
 (* (* |ray_(ite (select #valid cstpncpy_~d~3.base) 1 0)| lambda) 0)
 (* (* ray_cstpncpy_~s~3.base lambda) 0)
 (*
 (*
 |ray_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 lambda) 0) (* (* |ray_(select #length cstpncpy_~s~3.base)| lambda) 0)
 (* (* ray_cstpncpy_~n lambda) 0)
 (* (* |ray_cstpncpy_#in~dst.base| lambda) 0)
 (* (* |ray_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length cstpncpy_~#dst.base)| lambda) 0)
 (* (* |ray_cstpncpy_#t~post4.base| lambda) 0)
 (* (* |ray_(ite (select #valid cstpncpy_~#dst.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) cstpncpy_#in~dst.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| lambda) 0)
 (* (* |ray_cstpncpy_#t~post5.offset| lambda) 0)
 (* (* |ray_(ite (select #valid cstpncpy_#in~src.base) 1 0)| lambda) 0)
 (* (* |ray_cstpncpy_#in~dst.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid cstpncpy_~s~3.base) 1 0)| lambda) 0)
 (* (* ray_cstpncpy_~src.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* ray_cstpncpy_~d~3.offset lambda) 0)
 (* (* |ray_cstpncpy_#t~post3| lambda) 0)
 (* (* |ray_cstpncpy_~#dst.base| lambda) 0)
 (* (* ray_cstpncpy_~src.offset lambda) 0)
 (* (* |ray_cstpncpy_#in~src.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| lambda) 0)
 (* |ray_(select #length cstpncpy_~d~3.base)| 0)
 (* |ray_cstpncpy_#t~post4.offset| 0) 
 (* ray_cstpncpy_~s~3.offset (- 1))
 (*
 |ray_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |ray_cstpncpy_#t~mem7| 0) 
 (* ray_cstpncpy_~d~3.base 0) 
 (* |ray_cstpncpy_#t~post5.base| 0)
 (* |ray_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (* ray_cstpncpy_~s~3.base 0) 
 (* |ray_(select #length cstpncpy_~s~3.base)| 0) 
 (* ray_cstpncpy_~n 0) (* |ray_cstpncpy_#t~post4.base| 0)
 (* |ray_cstpncpy_#t~post5.offset| 0)
 (* |ray_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* ray_cstpncpy_~d~3.offset 0) 
 (* |ray_cstpncpy_#t~post3| 0)) 0)
 (>=
 (+ (* (* |ray_cstpncpy_#t~mem0.offset| lambda) 0)
 (* (* |ray_(select #length cstpncpy_~d~3.base)| lambda) 0)
 (* (* |ray_cstpncpy_#t~post4.offset| lambda) 0)
 (* (* ray_cstpncpy_~s~3.offset lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 lambda) 0)
 (* (* |ray_(select old(#length) cstpncpy_#in~src.base)| lambda) 0)
 (* (* |ray_cstpncpy_~#dst.offset| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 lambda) 0) (* (* |ray_cstpncpy_#t~mem7| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 lambda) 0) (* (* ray_cstpncpy_~d~3.base lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 lambda) 0) (* (* |ray_(select #length cstpncpy_#in~src.base)| lambda) 0)
 (* (* |ray_cstpncpy_#in~src.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| lambda) 0)
 (* (* |ray_cstpncpy_#t~mem1.offset| lambda) 0)
 (* (* |ray_(select #length cstpncpy_#in~dst.base)| lambda) 0)
 (* (* |ray_cstpncpy_#t~mem0.base| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_cstpncpy_#in~n| lambda) 0)
 (* (* |ray_cstpncpy_#t~mem1.base| lambda) 0)
 (* (* |ray_cstpncpy_#t~post5.base| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(select old(#length) cstpncpy_~#dst.base)| lambda) 0)
 (* (* |ray_(ite (select #valid cstpncpy_~d~3.base) 1 0)| lambda) 0)
 (* (* ray_cstpncpy_~s~3.base lambda) 0)
 (*
 (*
 |ray_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 lambda) 0) (* (* |ray_(select #length cstpncpy_~s~3.base)| lambda) 0)
 (* (* ray_cstpncpy_~n lambda) 0)
 (* (* |ray_cstpncpy_#in~dst.base| lambda) 0)
 (* (* |ray_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length cstpncpy_~#dst.base)| lambda) 0)
 (* (* |ray_cstpncpy_#t~post4.base| lambda) 0)
 (* (* |ray_(ite (select #valid cstpncpy_~#dst.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) cstpncpy_#in~dst.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| lambda) 0)
 (* (* |ray_cstpncpy_#t~post5.offset| lambda) 0)
 (* (* |ray_(ite (select #valid cstpncpy_#in~src.base) 1 0)| lambda) 0)
 (* (* |ray_cstpncpy_#in~dst.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid cstpncpy_~s~3.base) 1 0)| lambda) 0)
 (* (* ray_cstpncpy_~src.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* ray_cstpncpy_~d~3.offset lambda) 0)
 (* (* |ray_cstpncpy_#t~post3| lambda) 0)
 (* (* |ray_cstpncpy_~#dst.base| lambda) 0)
 (* (* ray_cstpncpy_~src.offset lambda) 0)
 (* (* |ray_cstpncpy_#in~src.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| lambda) 0)
 (* |ray_(select #length cstpncpy_~d~3.base)| 0)
 (* |ray_cstpncpy_#t~post4.offset| 0) 
 (* ray_cstpncpy_~s~3.offset 0)
 (*
 |ray_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |ray_cstpncpy_#t~mem7| 0) 
 (* ray_cstpncpy_~d~3.base 0) 
 (* |ray_cstpncpy_#t~post5.base| 0)
 (* |ray_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (* ray_cstpncpy_~s~3.base 0) 
 (* |ray_(select #length cstpncpy_~s~3.base)| 0) 
 (* ray_cstpncpy_~n 0) (* |ray_cstpncpy_#t~post4.base| 0)
 (* |ray_cstpncpy_#t~post5.offset| 0)
 (* |ray_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 1)
 (* ray_cstpncpy_~d~3.offset 0) 
 (* |ray_cstpncpy_#t~post3| 0)) 0)
 (>=
 (+ (* (* |ray_cstpncpy_#t~mem0.offset| lambda) 0)
 (* (* |ray_(select #length cstpncpy_~d~3.base)| lambda) 0)
 (* (* |ray_cstpncpy_#t~post4.offset| lambda) 0)
 (* (* ray_cstpncpy_~s~3.offset lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 lambda) 0)
 (* (* |ray_(select old(#length) cstpncpy_#in~src.base)| lambda) 0)
 (* (* |ray_cstpncpy_~#dst.offset| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 lambda) 0) (* (* |ray_cstpncpy_#t~mem7| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 lambda) 0) (* (* ray_cstpncpy_~d~3.base lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 lambda) 0) (* (* |ray_(select #length cstpncpy_#in~src.base)| lambda) 0)
 (* (* |ray_cstpncpy_#in~src.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| lambda) 0)
 (* (* |ray_cstpncpy_#t~mem1.offset| lambda) 0)
 (* (* |ray_(select #length cstpncpy_#in~dst.base)| lambda) 0)
 (* (* |ray_cstpncpy_#t~mem0.base| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_cstpncpy_#in~n| lambda) 0)
 (* (* |ray_cstpncpy_#t~mem1.base| lambda) 0)
 (* (* |ray_cstpncpy_#t~post5.base| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(select old(#length) cstpncpy_~#dst.base)| lambda) 0)
 (* (* |ray_(ite (select #valid cstpncpy_~d~3.base) 1 0)| lambda) 0)
 (* (* ray_cstpncpy_~s~3.base lambda) 0)
 (*
 (*
 |ray_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 lambda) 0) (* (* |ray_(select #length cstpncpy_~s~3.base)| lambda) 0)
 (* (* ray_cstpncpy_~n lambda) 1)
 (* (* |ray_cstpncpy_#in~dst.base| lambda) 0)
 (* (* |ray_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length cstpncpy_~#dst.base)| lambda) 0)
 (* (* |ray_cstpncpy_#t~post4.base| lambda) 0)
 (* (* |ray_(ite (select #valid cstpncpy_~#dst.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) cstpncpy_#in~dst.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| lambda) 0)
 (* (* |ray_cstpncpy_#t~post5.offset| lambda) 0)
 (* (* |ray_(ite (select #valid cstpncpy_#in~src.base) 1 0)| lambda) 0)
 (* (* |ray_cstpncpy_#in~dst.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid cstpncpy_~s~3.base) 1 0)| lambda) 0)
 (* (* ray_cstpncpy_~src.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* ray_cstpncpy_~d~3.offset lambda) 0)
 (* (* |ray_cstpncpy_#t~post3| lambda) 0)
 (* (* |ray_cstpncpy_~#dst.base| lambda) 0)
 (* (* ray_cstpncpy_~src.offset lambda) 0)
 (* (* |ray_cstpncpy_#in~src.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| lambda) 0)
 (* |ray_(select #length cstpncpy_~d~3.base)| 0)
 (* |ray_cstpncpy_#t~post4.offset| 0) 
 (* ray_cstpncpy_~s~3.offset 0)
 (*
 |ray_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |ray_cstpncpy_#t~mem7| 0) 
 (* ray_cstpncpy_~d~3.base 0) 
 (* |ray_cstpncpy_#t~post5.base| 0)
 (* |ray_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (* ray_cstpncpy_~s~3.base 0) 
 (* |ray_(select #length cstpncpy_~s~3.base)| 0) 
 (* ray_cstpncpy_~n (- 1)) 
 (* |ray_cstpncpy_#t~post4.base| 0) 
 (* |ray_cstpncpy_#t~post5.offset| 0)
 (* |ray_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* ray_cstpncpy_~d~3.offset 0) 
 (* |ray_cstpncpy_#t~post3| 0)) 0)
 (>=
 (+ (* (* |ray_cstpncpy_#t~mem0.offset| lambda) 0)
 (* (* |ray_(select #length cstpncpy_~d~3.base)| lambda) 0)
 (* (* |ray_cstpncpy_#t~post4.offset| lambda) 0)
 (* (* ray_cstpncpy_~s~3.offset lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 lambda) 0)
 (* (* |ray_(select old(#length) cstpncpy_#in~src.base)| lambda) 0)
 (* (* |ray_cstpncpy_~#dst.offset| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 lambda) 0) (* (* |ray_cstpncpy_#t~mem7| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 lambda) 0) (* (* ray_cstpncpy_~d~3.base lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 lambda) 0) (* (* |ray_(select #length cstpncpy_#in~src.base)| lambda) 0)
 (* (* |ray_cstpncpy_#in~src.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| lambda) 0)
 (* (* |ray_cstpncpy_#t~mem1.offset| lambda) 0)
 (* (* |ray_(select #length cstpncpy_#in~dst.base)| lambda) 0)
 (* (* |ray_cstpncpy_#t~mem0.base| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_cstpncpy_#in~n| lambda) 0)
 (* (* |ray_cstpncpy_#t~mem1.base| lambda) 0)
 (* (* |ray_cstpncpy_#t~post5.base| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(select old(#length) cstpncpy_~#dst.base)| lambda) 0)
 (* (* |ray_(ite (select #valid cstpncpy_~d~3.base) 1 0)| lambda) 0)
 (* (* ray_cstpncpy_~s~3.base lambda) 0)
 (*
 (*
 |ray_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 lambda) 0) (* (* |ray_(select #length cstpncpy_~s~3.base)| lambda) 1)
 (* (* ray_cstpncpy_~n lambda) 0)
 (* (* |ray_cstpncpy_#in~dst.base| lambda) 0)
 (* (* |ray_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length cstpncpy_~#dst.base)| lambda) 0)
 (* (* |ray_cstpncpy_#t~post4.base| lambda) 0)
 (* (* |ray_(ite (select #valid cstpncpy_~#dst.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) cstpncpy_#in~dst.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| lambda) 0)
 (* (* |ray_cstpncpy_#t~post5.offset| lambda) 0)
 (* (* |ray_(ite (select #valid cstpncpy_#in~src.base) 1 0)| lambda) 0)
 (* (* |ray_cstpncpy_#in~dst.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid cstpncpy_~s~3.base) 1 0)| lambda) 0)
 (* (* ray_cstpncpy_~src.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* ray_cstpncpy_~d~3.offset lambda) 0)
 (* (* |ray_cstpncpy_#t~post3| lambda) 0)
 (* (* |ray_cstpncpy_~#dst.base| lambda) 0)
 (* (* ray_cstpncpy_~src.offset lambda) 0)
 (* (* |ray_cstpncpy_#in~src.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| lambda) 0)
 (* |ray_(select #length cstpncpy_~d~3.base)| 0)
 (* |ray_cstpncpy_#t~post4.offset| 0) 
 (* ray_cstpncpy_~s~3.offset 0)
 (*
 |ray_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |ray_cstpncpy_#t~mem7| 0) 
 (* ray_cstpncpy_~d~3.base 0) 
 (* |ray_cstpncpy_#t~post5.base| 0)
 (* |ray_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (* ray_cstpncpy_~s~3.base 0)
 (* |ray_(select #length cstpncpy_~s~3.base)| (- 1)) 
 (* ray_cstpncpy_~n 0) (* |ray_cstpncpy_#t~post4.base| 0)
 (* |ray_cstpncpy_#t~post5.offset| 0)
 (* |ray_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* ray_cstpncpy_~d~3.offset 0) 
 (* |ray_cstpncpy_#t~post3| 0)) 0)
 (>=
 (+ (* (* |ray_cstpncpy_#t~mem0.offset| lambda) 0)
 (* (* |ray_(select #length cstpncpy_~d~3.base)| lambda) 0)
 (* (* |ray_cstpncpy_#t~post4.offset| lambda) 0)
 (* (* ray_cstpncpy_~s~3.offset lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 lambda) 0)
 (* (* |ray_(select old(#length) cstpncpy_#in~src.base)| lambda) 0)
 (* (* |ray_cstpncpy_~#dst.offset| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 lambda) 0) (* (* |ray_cstpncpy_#t~mem7| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 lambda) 0) (* (* ray_cstpncpy_~d~3.base lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 lambda) 0) (* (* |ray_(select #length cstpncpy_#in~src.base)| lambda) 0)
 (* (* |ray_cstpncpy_#in~src.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| lambda) 0)
 (* (* |ray_cstpncpy_#t~mem1.offset| lambda) 0)
 (* (* |ray_(select #length cstpncpy_#in~dst.base)| lambda) 0)
 (* (* |ray_cstpncpy_#t~mem0.base| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_cstpncpy_#in~n| lambda) 0)
 (* (* |ray_cstpncpy_#t~mem1.base| lambda) 0)
 (* (* |ray_cstpncpy_#t~post5.base| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(select old(#length) cstpncpy_~#dst.base)| lambda) 0)
 (* (* |ray_(ite (select #valid cstpncpy_~d~3.base) 1 0)| lambda) 0)
 (* (* ray_cstpncpy_~s~3.base lambda) 1)
 (*
 (*
 |ray_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 lambda) 0) (* (* |ray_(select #length cstpncpy_~s~3.base)| lambda) 0)
 (* (* ray_cstpncpy_~n lambda) 0)
 (* (* |ray_cstpncpy_#in~dst.base| lambda) 0)
 (* (* |ray_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length cstpncpy_~#dst.base)| lambda) 0)
 (* (* |ray_cstpncpy_#t~post4.base| lambda) 0)
 (* (* |ray_(ite (select #valid cstpncpy_~#dst.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) cstpncpy_#in~dst.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| lambda) 0)
 (* (* |ray_cstpncpy_#t~post5.offset| lambda) 0)
 (* (* |ray_(ite (select #valid cstpncpy_#in~src.base) 1 0)| lambda) 0)
 (* (* |ray_cstpncpy_#in~dst.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid cstpncpy_~s~3.base) 1 0)| lambda) 0)
 (* (* ray_cstpncpy_~src.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* ray_cstpncpy_~d~3.offset lambda) 0)
 (* (* |ray_cstpncpy_#t~post3| lambda) 0)
 (* (* |ray_cstpncpy_~#dst.base| lambda) 0)
 (* (* ray_cstpncpy_~src.offset lambda) 0)
 (* (* |ray_cstpncpy_#in~src.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| lambda) 0)
 (* |ray_(select #length cstpncpy_~d~3.base)| 0)
 (* |ray_cstpncpy_#t~post4.offset| 0) 
 (* ray_cstpncpy_~s~3.offset 0)
 (*
 |ray_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |ray_cstpncpy_#t~mem7| 0) 
 (* ray_cstpncpy_~d~3.base 0) 
 (* |ray_cstpncpy_#t~post5.base| 0)
 (* |ray_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (* ray_cstpncpy_~s~3.base (- 1))
 (* |ray_(select #length cstpncpy_~s~3.base)| 0) 
 (* ray_cstpncpy_~n 0) (* |ray_cstpncpy_#t~post4.base| 0)
 (* |ray_cstpncpy_#t~post5.offset| 0)
 (* |ray_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* ray_cstpncpy_~d~3.offset 0) 
 (* |ray_cstpncpy_#t~post3| 0)) 0)
 (>=
 (+ (* (* |ray_cstpncpy_#t~mem0.offset| lambda) 0)
 (* (* |ray_(select #length cstpncpy_~d~3.base)| lambda) 0)
 (* (* |ray_cstpncpy_#t~post4.offset| lambda) 0)
 (* (* ray_cstpncpy_~s~3.offset lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 lambda) 0)
 (* (* |ray_(select old(#length) cstpncpy_#in~src.base)| lambda) 0)
 (* (* |ray_cstpncpy_~#dst.offset| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 lambda) 0) (* (* |ray_cstpncpy_#t~mem7| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 lambda) 0) (* (* ray_cstpncpy_~d~3.base lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 lambda) 0) (* (* |ray_(select #length cstpncpy_#in~src.base)| lambda) 0)
 (* (* |ray_cstpncpy_#in~src.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| lambda) 0)
 (* (* |ray_cstpncpy_#t~mem1.offset| lambda) 0)
 (* (* |ray_(select #length cstpncpy_#in~dst.base)| lambda) 0)
 (* (* |ray_cstpncpy_#t~mem0.base| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_cstpncpy_#in~n| lambda) 0)
 (* (* |ray_cstpncpy_#t~mem1.base| lambda) 0)
 (* (* |ray_cstpncpy_#t~post5.base| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(select old(#length) cstpncpy_~#dst.base)| lambda) 0)
 (* (* |ray_(ite (select #valid cstpncpy_~d~3.base) 1 0)| lambda) 0)
 (* (* ray_cstpncpy_~s~3.base lambda) 0)
 (*
 (*
 |ray_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 lambda) 0) (* (* |ray_(select #length cstpncpy_~s~3.base)| lambda) 0)
 (* (* ray_cstpncpy_~n lambda) 0)
 (* (* |ray_cstpncpy_#in~dst.base| lambda) 0)
 (* (* |ray_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length cstpncpy_~#dst.base)| lambda) 0)
 (* (* |ray_cstpncpy_#t~post4.base| lambda) 0)
 (* (* |ray_(ite (select #valid cstpncpy_~#dst.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) cstpncpy_#in~dst.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| lambda) 0)
 (* (* |ray_cstpncpy_#t~post5.offset| lambda) 0)
 (* (* |ray_(ite (select #valid cstpncpy_#in~src.base) 1 0)| lambda) 0)
 (* (* |ray_cstpncpy_#in~dst.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid cstpncpy_~s~3.base) 1 0)| lambda) 0)
 (* (* ray_cstpncpy_~src.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* ray_cstpncpy_~d~3.offset lambda) 0)
 (* (* |ray_cstpncpy_#t~post3| lambda) 0)
 (* (* |ray_cstpncpy_~#dst.base| lambda) 0)
 (* (* ray_cstpncpy_~src.offset lambda) 0)
 (* (* |ray_cstpncpy_#in~src.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| lambda) 0)
 (* |ray_(select #length cstpncpy_~d~3.base)| 1)
 (* |ray_cstpncpy_#t~post4.offset| 0) 
 (* ray_cstpncpy_~s~3.offset 0)
 (*
 |ray_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |ray_cstpncpy_#t~mem7| 0) 
 (* ray_cstpncpy_~d~3.base 0) 
 (* |ray_cstpncpy_#t~post5.base| 0)
 (* |ray_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (* ray_cstpncpy_~s~3.base 0) 
 (* |ray_(select #length cstpncpy_~s~3.base)| 0) 
 (* ray_cstpncpy_~n 0) (* |ray_cstpncpy_#t~post4.base| 0)
 (* |ray_cstpncpy_#t~post5.offset| 0)
 (* |ray_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* ray_cstpncpy_~d~3.offset (- 1)) 
 (* |ray_cstpncpy_#t~post3| 0)) 0)
 (>=
 (+ (* (* |ray_cstpncpy_#t~mem0.offset| lambda) 0)
 (* (* |ray_(select #length cstpncpy_~d~3.base)| lambda) 0)
 (* (* |ray_cstpncpy_#t~post4.offset| lambda) 0)
 (* (* ray_cstpncpy_~s~3.offset lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 lambda) 0)
 (* (* |ray_(select old(#length) cstpncpy_#in~src.base)| lambda) 0)
 (* (* |ray_cstpncpy_~#dst.offset| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 lambda) 0) (* (* |ray_cstpncpy_#t~mem7| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 lambda) 0) (* (* ray_cstpncpy_~d~3.base lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 lambda) 0) (* (* |ray_(select #length cstpncpy_#in~src.base)| lambda) 0)
 (* (* |ray_cstpncpy_#in~src.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| lambda) 0)
 (* (* |ray_cstpncpy_#t~mem1.offset| lambda) 0)
 (* (* |ray_(select #length cstpncpy_#in~dst.base)| lambda) 0)
 (* (* |ray_cstpncpy_#t~mem0.base| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_cstpncpy_#in~n| lambda) 0)
 (* (* |ray_cstpncpy_#t~mem1.base| lambda) 0)
 (* (* |ray_cstpncpy_#t~post5.base| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(select old(#length) cstpncpy_~#dst.base)| lambda) 0)
 (* (* |ray_(ite (select #valid cstpncpy_~d~3.base) 1 0)| lambda) 0)
 (* (* ray_cstpncpy_~s~3.base lambda) 0)
 (*
 (*
 |ray_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 lambda) 0) (* (* |ray_(select #length cstpncpy_~s~3.base)| lambda) 0)
 (* (* ray_cstpncpy_~n lambda) 0)
 (* (* |ray_cstpncpy_#in~dst.base| lambda) 0)
 (* (* |ray_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length cstpncpy_~#dst.base)| lambda) 0)
 (* (* |ray_cstpncpy_#t~post4.base| lambda) 0)
 (* (* |ray_(ite (select #valid cstpncpy_~#dst.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) cstpncpy_#in~dst.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| lambda) 0)
 (* (* |ray_cstpncpy_#t~post5.offset| lambda) 0)
 (* (* |ray_(ite (select #valid cstpncpy_#in~src.base) 1 0)| lambda) 0)
 (* (* |ray_cstpncpy_#in~dst.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid cstpncpy_~s~3.base) 1 0)| lambda) 0)
 (* (* ray_cstpncpy_~src.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* ray_cstpncpy_~d~3.offset lambda) 0)
 (* (* |ray_cstpncpy_#t~post3| lambda) 0)
 (* (* |ray_cstpncpy_~#dst.base| lambda) 0)
 (* (* ray_cstpncpy_~src.offset lambda) 0)
 (* (* |ray_cstpncpy_#in~src.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| lambda) 0)
 (* |ray_(select #length cstpncpy_~d~3.base)| 0)
 (* |ray_cstpncpy_#t~post4.offset| 0) 
 (* ray_cstpncpy_~s~3.offset 0)
 (*
 |ray_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |ray_cstpncpy_#t~mem7| 0) 
 (* ray_cstpncpy_~d~3.base 0) 
 (* |ray_cstpncpy_#t~post5.base| 0)
 (* |ray_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 1)
 (* ray_cstpncpy_~s~3.base 0) 
 (* |ray_(select #length cstpncpy_~s~3.base)| 0) 
 (* ray_cstpncpy_~n 0) (* |ray_cstpncpy_#t~post4.base| 0)
 (* |ray_cstpncpy_#t~post5.offset| 0)
 (* |ray_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* ray_cstpncpy_~d~3.offset 0) 
 (* |ray_cstpncpy_#t~post3| 0)) 0)
 (>=
 (+ (* (* |ray_cstpncpy_#t~mem0.offset| lambda) 0)
 (* (* |ray_(select #length cstpncpy_~d~3.base)| lambda) 0)
 (* (* |ray_cstpncpy_#t~post4.offset| lambda) 0)
 (* (* ray_cstpncpy_~s~3.offset lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 lambda) 0)
 (* (* |ray_(select old(#length) cstpncpy_#in~src.base)| lambda) 0)
 (* (* |ray_cstpncpy_~#dst.offset| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 lambda) 0) (* (* |ray_cstpncpy_#t~mem7| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_$Pointer$.base) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 lambda) 0) (* (* ray_cstpncpy_~d~3.base lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_$Pointer$.offset) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 lambda) 0) (* (* |ray_(select #length cstpncpy_#in~src.base)| lambda) 0)
 (* (* |ray_cstpncpy_#in~src.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) cstpncpy_~#dst.base) 1 0)| lambda) 0)
 (* (* |ray_cstpncpy_#t~mem1.offset| lambda) 0)
 (* (* |ray_(select #length cstpncpy_#in~dst.base)| lambda) 0)
 (* (* |ray_cstpncpy_#t~mem0.base| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_cstpncpy_#in~n| lambda) 0)
 (* (* |ray_cstpncpy_#t~mem1.base| lambda) 0)
 (* (* |ray_cstpncpy_#t~post5.base| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(select old(#length) cstpncpy_~#dst.base)| lambda) 0)
 (* (* |ray_(ite (select #valid cstpncpy_~d~3.base) 1 0)| lambda) 0)
 (* (* ray_cstpncpy_~s~3.base lambda) 0)
 (*
 (*
 |ray_(select (select #memory_$Pointer$.base cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 lambda) 0) (* (* |ray_(select #length cstpncpy_~s~3.base)| lambda) 0)
 (* (* ray_cstpncpy_~n lambda) 0)
 (* (* |ray_cstpncpy_#in~dst.base| lambda) 0)
 (* (* |ray_(ite (select #valid cstpncpy_#in~dst.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length cstpncpy_~#dst.base)| lambda) 0)
 (* (* |ray_cstpncpy_#t~post4.base| lambda) 0)
 (* (* |ray_(ite (select #valid cstpncpy_~#dst.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) cstpncpy_#in~dst.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) cstpncpy_#in~dst.base) 1 0)| lambda) 0)
 (* (* |ray_cstpncpy_#t~post5.offset| lambda) 0)
 (* (* |ray_(ite (select #valid cstpncpy_#in~src.base) 1 0)| lambda) 0)
 (* (* |ray_cstpncpy_#in~dst.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid cstpncpy_~s~3.base) 1 0)| lambda) 0)
 (* (* ray_cstpncpy_~src.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* ray_cstpncpy_~d~3.offset lambda) 0)
 (* (* |ray_cstpncpy_#t~post3| lambda) 0)
 (* (* |ray_cstpncpy_~#dst.base| lambda) 0)
 (* (* ray_cstpncpy_~src.offset lambda) 0)
 (* (* |ray_cstpncpy_#in~src.base| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_$Pointer$.offset cstpncpy_~#dst.base) cstpncpy_~#dst.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) cstpncpy_#in~src.base) 1 0)| lambda) 0)
 (* |ray_(select #length cstpncpy_~d~3.base)| 0)
 (* |ray_cstpncpy_#t~post4.offset| 0) 
 (* ray_cstpncpy_~s~3.offset 0)
 (*
 |ray_(select (select #memory_int cstpncpy_~s~3.base) cstpncpy_~s~3.offset)|
 0) (* |ray_cstpncpy_#t~mem7| 0) 
 (* ray_cstpncpy_~d~3.base 0) 
 (* |ray_cstpncpy_#t~post5.base| 0)
 (* |ray_(ite (select #valid cstpncpy_~d~3.base) 1 0)| 0)
 (* ray_cstpncpy_~s~3.base 0) 
 (* |ray_(select #length cstpncpy_~s~3.base)| 0) 
 (* ray_cstpncpy_~n 0) (* |ray_cstpncpy_#t~post4.base| 0)
 (* |ray_cstpncpy_#t~post5.offset| 0)
 (* |ray_(ite (select #valid cstpncpy_~s~3.base) 1 0)| 0)
 (* ray_cstpncpy_~d~3.offset 0) 
 (* |ray_cstpncpy_#t~post3| 0) 
 (* aux_3763 (- 1)) (* aux_3758 1)) 0) 
 (= lambda lambda))) (>= lambda 0)))
(check-sat)
(exit)

